datalibrary = {
    "iridl_type": "Source",
    "parent": None,
    "invalid": [],
    "dir": "SOURCES",
    "banned": [
        "dir",
        "invalid",
        "parent",
        "name",
        "banned",
        "banned_long",
        "iridl_ds_name",
        "iridl_type"
    ],
    "iridl_ds_name": "SOURCES",
    "restriction": "Public",
    "ANEEL": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ANEEL",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "prcp_stadescription": "Precipitation station data for South America, primarily Brazil",
            "dis_stadescription": "Hydrological station data for South America, primarily Brazil",
            "description": "Ag&#234;ncia Nacional de Energia El&#233;trica",
            "iridlhasSemantics": "iridl:ANEEL",
            "Conventions": "IRIDL",
            "references": "ANEEL2000"
        },
        "prcp_sta": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "prcp_sta",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "STATION": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STATION",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "RIVER": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RIVER",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "prcp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "prcp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "maxncolor": "13",
                "colormap": "12800",
                "scale_max": "100.0",
                "ncolor": "13",
                "scale_min": "0.0",
                "CE": "100",
                "CS": "0",
                "missing_value": "-999.0",
                "units": "mm",
                "long_name": "precipitation"
            },
            "MUNICIPALITY": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MUNICIPALITY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "-90.0",
                "scale_max": "-30.0",
                "units": "degree_east",
                "long_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "-60.0",
                "scale_max": "15.0",
                "units": "degree_north",
                "long_name": "latitude"
            },
            "elev": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "elev",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "elevation",
                "units": "m"
            },
            "basin": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "basin",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "1",
                "scale_max": "8",
                "units": "ids",
                "long_name": "basin_id",
                "CLIST": "Uruguai"
            }
        },
        "dis_sta": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "dis_sta",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "STATION": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STATION",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "-90.0",
                "scale_max": "-30.0",
                "units": "degree_east",
                "long_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "-60.0",
                "scale_max": "15.0",
                "units": "degree_north",
                "long_name": "latitude"
            },
            "elev": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "elev",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "elevation",
                "units": "m"
            },
            "discharge": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "discharge",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "units": "m3/sec",
                "long_name": "discharge"
            },
            "basin": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "basin",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "maxncolor": "254",
                "ncolor": "11",
                "colormap": "0",
                "scale_min": "1",
                "scale_max": "8",
                "units": "ids",
                "long_name": "basin id",
                "CLIST": "Atlantico SE"
            },
            "area": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "area",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "drainage area",
                "units": "km2"
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0"
        },
        "ISTA_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "long_name": "station"
        },
        "MCODE": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MCODE",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0"
        },
        "ISTA_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "long_name": "station"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0"
        },
        "ISTA_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "long_name": "station"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "long_name": "station"
        },
        "dir": "SOURCES/ANEEL"
    },
    "ARCTIC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ARCTIC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "STATIONdescription": "Oceanic station data for the Arctic Region",
            "description": "Oceanic station data for the Arctic Region",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "STATION": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STATION",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Vint": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Vint",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "tritium vintage age",
                "units": "years",
                "missing_value": "-9999.0"
            },
            "Theta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Theta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "potential temperature",
                "units": "Celsius_scale",
                "missing_value": "-9999.0"
            },
            "Sta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "station",
                "units": "unitless",
                "missing_value": "-9999.0"
            },
            "Sil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "silicate",
                "units": "micro-moles per liter",
                "missing_value": "-9999.0"
            },
            "Sal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "salinity",
                "units": "PSU",
                "missing_value": "-9999.0"
            },
            "O18": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "O18",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "delta oxygen 18",
                "units": "ppt",
                "missing_value": "-9999.0"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "long_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "long_name": "latitude"
            },
            "Fr": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Fr",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "river runoff fraction",
                "units": "percent",
                "missing_value": "-9999.0"
            },
            "Fi": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Fi",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "ice fraction",
                "units": "percent",
                "missing_value": "-9999.0"
            },
            "Fa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Fa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Atlantic fraction",
                "units": "unitless",
                "missing_value": "-9999.0"
            },
            "Depth": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Depth",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "missing_value": "-9999.0"
            },
            "He": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "3He",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "tritium/helium age",
                "units": "unitless",
                "missing_value": "-9999.0"
            },
            "Hage": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "3Hage",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "tritium age",
                "units": "years",
                "missing_value": "-9999.0"
            },
            "H": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "3H",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "tritium",
                "units": "TU",
                "missing_value": "-9999.0"
            }
        },
        "IZ": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "IZ",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "dir": "SOURCES/ARCTIC"
    },
    "BRF": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "BRF",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "WeatherStationdescription": "Hourly and daily weather observations from Black Rock Forest",
            "WeatherStationiridlhasSemantics": "iridl:BRF",
            "SnowStation2005description": "Open Lowland Snow Station Main Hourly Observations",
            "SnowStationStonehousedescription": "Stonehouse main Snow Station Main Hourly Observations",
            "SnowStationOldHQdescription": "Old HQ main Snow Station Main Hourly Observations",
            "description": "Black Rock Forest",
            "iridlhasSemantics": "iridl:BRF",
            "Conventions": "IRIDL",
            "references": "Kastens_etal1998",
            "explorerhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.BRF/.explorer.html"
        },
        "WeatherStation": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WeatherStation",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RT_Hourly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RT_Hourly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wspdmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspdmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wspd": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspd",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdirsd1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdirsd1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction Std Dev",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdird1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdird1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "vappresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vappresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Vapor Pressure",
                    "units": "kPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-5200.0",
                    "long_name": "Minimum Temperature",
                    "units": "Celsius_scale",
                    "PGtype": "float4"
                },
                "tempmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp20avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp20avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 20 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp10avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp10avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 10 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp100avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp100avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 100 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "raintot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raintot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipitation Accumulation",
                    "units": "mm",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "partot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "partot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Photosynthetic Photon Flux Density (PPFD): photons in the 400 to 700 nm waveband/s/m2",
                    "long_name": "Photosynthetically-Active Radiation",
                    "units": "PPFD",
                    "missing_value": "99999.0",
                    "PGtype": "float4"
                },
                "gsravg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gsravg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NG Solar Radiation",
                    "units": "W/m2",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "dewptavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dewptavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-440.39999",
                    "long_name": "Average Dew Point",
                    "units": "Celsius_scale",
                    "PGtype": "float4"
                },
                "battvolt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battvolt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Battary Voltage",
                    "units": "volts",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-6999.0",
                    "long_name": "Minimum Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                },
                "barpresmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "0.0",
                    "long_name": "Average Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                }
            },
            "RT_Daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RT_Daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wspdmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspdmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wspd": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspd",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdirsd1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdirsd1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction Std Dev",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdird1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdird1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "vappresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vappresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Vapor Pressure",
                    "units": "kPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-5200.0",
                    "long_name": "Minimum Temperature",
                    "units": "Celsius_scale",
                    "PGtype": "float4"
                },
                "tempmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp20avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp20avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 20 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp10avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp10avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 10 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "raintot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raintot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipitation Accumulation",
                    "units": "mm",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "partot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "partot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Photosynthetic Photon Flux Density (PPFD): photons in the 400 to 700 nm waveband/s/m2",
                    "long_name": "Photosynthetically-Active Radiation",
                    "units": "PPFD",
                    "missing_value": "99999.0",
                    "PGtype": "float4"
                },
                "gsravg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gsravg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NG Solar Radiation",
                    "units": "W/m2",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "dewptavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dewptavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Dew Point",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "battvolt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battvolt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Battary Voltage",
                    "units": "volts",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-6999.0",
                    "long_name": "Minimum Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                },
                "barpresmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "0.0",
                    "long_name": "Average Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                }
            },
            "OL_Hourly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OL_Hourly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wspdmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspdmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wspd": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspd",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "195.5",
                    "long_name": "Wind Speed",
                    "units": "m/s",
                    "PGtype": "float4"
                },
                "wdirsd1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdirsd1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction Std Dev",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdird1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdird1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "vappresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vappresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Vapor Pressure",
                    "units": "kPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp20avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp20avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99999.0",
                    "long_name": "Soil Temperature 20 cm",
                    "units": "Celsius_scale",
                    "PGtype": "float4"
                },
                "stemp10avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp10avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 10 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp100avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp100avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 100 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "raintot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raintot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipitation Accumulation",
                    "units": "mm",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "partot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "partot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Photosynthetic Photon Flux Density (PPFD): photons in the 400 to 700 nm waveband/s/m2",
                    "long_name": "Photosynthetically-Active Radiation",
                    "units": "PPFD",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "gsravg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gsravg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NG Solar Radiation",
                    "units": "W/m2",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "dewptavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dewptavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Dew Point",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "co2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "co2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Percent CO2",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "battvolt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battvolt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-799.0",
                    "long_name": "Battary Voltage",
                    "units": "volts",
                    "PGtype": "float4"
                },
                "barpresmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "102.0",
                    "long_name": "Minimum Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                },
                "barpresmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                }
            },
            "OL_Daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OL_Daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wspdmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspdmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Wind Speed",
                    "units": "m/s",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wspd": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wspd",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "195.5",
                    "long_name": "Wind Speed",
                    "units": "m/s",
                    "PGtype": "float4"
                },
                "wdirsd1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdirsd1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction Std Dev",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "wdird1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wdird1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Wind Direction",
                    "units": "degree",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "vappresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vappresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Vapor Pressure",
                    "units": "kPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "tempavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tempavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "stemp20avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp20avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99999.0",
                    "long_name": "Soil Temperature 20 cm",
                    "units": "Celsius_scale",
                    "PGtype": "float4"
                },
                "stemp10avg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stemp10avg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Soil Temperature 10 cm",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Minimum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "rhavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rhavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Relative Humidity",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "raintot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raintot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipitation Accumulation",
                    "units": "mm",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "partot": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "partot",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "note": "Photosynthetic Photon Flux Density (PPFD): photons in the 400 to 700 nm waveband/s/m2",
                    "long_name": "Photosynthetically-Active Radiation",
                    "units": "PPFD",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "gsravg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gsravg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "NG Solar Radiation",
                    "units": "W/m2",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "dewptavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dewptavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Dew Point",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "co2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "co2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Percent CO2",
                    "units": "percent",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "battvolt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battvolt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-799.0",
                    "long_name": "Battary Voltage",
                    "units": "volts",
                    "PGtype": "float4"
                },
                "barpresmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "102.0",
                    "long_name": "Minimum Barometric Pressure",
                    "units": "hPa",
                    "PGtype": "float4"
                },
                "barpresmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Maximum Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "barpresavg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "barpresavg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Average Barometric Pressure",
                    "units": "hPa",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                }
            }
        },
        "SnowStation2005": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SnowStation2005",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "OLSSM_333_vars": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_333_vars",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "rn_w_m2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rn_w_m2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Rn_W_m2",
                    "units": "watts^m*m",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                }
            },
            "OLSSM_223_trefmux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_223_trefmux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "trefmux avg",
                "missing_value": "NaN",
                "units": "unitless",
                "PGtype": "float4",
                "codedstring": "select trefmux_avg from brf_olssm_hrly_223_2005_lt where tid=%d[tid] AND time=\\'%F %R[time]\\' ",
                "myallquery": "select trefmux_avg from brf_olssm_hrly_223_2005_lt where tid=1 AND time=\\'2000-01-01 00:00\\'",
                "pointwidth": "1.0"
            },
            "OLSSM_223_TC2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_223_TC2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "TC2 Thermistor Temperature avg",
                "units": "Celsius_scale",
                "missing_value": "NaN",
                "PGtype": "float4",
                "codedstring": "select tc_2_avg from brf_olssm_hrly_223_2005_lt where tid=%d[tid] AND time=\\'%F %R[time]\\' ",
                "myallquery": "select tc_2_avg from brf_olssm_hrly_223_2005_lt where tid=1 AND time=\\'2000-01-01 00:00\\'",
                "pointwidth": "1.0"
            },
            "OLSSM_120_vars": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_120_vars",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "treflog": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "treflog",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "treflog",
                    "missing_value": "NaN",
                    "units": "unitless",
                    "PGtype": "float4"
                },
                "battery": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battery",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Battery",
                    "units": "volts",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                }
            },
            "OLSSM_113_trefmux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_113_trefmux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "trefmux avg",
                "missing_value": "NaN",
                "units": "unitless",
                "PGtype": "float4",
                "codedstring": "select trefmux_avg from brf_olssm_hrly_113_2005_lt where tid=%d[tid] AND time=\\'%F %R[time]\\' ",
                "myallquery": "select trefmux_avg from brf_olssm_hrly_113_2005_lt where tid=1 AND time=\\'2000-01-01 00:00\\'",
                "pointwidth": "1.0"
            },
            "OLSSM_113_TC1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_113_TC1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "TC1 Thermistor Temperature Avg",
                "units": "Celsius_scale",
                "missing_value": "NaN",
                "PGtype": "float4",
                "codedstring": "select tc_1_avg from brf_olssm_hrly_113_2005_lt where tid=%d[tid] AND time=\\'%F %R[time]\\' ",
                "myallquery": "select tc_1_avg from brf_olssm_hrly_113_2005_lt where tid=1 AND time=\\'2000-01-01 00:00\\'",
                "pointwidth": "1.0"
            },
            "OLSSM_101_vars": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OLSSM_101_vars",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "dstime": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dstime",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "DSTime",
                    "units": "unitless",
                    "PGtype": "int4"
                },
                "dstempf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dstempf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Snow Depth Temperature",
                    "units": "Fahrenheit_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "dsretries": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dsretries",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Snow Depth Retries",
                    "units": "unitless",
                    "PGtype": "int4"
                },
                "dsdepth": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dsdepth",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Snow Depth",
                    "units": "inches",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                },
                "battery": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "battery",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Battery",
                    "units": "volts",
                    "missing_value": "NaN",
                    "PGtype": "float4"
                }
            }
        },
        "SnowStation": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SnowStation",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Stonehouse": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Stonehouse",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Stonehouse_Thermistors": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Stonehouse_Thermistors",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Thermistor Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4",
                    "codedstring": "select thrmtem_avg from stonehouse_main_therm where thermid=%d[tid] AND time=\\'%F %R[time]\\' ",
                    "myallquery": "select thrmtem_avg from stonehouse_main_therm where thermid=1 AND time=\\'2000-01-01 00:00\\'",
                    "pointwidth": "1.0"
                },
                "Stonehouse_rad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Stonehouse_rad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "uptotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uptotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Up_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempkavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempkavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature:K",
                        "units": "Kelvin_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempcavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempcavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature:C",
                        "units": "Celcius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "nettotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nettotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "netrsavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "netrsavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_Rs_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "netrlavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "netrlavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_Rl_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "dntotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dntotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Dn_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cm3upavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cm3upavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CM_up_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cm3dnavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cm3dnavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CM_dn_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cg3upavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cg3upavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CG_up_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cg3dnavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cg3dnavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CG_dn_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "albedoavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedoavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Albedo_AVG",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    }
                },
                "Stonehouse_main_1D_vars": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Stonehouse_main_1D_vars",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "windspd_ms_s_wvt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "windspd_ms_s_wvt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wind Speed",
                        "units": "m/s",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "winddir_sd1_wvt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "winddir_sd1_wvt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wind Direction SD1",
                        "units": "degrees",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "winddir_d1_wvt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "winddir_d1_wvt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wind Direction D1",
                        "units": "degrees",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "volumetric_water_content_2_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "volumetric_water_content_2_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Volumetric Water Content 2",
                        "units": "percent",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "volumetric_water_content_1_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "volumetric_water_content_1_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Volumetric Water Content 1",
                        "units": "percent",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempairx_max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempairx_max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Maximum Air Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempairn_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempairn_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Minimum Air Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempaira_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempaira_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Average Air Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_tempf_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_tempf_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth Temperature",
                        "units": "Fahrenheit_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_retries_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_retries_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth Retries",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_depth_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_depth_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth",
                        "units": "inches",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "rel_hum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rel_hum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Relative Humidity",
                        "units": "percent",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "rain_mm_tot": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rain_mm_tot",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total Rainfall",
                        "units": "mm",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "paneltemp_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paneltemp_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Panel Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "battery_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "battery_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Battery Minimum",
                        "units": "volts",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "air_press_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "air_press_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Average Air Pressure",
                        "units": "mb",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    }
                }
            },
            "OldHQ": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OldHQ",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "OldHQ_Thermistors": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OldHQ_Thermistors",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Thermistor Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "PGtype": "float4",
                    "codedstring": "select thrmtem_avg from oldhq_main_therm where thermid=%d[tid] AND time=\\'%F %R[time]\\' ",
                    "myallquery": "select thrmtem_avg from oldhq_main_therm where thermid=1 AND time=\\'2000-01-01 00:00\\'",
                    "pointwidth": "1.0"
                },
                "OldHQ_rad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OldHQ_rad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "uptotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uptotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Up_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempkavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempkavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature:K",
                        "units": "Kelvin_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "tempcavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempcavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Temperature:C",
                        "units": "Celcius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "nettotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nettotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "netrsavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "netrsavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_Rs_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "netrlavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "netrlavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Net_Rl_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "dntotalavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dntotalavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Dn_total_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cm3upavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cm3upavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CM_up_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cm3dnavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cm3dnavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CM_dn_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cg3upavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cg3upavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CG_up_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "cg3dnavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cg3dnavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CG_dn_AVG",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "albedoavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "albedoavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Albedo_AVG",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    }
                },
                "OldHQ_main_1D_vars": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OldHQ_main_1D_vars",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "volumetric_water_content_2_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "volumetric_water_content_2_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Volumetric Water Content 2",
                        "units": "percent",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "volumetric_water_content_1_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "volumetric_water_content_1_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Volumetric Water Content 1",
                        "units": "percent",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "uv_temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uv_temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "UV-temp",
                        "units": "mV",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "uv_b": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uv_b",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "UV-B",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "uv_a": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uv_a",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "UV-A",
                        "units": "watts^m*m",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_tempf_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_tempf_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth Temperature",
                        "units": "Fahrenheit_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_retries_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_retries_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth Retries",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "snow_depth_depth_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "snow_depth_depth_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Snow Depth",
                        "units": "inches",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "paneltemp_avg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paneltemp_avg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Panel Temperature",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    },
                    "battery_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "battery_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Battery Minimum",
                        "units": "volts",
                        "missing_value": "NaN",
                        "PGtype": "float4"
                    }
                }
            }
        },
        "time_16": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_16",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1995-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667"
        },
        "time_15": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_15",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1995-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667"
        },
        "time_14": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_14",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1995-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667"
        },
        "time_13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1995-01-01 00:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667"
        },
        "time_12": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_12",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_11": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_11",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "tid_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tid_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "time_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.04166667",
            "units": "s since 2000-01-01"
        },
        "time_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.0",
            "units": "s since 2000-01-01"
        },
        "time_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.006944444",
            "units": "s since 2000-01-01"
        },
        "time_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.0",
            "units": "s since 2000-01-01"
        },
        "time_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.0",
            "units": "s since 2000-01-01"
        },
        "tid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "time_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.006944444",
            "units": "s since 2000-01-01"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0.0",
            "units": "s since 2000-01-01"
        },
        "dir": "SOURCES/BRF"
    },
    "BerkeleyEarth": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "BerkeleyEarth",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "globalgriddeddailylanddeg1p0pc5180description": "Pentad Climatology 1951-1980",
            "globalgriddeddailylanddeg1p0minimuminstitution": "Berkeley Earth Surface Temperature Project, http://www.berkeleyearth.org/",
            "globalgriddeddailylanddeg1p0minimumdata": "http://berkeleyearth.org/data/",
            "globalgriddeddailylanddeg1p0meaninstitution": "Berkeley Earth Surface Temperature Project, http://www.berkeleyearth.org/",
            "globalgriddeddailylanddeg1p0meandata": "http://berkeleyearth.org/data/",
            "globalgriddeddailylanddeg1p0maximuminstitution": "Berkeley Earth Surface Temperature Project, http://www.berkeleyearth.org/",
            "globalgriddeddailylanddeg1p0maximumdata": "http://berkeleyearth.org/data/",
            "globalgriddeddailylanddeg1p0dc5180description": "Daily Climatology 1951-1980",
            "globalgriddeddailylanddeg1p0dc5180institution": "Berkeley Earth Surface Temperature Project, http://www.berkeleyearth.org/",
            "globalgriddeddailylanddeg1p0dc5180data": "http://berkeleyearth.org/data/",
            "globalgriddeddailylanddeg1p0institution": "Berkeley Earth Surface Temperature Project, http://www.berkeleyearth.org/",
            "globalgriddeddailylanddeg1p0Conventions": "Berkeley Earth Internal Convention (based on CF-1.5)",
            "globalgriddeddailylanddeg1p0title": "Gridded Berkeley Earth Surface Temperature Anomaly Field",
            "globalgriddeddailylanddeg1p0data": "http://berkeleyearth.org/data/",
            "globalgriddeddailylanddeg1p0comment": "This file contains surface temperature anomaly field gridded on a 1 deg. (longitude) by 1 deg. (latitude) grid-box basis.",
            "description": "Berkeley Earth",
            "iridlhasSemantics": "iridl:BerkeleyEarth",
            "Conventions": "IRIDL",
            "Berkeley": "http://berkeleyearth.org"
        },
        "_global": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "global",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridded": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "land": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "land",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "deg1p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "deg1p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pc5180": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pc5180",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "degree_Celsius",
                                    "long_name": "Minimum Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "standard_name": "air_temperature",
                                    "coordinates": "latitude longitude",
                                    "history": "[(17-Jun-2018 21:05:54) (Averaged in T2 with overlapping interval 5) (Boxes with less than 0.0% dropped)]"
                                },
                                "tmax": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmax",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "degree_Celsius",
                                    "long_name": "Maximum Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "standard_name": "air_temperature",
                                    "coordinates": "latitude longitude",
                                    "history": "[(17-Jun-2018 21:05:54) (Averaged in T2 with overlapping interval 5) (Boxes with less than 0.0% dropped)]"
                                },
                                "tavg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tavg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "degree_Celsius",
                                    "long_name": "Average Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "standard_name": "air_temperature",
                                    "coordinates": "latitude longitude",
                                    "history": "[(17-Jun-2018 21:05:54) (Averaged in T2 with overlapping interval 5) (Boxes with less than 0.0% dropped)]"
                                }
                            },
                            "minimum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "minimum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "yr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Year",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                },
                                "tmin_anomaly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmin_anomaly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "32.309147",
                                    "missing_value": "NaN",
                                    "valid_min": "-32.576313",
                                    "long_name": "Minimum Surface Air Temperature Anomaly",
                                    "standard_name": "air_temperature_anomaly",
                                    "units": "degree_Celsius",
                                    "pointwidth": "0"
                                },
                                "month": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "month",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Month",
                                    "units": "month number",
                                    "pointwidth": "0"
                                },
                                "land_mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "land_mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "1.0",
                                    "missing_value": "NaN",
                                    "valid_min": "0.0",
                                    "long_name": "Land Area Fraction",
                                    "standard_name": "land_area_fraction",
                                    "units": "unitless"
                                },
                                "day_of_year": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day_of_year",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Year",
                                    "units": "day of year",
                                    "pointwidth": "0"
                                },
                                "day": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Month",
                                    "units": "day of month",
                                    "pointwidth": "0"
                                },
                                "date_number": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date_number",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Date Number",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                }
                            },
                            "mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "yr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Year",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                },
                                "tavg_anomaly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tavg_anomaly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "32.309147",
                                    "missing_value": "NaN",
                                    "valid_min": "-32.576313",
                                    "long_name": "Average Surface Air Temperature Anomaly",
                                    "standard_name": "air_temperature_anomaly",
                                    "units": "degree_Celsius",
                                    "pointwidth": "0"
                                },
                                "month": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "month",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Month",
                                    "units": "month number",
                                    "pointwidth": "0"
                                },
                                "land_mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "land_mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "1.0",
                                    "missing_value": "NaN",
                                    "valid_min": "0.0",
                                    "long_name": "Land Area Fraction",
                                    "standard_name": "land_area_fraction",
                                    "units": "unitless"
                                },
                                "day_of_year": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day_of_year",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Year",
                                    "units": "day of year",
                                    "pointwidth": "0"
                                },
                                "day": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Month",
                                    "units": "day of month",
                                    "pointwidth": "0"
                                },
                                "date_number": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date_number",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Date Number",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                }
                            },
                            "maximum": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "maximum",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "yr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Year",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                },
                                "tmax_anomaly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmax_anomaly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "32.309147",
                                    "missing_value": "NaN",
                                    "valid_min": "-32.576313",
                                    "long_name": "Maximum Surface Air Temperature Anomaly",
                                    "standard_name": "air_temperature_anomaly",
                                    "units": "degree_Celsius",
                                    "pointwidth": "0"
                                },
                                "month": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "month",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Month",
                                    "units": "month number",
                                    "pointwidth": "0"
                                },
                                "land_mask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "land_mask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "1.0",
                                    "missing_value": "NaN",
                                    "valid_min": "0.0",
                                    "long_name": "Land Area Fraction",
                                    "standard_name": "land_area_fraction",
                                    "units": "unitless"
                                },
                                "day_of_year": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day_of_year",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Year",
                                    "units": "day of year",
                                    "pointwidth": "0"
                                },
                                "day": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day of Month",
                                    "units": "day of month",
                                    "pointwidth": "0"
                                },
                                "date_number": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date_number",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Date Number",
                                    "units": "year A.D.",
                                    "pointwidth": "0"
                                }
                            },
                            "dc5180": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dc5180",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmin_climatology": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmin_climatology",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "50.0",
                                    "missing_value": "NaN",
                                    "valid_min": "-75.0",
                                    "coordinates": "latitude longitude",
                                    "long_name": "Minimum Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "units": "degree_Celsius",
                                    "standard_name": "air_temperature"
                                },
                                "tmax_climatology": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmax_climatology",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "50.0",
                                    "missing_value": "NaN",
                                    "valid_min": "-75.0",
                                    "coordinates": "latitude longitude",
                                    "long_name": "Maximum Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "units": "degree_Celsius",
                                    "standard_name": "air_temperature"
                                },
                                "tavg_climatology": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tavg_climatology",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "valid_max": "50.0",
                                    "missing_value": "NaN",
                                    "valid_min": "-75.0",
                                    "coordinates": "latitude longitude",
                                    "long_name": "Average Surface Air Temperature Climatology (Jan 1951 - Dec 1980)",
                                    "units": "degree_Celsius",
                                    "standard_name": "air_temperature"
                                }
                            }
                        }
                    }
                }
            }
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "pentads since 1960-01-01",
            "gridtype": "1",
            "modulo": "73.0",
            "calendar": "365",
            "modulus": "73.0",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days",
            "gridtype": "1",
            "calendar": "365",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/BerkeleyEarth"
    },
    "Biosphere": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Biosphere",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL",
            "Biosphere": "http://www.b2science.org/",
            "description": "Biosphere 2 Laboratory"
        },
        "RFSoil50": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RFSoil50",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Fahrenheit",
                "missing_value": "-909090.0",
                "long_name": "Soil_Temp"
            }
        },
        "RFSoil0": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RFSoil0",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Fahrenheit",
                "missing_value": "-909090.0",
                "location": " ISMAP> Rain Forest Sensor Map</A>",
                "sensor_id": "Soil Temp #2225",
                "long_name": "Soil_Temp"
            }
        },
        "example": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "example",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "exlight": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "exlight",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "micro einsteins/m2/s",
                "missing_value": "-99999.0",
                "sensor": "LI-190SA Quantum which measures PAR (Photosynthetically Active Radiation)",
                "location": "outside the Biosphere 2 complex on the top of the Habitat ring",
                "sensorid": "light#1985",
                "long_name": "External Light"
            },
            "co2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "co2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ppm",
                "missing_value": "-99999.0",
                "sensor": "3K Priva",
                "location": " Desert Biome of the Biosphere",
                "sensorid": "co2#838",
                "long_name": "Carbon Dioxide"
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "0.01100152",
            "add_offset": "2450084"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "0.01041667",
            "add_offset": "2450084"
        },
        "dir": "SOURCES/Biosphere"
    },
    "BoM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "BoM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "POAMAM24Realtimem24cPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Realtimem24cThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Realtimem24cexpires": "1615334400",
            "POAMAM24Realtimem24cdescription": "POAMA 2.4C Multiweek Real-time Forecasts",
            "POAMAM24Realtimem24creferences": "Hudson_etal2013",
            "POAMAM24Realtimem24bPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Realtimem24bThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Realtimem24bdescription": "POAMA 2.4B Multiweek Real-time Forecasts",
            "POAMAM24Realtimem24breferences": "Hudson_etal2013",
            "POAMAM24Realtimem24aPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Realtimem24aThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Realtimem24adescription": "POAMA 2.4A Multiweek Real-time Forecasts",
            "POAMAM24Realtimem24areferences": "Hudson_etal2013",
            "POAMAM24Hindcastm24cdescription": "POAMA 2.4C Hindcast: All Starts",
            "POAMAM24Hindcastm24cThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Hindcastm24chistory": "Produced by BMRC DP V15 20120813 19:08",
            "POAMAM24Hindcastm24cexpt_id": "m24c    ",
            "POAMAM24Hindcastm24cmodl_vrsn": "3.0d    ",
            "POAMAM24Hindcastm24cPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Hindcastm24cserved_from": "opendap.bom.gov.au:8080",
            "POAMAM24Hindcastm24cconventions": "COARDS",
            "POAMAM24Hindcastm24carch_vrsn": "g2.0    ",
            "POAMAM24Hindcastm24cNCO": "4.0.0",
            "POAMAM24Hindcastm24creferences": "Hudson_etal2013",
            "POAMAM24Hindcastm24bdescription": "POAMA 2.4B Hindcast: All Starts",
            "POAMAM24Hindcastm24bThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Hindcastm24bhistory": "Produced by BMRC DP V15 20120813 19:08",
            "POAMAM24Hindcastm24bexpt_id": "m24b    ",
            "POAMAM24Hindcastm24bmodl_vrsn": "3.0d    ",
            "POAMAM24Hindcastm24bPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Hindcastm24bserved_from": "opendap.bom.gov.au:8080",
            "POAMAM24Hindcastm24bconventions": "COARDS",
            "POAMAM24Hindcastm24barch_vrsn": "g2.0    ",
            "POAMAM24Hindcastm24bNCO": "4.0.0",
            "POAMAM24Hindcastm24breferences": "Hudson_etal2013",
            "POAMAM24Hindcastm24adescription": "POAMA 2.4A Hindcast: All Starts",
            "POAMAM24Hindcastm24aThe": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24Hindcastm24ahistory": "Produced by BMRC DP V15 20120813 19:08",
            "POAMAM24Hindcastm24aexpt_id": "m24a    ",
            "POAMAM24Hindcastm24amodl_vrsn": "3.0d    ",
            "POAMAM24Hindcastm24aPOAMA": "http://poama.bom.gov.au/",
            "POAMAM24Hindcastm24aserved_from": "opendap.bom.gov.au:8080",
            "POAMAM24Hindcastm24aconventions": "COARDS",
            "POAMAM24Hindcastm24aarch_vrsn": "g2.0    ",
            "POAMAM24Hindcastm24aNCO": "4.0.0",
            "POAMAM24Hindcastm24areferences": "Hudson_etal2013",
            "POAMAM24description": "M24",
            "POAMAM24The": "http://poama.bom.gov.au/about_poama2.shtml#The_new_POAMA2_System",
            "POAMAM24references": "Hudson_etal2013",
            "POAMAdescription": "Predictive Ocean Atmosphere Model for Australia",
            "POAMAreferences": "Hudson_etal2013",
            "POAMAPOAMA": "http://poama.bom.gov.au/",
            "MJORMMdescription": "Real-time Multivariate MJO Index (with components of interannual variability removed)",
            "MJORMMdata": "http://www.bom.gov.au/climate/mjo/graphics/rmm.74toRealtime.txt",
            "MJORMMexpires": "1615161600",
            "MJORMMreferences": "Wheeler_Hendon2004",
            "MJORMMWheeler": "http://journals.ametsoc.org/doi/abs/10.1175/1520-0493(2004)132%3C1917:AARMMI%3E2.0.CO;2",
            "MJORMMsummary": "http://www.bom.gov.au/climate/mjo/",
            "MJOdescription": "Madden-Julian Oscillation",
            "description": "Australian Bureau of Meteorology",
            "Conventions": "IRIDL",
            "BoM": "http://www.bom.gov.au/"
        },
        "POAMA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "POAMA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "M24": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M24",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Realtime": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Realtime",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "m24c": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24c",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615334400",
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615334400",
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1615334400",
                            "dodsname": "hr24_prcp",
                            "standard_name": "precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm",
                            "pointwidth": "1.0"
                        }
                    },
                    "m24b": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24b",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "hr24_prcp",
                            "standard_name": "precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm",
                            "pointwidth": "1.0"
                        }
                    },
                    "m24a": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24a",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "hr24_prcp",
                            "standard_name": "precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm",
                            "pointwidth": "1.0"
                        }
                    }
                },
                "Hindcast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Hindcast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "m24c": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24c",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "hr24_prcp",
                            "standard_name": "lwe_precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm/day",
                            "pointwidth": "1.0"
                        }
                    },
                    "m24b": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24b",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "hr24_prcp",
                            "standard_name": "lwe_precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm/day",
                            "pointwidth": "1.0"
                        }
                    },
                    "m24a": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "m24a",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tsaira": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tsaira",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "tsaira",
                            "standard_name": "air_temperature",
                            "grid_type": "spatial",
                            "long_name": "temperature at 1.5m",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "sfc_temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sfc_temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "sfc_temp",
                            "standard_name": "surface_temperature",
                            "grid_type": "spatial",
                            "long_name": "surface temperature",
                            "level_type": "single",
                            "units": "Kelvin_scale",
                            "pointwidth": "1.0"
                        },
                        "hr24_prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hr24_prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "dodsname": "hr24_prcp",
                            "standard_name": "lwe_precipitation_rate",
                            "grid_type": "spatial",
                            "long_name": "total precipitation",
                            "level_type": "single",
                            "units": "mm/day",
                            "pointwidth": "1.0"
                        }
                    }
                }
            }
        },
        "MJO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MJO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RMM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RMM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "RMM2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RMM2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "9.99999962E35",
                    "units": "unitless",
                    "expires": "1615161600"
                },
                "RMM1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RMM1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "9.99999962E35",
                    "units": "unitless",
                    "expires": "1615161600"
                },
                "phase": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "phase",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "999.0",
                    "units": "unitless",
                    "expires": "1615161600"
                },
                "amplitude": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "amplitude",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "9.99999962E35",
                    "units": "unitless",
                    "expires": "1615161600"
                }
            }
        },
        "S_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1615334400",
            "standard_name": "forecast_reference_time",
            "long_name": "Start Time",
            "pointwidth": "0"
        },
        "S_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "forecast_reference_time",
            "long_name": "Start Time",
            "pointwidth": "0"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "standard_name": "forecast_period",
            "long_name": "Lead",
            "pointwidth": "1.0"
        },
        "S_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "forecast_reference_time",
            "long_name": "Start Time",
            "pointwidth": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "long_name": "latitude"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "long_name": "longitude",
            "pointwidth": "2.5"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "standard_name": "realization",
            "long_name": "Ensemble Member",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "0"
        },
        "L0": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L0",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "long_name": "Lead",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "expires": "1615161600",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/BoM"
    },
    "CAC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CAC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CAC/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL",
            "history": "Climate Analysis Center SST",
            "references": "Woodruff_etal1993 Reynolds_Smith1994",
            "description": "Climatological, smoothed, and raw sea surface temperature data for the tropical Pacific Ocean from the Climate Analysis Center (now known as the Climate Prediction Center)"
        },
        "ssta": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ssta",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_Celsius",
            "scale_max": "4.1999998",
            "ncolor": "254",
            "scale_min": "-4.1999998",
            "CS": "-4.1999998",
            "colorscalename": "sstacolorscale",
            "CE": "4.1999998",
            "maxncolor": "254",
            "colormap": "2763429",
            "long_name": "Sea Surface Temperature Anomaly"
        },
        "sst": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "sst",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "Celsius_scale",
            "long_name": "Sea Surface Temperature"
        },
        "smoothed": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "smoothed",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ssta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ssta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Celsius",
                "scale_max": "4.1999998",
                "ncolor": "254",
                "scale_min": "-4.1999998",
                "CS": "-4.1999998",
                "colorscalename": "sstacolorscale",
                "CE": "4.1999998",
                "maxncolor": "254",
                "colormap": "2763429",
                "long_name": "Sea Surface Temperature Anomaly"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "Sea Surface Temperature"
            }
        },
        "climatology": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "climatology",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Celsius_scale",
                "long_name": "Sea Surface Temperature"
            }
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/CAC"
    },
    "CARDONE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CARDONE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "ECMWF five day average wind stress; Cardone Level 2B data",
            "iridlhasSemantics": "iridl:Oceanweather",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "9999.0",
            "scale_factor": "0.001",
            "history": "ECMWF five day average wind stress.  This is Cardone Level 2B data.",
            "long_name": "meridional wind stress",
            "units": "dynes/cm2"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "9999.0",
            "scale_factor": "0.001",
            "history": "ECMWF five day average wind stress.  This is Cardone Level 2B data.",
            "long_name": "zonal wind stress",
            "units": "dynes/cm2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "5.0",
            "add_offset": "2444971"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "1.875"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.875"
        },
        "dir": "SOURCES/CARDONE"
    },
    "CARTON": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CARTON",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SODA3SODA331Creation_date": "October 2016",
            "SODA3SODA331source": "http://www.atmos.umd.edu/~ocean/index_files/soda3.3.1_mn_download.htm",
            "SODA3SODA331Created_by": "Gennady Chepurin and Ligang Chen",
            "SODA3SODA331dataset_documentation": "http://www.atmos.umd.edu/~ocean/index_files/soda3_readme.htm",
            "SODA3SODA331Principal_investigator_email": "carton@atmos.umd.edu",
            "SODA3SODA331Acknowledgement": "The SODA3 project is funded by the US National Science Foundation. Please cite: Carton, Chepurin, and Chen (2017)",
            "SODA3SODA331Institution": "University of Maryland",
            "SODA3SODA331Website": "http://www.soda.umd.edu",
            "SODA3SODA331Title": "SODA3.3.1 ocean state",
            "SODA3SODA331Principal_investigator": "James A. Carton",
            "Conventions": "IRIDL"
        },
        "SODA3": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SODA3",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SODA331": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SODA3.3.1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "100000.0",
                    "cell_methods": "time: mean",
                    "long_name": "dia-surface velocity T-points",
                    "standard_name": "",
                    "units": "m/sec",
                    "pointwidth": "0"
                },
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10.0",
                    "cell_methods": "time: mean",
                    "long_name": "j-current",
                    "standard_name": "sea_water_y_velocity",
                    "units": "m/sec",
                    "pointwidth": "0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10.0",
                    "cell_methods": "time: mean",
                    "long_name": "i-current",
                    "standard_name": "sea_water_x_velocity",
                    "units": "m/sec",
                    "pointwidth": "0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "500.0",
                    "cell_methods": "time: mean",
                    "long_name": "Potential temperature",
                    "standard_name": "sea_water_potential_temperature",
                    "units": "degrees C",
                    "pointwidth": "0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10.0",
                    "cell_methods": "time: mean",
                    "long_name": "j-directed wind stress forcing v-velocity",
                    "standard_name": "surface_downward_y_stress",
                    "units": "N/m^2",
                    "pointwidth": "0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10.0",
                    "cell_methods": "time: mean",
                    "long_name": "i-directed wind stress forcing u-velocity",
                    "standard_name": "surface_downward_x_stress",
                    "units": "N/m^2",
                    "pointwidth": "0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "1000.0",
                    "cell_methods": "time: mean",
                    "long_name": "effective sea level (eta_t + patm/(rho0*g)) on T cells",
                    "standard_name": "sea_surface_height_above_geoid",
                    "units": "m",
                    "pointwidth": "0"
                },
                "salt_flux_total": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt_flux_total",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10000.0",
                    "cell_methods": "time: mean",
                    "long_name": "sfc_salt_flux_total",
                    "standard_name": "",
                    "units": "kg/(m^2*sec)",
                    "pointwidth": "0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "100.0",
                    "cell_methods": "time: mean",
                    "long_name": "Practical Salinity",
                    "standard_name": "sea_water_salinity",
                    "units": "psu",
                    "pointwidth": "0"
                },
                "prho": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prho",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "100000.0",
                    "cell_methods": "time: mean",
                    "long_name": "potential density referenced to 0 dbar",
                    "standard_name": "sea_water_potential_density",
                    "units": "kg/m^3",
                    "pointwidth": "0"
                },
                "net_heating": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "net_heating",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "10000.0",
                    "cell_methods": "time: mean",
                    "long_name": "surface ocean heat flux coming through coupler and mass transfer",
                    "standard_name": "",
                    "units": "W/m2",
                    "pointwidth": "0"
                },
                "mlt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mlt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "1000000.0",
                    "cell_methods": "time: mean",
                    "long_name": "mixed layer depth determined by temperature criteria",
                    "standard_name": "",
                    "units": "m",
                    "pointwidth": "0"
                },
                "mls": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mls",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "1000000.0",
                    "cell_methods": "time: mean",
                    "long_name": "mixed layer depth determined by salinity criteria",
                    "standard_name": "",
                    "units": "m",
                    "pointwidth": "0"
                },
                "mlp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mlp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "1000000.0",
                    "cell_methods": "time: mean",
                    "long_name": "Depth of potential density mixed layer",
                    "standard_name": "",
                    "units": "m",
                    "pointwidth": "0"
                },
                "mi": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mi",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "cell_methods": "time: mean",
                    "long_name": "Sea Ice Mass",
                    "units": "kg/m^2",
                    "pointwidth": "0"
                },
                "isotemp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "isotemp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "long_name": "potential temperature at the depth of isopycn",
                    "units": "degrees C",
                    "pointwidth": "0"
                },
                "isosalt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "isosalt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "long_name": "salinity at the depth of isopycn",
                    "units": "psu",
                    "pointwidth": "0"
                },
                "isodepth": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "isodepth",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "long_name": "depth of isoypycn",
                    "units": "m",
                    "pointwidth": "0"
                },
                "hs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "cell_methods": "time: mean",
                    "long_name": "Snow Thickness",
                    "units": "m-snow",
                    "pointwidth": "0"
                },
                "hi": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "hi",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "cell_methods": "time: mean",
                    "long_name": "Sea Ice Thickness",
                    "units": "m-ice",
                    "pointwidth": "0"
                },
                "cn": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cn",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "cell_methods": "time: mean ct: mean",
                    "long_name": "Sea Ice Concentration",
                    "units": "0-1",
                    "pointwidth": "0"
                },
                "anompb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "anompb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-1.00000002E20",
                    "valid_range": "1000000.0",
                    "cell_methods": "time: mean",
                    "long_name": "T-cell bottom pressure - rho0*grav*ht",
                    "standard_name": "",
                    "units": "dbar",
                    "pointwidth": "0"
                }
            }
        },
        "depth": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "depth",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "level": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "level",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "latitude": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "latitude",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5"
        },
        "longitude": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "longitude",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "0.5"
        },
        "dir": "SOURCES/CARTON"
    },
    "CARTONGIESE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CARTON-GIESE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SODAv2p2p4source": "http://dsrs.atmos.umd.edu/DATA/soda_2.2.4/",
            "SODAv2p2p4long_name": "SODA 2.2.4, 1871-2008 Assimilation Run",
            "SODAv2p2p4released": "July 20, 2010",
            "SODAv2p2p4description": "Oceanic and air-sea interface data from the UMD Simple Ocean Data Assimilation Reanalysis",
            "SODAv2p2p4documentation": "http://www.atmos.umd.edu/~carton/pdfs/carton&giese05.pdf",
            "SODAv2p2p4readme": "http://dsrs.atmos.umd.edu/DATA/soda_2.2.4/README.txt",
            "SODAv2p1p6source": "http://dsrs.atmos.umd.edu/DATA/soda_2.1.6/",
            "SODAv2p1p6long_name": "SODA 2.1.6",
            "SODAv2p1p6references": "Carton_Giese2007",
            "SODAv2p1p6SODA": "http://www.atmos.umd.edu/~carton/pdfs/carton&giese05.pdf",
            "SODAv2p1p6description": "Oceanic and air-sea interface data from the UMD Simple Ocean Data Assimilation Reanalysis",
            "SODAv2p1p6iridlhasSemantics": "iridl:Ocean",
            "SODAv2p0p24SODA": "http://www.atmos.umd.edu/~carton/pdfs/carton&giese05.pdf",
            "SODAv2p0p24long_name": "Version 2.0.2-4",
            "SODAv2p0p24references": "Carton_Giese2007",
            "SODAv2p0p24title": "SODA - POP 2.0.2-4 Assimilation Giese/Carton",
            "SODAv2p0p24iridlhasSemantics": "iridl:Ocean",
            "SODAv2p0p23long_name": "Version 2.0.2-3",
            "SODAv2p0p23references": "Carton_Giese2007",
            "SODAv2p0p23SODA": "http://iridl.ldeo.columbia.edu/SOURCES/.CARTON-GIESE/.SODA/.v2p0p2-4/",
            "SODAv2p0p23title": "SODA - POP 2.0.2-3 Assimilation Giese/Carton",
            "SODAv2p0p23iridlhasSemantics": "iridl:Ocean",
            "SODAv1p4p3source": "http://dsrs.atmos.umd.edu/DATA/SODA_1.4.3/",
            "SODAv1p4p3long_name": "Version 1.4.3",
            "SODAv1p4p3references": "Carton_Giese2006",
            "SODAv1p4p3SODA": "http://iridl.ldeo.columbia.edu/SOURCES/.CARTON-GIESE/.SODA/.v2p0p2-3/",
            "SODAv1p4p3title": "SODA - POP 1.4.3 Assimilation TAMU/UMD",
            "SODAv1p4p3iridlhasSemantics": "iridl:Ocean",
            "SODAv1p4p2source": "http://dsrs.atmos.umd.edu/DATA/SODA_1.4.2/",
            "SODAv1p4p2long_name": "Version 1.4.2",
            "SODAv1p4p2references": "Carton_Giese2006",
            "SODAv1p4p2SODA": "http://iridl.ldeo.columbia.edu/SOURCES/.CARTON-GIESE/.SODA/.v2p0p2-3/",
            "SODAv1p4p2title": "SODA - POP 1.4.2 Assimilation TAMU/UMD",
            "SODAv1p4p2iridlhasSemantics": "iridl:Ocean",
            "SODAv1p2SODA": "http://www.atmos.umd.edu/~ocean/soda1.2.pdf",
            "SODAv1p2source": "http://dsrs.atmos.umd.edu/DATA/SODA_1.2/",
            "SODAv1p2long_name": "Version 1.2",
            "SODAv1p2references": "Carton_etal2000a Carton_etal2000b",
            "SODAv1p2title": "SODA - POP 1.2 Assimilation TAMU/UMD",
            "SODAdescription": "SODA: A Reanalysis of Ocean Climate",
            "SODAlong_name": "Simple Ocean Data Assimilation",
            "iridlhasSemantics": "iridl:TAMU",
            "Conventions": "IRIDL",
            "long_name": "Carton/Giese"
        },
        "SODA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SODA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v2p2p4": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p2p4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "w": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "VERTICAL VELOCITY",
                    "units": "m/sec",
                    "standard_name": "upward_sea_water_velocity",
                    "pointwidth": "1.0"
                },
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "m/sec",
                    "standard_name": "northward_sea_water_velocity",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "m/sec",
                    "standard_name": "eastward_sea_water_velocity",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "standard_name": "sea_water_temperature",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAUY",
                    "units": "N/m2",
                    "standard_name": "surface_downward_northward_stress",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAUX",
                    "units": "N/m2",
                    "standard_name": "surface_downward_eastward_stress",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA SURFACE HEIGHT",
                    "units": "meters",
                    "standard_name": "sea_surface_height",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "iridlhasSemantics": "iridl:Salinity",
                    "long_name": "SALINITY",
                    "units": "g/kg",
                    "pointwidth": "1.0"
                }
            },
            "v2p1p6": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p1p6",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "m/sec",
                    "standard_name": "northward_sea_water_velocity",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "m/sec",
                    "standard_name": "eastward_sea_water_velocity",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "standard_name": "sea_water_temperature",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAUY",
                    "units": "N/m2",
                    "standard_name": "surface_downward_northward_stress",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAUX",
                    "units": "N/m2",
                    "standard_name": "surface_downward_eastward_stress",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA SURFACE HEIGHT",
                    "units": "meters",
                    "standard_name": "sea_surface_height",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "iridlhasSemantics": "iridl:Salinity",
                    "long_name": "SALINITY",
                    "units": "g/kg",
                    "pointwidth": "1.0"
                }
            },
            "v2p0p24": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p0p2-4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "w": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "VERTICAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU Y",
                    "units": "N/m2",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU X",
                    "units": "N/m2",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA LEVEL HEIGHT",
                    "units": "meters",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "iridlhasSemantics": "iridl:Salinity",
                    "long_name": "SALINITY",
                    "units": "g/kg",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                }
            },
            "v2p0p23": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p0p2-3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "w": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "VERTICAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "m/sec",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU Y",
                    "units": "N/m2",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU X",
                    "units": "N/m2",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA LEVEL HEIGHT",
                    "units": "meters",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "iridlhasSemantics": "iridl:Salinity",
                    "long_name": "SALINITY",
                    "units": "g/kg",
                    "fnname": "flaggt",
                    "pointwidth": "1.0"
                }
            },
            "v1p4p3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p4p3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU Y",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU X",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA LEVEL HEIGHT",
                    "units": "cm",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SALINITY",
                    "units": "ppt",
                    "pointwidth": "1.0"
                }
            },
            "v1p4p2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p4p2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU Y",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU X",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA LEVEL HEIGHT",
                    "units": "cm",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "iridlhasSemantics": "iridl:Salinity",
                    "long_name": "SALINITY",
                    "units": "ppt",
                    "pointwidth": "1.0"
                }
            },
            "v1p2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "MERIDIONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "ZONAL VELOCITY",
                    "units": "cm/sec",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TEMPERATURE",
                    "units": "Celsius_scale",
                    "pointwidth": "1.0"
                },
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU Y",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "TAU X",
                    "units": "dynes/cm^2",
                    "pointwidth": "1.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SEA LEVEL HEIGHT",
                    "units": "cm",
                    "pointwidth": "1.0"
                },
                "salt": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "salt",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-9.98999971E33",
                    "long_name": "SALINITY",
                    "units": "ppt",
                    "pointwidth": "1.0"
                }
            }
        },
        "time_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "time_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "time_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "time_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "depth_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "depth_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "meters",
            "gridtype": "0"
        },
        "time_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "depth": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "depth",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "meters",
            "gridtype": "0"
        },
        "dir": "SOURCES/CARTON-GIESE"
    },
    "CAYAN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CAYAN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Heat flux and irradiance data analysis of COADS from Cayan of Scripps",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CAYAN/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:SIO",
            "Conventions": "IRIDL",
            "references": "Cayan1992"
        },
        "Ti": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Ti",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "W/m2",
            "missing_value": "-99999.0",
            "long_name": "terrestrial irradiance",
            "history": "Cayan Terrestrial Irradiance Derived from COADS"
        },
        "Si": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Si",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "W/m2",
            "missing_value": "-99999.0",
            "long_name": "solar irradiance",
            "history": "Cayan Solar Irradiance Derived from COADS"
        },
        "Qsh": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Qsh",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "W/m2",
            "missing_value": "-99999.0",
            "long_name": "sensible heat flux",
            "history": "Cayan Sensible Heat Flux Derived from COADS"
        },
        "Qnet": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Qnet",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "W/m2",
            "missing_value": "-99999.0",
            "long_name": "net heat flux",
            "history": "Cayan Net Heat Flux Derived from COADS"
        },
        "Qlh": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Qlh",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "W/m2",
            "missing_value": "-99999.0",
            "long_name": "latent heat flux",
            "history": "Cayan Latent Heat Derived from COADS"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "5.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "long_name": "month",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "5.0"
        },
        "dir": "SOURCES/CAYAN"
    },
    "CCCma": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CCCma",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "DECADALuninitialized55_year_runmonthlyATMhistory": "2011-03-07T23:19:04Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
            "DECADALuninitialized55_year_runmonthlyATMexperiment": "10- or 30-year run initialized in year 1960",
            "DECADALuninitialized55_year_runmonthlyATMCCCma_runid": "DHFP1B_E010_I1961_M01",
            "DECADALuninitialized55_year_runmonthlyATMmodel_id": "CanCM4",
            "DECADALuninitialized55_year_runmonthlyATMforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
            "DECADALuninitialized55_year_runmonthlyATMtable_id": "Table Amon (31 January 2011) 53b766a395ac41696af40aab76a49ae5",
            "DECADALuninitialized55_year_runmonthlyATMinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
            "DECADALuninitialized55_year_runmonthlyATMsource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
            "DECADALuninitialized55_year_runmonthlyATMmodeling_realm": "atmos",
            "DECADALuninitialized55_year_runmonthlyATMexperiment_id": "decadal1960",
            "DECADALuninitialized55_year_runmonthlyATMcreation_date": "2011-03-07T23:19:04Z",
            "DECADALuninitialized55_year_runmonthlyATMinstitute_id": "CCCma",
            "DECADALuninitialized55_year_runmonthlyATMtitle": "CanCM4 model output prepared for CMIP5 10- or 30-year run initialized in year 1960",
            "DECADALuninitialized55_year_runmonthlyATMConventions": "CF-1.4",
            "DECADALuninitialized55_year_runmonthlyATMcontact": "cccma_info@ec.gc.ca",
            "DECADALuninitialized55_year_runmonthlyATMcmor_version": "2.5.4",
            "DECADALuninitialized55_year_runmonthlyATMphysics_version": "1",
            "DECADALuninitialized55_year_runmonthlyATMparent_experiment_rip": "N/A",
            "DECADALuninitialized55_year_runmonthlyATMproject_id": "CMIP5",
            "DECADALinitialized30_year_runmonthlyATMhistory": "2011-03-07T23:19:04Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
            "DECADALinitialized30_year_runmonthlyATMexperiment": "10- or 30-year run initialized in year 1960",
            "DECADALinitialized30_year_runmonthlyATMCCCma_runid": "DHFP1B_E010_I1961_M01",
            "DECADALinitialized30_year_runmonthlyATMmodel_id": "CanCM4",
            "DECADALinitialized30_year_runmonthlyATMforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
            "DECADALinitialized30_year_runmonthlyATMtable_id": "Table Amon (31 January 2011) 53b766a395ac41696af40aab76a49ae5",
            "DECADALinitialized30_year_runmonthlyATMinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
            "DECADALinitialized30_year_runmonthlyATMsource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
            "DECADALinitialized30_year_runmonthlyATMmodeling_realm": "atmos",
            "DECADALinitialized30_year_runmonthlyATMexperiment_id": "decadal1960",
            "DECADALinitialized30_year_runmonthlyATMcreation_date": "2011-03-07T23:19:04Z",
            "DECADALinitialized30_year_runmonthlyATMinstitute_id": "CCCma",
            "DECADALinitialized30_year_runmonthlyATMtitle": "CanCM4 model output prepared for CMIP5 10- or 30-year run initialized in year 1960",
            "DECADALinitialized30_year_runmonthlyATMConventions": "CF-1.4",
            "DECADALinitialized30_year_runmonthlyATMcontact": "cccma_info@ec.gc.ca",
            "DECADALinitialized30_year_runmonthlyATMcmor_version": "2.5.4",
            "DECADALinitialized30_year_runmonthlyATMphysics_version": "1",
            "DECADALinitialized30_year_runmonthlyATMparent_experiment_rip": "N/A",
            "DECADALinitialized30_year_runmonthlyATMproject_id": "CMIP5",
            "DECADALinitialized10_year_runmonthlyATMhistory": "2011-03-07T23:19:04Z CMOR rewrote data to comply with CF standards and CMIP5 requirements.",
            "DECADALinitialized10_year_runmonthlyATMexperiment": "10- or 30-year run initialized in year 1960",
            "DECADALinitialized10_year_runmonthlyATMCCCma_runid": "DHFP1B_E010_I1961_M01",
            "DECADALinitialized10_year_runmonthlyATMmodel_id": "CanCM4",
            "DECADALinitialized10_year_runmonthlyATMforcing": "GHG,Oz,SA,BC,OC,LU,Sl,Vl (GHG includes CO2,CH4,N2O,CFC11,effective CFC12)",
            "DECADALinitialized10_year_runmonthlyATMtable_id": "Table Amon (31 January 2011) 53b766a395ac41696af40aab76a49ae5",
            "DECADALinitialized10_year_runmonthlyATMinstitution": "CCCma (Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada)",
            "DECADALinitialized10_year_runmonthlyATMsource": "CanCM4 2010 atmosphere: CanAM4 (AGCM15i, T63L35) ocean: CanOM4 (OGCM4.0, 256x192L40) sea ice: CanSIM1 (Cavitating Fluid, T63 Gaussian Grid) land: CLASS2.7",
            "DECADALinitialized10_year_runmonthlyATMmodeling_realm": "atmos",
            "DECADALinitialized10_year_runmonthlyATMexperiment_id": "decadal1960",
            "DECADALinitialized10_year_runmonthlyATMcreation_date": "2011-03-07T23:19:04Z",
            "DECADALinitialized10_year_runmonthlyATMinstitute_id": "CCCma",
            "DECADALinitialized10_year_runmonthlyATMtitle": "CanCM4 model output prepared for CMIP5 10- or 30-year run initialized in year 1960",
            "DECADALinitialized10_year_runmonthlyATMConventions": "CF-1.4",
            "DECADALinitialized10_year_runmonthlyATMcontact": "cccma_info@ec.gc.ca",
            "DECADALinitialized10_year_runmonthlyATMcmor_version": "2.5.4",
            "DECADALinitialized10_year_runmonthlyATMphysics_version": "1",
            "DECADALinitialized10_year_runmonthlyATMparent_experiment_rip": "N/A",
            "DECADALinitialized10_year_runmonthlyATMproject_id": "CMIP5",
            "DECADALdescription": "CanCM4 model output",
            "DECADALsource": "http://www.ec.gc.ca/ccmac-cccma/default.asp?lang=En&n=8A6F8F67-1",
            "DECADALreferences": "Arora_VK_etal_2011 Merryfield_WJ_etal2011",
            "description": "The Canadian Centre for Climate Modelling and Analysis",
            "Conventions": "IRIDL"
        },
        "DECADAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DECADAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "uninitialized": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uninitialized",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "_year_run": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "55_year_run",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ATM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ATM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "long_name": "Near-Surface Air Temperature",
                                    "units": "Kelvin_scale",
                                    "standard_name": "air_temperature",
                                    "pointwidth": "1.0"
                                },
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "standard_name": "precipitation_flux",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    }
                }
            },
            "initialized": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "initialized",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "_year_run": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "10_year_run",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ATM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ATM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1"
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "institution": "Canadian Centre for Climate Modelling and Analysis, Victoria, BC, Canada",
                                    "long_name": "Near-Surface Air Temperature",
                                    "units": "Kelvin_scale",
                                    "standard_name": "air_temperature",
                                    "pointwidth": "0"
                                },
                                "pr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "long_name": "Precipitation",
                                    "units": "kg m-2 s-1",
                                    "standard_name": "precipitation_flux",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                }
            }
        },
        "L_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_period",
            "long_name": "Lead time",
            "pointwidth": "1"
        },
        "S_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "pointwidth": "0"
        },
        "L_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_period",
            "long_name": "Lead time",
            "pointwidth": "1"
        },
        "S_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "pointwidth": "0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "long_name": "Lead time",
            "calendar": "360",
            "standard_name": "forecast_period",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.8125"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "long_name": "Member",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "pointwidth": "0"
        },
        "dir": "SOURCES/CCCma"
    },
    "CCROM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CCROM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Centre for Climate Risk and Opportunity Management in Southeast Asia Pacific",
            "Conventions": "IRIDL"
        },
        "Lao": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Lao",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "stations": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stations",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ncolor": "254",
                    "colorscalename": "temp_colors",
                    "maxncolor": "254",
                    "colormap": "255",
                    "long_name": "Minimum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0"
                },
                "Tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ncolor": "254",
                    "colorscalename": "temp_colors",
                    "maxncolor": "254",
                    "colormap": "255",
                    "long_name": "Maximum Temperature",
                    "units": "Celsius_scale",
                    "missing_value": "NaN",
                    "fnname": "maskle",
                    "file_missing_value": "-999.0"
                },
                "Rainfall": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Rainfall",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "CS": "0",
                    "maxncolor": "254",
                    "colorscalename": "precip_colors",
                    "colormap": "290304",
                    "ncolor": "254",
                    "long_name": "Total Rainfall",
                    "units": "mm",
                    "missing_value": "-999.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "108.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "100.0"
                },
                "location": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "location",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "OpenGISSimpleFeature": "Point",
                    "long_name": "location",
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "108.0",
                    "units": "degree_east",
                    "scale_min": "100.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "23.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "13.5"
                },
                "label": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "label",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "label"
                }
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "scale_min": "2444239.5",
            "scale_max": "2455562.5",
            "units": "julian_day",
            "add_offset": "2444239.5",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Station": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Station",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "dir": "SOURCES/CCROM"
    },
    "CDIAC": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CDIAC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "USHCNdailyUSHCN": "http://cdiac.ornl.gov/epubs/ndp/ushcn/daily_doc.html",
            "USHCNdailycitation": "M. J. Menne, C. N. Williams, Jr., and R. S. Vose, 2015. United States Historical Climatology Network Daily Temperature, Precipitation, and Snow Data. Carbon Dioxide Information Analysis Center, Oak Ridge National Laboratory, Oak Ridge, Tennessee",
            "USHCNdailyreferences": "Easterling_etal1996 Hughes_etal1992 Karl_etal1990 Quinlan_etal1987 Williams_etal2004",
            "USHCNdescription": "United States Historical Climatology Network",
            "tr051references": "Eischeid_etal1991",
            "tr051description": "Comprehensive preciptation anomaly data set for global land areas",
            "tr051dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CDIAC/.tr051.dataset_documentation.html",
            "ndp043adescription": "Coastal hazards data base for United States East Coast",
            "ndp043airidlhasSemantics": "iriref:White_TW",
            "ndb017references": "Olson_etal1983",
            "ndb017description": "Major world ecosystem complexes ranked by carbon in live vegetation",
            "ndb017source": ">Olson Vegetation Complexes</a>",
            "ndb017dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CDIAC/.ndb017.dataset_documentation.html",
            "ndb017long_name": "MAJOR WORLD ECOSYSTEM COMPLEXES RANKED BY CARBON IN LIVE VEGETATION",
            "msudescription": "MSU-measured precipitation from CDIAC",
            "description": "Carbon Dioxide Information Analysis Center",
            "iridlhasSemantics": "CDIAC",
            "Conventions": "IRIDL"
        },
        "USHCN": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "USHCN",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Fahrenheit_scale",
                    "missing_value": "-99.0",
                    "standard_name": "air_temperature",
                    "long_name": "minimum temperature"
                },
                "tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Fahrenheit_scale",
                    "missing_value": "-99.0",
                    "standard_name": "air_temperature",
                    "long_name": "maximum temperature"
                },
                "state": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "state",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "state abbreviation",
                    "units": "ids"
                },
                "snowfall": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "snowfall",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "inches/day",
                    "missing_value": "-99.900002",
                    "standard_name": "thickness_of_snowfall_amount"
                },
                "snow_depth": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "snow_depth",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "inches",
                    "missing_value": "-99.0",
                    "standard_name": "thickness_of_snowfall_amount"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "inches/day",
                    "missing_value": "-99.989998",
                    "standard_name": "lwe_precipitation_rate",
                    "long_name": "precipitation"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-132.0",
                    "scale_max": "-60.0",
                    "units": "degree_east",
                    "long_name": "longitude"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "20.0",
                    "scale_max": "52.0",
                    "units": "degree_north",
                    "long_name": "latitude"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "elevation",
                    "units": "m"
                },
                "comp3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "comp3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Coop ID for third station used to create time series",
                    "units": "ids"
                },
                "comp2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "comp2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Coop ID for second station used to create time series",
                    "units": "ids"
                },
                "comp1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "comp1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Coop ID for first station used to create time series",
                    "units": "ids"
                }
            }
        },
        "tr051": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tr051",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "precipitation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "precipitation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "anomalies": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "anomalies",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mm",
                    "missing_value": "-9999.9902"
                }
            }
        },
        "ndp043a": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ndp043a",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "WHSD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WHSD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "standard deviation of the 20-year mean wave height",
                "units": "m"
            },
            "WHMAX": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WHMAX",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "maximum significant wave height",
                "units": "m"
            },
            "WHAVG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WHAVG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "20-year mean wave height",
                "units": "m"
            },
            "TRNUM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TRNUM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of tide gauge stations used in tide calculations",
                "units": "unitless"
            },
            "TRMAX": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TRMAX",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "maximum tide range",
                "units": "m"
            },
            "TRLVL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TRLVL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "mean tide level",
                "units": "m"
            },
            "TRAVG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TRAVG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "mean tide range",
                "units": "m"
            },
            "SLYR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SLYR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "years of record used in sea level trend",
                "units": "unitless"
            },
            "SLS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SLS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "local subsidence trend",
                "units": "mm/year"
            },
            "SLR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SLR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "relative sea level trend",
                "units": "mm/year"
            },
            "SLG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SLG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "long-term geologic-trend  derived from 14C data",
                "units": "mm/year"
            },
            "SLC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SLC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "corrected sea level trend",
                "units": "mm/year"
            },
            "GM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.0",
                "long_name": "landform inundation-and-erosion susceptibility index",
                "units": "unitless"
            },
            "GL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.0",
                "long_name": "rock erosion resistance index",
                "units": "unitless"
            },
            "ERNUM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERNUM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of 3\\', 7.5\\', or 15\\' grid cells used in calculating erosion",
                "units": "unitless"
            },
            "ERMIN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERMIN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "minimum long-term erosion trend",
                "units": "m"
            },
            "ERMAX": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERMAX",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "maximum long-term erosion trend",
                "units": "m"
            },
            "ERAVG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ERAVG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "mean long-term erosion trend",
                "units": "m"
            },
            "ELNUM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ELNUM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "number of cells used in elevation",
                "units": "unitless"
            },
            "ELMIN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ELMIN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "minimum non-negative elevation",
                "units": "m"
            },
            "ELMAX": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ELMAX",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "maximum non-negative elevation",
                "units": "m"
            },
            "ELAVG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ELAVG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "9999.9902",
                "long_name": "mean non-negative elevation",
                "units": "m"
            }
        },
        "ndb017": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ndb017",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "_class": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "class",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "long_name": "land ecosystem class"
            }
        },
        "msu": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "msu",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "precipitation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "precipitation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-99.900002",
                "units": "mm",
                "long_name": "precipitation"
            }
        },
        "STNID_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "STNID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "5.0"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "4.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "3.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.25"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.25"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.5"
        },
        "dir": "SOURCES/CDIAC"
    },
    "CEREGE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CEREGE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Indonesia_station_preciptitle": "Indonesia Station Rainfall Observations",
            "Indonesia_station_precipDescription": "Compilation of station rainfall data over Indonesia 1961--2010 , from Hamada and GSOD (NCDC and CPC).Compiled by V. Moron (moron@cerege.fr).",
            "Conventions": "IRIDL"
        },
        "Indonesia_station_precip": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Indonesia_station_precip",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "prec": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "prec",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "units": "mm",
                "long_name": "precipitation_amount"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "units": "degree_east",
                "long_name": "longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "units": "degree_north",
                "long_name": "latitude"
            },
            "elev": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "elev",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-999.0",
                "units": "m",
                "long_name": "elevation"
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1973-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "long_name": "time",
            "pointwidth": "1.0"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/CEREGE"
    },
    "CHRIS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CHRIS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SMIhistory": "Christine wind stress calculated from Christine pseudo stress and Cd from Smith",
            "LPhistory": "Christine wind stress calculated from Christine pseudo stress and Cd from Large & Pond",
            "LIUhistory": "Christine wind stress calculated from Christine pseudo stress and Cd from Liu",
            "IHAShistory": "Christine wind stress calculated from Christine pseudo stress and Cd from Isemer & Hasse",
            "CLIMOhistory": "a wind field calculated from a Servain wind field with EOF analysis factored in.",
            "CARDhistory": "Christine wind stress calculated from Christine pseudo stress and Cd from Cardone",
            "YRRMhistory": "a wind field calculated from a Servain wind field with EOF analysis factored in.",
            "YRHhistory": "a wind field calculated from a Servain wind field with EOF analysis factored in.  Hellerman75 mean and 4yr detrend.",
            "description": "Wind stress calculated from EOF-filtered Servain stress and various drag formulations for the tropical Atlantic",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CHRIS/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:LDEO",
            "Conventions": "IRIDL"
        },
        "SMI": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SMI",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Smith",
                "missing_value": "9998.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Smith",
                "missing_value": "9998.0"
            }
        },
        "LP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "LP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Large & Pond",
                "missing_value": "9998.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Large & Pond",
                "missing_value": "9998.0"
            }
        },
        "LIU": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "LIU",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Liu",
                "missing_value": "9998.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Liu",
                "missing_value": "9998.0"
            }
        },
        "IHAS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "IHAS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Isemer & Hasse",
                "missing_value": "9998.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Isemer & Hasse",
                "missing_value": "9998.0"
            }
        },
        "CLIMO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CLIMO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "absuv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in."
            },
            "absuu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in."
            }
        },
        "CARD": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CARD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Cardone",
                "missing_value": "9998.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "history": "Christine wind stress calculated from Christine pseudo stress and Cd from Cardone",
                "missing_value": "9998.0"
            }
        },
        "YRRM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "4YRRM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "absuv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in."
            },
            "absuu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in."
            }
        },
        "YRH": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "4YRH",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "absuv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in.  Hellerman75 mean and 4yr detrend."
            },
            "absuu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal pseudostress",
                "units": "m2/s2",
                "history": "a wind field calculated from a Servain wind field with EOF analysis factored in.  Hellerman75 mean and 4yr detrend."
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "dir": "SOURCES/CHRIS"
    },
    "CIAT": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/CIAT",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "CIAT",
        "restriction": "Public",
        "CSI": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/CIAT/CSI",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "CSI",
            "restriction": "Public",
            "SRTM": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/CIAT/CSI/SRTM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "SRTM",
                "restriction": "Public",
                "version4p1": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/CIAT/CSI/SRTM/version4p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "version4p1",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "version4p1"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "SRTM"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "CSI"
        ]
    },
    "CIESIN": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/CIESIN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "CIESIN",
        "restriction": "Public",
        "GPWv2": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/CIESIN/GPWv2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "GPWv2",
            "restriction": "requires dlauth tokens"
        },
        "GPWv3": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/CIESIN/GPWv3",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "GPWv3",
            "restriction": "requires dlauth tokens"
        },
        "Poverty": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Poverty",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "globalbetagrid0p25deginfantmortalitydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CIESIN/.Poverty/.global.beta.grid0p25deg.infantmortality.dataset_documentation.html",
                "globalbetagrid0p25deginfantmortalitylong_name": "Infant Mortality Rates",
                "globalbetagrid0p25deghungerdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CIESIN/.Poverty/.global.beta.grid0p25deg.hunger.dataset_documentation.html",
                "globalbetagrid0p25deghungerlong_name": "Prevalence of Child Malnutrition",
                "globalbetagrid0p25degancillarylong_name": "Ancillary Grid Data",
                "globalbetagrid0p25degdescription": "Global Distribution of Poverty, beta version, from the Socioeconomic Data and Applications Center (SEDAC) at CIESIN, gridded at 0.25 degree resolution",
                "globalbetagrid0p25degdata": "http://sedac.ciesin.org/povmap/ds_global.jsp",
                "globalbetagrid0p25degGlobal": "http://sedac.ciesin.org/povmap/",
                "description": "Global Distribution of Poverty",
                "Conventions": "IRIDL",
                "Global": "http://sedac.ciesin.org/povmap/"
            },
            "_global": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "global",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "beta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "beta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "grid0p25deg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grid0p25deg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "infantmortality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "infantmortality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "imr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "imr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Infant deaths per 10,000 live births",
                                "missing_value": "-9999.0",
                                "long_name": "Infant mortality rates, year 2000"
                            },
                            "deaths": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "deaths",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons",
                                "missing_value": "-9999.0",
                                "long_name": "Infant Deaths, year 2000"
                            },
                            "births": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "births",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons",
                                "missing_value": "-9999.0",
                                "long_name": "Births, year 2000"
                            }
                        },
                        "hunger": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hunger",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "uwu5pop": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uwu5pop",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons",
                                "missing_value": "-9999.0",
                                "long_name": "Estimate of children, under the age of 5, who are underweight, year 2000"
                            },
                            "uw": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uw",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.90002",
                                "units": "percent",
                                "long_name": "Percent of children, under the age of 5, who are underweight (year period: 1990-2002)"
                            },
                            "u5pop": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u5pop",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons",
                                "missing_value": "-9999.0",
                                "long_name": "Count of children under age 5, year 2000"
                            }
                        },
                        "ancillary": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ancillary",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "sequence": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sequence",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "missing_value": "-9999.0",
                                "long_name": "Unique grid cell identifier, counting from NW to SE by rows"
                            },
                            "popdens": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "popdens",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons/km2",
                                "missing_value": "-9999.0",
                                "long_name": "Population density, year 2000"
                            },
                            "pop2000": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pop2000",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Number of Persons",
                                "missing_value": "-9999.0",
                                "long_name": "Population count, year 2000"
                            },
                            "longitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "longitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "missing_value": "-9999.0",
                                "long_name": "Longitude of the center point of a grid cell"
                            },
                            "latitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "latitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "missing_value": "-9999.0",
                                "long_name": "Latitude of the center point of a grid cell"
                            },
                            "landarea": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "landarea",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "km2",
                                "missing_value": "-9999.0",
                                "long_name": "Land area from GPWv3"
                            },
                            "cntry4q": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cntry4q",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "missing_value": "-9999.0",
                                "long_name": "The country with the fourth-most land area within a given grid cell"
                            },
                            "cntry3q": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cntry3q",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "missing_value": "-9999.0",
                                "long_name": "The country with the third-most land area within a given grid cell"
                            },
                            "cntry2q": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cntry2q",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "missing_value": "-9999.0",
                                "long_name": "The country with the second-most land area within a given grid cell"
                            },
                            "cntry1q": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "cntry1q",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "missing_value": "-9999.0",
                                "long_name": "The country with the most land area within a given grid cell"
                            }
                        }
                    }
                }
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "0.25"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "0.25"
            },
            "dir": "SOURCES/CIESIN/Poverty"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "GPWv2",
            "GPWv3",
            "Poverty"
        ]
    },
    "CIMH": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/CIMH",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "CIMH",
        "restriction": "requires dlauth tokens"
    },
    "CLARIS_LPB": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CLARIS_LPB",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SESATencer_tempreferences": ">Tencer, B\\xc3\\xa1rbara, Matilde Rusticucci, Phil Jones, David Lister, 2011: A Southeastern South American Daily Gridded Dataset of Observed Surface Minimum and Maximum Temperature for 1961\\xe2\\x80\\x932000. Bull. Amer. Meteor. Soc., 92, 1339\\xe2\\x80\\x931346.doi</a>",
            "SESAdescription": "South-East South America",
            "description": "CLARIS La Plata Basin",
            "Conventions": "IRIDL",
            "CLARISLPB": "http://www.claris-eu.org/"
        },
        "SESA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SESA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Tencer_temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tencer_temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tx": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tx",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "400",
                    "ncolor": "254",
                    "scale_min": "-400",
                    "CS": "-40",
                    "colorscalename": "temp_colors",
                    "CE": "40",
                    "maxncolor": "254",
                    "colormap": "255",
                    "scale_factor": "0.1",
                    "missing_value": "-9999",
                    "long_name": "maximum temperature",
                    "units": "Celsius_scale"
                },
                "tn": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tn",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "400",
                    "ncolor": "254",
                    "scale_min": "-400",
                    "CS": "-40",
                    "colorscalename": "temp_colors",
                    "CE": "40",
                    "maxncolor": "254",
                    "colormap": "255",
                    "scale_factor": "0.1",
                    "missing_value": "-9999",
                    "long_name": "minimum temperature",
                    "units": "Celsius_scale"
                }
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "long_name": "Latitude",
            "pointwidth": "0.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1961-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "long_name": "Longitude",
            "pointwidth": "0.5"
        },
        "dir": "SOURCES/CLARIS_LPB"
    },
    "CLIMAP": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CLIMAP",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MODdescription": "Modern soil and vegetation characteristics from the World Data Center for Paleoclimatology",
            "MODlong_name": "Modern",
            "LGMdescription": "Last glacial maximum (18 KBP) soil and vegetation characteristics from the World Data Center for Paleoclimatology",
            "LGMlong_name": "Last Glacial Maximum",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CLIMAP/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL",
            "references": "CLIMAP1984",
            "description": "Modern and last glacial maximum (18 KBP) comparison of soil and vegetation characteristics from the World Data Center for Paleoclimatology"
        },
        "MOD": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "MOD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "water": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "water",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "vegetative": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetative",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "vegetation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "scale_min": "11.0",
                "missing_value": "0.0",
                "scale_max": "91.0",
                "long_name": "vegetation type",
                "CLIST": "arctic"
            },
            "topo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "topo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "long_name": "elevation"
            },
            "soil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "soil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "ncolor": "52",
                "missing_value": "0.0",
                "scale_max": "59.0",
                "colormap": "16777215",
                "long_name": "soil type",
                "CLIST": "bright white unclassified",
                "scale_min": "11.0"
            },
            "relief": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "relief",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "ncolor": "57",
                "missing_value": "0.0",
                "scale_max": "64.0",
                "colormap": "16711680",
                "long_name": "relief type",
                "CLIST": "mountainous random orientation, unclassified",
                "scale_min": "11.0"
            },
            "glacial_ice": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "glacial_ice",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "feb": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "feb",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "missing_value": "55.5",
                    "long_name": "sea surface temperature"
                }
            },
            "exposed_soil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "exposed_soil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "aug": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "aug",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "missing_value": "55.5",
                    "long_name": "sea surface temperature"
                }
            }
        },
        "LGM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "LGM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "water": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "water",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "vegetative": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetative",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "vegetation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "scale_min": "11.0",
                "missing_value": "0.0",
                "scale_max": "93.0",
                "long_name": "vegetation type",
                "CLIST": "arctic"
            },
            "topo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "topo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "long_name": "elevation"
            },
            "soil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "soil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "scale_max": "59.0",
                "ncolor": "52",
                "scale_min": "11.0",
                "CS": "11.0",
                "colorscalename": "custom",
                "CE": "59.0",
                "maxncolor": "52",
                "colormap": "16777215",
                "CLIST": "bright white unclassified",
                "long_name": "soil type"
            },
            "relief": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "relief",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "maxncolor": "57",
                "colormap": "16711680",
                "scale_max": "64.0",
                "ncolor": "57",
                "scale_min": "11.0",
                "CE": "64.0",
                "CS": "11.0",
                "missing_value": "0.0",
                "CLIST": "mountainous random orientation, unclassified",
                "long_name": "relief type"
            },
            "glacial_ice": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "glacial_ice",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "feb": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "feb",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "missing_value": "55.5",
                    "long_name": "sea surface temperature"
                }
            },
            "exposed_soil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "exposed_soil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "percent": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percent",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "long_name": "percentage of grid cell"
                }
            },
            "aug": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "aug",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "missing_value": "55.5",
                    "long_name": "sea surface temperature"
                }
            }
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "dir": "SOURCES/CLIMAP"
    },
    "CMA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CMA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "BCCRegCM3_NCPdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CMA/.BCC.RegCM3_NCP.dataset_documentation.html",
            "BCCRegCM3_NCPlong_name": "RegCM with 0.1126deg grids over North China Plain",
            "BCCRegCM3_NCPreferences": "Giorgi_F_etal1993a Giorgi_F_etal1993b",
            "BCCGODASreferences": "Liu_etal2005a Liu_etal2005b",
            "BCCGODASdescription": "global ocean data assimilation operational system",
            "BCCGODASdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CMA/.BCC.GODAS.dataset_documentation.html",
            "BCCGODASiridlhasSemantics": "iridl:Ocean",
            "BCCCGCMMONTHLYSurfacecomment": "IMPORTANT:  It was discovered in December 2020 that the latitude coordinate was erroneously reversed in the Precipitation_Total, U, and V variables in this dataset.  This error has been corrected as of 07 January 2021.",
            "BCCCGCMMONTHLYPressureLevelcomment": "IMPORTANT:  It was discovered in December 2020 that the latitude coordinate was erroneously reversed in the Precipitation_Total, U, and V variables in this dataset.  This error has been corrected as of 07 January 2021.",
            "BCCCGCMMONTHLYcomment": "IMPORTANT:  It was discovered in December 2020 that the latitude coordinate was erroneously reversed in the Precipitation_Total, U, and V variables in this dataset.  This error has been corrected as of 07 January 2021.",
            "BCCdescription": "Beijing Climate Center",
            "BCCHome": "http://ncc.cma.gov.cn/bcc/main.htm",
            "BCCiridlhasSemantics": "iridl:BCC",
            "description": "China Meteorological Administration",
            "iridlhasSemantics": "iridl:CMA",
            "Conventions": "IRIDL",
            "home": "http://www.cma.gov.cn/ywwz/"
        },
        "station": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "station",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WSPD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WSPD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "m/s",
                    "long_name": "Wind_Speed"
                },
                "TMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "Celsius_scale",
                    "long_name": "Minimum_Temperature"
                },
                "TMEAN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMEAN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "Celsius_scale",
                    "long_name": "Mean_Temperature"
                },
                "TMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "Celsius_scale",
                    "long_name": "Maximum_Temperature"
                },
                "SUN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SUN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "hours/day",
                    "long_name": "Sunlight_Duration"
                },
                "RH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "percent",
                    "long_name": "Relative_Humidity"
                },
                "Province": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Province",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "PRCP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PRCP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.90002",
                    "units": "mm/day",
                    "long_name": "Precipitation"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "110.0",
                    "missing_value": "-999.0",
                    "scale_max": "123.0",
                    "units": "degree_east",
                    "long_name": "longitude"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "30.0",
                    "missing_value": "-999.0",
                    "scale_max": "42.0",
                    "units": "degree_north",
                    "long_name": "latitude"
                },
                "altitude": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "altitude",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "m"
                }
            }
        },
        "BCC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "BCC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RegCM3_NCP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RegCM3_NCP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Surface": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Surface",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "t2min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t2min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Min air temperature at 2 meters AGL",
                        "units": "Kelvin_scale",
                        "cNZ": "0",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    },
                    "t2max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "t2max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Max air temperature at 2 meters AGL",
                        "units": "Kelvin_scale",
                        "cNZ": "0",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    },
                    "swi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "swi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Solar incident",
                        "units": "W/m2",
                        "cNZ": "0",
                        "missing_value": "-1.00000002E30",
                        "pointwidth": "0.0"
                    },
                    "slp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "slp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sea level pressure",
                        "units": "mb",
                        "cNZ": "0",
                        "missing_value": "-1.00000002E30",
                        "pointwidth": "0.0"
                    },
                    "rt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Total precipitation",
                        "units": "mm",
                        "cNZ": "0",
                        "missing_value": "-1.00000002E30",
                        "pointwidth": "0.0"
                    }
                },
                "PressureLevel": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PressureLevel",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "V wind",
                        "units": "m/s",
                        "cNZ": "1",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    },
                    "u": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "U wind",
                        "units": "m/s",
                        "cNZ": "1",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    },
                    "q": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "q",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "specific humidity",
                        "units": "g/kg",
                        "cNZ": "1",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    },
                    "gz": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gz",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "geopotential geight",
                        "units": "gm",
                        "cNZ": "1",
                        "missing_value": "-9.99999979E33",
                        "pointwidth": "0.0"
                    }
                }
            },
            "GODAS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GODAS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "missing_value": "9999.0",
                    "pointwidth": "1.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m/s",
                    "missing_value": "9999.0",
                    "pointwidth": "1.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "missing_value": "9999.0",
                    "pointwidth": "1.0"
                },
                "sal": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridlhasSemantics": "iridl:Salinity",
                    "units": "1e-3 PSU above 35",
                    "missing_value": "9999.0",
                    "pointwidth": "1.0"
                }
            },
            "CGCM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CGCM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MONTHLY": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MONTHLY",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Precipitation_Total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Precipitation_Total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Surface Total Precipitation",
                            "units": "mm",
                            "cNZ": "48"
                        }
                    },
                    "PressureLevel": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PressureLevel",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "V",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "V-wind",
                            "units": "m/s",
                            "cNZ": "48"
                        },
                        "U": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "U",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "U-wind",
                            "units": "m/s",
                            "cNZ": "48"
                        }
                    }
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "STNID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "P_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "650.0"
        },
        "P_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "P_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.1126"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.1126"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "365",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "calendar": "standard",
            "pointwidth": "1.875"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "calendar": "standard",
            "pointwidth": "1.875"
        },
        "Z_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.875"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.875"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.875"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "long_name": "Ensemble member",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.5"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "long_name": "Lead time",
            "standard_time": "forecast_period",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.5"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "long_name": "Start time",
            "calendar": "360",
            "pointwidth": "0"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "gridtype": "0",
            "pointwidth": "650.0"
        },
        "dir": "SOURCES/CMA"
    },
    "CNES": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CNES",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SPOTiridlhasSemantics": "iridl:SPOT",
            "SPOTabout": "http://www.auslig.gov.au/acres/prod_ser/spotdata.htm",
            "SPOTspot": "http://www.spotimage.fr/home/",
            "description": "Centre National d\\'Etudes Spatiale",
            "iridlhasSemantics": "iridl:CNES",
            "Conventions": "IRIDL"
        },
        "SPOT": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SPOT",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "vegetation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "westasia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "west-asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "southeastasia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "southeast-asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "southamerica": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "south-america",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "northasia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "north-asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "northamerica": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "north-america",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "europe": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "europe",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "colombia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "colombia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI",
                        "units": "unitless",
                        "add_offset": "-0.1"
                    }
                },
                "centralamerica": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "central-america",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "australiaasia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "australia-asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "asianislands": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "asian-islands",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI"
                    }
                },
                "africa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "africa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "NDVIcolorscale",
                        "colormap": "16777215",
                        "scale_max": "229.09999",
                        "ncolor": "254",
                        "scale_min": "-24.9",
                        "CE": "0.916",
                        "CS": "-0.1",
                        "missing_value": "255",
                        "units": "unitless",
                        "long_name": "Normalized Difference Vegetation Index",
                        "add_offset": "-0.1",
                        "scale_factor": "0.004",
                        "iridlhasSemantics": "iridl:NDVI",
                        "calendar": "standard"
                    }
                }
            }
        },
        "Y_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.00867347"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.008928572"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "0",
            "calendar": "standard",
            "add_offset": "-3653.0",
            "units": "days since 1970-01-01"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.008928572"
        },
        "dir": "SOURCES/CNES"
    },
    "COADS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "COADS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ylatdescription": "Average latitude for gridbox",
            "xlondescription": "Average longitude for gridbox",
            "stdevdescription": "Monthly average standard deviation of data for gridbox",
            "nobsdescription": "Number of observations for gridbox",
            "meandescription": "Monthly average data for gridbox",
            "description": "Comprehensive Ocean-Atmosphere Data Set: Trimmed monthly summaries",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.COADS/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NCAR",
            "Conventions": "IRIDL",
            "references": "Slutz_etal1985"
        },
        "ylat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ylat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_north",
                "precision": "0.2"
            }
        },
        "xlon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "xlon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_east",
                "precision": "0.2"
            }
        },
        "stdev": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "stdev",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "wind speed",
                "precision": "0.01"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "meridional wind",
                "precision": "0.01"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "zonal wind",
                "precision": "0.01"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_Celsius",
                "long_name": "air temperature",
                "precision": "0.01"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "degree_Celsius",
                "long_name": "sea surface temperature",
                "precision": "0.01"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "mb",
                "long_name": "sea level pressure",
                "precision": "0.01"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "g/kg",
                "long_name": "specific humidity",
                "precision": "0.01"
            }
        },
        "nobs": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "nobs",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "unitless",
                "precision": "1"
            }
        },
        "mean": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "mean",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "wind speed",
                "precision": "0.01"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "meridional wind",
                "precision": "0.01"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "m/s",
                "long_name": "zonal wind",
                "precision": "0.01"
            },
            "tair": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tair",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "Celsius_scale",
                "long_name": "air temperature",
                "precision": "0.01"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "Celsius_scale",
                "long_name": "sea surface temperature",
                "precision": "0.01"
            },
            "slp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "mb",
                "long_name": "sea level pressure",
                "precision": "0.01"
            },
            "shum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "shum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "NaN",
                "units": "g/kg",
                "long_name": "specific humidity",
                "precision": "0.01"
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.0",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/COADS"
    },
    "COLA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "COLA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Decadal_HindcastsCFSv2iridlhasSemantics": "iriref:Schneider_EK",
            "Conventions": "IRIDL"
        },
        "Decadal_Hindcasts": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Decadal_Hindcasts",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CFSv2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CFSv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PGBF": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PGBF",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "standard_name": "time"
                    },
                    "pressure_level": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_level",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "HGT": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "HGT",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geopotential Height",
                            "units": "gpm",
                            "standard_name": "geopotential_height",
                            "cNZ": "1",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "OCNH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "OCNH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "standard_name": "time"
                    },
                    "surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "TMP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TMP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "sea surface temperature",
                            "cNZ": "0",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "FLXF": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FLXF",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "pointwidth": "1.0",
                        "long_name": "Forecast Time",
                        "units": "months since 1960-01-01",
                        "standard_name": "time"
                    },
                    "surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PRATE": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PRATE",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Precipitation Rate",
                            "units": "kg m-2 s-1",
                            "standard_name": "precipitation flux",
                            "cNZ": "0",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        }
                    },
                    "m_above_ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "2m_above_ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "TMP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "TMP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Temperature",
                            "units": "Kelvin_scale",
                            "standard_name": "air_temperature",
                            "cNZ": "0",
                            "gribfield": "1",
                            "missing_value": "9.99900026E20",
                            "pointwidth": "0.0"
                        }
                    }
                }
            }
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "gridtype": "0",
            "standard_name": "air_pressure",
            "long_name": "Pressure level",
            "pointwidth": "0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "standard_name": "forecast_period",
            "pointwidth": "1"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.9375"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "pointwidth": "0.0"
        },
        "dir": "SOURCES/COLA"
    },
    "CORAL": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CORAL",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Seychellesdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CORAL/.Seychelles.dataset_documentation.html",
            "description": "Isotope d18O data from coral colonies",
            "Conventions": "IRIDL"
        },
        "Tarawa": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Tarawa",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "Seychelles": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Seychelles",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "dir": "SOURCES/CORAL"
    },
    "Chile": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "Chile",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "DGAmeteorologicalregionIVstationdailydescription": "Daily Precipitation of the Coquimbo Region",
            "DGAhydrologicalregionIVstationmonthlydescription": "Monthly Streamflow for the Elqui River Basin",
            "DGAhydrologicalregionIVstationdailydescription": "Daily Streamflow for Region IV",
            "DGAdescription": "Direcci&#243;n General de Aguas",
            "DGAiridlhasSemantics": "iridl:DGA_Chile",
            "DGAlong_name": "Direcci&#243;n General de Aguas",
            "DGADGA": "http://www.dga.cl/",
            "Conventions": "IRIDL"
        },
        "DGA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DGA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "meteorological": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "meteorological",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "regionIV": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "regionIV",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "station": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "station",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "UTM_North": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UTM_North",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meters"
                            },
                            "UTM_East": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UTM_East",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meters"
                            },
                            "Suspension_Date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Suspension_Date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "Region": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Region",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "PRCP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PRCP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "mm/day",
                                "long_name": "Precipitation",
                                "standard_name": "lwe_precipitation_rate"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-71.5",
                                "missing_value": "-999.0",
                                "scale_max": "-69.800003",
                                "units": "degree_east",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-32.0",
                                "missing_value": "-999.0",
                                "scale_max": "-29.299999",
                                "units": "degree_north",
                                "long_name": "latitude"
                            },
                            "Installation_Date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Installation_Date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "Altitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Altitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "surface_altitude",
                                "units": "meters"
                            },
                            "Alt_ID": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Alt_ID",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            }
                        }
                    }
                }
            },
            "hydrological": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "hydrological",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "regionIV": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "regionIV",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "station": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "station",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "streamflow": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "streamflow",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3/s",
                                "missing_value": "-999.0",
                                "long_name": "streamflow"
                            },
                            "Region": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Region",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-71.5",
                                "missing_value": "-999.0",
                                "scale_max": "-69.800003",
                                "units": "degree_east",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-30.5",
                                "missing_value": "-999.0",
                                "scale_max": "-29.5",
                                "units": "degree_north",
                                "long_name": "latitude"
                            },
                            "Elevation": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Elevation",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meters"
                            },
                            "Alt_ID": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Alt_ID",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "UTM_North": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UTM_North",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meters"
                            },
                            "UTM_East": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UTM_East",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "meters"
                            },
                            "Suspension_Date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Suspension_Date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "STRFLOW": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "STRFLOW",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-99.900002",
                                "units": "m3/s",
                                "long_name": "Streamflow",
                                "standard_name": "surface_runoff_flux"
                            },
                            "Region": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Region",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "Name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-72.0",
                                "scale_max": "-70.0",
                                "units": "degree_east",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-32.5",
                                "scale_max": "-29.299999",
                                "units": "degree_north",
                                "long_name": "latitude"
                            },
                            "Installation_Date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Installation_Date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "altitude": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "altitude",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "meters"
                            }
                        }
                    }
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0",
            "long_name": "Time",
            "standard_name": "time"
        },
        "ID_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ID_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "ID_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ID_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "pointwidth": "1.0",
            "long_name": "Time",
            "standard_name": "time"
        },
        "ID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "dir": "SOURCES/Chile"
    },
    "CountrySTAT": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "CountrySTAT",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "PhilippinesSubnationalProductionFisheriesC40PNVFPdescription": "Fisheries: Volume of Production by Subsector, by Region and by Province, 1980-2012",
            "PhilippinesSubnationalProductionFisheriesC40PNVFPsource": "http://countrystat.psa.gov.ph/?cont=10&pageid=1&ma=C40PNVFP",
            "PhilippinesSubnationalProductionFisheriesC40PNVFPdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Philippines.Sub-national.Production.Fisheries.C40PNVFP.dataset_documentation.html",
            "PhilippinesSubnationalProductionCropsYieldAH_Catdescription": "Palay and Corn: Categories of Areas by Province and Quarter",
            "PhilippinesSubnationalProductionCropsYielddescription": "Palay and Corn: Yield anomalies estimate by Year, Period",
            "PhilippinesSubnationalProductionCropsYielddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Philippines.Sub-national.Production.Crops.Yield.dataset_documentation.html",
            "Philippineshome": "http://countrystat.psa.gov.ph/",
            "NigerSubnationalProductionLivestockPVdescription": "Distribution of Meat Production by Region, 2000-2010",
            "NigerSubnationalProductionLivestockPVsource": "http://countrystat.org/home.aspx?c=NER&ta=158SPD050&tr=21",
            "NigerSubnationalProductionLivestockPVdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Niger.Sub-national.Production.Livestock.PV.dataset_documentation.html",
            "NigerSubnationalProductionLivestockEAVsource": "http://countrystat.org/home.aspx?c=NER&ta=158SPD035&tr=21",
            "NigerSubnationalProductionLivestockEAVdescription": "Distribution of Live Animals by Region, 1970-2010",
            "NigerSubnationalProductionLivestockEAVdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Niger.Sub-national.Production.Livestock.EAV.dataset_documentation.html",
            "NigerSubnationalProductionCropsSRdescription": "Distribution of the Area Harvested by Region, 2000-2011",
            "NigerSubnationalProductionCropsSRsource": "http://countrystat.org/home.aspx?c=NER&ta=158SPD015&tr=21",
            "NigerSubnationalProductionCropsSRdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Niger.Sub-national.Production.Crops.SR.dataset_documentation.html",
            "NigerSubnationalProductionCropsPCPdescription": "Distribution of Main Crops Production by Region, 2000-2011",
            "NigerSubnationalProductionCropsPCPsource": "http://countrystat.org/home.aspx?c=NER&ta=158SPD010&tr=21",
            "NigerSubnationalProductionCropsPCPdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.CountrySTAT/.Niger.Sub-national.Production.Crops.PCP.dataset_documentation.html",
            "Conventions": "IRIDL"
        },
        "Philippines": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Philippines",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Subnational": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sub-national",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Production": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Production",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Fisheries": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Fisheries",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "C40PNVFP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "C40PNVFP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "VoP_MMF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_MMF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Marine Municipal Fisheries",
                                "units": "tons"
                            },
                            "VoP_IMF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_IMF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Inland Municipal Fisheries",
                                "units": "tons"
                            },
                            "VoP_CF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_CF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Commercial Fisheries",
                                "units": "tons"
                            },
                            "VoP_A": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_A",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Aquaculture",
                                "units": "tons"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provinces Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "regcode": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "regcode",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "provname": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "provname",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "PGtype": "text"
                            }
                        }
                    },
                    "Crops": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Crops",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Yield": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Yield",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Yano_YC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_YC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of Yellow Corn",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "Yano_WC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_WC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of White Corn",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "Yano_RP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_RP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of Rainfed Palay",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "Yano_P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of Palay",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "Yano_IP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_IP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of Irrigated Palay",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "Yano_C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Yano_C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "long_name": "Yield Anomalies estimate of Corn",
                                "missing_value": "NaN",
                                "units": "0.090718474 kilogram meter-2",
                                "history": "Averaged over T2[1987, 2015] minimum 0.0% data present",
                                "file_missing_value": "-9"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provinces Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "regcode": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "regcode",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "provname": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "provname",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "AH_Cat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_Cat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "regcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "regcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Region Code",
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "PGtype": "float8"
                                },
                                "provname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "AH_YC_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_YC_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for Yellow Corn",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                },
                                "AH_WC_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_WC_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for White Corn",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                },
                                "AH_RP_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_RP_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for Rainfed Palay",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                },
                                "AH_P_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_P_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for Palay",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                },
                                "AH_IP_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_IP_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for Irrigated Palay",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                },
                                "AH_C_Cat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AH_C_Cat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "5",
                                    "colormap": "16711680",
                                    "maxncolor": "254",
                                    "long_name": "Type of Variance of Area for Corn",
                                    "scale_min": "1",
                                    "missing_value": "0",
                                    "CLIST": "lowVar",
                                    "scale_max": "2",
                                    "units": "ids",
                                    "CE": "2",
                                    "CS": "1",
                                    "valid_min": "1",
                                    "valid_max": "2",
                                    "history": "dominant_class over flag[highVar, lowVar]",
                                    "colorscalename": "halfgreyscale",
                                    "fnname": "flaglt",
                                    "file_missing_value": "-9"
                                }
                            }
                        },
                        "O80LUAHC": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "O80LUAHC",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provinces Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "regcode": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "regcode",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "provname": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "provname",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "AH_YC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_YC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of Yellow Corn",
                                "units": "hectares"
                            },
                            "AH_WC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_WC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of White Corn",
                                "units": "hectares"
                            },
                            "AH_RP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_RP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of Rainfed Palay",
                                "units": "hectares"
                            },
                            "AH_P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of Palay",
                                "units": "hectares"
                            },
                            "AH_IP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_IP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of Irrigated Palay",
                                "units": "hectares"
                            },
                            "AH_C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AH_C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Area Harvested of Corn",
                                "units": "hectares"
                            }
                        },
                        "A10PNCVP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "A10PNCVP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "VoP_YC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_YC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Yellow Corn",
                                "units": "tons"
                            },
                            "VoP_WC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_WC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of White Corn",
                                "units": "tons"
                            },
                            "VoP_RP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_RP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Rainfed Palay",
                                "units": "tons"
                            },
                            "VoP_P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Palay",
                                "units": "tons"
                            },
                            "VoP_IP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_IP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Irrigated Palay",
                                "units": "tons"
                            },
                            "VoP_C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "VoP_C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "long_name": "Volume of Production of Corn",
                                "units": "tons"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provinces Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "regcode": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "regcode",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Region Code",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "provname": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "provname",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Province Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "PGtype": "text"
                            }
                        }
                    }
                }
            }
        },
        "Niger": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Niger",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Subnational": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sub-national",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Production": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Production",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Livestock": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Livestock",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PV": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PV",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin1 geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "RPV_O": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPV_O",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Meat Production - Sheep"
                            },
                            "RPV_CP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPV_CP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Meat Production - Goats"
                            },
                            "RPV_CM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPV_CM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Meat Production - Camelids"
                            },
                            "RPV_B": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPV_B",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Meat Production - Cattle"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "adm1_name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "adm1_code": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_code",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 id",
                                "units": "unitless",
                                "PGtype": "int4"
                            }
                        },
                        "EAV": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EAV",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin1 geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "REAV_O": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_O",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Sheep"
                            },
                            "REAV_E": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_E",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Horses"
                            },
                            "REAV_CP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_CP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Goats"
                            },
                            "REAV_CM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_CM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Camelids"
                            },
                            "REAV_B": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_B",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Cattle"
                            },
                            "REAV_A": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "REAV_A",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Live Animals - Donkeys"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "adm1_name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "adm1_code": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_code",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 id",
                                "units": "unitless",
                                "PGtype": "int4"
                            }
                        }
                    },
                    "Crops": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Crops",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin1 geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "RSR_S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSR_S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Area Harvested - Sorghum"
                            },
                            "RSR_N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSR_N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Area Harvested - Cowpea"
                            },
                            "RSR_M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSR_M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Area Harvested - Millet"
                            },
                            "RSR_A": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSR_A",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Area Harvested - Groundnuts"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "adm1_name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "adm1_code": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_code",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 id",
                                "units": "unitless",
                                "PGtype": "int4"
                            }
                        },
                        "PCP": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PCP",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin1 geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "RPCP_S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPCP_S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Main Crops Production - Sorghum"
                            },
                            "RPCP_N": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPCP_N",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Main Crops Production - Cowpea"
                            },
                            "RPCP_M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPCP_M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Main Crops Production - Millet"
                            },
                            "RPCP_A": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RPCP_A",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9.0",
                                "units": "tons",
                                "long_name": "Distribution of Main Crops Production - Groundnuts"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Label",
                                "units": "ids",
                                "PGtype": "text"
                            },
                            "adm1_name": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_name",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 Name",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "adm1_code": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "adm1_code",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Admin Level1 id",
                                "units": "unitless",
                                "PGtype": "int4"
                            }
                        }
                    }
                }
            }
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "3.0"
        },
        "provcode_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "provcode_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "2",
            "long_name": "Province Code"
        },
        "provcode": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "provcode",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridtype": "2",
            "units": "ids"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "pointwidth": "3.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "3.0"
        },
        "gid_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "2"
        },
        "gid_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "12.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "12.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "12.0"
        },
        "gid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/CountrySTAT"
    },
    "DASILVA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "DASILVA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SMD94halfbyhalfclimatologyiridlhasSemantics": "iridl:climatology",
            "SMD94climatologyiridlhasSemantics": "iridl:climatology",
            "SMD94description": "a five-volume atlas series depicting the seasonal and yearly variations of the surface marine atmosphere over the global oceans",
            "SMD94dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.DASILVA/.SMD94.dataset_documentation.html",
            "SMD94iridlhasSemantics": "iridl:NOAA",
            "SMD94GCMD_id": "NOAA_ATLAS_SURFACE_MARINE_DATA",
            "SMD94long_name": "Atlas of Surface Marine Data 1994",
            "SMD94references": "daSilva:etal1994",
            "description": "Atlas of Surface Marine Data 1994 from da Silva et. al",
            "Conventions": "IRIDL"
        },
        "SMD94": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SMD94",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "halfbyhalf": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "halfbyhalf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zdl": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zdl",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "unitless",
                        "long_name": "10m / (Monin Obukov length)",
                        "history": "surface marine climatology 1945-89"
                    },
                    "w3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "w3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "m/s",
                        "long_name": "wind speed",
                        "history": "surface marine climatology 1945-89"
                    },
                    "vq": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vq",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "m/s",
                        "long_name": "meridional moisture flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "virtemp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "virtemp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "Celsius_scale",
                        "long_name": "virtual temperature",
                        "history": "surface marine climatology 1945-89"
                    },
                    "vappres": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vappres",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "hPa",
                        "long_name": "vapor pressure",
                        "history": "surface marine climatology 1945-89"
                    },
                    "va": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "va",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "kelvin meter/second",
                        "long_name": "meridional heat flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "v3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "m/s",
                        "long_name": "meridional wind",
                        "history": "surface marine climatology 1945-89"
                    },
                    "uq": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "uq",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "m/s",
                        "long_name": "zonal moisture flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "ua": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ua",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "kelvin meter/second",
                        "long_name": "zonal heat flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "u3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "u3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "m/s",
                        "long_name": "zonal wind",
                        "history": "surface marine climatology 1945-89"
                    },
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "N/m2",
                        "long_name": "meridional wind stress",
                        "history": "surface marine climatology 1945-89"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "N/m2",
                        "long_name": "zonal wind stress",
                        "history": "surface marine climatology 1945-89"
                    },
                    "sstsat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst-sat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "Celsius_scale",
                        "long_name": "sea minus air temperature",
                        "history": "surface marine climatology 1945-89"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "Celsius_scale",
                        "long_name": "sea surface temperature",
                        "history": "surface marine climatology 1945-89"
                    },
                    "slp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "slp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "hPa",
                        "long_name": "sea level air presure",
                        "history": "surface marine climatology 1945-89"
                    },
                    "shortrad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shortrad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "net short wave radiation",
                        "history": "surface marine climatology 1945-89"
                    },
                    "sensib": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sensib",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "N/m2",
                        "long_name": "sensible heat flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "sat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "Celsius_scale",
                        "long_name": "sea level air temperature",
                        "history": "surface marine climatology 1945-89"
                    },
                    "rh": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rh",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "percent",
                        "long_name": "relative humidity",
                        "history": "surface marine climatology 1945-89"
                    },
                    "qsea": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "qsea",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "g/kg",
                        "long_name": "sea level specific humidity",
                        "history": "surface marine climatology 1945-89"
                    },
                    "qsqa": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "qs-qa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "g/kg",
                        "long_name": "qsea minus qair",
                        "history": "surface marine climatology 1945-89"
                    },
                    "qair": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "qair",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "g/kg",
                        "long_name": "specific humidity",
                        "history": "surface marine climatology 1945-89"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "mm/(3hours)",
                        "long_name": "precipitation rate",
                        "history": "surface marine climatology 1945-89"
                    },
                    "netheat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "netheat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "constrained new outgoing heat flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "longrad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "longrad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "outgoing longwave radiation",
                        "history": "surface marine climatology 1945-89"
                    },
                    "latent": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "latent",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "latent heat flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "ice": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ice",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "none",
                        "long_name": "ice mask",
                        "history": "surface marine climatology 1945-89"
                    },
                    "fvcubed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fvcubed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "N/m2",
                        "long_name": "ocean friction velocity cubed",
                        "history": "surface marine climatology 1945-89"
                    },
                    "emp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "emp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "mm/(3hours)",
                        "long_name": "constrained evaporation minus precipitation",
                        "history": "surface marine climatology 1945-89"
                    },
                    "cloud": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cloud",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "percent/100.",
                        "long_name": "cloudiness",
                        "history": "surface marine climatology 1945-89"
                    },
                    "buoy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "buoy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "kg/(meter*second3)",
                        "long_name": "constrained buoyancy flux",
                        "history": "surface marine climatology 1945-89"
                    },
                    "airdens": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "airdens",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "kg/m3",
                        "long_name": "sea level air density",
                        "history": "surface marine climatology 1945-89"
                    },
                    "ae": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ae",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "long wave vapor pressure sensitivity parameter",
                        "history": "surface marine climatology 1945-89"
                    },
                    "achi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "achi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "long wave Chi sensitivity parameter",
                        "history": "surface marine climatology 1945-89"
                    },
                    "ac": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ac",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.00000000E10",
                        "Version": "UWM-1.00 05/01/93",
                        "units": "W/m2",
                        "long_name": "short wave cloudiness sensitivity parameter",
                        "history": "surface marine climatology 1945-89"
                    }
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "zdl": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "zdl",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "6.39830032E-05",
                    "add_offset": "0.0895",
                    "units": "unitless",
                    "long_name": "10m / (Monin Obukov length)",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "w3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "2.43830000E-04",
                    "add_offset": "7.3150001",
                    "units": "m/s",
                    "long_name": "wind speed",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "vq": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vq",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "7.38669996E-06",
                    "add_offset": "-0.0186",
                    "units": "degK m/s",
                    "long_name": "meridional moisture flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "va": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "va",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.10922",
                    "add_offset": "-0.050049",
                    "units": "m/s",
                    "long_name": "meridional heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "v3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.18670015E-04",
                    "add_offset": "1.35",
                    "units": "m/s",
                    "long_name": "meridional wind",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "uq": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "uq",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "6.84830002E-06",
                    "add_offset": "0.01065",
                    "units": "m/s",
                    "long_name": "zonal moisture flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "ua": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ua",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.18212",
                    "add_offset": "-1716.5",
                    "units": "degK m/s",
                    "long_name": "zonal heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "u3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "6.79670018E-04",
                    "add_offset": "-3.97",
                    "units": "m/s",
                    "long_name": "zonal wind",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "tauy3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "6.58169984E-06",
                    "add_offset": "0.00655",
                    "units": "N/m2",
                    "long_name": "meridional wind stress",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "taux3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "9.68499990E-06",
                    "add_offset": "-0.03455",
                    "units": "N/m2",
                    "long_name": "zonal wind stress",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sstsat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst-sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.92330005E-04",
                    "add_offset": "12.74",
                    "units": "degree_Celsius",
                    "long_name": "sea minus air temperature            ",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "7.25499995E-04",
                    "add_offset": "11.815",
                    "units": "Celsius_scale",
                    "long_name": "sea surface temperature",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "slp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "8.71170021E-04",
                    "add_offset": "1003.7",
                    "units": "hPa",
                    "long_name": "sea level air presure",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "shortrad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "shortrad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0066022",
                    "add_offset": "198.07001",
                    "units": "W/m2",
                    "long_name": "incoming short wave radiation",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sensib3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sensib3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0036573",
                    "add_offset": "57.16",
                    "units": "W/m2",
                    "long_name": "sensible heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0013675",
                    "add_offset": "-6.855",
                    "units": "Celsius_scale",
                    "long_name": "sea level air temperature",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "rh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0018512",
                    "add_offset": "82.775002",
                    "units": "percent",
                    "long_name": "relative humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qsea": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qsea",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.24399977E-04",
                    "add_offset": "16.504",
                    "units": "g/kg",
                    "long_name": "sea level specific humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qsqa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qs-qa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.72669999E-04",
                    "add_offset": "4.04",
                    "units": "g/kg",
                    "long_name": "qsea minus qair",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qair": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qair",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.46119991E-04",
                    "add_offset": "16.384001",
                    "units": "g/kg",
                    "long_name": "specific humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "precip7": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip7",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.83330007E-05",
                    "add_offset": "1.15",
                    "units": "mm/(3hours)",
                    "long_name": "precipitation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "precip6": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip6",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.14429997E-04",
                    "add_offset": "3.4330001",
                    "units": "mm/(3hours)",
                    "long_name": "precipitation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "netheat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "netheat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.012595",
                    "add_offset": "-97.550003",
                    "units": "W/m2",
                    "long_name": "constrained net outgoing",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "longrad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "longrad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0035487",
                    "add_offset": "90.269997",
                    "units": "W/m2",
                    "long_name": "outgoing longwave radiation",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "latent3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latent3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.00626",
                    "add_offset": "97.639999",
                    "units": "W/m2",
                    "long_name": "latent heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "fvcubed": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "fvcubed",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.34680022E-10",
                    "add_offset": "8.64649974E-06",
                    "units": "m3/s3",
                    "long_name": "ocean friction velocity cubed",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "evaprate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "evaprate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "2.78169991E-05",
                    "add_offset": "0.6065",
                    "units": "mm/(3hours)",
                    "long_name": "evaporation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "cloud": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "2.94649999E-05",
                    "add_offset": "0.88395",
                    "units": "unitless",
                    "long_name": "fractional cloudiness",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "airdens": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "airdens",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "7.18499996E-06",
                    "add_offset": "1.3301001",
                    "units": "kg/m3",
                    "long_name": "sea level air density",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                }
            },
            "anomalies": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "anomalies",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "zdl": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "zdl",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "6.32000010E-05",
                    "add_offset": "-0.041",
                    "units": "unitless",
                    "long_name": "10m/(Monin Obukov length)",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "w3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.69169992E-04",
                    "add_offset": "0.045",
                    "units": "m/s",
                    "long_name": "wind speed",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "vq": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vq",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.17279997E-05",
                    "add_offset": "-0.02495",
                    "units": "degK m/s",
                    "long_name": "meridional moisture flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "vappress": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vappress",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.03329987E-04",
                    "units": "hPa",
                    "long_name": "vapor pressure",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "va": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "va",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.107",
                    "add_offset": "-37.200001",
                    "units": "m/s",
                    "long_name": "meridional heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "v3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.48170006E-04",
                    "add_offset": "0.035",
                    "units": "m/s",
                    "long_name": "meridional wind",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "uq": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "uq",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.13579999E-05",
                    "add_offset": "0.02235",
                    "units": "m/s",
                    "long_name": "zonal moisture flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "ua": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ua",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.15233",
                    "add_offset": "-118.0",
                    "units": "degK m/s",
                    "long_name": "zonal heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "u3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.95829973E-04",
                    "add_offset": "-0.615",
                    "units": "m/s",
                    "long_name": "zonal wind",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "tauy3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.82669992E-05",
                    "add_offset": "-0.0357",
                    "units": "N/m2",
                    "long_name": "meridional wind stress",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "taux3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.66699992E-05",
                    "add_offset": "0.0106",
                    "units": "N/m2",
                    "long_name": "zonal wind stress",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sstsat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst-sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.54499993E-04",
                    "add_offset": "-0.025",
                    "units": "degree_Celsius",
                    "long_name": "sea minus air temperature",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "2.43169998E-04",
                    "add_offset": "-0.465",
                    "units": "degree_Celsius",
                    "long_name": "sea surface temperature",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "slp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "slp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0026342",
                    "add_offset": "-19.084999",
                    "units": "hPa",
                    "long_name": "sea level air presure",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "shortrad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "shortrad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.005167",
                    "add_offset": "30.43",
                    "units": "W/m2",
                    "long_name": "incoming short wave radiation",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sensib3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sensib3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0076502",
                    "add_offset": "-5.5450001",
                    "units": "W/m2",
                    "long_name": "sensible heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "sat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "7.37669994E-04",
                    "add_offset": "-0.02",
                    "units": "degree_Celsius",
                    "long_name": "sea level air temperature",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "rh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "8.83169996E-04",
                    "add_offset": "-3.375",
                    "units": "percent",
                    "long_name": "relative humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qsea": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qsea",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "2.44619994E-04",
                    "add_offset": "0.3995",
                    "units": "g/kg",
                    "long_name": "sea level specific humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qsqa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qs-qa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.31329997E-04",
                    "add_offset": "0.51",
                    "units": "g/kg",
                    "long_name": "qsea minus qair",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "qair": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "qair",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.19749990E-04",
                    "add_offset": "0.1515",
                    "units": "g/kg",
                    "long_name": "specific humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "q": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "q",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.19749990E-04",
                    "add_offset": "0.1515",
                    "units": "g/kg",
                    "long_name": "specific humidity",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "precip6": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip6",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.25830004E-04",
                    "add_offset": "1.375",
                    "units": "mm/3hours  ",
                    "long_name": "precipitation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "precip": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "1.25649996E-04",
                    "add_offset": "0.8425",
                    "units": "mm/3hours  ",
                    "long_name": "precipitation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "netheat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "netheat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.013058",
                    "add_offset": "-37.450001",
                    "units": "W/m2",
                    "long_name": "constrained net outgoing",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "longrad": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "longrad",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0020448",
                    "add_offset": "1.455",
                    "units": "W/m2",
                    "long_name": "outgoing longwave radiation",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "latent3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "latent3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0078372",
                    "add_offset": "3.2049999",
                    "units": "W/m2",
                    "long_name": "latent heat flux",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "fvcubed": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "fvcubed",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.77500003E-10",
                    "add_offset": "-4.11000002E-07",
                    "units": "m3/s3",
                    "long_name": "ocean friction velocity cubed",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "evaprate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "evaprate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "3.19499995E-05",
                    "add_offset": "0.0685",
                    "units": "mm/3hours  ",
                    "long_name": "evaporation rate",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "cloud": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cloud",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "4.45869991E-05",
                    "add_offset": "-0.2844",
                    "units": "unitless",
                    "long_name": "fractional cloudiness",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "airdens": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "airdens",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "5.34499986E-06",
                    "add_offset": "0.00555",
                    "units": "kg/m3",
                    "long_name": "sea level air density",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "ae": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ae",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0012715",
                    "add_offset": "-1.585",
                    "units": "W/m2",
                    "long_name": "longwave vapor pressure sensitivity coefficient",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "achi": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "achi",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.0012473",
                    "add_offset": "0.030001",
                    "units": "W/m2",
                    "long_name": "longwave Chi sensitivity coefficient",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                },
                "ac": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ac",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "32767",
                    "scale_factor": "0.005512",
                    "add_offset": "34.669998",
                    "units": "W/m2",
                    "long_name": "shortwave cloud sensitivity coefficient",
                    "history": "da Silva et al. 1994: Atlas of Surface Marine Data"
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "0.5",
            "long_name": "latitude"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "0.5",
            "long_name": "longitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "calendar": "360",
            "modulus": "12.0",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "1.0",
            "long_name": "longitude"
        },
        "dir": "SOURCES/DASILVA"
    },
    "DEKLIM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "DEKLIM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "VASClimOPrcpClimResolution2p5x2p5description": "VASClimO Precipitation Climatology (2.5 x 2.5)",
            "VASClimOPrcpClimResolution1p0x1p0description": "VASClimO Precipitation Climatology (1.0 x 1.0)",
            "VASClimOPrcpClimResolution0p5x0p5description": "VASClimO Precipitation Climatology (0.5 x 0.5)",
            "VASClimOPrcpClimdescription": "VASClimO Precipitation Climatology",
            "VASClimOPrcpClimdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.DEKLIM/.VASClimO.PrcpClim.dataset_documentation.html",
            "VASClimOPrcpClimreferences": "Beck_etal2005",
            "VASClimOdescription": "Variability Analysis of Surface Climate Observations - a joint project of the German Weather Service (DWD/GPCC)and the Johann Wolfgang Goethe-University Frankfurt",
            "description": "German Climate Research Program",
            "iridlhasSemantics": "iridl:DEKLIM",
            "Conventions": "IRIDL"
        },
        "VASClimO": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "VASClimO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "PrcpClim": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PrcpClim",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Resolution2p5x2p5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Resolution-2p5x2p5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "units": "mm",
                        "long_name": "precipitation"
                    }
                },
                "Resolution1p0x1p0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Resolution-1p0x1p0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "units": "mm",
                        "long_name": "precipitation"
                    }
                },
                "Resolution0p5x0p5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Resolution-0p5x0p5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "prcp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "units": "mm",
                        "long_name": "precipitation"
                    }
                }
            }
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.5"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.5"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "dir": "SOURCES/DEKLIM"
    },
    "DGM": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/DGM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "DGM",
        "restriction": "Public",
        "Madagascar_v2": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/DGM/Madagascar_v2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "Madagascar_v2",
            "restriction": "requires dlauth tokens"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Madagascar_v2"
        ]
    },
    "EC9293": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "EC9293",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Zonal and meridional wind stress data",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.1214733"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.1179686"
        },
        "dir": "SOURCES/EC9293"
    },
    "ECHAM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ECHAM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ECHAM/.dataset_documentation.html",
            "iridlhasSemantics": "iriref:Latif_M",
            "Conventions": "IRIDL",
            "description": "ECHAM surface stresses"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "format": "ensotime",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.8125",
            "modulus": "360.0"
        },
        "dir": "SOURCES/ECHAM"
    },
    "ECMWF": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/ECMWF",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "ECMWF",
        "restriction": "Public",
        "DEMETER": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/DEMETER",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "DEMETER",
            "restriction": "requires dlauth tokens"
        },
        "ENSEMBLES": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ENSEMBLES",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "STREAM2SEASONALdata_description": "http://www.ecmwf.int/products/forecasts/seasonal/documentation/system3/ch2.html",
                "STREAM2Malariamaydescription": "Ensembles/system-3 hindcasts from ECMWF",
                "STREAM2MalariaBotswanaENSEMBLES_Botswana_Malaria_Page": "http://www.ecmwf.int/research/EU_projects/ENSEMBLES/results/Malariadata.html",
                "STREAM2MalariaBotswanadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ECMWF/.ENSEMBLES/.STREAM2.Malaria.Botswana.dataset_documentation.html",
                "Conventions": "IRIDL",
                "ECMWF_DAP": "http://ensembles.ecmwf.int/thredds/dodsC/"
            },
            "STREAM2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STREAM2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SEASONAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SEASONAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m s-1",
                            "gribfield": "1",
                            "long_name": "total precipitation",
                            "pointwidth": "0"
                        },
                        "t": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "2t",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Kelvin_scale",
                            "gribfield": "1",
                            "long_name": "2 meter teperature",
                            "pointwidth": "0"
                        }
                    }
                },
                "Malaria": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Malaria",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "may": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "may",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "V10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "10m v wind component",
                                "units": "m s**-1",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "U10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "U10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "10m u wind component",
                                "units": "m s**-1",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "TP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Accumulated precipitation",
                                "units": "mm",
                                "scale_factor": "1000",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "TEMP2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TEMP2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean 2m temperature",
                                "units": "K",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "TCWV": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "TCWV",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total column water vapor",
                                "units": "mm",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T2MIN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T2MIN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Min 2m temperature",
                                "units": "K",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T2MAX": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T2MAX",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Max 2m temperature",
                                "units": "K",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "ST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Soil/sea surface temperature",
                                "units": "K",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "OLR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OLR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Out long wave radiation",
                                "units": "W m**2",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "MSLP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MSLP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Mean sea level pressure",
                                "units": "Pa",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "EVAP": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "EVAP",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Surface Evaporation",
                                "units": "m s**-1",
                                "cNZ": "0",
                                "gribfield": "1",
                                "pointwidth": "0"
                            }
                        },
                        "PressureLevel": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "V": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "V wind",
                                "units": "m s**-1",
                                "cNZ": "3",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "U": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "U",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "U wind",
                                "units": "m s**-1",
                                "cNZ": "3",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Temperature",
                                "units": "K",
                                "cNZ": "3",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "q": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "q",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Specific humidity",
                                "units": "kg kg**-1",
                                "cNZ": "3",
                                "gribfield": "1",
                                "pointwidth": "0"
                            },
                            "Geo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Geo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geopotential height",
                                "units": "g m",
                                "cNZ": "3",
                                "gribfield": "1",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "Botswana": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Botswana",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "METOFFICE": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "METOFFICE",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precip": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precip",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0"
                            }
                        },
                        "METEOFR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "METEOFR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precip": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precip",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0"
                            }
                        },
                        "ECMWF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECMWF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "precip": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "precip",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0"
                            }
                        }
                    }
                }
            },
            "STREAM1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "STREAM1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "L_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months",
                "gridtype": "0",
                "long_name": "Lead Time",
                "pointwidth": "1"
            },
            "X_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "1.5"
            },
            "S_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Start time",
                "pointwidth": "0"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "1.5"
            },
            "L_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days",
                "gridtype": "0",
                "long_name": "Integration Time",
                "pointwidth": "1"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "1.5"
            },
            "M_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "Member",
                "pointwidth": "1.0"
            },
            "S_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Start time",
                "pointwidth": "0"
            },
            "P": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "gridtype": "0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "2.5"
            },
            "L": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months",
                "gridtype": "0",
                "long_name": "Integration Time",
                "pointwidth": "0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "2.5"
            },
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "Member",
                "pointwidth": "1.0"
            },
            "S": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Start time",
                "pointwidth": "0"
            },
            "dir": "SOURCES/ECMWF/ENSEMBLES"
        },
        "ERA15": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/ERA-15",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ERA-15",
            "restriction": "Public",
            "ERA15pdf": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-15/ERA15.pdf",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ERA15.pdf",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "indextex": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-15/index.tex",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "index.tex",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "ERA15pdf",
                "indextex"
            ]
        },
        "ERA40": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/ERA-40",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ERA-40",
            "restriction": "Public",
            "MONTHLY": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-40/MONTHLY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "MONTHLY",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "SIXHOURLY": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-40/SIX-HOURLY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "SIX-HOURLY",
                "restriction": "requires dlauth tokens"
            },
            "TimeInv": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-40/TimeInv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "TimeInv",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "MONTHLY",
                "SIXHOURLY",
                "TimeInv"
            ]
        },
        "ERAInterim": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/ERA-Interim",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ERA-Interim",
            "restriction": "Public",
            "SIXHOURLY": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/ERA-Interim/SIX-HOURLY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "SIX-HOURLY",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "SIXHOURLY"
            ]
        },
        "GGA": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/GGA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "GGA",
            "restriction": "Public",
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "S2S": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/ECMWF/S2S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "S2S",
            "restriction": "Public",
            "BOM": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/BOM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "BOM",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/BOM/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/BOM/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/BOM/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "CMA": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/CMA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "CMA",
                "restriction": "Public",
                "BCCCPSS2Sv1": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "BCC-CPS-S2Sv1",
                    "restriction": "Public",
                    "forecast": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "forecast",
                        "restriction": "Public",
                        "control": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/forecast/control",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "control",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "perturbed": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/forecast/perturbed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "perturbed",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "control",
                            "perturbed"
                        ]
                    },
                    "reforecast": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/reforecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "reforecast",
                        "restriction": "Public",
                        "control": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/reforecast/control",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "control",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "perturbed": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv1/reforecast/perturbed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "perturbed",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "control",
                            "perturbed"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "forecast",
                        "reforecast"
                    ]
                },
                "BCCCPSS2Sv2": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "BCC-CPS-S2Sv2",
                    "restriction": "Public",
                    "forecast": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "forecast",
                        "restriction": "Public",
                        "control": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/forecast/control",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "control",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "perturbed": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/forecast/perturbed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "perturbed",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "control",
                            "perturbed"
                        ]
                    },
                    "reforecast": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/reforecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "reforecast",
                        "restriction": "Public",
                        "control": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/reforecast/control",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "control",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "perturbed": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/ECMWF/S2S/CMA/BCC-CPS-S2Sv2/reforecast/perturbed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "perturbed",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "control",
                            "perturbed"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "forecast",
                        "reforecast"
                    ]
                },
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CMA/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CMA/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CMA/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "BCCCPSS2Sv1",
                    "BCCCPSS2Sv2",
                    "forecast",
                    "reforecast"
                ]
            },
            "CNRM": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/CNRM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "CNRM",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CNRM/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/CNRM/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/CNRM/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "ECCC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/ECCC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ECCC",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ECCC/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ECCC/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECCC/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "ECMF": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/ECMF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ECMF",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ECMF/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ECMF/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ECMF/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "EI": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/EI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "EI",
                "restriction": "Public",
                "reanalysis": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/EI/reanalysis",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reanalysis",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/EI/reanalysis/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "reanalysis"
                ]
            },
            "HMCR": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/HMCR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "HMCR",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/HMCR/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/HMCR/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/HMCR/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "ISAC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/ISAC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ISAC",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ISAC/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ISAC/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ISAC/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ISAC/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/ISAC/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ISAC/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/ISAC/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "JMA": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/JMA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "JMA",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/JMA/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbedM49": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/forecast/perturbedM49",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbedM49",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed",
                        "perturbedM49"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/JMA/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/JMA/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "KMA": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/KMA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "KMA",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/KMA/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/KMA/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/KMA/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/KMA/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/KMA/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/KMA/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "NCEP": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/NCEP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "NCEP",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/NCEP/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/NCEP/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/NCEP/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "UKMO": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/UKMO",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "UKMO",
                "restriction": "Public",
                "forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/UKMO/forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "forecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/forecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/forecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/forecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed"
                    ]
                },
                "reforecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/UKMO/reforecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "reforecast",
                    "restriction": "Public",
                    "RMMS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/reforecast/RMMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "RMMS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "control": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/reforecast/control",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "control",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbed": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/reforecast/perturbed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbed",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "perturbedM6": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/UKMO/reforecast/perturbedM6",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "perturbedM6",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "RMMS",
                        "control",
                        "perturbed",
                        "perturbedM6"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "forecast",
                    "reforecast"
                ]
            },
            "climatologies": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/ECMWF/S2S/climatologies",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "climatologies",
                "restriction": "Public",
                "hindcast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "hindcast",
                    "restriction": "Public",
                    "BOM": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/BOM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "BOM",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "CMA": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/CMA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CMA",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "CNRM": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/CNRM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CNRM",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "ECCC": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/ECCC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ECCC",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "ECMF": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/ECMF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ECMF",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "ISAC": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/ISAC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ISAC",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "JMA": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/JMA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "JMA",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "KMA": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/KMA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "KMA",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "NCEP": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/NCEP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "NCEP",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "UKMO": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/hindcast/UKMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "UKMO",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "BOM",
                        "CMA",
                        "CNRM",
                        "ECCC",
                        "ECMF",
                        "ISAC",
                        "JMA",
                        "KMA",
                        "NCEP",
                        "UKMO"
                    ]
                },
                "observed": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/ECMWF/S2S/climatologies/observed",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "observed",
                    "restriction": "Public",
                    "CHIRPS": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/observed/CHIRPS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CHIRPS",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "CPC": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/observed/CPC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CPC",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "GPCP": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/ECMWF/S2S/climatologies/observed/GPCP",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "GPCP",
                        "restriction": "Public",
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "CHIRPS",
                        "CPC",
                        "GPCP"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "hindcast",
                    "observed"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "BOM",
                "CMA",
                "CNRM",
                "ECCC",
                "ECMF",
                "EI",
                "HMCR",
                "ISAC",
                "JMA",
                "KMA",
                "NCEP",
                "UKMO",
                "climatologies"
            ]
        },
        "TCs": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TCs",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "reforecastsWNPdescription": "West Northern Pacific basin",
                "bestTrackWNPdescription": "West Northern Pacific basin",
                "bestTrackWNPdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ECMWF/.TCs/.bestTrack.WNP.dataset_documentation.html",
                "description": "Tropical Cyclones",
                "Conventions": "IRIDL"
            },
            "reforecasts": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "reforecasts",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WNP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WNP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "maxncolor": "254",
                        "colorscalename": "windspeed_colors",
                        "colormap": "2622920",
                        "ncolor": "254",
                        "missing_value": "9.96920997E36",
                        "units": "m/s",
                        "long_name": "Maximum wind velocity",
                        "pointwidth": "0"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Forecast Time",
                        "pointwidth": "0",
                        "calendar": "standard",
                        "units": "days since 1960-01-01"
                    },
                    "StormId": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "StormId",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "long_name": "Storm ID",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "pmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "hPa",
                        "long_name": "Minimum Pressure",
                        "pointwidth": "0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_east",
                        "long_name": "longitude",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "units": "degree_east",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_north",
                        "long_name": "latitude",
                        "scale_max": "54.0",
                        "scale_min": "-4.0",
                        "pointwidth": "0"
                    }
                }
            },
            "forecasts": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "forecasts",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WNP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WNP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "maxncolor": "254",
                        "colorscalename": "windspeed_colors",
                        "colormap": "2622920",
                        "ncolor": "254",
                        "missing_value": "9.96920997E36",
                        "units": "knot",
                        "long_name": "Maximum wind velocity",
                        "pointwidth": "0"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Forecast Time",
                        "pointwidth": "0",
                        "calendar": "standard",
                        "units": "days since 2015-01-01"
                    },
                    "StormId": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "StormId",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "long_name": "Storm ID",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "pmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "mb",
                        "long_name": "Minimum Pressure",
                        "pointwidth": "0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_east",
                        "long_name": "longitude",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "units": "degree_east",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_north",
                        "long_name": "latitude",
                        "scale_max": "54.0",
                        "scale_min": "-4.0",
                        "pointwidth": "0"
                    }
                }
            },
            "bestTrack": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "bestTrack",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WNP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WNP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0.0",
                        "CS": "0",
                        "maxncolor": "254",
                        "colorscalename": "windspeed_colors",
                        "colormap": "2622920",
                        "ncolor": "254",
                        "missing_value": "9.96920997E36",
                        "units": "knot",
                        "long_name": "Maximum wind velocity",
                        "pointwidth": "0"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Forecast Time",
                        "pointwidth": "0",
                        "calendar": "standard",
                        "units": "days since 1960-01-01"
                    },
                    "StormId": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "StormId",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "long_name": "Storm ID",
                        "units": "unitless",
                        "pointwidth": "0"
                    },
                    "pmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "hPa",
                        "long_name": "Minimum Pressure",
                        "pointwidth": "0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_east",
                        "long_name": "longitude",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "units": "degree_east",
                        "scale_max": "225.0",
                        "scale_min": "85.0",
                        "pointwidth": "0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "9.96920997E36",
                        "units": "degree_north",
                        "long_name": "latitude",
                        "scale_max": "54.0",
                        "scale_min": "-4.0",
                        "pointwidth": "0"
                    }
                }
            },
            "L_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days",
                "gridtype": "0",
                "long_name": "lead time",
                "pointwidth": "1.0"
            },
            "M_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "ensemble member",
                "pointwidth": "1.0"
            },
            "L_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days",
                "gridtype": "0",
                "long_name": "lead time",
                "pointwidth": "0.5"
            },
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "ensemble member",
                "pointwidth": "1.0"
            },
            "S_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "0",
                "calendar": "standard",
                "long_name": "Start time",
                "units": "days since 2015-01-01",
                "pointwidth": "0"
            },
            "StormNum": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "StormNum",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "L": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days",
                "gridtype": "0",
                "long_name": "lead time",
                "pointwidth": "0.25"
            },
            "S": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "calendar": "standard",
                "long_name": "Start time",
                "pointwidth": "0"
            },
            "dir": "SOURCES/ECMWF/TCs"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "DEMETER",
            "ENSEMBLES",
            "ERA15",
            "ERA40",
            "ERAInterim",
            "GGA",
            "S2S",
            "TCs"
        ]
    },
    "ECOSYSTEMS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ECOSYSTEMS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Olsonreferences": "Olson_etal1983",
            "Olsondescription": "Global vegetation and ecosystems data",
            "Olsondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ECOSYSTEMS/.Olson.dataset_documentation.html",
            "OlsoniridlhasSemantics": "iridl:ORNL",
            "Olsonlong_name": "Olson Ecosystem Complexes",
            "Matthewsdescription": "Global vegetation and ecosystems data",
            "Matthewssource": ">Matthews Global Vegetation Index</a>",
            "Matthewsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ECOSYSTEMS/.Matthews.dataset_documentation.html",
            "MatthewsiridlhasSemantics": "iridl:GISS",
            "Matthewslong_name": "Matthews Vegetation Index",
            "Matthewsreferences": "Matthews1983 Matthews1984",
            "Holdridgechangeslong_name": "Areas with Life-Zone Changes in doubled CO2 senario",
            "Holdridgereferences": "Leemans1990",
            "Holdridgesource": ">Holdridge Life Zones Data Set</a>",
            "HoldridgeiridlhasSemantics": "iridl:IIASA",
            "Holdridgelong_name": "Holdridge Life Zones",
            "description": "Vegetation and ecosystem data from the IIASA, GISS, and USGS",
            "Conventions": "IRIDL"
        },
        "Olson": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Olson",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "_class": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "class",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "scale_min": "17.0",
                "scale_max": "70.0",
                "iridlhasSemantics": "iridl:LandCover",
                "long_name": "land ecosystem class",
                "CLIST": "ice"
            }
        },
        "Matthews": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Matthews",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "vegetation": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "vegetation",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "scale_min": "1.0",
                "scale_max": "32.0",
                "source": ">Matthews Global Vegetation Index</a>",
                "iridlhasSemantics": "iridl:LandCover",
                "long_name": "vegetation index",
                "missing_values": "99999",
                "CLIST": "cultivation"
            }
        },
        "Holdridge": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Holdridge",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "present": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "present",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "lifezone": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "life-zone",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "maxncolor": "41",
                    "colormap": "1710726",
                    "scale_max": "38.0",
                    "ncolor": "41",
                    "scale_min": "1.0",
                    "CE": "38",
                    "CS": "1",
                    "iridlhasSemantics": "iridl:LandCover",
                    "long_name": "life-zone class",
                    "CLIST": "Tropical rain forest"
                }
            },
            "doubleCO2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "doubleCO2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "lifezone": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "life-zone",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "scale_max": "38.0",
                    "ncolor": "41",
                    "scale_min": "1.0",
                    "CS": "1",
                    "CE": "38",
                    "maxncolor": "41",
                    "colormap": "1710726",
                    "CLIST": "Tropical rain forest",
                    "iridlhasSemantics": "iridl:LandCover",
                    "long_name": "life-zone class"
                }
            },
            "changes": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "changes",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "present": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "present",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "lifezone": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "life-zone",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "scale_max": "38.0",
                        "ncolor": "41",
                        "scale_min": "1.0",
                        "CS": "1",
                        "iridlhasSemantics": "iridl:LandCover",
                        "CE": "38",
                        "maxncolor": "41",
                        "colormap": "1710726",
                        "CLIST": "Tropical rain forest",
                        "long_name": "life-zone class"
                    }
                },
                "doubleCO2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "doubleCO2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "lifezone": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "life-zone",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "scale_max": "38.0",
                        "ncolor": "41",
                        "scale_min": "1.0",
                        "CS": "1",
                        "iridlhasSemantics": "iridl:LandCover",
                        "CE": "38",
                        "maxncolor": "41",
                        "colormap": "1710726",
                        "CLIST": "Tropical rain forest",
                        "long_name": "life-zone class"
                    }
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "dir": "SOURCES/ECOSYSTEMS"
    },
    "ECP9293": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ECP9293",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Zonal and meridional wind stress data",
            "Conventions": "IRIDL"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.1214733"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.1179686"
        },
        "dir": "SOURCES/ECP9293"
    },
    "ENSOFORECAST": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ENSOFORECAST",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "LDEO2CACSMdescription": "observed ssta fields",
            "LDEO212MONdescription": "forecast ssta fields",
            "LDEO209MONdescription": "forecast ssta fields",
            "LDEO206MONdescription": "forecast ssta fields",
            "LDEO203MONdescription": "forecast ssta fields",
            "LDEO2Y": "Y",
            "LDEO2description": "LDEO2 Forecasts of Tropical Pacific SSTA at 3-12 month lead times",
            "LDEO2T": "T",
            "LDEO2X": "X",
            "LDEO1CACSMdescription": "observed ssta fields",
            "LDEO112MONdescription": "forecast ssta fields",
            "LDEO109MONdescription": "forecast ssta fields",
            "LDEO106MONdescription": "forecast ssta fields",
            "LDEO103MONdescription": "forecast ssta fields",
            "LDEO1Y": "Y",
            "LDEO1description": "Forecasts of Tropical Pacific SSTA at 3-12 month lead times",
            "LDEO1T": "T",
            "LDEO1X": "X",
            "description": "Equatorial Pacific SSTA forecasts from the Lamont-Doherty Earth Observatory Climate Group",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ENSOFORECAST/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:forecast",
            "Conventions": "IRIDL",
            "references": "Zebiak_Cane1987"
        },
        "LDEO2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "LDEO2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CACSM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CACSM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "history": "CACSM SSTA with land gridded as in the forecasts",
                    "missing_value": "-999.0",
                    "units": "degC"
                }
            },
            "MON": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "03MON",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "degC",
                    "long_name": "temperature anomaly"
                }
            }
        },
        "LDEO1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "LDEO1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CACSM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CACSM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "history": "CACSM SSTA with land gridded as in the forecasts",
                    "missing_value": "-999.0",
                    "units": "degC"
                }
            },
            "MON": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "03MON",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "degC"
                }
            }
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "4.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0"
        },
        "dir": "SOURCES/ENSOFORECAST"
    },
    "EPCU": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "EPCU",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "EPCU",
            "references": "vanGeen_etal1992",
            "description": "Eastern pacific coastal upwelling data for the Americas from the Lamont-Doherty Earth Observatory",
            "Conventions": "IRIDL",
            "iridlhasSemantics": "iridl:LDEO",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.EPCU/.dataset_documentation.html"
        },
        "TIME": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TIME",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "add_offset": "2448257.0",
            "calendar": "standard",
            "units": "julian_day",
            "pointwidth": "0"
        },
        "Si": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Si",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "units": "micro mole/L",
            "long_name": "Silicate"
        },
        "SALINITY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SALINITY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "units": "PSU"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "units": "micro mole/L",
            "long_name": "Phosphate"
        },
        "N": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "N",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "units": "micro mole/L",
            "long_name": "Nitrate and Nitrite"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "scale_min": "-130.0",
            "scale_max": "-60.0",
            "units": "degree_east",
            "long_name": "longitude"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "scale_min": "-50.0",
            "scale_max": "50.0",
            "units": "degree_north",
            "long_name": "latitude"
        },
        "Cd": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Cd",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "-999.0",
            "units": "nano mole/kg",
            "long_name": "Cadmium"
        },
        "IT": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "IT",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "0.5",
            "add_offset": "372.0"
        },
        "STA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2",
            "long_name": "station"
        },
        "dir": "SOURCES/EPCU"
    },
    "ERBE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ERBE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "partdescription": "Shortwave radiation budget data 60S-60N derived from 5 Years of ERBE measurements",
            "globalmeanforcinglong_name": "cloud forcing",
            "globalmeanclrlong_name": "clear-sky",
            "globalmeancldlong_name": "all-sky",
            "globaldescription": "Global shortwave radiation budget data derived from 5 Years of ERBE measurements",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.ERBE/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL",
            "references": "Li_Leighton1993 Li_etal1993a Li_etal1993b",
            "description": "Earth Radiation Budget Experiment"
        },
        "part": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "part",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "srb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "srb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": ">ERBE description</A>",
                    "units": "W/m2",
                    "long_name": "surface radiation budget",
                    "history": "ERBE Surface Radiation Budget"
                }
            }
        },
        "_global": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "global",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "srb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "srb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "source": ">ERBE description</A>",
                    "units": "W/m2",
                    "long_name": "surface radiation budget",
                    "history": "ERBE Surface Radiation Budget"
                }
            },
            "mean": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "mean",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "forcing": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "forcing",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "srb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "srb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "source": ">ERBE description</A>",
                        "units": "W/m2",
                        "long_name": "surface radiation budget",
                        "history": "ERBE Surface Radiation Budget"
                    }
                },
                "clr": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "clr",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "srb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "srb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "source": ">ERBE description</A>",
                        "units": "W/m2",
                        "long_name": "surface radiation budget",
                        "history": "ERBE Surface Radiation Budget"
                    }
                },
                "cld": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cld",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "srb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "srb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "source": ">ERBE description</A>",
                        "units": "W/m2",
                        "long_name": "surface radiation budget",
                        "history": "ERBE Surface Radiation Budget"
                    }
                }
            }
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "calendar": "360",
            "modulus": "12.0",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5"
        },
        "dir": "SOURCES/ERBE"
    },
    "EU": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/EU",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "EU",
        "restriction": "Public",
        "Copernicus": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Copernicus",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "CDSC3SUKMOGloSea5GC2System15hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System15hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SUKMOGloSea5GC2System15hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SUKMOGloSea5GC2System15forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System15forecastexpires": "1614582000",
                "CDSC3SUKMOGloSea5GC2System15forecastlicense": "https://cds.climate.copernicus.eu/api/v2/terms/static/20180314_Copernicus_License_V1.1.pdf",
                "CDSC3SUKMOGloSea5GC2System15forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SUKMOGloSea5GC2System14hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System14hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SUKMOGloSea5GC2System14hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SUKMOGloSea5GC2System14forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System14forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SUKMOGloSea5GC2System14forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SUKMOGloSea5GC2System13hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System13hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SUKMOGloSea5GC2System13hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SUKMOGloSea5GC2System13forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SUKMOGloSea5GC2System13forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SUKMOGloSea5GC2System13forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem7hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem7hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SMeteo_FranceSystem7hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem7forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem7forecastexpires": "1614582000",
                "CDSC3SMeteo_FranceSystem7forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SMeteo_FranceSystem7forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem6hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem6hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SMeteo_FranceSystem6hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem6forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem6forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SMeteo_FranceSystem6forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem5hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem5hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem5hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SMeteo_FranceSystem5forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SMeteo_FranceSystem5forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SMeteo_FranceSystem5forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SECMWFSEAS5hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SECMWFSEAS5hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SECMWFSEAS5hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SECMWFSEAS5forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SECMWFSEAS5forecastexpires": "1614582000",
                "CDSC3SECMWFSEAS5forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SECMWFSEAS5forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SDWDGCFS2p1hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SDWDGCFS2p1hindcastlicense": "https://cds.climate.copernicus.eu/api/v2/terms/static/20180314_Copernicus_License_V1.1.pdf",
                "CDSC3SDWDGCFS2p1hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SDWDGCFS2p1forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SDWDGCFS2p1forecastexpires": "1614582000",
                "CDSC3SDWDGCFS2p1forecastlicense": "https://cds.climate.copernicus.eu/api/v2/terms/static/20180314_Copernicus_License_V1.1.pdf",
                "CDSC3SDWDGCFS2p1forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SDWDGCFS2p0hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SDWDGCFS2p0hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SDWDGCFS2p0hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SDWDGCFS2p0forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SDWDGCFS2p0forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SDWDGCFS2p0forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SCMCCSPSv3p5hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SCMCCSPSv3p5hindcastlicense": "https://cds.climate.copernicus.eu/api/v2/terms/static/20180314_Copernicus_License_V1.1.pdf",
                "CDSC3SCMCCSPSv3p5hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SCMCCSPSv3p5forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SCMCCSPSv3p5forecastexpires": "1614582000",
                "CDSC3SCMCCSPSv3p5forecastlicense": "https://cds.climate.copernicus.eu/api/v2/terms/static/20180314_Copernicus_License_V1.1.pdf",
                "CDSC3SCMCCSPSv3p5forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SCMCCSPSv3hindcastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SCMCCSPSv3hindcastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SCMCCSPSv3hindcastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3SCMCCSPSv3forecastsource": "https://cds.climate.copernicus.eu/cdsapp#!/home",
                "CDSC3SCMCCSPSv3forecastlicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3SCMCCSPSv3forecastnote": "Generated using Copernicus Climate Change Service information [2018]",
                "CDSC3Shome": "https://climate.copernicus.eu/",
                "CDSC3Slicense": "https://iridl.ldeo.columbia.edu/documentation/eu/copernicus/cds/c3s/licence-to-use-copernicus-products.pdf",
                "CDSC3Sdescription": "Copernicus Climate Change Service",
                "CDSdescription": "Climate Data Store",
                "Conventions": "IRIDL",
                "description": "Copernicus Earth Observation Programme"
            },
            "CDS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CDS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "C3S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "C3S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "UKMO": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "UKMO",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GloSea5GC2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GloSea5-GC2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "System15": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "System15",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "hindcast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "24",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                },
                                "forecast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "24",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "expires": "1614582000",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0",
                                        "defaultvalue": "733.0",
                                        "bounds": "S"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "expires": "1614582000",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "defaultvalue": "733.0",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "System14": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "System14",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "hindcast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "24",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                },
                                "forecast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "24",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "System13": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "System13",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "hindcast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                },
                                "forecast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "geopotential",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m2 s-2",
                                        "gribfield": "1",
                                        "gribparam": "129",
                                        "grib_name": "Z",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "geopotential",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "V-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "132",
                                        "grib_name": "VGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "northward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "U-component of wind",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "gribparam": "131",
                                        "grib_name": "UGRD",
                                        "process": "128",
                                        "gribcenter": "74",
                                        "standard_name": "eastward_wind",
                                        "gribNumBits": "24",
                                        "pointwidth": "0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "2-meter temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "330.0",
                                        "scale_min": "180.0",
                                        "gribparam": "167",
                                        "grib_name": "2T",
                                        "standard_name": "air_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "sea surface temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "scale_max": "365.39999",
                                        "scale_min": "180.0",
                                        "gribparam": "34",
                                        "grib_name": "SSTK",
                                        "standard_name": "sea_surface_temperature",
                                        "process": "128",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "fnname": "maskge",
                                        "long_name": "total precipitation",
                                        "file_missing_value": "9.99900026E20",
                                        "units": "m s-1",
                                        "gribfield": "1",
                                        "scale_min": "0.0",
                                        "gribparam": "228",
                                        "grib_name": "TP",
                                        "standard_name": "lwe_precipitation_rate",
                                        "process": "255",
                                        "gribNumBits": "16",
                                        "gribcenter": "74",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    },
                    "Meteo_France": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Meteo_France",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "System7": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "System7",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "expires": "1614582000",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "733.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "System6": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "System6",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "85",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "System5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "System5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "231",
                                    "gribcenter": "85",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "ECMWF": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ECMWF",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SEAS5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SEAS5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "147",
                                    "gribcenter": "98",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "16",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "expires": "1614582000",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "733.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "365.39999",
                                    "scale_min": "180.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "142",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "147",
                                    "gribNumBits": "16",
                                    "gribcenter": "98",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "DWD": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "DWD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GCFS2p1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GCFS2p1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "expires": "1614582000",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "733.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "GCFS2p0": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GCFS2p0",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "78",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "78",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "CMCC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CMCC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SPSv3p5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SPSv3p5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "expires": "1614582000",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "733.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "expires": "1614582000",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "defaultvalue": "733.0",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "SPSv3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SPSv3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "hindcast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            },
                            "forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "geopotential",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m2 s-2",
                                    "gribfield": "1",
                                    "gribparam": "129",
                                    "grib_name": "Z",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "geopotential",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "V-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "132",
                                    "grib_name": "VGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "northward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "U-component of wind",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "gribparam": "131",
                                    "grib_name": "UGRD",
                                    "process": "128",
                                    "gribcenter": "80",
                                    "standard_name": "eastward_wind",
                                    "gribNumBits": "24",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "2-meter temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "330.0",
                                    "scale_min": "180.0",
                                    "gribparam": "167",
                                    "grib_name": "2T",
                                    "standard_name": "air_temperature",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "sea surface temperature",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "Kelvin_scale",
                                    "gribfield": "1",
                                    "scale_max": "320.0",
                                    "scale_min": "270.0",
                                    "gribparam": "34",
                                    "grib_name": "SSTK",
                                    "standard_name": "sea_surface_temperature",
                                    "process": "128",
                                    "gribNumBits": "16",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "fnname": "maskge",
                                    "long_name": "total precipitation",
                                    "file_missing_value": "9.99900026E20",
                                    "units": "m s-1",
                                    "gribfield": "1",
                                    "scale_min": "0.0",
                                    "gribparam": "228",
                                    "grib_name": "TP",
                                    "standard_name": "lwe_precipitation_rate",
                                    "process": "128",
                                    "gribNumBits": "24",
                                    "gribcenter": "80",
                                    "gribleveltype": "1",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                }
            },
            "S_13": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_13",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "expires": "1614582000",
                "calendar": "360",
                "defaultvalue": "733.0",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "M_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_11": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_11",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "S_10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "expires": "1614582000",
                "calendar": "360",
                "defaultvalue": "733.0",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "S_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "P_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "hPa",
                "gridtype": "0",
                "standard_name": "air_pressure",
                "long_name": "Pressure Level"
            },
            "S_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "1.0"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "1.0"
            },
            "M_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "expires": "1614582000",
                "calendar": "360",
                "defaultvalue": "733.0",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "S_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "expires": "1614582000",
                "calendar": "360",
                "defaultvalue": "733.0",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "S_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "expires": "1614582000",
                "calendar": "360",
                "defaultvalue": "733.0",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "M_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "P": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "hPa",
                "gridtype": "0",
                "standard_name": "air_pressure",
                "long_name": "Pressure Level"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "1.0"
            },
            "L": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "L",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months",
                "gridtype": "0",
                "standard_name": "forecast_period",
                "long_name": "Lead",
                "pointwidth": "1.0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "1.0"
            },
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "member",
                "pointwidth": "1.0"
            },
            "S": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "S",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "forecast_reference_time",
                "long_name": "Forecast Start Time",
                "pointwidth": "0"
            },
            "dir": "SOURCES/EU/Copernicus"
        },
        "EUMETSAT": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "EUMETSAT",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.EU/.EUMETSAT/.dataset_documentation.html",
                "Conventions": "IRIDL"
            },
            "Meteosat_3712": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Meteosat_3712",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "valid_min": "2",
                    "COFF": "1250.5",
                    "LFAC": "521518918",
                    "short_name": "temperature",
                    "SpatialReferenceSystemDims": "Y",
                    "LOFF": "1250.5",
                    "units": "Kelvin_scale",
                    "CFAC": "521518918",
                    "long_name": "Brightness temperature",
                    "SpatialReferenceSystemWKT": ",0]]",
                    "ssp_lon": "0.0",
                    "Meteosat": "2-7",
                    "missing_value": "-99",
                    "pointwidth": "0.0"
                }
            },
            "Meteosat_3711": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Meteosat_3711",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "valid_min": "2",
                    "COFF": "1250.5",
                    "LFAC": "521518918",
                    "short_name": "temperature",
                    "SpatialReferenceSystemDims": "Y",
                    "LOFF": "1250.5",
                    "units": "Kelvin_scale",
                    "CFAC": "521518918",
                    "long_name": "Brightness temperature",
                    "SpatialReferenceSystemWKT": ",0]]",
                    "ssp_lon": "0.0",
                    "Meteosat": "2-7",
                    "missing_value": "-99",
                    "pointwidth": "0.0"
                }
            },
            "Meteosat_2500": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Meteosat_2500",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "valid_min": "2",
                    "COFF": "1250.5",
                    "LFAC": "521518918",
                    "short_name": "temperature",
                    "SpatialReferenceSystemDims": "Y",
                    "LOFF": "1250.5",
                    "units": "Kelvin_scale",
                    "CFAC": "521518918",
                    "long_name": "Brightness temperature",
                    "SpatialReferenceSystemWKT": ",0]]",
                    "ssp_lon": "0.0",
                    "Meteosat": "2-7",
                    "missing_value": "-99",
                    "pointwidth": "0.0"
                }
            },
            "Y_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "3003.0498"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "minutes since 1983-01-01 0:0:0",
                "gridtype": "0",
                "calendar": "standard",
                "standard_name": "time",
                "pointwidth": "0.0"
            },
            "X_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "3015.2649"
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "3003.0496"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "minutes since 1983-01-01 0:0:0",
                "gridtype": "0",
                "calendar": "standard",
                "standard_name": "time",
                "pointwidth": "0.0"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "3015.2646"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "4517.0977"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "minutes since 1983-01-01 0:0:0",
                "gridtype": "0",
                "calendar": "standard",
                "standard_name": "time",
                "pointwidth": "0.0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "m",
                "gridtype": "0",
                "pointwidth": "4517.2559"
            },
            "dir": "SOURCES/EU/EUMETSAT"
        },
        "JRC": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "JRC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "IESGVMGLC2000V1p1globaldescription": "Gridded global land cover data set from the Global Vegetation Monitoring Unit of the Institute for Environment and Sustainability of the EC Joint Research Centre",
                "IESGVMGLC2000V1p1globalhome_page": "http://www-gvm.jrc.it/glc2000/defaultGLC2000.htm",
                "IESGVMGLC2000V1p1description": "Version 1.1",
                "IESGVMGLC2000description": "Global Landcover Classification 2000",
                "IESGVMFAPARWestAfricaProcessing_Center": "Joint Research Centre - IMW - GVM / IES",
                "IESGVMFAPARWestAfricaSoftware_Version": "ReMap Aggregate - Version 1.0",
                "IESGVMFAPARWestAfricaMission": "Seastar SeaWiFS",
                "IESGVMFAPARWestAfricaSoftware_Name": "ReMap Aggregate - JRC - GVM / IES",
                "IESGVMFAPARsource": "http://fapar.jrc.it/WWW/Home.php",
                "IESGVMFAPARreferences": "Gobron_etal2002 Gobron_etal2006",
                "IESGVMdescription": "Global Vegetation Monitoring Unit",
                "IESGVMhome_page": "http://www-gvm.jrc.it/",
                "IESdescription": "Institute for Environment and Sustainability",
                "IESiridlhasSemantics": "iridl:IES",
                "IEShome_page": "http://ies.jrc.cec.eu.int/",
                "description": "Joint Research Centre",
                "iridlhasSemantics": "iridl:JRC",
                "Conventions": "IRIDL",
                "home_page": "http://www.jrc.cec.eu.int/"
            },
            "IES": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "IES",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "GVM": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GVM",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GLC2000": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GLC2000",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V1p1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "V1p1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "_global": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "global",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "_class": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "class",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "26",
                                    "colormap": "16777215",
                                    "scale_max": "23.0",
                                    "ncolor": "26",
                                    "scale_min": "1.0",
                                    "CE": "23",
                                    "CS": "1",
                                    "iridlhasSemantics": "iridl:LandCover",
                                    "units": "ids",
                                    "long_name": "land cover class",
                                    "CLIST": "No data"
                                }
                            }
                        }
                    },
                    "FAPAR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FAPAR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WestAfrica": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WestAfrica",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tenday": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tenday",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "version": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "version",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "nb_temporal_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nb_temporal_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of daily FAPAR estimates used in time composite",
                                    "missing_value": "255",
                                    "units": "unitless"
                                },
                                "fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Fraction of Absorbed Photosynthetically Active Radiation (FAPAR)",
                                    "missing_value": "255",
                                    "scale_factor": "0.004",
                                    "valid_range": "250",
                                    "units": "unitless"
                                },
                                "dev_temporal_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dev_temporal_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temporal deviation of FAPAR during the time composite period",
                                    "units": "unitless"
                                },
                                "day_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day selected for FAPAR value during the time composite",
                                    "missing_value": "255",
                                    "units": "unitless"
                                }
                            },
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "nb_temporal_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nb_temporal_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Number of daily FAPAR estimates used in time composite",
                                    "missing_value": "255",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Fraction of Absorbed Photosynthetically Active Radiation (FAPAR)",
                                    "missing_value": "255",
                                    "scale_factor": "0.004",
                                    "valid_range": "250",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "dev_temporal_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dev_temporal_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temporal deviation of FAPAR during the time composite period",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "day_fapar": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "day_fapar",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Day selected for FAPAR value during the time composite",
                                    "missing_value": "255",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    }
                }
            },
            "Y_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "0.008928572"
            },
            "X_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "0.008928572"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "days since 1960-01-01",
                "gridtype": "0",
                "calendar": "standard"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "0.01949026"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "standard_name": "longitude",
                "pointwidth": "0.01983003"
            },
            "dir": "SOURCES/EU/JRC"
        },
        "VITO": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/EU/VITO",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "VITO",
            "restriction": "Public",
            "DevCoCast": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/EU/VITO/DevCoCast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "DevCoCast",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "DevCoCast"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Copernicus",
            "EUMETSAT",
            "JRC",
            "VITO"
        ]
    },
    "Ethiopia": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Ethiopia",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Ethiopia",
        "restriction": "Public",
        "NMA": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Ethiopia/NMA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "NMA",
            "restriction": "requires dlauth tokens"
        },
        "WASPqueries": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WASPqueries",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "countryquerylong_name": "country info",
                "Conventions": "IRIDL"
            },
            "provincequery": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "provincequery",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "province": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "province",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Province info",
                    "units": "ids",
                    "PGtype": "varchar"
                }
            },
            "paENACTSlast_WASP12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "paENACTS-last_WASP12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Province-Average ENACTS 12-Month WASP",
                "scale_max": "2.5",
                "scale_min": "-2.5",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Boxes with less than 0.0% dropped",
                "ncolor": "254",
                "CS": "-3.5",
                "colorscalename": "std_wasp_colors",
                "CE": "3.5",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "pabaseline_full": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "pabaseline_full",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Province-Average ENACTS 12-Month WASP Baseline",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                "ncolor": "254",
                "colorscalename": "std_wasp_colors",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "districtquery": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "districtquery",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "district": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "district",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "District info",
                    "units": "ids",
                    "PGtype": "varchar"
                }
            },
            "daENACTSlast_WASP12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daENACTS-last_WASP12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "District-Average ENACTS 12-Month WASP",
                "scale_max": "2.5",
                "scale_min": "-2.5",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Boxes with less than 0.0% dropped",
                "ncolor": "254",
                "CS": "-3.5",
                "colorscalename": "std_wasp_colors",
                "CE": "3.5",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "dabaseline_full": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dabaseline_full",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "District-Average ENACTS 12-Month WASP Baseline",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                "ncolor": "254",
                "colorscalename": "std_wasp_colors",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "countryquery": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "countryquery",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "cntry_name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cntry_name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "PGtype": "varchar"
                }
            },
            "caENACTSlast_WASP12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "caENACTS-last_WASP12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Country-Average ENACTS 12-Month WASP",
                "scale_max": "2.5",
                "scale_min": "-2.5",
                "missing_value": "NaN",
                "history": "Boxes with less than 0.0% dropped",
                "units": "unitless",
                "ncolor": "254",
                "CS": "-3.5",
                "colorscalename": "std_wasp_colors",
                "CE": "3.5",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "cabaseline_full": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "cabaseline_full",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Country-Average ENACTS 12-Month WASP Baseline",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                "ncolor": "254",
                "colorscalename": "std_wasp_colors",
                "maxncolor": "254",
                "colormap": "360960"
            },
            "prov_na": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "prov_na",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "2",
                "units": "ids"
            },
            "province": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "province",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "2",
                "units": "ids"
            },
            "dist_na": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dist_na",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "2",
                "units": "ids"
            },
            "district": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "district",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "2",
                "units": "ids"
            },
            "country": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "country",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "0",
                "pointwidth": "0",
                "units": "ids"
            },
            "BaseYears": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "BaseYears",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0"
            },
            "Baseline": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Baseline",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "1",
                "modulo": "12.0",
                "modulus": "12.0",
                "calendar": "360",
                "pointwidth": "1.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0"
            },
            "dir": "SOURCES/Ethiopia/WASPqueries"
        },
        "wasp_functions": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "wasp_functions",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Conventions": "IRIDL"
            },
            "ENACT1210_WASP12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ENACT-1210_WASP12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "3.5",
                "ncolor": "254",
                "scale_min": "-3.5",
                "CS": "-3.5",
                "colorscalename": "std_wasp_colors",
                "CE": "3.5",
                "maxncolor": "254",
                "colormap": "360960",
                "long_name": "ENACT-1210_WASP12",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Averaged over T[Jan, Dec] minimum 0.0% data present"
            },
            "ENACT1210_lag_WASP12": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ENACT-1210_lag_WASP12",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "3.5",
                "ncolor": "254",
                "scale_min": "-3.5",
                "CS": "-3.5",
                "colorscalename": "std_wasp_colors",
                "CE": "3.5",
                "maxncolor": "254",
                "colormap": "360960",
                "long_name": "ENACT-1210_WASP12",
                "missing_value": "NaN",
                "units": "unitless",
                "history": "Averaged over T[Jan, Dec] minimum 0.0% data present"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "0.09999999"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "pointwidth": "12.0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "standard_name": "longitude",
                "pointwidth": "0.1"
            },
            "mylag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "mylag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/Ethiopia/wasp_functions"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "NMA",
            "WASPqueries",
            "wasp_functions"
        ]
    },
    "FAO": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "FAO",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NRMEDSDClimateDerivedlong_name": "Derived Climate Products",
            "NRMEDSDdescription": "Sustainable Development",
            "NRMEDdescription": "Natural Resources Management and Environment Department",
            "NRMEDNRMED_Home": "http://www.fao.org/nr/index_en.htm",
            "GeoNetworkagrometeorologicalETdeg0p5edition1c6190source": ">FAO</a>",
            "GeoNetworkagrometeorologicalETdeg0p5edition1c6190FAO_GeoNetwork": "http://www.fao.org/geonetwork/srv/en/main.home",
            "GeoNetworkagrometeorologicalETdeg0p5edition1c6190history": "prepared according to the FAO Penman-Monteith method from University of East Anglia Climate Research Unit CRU CL 1.0 climate dataset, 1961-1990",
            "GeoNetworkagrometeorologicalETdeg0p5edition1c6190dataset_documentation": "http://www.fao.org/geonetwork/srv/en/metadata.show?id=5017&currTab=simple",
            "description": "Food and Agriculture Organization",
            "iridlhasSemantics": "iridl:FAO",
            "Conventions": "IRIDL",
            "FAO_Home": "http://www.fao.org/"
        },
        "NRMED": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NRMED",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Climate": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Climate",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Derived": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Derived",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "_class": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "class",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "maxncolor": "51",
                            "colormap": "708330",
                            "scale_max": "48.0",
                            "ncolor": "51",
                            "scale_min": "1.0",
                            "CE": "48",
                            "CS": "1",
                            "missing_value": "-999.0",
                            "iridlhasSemantics": "iridl:Classification",
                            "long_name": "Koeppen Climate Classification",
                            "CLIST": "Dry BWk\\'"
                        }
                    }
                }
            }
        },
        "GeoNetwork": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GeoNetwork",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "agrometeorological": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "agrometeorological",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ET": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ET",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "deg0p5": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "deg0p5",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "edition1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "edition1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "c6190": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c6190",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "etref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "etref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_factor": "0.1",
                                    "units": "mm/day",
                                    "long_name": "reference evapotranspiration",
                                    "missing_value": "-9999",
                                    "modulo": "12.0",
                                    "modulus": "12.0",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    }
                }
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "dir": "SOURCES/FAO"
    },
    "FSU": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "FSU",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SMOOTH4yrFULLdescription": "Anomalies from SMOOTH4yr ANOM plus mean values",
            "SMOOTH4yrANOMdescription": "Spatial and temporal smoothing of FSU 4yr ANOM",
            "SMOOTH4yrdescription": "Spatial and temporal smoothing of FSU monthly wind stress data",
            "FULLdescription": "Full wind speeds",
            "DETRENDEDSMOOTHFULLdescription": "Detrended and smoothed FSU wind stress data",
            "DETRENDEDSMOOTHdescription": "Detrended and smoothed FSU wind stress data",
            "DETRENDEDFULLdescription": "Detrended FSU wind stress data",
            "DETRENDEDCLIMATOLOGYdescription": "Detrended FSU wind stress climatological data",
            "DETRENDEDANOMdescription": "Detrended FSU wind stress anomalies",
            "DETRENDEDdescription": "Detrended FSU wind stress data",
            "DETRENDEDsource": "FSU winds detrended according to Neil Ward",
            "CLIMATOLOGYdescription": "Climatology used in computing anomalies",
            "ANOMdescription": "Raw wind stress data from FSU converted to anomalies by subtraction of the climatology",
            "yrANOMdescription": "The monthly wind stress anomaly relative to the four year running mean",
            "yrdescription": "Monthly wind stress anomaly relative to the four year running mean",
            "description": "Florida State University wind analysis",
            "Conventions": "IRIDL",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.FSU/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:FSU",
            "references": "Legler_OBrien1988"
        },
        "SMOOTH4yr": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SMOOTH4yr",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "FULL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "FULL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                }
            },
            "ANOM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ANOM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2"
                }
            }
        },
        "FULL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "FULL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "missing_value": "NaN",
                "file_missing_value": "999.0"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "missing_value": "NaN",
                "file_missing_value": "999.0"
            },
            "absuv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind pseudo-stress",
                "units": "m2/s2",
                "missing_value": "999.0"
            },
            "absuu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind pseudo-stress",
                "units": "m2/s2",
                "missing_value": "999.0"
            }
        },
        "DETRENDED": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DETRENDED",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "SMOOTH": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SMOOTH",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "FULL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FULL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tauy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tauy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "meridional wind stress",
                        "units": "dynes/cm2",
                        "missing_value": "19.98"
                    },
                    "taux": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "taux",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "zonal wind stress",
                        "units": "dynes/cm2",
                        "missing_value": "19.98"
                    }
                }
            },
            "FULL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "FULL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "NaN",
                    "file_missing_value": "999.0"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "NaN",
                    "file_missing_value": "999.0"
                },
                "absuv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "absuv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind pseudo-stress",
                    "units": "m2/s2",
                    "missing_value": "999.0"
                },
                "absuu": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "absuu",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind pseudo-stress",
                    "units": "m2/s2",
                    "missing_value": "999.0"
                }
            },
            "CLIMATOLOGY": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CLIMATOLOGY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                }
            },
            "ANOM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ANOM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2",
                    "missing_value": "19.98"
                }
            }
        },
        "CLIMATOLOGY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CLIMATOLOGY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2",
                "missing_value": "19.98"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2",
                "missing_value": "19.98"
            }
        },
        "ANOM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ANOM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "tauy": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "tauy",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional wind stress",
                "units": "dynes/cm2"
            },
            "taux": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "taux",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal wind stress",
                "units": "dynes/cm2"
            }
        },
        "yr": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "4yr",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ANOM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ANOM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tauy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tauy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind stress",
                    "units": "dynes/cm2"
                },
                "taux": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "taux",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind stress",
                    "units": "dynes/cm2"
                }
            }
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "dir": "SOURCES/FSU"
    },
    "FUNCEME": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "FUNCEME",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Tropical_Atlanticmonthlydescription": "Monthly sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticclimatologyc6403description": "Climatological sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticclimatologyc6403iridlhasSemantics": "iridl:climatology",
            "Tropical_Atlanticclimatologyc6403long_name": "1964-2003 Climatology",
            "Tropical_Atlanticdescription": "Sea surface temperature and wind pseudo-stress data for the tropical Atlantic Ocean",
            "Tropical_Atlanticdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.FUNCEME/.Tropical_Atlantic.dataset_documentation.html",
            "description": "Funda&#231;&#227;o Cearense de Meteorologia e Recursos H&#237;dricos",
            "iridlhasSemantics": "iriref:Durand_B",
            "Conventions": "IRIDL"
        },
        "Tropical_Atlantic": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Tropical_Atlantic",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "5.0",
                    "scale_min": "-5.0",
                    "units": "degree_Celsius",
                    "long_name": "sea surface temperature anomaly",
                    "missing_value": "9999.7998"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "31.5",
                    "scale_min": "0.0",
                    "units": "Celsius_scale",
                    "long_name": "sea surface temperature",
                    "missing_value": "9999.7998"
                },
                "pwsyanom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsyanom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "63.0",
                    "scale_min": "-78.0",
                    "units": "m2/s2",
                    "long_name": "meridional wind pseudo-stress anomaly",
                    "missing_value": "9999.7998"
                },
                "pwsy": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsy",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "123.0",
                    "scale_min": "-106.0",
                    "units": "m2/s2",
                    "long_name": "meridional wind pseudo-stress",
                    "missing_value": "9999.7998"
                },
                "pwsxanom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsxanom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "122.0",
                    "scale_min": "-100.0",
                    "units": "m2/s2",
                    "long_name": "zonal wind pseudo-stress anomaly",
                    "missing_value": "9999.7998"
                },
                "pwsx": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pwsx",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "123.0",
                    "scale_min": "-132.0",
                    "units": "m2/s2",
                    "long_name": "zonal wind pseudo-stress",
                    "missing_value": "9999.7998"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "c6403": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "c6403",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "29.5",
                        "scale_min": "13.0",
                        "units": "degree_Celsius",
                        "long_name": "sea surface temperature",
                        "missing_value": "9999.7998"
                    },
                    "pwsy": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pwsy",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "60.0",
                        "scale_min": "-70.0",
                        "units": "m2/s2",
                        "long_name": "meridional wind pseudo-stress",
                        "missing_value": "9999.7998"
                    },
                    "pwsx": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pwsx",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "27.0",
                        "scale_min": "-90.0",
                        "units": "m2/s2",
                        "long_name": "zonal wind pseudo-stress",
                        "missing_value": "9999.7998"
                    }
                }
            }
        },
        "Nordeste": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Nordeste",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "daily": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "daily",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "station": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "station",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PCPN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PCPN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-1.0",
                        "units": "mm",
                        "long_name": "Precipitation"
                    },
                    "Name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-42.0",
                        "scale_max": "-37.5",
                        "units": "degree_east",
                        "long_name": "longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-8.0",
                        "scale_max": "-2.5",
                        "units": "degree_north",
                        "long_name": "latitude"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "units": "m",
                        "long_name": "Elevation"
                    }
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "STNID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "long_name": "Station"
        },
        "dir": "SOURCES/FUNCEME"
    },
    "Features": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Features",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Features",
        "restriction": "Public",
        "Agricultural": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Agricultural",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "WFPdescription": " Livelihood Zones in Mali from WFP",
                "SriLanka_agridescription": " Agricultural Zones in Sri Lanka",
                "PhilippinesBicolsoilTypedescription": "Soil Types",
                "PhilippinesBicollandCoverdescription": "Land Cover",
                "PhilippinesBicoldescription": "Bicol Agricultural Information",
                "PhilippinesBicoliridlhasSemantics": "irigaz:Philippines_119_1",
                "Mali_agriLivelihood_Mali_2010description": "Livelihood Zones in Mali 2010",
                "Mali_agriLivelihood_Mali_2005description": "Livelihood Zones in Mali 2005",
                "EmbrapaBrazilRio_Grande_do_Sulsolos_tipodescription": "Tipo Solos Rio Grande do Sul",
                "EmbrapaBrazilRio_Grande_do_Sulsolosdescription": "Solos Rio Grande do Sul",
                "EmbrapaBrazilRio_Grande_do_Suljoindescription": "Join Rio Grande do Sul",
                "EmbrapaBrazilRio_Grande_do_Sularea_tipodescription": "Area Tipo Rio Grande do Sul",
                "Colombia_soilsdescription": " Soil types of Colombia",
                "Africa_agriculturedescription": " Agricultural Zones in Africa",
                "Africa_agriculturedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Agricultural/.Africa_agriculture.dataset_documentation.html",
                "Africa_agricultureiridlhasSemantics": "irigaz:Africa_3327_1",
                "description": " Agricultural zones",
                "Conventions": "IRIDL"
            },
            "WFP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WFP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Livelihood_Mali_PAM_SAP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Livelihood_Mali_PAM_SAP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "libelle_zo": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "libelle_zo",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Libelle Zone",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code_zone": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code_zone",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "8",
                        "maxncolor": "11",
                        "ncolor": "11",
                        "scale_min": "1",
                        "CS": "1",
                        "CE": "8",
                        "CLIST": "Bamako",
                        "long_name": "Zone Code",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "Livelihood_Mali": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Livelihood_Mali",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zonage_sap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zonage_sap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zonage SAP",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "orig_fid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "orig_fid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "11",
                        "maxncolor": "15",
                        "ncolor": "15",
                        "scale_min": "0",
                        "CS": "0",
                        "CE": "11",
                        "CLIST": "Salariat-commerce (Ville)",
                        "long_name": "Original File ID",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                }
            },
            "SriLanka_agri": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SriLanka_agri",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Agri_zones": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Agri_zones",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zone1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zone1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone Type, Rainfall, Elevation",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "zone": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zone",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Rainfall Zone",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Agricultural zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone Type, Rainfall, Elevation, Soils",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "rain75": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rain75",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Rainfall amount",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Perimeter",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone Code",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "agroeco_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "agroeco_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Agro Eco id",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "agroeco_": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "agroeco_",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Agro Eco",
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                }
            },
            "Philippines": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Philippines",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Bicol": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Bicol",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "soilType": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soilType",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Soil Type Geometries",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "soildesc": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soildesc",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Soil Description",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "soilcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "soilcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Soil Code",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "philbuo_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "philbuo_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Phillipines buoID",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "philbuo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "philbuo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Phillipines buo",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "ph": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ph",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "landCover": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "landCover",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Land Cover Geometries",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "perimeter": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "perimeter",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Perimeter",
                            "units": "km",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "ID",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "hectares": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hectares",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Area",
                            "units": "hectare",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        },
                        "envi_lmu_i": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "envi_lmu_i",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Environment lmu i",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "desc3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "desc3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Description",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "desc2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "desc2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Description",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "desc1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "desc1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Description",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "count": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "count",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "area": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "area",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Area",
                            "units": "m2",
                            "missing_value": "NaN",
                            "PGtype": "float8"
                        }
                    }
                }
            },
            "Mali_agri": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Mali_agri",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Livelihood_Mali_2010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Livelihood_Mali_2010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "lznum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "13.0",
                        "maxncolor": "16",
                        "ncolor": "16",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "13",
                        "CLIST": "Bamako urban",
                        "long_name": "Livelihood Number",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lznamef": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznamef",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood-French",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lznamee": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznamee",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood-English",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lzcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lzcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "country": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "_class": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "class",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood Class",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Livelihood_Mali_2005": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Livelihood_Mali_2005",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "lznum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "11.0",
                        "maxncolor": "14",
                        "ncolor": "14",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "11",
                        "CLIST": "Rainfed millet/sorghum/fruits",
                        "long_name": "Livelihood Number",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lznamef": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznamef",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood-French",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lznamee": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lznamee",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Livelihood-English",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "gavprimary": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gavprimary",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "GAV Primary",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "cccode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cccode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CC Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                }
            },
            "Embrapa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Embrapa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Brazil": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Brazil",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Rio_Grande_do_Sul": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Rio_Grande_do_Sul",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "solos_tipo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "solos_tipo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tipo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tipo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Tipo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "textura": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "textura",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Textura",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "solos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "solos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Solos",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "solo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "solo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Solo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "sbcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sbcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "sbcs",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "codigo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "codigo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Codigo",
                                "units": "ids",
                                "PGtype": "varchar"
                            }
                        },
                        "solos": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "solos",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "textura": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "textura",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Textura",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "simbolo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simbolo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Simbolo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "sibcs_desc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sibcs_desc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "SIBCS Description",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "nova_leg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nova_leg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Nova leg",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "nivel1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nivel1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Nivel 1",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "n_3_sibcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_3_sibcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "nome 3 SIBCS",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "n_3_sibc_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_3_sibc_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "nome 3 SIBC 1",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "n_2_sibcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n_2_sibcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "nome 2 SIBCS",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "fid_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "fid_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "FID 1",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "comp_3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "comp_3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "COMP 3",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "comp_2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "comp_2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "COMP 2",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "comp_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "comp_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "COMP 1",
                                "units": "ids",
                                "PGtype": "varchar"
                            }
                        },
                        "join": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "join",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tipo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tipo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Tipo",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "textura": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "textura",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Textura",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "solos": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "solos",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Solos",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "solo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "solo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Solo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "sbcs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sbcs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "sbcs",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "r": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "r",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "r",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "pct": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pct",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "pct",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "p": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "p",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "p",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "n19": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n19",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "N 19",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "n18": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "n18",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "N 18",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "m",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "legenda_1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "legenda_1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Legenda 1",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "legenda": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "legenda",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Legenda",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "id1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "id1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "ID 1",
                                "units": "unitless",
                                "PGtype": "int4"
                            },
                            "i": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "i",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "i",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "edafica": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "edafica",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Edafica",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "codigo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "codigo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Codigo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "autonumber": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "autonumber",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Autonumber",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "aptidxc3xa3o": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aptid\\xc3\\xa3o",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Aptid\\xc3\\xa3o",
                                "units": "ids",
                                "PGtype": "varchar"
                            }
                        },
                        "area_tipo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "area_tipo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "xc3x81rea": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "\\xc3\\x81rea",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "\\xc3\\x81rea",
                                "missing_value": "NaN",
                                "units": "unitless",
                                "PGtype": "float8"
                            },
                            "tipo": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tipo",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Tipo",
                                "units": "ids",
                                "PGtype": "varchar"
                            },
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "area_ha": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "area_ha",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Area",
                                "units": "hectare",
                                "missing_value": "NaN",
                                "PGtype": "float8"
                            }
                        }
                    }
                }
            },
            "Colombia_soils": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Colombia_soils",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Soils_Colombia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Soils_Colombia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "soil type geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "ord": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ord",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "ORD",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                }
            },
            "Africa_agriculture": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Africa_agriculture",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Agri_zones": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Agri_zones",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zone_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zone_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Agricultural zone index",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Agricultural zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "sq_km": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sq_km",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone area sq_km",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone perimeter",
                        "units": "m",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "descrip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "descrip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone type description",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code_fs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code_fs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "14",
                        "maxncolor": "17",
                        "ncolor": "17",
                        "scale_min": "1",
                        "CS": "1",
                        "CE": "14",
                        "CLIST": "Coastal artisanal fishing",
                        "long_name": "Zone type code",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                }
            },
            "gid_11": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_11",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_10": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_10",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "theid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "theid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/Features/Agricultural"
        },
        "Climatological": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Climatological",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Vietnam_climatedescription": "Climate Zones in Vietnam",
                "Vietnam_climatedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Climatological/.Vietnam_climate.dataset_documentation.html",
                "Vietnam_climateiridlhasSemantics": "iridl:Vietnam",
                "US_climate_regionsdescription": " Climate Regions in the U.S.",
                "US_climate_regionsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Climatological/.US_climate_regions.dataset_documentation.html",
                "US_climate_regionsiridlhasSemantics": "irigaz:United_States_156_1",
                "US_climatedescription": " Climate divisions in the U.S.",
                "US_climatedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Climatological/.US_climate.dataset_documentation.html",
                "US_climateiridlhasSemantics": "irigaz:United_States_156_1",
                "SriLanka_climatedescription": " Climate zones in Sri Lanka",
                "SriLanka_climatedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Climatological/.SriLanka_climate.dataset_documentation.html",
                "SriLanka_climateiridlhasSemantics": "irigaz:Sri_Lanka_136_1",
                "Ethiopia_climatedescription": "Ethiopia Rainfall Climate Zones",
                "Ethiopia_climatedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Climatological/.Ethiopia_climate.dataset_documentation.html",
                "Ethiopia_climateiridlhasSemantics": "iridl:Ethiopia_49_1",
                "description": " Climate zones",
                "Conventions": "IRIDL"
            },
            "Vietnam_climate": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Vietnam_climate",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Climate_Zones_Vietnam": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Climate_Zones_Vietnam",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "clim_zone_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clim_zone_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone ID",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                }
            },
            "US_climate_regions": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "US_climate_regions",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Region Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                }
            },
            "US_climate": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "US_climate",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Divisions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Divisions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "State-Climate Div. geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "st": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "st",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "State",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "div_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "div_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name of Climate Div. within a state",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "div_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "div_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Index of Climate Div. within a state",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                }
            },
            "SriLanka_climate": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SriLanka_climate",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Czones": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Czones",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone index",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "czone": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "czone",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                }
            },
            "Ethiopia_climate": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia_climate",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "eth_clim": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eth_clim",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "clim_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clim_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "clim_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "clim_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate Zone ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                }
            },
            "gid_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "region_name": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "region_name",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "gridtype": "2",
                "long_name": "Climate Region Name",
                "units": "ids"
            },
            "division_i": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "division_i",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "long_name": "Unique State-Climate Div. index"
            },
            "gid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/Features/Climatological"
        },
        "Epidemiological": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Epidemiological",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "VCAPmergeddescription": " Vectoral Capacity Epidemic map for Africa as one geometry",
                "VCAPdescription": " Vectoral Capacity Epidemic map for Africa",
                "Malariadescription": " Risk map for malaria in Africa",
                "Malariadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Epidemiological/.Malaria.dataset_documentation.html",
                "MalariairidlhasSemantics": "irigaz:Africa_3327_1",
                "description": " Risk maps",
                "Conventions": "IRIDL"
            },
            "VCAPmerged": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "VCAPmerged",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "epidemic_map": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "epidemic_map",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                }
            },
            "VCAP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "VCAP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "epidemic_map": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "epidemic_map",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                }
            },
            "Malaria": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Malaria",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Risk_map": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Risk_map",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                }
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "id": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "id",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/Features/Epidemiological"
        },
        "Hydrological": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Hydrological",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Riversdescription": " Rivers of the World",
                "Riversdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Hydrological/.Rivers.dataset_documentation.html",
                "River_BasinsUpper_Colo_basindescription": "Upper Colorado River Basin",
                "River_BasinsIransubbasinsdescription": "Iran Sub River Basins",
                "River_BasinsIranbasinsdescription": "Iran River Basins",
                "River_BasinsEth_sub_basinsdescription": "River Sub Basins in Ethiopia",
                "River_BasinsEth_River_Basinsdescription": "River Basins in Ethiopia",
                "River_Basinsdescription": "River Basins of the World",
                "River_Basinsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Hydrological/.River_Basins.dataset_documentation.html",
                "PhilippinesWatershedsdescription": "Watersheds of the Philippines",
                "PhilippinesRiversdescription": "Rivers of the Philippines",
                "PhilippinesLakesdescription": "Lakes of the Philippines",
                "PeruSubBasinsdescription": "GR2M Sub-Basins of Peru",
                "Lakes_level1description": "Global Lakes and Wetlands Database Boundaries",
                "Lakesdescription": " Lakes of the World",
                "Lakesdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Hydrological/.Lakes.dataset_documentation.html",
                "description": " Rivers, Streams, Lakes, Drainage Basins",
                "iridlhasSemantics": "iridl:Global",
                "Conventions": "IRIDL"
            },
            "Rivers": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Rivers",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MajorRivers": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MajorRivers",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTILINESTRING",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "system": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "system",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "River System name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "r_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "r_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "River name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                }
            },
            "River_Basins": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "River_Basins",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Upper_Colo_basin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Upper_Colo_basin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Basin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Basin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "ext_typ_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ext_typ_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "ext_id": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ext_id",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "basin_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "Upper_Blue_Nile": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Upper_Blue_Nile",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "Sri_Lanka_Sub_Catchments": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sri_Lanka_Sub_Catchments",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "name_sub": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_sub",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "basin_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "basin_": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin_",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "Sri_Lanka_River_Basins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sri_Lanka_River_Basins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "name_sub": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_sub",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "basin_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "LaPlata_basin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "LaPlata_basin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "gridcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gridcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                },
                "Iran": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Iran",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "subbasins": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "subbasins",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "mantaghe": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mantaghe",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int2"
                        },
                        "linkcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "linkcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Link Code",
                            "units": "unitless",
                            "PGtype": "int2"
                        },
                        "code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Code",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        }
                    },
                    "basins": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basins",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "hozeh6": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hozeh6",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        },
                        "count": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "count",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Count",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        }
                    }
                },
                "GTN_River_Basins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GTN_River_Basins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "subbas_num": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "subbas_num",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "in_out": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "in_out",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "gtn_r_sta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gtn_r_sta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "drainage": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "drainage",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "basin_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "basin_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "area_calc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area_calc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "Eth_sub_basins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Eth_sub_basins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Sub_Basins": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sub_Basins",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "sqkm": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sqkm",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "etwshed0_1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "etwshed0_1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "etwshed01c": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "etwshed01c",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "basin_nr": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin_nr",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int2"
                        },
                        "basin_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "basin_cod": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin_cod",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "basin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    }
                },
                "Eth_River_Basins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Eth_River_Basins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Basins": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Basins",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "short_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "short_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "basin_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "basin_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "area_km2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "area_km2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "PGtype": "float8"
                        }
                    }
                }
            },
            "Philippines": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Philippines",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Watersheds": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Watersheds",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wfp_waters": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wfp_waters",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "WFP Waters",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "leng": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "leng",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Perimeter",
                        "units": "km",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "first_leve": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "first_leve",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "First Level",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "ave_treeco": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ave_treeco",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Average Tree Cover",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    }
                },
                "Rivers": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Rivers",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tile_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tile_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Tile ID",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTILINESTRING",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nam": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nam",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "leng": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "leng",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Length",
                        "units": "km",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "hyc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hyc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "globalid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "globalid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Global ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "fac_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fac_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "fac ID",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "f_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "f_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "F Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Lakes": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Lakes",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "type_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "type_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Type Code",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "Type": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Type",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Type",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "swb_flag": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "swb_flag",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Flag",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "src_rank": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "src_rank",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Rank",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "src_layer": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "src_layer",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Layer",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "leng": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "leng",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Perimeter",
                        "units": "km",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "code_flag": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code_flag",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Code Flag",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    }
                }
            },
            "Peru": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Peru",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "SubBasins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SubBasins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "Region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    }
                }
            },
            "Lakes_level1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Lakes_level1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Lakes": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Lakes",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "lake_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lake_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                }
            },
            "Lakes": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Lakes",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MajorLakes": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MajorLakes",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "surf_elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "surf_elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Surface Elevation",
                        "units": "feet",
                        "PGtype": "int4"
                    },
                    "sqmi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sqmi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area sqmi",
                        "units": "mile2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "sqkm": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sqkm",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area sqkm",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "l_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "l_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "depth": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "depth",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Depth",
                        "units": "feet",
                        "PGtype": "int4"
                    }
                }
            },
            "gid_09": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_09",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_08": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_08",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "basin_": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "basin_",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_07": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_07",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "0"
            },
            "gid_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "objectid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "objectid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0"
            },
            "objectid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "objectid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0"
            },
            "uniq_id": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "uniq_id",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0"
            },
            "gid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "glwd_id": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "glwd_id",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/Features/Hydrological"
        },
        "Political": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Features/Political",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "Political",
            "restriction": "Public",
            "Africa": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Africa",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Africa 1st and 2nd Order Administrative Boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Africa/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "country_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Prov_SALB_2008": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Prov_SALB_2008",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dist_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "country_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "feature_id_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "feature_id_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "feature_id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "feature_id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Africa"
            },
            "Bangladesh": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Bangladesh",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Banglades Division, District, and Upazilla Admin. boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Bangladesh/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Upazillas": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Upazillas",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "type_3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "type_3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Admin level 3 Type",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Upazilla Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name_3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Upazilla Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "id_3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Upazilla id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "cc_3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cc_3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Upazila CC",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Divisions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Divisions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "coastal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "coastal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Coastal",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "id_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "divcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "divcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division code",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "dis_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dis_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District code",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "coastal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "coastal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Coastal",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Bangladesh"
            },
            "Bihar": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Bihar",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Admin2 geometry",
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "label": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "label",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Label",
                    "units": "ids",
                    "PGtype": "text"
                },
                "adm2_name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm2_name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Admin Level2 Name",
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Bihar"
            },
            "Botswana": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Botswana",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "15,16, and 17 Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Botswana/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Botswana_18_1",
                    "Conventions": "IRIDL"
                },
                "Districts17": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts17",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "Districts16": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts16",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "Districts15": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts15",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "epidemio": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "epidemio",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Epidemiological Districts",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "districts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "districts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Political Districts",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "idr_id_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "idr_id_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "IDR id",
                    "pointwidth": "1.0"
                },
                "idr_id_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "idr_id_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "IDR id",
                    "pointwidth": "1.0"
                },
                "idr_id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "idr_id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "IDR id",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Botswana"
            },
            "Brazil": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Brazil",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Municipios",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Brazil/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Brazil_19_1",
                    "Conventions": "IRIDL"
                },
                "Municipios": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Municipios",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipio geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nome": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nome",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipio name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "muni6": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "muni6",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipio code - 6 digit",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "municode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "municode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Brazil"
            },
            "BurkinaFaso": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "BurkinaFaso",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Health Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.BurkinaFaso/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Burkina_Faso_22_1",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "grp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Abbrev.",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Health_Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Health_Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "sqkm": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sqkm",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "namemaj": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "namemaj",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District name in caps",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "LVL id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "h_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "h_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "amap11": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "amap11",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "AMAP 11 code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/BurkinaFaso"
            },
            "CentralWestAfrica": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CentralWestAfrica",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Regions",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.CentralWestAfrica/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Africa_West_302_0",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "neww": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "neww",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region name abbrev.",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "country": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/CentralWestAfrica"
            },
            "Chile": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Chile",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Chile Admin boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Chile/.dataset_documentation.html",
                    "iridlhasSemantics": "iridl:Chile_31_1",
                    "Conventions": "IRIDL"
                },
                "admin3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "admin3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Distrito geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "com_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "com_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Commun Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Distrito Area",
                        "units": "m^2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "admin3_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin3_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Distrito Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "a_homog": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "a_homog",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Homog Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "admin2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "admin2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Provincia geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "admin2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Provincia Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "admin1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "admin1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "admin1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "distripol1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "distripol1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "pro10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pro10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "reg10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "reg10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Chile"
            },
            "Colombia": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Colombia",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Districtsdescription": "Municipios",
                    "Departamentosdescription": "Departamentos",
                    "description": "Departamentos and Municipios",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Colombia/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Colombia_33_1",
                    "Conventions": "IRIDL"
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nom_muni": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nom_muni",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipio/District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "departamen": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "departamen",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Departamento/State name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "codmu": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "codmu",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipio/District Code",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Departamentos": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Departamentos",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "departamen": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "departamen",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Departamento/State name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "dane": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dane",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Colombia"
            },
            "Colombia_CIAT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Colombia_CIAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "CIAT provided admin boundaries",
                    "Conventions": "IRIDL"
                },
                "States": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "States",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "adm1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Municipalities": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Municipalities",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "adm2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "adm1_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm1_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "adm2_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm2_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Colombia_CIAT"
            },
            "CotedIvoire": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CotedIvoire",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Regions",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.CotedIvoire/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Cote_d_Ivoire_75_1",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "grp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Group Abbrev.",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "count": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "count",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Count",
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/CotedIvoire"
            },
            "Eritrea": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Eritrea",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Ministry of Health Sub Zobas",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Eritrea/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Eritrea_47_1",
                    "Conventions": "IRIDL"
                },
                "MOH_SubZobas": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MOH_SubZobas",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zonename_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zonename_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "zonecode_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zonecode_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ministry of Health Sub-Zoba geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "mohname_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mohname_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ministry of Health Sub-Zoba name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "mohcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mohcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ministry of Health Sub-Zoba code",
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                },
                "mohcode_2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mohcode_2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "Ministry of Health Sub-Zoba code"
                },
                "dir": "SOURCES/Features/Political/Eritrea"
            },
            "Ethiopia": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Zones, Sub-Zones/Woderas",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Ethiopia/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Ethiopia_49_1",
                    "Conventions": "IRIDL"
                },
                "Zones": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Zones",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zone_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zone_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "zid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Tigray_Wards": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Tigray_Wards",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "warname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "warname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "w_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "w_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "short": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "short",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Abbrev. Ward name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "SubZones": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sub-Zones",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wodera id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "w_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "w_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wodera name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Wodera/Sub-District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_r2i": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_r2i",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "ease_zonen": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ease_zonen",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ease Zone name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "ease_z4id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ease_z4id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ease Zone id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "ease_wored": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ease_wored",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ease Wodera name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "ease_w6id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ease_w6id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ease Wodera id",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Health_District": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Health_District",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zone_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zone_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Zone name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "wid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "W id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "h_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "h_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "h_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "h_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Health District id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "z4id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "z4id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "gridtype": "2",
                    "long_name": "Zone id",
                    "units": "ids"
                },
                "w6id_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w6id_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "gridtype": "2",
                    "long_name": "Ward id",
                    "units": "ids"
                },
                "w6id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "w6id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "Wodera id"
                },
                "id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "Health District id"
                },
                "dir": "SOURCES/Features/Political/Ethiopia"
            },
            "Ethiopia_adm1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia_adm1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Ethiopia 1st level of Administrative Boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Ethiopia_adm1/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Ethiopia_level1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Ethiopia_level1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "varname_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "varname_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "shape_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "regionbb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regionbb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region bbox",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "name_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "iso": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iso",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "hasc_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hasc_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "engtype_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "engtype_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "cc_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cc_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Ethiopia_adm1"
            },
            "Ethiopia_adm2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia_adm2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Ethiopia 2nd level of Administrative Boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Ethiopia_adm2/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Ethiopia_level2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Ethiopia_level2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "type_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "type_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "shape_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "regionbb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regionbb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region bbox",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "name_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "iso": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iso",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "id_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "cc_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cc_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Ethiopia_adm2"
            },
            "Ethiopia_adm3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia_adm3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Ethiopia 3rd level of Administrative Boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Ethiopia_adm3/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Ethiopia_level3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Ethiopia_level3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "regionbb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regionbb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region bbox",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "id_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "adm3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Ethiopia_adm3"
            },
            "Ethiopia_adm3_reduced": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Ethiopia_adm3_reduced",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Reduced set of Ethiopia 3rd level of Admin. Boundaries ",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Ethiopia_adm3_reduced/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Ethiopia_level3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Ethiopia_level3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "adm3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Ethiopia_adm3_reduced"
            },
            "Guatemala": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Guatemala",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GAULsecondOrder_GAULlong_name": "Second_Order_GAUL_Guatemala",
                    "GAULfirstOrder_GAULlong_name": "First_Order_GAUL_Guatemala",
                    "GAULCountries_GAULlong_name": "Countries_GAUL_Guatemala",
                    "GAULFirst_Order": "def",
                    "GAULCountries": "def",
                    "GAULSecond_Order": "def",
                    "Conventions": "IRIDL"
                },
                "GAUL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GAUL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "secondOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "secondOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin2 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm2_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "firstOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "firstOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin1 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "Countries_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Countries_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "adm0_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm0_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Guatemala"
            },
            "Honduras": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Honduras",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Honduras Municipalities",
                    "Conventions": "IRIDL"
                },
                "Municipalities": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Municipalities",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "mlabel": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mlabel",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Honduras"
            },
            "Humdata": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Humdata",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Zambiazmb_admbnda_adm2_2020description": "Zambia Admin Level 2 (humdata.org)",
                    "Zambiazmb_admbnda_adm1_2020description": "Zambia Admin Level 1 (humdata.org)",
                    "Zambiazmb_admbnda_adm0_2020description": "Zambia Admin Level 0 (humdata.org)",
                    "Madagascarmdg_admbnda_adm4_bngrc_ocha_20181031description": "Madagascar Admin Level 4 (humdata.org)",
                    "Madagascarmdg_admbnda_adm3_bngrc_ocha_20181031description": "Madagascar Admin Level 3 (humdata.org)",
                    "Madagascarmdg_admbnda_adm2_bngrc_ocha_20181031description": "Madagascar Admin Level 2 (humdata.org)",
                    "Madagascarmdg_admbnda_adm1_bngrc_ocha_20181031description": "Madagascar Admin Level 1 (humdata.org)",
                    "Madagascarmdg_admbnda_adm0_bngrc_ocha_20181031description": "Madagascar Admin Level 0 (humdata.org)",
                    "Conventions": "IRIDL"
                },
                "Zambia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Zambia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "zmb_admbnda_adm2_2020": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zmb_admbnda_adm2_2020",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "x": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "x",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "x",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm2_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "zmb_admbnda_adm1_2020": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zmb_admbnda_adm1_2020",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "zmb_admbnda_adm0_2020": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zmb_admbnda_adm0_2020",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "Madagascar": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Madagascar",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mdg_admbnda_adm4_bngrc_ocha_20181031": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mdg_admbnda_adm4_bngrc_ocha_20181031",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "source",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_code_": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_code_",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_code_",
                            "units": "unitless",
                            "PGtype": "int8"
                        },
                        "old_provin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "old_provin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "old_provin",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "notes": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "notes",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "notes",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm4_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm4_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm4_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm4_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm4_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm4_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm4_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm4_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm4_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm3_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm3_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm3_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "mdg_admbnda_adm3_bngrc_ocha_20181031": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mdg_admbnda_adm3_bngrc_ocha_20181031",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "source",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_code_": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_code_",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_code_",
                            "units": "unitless",
                            "PGtype": "int8"
                        },
                        "old_provin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "old_provin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "old_provin",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "notes": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "notes",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "notes",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm3_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm3_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm3_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm3_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm3_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "mdg_admbnda_adm2_bngrc_ocha_20181031": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mdg_admbnda_adm2_bngrc_ocha_20181031",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "source",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_code",
                            "units": "unitless",
                            "PGtype": "int8"
                        },
                        "old_provin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "old_provin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "old_provin",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "notes": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "notes",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "notes",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm2_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm2_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "mdg_admbnda_adm1_bngrc_ocha_20181031": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mdg_admbnda_adm1_bngrc_ocha_20181031",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "source",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "prov_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prov_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "prov_code",
                            "units": "unitless",
                            "PGtype": "int8"
                        },
                        "old_provin": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "old_provin",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "old_provin",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm1_type": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_type",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_type",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm1_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    },
                    "mdg_admbnda_adm0_bngrc_ocha_20181031": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mdg_admbnda_adm0_bngrc_ocha_20181031",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "the_geom",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "source": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "source",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "source",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "label",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_pcode": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_pcode",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_pcode",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_en": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_en",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "adm0_en",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "gid_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/Features/Political/Humdata"
            },
            "India": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "India",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Bihar_distBihar_dist": "district",
                    "description": "Districts and Provinces in India",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.India/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:India_68_1",
                    "Conventions": "IRIDL"
                },
                "Provinces_WHO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces_WHO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "provname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "LVL ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Province_WHO_disputed": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Province_WHO_disputed",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "provname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "India_K": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "India_K",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "state": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "state",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sate Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "pcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province code",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "name2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Provicne name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    }
                },
                "Bihar_dist": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Bihar_dist",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "state": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "state",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "State name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "objectid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "objectid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District code",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "district": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dcode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dcode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/India"
            },
            "Indonesia": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Indonesia",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Provinces and Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Indonesia/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Indonesia_69_1",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry_id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry_id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Indonesia"
            },
            "MVPSites": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MVPSites",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Earth Institute Millennium Villages",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.MVPSites/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "MillenniumVillages": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MillenniumVillages",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "village": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "village",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Village Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Village point geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "POINT",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/MVPSites"
            },
            "Madagascar": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Madagascar",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SubDistrictsdescription": "Delimitations administratives Communes Madagascar",
                    "Regionsdescription": "Delimitations administratives Regions Madagascar",
                    "Provincesdescription": "Delimitations administratives Provinces Madagascar",
                    "ProvincesProvinces": "description",
                    "Districtsdescription": "Delimitations administratives Districts Madagascar",
                    "description": "Delimitations administratives Madagascar",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Madagascar/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Madagascar_94_1",
                    "Conventions": "IRIDL"
                },
                "SubDistricts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SubDistricts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nomprov": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomprov",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "nomdist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomdist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "nomcomm": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomcomm",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "codefiv": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "codefiv",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "codefar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "codefar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nomreg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomreg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "nomprov": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomprov",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "fir_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fir_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "fir": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fir",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "codefar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "codefar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "p_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "p_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "LVL ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "nomprov": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomprov",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "nomdist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nomdist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "fir_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fir_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "fir": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fir",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "codefar": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "codefar",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "codefir": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "codefir",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "codefiv_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "codefiv_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "codefiv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "codefiv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Madagascar"
            },
            "Mali": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Mali",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Health Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Mali/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "grp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "grp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Group abbrev.",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Health_Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Health_Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "LVL id",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "d_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "d_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dist_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Mali"
            },
            "Nepal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Nepal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Nepal_districtsdescription": "Nepal Districts from maplibrary.org",
                    "iridlhasSemantics": "iridl:Nepal",
                    "Conventions": "IRIDL"
                },
                "Nepal_districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Nepal_districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "the_geom",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Admin level 1",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "mm_uid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mm_uid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "mm u ID",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "division": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "division",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Division",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Nepal"
            },
            "Nepal_Prov": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Nepal_Prov",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Nepal Provinces from Francis Colledge, UK Metoffice 2020",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "state_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "state_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Nepal_Prov"
            },
            "Niger": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Niger",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Districtsdescription": "Niger District Boundaries",
                    "Districtsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Niger/.Districts.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dist_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "idr_id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "idr_id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Niger"
            },
            "Nigeria": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Nigeria",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Districts",
                    "iridlhasSemantics": "irigaz:Nigeria_111_1",
                    "Conventions": "IRIDL"
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Admin Lev 2 geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "pop_9798": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pop_9798",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Population 1998-97",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "pop_90": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pop_90",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Population 1990",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "oldvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "oldvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Old LVL ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "oldlvlid2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "oldlvlid2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Old LVL ID2",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "lvlid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lvlid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "LVL ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dens90": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dens90",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Density 1990",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "admin2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Admin Lev 2 Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Admin Lev 1 Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Nigeria"
            },
            "Pakistan": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Pakistan",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Pakistan/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "District geometry",
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "first_prov": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "first_prov",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Province Name",
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "first_pro": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "first_pro",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Province ID",
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "first_dist": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "first_dist",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "District Name",
                    "units": "ids",
                    "PGtype": "varchar"
                },
                "first_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "first_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "gridtype": "2",
                    "units": "ids"
                },
                "dir": "SOURCES/Features/Political/Pakistan"
            },
            "Philippines": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Philippines",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Regionsdescription": "Regions",
                    "Provincesdescription": "Provinces",
                    "Municipalitiesdescription": "Municipalities",
                    "Districtsdescription": "Districts",
                    "description": "Philippines Districts, Municipalities, Provinces and Regions",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Philippines/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Philippines_119_1",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Regions Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "regcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "count": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "count",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Provinces Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "regcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "provname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "provcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "text"
                    }
                },
                "Municipalities": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Municipalities",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipality Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "regcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "regcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "provname1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provname1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "provname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "provcode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "provcode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "munoldname": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "munoldname",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipality Old Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "munctycode": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "munctycode",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipality Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "muncity": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "muncity",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Municipaity",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "dist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Philippines"
            },
            "Rwanda": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Rwanda",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Rwanda 1st and 2nd Order Administrative Boundaries",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dist_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Rwanda"
            },
            "Senegal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Senegal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Sub-Districts, Wards",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Senegal/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Senegal_128_1",
                    "Conventions": "IRIDL"
                },
                "SubDistricts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sub-Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward/Sub-District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "adm2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "2nd Order Admin. name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm2_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "2nd Order Admin. code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1st Order Admin. name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "1st Order Admin. code",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Senegal"
            },
            "Senegal2008": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Senegal2008",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Departmentdescirption": "D\\xc3\\xa9partements",
                    "description": "Senegal 2008 2nd Administrative Boundaries",
                    "Conventions": "IRIDL"
                },
                "Department": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Department",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "eff_year": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "eff_year",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Eff Year",
                        "units": "unitless",
                        "PGtype": "int2"
                    },
                    "country": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country ID",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "aliases": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "aliases",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Aliases",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "admin2fr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin2fr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "D\\xc3\\xa9partement",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "admin2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Department",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "admin1fr": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin1fr",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "R\\xc3\\xa9gion",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "admin1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "admin0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "admin0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "fnid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "fnid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "gridtype": "2",
                    "units": "ids"
                },
                "dir": "SOURCES/Features/Political/Senegal2008"
            },
            "SenegalARV": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SenegalARV",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Departmentdescirption": "D\\xc3\\xa9partements",
                    "description": "Afircan Risk View Senegal 2nd Administrative Boundaries",
                    "Conventions": "IRIDL"
                },
                "Department": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Department",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "Region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "last_updat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "last_updat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Last Update YYYYMMDD",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "continent": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "continent",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Cntinent",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Department Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm1_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "adm0_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm0_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "adm0_code": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm0_code",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Country Code",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "adm2_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm2_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/SenegalARV"
            },
            "Senegal_Adm": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Senegal_Adm",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Senegal Country\\', \\'1st\\', \\'2nd\\', \\'3rd and 4th Order Administrative Boundaries",
                    "Conventions": "IRIDL"
                },
                "Region": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Region",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Pays": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Pays",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "iso3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iso3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "iso2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iso2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "country_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "country_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Department": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Department",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "dept_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dept_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Commune": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Commune",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "dept_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dept_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "commune_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "commune_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "arrondissement_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "arrondissement_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Arrondissement": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Arrondissement",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "dept_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dept_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "arrondissement_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "arrondissement_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "id_1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id_1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "id_0": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id_0",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "id_2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id_2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "id_4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id_4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "id_3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id_3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Senegal_Adm"
            },
            "SriLanka": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SriLanka",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Provinces, Districts, Sub-districts, Villages, and Ministry of Health Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.SriLanka/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Villages": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Villages",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "province_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "province_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "gnd_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gnd_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Village Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "gnd_c": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gnd_c",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Village Code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dsd_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dsd_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sub-District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "m2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    }
                },
                "SubDistricts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SubDistricts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "province_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "province_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "dsd_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dsd_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sub-District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "sum_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sum_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "m2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "MOH_115": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MOH_115",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "moh_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "moh_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "MOH id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "moh115_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "moh115_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "MOH District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "MinistryOfHealth_Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MinistryOfHealth_Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "province": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "province",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "moh_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "moh_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ministry of Health District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "iri_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "iri_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "MOH id for 115 districts",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "district": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "czone_gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "czone_gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Climate zone gid",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "cezone_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cezone_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Elevation zone name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "cezone_gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "cezone_gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Elevation zone gid",
                        "units": "unitless",
                        "PGtype": "int4"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "sum_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sum_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "units": "m2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    },
                    "name1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "iri_id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "iri_id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "new_distid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "new_distid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/SriLanka"
            },
            "Sudan": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Sudan",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GAULsecondOrder_GAULlong_name": "Second_Order_GAUL",
                    "GAULfirstOrder_GAULlong_name": "First_Order_GAUL",
                    "GAULCountries_GAULlong_name": "Countries_GAUL",
                    "GAULSecond_Order": "def",
                    "GAULCountries": "def",
                    "GAULFirst_Order": "def",
                    "description": "Horn Region",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Sudan/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Sudan_137_1",
                    "Conventions": "IRIDL"
                },
                "Horn_Region": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Horn_Region",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "suadmn1_": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "suadmn1_",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Sudan admn1",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "GAUL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GAUL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "secondOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "secondOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin2 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm2_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "firstOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "firstOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin1 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "Countries_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Countries_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "suadmn1_id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "suadmn1_id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "adm0_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm0_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Sudan"
            },
            "TZA_DHIS2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TZA_DHIS2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Tanzania 2nd Order Administrative Boundaries used in DHIS2",
                    "Conventions": "IRIDL"
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_c": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_c",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/TZA_DHIS2"
            },
            "Tanzania": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tanzania",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Sub-Districts, Wards",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Tanzania/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Tanzania_145_1",
                    "Conventions": "IRIDL"
                },
                "SubDistricts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Sub-Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wardid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wardid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "ward_shehi": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ward_shehi",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward/Sub-District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "reg_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "reg_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Region id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "geom_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "district": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "dist_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District id",
                        "units": "unitless",
                        "PGtype": "int4"
                    },
                    "area_km2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area_km2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Ward area",
                        "units": "km2",
                        "missing_value": "NaN",
                        "PGtype": "float8"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Tanzania"
            },
            "Tanzania_2017": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tanzania_2017",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Tanzania 1st and 2nd Order Administrative Boundaries updated in 2017",
                    "Conventions": "IRIDL"
                },
                "Regions": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Regions",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "region_nam": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_nam",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "region_cod": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "region_cod",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_n": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_n",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "district_c": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "district_c",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Tanzania_2017"
            },
            "Togo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Togo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Districts",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Togo/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:Togo_147_1",
                    "Conventions": "IRIDL"
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "newfield1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "newfield1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "New Field1 code",
                        "units": "unitless",
                        "PGtype": "int8"
                    },
                    "first_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "first_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "id": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "id",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Togo"
            },
            "Uganda": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Features/Political/Uganda",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "Uganda",
                "restriction": "requires dlauth tokens"
            },
            "UnitedStates": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "UnitedStates",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": " Counties",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.UnitedStates/.dataset_documentation.html",
                    "iridlhasSemantics": "irigaz:United_States_156_1",
                    "Conventions": "IRIDL"
                },
                "Counties": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Counties",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "County geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "state": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "state",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "State code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "county": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "county",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "County code",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "co_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "co_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "County name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "co_id": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "co_id",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "County id",
                        "units": "unitless",
                        "PGtype": "int8"
                    }
                },
                "co99_d00_i": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "co99_d00_i",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/UnitedStates"
            },
            "Uruguay": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Uruguay",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Seccionales_Policialesdescription": "Seccionales Policiales 2010",
                    "Conventions": "IRIDL"
                },
                "Seccionales_Policiales": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Seccionales_Policiales",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "shape_leng": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_leng",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Shape Leng",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "shape_area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "shape_area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Shape Area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "perimeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "perimeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Perimeter",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "deptosec": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "deptosec",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Deptosec",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "area": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "area",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Area",
                        "missing_value": "NaN",
                        "units": "unitless",
                        "PGtype": "float8"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Features/Political/Uruguay"
            },
            "Vietnam": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Vietnam",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Vietnam Provinces and Districts Admin boundaries",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.Features/.Political/.Vietnam/.dataset_documentation.html",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "adm1_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm1_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name - Admin Level 1 Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "adm2_name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "adm2_name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name - Admin Level 2 Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dcode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dcode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Vietnam"
            },
            "World": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/Features/Political/World",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "World",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "Zambia": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Zambia",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Provincesdescription": "Zambia Provincial Boundaries",
                    "Districtsdescription": "Zambia District Boundaries",
                    "Countrydescription": "Zambia Political Boundaries",
                    "Conventions": "IRIDL"
                },
                "Provinces": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Provinces",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "prov_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prov_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Province Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    }
                },
                "Districts": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Districts",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "dist_na": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist_na",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "District Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "Country": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Country",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "name_engli": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "name_engli",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Name",
                        "units": "ids",
                        "PGtype": "varchar"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "varchar"
                    }
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/Features/Political/Zambia"
            },
            "Zimbabwe": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Zimbabwe",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GAULsecondOrder_GAULlong_name": "Second_Order_GAUL_Zimbabwe",
                    "GAULfirstOrder_GAULlong_name": "First_Order_GAUL_Zimbabwe",
                    "GAULCountries_GAULlong_name": "Countries_GAUL_Zimbabwe",
                    "GAULCountries": "def",
                    "GAULFirst_Order": "def",
                    "GAULSecond_Order": "def",
                    "Conventions": "IRIDL"
                },
                "GAUL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GAUL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "secondOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "secondOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin2 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm2_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm2_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm2_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level2 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "firstOrder_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "firstOrder_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin1 geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "text"
                        },
                        "adm1_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm1_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm1_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Admin Level1 id",
                            "units": "unitless",
                            "PGtype": "int4"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_code": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_code",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country id",
                            "units": "unitless",
                            "PGtype": "int4"
                        }
                    },
                    "Countries_GAUL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Countries_GAUL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "adm0_name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adm0_name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "adm0_code": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "adm0_code",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "dir": "SOURCES/Features/Political/Zimbabwe"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "Africa",
                "Bangladesh",
                "Bihar",
                "Botswana",
                "Brazil",
                "BurkinaFaso",
                "CentralWestAfrica",
                "Chile",
                "Colombia",
                "Colombia_CIAT",
                "CotedIvoire",
                "Eritrea",
                "Ethiopia",
                "Ethiopia_adm1",
                "Ethiopia_adm2",
                "Ethiopia_adm3",
                "Ethiopia_adm3_reduced",
                "Guatemala",
                "Honduras",
                "Humdata",
                "India",
                "Indonesia",
                "MVPSites",
                "Madagascar",
                "Mali",
                "Nepal",
                "Nepal_Prov",
                "Niger",
                "Nigeria",
                "Pakistan",
                "Philippines",
                "Rwanda",
                "Senegal",
                "Senegal2008",
                "SenegalARV",
                "Senegal_Adm",
                "SriLanka",
                "Sudan",
                "TZA_DHIS2",
                "Tanzania",
                "Tanzania_2017",
                "Togo",
                "Uganda",
                "UnitedStates",
                "Uruguay",
                "Vietnam",
                "World",
                "Zambia",
                "Zimbabwe"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "Agricultural",
            "Climatological",
            "Epidemiological",
            "Hydrological",
            "Political"
        ]
    },
    "GEDEX": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "GEDEX",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "isccp_c2description": "Monthly mean cloud product from the Greenhouse Effect Detection Experiment",
            "isccp_c2title": "ISCCP-C2 Monthly Mean Cloud Product",
            "iridlhasSemantics": "iridl:NASA",
            "Conventions": "IRIDL"
        },
        "isccp_c2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "isccp_c2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "TMP_SSFC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TMP_SSFC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Mean Skin Surface Temp for Clear Sky Composite",
                "units": "/K",
                "long_name": "Mn Skin Sfc Tmp",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "345.0",
                "valid_min": "165.0"
            },
            "TMP_CLDT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TMP_CLDT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Mean Cloud Top Temperature",
                "units": "/K",
                "long_name": "Mn Cld Top Tmp",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "345.0",
                "valid_min": "165.0"
            },
            "SNOW_ICE": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SNOW_ICE",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Average Snow Ice Cover",
                "units": "/%",
                "long_name": "Ave Snow Ice Cover",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            },
            "SFC_CODE": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SFC_CODE",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Code_1,2,3_Day H2O,Land,Coast 101,102,103_Night",
                "units": "unitless",
                "long_name": "Surface Type",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "103.0",
                "valid_min": "0.0"
            },
            "RFL_SFC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "RFL_SFC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Mean Surface Reflectance for Clear Sky Composite",
                "units": "unitless",
                "long_name": "Mn Surface Reflec",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "1.0",
                "valid_min": "0.0"
            },
            "PRS_CLDT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PRS_CLDT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Mean Cloud Top Pressure",
                "units": "/Mb",
                "long_name": "Mn Cld Top Pres",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "1100.0",
                "valid_min": "1.0"
            },
            "OPT_DPTH": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "OPT_DPTH",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Mean Optical Thickness (TAU)",
                "units": "unitless",
                "long_name": "Optical Thickness",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "120.0",
                "valid_min": "0.0"
            },
            "FQ_MCLD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "FQ_MCLD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Ave Freq Middle Clouds  Alto- and Nimbostratus",
                "units": "/%",
                "long_name": "Middle Cld Freq",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            },
            "FQ_LCLD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "FQ_LCLD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Ave Freq Low Clouds  Cumulus and Stratus",
                "units": "/%",
                "long_name": "Low Cld Freq",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            },
            "FQ_HCLD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "FQ_HCLD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Ave Freq High Clds_Cirrus Cirrostr & Deep Conv",
                "units": "/%",
                "long_name": "High Cld Freq",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            },
            "CLD_PATH": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CLD_PATH",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Cloud Water Mass Per Unit Area",
                "units": "/g/m**2",
                "long_name": "Cloud Water Path",
                "FORTRAN_format": "F5.2",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "800.0",
                "valid_min": "0.0"
            },
            "CLD_AMT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CLD_AMT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "description": "Average Frequency of Cloudy Pixels",
                "units": "/%",
                "long_name": "Cloud Fraction",
                "FORTRAN_format": "F10.3",
                "title": "ISCCP-C2 Monthly Mean Cloud Product",
                "missing_value": "-1000.0",
                "valid_max": "100.0",
                "valid_min": "0.0"
            }
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "long_name": "Latitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "long_name": "Time"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "modulus": "360.0",
            "pointwidth": "2.5",
            "long_name": "Longitude"
        },
        "dir": "SOURCES/GEDEX"
    },
    "GEOSECS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "GEOSECS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "description": "Geochemical Ocean Sections Study, a global survey of the three-dimensional distribution of chemical, isotopic, and radiochemical tracers in the ocean.  The expeditions were in the Atlantic from July 1972 to May 1973; the Pacific from  August 1973 to June 1974, and the Indian Ocean from December 1977 to March 1978",
            "Conventions": "IRIDL",
            "iridlhasSemantics": "iridl:SIO",
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.GEOSECS/.dataset_documentation.html"
        },
        "Tritium_TU": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Tritium_TU",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "unitless",
            "long_name": "tritium TU"
        },
        "THETA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "THETA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "Celsius_scale",
            "long_name": "potential temperature"
        },
        "TEMP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TEMP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "Celsius_scale",
            "long_name": "temperature"
        },
        "TCO2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TCO2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "total $@ CO sub 2$"
        },
        "TALK": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TALK",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "microEquivalents/kg",
            "long_name": "total alkalinity"
        },
        "STA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "unitless",
            "long_name": "station"
        },
        "SIO3": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SIO3",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "$@ SiO sub 3$"
        },
        "SIGMA4": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SIGMA4",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "sigma",
            "long_name": "$sigma sub 4$"
        },
        "SIGMA2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SIGMA2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "sigma",
            "long_name": "$sigma sub 2$"
        },
        "SIGMA0": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SIGMA0",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "sigma",
            "long_name": "$sigma sub 0$"
        },
        "SAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "PSU",
            "long_name": "salinity"
        },
        "PRESS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PRESS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "dbar",
            "long_name": "pressure"
        },
        "PO4": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PO4",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "phosphate"
        },
        "PCO2_TEMP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PCO2_TEMP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "Celsius_scale"
        },
        "PCO2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "PCO2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "microatm"
        },
        "OXY": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "OXY",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "oxygen"
        },
        "NO3": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NO3",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "nitrate"
        },
        "NO2": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NO2",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "nitrite"
        },
        "lon": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lon",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "longitude",
            "units": "degree_east"
        },
        "lat": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "lat",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "latitude",
            "units": "degree_north"
        },
        "DEPTH": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DEPTH",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "m",
            "long_name": "depth"
        },
        "Delta_C14": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Delta_C-14",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "per mil",
            "long_name": "$Delta sup 14 @ C$"
        },
        "Delta_C13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Delta_C-13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "per mil",
            "long_name": "$Delta sup 13 @ C$"
        },
        "BOTTLE": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "BOTTLE",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "unitless",
            "long_name": "bottle number"
        },
        "AOU": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "AOU",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "missing_value": "NaN",
            "units": "micromole/kg",
            "long_name": "apparent oxygen utilization"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2",
            "long_name": "ISTA"
        },
        "IZ": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "IZ",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0",
            "long_name": "IZ"
        },
        "dir": "SOURCES/GEOSECS"
    },
    "GISS": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/GISS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "GISS",
        "restriction": "Public",
        "AMIP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "AMIP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "contact": "Gary L. Russell <I>cmglr@isis.giss.nasa.gov</I>",
                "source": "Run C027AM",
                "description": "The surface diagnostics from an atmospheric model simulation with AMIP boundary conditions.",
                "Conventions": "IRIDL",
                "iridlhasSemantics": "iriref:Russell_GL"
            },
            "TOTCLOUD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TOTCLOUD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "percent",
                "long_name": "TOTAL CLOUD COVER"
            },
            "SENSHEAT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SENSHEAT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "long_name": "SENSIBLE HEAT FLUX"
            },
            "SATEM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SATEM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Kelvin_scale",
                "long_name": "Surface Air Temperature"
            },
            "SAHUM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SAHUM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "g/kg",
                "long_name": "SURFACE AIR SPECIFIC HUMIDITY"
            },
            "PRECIPITATION": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PRECIPITATION",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mm/day",
                "long_name": "PRECIPITATION"
            },
            "NLWRADS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NLWRADS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "long_name": "NET THERMAL RADIATION at SURFACE"
            },
            "LOWCLOUD": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LOWCLOUD",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "percent",
                "long_name": "CLOUD COVER from Layers 1, 2 and 3"
            },
            "INCSRADS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "INCSRADS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "long_name": "INCIDENT SOLAR RADIATION at SURFACE"
            },
            "GTEM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GTEM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "Kelvin_scale",
                "long_name": "GROUND TEMPERATURE of Layer 1"
            },
            "EVAP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "EVAP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mm/day",
                "long_name": "EVAPORATAION"
            },
            "ABSSRADS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ABSSRADS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "W/m2",
                "long_name": "ABSORBED SOLAR RADIATION at SURFACE"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "5.0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "4.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/GISS/AMIP"
        },
        "CMATM1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CMATM1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "source": "Run C027AM",
                "Conventions": "IRIDL",
                "contact": "Gary L. Russell <I>cmglr@isis.giss.nasa.gov</I>",
                "history": "The surface diagnostics from a coupled model run"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "C",
                "history": "The surface diagnostics from a coupled model run",
                "long_name": "Sea Surface Temperature"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "5.0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "4.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/GISS/CMATM1"
        },
        "GlobalFWI": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/GISS/GlobalFWI",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "GlobalFWI",
            "restriction": "Public",
            "v1p4": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/GISS/GlobalFWI/v1p4",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "v1p4",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "v1p5": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/GISS/GlobalFWI/v1p5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "v1p5",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "v1p4",
                "v1p5"
            ]
        },
        "SCENARIOA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SCENARIO-A",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Conventions": "IRIDL"
            },
            "ssta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ssta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_Celsius",
                "history": "10 year mean anomalies from giss A scenario simulation.",
                "long_name": "Sea Surface Temperature Anomalies"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "0",
                "standard_name": "longitude",
                "pointwidth": "5.625"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "2.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/GISS/SCENARIO-A"
        },
        "SI2000": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "SI2000",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "MONTHLYB424description": " with radiative forcings",
                "MONTHLYB424references": "Hansen_etal2002",
                "MONTHLYB399description": " with no radiative forcings",
                "MONTHLYB399references": "Hansen_etal2002",
                "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.GISS/.SI2000/.MONTHLY.dataset_documentation.html",
                "Conventions": "IRIDL"
            },
            "MONTHLY": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MONTHLY",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "B424": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "B424",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "w": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "w",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wind speed",
                            "units": "m/s"
                        },
                        "v": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "meridional velocity",
                            "units": "m/s"
                        },
                        "u": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "u",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "zonal velocity",
                            "units": "m/s"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "temperature",
                            "units": "Celsius_scale"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "sea level pressure",
                            "units": "mb",
                            "add_offset": "1000.0"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "precipitation",
                            "units": "mm/day"
                        }
                    },
                    "PressureLevel": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PressureLevel",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "V",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "meridional velocity",
                            "units": "m/s"
                        },
                        "U": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "U",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "zonal velocity",
                            "units": "m/s"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "temperaturey",
                            "units": "Celsius_scale"
                        },
                        "RH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "relative humidity",
                            "units": "percent"
                        },
                        "Hoffset": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Hoffset",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m"
                        },
                        "H": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "H",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "height",
                            "units": "m"
                        }
                    },
                    "Ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vegetated": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vegetated",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "root": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "root",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "combined": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "combined",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "bare": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bare",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        }
                    }
                },
                "B399": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "B399",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Surface": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Surface",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "w": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "w",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "wind speed",
                            "units": "m/s"
                        },
                        "v": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "meridional velocity",
                            "units": "m/s"
                        },
                        "u": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "u",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "zonal velocity",
                            "units": "m/s"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "temperature",
                            "units": "Celsius_scale"
                        },
                        "psl": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psl",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "sea level pressure",
                            "units": "mb",
                            "add_offset": "1000.0"
                        },
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "precipitation",
                            "units": "mm/day"
                        }
                    },
                    "PressureLevel": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PressureLevel",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "V": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "V",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "meridional velocity",
                            "units": "m/s"
                        },
                        "U": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "U",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "zonal velocity",
                            "units": "m/s"
                        },
                        "temp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "temperaturey",
                            "units": "Celsius_scale"
                        },
                        "RH": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RH",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "relative humidity",
                            "units": "percent"
                        },
                        "Hoffset": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Hoffset",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "m"
                        },
                        "H": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "H",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "height",
                            "units": "m"
                        }
                    },
                    "Ground": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Ground",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "vegetated": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "vegetated",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "root": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "root",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "combined": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "combined",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        },
                        "bare": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "bare",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "gwet": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "gwet",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "missing_value": "-9999.0",
                                "scale_max": "100.0",
                                "long_name": "ground wetness",
                                "units": "percent"
                            }
                        }
                    }
                }
            },
            "M_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "member"
            },
            "P_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "gridtype": "0"
            },
            "P": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "P",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "mb",
                "gridtype": "0"
            },
            "X": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "X",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_east",
                "gridtype": "1",
                "standard_name": "longitude",
                "pointwidth": "5.0"
            },
            "Y": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Y",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "degree_north",
                "gridtype": "0",
                "standard_name": "latitude",
                "pointwidth": "4.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "standard_name": "time",
                "pointwidth": "1.0"
            },
            "M": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "M",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "member"
            },
            "dir": "SOURCES/GISS/SI2000"
        },
        "indextex": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/GISS/index.tex",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "index.tex",
            "restriction": "Public",
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "AMIP",
            "CMATM1",
            "GlobalFWI",
            "SCENARIOA",
            "SI2000",
            "indextex"
        ]
    },
    "GOSTA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "GOSTA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "landsstdescription": "Blended Land and SST Data",
            "landsstreferences": "Jones1994",
            "gisst22description": "Global SST and Ice Concentration (GISST)",
            "gisst22references": "Parker_etal1995 Rayner_etal1996",
            "atlas8climatologylong_name": "GISST2.2 Climatology 1961-1990",
            "atlas8description": "Global Ocean Surface Temperature Atlas 8",
            "atlas8references": "Bottomley_etal1990 Parker_etal1995b",
            "atlas7climatologylong_name": "MOHSST4 Climatology 1951-1980",
            "atlas7description": "Global Ocean Surface Temperature Atlas 7",
            "atlas7references": "Bottomley_etal1990",
            "description": "Global Ocean Surface Temperature Atlas",
            "source": "PO DAAC binary Data Format CD-ROM (except for Atlas 7 5 deg sst climatology)",
            "PO": "http://podaac.jpl.nasa.gov/cdrom/gostaplus_binary/order.htm",
            "iridlhasSemantics": "iridl:BADC",
            "UK": "http://badc.nerc.ac.uk/data/gosta/",
            "Conventions": "IRIDL",
            "long_name": "GOSTAplus",
            "disclaimerhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.GOSTA/.disclaimer.html"
        },
        "landsst": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "landsst",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "temp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "temp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-32768",
                "units": "Celsius_scale",
                "scale_factor": "0.01",
                "pointwidth": "0"
            }
        },
        "gisst22": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gisst22",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-32768",
                "units": "Celsius_scale",
                "scale_factor": "0.01",
                "pointwidth": "0"
            },
            "ice": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ice",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-32768",
                "scale_factor": "0.1",
                "long_name": "ice concentration",
                "units": "unitless",
                "pointwidth": "0"
            }
        },
        "atlas8": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "atlas8",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MOHSST6": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MOHSST6",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "valid_max": "327.66998",
                    "valid_min": "-327.67999",
                    "missing_value": "NaN",
                    "long_name": "sea surface temperature anomaly",
                    "units": "degree_Celsius"
                }
            },
            "MOHSST5": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MOHSST5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "valid_max": "327.66998",
                    "valid_min": "-327.67999",
                    "missing_value": "NaN",
                    "units": "degree_Celsius"
                }
            },
            "MOHMAT4N": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MOHMAT4N",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "valid_max": "327.66998",
                    "valid_min": "-327.67999",
                    "long_name": "night marine air temperature anomaly",
                    "missing_value": "NaN",
                    "units": "degree_Celsius"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "1deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-2.0",
                        "colorscalename": "sstcolorscale",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "colormap": "12632256",
                        "CE": "35",
                        "CS": "-2",
                        "valid_max": "327.66998",
                        "valid_min": "-327.67999",
                        "missing_value": "NaN",
                        "units": "Celsius_scale"
                    }
                }
            }
        },
        "atlas7": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "atlas7",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "MOHSST5": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MOHSST5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "4.1999998",
                    "ncolor": "254",
                    "scale_min": "-4.1999998",
                    "CS": "-4.1999998",
                    "colorscalename": "sstacolorscale",
                    "CE": "4.1999998",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "valid_max": "327.66998",
                    "valid_min": "-327.67999",
                    "missing_value": "NaN",
                    "long_name": "sea surface temperature anomaly",
                    "units": "degree_Celsius"
                }
            },
            "MOHMAT2N": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MOHMAT2N",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "night marine air temperature anomaly",
                    "missing_value": "-32768",
                    "units": "degree_Celsius",
                    "scale_factor": "0.01"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "deg": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "1deg",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-2.0",
                        "colorscalename": "sstcolorscale",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "colormap": "12632256",
                        "CE": "35",
                        "CS": "-2",
                        "valid_max": "327.66998",
                        "valid_min": "-327.67999",
                        "missing_value": "NaN",
                        "units": "Celsius_scale"
                    }
                }
            }
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "bucket": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "bucket",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "wspd": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "wspd",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m/s",
            "gridtype": "0",
            "pointwidth": "0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "5.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "5.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/GOSTA"
    },
    "Gambia": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Gambia",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Gambia",
        "restriction": "Public",
        "ENACTS": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/Gambia/ENACTS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "ENACTS",
            "restriction": "Public",
            "dekadly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "dekadly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.0",
                        "long_name": "Minimum Temperature",
                        "units": "degree_Celsius"
                    },
                    "tmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.0",
                        "long_name": "Maximum Temperature",
                        "units": "degree_Celsius"
                    }
                },
                "rainfall": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rainfall",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "SPIrfe_adj_1dekad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "SPI-rfe_adj_1-dekad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Standard Precipitation Index 1-dekad",
                        "maxncolor": "254",
                        "colormap": "45",
                        "scale_max": "3.0999999",
                        "ncolor": "253",
                        "scale_min": "-3.0999999",
                        "CE": "3.0999999",
                        "CS": "-3.0999999",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "file_missing_value": "-9.9899998",
                        "valid_max": "32767.0",
                        "valid_min": "-32768.0"
                    },
                    "rfe_mergeddiff_percent": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe_mergeddiff_percent",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "long_name": "Merged Gauge-Satellite Rainfall Difference Expressed as Percent of Long-Term Average (%)",
                        "colormap": "4026644",
                        "scale_max": "500.0",
                        "ncolor": "254",
                        "scale_min": "-100.0",
                        "CE": "500",
                        "CS": "-100",
                        "units": "unitless",
                        "history": "Averaged over T2[0.5, 1044.5] minimum 0.0% data present"
                    },
                    "rfe_mergeddiff": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe_mergeddiff",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "long_name": "Merged Gauge-Satellite Rainfall Anomaly",
                        "colormap": "10526303",
                        "scale_max": "200.0",
                        "ncolor": "254",
                        "scale_min": "-120.0",
                        "CE": "200",
                        "CS": "-120",
                        "missing_value": "NaN",
                        "units": "mm",
                        "history": "Averaged over T2[0.5, 1044.5] minimum 0.0% data present"
                    },
                    "rfe_merged_vs_meanrfe_merged": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe_merged_vs_meanrfe_merged",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "long_name": "Merged Gauge-Satellite Rainfall Expressed as Percentages of the Long-Term Average",
                        "colormap": "4026644",
                        "scale_max": "600.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "600",
                        "CS": "0",
                        "units": "unitless",
                        "history": "Averaged over T2[0.5, 1044.5] minimum 0.0% data present"
                    },
                    "rfe": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "0",
                        "CS": "0",
                        "ncolor": "16",
                        "colormap": "13434880",
                        "maxncolor": "254",
                        "missing_value": "-9999",
                        "long_name": "Merged Station-Satellite Rainfall",
                        "units": "mm"
                    }
                },
                "climatologies": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatologies",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "5.0",
                        "scale_max": "27.0",
                        "CE": "27",
                        "CS": "5",
                        "ncolor": "254",
                        "colorscalename": "temp_colors",
                        "maxncolor": "254",
                        "colormap": "255",
                        "long_name": "minimum temperature 1981-2010 average",
                        "history": "Averaged over T2[0.5, 1080.5] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "file_missing_value": "-99.0",
                        "units": "degree_Celsius"
                    },
                    "tmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "20.0",
                        "scale_max": "43.0",
                        "CE": "43",
                        "CS": "20",
                        "ncolor": "254",
                        "colorscalename": "temp_colors",
                        "maxncolor": "254",
                        "colormap": "255",
                        "long_name": "maximum temperature 1981-2010 average",
                        "history": "Averaged over T2[0.5, 1080.5] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "file_missing_value": "-99.0",
                        "units": "degree_Celsius"
                    },
                    "rfe_stddev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe_stddev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "cmorph_dekad_colors",
                        "colormap": "2237106",
                        "scale_max": "300.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "300",
                        "CS": "0",
                        "long_name": "rfe merged 1983-2011 standard deviation",
                        "history": "Averaged over T2[18.5, 1026.5] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "units": "mm"
                    },
                    "rfe": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "16",
                        "colormap": "13434880",
                        "maxncolor": "254",
                        "long_name": "rfe merged 1983-2011 average",
                        "history": "Averaged over T2[0.5, 1044.5] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "units": "mm"
                    }
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1981-01-01",
                    "gridtype": "1",
                    "modulo": "365.0",
                    "modulus": "365.0",
                    "calendar": "365"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.0375"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.0375"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1983-01-01",
                    "gridtype": "1",
                    "modulo": "365.0",
                    "modulus": "365.0",
                    "calendar": "365"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.03750001"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.03750001"
                },
                "dir": "SOURCES/Gambia/ENACTS/dekadly"
            },
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "climatologies": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatologies",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "14.0",
                        "scale_max": "26.0",
                        "CE": "26",
                        "CS": "14",
                        "ncolor": "254",
                        "colorscalename": "temp_colors",
                        "maxncolor": "254",
                        "colormap": "255",
                        "long_name": "tmin 1981-2010 average",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "units": "degree_Celsius",
                        "file_missing_value": "-99.0"
                    },
                    "tmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "30.0",
                        "scale_max": "43.0",
                        "CE": "43",
                        "CS": "30",
                        "ncolor": "254",
                        "colorscalename": "temp_colors",
                        "maxncolor": "254",
                        "colormap": "255",
                        "long_name": "tmax 1981-2010 average",
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "units": "degree_Celsius",
                        "file_missing_value": "-99.0"
                    },
                    "rfe": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rfe",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "16",
                        "colormap": "13434880",
                        "maxncolor": "254",
                        "long_name": "rfe 1983-2011 average",
                        "history": "Averaged over T2[1983, 2011] minimum 0.0% data present",
                        "missing_value": "NaN",
                        "units": "mm"
                    }
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.0375"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.0375"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.03750001"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.03750001"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/Gambia/ENACTS/monthly"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "dekadly",
                "monthly"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "ENACTS"
        ]
    },
    "Ghana": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/Ghana",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "Ghana",
        "restriction": "requires dlauth tokens"
    },
    "HADLEY": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "HADLEY",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "HadSLPdataset_documentationhtml": "http://hadobs.metoffice.com/gmslp",
            "ClimateModelDECADALstream2hindcastsnoassimOCEAN30yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsnoassimOCEAN10yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsnoassimATM30yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsnoassimATM10yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsdepresysOCEAN30yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsdepresysOCEAN10yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsdepresysATM30yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2hindcastsdepresysATM10yearrunConventions": "CF-1.0",
            "ClimateModelDECADALstream2climatologyOCEANHISTORICConventions": "CF-1.0",
            "ClimateModelDECADALstream2climatologyOCEANA1BConventions": "CF-1.0",
            "ClimateModelDECADALstream2climatologyATMHISTORICConventions": "CF-1.0",
            "ClimateModelDECADALstream2climatologyATMA1BConventions": "CF-1.0",
            "ClimateModelDECADALdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.HADLEY/.ClimateModel.DECADAL.dataset_documentation.html",
            "ClimateModelDECADALreferences": "Gordon_etal2000 Pope_etal2000 Johns_etal2003 Collins_etal2006 Smith_etal2007",
            "ClimateModelDECADALdescription": "HadCM3 ENSEMBLES Stream 2",
            "ClimateModeldescription": "HadCM3 ENSEMBLES Stream 2",
            "ClimateModelreferences": "Gordon_etal2000 Pope_etal2000 Johns_etal2003 Collins_etal2006 Smith_etal2007",
            "iridlhasSemantics": "iridl:HADLEY",
            "hadley_centre": "http://www.hadobs.org/",
            "Conventions": "IRIDL"
        },
        "HadSLP": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "HadSLP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "sislp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sislp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "missing_value": "-99990",
                "scale_factor": "0.01",
                "long_name": "spatially incomplete sea level pressure",
                "units": "mb"
            },
            "scslp": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "scslp",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "spatially complete sea level pressure",
                "units": "mb",
                "scale_factor": "0.01"
            }
        },
        "ClimateModel": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ClimateModel",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "DECADAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "DECADAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "stream2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stream2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "hindcasts": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcasts",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "noassim": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "noassim",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OCEAN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OCEAN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yearrun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "10yearrun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "long_name": "Forecast time",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "3",
                                        "standard_name": "time"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "long_name": "Forecast time",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "3",
                                            "standard_name": "time"
                                        },
                                        "sit": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sit",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sea ice thickness",
                                            "units": "m",
                                            "pointwidth": "1.0"
                                        },
                                        "aic": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "aic",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sea ice concentration",
                                            "units": "unitless",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "belowSeaSurface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "belowSeaSurface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "vo": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vo",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total v-velocity (ocean)",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "uo": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uo",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total u-velocity (ocean)",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "thetao": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "thetao",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "potential temperature (ocean)",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "so": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "so",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "salinity (ocean)",
                                            "units": "psu",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            },
                            "ATM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ATM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yearrun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "10yearrun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "rsutcs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsutcs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "clear sky top upward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rsut": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsut",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top upward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top net SW radiation (rsdt-rsut)",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rsdt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsdt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top downward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlutcs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlutcs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "clear sky top upward LW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlut": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlut",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top upward LW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast time",
                                        "units": "months since 1960-01-01",
                                        "calendar": "360",
                                        "pointwidth": "1"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ts": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ts",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "surface temp.",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "2-meter air temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "snw": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snw",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "snow water equivalent",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        },
                                        "rss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "net SW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "net LW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlds": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlds",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "downward LW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "psl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "mean sea level pressure",
                                            "units": "Pa",
                                            "pointwidth": "1.0"
                                        },
                                        "pr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "precipitation",
                                            "units": "kg m-2 s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sensible heat flux at surface",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "latent heat flux at surface",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "mrsos": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mrsos",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "soil moisture (profile on model level)",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        },
                                        "mrso": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mrso",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total soil moisture content",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "geopotential height",
                                            "units": "m",
                                            "pointwidth": "1.0"
                                        },
                                        "va": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "va",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "v wind",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "ua": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ua",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "u wind",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            }
                        },
                        "depresys": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "depresys",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OCEAN": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "OCEAN",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yearrun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "10yearrun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "long_name": "Forecast time",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "3",
                                        "standard_name": "time"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "long_name": "Forecast time",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "3",
                                            "standard_name": "time"
                                        },
                                        "sit": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sit",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sea ice thickness",
                                            "units": "m",
                                            "pointwidth": "1.0"
                                        },
                                        "aic": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "aic",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sea ice concentration",
                                            "units": "unitless",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "belowSeaSurface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "belowSeaSurface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "vo": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vo",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total v-velocity (ocean)",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "uo": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uo",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total u-velocity (ocean)",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "thetao": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "thetao",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "potential temperature (ocean)",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "so": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "so",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "salinity (ocean)",
                                            "units": "psu",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            },
                            "ATM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ATM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "yearrun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "10yearrun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "rsutcs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsutcs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "clear sky top upward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rsut": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsut",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top upward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top net SW radiation (rsdt-rsut)",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rsdt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rsdt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top downward SW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlutcs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlutcs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "clear sky top upward LW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlut": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlut",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "top upward LW radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast time",
                                        "units": "months since 1960-01-01",
                                        "calendar": "360",
                                        "pointwidth": "1"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ts": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ts",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "surface temp.",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "2-meter air temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        },
                                        "snw": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snw",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "snow water equivalent",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        },
                                        "rss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "net SW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "net LW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "rlds": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rlds",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "downward LW surface radiation",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "psl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "mean sea level pressure",
                                            "units": "Pa",
                                            "pointwidth": "1.0"
                                        },
                                        "pr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "precipitation",
                                            "units": "kg m-2 s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "sensible heat flux at surface",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        },
                                        "hfso": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfso",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "missing_value": "1.00000002E20",
                                            "pointwidth": "1.0"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "latent heat flux at surface",
                                            "units": "W/m2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "mrsos": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mrsos",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "soil moisture (profile on model level)",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        },
                                        "mrso": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mrso",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "total soil moisture content",
                                            "units": "kg m-2",
                                            "pointwidth": "1.0"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "geopotential height",
                                            "units": "m",
                                            "pointwidth": "1.0"
                                        },
                                        "va": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "va",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "v wind",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "ua": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ua",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "u wind",
                                            "units": "m s-1",
                                            "pointwidth": "1.0"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "1.00000002E20",
                                            "long_name": "temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "1.0"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OCEAN": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "OCEAN",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HISTORIC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HISTORIC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sit": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sit",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sea ice thickness",
                                        "units": "m"
                                    },
                                    "aic": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "aic",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sea ice concentration",
                                        "units": "unitless"
                                    }
                                },
                                "belowSeaSurface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "belowSeaSurface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total v-velocity (ocean)",
                                        "units": "m s-1"
                                    },
                                    "uo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total u-velocity (ocean)",
                                        "units": "m s-1"
                                    },
                                    "thetao": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "thetao",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "potential temperature (ocean)",
                                        "units": "Kelvin_scale"
                                    },
                                    "so": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "so",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "salinity (ocean)",
                                        "units": "psu"
                                    }
                                }
                            },
                            "A1B": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A1B",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sit": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sit",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sea ice thickness",
                                        "units": "m"
                                    },
                                    "aic": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "aic",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sea ice concentration",
                                        "units": "unitless"
                                    }
                                },
                                "belowSeaSurface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "belowSeaSurface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total v-velocity (ocean)",
                                        "units": "m s-1"
                                    },
                                    "uo": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uo",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total u-velocity (ocean)",
                                        "units": "m s-1"
                                    },
                                    "thetao": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "thetao",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "potential temperature (ocean)",
                                        "units": "Kelvin_scale"
                                    },
                                    "so": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "so",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "salinity (ocean)",
                                        "units": "psu"
                                    }
                                }
                            }
                        },
                        "ATM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ATM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HISTORIC": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HISTORIC",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rsutcs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsutcs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "clear sky top upward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rsut": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsut",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top upward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top net SW radiation (rsdt-rsut)",
                                        "units": "W/m2"
                                    },
                                    "rsdt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsdt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top downward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rlutcs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlutcs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "clear sky top upward LW radiation",
                                        "units": "W/m2"
                                    },
                                    "rlut": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlut",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top upward LW radiation",
                                        "units": "W/m2"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ts": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ts",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "surface temp.",
                                        "units": "Kelvin_scale"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "2-meter air temperature",
                                        "units": "Kelvin_scale"
                                    },
                                    "snw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "snow water equivalent",
                                        "units": "kg m-2"
                                    },
                                    "rss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "net SW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "rls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "net LW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "rlds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "downward LW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "psl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa"
                                    },
                                    "pr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "precipitation",
                                        "units": "kg m-2 s-1"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sensible heat flux at surface",
                                        "units": "W/m2"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "latent heat flux at surface",
                                        "units": "W/m2"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mrsos": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mrsos",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "soil moisture (profile on model level)",
                                        "units": "kg m-2"
                                    },
                                    "mrso": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mrso",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total soil moisture content",
                                        "units": "kg m-2"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "geopotential height",
                                        "units": "m"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "v wind",
                                        "units": "m s-1"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "u wind",
                                        "units": "m s-1"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale"
                                    }
                                }
                            },
                            "A1B": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "A1B",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "rsutcs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsutcs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "clear sky top upward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rsut": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsut",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top upward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top net SW radiation (rsdt-rsut)",
                                        "units": "W/m2"
                                    },
                                    "rsdt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rsdt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top downward SW radiation",
                                        "units": "W/m2"
                                    },
                                    "rlutcs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlutcs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "clear sky top upward LW radiation",
                                        "units": "W/m2"
                                    },
                                    "rlut": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlut",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "top upward LW radiation",
                                        "units": "W/m2"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ts": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ts",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "surface temp.",
                                        "units": "Kelvin_scale"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "2-meter air temperature",
                                        "units": "Kelvin_scale"
                                    },
                                    "snw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "snow water equivalent",
                                        "units": "kg m-2"
                                    },
                                    "rss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "net SW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "rls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "net LW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "rlds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rlds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "downward LW surface radiation",
                                        "units": "W/m2"
                                    },
                                    "psl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa"
                                    },
                                    "pr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "precipitation",
                                        "units": "kg m-2 s-1"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "sensible heat flux at surface",
                                        "units": "W/m2"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "latent heat flux at surface",
                                        "units": "W/m2"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mrsos": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mrsos",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "soil moisture (profile on model level)",
                                        "units": "kg m-2"
                                    },
                                    "mrso": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mrso",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "total soil moisture content",
                                        "units": "kg m-2"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "geopotential height",
                                        "units": "m"
                                    },
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "v wind",
                                        "units": "m s-1"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "u wind",
                                        "units": "m s-1"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "1.00000002E20",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale"
                                    }
                                }
                            }
                        }
                    }
                }
            }
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "5.0"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "5.0"
        },
        "L_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_period",
            "long_name": "Lead time",
            "pointwidth": "3"
        },
        "L_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_period",
            "long_name": "Lead time",
            "pointwidth": "3"
        },
        "L_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "long_name": "Lead time",
            "calendar": "360",
            "standard_name": "forecast_period",
            "pointwidth": "1.0"
        },
        "S_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "pointwidth": "0"
        },
        "z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Soil level",
            "pointwidth": "1.0"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "long_name": "Lead time",
            "calendar": "360",
            "standard_name": "forecast_period",
            "pointwidth": "1.0"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "forecast_reference_time",
            "long_name": "Start time",
            "pointwidth": "0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "Time",
            "long_name": "Time",
            "pointwidth": "3"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.25"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.25"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.25"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "Time",
            "long_name": "Time",
            "pointwidth": "3"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "1.25"
        },
        "z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Below sea surface"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "Time",
            "long_name": "Time",
            "pointwidth": "0"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Soil level",
            "pointwidth": "1.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.5"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "3.75"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.5"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "Time",
            "long_name": "Time",
            "pointwidth": "0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "3.7631578"
        },
        "M": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "M",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "long_name": "Member",
            "pointwidth": "1.0"
        },
        "P": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "P",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "mb",
            "gridtype": "0",
            "long_name": "Pressure level"
        },
        "dir": "SOURCES/HADLEY"
    },
    "HELLERMAN": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "HELLERMAN",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.HELLERMAN/.dataset_documentation.html",
            "iridlhasSemantics": "iridl:NOAA",
            "Conventions": "IRIDL",
            "GCMD_id": "HELLERMAN",
            "references": "Hellerman_Rosenstein1983",
            "description": "Hellerman and Rosenstein Global Wind Stress Climatology"
        },
        "tauy": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "tauy",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "meridional wind stress",
            "units": "dynes/cm2"
        },
        "taux": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "taux",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "long_name": "zonal wind stress",
            "units": "dynes/cm2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "standard_name": "longitude",
            "pointwidth": "2.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "2.0"
        },
        "dir": "SOURCES/HELLERMAN"
    },
    "IBGE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IBGE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Municipiolavoura_temporariasource": ">IBGE</a>",
            "Municipiolavoura_permanentesource": ">IBGE</a>",
            "Municipiodescription": "Produ\\xc3\\xa7\\xc3\\xa3o Agr\\xc3\\xadcola Municipal",
            "description": "Instituto Brasileiro de Geografia e Estat\\xc3\\xadstica",
            "Conventions": "IRIDL"
        },
        "Municipio": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Municipio",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "lavoura_temporaria": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lavoura_temporaria",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "trigo_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "trigo_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do trigo"
                },
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Municipio geometry",
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "sorgo_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sorgo_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do sorgo"
                },
                "soja_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "soja_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do soja"
                },
                "soja_AcP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "soja_AcP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "percent",
                    "long_name": "\\xc3\\x81rea colhida do soja",
                    "scale_max": "100.0"
                },
                "municode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "municode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "milho_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "milho_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do milho"
                },
                "milho_AcP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "milho_AcP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "percent",
                    "long_name": "\\xc3\\x81rea colhida do milho",
                    "scale_max": "100.0"
                },
                "canaAc_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "canaAc_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do cana de a\\xc3\\xa7\\xc3\\xbacar"
                },
                "arroz_rendimiento": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "arroz_rendimiento",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do arroz"
                }
            },
            "lavoura_permanente": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lavoura_permanente",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "the_geom": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "the_geom",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Municipio geometry",
                    "units": "unitless",
                    "PGtype": "bytea",
                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                    "SpatialReferenceSystemWKT": "]]"
                },
                "municode": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "municode",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "cafe": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cafe",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "0.0",
                    "missing_value": "-9.0",
                    "units": "kg/hectare",
                    "long_name": "Rendimento m\\xc3\\xa9dio da produ\\xc3\\xa7\\xc3\\xa3o do caf\\xc3\\xa9"
                }
            }
        },
        "municode_id_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "municode_id_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "municode_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "municode_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "municode_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "municode_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "municode_id": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "municode_id",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "municode": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "municode",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "long_name": "Time",
            "pointwidth": "12"
        },
        "dir": "SOURCES/IBGE"
    },
    "ICE": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "ICE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "COREVOSTOKCO2long_name": "$@ CO sub 2$",
            "COREVOSTOKiridlhasSemantics": "iridl:CNRS",
            "COREVOSTOKreferences": "Jouzel_etal1987 Petit_etal1990",
            "COREQUELCCAYAreferences": "Thompson_Mosley-Thompson1989",
            "COREQUELCCAYAiridlhasSemantics": "iridl:OhioStateUniversity",
            "COREGRIPreferences": "Dansgaard_etal1993 GRIPmembers1993",
            "COREGRIPiridlhasSemantics": "iridl:CNRS",
            "COREdescription": "Chemical measurements from ice cores",
            "COREiridlhasSemantics": "iridl:IceCore",
            "description": "Chemical measurements from ice cores",
            "Conventions": "IRIDL"
        },
        "CORE": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CORE",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "VOSTOK": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "VOSTOK",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "long_name": "temperature difference from present"
                },
                "ice_age": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ice_age",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "history": "Z regridded on ICE CORE VOSTOK ice_age",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.999901",
                    "long_name": "Ice Age",
                    "units": "kya"
                },
                "gas_age": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gas_age",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "history": "Z regridded on ICE CORE VOSTOK gas_age",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.999901",
                    "long_name": "Gas Age",
                    "units": "kya"
                },
                "dstvlm": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dstvlm",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "10-9cm3g-1",
                    "missing_value": "-99.999901",
                    "history": "noaa ftp site",
                    "long_name": "dust volume: insoluble microparticles"
                },
                "dstflx": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "dstflx",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mg m-2 a-1",
                    "missing_value": "-99.999901",
                    "history": "noaa ftp site",
                    "long_name": "dust flux"
                },
                "deuterium": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "deuterium",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless"
                },
                "CO2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CO2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.999901",
                        "history": "noaa ftp site",
                        "long_name": "carbon dioxide minimum",
                        "units": "ppmv"
                    },
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.999901",
                        "history": "noaa ftp site",
                        "long_name": "carbon dioxide",
                        "units": "ppmv"
                    },
                    "max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.999901",
                        "history": "noaa ftp site",
                        "long_name": "carbon dioxide maximum",
                        "units": "ppmv"
                    },
                    "ice_age": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ice_age",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.999901",
                        "history": " noaa ftp site",
                        "long_name": "Ice Age",
                        "units": "kya"
                    },
                    "gas_age": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gas_age",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-99.999901",
                        "history": " noaa ftp site",
                        "long_name": "Gas Age",
                        "units": "kya"
                    }
                },
                "ch4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ch4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ppbv",
                    "missing_value": "-99.999901",
                    "history": "noaa ftp site",
                    "long_name": "methane"
                }
            },
            "QUELCCAYA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "QUELCCAYA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "o18": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "o18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "0.0",
                    "units": "per mil",
                    "long_name": "Oxygen 18 isotopic ratio",
                    "history": "noaa ftp site"
                }
            },
            "GRIP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GRIP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "o18": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "o18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.999901",
                    "units": "per mil",
                    "long_name": "Oxygen 18 isotopic ratio",
                    "history": "noaa ftp site"
                },
                "ch4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ch4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.999901",
                    "units": "ppbv",
                    "long_name": "Methane",
                    "history": "noaa ftp site"
                }
            }
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "years before present",
            "gridtype": "0",
            "long_name": "age",
            "pointwidth": "100.0"
        },
        "Z_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Depth"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "kya",
            "gridtype": "0",
            "long_name": "time"
        },
        "Z_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Depth"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "long_name": "Depth"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "years since 0001-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "add_offset": "-0.5"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "kya",
            "gridtype": "0",
            "pointwidth": "0.2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "kya",
            "gridtype": "0"
        },
        "dir": "SOURCES/ICE"
    },
    "IGOSS": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IGOSS",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "TOPEXUTCSRreferences": "Tapley_etal1994",
            "TOPEXUTCSRdescription": "University of Texas at Austin Center for Space Research TOPEX/POSEIDON Gridded Sea Level Anomalies",
            "TOPEXUTCSRdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.TOPEX.UTCSR.dataset_documentation.html",
            "TOPEXNOAAreferences": "Cheney_etal1994",
            "TOPEXNOAAdescription": "NOAA TOPEX/POSEIDON Altimeter Gridded Sea Level Analysis",
            "TOPEXNOAAdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.TOPEX.NOAA.dataset_documentation.html",
            "TOPEXdescription": "TOPEX/POSEIDON altimeter gridded sea level analysis of sea surface heights and anomalies",
            "TOGATAOreferences": "Mangum_etal1994 Soreide_etal1994",
            "TOGATAOdescription": "Wind vectors and sea surface temperatures from the TOGA-TAO array in the tropical Pacific",
            "TOGATAOiridlhasSemantics": "iridl:PMEL",
            "TOGATAOdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.TOGA-TAO.dataset_documentation.html",
            "siomonthlyheat_storagelong_name": "heat storage",
            "siomonthlyheat_storagedescription": "Monthly heat storage data from Scripps Institution of Oceanography",
            "siomonthlyheat_storagedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.sio.monthly.heat_storage.dataset_documentation.html",
            "siomonthlyheat_storageiridlhasSemantics": "iriref:White_W",
            "siomonthlydescription": "Monthly heat storage data from Scripps Institution of Oceanography",
            "siomonthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.sio.monthly.dataset_documentation.html",
            "sioclimatologydescription": "Climatological heat storage, mixed layer depth, and temperature data from Scripps Institution of Oceanography. ",
            "sioclimatologyiridlhasSemantics": "iridl:climatology",
            "siodescription": "Climatological and monthly heat storage and mixed layer depth data from Scripps Institution of Oceanography",
            "nmcReyn_SmithOIv2weeklyexpires": "1615161600",
            "nmcReyn_SmithOIv2monthlyexpires": "1615161600",
            "nmcReyn_SmithOIv2monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.nmc.Reyn_SmithOIv2.monthly.dataset_documentation.html",
            "nmcReyn_SmithOIv2monthlynote": "revised 13 Sep 2005: replaced pre Apr 2002 files with Apr 2002 versions",
            "nmcReyn_SmithOIv2climatologyc8110long_name": "1981-2010",
            "nmcReyn_SmithOIv2climatologyc8110dataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/NOAA/NCEP/EMC/CMB/GLOBAL/Reyn_SmithOIv2/Note_SST_Climatology_1981-2010.pdf",
            "nmcReyn_SmithOIv2climatologyc8110source": "https://www.cpc.ncep.noaa.gov/products/people/yxue/sstclim/",
            "nmcReyn_SmithOIv2climatologyc7100long_name": "1971-2000",
            "nmcReyn_SmithOIv2climatologyc6190long_name": "1961-1990",
            "nmcReyn_SmithOIv2climatologyiridlhasSemantics": "iridl:climatology",
            "nmcReyn_SmithOIv2references": "Reynolds_etal2002",
            "nmcReyn_SmithOIv2description": "SST fields updated from version 1 with more COADS data, new sea-ice to SST conversion algorithm, and 1971-2000 climatology",
            "nmcReyn_SmithOIv2OISST": "http://www.emc.ncep.noaa.gov/research/cmb/sst_analysis/",
            "nmcReyn_SmithOIv1weeklydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.nmc.Reyn_SmithOIv1.weekly.dataset_documentation.html",
            "nmcReyn_SmithOIv1pentadclimatologydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.nmc.Reyn_SmithOIv1.pentad-climatology.dataset_documentation.html",
            "nmcReyn_SmithOIv1monthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.nmc.Reyn_SmithOIv1.monthly.dataset_documentation.html",
            "nmcReyn_SmithOIv1climatologydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.nmc.Reyn_SmithOIv1.climatology.dataset_documentation.html",
            "nmcReyn_SmithOIv1ReynoldsSmithOIv2": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CMB/.GLOBAL/.Reyn_SmithOIv2/",
            "nmcReyn_SmithOIv1references": "Reynolds:Smith1994",
            "nmcReyn_SmithOIv1description": "Sea surface temperature fields blended from ship, buoy and bias-corrected satellite data  (Reynolds and Smith 1994)",
            "leetmadescription": "Pacific surface currents and equatorial thermocline depth",
            "leetmadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.leetma.dataset_documentation.html",
            "leetmairidlhasSemantics": "iriref:Leetmaa_A",
            "fsudescription": "Florida State University wind analysis",
            "fsudataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.fsu.dataset_documentation.html",
            "ers1references": "Miller_etal1993",
            "ers1description": "Analysis of monthly mean ERS-1 altimeter and tide gauge measurements at 30 island locations in the central and western Pacific",
            "ers1dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.ers1.dataset_documentation.html",
            "australiahistory": "The surface winds are calculated using boundary layer similarity theory. <b>AUSTRALIA</b>",
            "australiadescription": "Surface winds from the Australian Bureau of Meteorology in Melbourne",
            "australiadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.australia.dataset_documentation.html",
            "australiairidlhasSemantics": "iriref:Parker_P",
            "TOGATAOhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.TOGA-TAO.html",
            "description": "Integrated Global Ocean Services System Products Bulletin",
            "data_productshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.data_products.html",
            "Conventions": "IRIDL",
            "analyseshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.analyses.html",
            "iridlhasSemantics": "iriref:Tourre_Y",
            "products_bulletinhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IGOSS/.products_bulletin.html"
        },
        "TOPEX": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TOPEX",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "UTCSR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "UTCSR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ssha": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssha",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "60.0",
                    "scale_min": "-60.0",
                    "colormap": "12632256",
                    "CS": "-60",
                    "CE": "60",
                    "units": "cm",
                    "long_name": "Sea Surface Height Anomaly",
                    "history": "Monthly mean sea surface height. <B>USA</B>",
                    "missing_value": "999.0"
                },
                "ssh": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "cm",
                    "long_name": "Sea Surface Height",
                    "history": "Monthly mean sea surface height. <B>USA</B>",
                    "missing_value": "999.0"
                }
            },
            "NOAA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "sshd": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sshd",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "60.0",
                    "scale_min": "-60.0",
                    "colormap": "12632256",
                    "CS": "-60",
                    "CE": "60",
                    "units": "cm",
                    "long_name": "Sea Surface Height Deviations",
                    "history": "Monthly mean sea surface height deviations. <B>USA</B>",
                    "missing_value": "NaN"
                },
                "ssha": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ssha",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "60.0",
                    "scale_min": "-60.0",
                    "colormap": "12632256",
                    "CS": "-60",
                    "CE": "60",
                    "units": "cm",
                    "long_name": "Sea Surface Height Anomaly",
                    "history": "Monthly mean sea surface height anomaly. <B>USA</B>",
                    "missing_value": "NaN"
                }
            }
        },
        "TOGATAOcdf": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "TOGA-TAO.cdf",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "va": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "va",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "10.0",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "CE": "10",
                "CSCALE": "0.035",
                "generic_name": "v",
                "long_name": "meridional wind anomaly",
                "CS": "-10",
                "scale_min": "-10.0",
                "FORTRAN_format": "F9.4",
                "CI": "1",
                "epic_code": "423",
                "units": "m s-1",
                "missing_value": "1.00000004E35"
            },
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "10.0",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "CE": "10",
                "CSCALE": "0.035",
                "generic_name": "v",
                "long_name": "meridional wind velocity",
                "CS": "-10",
                "scale_min": "-10.0",
                "FORTRAN_format": "F9.4",
                "CI": "1",
                "epic_code": "423",
                "units": "m s-1",
                "missing_value": "1.00000004E35"
            },
            "ua": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ua",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "10.0",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "CE": "10",
                "CSCALE": "0.035",
                "generic_name": "u",
                "long_name": "zonal wind anomaly",
                "CS": "-10",
                "scale_min": "-10.0",
                "FORTRAN_format": "F9.4",
                "CI": "1",
                "epic_code": "422",
                "units": "m s-1",
                "missing_value": "1.00000004E35"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_max": "10.0",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "CE": "10",
                "CSCALE": "0.035",
                "generic_name": "u",
                "long_name": "zonal wind velocity",
                "CS": "-10",
                "scale_min": "-10.0",
                "FORTRAN_format": "F9.4",
                "CI": "1",
                "epic_code": "422",
                "units": "m s-1",
                "missing_value": "1.00000004E35"
            },
            "ssta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ssta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "maxncolor": "254",
                "colormap": "2763429",
                "scale_max": "4.1999998",
                "ncolor": "254",
                "scale_min": "-4.1999998",
                "CS": "-4.1999998",
                "colorscalename": "sstacolorscale",
                "CE": "4.1999998",
                "FORTRAN_format": "f10.2",
                "units": "C",
                "generic_name": "temp",
                "CI": "0.25",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "long_name": "sea surface temperature anomaly",
                "epic_code": "20",
                "missing_value": "1.00000004E35"
            },
            "sst": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sst",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "colorscalename": "sstcolorscale",
                "scale_max": "35.0",
                "ncolor": "256",
                "scale_min": "-2.0",
                "colormap": "12632256",
                "CS": "-2",
                "CE": "35",
                "FORTRAN_format": "f10.2",
                "units": "C",
                "generic_name": "temp",
                "CI": "0.5",
                "history": "><B>USA-FRANCE-JAPAN-KOREA-TAIWAN</B></a>)]",
                "long_name": "sea surface temperature",
                "epic_code": "20",
                "missing_value": "1.00000004E35"
            }
        },
        "sio": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "sio",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "heat_storage": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "heat_storage",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "error": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "error",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Interpolation Error",
                        "missing_value": "9.99999962E35"
                    },
                    "anomalies": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomalies",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "10**9 J/m2",
                        "colormap": "2763429",
                        "scale_max": "2.9880478",
                        "ncolor": "254",
                        "scale_min": "-2.9880478",
                        "CS": "-2.9880478",
                        "CE": "2.9880478",
                        "colorscalename": "custom",
                        "CI": "0.25",
                        "long_name": "Heat Storage Anomalies",
                        "history": "Vertically averaged (0/400m) heat storage anomaly.  1979-1988 climatology",
                        "missing_value": "9.99999962E35"
                    }
                }
            },
            "coastal": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "coastal",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "wv": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wv",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional wind velocity",
                    "units": "m s-1",
                    "missing_value": "999999.0"
                },
                "wu": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wu",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal wind velocity",
                    "units": "m s-1",
                    "missing_value": "999999.0"
                },
                "v": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "v",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "meridional velocity",
                    "units": "m s-1",
                    "missing_value": "999999.0"
                },
                "u": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "u",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "zonal velocity",
                    "units": "m s-1",
                    "missing_value": "999999.0"
                },
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "temperature",
                    "units": "Celsius_scale",
                    "missing_value": "999999.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north"
                }
            },
            "climatology": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "climatology",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "temp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Celsius_scale",
                    "colormap": "12632256",
                    "scale_max": "35.0",
                    "ncolor": "256",
                    "scale_min": "-2.0",
                    "CS": "-2",
                    "colorscalename": "sstcolorscale",
                    "CE": "35",
                    "long_name": "temperature",
                    "missing_value": "9.99999962E35"
                },
                "mld": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mld",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "m",
                    "long_name": "Mixed Layer Depth",
                    "missing_value": "9.99999962E35"
                },
                "heat_storage": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "heat_storage",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "10**7 Joules/m2",
                    "long_name": "Heat Storage",
                    "missing_value": "9.99999962E35"
                }
            }
        },
        "nmc": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "nmc",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Reyn_SmithOIv2": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Reyn_SmithOIv2",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "weekly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "weekly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature Anomaly",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "scale_max": "4.1999998",
                        "ncolor": "254",
                        "scale_min": "-4.1999998",
                        "CS": "-4.1999998",
                        "colorscalename": "sstacolorscale",
                        "CE": "4.1999998",
                        "units": "degree_Celsius",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "expires": "1615161600"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615161600",
                        "units": "Celsius_scale",
                        "colorscalename": "sstcolorscale",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "scale_min": "-2.0",
                        "colormap": "12632256",
                        "CS": "-2",
                        "CE": "35",
                        "long_name": "Sea Surface Temperature"
                    },
                    "sea_ice": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615161600",
                        "scale_max": "100",
                        "long_name": "Sea Ice Concentration",
                        "units": "percent",
                        "scale_min": "0"
                    },
                    "mask": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mask",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Land-Sea Mask",
                        "expires": "1615161600"
                    },
                    "err": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "err",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615161600",
                        "scale_max": "1.0",
                        "long_name": "SST Normalized Error Variance",
                        "units": "unitless",
                        "scale_min": "0.0"
                    }
                },
                "pentadclimatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pentad-climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "35.0",
                        "scale_min": "-2.0",
                        "CS": "-2",
                        "CE": "35",
                        "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                        "units": "Celsius_scale",
                        "missing_value": "NaN",
                        "file_missing_value": "-999.90002",
                        "colormap": "12632256",
                        "ncolor": "256",
                        "colorscalename": "sstcolorscale",
                        "long_name": "Sea Surface Temperature"
                    }
                },
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature Anomaly",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "scale_max": "4.1999998",
                        "ncolor": "254",
                        "scale_min": "-4.1999998",
                        "CS": "-4.1999998",
                        "colorscalename": "sstacolorscale",
                        "CE": "4.1999998",
                        "units": "degree_Celsius",
                        "missing_value": "NaN",
                        "expires": "1615161600",
                        "pointwidth": "1.0"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615161600",
                        "units": "Celsius_scale",
                        "colorscalename": "sstcolorscale",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "scale_min": "-2.0",
                        "colormap": "12632256",
                        "CS": "-2",
                        "CE": "35",
                        "standard_name": "sea_surface_temperature",
                        "long_name": "Sea Surface Temperature",
                        "pointwidth": "1.0"
                    },
                    "sea_ice": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sea_ice",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1615161600",
                        "scale_max": "100",
                        "long_name": "Sea Ice Concentration",
                        "standard_name": "sea_ice_area_fraction",
                        "units": "percent",
                        "scale_min": "0",
                        "valid_max": "100",
                        "valid_min": "0",
                        "pointwidth": "1.0"
                    },
                    "mask": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mask",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "standard_name": "land_binary_mask",
                        "long_name": "Land-Sea Mask",
                        "expires": "1615161600"
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mask": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mask",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Land-Sea Mask"
                    },
                    "c8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "colormap": "12632256",
                            "scale_max": "35.0",
                            "ncolor": "256",
                            "scale_min": "-2.0",
                            "CS": "-2",
                            "colorscalename": "sstcolorscale",
                            "CE": "35",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "-9999.0"
                        }
                    },
                    "c7100": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c7100",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "colormap": "12632256",
                            "scale_max": "35.0",
                            "ncolor": "256",
                            "scale_min": "-2.0",
                            "CS": "-2",
                            "colorscalename": "sstcolorscale",
                            "CE": "35",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "-999.90002"
                        }
                    },
                    "c6190": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c6190",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "Celsius_scale",
                            "colormap": "12632256",
                            "scale_max": "35.0",
                            "ncolor": "256",
                            "scale_min": "-2.0",
                            "CS": "-2",
                            "colorscalename": "sstcolorscale",
                            "CE": "35",
                            "long_name": "Sea Surface Temperature",
                            "missing_value": "-999.90002"
                        }
                    }
                }
            },
            "Reyn_SmithOIv1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Reyn_SmithOIv1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "weekly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "weekly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature Anomaly",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "scale_max": "4.1999998",
                        "ncolor": "254",
                        "scale_min": "-4.1999998",
                        "CS": "-4.1999998",
                        "colorscalename": "sstacolorscale",
                        "CE": "4.1999998",
                        "units": "degree_Celsius",
                        "history": "T regridded on NOAA NCEP EMC CMB GLOBAL Reyn_SmithOIv1 pentad-climatology sst"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "colormap": "12632256",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "scale_min": "-2.0",
                        "CS": "-2",
                        "colorscalename": "sstcolorscale",
                        "CE": "35",
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature",
                        "history": "Weekly mean sea surface temperature (blended from ship, buoy, and bias-corrected satellite data)."
                    }
                },
                "pentadclimatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pentad-climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "colormap": "12632256",
                        "scale_max": "35.0",
                        "ncolor": "256",
                        "scale_min": "-2.0",
                        "CS": "-2",
                        "colorscalename": "sstcolorscale",
                        "CE": "35",
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature",
                        "labelinterval": "5.0",
                        "history": "Interpolated Climatological sea surface temperature (blended from ship and buoy, data (1950-1979))."
                    }
                },
                "monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_Celsius",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "history": "Monthly mean sea surface temperature anomaly (blended from ship, buoy, and bias-corrected satellite data)",
                        "scale_max": "4.1999998",
                        "ncolor": "254",
                        "scale_min": "-4.1999998",
                        "CS": "-4.1999998",
                        "colorscalename": "sstacolorscale",
                        "CE": "4.1999998",
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature Anomaly"
                    },
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "colormap": "12632256",
                        "scale_max": "3500.0",
                        "ncolor": "256",
                        "scale_min": "-200.0",
                        "CS": "-2",
                        "colorscalename": "sstcolorscale",
                        "CE": "35",
                        "PLOTCOAST": "1",
                        "long_name": "Sea Surface Temperature",
                        "history": "Monthly mean sea surface temperature (blended from ship, buoy and bias-corrected satellite data). "
                    }
                },
                "climatology": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "climatology",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "colormap": "12632256",
                        "scale_max": "3500.0",
                        "ncolor": "256",
                        "scale_min": "-200.0",
                        "CS": "-2",
                        "colorscalename": "sstcolorscale",
                        "CE": "35",
                        "PLOTCOAST": "1",
                        "iridlhasSemantics": "iridl:climatology",
                        "long_name": "Sea Surface Temperature",
                        "references": "Reynolds_Smith1995",
                        "labelinterval": "5.0",
                        "history": "Climatological sea surface temperature (blended from ship and buoy, data (1950-1979))."
                    }
                }
            }
        },
        "leetma": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "leetma",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas v",
                "units": "cm/s",
                "long_name": "meridional velocity",
                "missing_value": "NaN"
            },
            "umag": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "umag",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas u",
                "long_name": "surface speed",
                "CI": "50.0",
                "fnname": "sqrt",
                "units": "unitless",
                "missing_value": "NaN"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "history": "T:  Feb 2005 to Oct 2008 appended from NOAA NCEP EMC CMB Pacific godas u",
                "units": "cm/s",
                "long_name": "zonal velocity",
                "missing_value": "NaN"
            },
            "d20C": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "d20C",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "colormap": "2763429",
                "scale_max": "200.0",
                "maxncolor": "254",
                "ncolor": "254",
                "scale_min": "0.0",
                "CS": "0",
                "CE": "200",
                "long_name": "Depth of 20C",
                "missing_value": "NaN",
                "history": "toS: regridded Z to NOAA NCEP EMC CMB Pacific monthly temp",
                "units": "m",
                "bounds": "Z",
                "positive": "down"
            }
        },
        "fsu": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "fsu",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "absuv": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuv",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "(m/s)2",
                "long_name": "meridional pseudo-stress",
                "history": ">USA-FRANCE</a></B>",
                "missing_value": "999.0",
                "arrowsperinch": "5",
                "CSCALE": "1.0"
            },
            "absuu": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "absuu",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "(m/s)2",
                "long_name": "zonal pseudo-stress",
                "history": "Monthly mean surface pseudo-stress using variational, subjective, and objective-subjective techniques in the Indian, Pacific, and Atlantic oceans.<B>USA-FRANCE</B>",
                "missing_value": "999.0",
                "arrowsperinch": "5",
                "CSCALE": "1.0"
            }
        },
        "ers1": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ers1",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "stations": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "stations",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north"
                }
            },
            "sealevel": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "sealevel",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "long_name": "Sea Level Anomaly",
                "history": "Annual and semiannual signals have been removed, leaving only the interannual changes relative to the April 1985-86 mean.",
                "CI": "4.0",
                "missing_value": "999.0"
            }
        },
        "canadaplots": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "canadaplots",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "australiaplots": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "australiaplots",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ]
        },
        "australia": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "australia",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "meridional surface wind",
                "units": "m s-1",
                "missing_value": "396.0",
                "history": "The surface winds are calculated using boundary layer similarity theory. <b>AUSTRALIA</b>"
            },
            "u": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "u",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "zonal surface wind",
                "units": "m s-1",
                "missing_value": "396.0",
                "history": "The surface winds are calculated using boundary layer similarity theory. <b>AUSTRALIA</b>"
            }
        },
        "Y_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T_15": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_15",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "Y_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T_14": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_14",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "4.0",
            "standard_name": "longitude"
        },
        "Y_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "epic_code": "500"
        },
        "time_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "epic_code": "502"
        },
        "Y_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "epic_code": "500"
        },
        "time": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "time",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "depth": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "depth",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "epic_code": "3"
        },
        "X_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "1.0",
            "epic_code": "502"
        },
        "T_13": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_13",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "T_12": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_12",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time"
        },
        "T_11": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_11",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "STA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2",
            "long_name": "Station"
        },
        "Z_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0"
        },
        "X_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "5.0",
            "standard_name": "longitude"
        },
        "Y_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "T_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "expires": "1615161600",
            "standard_name": "time"
        },
        "T_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "pentads since 1960-01-01",
            "gridtype": "1",
            "modulus": "73.0",
            "calendar": "365",
            "modulo": "73.0",
            "pointwidth": "1.0"
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "expires": "1615161600",
            "pointwidth": "1.0",
            "standard_name": "time"
        },
        "X_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "pointwidth": "7.0",
            "standard_name": "time",
            "add_offset": "2444910.0",
            "calendar": "standard"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "pentads since 1960-01-01",
            "gridtype": "1",
            "calendar": "365",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "73.0",
            "modulus": "73.0"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "calendar": "360",
            "pointwidth": "1.0",
            "standard_name": "time",
            "modulo": "12.0",
            "modulus": "12.0"
        },
        "X_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "1.0",
            "standard_name": "longitude"
        },
        "Z": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Z",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "m",
            "gridtype": "0",
            "positive": "down"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "latitude"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "1.5",
            "standard_name": "longitude"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "latitude"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "2.0",
            "standard_name": "longitude"
        },
        "I": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "I",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "1.3333334",
            "standard_name": "latitude"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "pointwidth": "6.0",
            "standard_name": "longitude"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "pointwidth": "1.0",
            "standard_name": "time",
            "calendar": "360"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "1",
            "pointwidth": "2.5",
            "standard_name": "longitude"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "pointwidth": "2.5",
            "standard_name": "latitude"
        },
        "dir": "SOURCES/IGOSS"
    },
    "IITM": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IITM",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Subdivisiondescription": "Subdivisional-level precipitation data from the IITM",
            "Subdivisiondataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IITM/.Subdivision.dataset_documentation.html",
            "SubdivisioniridlhasSemantics": "iridl:Climate_Division",
            "Subdivisionreferences": "Pant_RupaKumar1997 Parthasarathy_etal1995b Mooley_etal1981 Parthasarathy_etal1987 Parthasarathy_etal1993 Parthasarathy_etal1995",
            "RegionTemperaturelongname": "Homogeneous Indian Monthly Temperature-Regional",
            "RegionTemperaturedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IITM/.Region.Temperature.dataset_documentation.html",
            "RegionTemperaturereferences": "Pant_RupaKumar1997 RupaKumar_etal1994",
            "RegionTemperaturedescription": "Region-level temperature data from the IITM",
            "RegionRainfalllongname": "Homogeneous Indian Monthly Rainfall-Regional",
            "RegionRainfalldataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IITM/.Region.Rainfall.dataset_documentation.html",
            "RegionRainfallreferences": "Pant_RupaKumar1997 Parthasarathy_etal1995b Mooley_etal1981 Parthasarathy_etal1987 Parthasarathy_etal1993 Parthasarathy_etal1995",
            "RegionRainfalldescription": "Region-level precipitation data from the IITM",
            "Regiondescription": "Region-level precipitation and temperature data from the IITM",
            "RegioniridlhasSemantics": "iridl:Climate_Division",
            "All_Indiav18712016Rainfalldescription": "County-level precipitation data from the IITM for 1871-2016",
            "All_Indiav18712016Rainfallinstitution": "Indian Institute of Tropical Meteorology (IITM)",
            "All_Indiav18712016RainfallPDF_document": "https://iridl.ldeo.columbia.edu/documentation/IITM/All_India/Readme_v1871-2016.pdf",
            "All_Indiav18712016Rainfallnote": " provided IITM is duly acknowledged as the data source. Any redistribution should necessarily include this document.",
            "All_Indiav18712016Rainfalllong_name": "Indian Monthly Rainfall - All_India",
            "All_Indiav18712016Rainfallreferences": "Pant_RupaKumar1997 Parthasarathy_etal1995b Mooley_etal1981 Parthasarathy_etal1987 Parthasarathy_etal1993 Parthasarathy_etal1995",
            "All_IndiaTemperaturelongname": "Indian Monthly Temperature - All_India",
            "All_IndiaTemperaturedataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IITM/.All_India.Temperature.dataset_documentation.html",
            "All_IndiaTemperaturereferences": "Pant_RupaKumar1997 RupaKumar_etal1994",
            "All_IndiaTemperaturedescription": "County-level temperature data from the IITM",
            "All_IndiaRainfalllongname": "Indian Monthly Rainfall - All_India",
            "All_IndiaRainfalldataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IITM/.All_India.Rainfall.dataset_documentation.html",
            "All_IndiaRainfallreferences": "Pant_RupaKumar1997 Parthasarathy_etal1995b Mooley_etal1981 Parthasarathy_etal1987 Parthasarathy_etal1993 Parthasarathy_etal1995",
            "All_IndiaRainfalldescription": "County-level precipitation data from the IITM",
            "All_Indiadescription": "Country-level precipitation and temperature data from the IITM",
            "description": "Indian Institute of Tropical Meteorology",
            "iridlhasSemantics": "iridl:IITM",
            "Conventions": "IRIDL"
        },
        "Subdivision": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Subdivision",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "PCPN": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "PCPN",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_factor": "0.1",
                "units": "mm",
                "long_name": "Precipitation"
            },
            "Name": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Name",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "Subdivision Name",
                "units": "unitless"
            },
            "lon": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lon",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "65.0",
                "scale_max": "98.0",
                "units": "degree_east",
                "long_name": "Longitude"
            },
            "lat": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "lat",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "scale_min": "5.0",
                "scale_max": "35.0",
                "units": "degree_north",
                "long_name": "Latitude"
            },
            "Area": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Area",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "km^2"
            }
        },
        "Region": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Region",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Temperature": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Temperature",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "Celsius_scale",
                    "long_name": "Minimum Temperature"
                },
                "TMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "Celsius_scale",
                    "long_name": "Maximum Temperature"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Region Name",
                    "units": "unitless"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "65.0",
                    "scale_max": "98.0",
                    "units": "degree_east",
                    "long_name": "Longitude"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "5.0",
                    "scale_max": "35.0",
                    "units": "degree_north",
                    "long_name": "Latitude"
                }
            },
            "Rainfall": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Rainfall",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PCPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PCPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "mm",
                    "long_name": "Precipitation"
                },
                "Name": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Name",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Region Name",
                    "units": "unitless"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "65.0",
                    "scale_max": "98.0",
                    "units": "degree_east",
                    "long_name": "Longitude"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "5.0",
                    "scale_max": "35.0",
                    "units": "degree_north",
                    "long_name": "Latitude"
                },
                "Area": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Area",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "km^2"
                }
            }
        },
        "All_India": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "All_India",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v18712016": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1871-2016",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Rainfall": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Rainfall",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PCPN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PCPN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "missing_value": "3.00000006E33",
                        "long_name": "ALL-INDIA  RAINFALL"
                    }
                }
            },
            "Temperature": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Temperature",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "TMIN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "Celsius_scale",
                    "long_name": "Minimum Temperature"
                },
                "TMAX": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TMAX",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "Celsius_scale",
                    "long_name": "Maximum Temperature"
                }
            },
            "Rainfall": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Rainfall",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "PCPN": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PCPN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_factor": "0.1",
                    "units": "mm",
                    "long_name": "Precipitation"
                }
            }
        },
        "DIV_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DIV_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "subdivision ids",
            "gridtype": "0",
            "long_name": "Subdivision",
            "pointwidth": "1.0"
        },
        "DIV_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DIV_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "region ids",
            "gridtype": "0",
            "long_name": "Region",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "DIV": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DIV",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "region ids",
            "gridtype": "0",
            "long_name": "Region",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "long_name": "Time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/IITM"
    },
    "IMD": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IMD",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "RF0p5griddeddailyv1p0description": "IMD 0.5 Degree Daily Gridded Precipitation Data Set",
            "RF0p5griddeddailyv1p0iridlhasSemantics": "iridl:India_ERFS",
            "RF0p25griddeddailyv2p0description": "IMD 0.25 Degree Daily Gridded Precipitation Data Set",
            "RF0p25griddeddailyv2p0iridlhasSemantics": "iridl:India_ERFS",
            "RF0p25griddeddailyv19012015description": "IMD 0.25 Degree Daily Gridded Precipitation Data Set",
            "RF0p25griddeddailyv19012015iridlhasSemantics": "iridl:India_ERFS",
            "NCC12008v1p0description": "IMD High Resolution Gridded Precipitation Data Set",
            "NCC12008v1p0references": "Rajeevan_etal2008",
            "NCC12008v1p0dataset_documentation": "http://www.agu.org/journals/gl/gl0818/2008GL035143/",
            "NCC12008description": "NCC1-2008 High Resolution Gridded Precipitation Data Set",
            "NCC12008iridlhasSemantics": "iridl:India_ERFS",
            "NCC12005v4p0description": "IMD High Resolution (1&deg;x1&deg;) Daily Gridded Rainfall Data For the Indian Region 1951-2015 Version 4 (NCC1/2005)",
            "NCC12005v4p0data": "http://www.imd.ernet.in/nccraindata.htm",
            "NCC12005v4p0IMDHP": "http://www.imd.gov.in/",
            "NCC12005v4p0references": "Rajeevan_etal2005 Rajeevan_etal2006",
            "NCC12005v2p0description": "IMD High Resolution (1&deg;x1&deg;) Daily Gridded Rainfall Data For the Indian Region 1951-2004 Version 2 (NCC1/2005)",
            "NCC12005v2p0data": "http://www.imd.ernet.in/nccraindata.htm",
            "NCC12005v2p0dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IMD/.NCC1-2005.v2p0.dataset_documentation.html",
            "NCC12005v2p0IMDHP": "http://www.imd.gov.in/",
            "NCC12005v2p0references": "Rajeevan_etal2005 Rajeevan_etal2006",
            "NCC12005v1p0description": "IMD High Resolution (1&deg;x1&deg;) Daily Gridded Rainfall Data for the Indian Region, (NCC1/2005)",
            "NCC12005v1p0NCC12005": "http://iridl.ldeo.columbia.edu/SOURCES/.IMD/.NCC1-2005/.v2p0/",
            "NCC12005v1p0dataset_documentation": "http://www.imd.ernet.in/nccraindata.htm",
            "NCC12005iridlhasSemantics": "iridl:India_ERFS",
            "HRDGTv1p0description": "IMD High Resolution Daily Gridded Temperature Data Set",
            "HRDGTv1p0references": "Srivastava_etal2008",
            "HRDGTv1p0dataset_documentation": "http://www.imdpune.gov.in/ncc_rept/RESEARCH%20%20REPORT%208.pdf",
            "HRDGTv19512015_monthlydescription": "IMD High Resolution Monthly Gridded Temperature Data Set",
            "HRDGTv19512015_monthlyreferences": "Srivastava_etal2008",
            "HRDGTv19512015description": "IMD High Resolution Daily Gridded Temperature Data Set",
            "HRDGTv19512015references": "Srivastava_etal2008",
            "HRDGTdescription": "High Resolution Daily Gridded Temperature Data Set",
            "HRDGTiridlhasSemantics": "iridl:India_ERFS",
            "note": " section of this page to inquire about obtaining data directly from IMD.",
            "iridlhasSemantics": "iridl:IMD",
            "Conventions": "IRIDL",
            "IMDHP": "http://www.imd.gov.in/",
            "long_name": "India Meteorological Department"
        },
        "RF0p5": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RF0p5",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridded": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v1p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "rf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "long_name": "GRIDDED RAINFALL",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "standard_name": "rainfall_rate",
                            "units": "mm/day",
                            "step": "1.0"
                        }
                    }
                }
            }
        },
        "RF0p25": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "RF0p25",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "gridded": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "v2p0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v2p0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "rf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "long_name": "GRIDDED RAINFALL",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "standard_name": "rainfall_rate",
                            "units": "mm/day",
                            "step": "1.0"
                        }
                    },
                    "v19012015": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "v1901-2015",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "stn": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "stn",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "0.0",
                            "long_name": "Number of Stations",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "units": "count",
                            "step": "1.0"
                        },
                        "rf": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rf",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "long_name": "GRIDDED RAINFALL",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "standard_name": "rainfall_rate",
                            "units": "mm/day",
                            "step": "1.0"
                        }
                    }
                }
            }
        },
        "NCC12008": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NCC1-2008",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v1p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "rf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "long_name": "GRIDDED RAINFALL",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "rainfall_rate",
                    "units": "mm/day",
                    "step": "1.0"
                }
            }
        },
        "NCC12005": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NCC1-2005",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v4p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v4p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "stn": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "stn",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "0.0",
                    "long_name": "Number of stations",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "units": "unitless",
                    "step": "1.0"
                },
                "rf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "long_name": "GRIDDED RAINFALL",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "rainfall_rate",
                    "units": "mm/day",
                    "step": "1.0"
                }
            },
            "v2p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v2p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "rf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "long_name": "GRIDDED RAINFALL",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "rainfall_rate",
                    "units": "mm/day",
                    "step": "1.0"
                }
            },
            "v1p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "rf": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rf",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-99.900002",
                    "long_name": "GRIDDED RAINFALL",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "rainfall_rate",
                    "units": "mm/day",
                    "step": "1.0"
                }
            }
        },
        "HRDGT": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "HRDGT",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "v1p0": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1p0",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Minimum Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                },
                "tmean": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmean",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Mean Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                },
                "tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Maximum Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                }
            },
            "v19512015_monthly": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1951-2015_monthly",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmean_climo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmean_climo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperature Monthly Climatology 1951-2015",
                    "history": "Averaged over T2[1951, 2015] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "units": "Celsius_scale",
                    "file_missing_value": "99.900002",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "step": "1.0"
                },
                "tmean": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmean",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperature Monthly Average",
                    "missing_value": "NaN",
                    "history": "Boxes with less than 0.0% dropped",
                    "units": "Celsius_scale",
                    "file_missing_value": "99.900002",
                    "calendar": "standard",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "step": "1.0"
                }
            },
            "v19512015": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "v1951-2015",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "tmin": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmin",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Minimum Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                },
                "tmean": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmean",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Mean Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                },
                "tmax": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "tmax",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "99.900002",
                    "calendar": "standard",
                    "long_name": "Maximum Temperature",
                    "pointwidth": "1.0",
                    "standard_name": "air_temperature",
                    "units": "Celsius_scale",
                    "step": "1.0"
                }
            }
        },
        "X_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.5"
        },
        "Y_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.5"
        },
        "T_10": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_10",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_09": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_09",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "0.25"
        },
        "Y_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "0.25"
        },
        "T_08": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_08",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_07": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_07",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_06": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_06",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1951-01-01 12:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "Y_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "T_05": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_05",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1951-01-01 12:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1951-01-01 12:00:00",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "X_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "Y_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "1",
            "modulo": "12.0",
            "modulus": "12.0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "pointwidth": "1.0"
        },
        "X": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "X",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_east",
            "gridtype": "0",
            "standard_name": "longitude",
            "pointwidth": "1.0"
        },
        "Y": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Y",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "degree_north",
            "gridtype": "0",
            "standard_name": "latitude",
            "pointwidth": "1.0"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/IMD"
    },
    "INIA": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "INIA",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "GRASExpStationsMonthlyData_Source": "http://www.inia.org.uy/online/site/143782I1.php",
            "GRASExpStationsMonthlydescription": "Monthly meteorological observations in Uruguay from INIA experimental stations",
            "GRASExpStationsMonthlydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.INIA/.GRAS.ExpStations.Monthly.dataset_documentation.html",
            "GRASExpStationsDailyData_Source": "http://www.inia.org.uy/online/site/143782I1.php",
            "GRASExpStationsDailydescription": "Daily meteorological observations in Uruguay from INIA experimental stations",
            "GRASExpStationsDailydataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.INIA/.GRAS.ExpStations.Daily.dataset_documentation.html",
            "GRASExpStationsdescription": "INIA Experimental Stations",
            "GRASDNMdescription": "Data from Direcci&#xF3;n Nacional de Meteorolog&#xED;a Uruguay",
            "GRASGRAS_Home": "http://www.inia.uy/gras/",
            "description": "Instituto Nacional de Investigaci&#243;n Agropecuaria - Uruguay",
            "iridlhasSemantics": "iridl:INIA",
            "Conventions": "IRIDL"
        },
        "GRAS": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "GRAS",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ExpStations": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ExpStations",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Monthly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Monthly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "km/day",
                        "missing_value": "-99.900002",
                        "long_name": "Wind"
                    },
                    "tempmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Minimum Temperature"
                    },
                    "tempmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Maximum Temperature"
                    },
                    "tempavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Average Temperature"
                    },
                    "sun": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sun",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hrs",
                        "missing_value": "-99.900002",
                        "long_name": "Hours of Sun"
                    },
                    "rh": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rh",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "long_name": "Relative Humidity"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Potential Evapotranspiration"
                    },
                    "pcpn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pcpn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Precipitation"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-65.0",
                        "scale_max": "-45.0",
                        "units": "degree_east",
                        "long_name": "longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-45.0",
                        "scale_max": "-25.0",
                        "units": "degree_north",
                        "long_name": "latitude"
                    },
                    "evap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "evap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Pan Evaporation"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "elevation"
                    }
                },
                "Daily": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Daily",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "wind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "wind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "km/day",
                        "missing_value": "-99.900002",
                        "long_name": "Wind"
                    },
                    "tempmin": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempmin",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Minimum Temperature"
                    },
                    "tempmax": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempmax",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Maximum Temperature"
                    },
                    "tempavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tempavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Celsius_scale",
                        "missing_value": "-99.900002",
                        "long_name": "Average Temperature"
                    },
                    "sun": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sun",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hrs",
                        "missing_value": "-99.900002",
                        "long_name": "Hours of Sun"
                    },
                    "rh": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rh",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "percent",
                        "missing_value": "-99.900002",
                        "long_name": "Relative Humidity"
                    },
                    "pet": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pet",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Potential Evapotranspiration"
                    },
                    "pcpn": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pcpn",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Precipitation"
                    },
                    "Name": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Name",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-65.0",
                        "scale_max": "-45.0",
                        "units": "degree_east",
                        "long_name": "longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "-45.0",
                        "scale_max": "-25.0",
                        "units": "degree_north",
                        "long_name": "latitude"
                    },
                    "evap": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "evap",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "missing_value": "-99.900002",
                        "long_name": "Pan Evaporation"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "long_name": "elevation"
                    }
                }
            },
            "DNM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "DNM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Stations": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Stations",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "long_name": "Precipitation",
                            "units": "mm/month",
                            "standard_name": "lwe_precipitation_rate"
                        },
                        "Name": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Name",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-59.5",
                            "missing_value": "-9.0",
                            "scale_max": "-52.5",
                            "units": "degree_east",
                            "long_name": "longitude"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-35.5",
                            "missing_value": "-9.0",
                            "scale_max": "-29.5",
                            "units": "degree_north",
                            "long_name": "latitude"
                        },
                        "IWMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IWMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999",
                            "units": "ids"
                        }
                    }
                }
            }
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "julian_day",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "STNID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "STNID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "dir": "SOURCES/INIA"
    },
    "INMET": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "INMET",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "sologeodescription": "Solo geo do Brazil",
            "description": "Instituto Nacional de Meteorologia do Brasil",
            "Conventions": "IRIDL"
        },
        "sologeo": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "sologeo",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "the_google": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "the_google",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "the google",
                "units": "ids",
                "PGtype": "varchar"
            },
            "the_geom": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "the_geom",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "geometry",
                "units": "unitless",
                "PGtype": "bytea",
                "OpenGISSimpleFeature": "MULTIPOLYGON",
                "SpatialReferenceSystemWKT": "]]"
            },
            "slgsubclas": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slgsubclas",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "sub classe solo geo",
                "units": "ids",
                "PGtype": "varchar"
            },
            "slgdescric": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slgdescric",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "descri\\xc3\\xa7\\xc3\\xa3o solo geo",
                "units": "ids",
                "PGtype": "varchar"
            },
            "slgcodigo": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slgcodigo",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "codigo solo geo",
                "missing_value": "NaN",
                "units": "unitless",
                "PGtype": "float8"
            },
            "slgclasse": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "slgclasse",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "long_name": "classe solo geo",
                "units": "ids",
                "PGtype": "varchar"
            }
        },
        "Forecast": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "Forecast",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "rain": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "rain",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "rain_HW": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_HW",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by HOLTWINTERS",
                    "units": "mm",
                    "missing_value": "-999.0"
                },
                "rain_CPT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_CPT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by CPT",
                    "units": "mm",
                    "missing_value": "-999.0"
                },
                "rain_ARIMA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_ARIMA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by ARIMA",
                    "units": "mm",
                    "missing_value": "-999.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-34.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "-74.0",
                    "missing_value": "-999.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "6.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "-34.0",
                    "missing_value": "-999.0"
                },
                "Cor_HW": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_HW",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for HOLTWINTERS",
                    "missing_value": "-999.0",
                    "units": "unitless"
                },
                "Cor_CPT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_CPT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for CPT",
                    "missing_value": "-999.0",
                    "units": "unitless"
                },
                "Cor_ARIMA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_ARIMA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for ARIMA",
                    "missing_value": "-999.0",
                    "units": "unitless"
                }
            },
            "historical": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "historical",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Rio_Grande_do_Sul": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Rio_Grande_do_Sul",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "rain": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "rain",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm",
                        "long_name": "Historical rainfall"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "-48.0",
                        "scale_min": "-58.0",
                        "units": "degree_east",
                        "long_name": "Longitude"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "-26.0",
                        "scale_min": "-34.0",
                        "units": "degree_north",
                        "long_name": "Latitude"
                    }
                }
            },
            "CPT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CPT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "target_date": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "target_date",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "forecast time",
                    "pointwidth": "1",
                    "calendar": "360",
                    "units": "months since 1960-01-01",
                    "bounds": "S"
                },
                "rain_vvel": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_vvel",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by VERTICAL VELOCITY",
                    "units": "mm",
                    "pointwidth": "0"
                },
                "rain_tsm": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_tsm",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by TSM",
                    "units": "mm",
                    "pointwidth": "0"
                },
                "rain_geo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rain_geo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "rain forecast by GEOPOTENTIAL HEIGHT",
                    "units": "mm",
                    "pointwidth": "0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-34.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "-74.0",
                    "pointwidth": "0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "6.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "-34.0",
                    "pointwidth": "0"
                },
                "Cor_vvel": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_vvel",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for VERTICAL VELOCITY",
                    "units": "unitless",
                    "pointwidth": "0"
                },
                "Cor_tsm": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_tsm",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for TSM",
                    "units": "unitless",
                    "pointwidth": "0"
                },
                "Cor_geo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Cor_geo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_min": "-1.0",
                    "scale_max": "1.0",
                    "CE": "1",
                    "CS": "-1",
                    "ncolor": "254",
                    "colorscalename": "correlationcolorscale",
                    "maxncolor": "254",
                    "colormap": "2763429",
                    "long_name": "correlation hindcast for GEOPOTENTIAL HEIGHT",
                    "units": "unitless",
                    "pointwidth": "0"
                }
            }
        },
        "DataBank": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "DataBank",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "Rio_Grande_do_Sul": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Rio_Grande_do_Sul",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "vel_vento_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vel_vento_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Velocidade M\\xc3\\xa9dia do Vento",
                    "units": "m/s",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "umidade_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "umidade_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Umidade Relativa do Ar M\\xc3\\xa9dia",
                    "units": "percent",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_min": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_min",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xadnima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa9dia Compensada",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa1xima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "pressao_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pressao_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Press\\xc3\\xa3o M\\xc3\\xa9dia ao N\\xc3\\xadvel da Esta\\xc3\\xa7\\xc3\\xa3o",
                    "units": "mb",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "precipitacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precipitacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipita\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1ria",
                    "units": "mm",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-48.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "-58.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "location": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "location",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "OpenGISSimpleFeature": "Point",
                    "long_name": "location",
                    "SpatialReferenceSystemWKT": "]]",
                    "scale_max": "-48",
                    "units": "degree_east",
                    "scale_min": "-58",
                    "pointwidth": "1.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-26.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "-34.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "insolacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "insolacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Insola\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1rio",
                    "units": "h",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "evaporacao_piche": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "evaporacao_piche",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Evapora\\xc3\\xa7\\xc3\\xa3o de Piche",
                    "units": "mm",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "elevation",
                    "units": "m",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "Completos": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Completos",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "vel_vento_med": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "vel_vento_med",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Velocidade M\\xc3\\xa9dia do Vento",
                        "units": "m/s"
                    },
                    "umidade_med": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "umidade_med",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Umidade Relativa do Ar M\\xc3\\xa9dia",
                        "units": "percent"
                    },
                    "temp_min": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp_min",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Temperatura M\\xc3\\xadnima",
                        "units": "Celsius_scale"
                    },
                    "temp_med": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp_med",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Temperatura M\\xc3\\xa9dia Compensada",
                        "units": "Celsius_scale"
                    },
                    "temp_max": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp_max",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Temperatura M\\xc3\\xa1xima",
                        "units": "Celsius_scale"
                    },
                    "precipitacao": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitacao",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Precipita\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1ria",
                        "units": "mm"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "-48.0",
                        "long_name": "Longitude",
                        "units": "degree_east",
                        "scale_min": "-58.0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "SpatialReferenceSystemWKT": "]]",
                        "long_name": "location",
                        "scale_max": "-48",
                        "units": "degree_east",
                        "scale_min": "-58"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "-26.0",
                        "long_name": "Latitude",
                        "units": "degree_north",
                        "scale_min": "-34.0"
                    },
                    "insolacao": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "insolacao",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-999.0",
                        "long_name": "Insola\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1rio",
                        "units": "h"
                    },
                    "elev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "elev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "elevation",
                        "units": "m"
                    }
                }
            },
            "ESTACOES_CONVENCIONAIS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ESTACOES_CONVENCIONAIS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "vel_vento_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vel_vento_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Velocidade M\\xc3\\xa9dia do Vento",
                    "units": "m/s",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "umidade_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "umidade_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Umidade Relativa do Ar M\\xc3\\xa9dia",
                    "units": "percent",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_min": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_min",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xadnima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa9dia Compensada",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa1xima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "pressao_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pressao_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Press\\xc3\\xa3o M\\xc3\\xa9dia ao N\\xc3\\xadvel da Esta\\xc3\\xa7\\xc3\\xa3o",
                    "units": "mb",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "precipitacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precipitacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipita\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1ria",
                    "units": "mm",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-34.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "-74.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "6.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "-34.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "insolacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "insolacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Insola\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1rio",
                    "units": "h",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "evaporaxc3xa7xc3xa3o_piche": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "evapora\\xc3\\xa7\\xc3\\xa3o_piche",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Evapora\\xc3\\xa7\\xc3\\xa3o de Piche",
                    "units": "mm",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "elevation",
                    "units": "m",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                }
            },
            "ESTACOES_AUTOMATICAS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ESTACOES_AUTOMATICAS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "vel_vento_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "vel_vento_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Velocidade M\\xc3\\xa9dia do Vento",
                    "units": "m/s",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "umidade_min": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "umidade_min",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Umidade Relativa do Ar M\\xc3\\xadnima",
                    "units": "percent",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "umidade_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "umidade_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Umidade Relativa do Ar M\\xc3\\xa9dia",
                    "units": "percent",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "umidade_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "umidade_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Umidade Relativa do Ar M\\xc3\\xa1xima",
                    "units": "percent",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_min_po": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_min_po",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura Minina de Ponto de Orvalho",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_min": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_min",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xadnima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa9dia",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "temp_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperatura M\\xc3\\xa1xima",
                    "units": "Celsius_scale",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "raj_vento_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "raj_vento_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Rajada M\\xc3\\xa1xima de Vento",
                    "units": "m/s",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "radiacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "radiacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Radia\\xc3\\xa7\\xc3\\xa3o Global",
                    "missing_value": "-999.0",
                    "units": "unitless",
                    "pointwidth": "1.0"
                },
                "pressao_min": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pressao_min",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Press\\xc3\\xa3o M\\xc3\\xadnima ao N\\xc3\\xadvel da Esta\\xc3\\xa7\\xc3\\xa3o",
                    "units": "mb",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "pressao_med": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pressao_med",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Press\\xc3\\xa3o M\\xc3\\xa9dia ao N\\xc3\\xadvel da Esta\\xc3\\xa7\\xc3\\xa3o",
                    "units": "mb",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "pressao_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "pressao_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Press\\xc3\\xa3o M\\xc3\\xa1xima ao N\\xc3\\xadvel da Esta\\xc3\\xa7\\xc3\\xa3o",
                    "units": "mb",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "precipitacao_max": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precipitacao_max",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipita\\xc3\\xa7\\xc3\\xa3o M\\xc3\\xa1xima",
                    "missing_value": "-999.0",
                    "units": "unitless",
                    "pointwidth": "1.0"
                },
                "precipitacao": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precipitacao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Precipita\\xc3\\xa7\\xc3\\xa3o Total Di\\xc3\\xa1ria",
                    "units": "mm",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "-34.0",
                    "long_name": "Longitude",
                    "units": "degree_east",
                    "scale_min": "-74.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "6.0",
                    "long_name": "Latitude",
                    "units": "degree_north",
                    "scale_min": "-34.0",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "elevation",
                    "units": "m",
                    "missing_value": "-999.0",
                    "pointwidth": "1.0"
                }
            }
        },
        "gid": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "gid",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "T_04": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_04",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "standard_name": "time",
            "long_name": "Forecast Time",
            "pointwidth": "3"
        },
        "T_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "long_name": "Time",
            "standard_name": "time",
            "pointwidth": "1.0",
            "poinwidth": "1"
        },
        "L": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "L",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months",
            "gridtype": "0",
            "pointwidth": "1"
        },
        "S": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "S",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "months since 1960-01-01",
            "gridtype": "0",
            "calendar": "360",
            "long_name": "Forecast Start Time",
            "pointwidth": "0"
        },
        "WMOID_03": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WMOID_03",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "T_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "WMOID_02": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WMOID_02",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "WMOID_01": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WMOID_01",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1960-01-01",
            "gridtype": "0",
            "calendar": "standard",
            "standard_name": "time",
            "pointwidth": "1.0"
        },
        "WMOID": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WMOID",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "ids",
            "gridtype": "2"
        },
        "dir": "SOURCES/INMET"
    },
    "INPE": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/INPE",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "INPE",
        "restriction": "Public",
        "CPTEC": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/INPE/CPTEC",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "CPTEC",
            "restriction": "Public",
            "latam": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/INPE/CPTEC/latam",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "latam",
                "restriction": "Public",
                "CoSch": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/INPE/CPTEC/latam/CoSch",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CoSch",
                    "restriction": "Public",
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "rainfall": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rainfall",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "missing_value": "-9999.0",
                            "long_name": "Rainfall",
                            "units": "mm/day",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "long_name": "Latitude",
                            "pointwidth": "0.25"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "days since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "standard",
                            "standard_name": "time",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "long_name": "Longitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/INPE/CPTEC/latam/CoSch/daily"
                    },
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "rainfall": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "rainfall",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "long_name": "Rainfall",
                            "missing_value": "NaN",
                            "units": "mm/month",
                            "history": "Boxes with less than 0.0% dropped",
                            "file_missing_value": "-9999.0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "long_name": "Latitude",
                            "pointwidth": "0.25"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "long_name": "Longitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/INPE/CPTEC/latam/CoSch/monthly"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "daily",
                        "monthly"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CoSch"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "latam"
            ]
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "CPTEC"
        ]
    },
    "IPB": {
        "iridl_type": "DataSet",
        "iridl_ds_name": "IPB",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "NC_GLOBAL": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "NC_GLOBAL",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "CCROMASEAN_Compendiumtitle": "Indonesia Station Rainfall Observations (from ASEAN Compedium)",
            "CCROMASEAN_CompendiumDescription": "Compilation of station rainfall data over Indonesia 1975--1999 , from ASEAN Compedium database.Compiled by A. Faqih (akhmadfaqih@gmail.com).",
            "description": "Institut Pertanian Bogor",
            "Conventions": "IRIDL"
        },
        "CCROM": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "CCROM",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "ASEAN_Compendium": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ASEAN_Compendium",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "prec": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prec",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "mm",
                    "long_name": "precipitation_amount"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "scale_max": "141.0",
                    "units": "degree_east",
                    "long_name": "longitude",
                    "scale_min": "95.0"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "scale_min": "-11.0",
                    "units": "degree_north",
                    "long_name": "latitude",
                    "scale_max": "6.0"
                },
                "elev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "elev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "units": "m",
                    "long_name": "elevation"
                }
            }
        },
        "T": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "T",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "days since 1974-12-31 12:00",
            "gridtype": "0",
            "calendar": "standard",
            "long_name": "time",
            "pointwidth": "1.0"
        },
        "ISTA": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "ISTA",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "units": "unitless",
            "gridtype": "0",
            "pointwidth": "1.0"
        },
        "dir": "SOURCES/IPB"
    },
    "IPC": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/IPC",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "IPC",
        "restriction": "Public",
        "CurSit": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/IPC/CurSit",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "CurSit",
            "restriction": "Public",
            "EAF": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "EAF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "eaf202010description": "October 2020",
                    "eaf202006description": "June 2020",
                    "eaf202002description": "February 2020",
                    "eaf201910description": "October 2019",
                    "eaf201906description": "June 2019",
                    "eaf201902description": "February 2019",
                    "eaf201810description": "October 2018",
                    "eaf201806description": "June 2018",
                    "eaf201802description": "February 2018",
                    "eaf201710description": "October 2017",
                    "eaf201706description": "June 2017",
                    "eaf201702description": "February 2017",
                    "eaf201610description": "October 2016",
                    "eaf201606description": "June 2016",
                    "eaf201602description": "February 2016",
                    "eaf201510description": "October 2015",
                    "eaf201507description": "July 2015",
                    "eaf201504description": "April 2015",
                    "eaf201501description": "January 2015",
                    "eaf201410description": "October 2014",
                    "eaf201407description": "July 2014",
                    "eaf201404description": "April 2014",
                    "eaf201401description": "January 2014",
                    "eaf201310description": "October 2013",
                    "eaf201307description": "July 2013",
                    "eaf201304description": "April 2013",
                    "eaf201301description": "January 2013",
                    "eaf201210description": "October 2012",
                    "eaf201207description": "July 2012",
                    "eaf201204description": "April 2012",
                    "eaf201201description": "January 2012",
                    "eaf201110description": "October 2011",
                    "eaf201107description": "July 2011",
                    "eaf201104description": "April 2011",
                    "eaf201101description": "January 2011",
                    "eaf201010description": "October 2010",
                    "eaf201007description": "July 2010",
                    "eaf201004description": "April 2010",
                    "eaf201001description": "January 2010",
                    "eaf200910description": "October 2009",
                    "eaf200907description": "July 2009",
                    "Conventions": "IRIDL",
                    "description": "East Africa - Acute Food Insecurity Phase"
                },
                "eaf202010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf202010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf202006": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf202006",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf202002": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf202002",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201906": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201906",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201902": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201902",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201810": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201810",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201806": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201806",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201802": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201802",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201710": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201710",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201706": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201706",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201702": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201702",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "PGtype": "float8"
                    }
                },
                "eaf201610": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201610",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201606": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201606",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201602": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201602",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201510": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201510",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201507": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201507",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201504": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201504",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201501": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201501",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201410": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201410",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201407": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201407",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201404": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201404",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201401": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201401",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201310": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201310",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201307": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201307",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201304": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201304",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201301": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201301",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201207": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201207",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201204": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201204",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201201": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201201",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201107": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201107",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201104": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201104",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201101": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201101",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201007": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201007",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201004": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201004",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf201001": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf201001",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf200910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf200910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "eaf200907": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eaf200907",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "PGtype": "int4"
                    }
                },
                "gid_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/IPC/CurSit/EAF"
            },
            "EAF_gridded": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IPC/CurSit/EAF_gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "EAF_gridded",
                "restriction": "Public",
                "EAF_0p01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EAF_0p01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.01",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.01",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/EAF_gridded/EAF_0p01"
                },
                "EAF_0p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "EAF_0p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/EAF_gridded/EAF_0p1"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "EAF_0p01",
                    "EAF_0p1"
                ]
            },
            "SAF": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IPC/CurSit/SAF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "SAF",
                "restriction": "Public",
                "saf200907": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf200907",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2009",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf200907"
                },
                "saf200910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf200910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2009",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf200910"
                },
                "saf201001": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201001",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2010",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201001"
                },
                "saf201004": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201004",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2010",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201004"
                },
                "saf201007": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201007",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2010",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201007"
                },
                "saf201010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2010",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201010"
                },
                "saf201101": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201101",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2011",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201101"
                },
                "saf201104": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201104",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2011",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201104"
                },
                "saf201107": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201107",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2011",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201107"
                },
                "saf201110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2011",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201110"
                },
                "saf201201": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201201",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2012",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201201"
                },
                "saf201204": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201204",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2012",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201204"
                },
                "saf201207": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201207",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2012",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201207"
                },
                "saf201210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2012",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201210"
                },
                "saf201301": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201301",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2013",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201301"
                },
                "saf201304": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201304",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2013",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201304"
                },
                "saf201307": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201307",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2013",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201307"
                },
                "saf201310": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201310",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2013",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201310"
                },
                "saf201401": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201401",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2014",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201401"
                },
                "saf201404": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201404",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2014",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201404"
                },
                "saf201407": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201407",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2014",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201407"
                },
                "saf201410": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201410",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2014",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201410"
                },
                "saf201501": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201501",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "January 2015",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201501"
                },
                "saf201504": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201504",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "April 2015",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201504"
                },
                "saf201507": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201507",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "July 2015",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201507"
                },
                "saf201510": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201510",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2015",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201510"
                },
                "saf201602": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201602",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "February 2016",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201602"
                },
                "saf201606": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201606",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "June 2016",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201606"
                },
                "saf201610": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201610",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2016",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201610"
                },
                "saf201702": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201702",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "February 2017",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201702"
                },
                "saf201706": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201706",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "June 2017",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201706"
                },
                "saf201710": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201710",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2017",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201710"
                },
                "saf201802": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201802",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "February 2018",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201802"
                },
                "saf201806": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201806",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "June 2018",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201806"
                },
                "saf201810": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201810",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2018",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201810"
                },
                "saf201902": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201902",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "February 2019",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201902"
                },
                "saf201906": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201906",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "June 2019",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201906"
                },
                "saf201910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf201910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2019",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf201910"
                },
                "saf202002": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf202002",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "February 2020",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf202002"
                },
                "saf202006": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf202006",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "June 2020",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf202006"
                },
                "saf202010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "saf202010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "description": "October 2020",
                        "Conventions": "IRIDL"
                    },
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF/saf202010"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "saf200907",
                    "saf200910",
                    "saf201001",
                    "saf201004",
                    "saf201007",
                    "saf201010",
                    "saf201101",
                    "saf201104",
                    "saf201107",
                    "saf201110",
                    "saf201201",
                    "saf201204",
                    "saf201207",
                    "saf201210",
                    "saf201301",
                    "saf201304",
                    "saf201307",
                    "saf201310",
                    "saf201401",
                    "saf201404",
                    "saf201407",
                    "saf201410",
                    "saf201501",
                    "saf201504",
                    "saf201507",
                    "saf201510",
                    "saf201602",
                    "saf201606",
                    "saf201610",
                    "saf201702",
                    "saf201706",
                    "saf201710",
                    "saf201802",
                    "saf201806",
                    "saf201810",
                    "saf201902",
                    "saf201906",
                    "saf201910",
                    "saf202002",
                    "saf202006",
                    "saf202010"
                ]
            },
            "SAF_gridded": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IPC/CurSit/SAF_gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "SAF_gridded",
                "restriction": "Public",
                "SAF_0p01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SAF_0p01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.01",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.01",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF_gridded/SAF_0p01"
                },
                "SAF_0p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SAF_0p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/SAF_gridded/SAF_0p1"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "SAF_0p01",
                    "SAF_0p1"
                ]
            },
            "WAF": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WAF",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "waf202010description": "October 2020",
                    "waf202006description": "June 2020",
                    "waf202002description": "February 2020",
                    "waf201910description": "October 2019",
                    "waf201906description": "June 2019",
                    "waf201902description": "February 2019",
                    "waf201810description": "October 2018",
                    "waf201806description": "June 2018",
                    "waf201802description": "February 2018",
                    "waf201710description": "October 2017",
                    "waf201706description": "June 2017",
                    "waf201702description": "February 2017",
                    "waf201610description": "October 2016",
                    "waf201606description": "June 2016",
                    "waf201602description": "February 2016",
                    "waf201510description": "October 2015",
                    "waf201507description": "July 2015",
                    "waf201504description": "April 2015",
                    "waf201501description": "January 2015",
                    "waf201410description": "October 2014",
                    "waf201407description": "July 2014",
                    "waf201404description": "April 2014",
                    "waf201401description": "January 2014",
                    "waf201310description": "October 2013",
                    "waf201307description": "July 2013",
                    "waf201304description": "April 2013",
                    "waf201301description": "January 2013",
                    "waf201210description": "October 2012",
                    "waf201207description": "July 2012",
                    "waf201204description": "April 2012",
                    "waf201201description": "January 2012",
                    "waf201110description": "October 2011",
                    "waf201107description": "July 2011",
                    "waf201104description": "April 2011",
                    "waf201101description": "January 2011",
                    "waf201010description": "October 2010",
                    "waf201007description": "July 2010",
                    "waf201004description": "April 2010",
                    "waf201001description": "January 2010",
                    "waf200910description": "October 2009",
                    "waf200907description": "July 2009",
                    "description": "West Africa - Acute Food Insecurity Phase",
                    "Conventions": "IRIDL"
                },
                "waf202010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf202010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf202006": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf202006",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf202002": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf202002",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201906": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201906",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201902": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201902",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201810": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201810",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201806": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201806",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201802": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201802",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201710": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201710",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201706": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201706",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201702": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201702",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1.0",
                        "missing_value": "99.0",
                        "CLIST": "Famine",
                        "scale_max": "5.0",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "float8"
                    }
                },
                "waf201610": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201610",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201606": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201606",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201602": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201602",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201510": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201510",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201507": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201507",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201504": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201504",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201501": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201501",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201410": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201410",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201407": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201407",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201404": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201404",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201401": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201401",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201310": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201310",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201307": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201307",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201304": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201304",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201301": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201301",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201210": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201210",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201207": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201207",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201204": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201204",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201201": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201201",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201110": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201110",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201107": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201107",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201104": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201104",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Integrated Phase Classification",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201101": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201101",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201010": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201010",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201007": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201007",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201004": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201004",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf201001": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf201001",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf200910": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf200910",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "waf200907": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "waf200907",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "missing_value": "99",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "FEWS NET Food Insecurity Severity Scale",
                        "units": "ids",
                        "PGtype": "int4"
                    }
                },
                "gid_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/IPC/CurSit/WAF"
            },
            "WAF_gridded": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IPC/CurSit/WAF_gridded",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "WAF_gridded",
                "restriction": "Public",
                "WAF_0p01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WAF_0p01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/WAF_gridded/WAF_0p01"
                },
                "WAF_0p1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WAF_0p1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "ipc": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ipc",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Integrated Phase Classification Gridded",
                        "scale_min": "1.0",
                        "scale_max": "5.0",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "CS": "1",
                        "CE": "5",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "99",
                        "PGtype": "int4"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "0.1",
                        "long_name": "Longitude"
                    },
                    "dir": "SOURCES/IPC/CurSit/WAF_gridded/WAF_0p1"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "WAF_0p01",
                    "WAF_0p1"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "EAF",
                "EAF_gridded",
                "SAF",
                "SAF_gridded",
                "WAF",
                "WAF_gridded"
            ]
        },
        "EAF": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "EAF",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "eaflastML2description": "Medium Term",
                "eaflastML1description": "Near Term",
                "eaflastdescription": "January 2018",
                "eaf201801ML2description": "Medium Term",
                "eaf201801ML1description": "Near Term",
                "eaf201801description": "January 2018",
                "eaf201606ML2description": "Medium Term",
                "eaf201606ML1description": "Near Term",
                "eaf201606description": "June 2016",
                "description": "Eastern Africa",
                "Conventions": "IRIDL"
            },
            "eaflast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "eaflast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "eaf201801": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "eaf201801",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "eaf201606": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "eaf201606",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "4"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "4"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "units": "months since 1960-01-01",
                        "pointwidth": "1"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "8",
                        "colormap": "2763429",
                        "maxncolor": "254",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ncolor": "5",
                        "colormap": "0",
                        "maxncolor": "254",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    }
                }
            },
            "gid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/IPC/EAF"
        },
        "WAF": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "WAF",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "waflastML2description": "Medium Term",
                "waflastML1description": "Near Term",
                "waflastdescription": "January 2018",
                "waf201801ML2description": "Medium Term",
                "waf201801ML1description": "Near Term",
                "waf201801description": "January 2018",
                "waf201702ML2description": "Medium Term",
                "waf201702ML1description": "Near Term",
                "waf201702description": "February 2017",
                "waf201610ML2description": "Medium Term",
                "waf201610ML1description": "Near Term",
                "waf201610description": "October 2016",
                "waf201606ML2description": "Medium Term",
                "waf201606ML1description": "Near Term",
                "waf201606description": "June 2016",
                "description": "Western Africa",
                "Conventions": "IRIDL"
            },
            "waflast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "waflast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "pointwidth": "4",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "waf201801": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "waf201801",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "pointwidth": "4",
                        "long_name": "Target Date",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "waf201702": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "waf201702",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "waf201610": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "waf201610",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "waf201606": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "waf201606",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "ML2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                },
                "ML1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ML1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "the_geom": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "the_geom",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Geometry",
                        "units": "unitless",
                        "PGtype": "bytea",
                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                        "SpatialReferenceSystemWKT": "]]"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Target Date",
                        "pointwidth": "4",
                        "units": "months since 1960-01-01"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "calendar": "360",
                        "long_name": "Issue Date",
                        "pointwidth": "1",
                        "units": "months since 1960-01-01"
                    },
                    "ml1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ml1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "8",
                        "colormap": "2763429",
                        "scale_max": "5",
                        "long_name": "Acute Food Insecurity Phase",
                        "units": "ids",
                        "scale_min": "1",
                        "CLIST": "Famine",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Label",
                        "units": "ids",
                        "PGtype": "text"
                    },
                    "ha1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ha1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "ncolor": "5",
                        "colormap": "0",
                        "scale_max": "1",
                        "long_name": "Humanitarian Assistance",
                        "units": "ids",
                        "scale_min": "0",
                        "CLIST": "would be 1 phase worse without HA",
                        "missing_value": "-2147483648",
                        "PGtype": "float8"
                    }
                }
            },
            "gid_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "gid": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "gid",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "unitless",
                "gridtype": "0",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/IPC/WAF"
        },
        "banned_long": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type",
            "CurSit",
            "EAF",
            "WAF"
        ]
    },
    "IRI": {
        "iridl_type": "Source",
        "invalid": [],
        "dir": "SOURCES/IRI",
        "banned": [
            "dir",
            "invalid",
            "parent",
            "name",
            "banned",
            "banned_long",
            "iridl_ds_name",
            "iridl_type"
        ],
        "iridl_ds_name": "IRI",
        "restriction": "Public",
        "Analyses": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/IRI/Analyses",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "Analyses",
            "restriction": "Public",
            "CSMT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CSMT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Climatic Suitability for Malaria Transmission",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.Analyses/.CSMT/.dataset_documentation.html",
                    "iridlhasSemantics": "iridl:Malaria",
                    "Conventions": "IRIDL",
                    "references": "Grover-Kopec_etal2006"
                },
                "TempCondProb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "TempCondProb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "16777215",
                    "scale_max": "100.0",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CE": "100.0",
                    "CS": "0.0",
                    "CI": "25.0",
                    "long_name": "Percent Occurrence of Temperature Condition in Historical Record",
                    "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "units": "unitless",
                    "fnname": "flagge",
                    "file_missing_value": "-99.900002"
                },
                "RHCondProb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "RHCondProb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "13882323",
                    "scale_max": "100.0",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CE": "100.0",
                    "CS": "0.0",
                    "CI": "25.0",
                    "long_name": "Percent Occurrence of Relative Humidity Condition in Historical Record",
                    "history": "Averaged over T2[1951, 2000]",
                    "units": "unitless",
                    "fnname": "flagge",
                    "GRIBgridcode": "2",
                    "gribparam": "51",
                    "grib_name": "SPFH",
                    "center": "US Weather Service - National Met. Center",
                    "calendar": "standard",
                    "gribfield": "1",
                    "subcenter": "NCEP Ensemble Products",
                    "PTVersion": "2",
                    "process": " run",
                    "gribNumBits": "15",
                    "PDS_TimeRange": "113",
                    "gribvariable": "51",
                    "gribleveltype": "100",
                    "pointwidth": "1.0"
                },
                "PcpnCondProb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PcpnCondProb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "16777215",
                    "scale_max": "100.0",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CE": "100.0",
                    "CS": "0.0",
                    "CI": "25.0",
                    "long_name": "Percent Occurrence of Precipitation Condition in Historical Record",
                    "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                    "units": "unitless",
                    "fnname": "flagge",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "Annual_Sum": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Annual_Sum",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "long_name": "Number of Months Suitable for Malaria Transmission",
                    "colormap": "0",
                    "scale_max": "12.5",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CE": "12.5",
                    "CS": "0.0",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "units": "unitless",
                    "fnname": "flagge",
                    "file_missing_value": "-99.900002"
                },
                "AllCondProb": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AllCondProb",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "13882323",
                    "scale_max": "100.0",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CE": "100.0",
                    "CS": "0.0",
                    "CI": "25.0",
                    "long_name": "Percent Occurrence of All Three Climate Conditions in Historical Record",
                    "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "units": "unitless",
                    "fnname": "flagge",
                    "file_missing_value": "-99.900002"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "long_name": "Month",
                    "expires": "1617408000",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/IRI/Analyses/CSMT"
            },
            "ENSORP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ENSO-RP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ver19502002description": "Probabilistic precipitation anomalies associated with ENSO (1950-2002)",
                    "ver19501996description": "Probabilistic precipitation anomalies associated with ENSO (1950-1996)",
                    "references": "Mason_Goddard2001",
                    "description": "Probabilistic precipitation anomalies associated with ENSO",
                    "Conventions": "IRIDL"
                },
                "ver19502002": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ver1950-2002",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "p5deg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "0p5deg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prob": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prob",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "CE": "1.0",
                            "CS": "0.0",
                            "scale_min": "0.0",
                            "maxncolor": "254",
                            "colorscalename": "tercileclassesscale",
                            "colormap": "6303920",
                            "ncolor": "254",
                            "missing_value": "-9999.0",
                            "long_name": "probability"
                        },
                        "maskedprob": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maskedprob",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "CE": "1.0",
                            "CS": "0.0",
                            "scale_min": "0.0",
                            "maxncolor": "254",
                            "colorscalename": "tercileclassesscale",
                            "colormap": "6303920",
                            "ncolor": "254",
                            "missing_value": "-9999.0",
                            "long_name": "probability masked below 90% significance"
                        }
                    }
                },
                "ver19501996": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ver1950-1996",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "p5deg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "0p5deg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prob": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prob",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "CE": "1.0",
                            "CS": "0.0",
                            "scale_min": "0.0",
                            "maxncolor": "254",
                            "colorscalename": "tercileclassesscale",
                            "colormap": "6303920",
                            "ncolor": "254",
                            "missing_value": "-9999.0",
                            "long_name": "probability"
                        },
                        "maskedprob": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maskedprob",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "CE": "1.0",
                            "CS": "0.0",
                            "scale_min": "0.0",
                            "maxncolor": "254",
                            "colorscalename": "tercileclassesscale",
                            "colormap": "6303920",
                            "ncolor": "254",
                            "missing_value": "-9999.0",
                            "long_name": "probability masked below 90% significance"
                        }
                    }
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.5"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.5"
                },
                "prcp": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "3.0"
                },
                "ENSO": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ENSO",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "dir": "SOURCES/IRI/Analyses/ENSO-RP"
            },
            "Fire": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Fire",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "IndonesiaKapuasCMAdescription": "Three-class model of fire vulnerability in Kapuas district determined from Composite Mapping Analysis (CMA)",
                    "IndonesiaKapuasdescription": "Fire risk data for Kapuas",
                    "AmazonFiresAmFires025long_name": "AmazonFires025",
                    "AmazonFirePredictionMayLead2long_name": "MayFCST_JAS_T2m",
                    "AmazonFirePredictionMayLead1long_name": "MayFCST_JJA_T2m",
                    "AmazonFirePredictionMay18Lead2long_name": "May18FCST_JAS",
                    "AmazonFirePredictionMay18Lead1long_name": "May18FCST_JJA",
                    "AmazonFirePredictionMarLead2long_name": "MarFCST_MJJ_T2m",
                    "AmazonFirePredictionMarLead1long_name": "MarFCST_AMJ_T2m",
                    "AmazonFirePredictionJunLead1long_name": "JunFCST_JAS_T2m",
                    "AmazonFirePredictionJun18Lead1long_name": "Jun18FCST_JAS",
                    "AmazonFirePredictionJun17Lead1long_name": "Jun17FCST_JAS",
                    "AmazonFirePredictionAprLead2long_name": "AprFCST_JJA_T2m",
                    "AmazonFirePredictionAprLead1long_name": "AprFCST_MJJ_T2m",
                    "AmazonFirePredictionApr18Lead2long_name": "Apr18FCST_JJA",
                    "AmazonFirePredictionApr18Lead1long_name": "Apr18FCST_MJJ",
                    "description": "Fire maproom analyses",
                    "Conventions": "IRIDL"
                },
                "Indonesia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Indonesia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Kapuas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Kapuas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "risk": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "risk",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "6",
                            "CLIST": "high",
                            "colormap": "16777215",
                            "scale_max": "3.0",
                            "ncolor": "6",
                            "scale_min": "1.0",
                            "CE": "3",
                            "CS": "1",
                            "missing_value": "-9",
                            "long_name": "Fire Risk",
                            "units": "ids"
                        },
                        "CMA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vulnerability": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vulnerability",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "6",
                                "CLIST": "High",
                                "colormap": "16777215",
                                "scale_max": "3.0",
                                "ncolor": "6",
                                "scale_min": "1.0",
                                "CE": "3",
                                "CS": "1",
                                "missing_value": "127",
                                "valid_max": "3",
                                "valid_min": "1",
                                "long_name": "fire vulnerability",
                                "units": "ids"
                            }
                        }
                    },
                    "Kalimantan": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Kalimantan",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "the_geom": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "the_geom",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Province Geometry",
                            "units": "unitless",
                            "PGtype": "bytea",
                            "OpenGISSimpleFeature": "MULTIPOLYGON",
                            "SpatialReferenceSystemWKT": "]]"
                        },
                        "numberOfFires": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "numberOfFires",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "missing_value": "-9.0",
                            "long_name": "Number of fires"
                        },
                        "name1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "name1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Province Name",
                            "units": "ids",
                            "PGtype": "varchar"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Label",
                            "units": "ids",
                            "PGtype": "varchar"
                        }
                    }
                },
                "CMORPH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CMORPH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "dekadal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "avg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "avg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Dekadal CMORPH 2003-14 average",
                            "history": "Averaged over T2[0.5, 432.5] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "maxncolor": "254",
                            "colorscalename": "cmorph_dekad_colors",
                            "colormap": "2237106",
                            "ncolor": "254",
                            "units": "mm",
                            "file_missing_value": "-9999.0",
                            "pointwidth": "0"
                        }
                    }
                },
                "Amazon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Amazon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Fires": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Fires",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "AmFires025": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AmFires025",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "AmazonFires025": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AmazonFires025",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0",
                                "units": "unitless",
                                "history": "[([(home katia Fires AmFires AmazonFires) [(X regridded on home katia Fires AmFires AmazonFires) (Y regridded on home katia Fires AmFires AmazonFires) (Boxes with less than 0.0% dropped)] (Averaged over T[Jul-Sep 2000, Jul-Sep 2015] minimum 0% data present)]) (T:  Jul-Sep 2016 to Jul-Sep 2016 appended from maskrange [ ( home katia Fires AmFires025 AmazonFires025 ) , -20 , 20 ])]"
                            }
                        }
                    },
                    "FirePrediction": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "FirePrediction",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "MayLead2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MayLead2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MayFCST_JAS_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MayFCST_JAS_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "MayLead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MayLead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MayFCST_JJA_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MayFCST_JJA_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "May18Lead2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "May18Lead2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "May18FCST_JAS_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "May18FCST_JAS_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "May18Lead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "May18Lead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "May18FCST_JJA_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "May18FCST_JJA_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "MarLead2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MarLead2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MarFCST_MJJ_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MarFCST_MJJ_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "MarLead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MarLead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MarFCST_AMJ_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MarFCST_AMJ_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "JunLead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "JunLead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "JunFCST_JAS_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "JunFCST_JAS_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "Jun18Lead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Jun18Lead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Jun18FCST_JAS_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Jun18FCST_JAS_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "Jun17Lead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Jun17Lead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Jun17FCST_JAS_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Jun17FCST_JAS_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "AprLead2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AprLead2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "AprFCST_JJA_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AprFCST_JJA_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "AprLead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AprLead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "AprFCST_MJJ_T2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "AprFCST_MJJ_T2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "Apr18Lead2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Apr18Lead2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Apr18FCST_JJA_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Apr18FCST_JJA_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        },
                        "Apr18Lead1": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Apr18Lead1",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Apr18FCST_MJJ_SST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Apr18FCST_MJJ_SST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Standard Deviation"
                            }
                        }
                    }
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.70945049E-04"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "2.70978169E-04"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "1.26170009E-04"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "1.26169922E-04"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2003-01-01",
                    "gridtype": "1",
                    "modulo": "365.0",
                    "modulus": "365.0",
                    "calendar": "365"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "0.25"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.25"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Year",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Year",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.25"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "Year",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.25"
                },
                "dir": "SOURCES/IRI/Analyses/Fire"
            },
            "ICPAC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/Analyses/ICPAC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ICPAC",
                "restriction": "Public",
                "Models": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Models",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean NCEP-CFSv2 hindcast temperature and GHCN-CAMS temperature during 1982-2010",
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean NCEP-CFSv2 hindcast sst and ERSSTv5 sst during 1982-2010",
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean NCEP-CFSv2 hindcast sst and ERSSTv4 sst during 1982-2010",
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean NCEP-CFSv2 hindcast precipitation and CAMS-OPI precipitation during 1982-2010",
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESMONTHLYSamplingTable": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.ENSEMBLE/.FLXF/mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html",
                        "WashingtonNCEPCFSv2HINDCASTPENTAD_SAMPLESMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "WashingtonNCEPCFSv2FORECASTPENTAD_SAMPLESMONTHLYSamplingTable": "http://iridl.ldeo.columbia.edu/SOURCES/.NOAA/.NCEP/.EMC/.CFSv2/.REALTIME_ENSEMBLE/.FLXF/mark/sampleS/M/4/STEP/S/exch%5BM%5Dtable:/mark/:table/.html",
                        "WashingtonNCEPCFSv2FORECASTPENTAD_SAMPLESMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "WashingtonNCEPCFSv2FORECASTPENTAD_SAMPLESdescription": "pentad realtime forecasts organized as monthly starts of 24-28 members, starting from Apr 2011, matching pattern of CFSv2 hindcast starts",
                        "NASANASAGMAO062012MONTHLYdataset_documentation": "geos5_model_basics.pptx",
                        "NASANASAGMAO062012MONTHLYIMPORTANT": "As of 2 November 2016 an error has been found and corrected in the IRI Data Library archive of the NMME NASA-GMAO-062012 January hindcast and forecast starts.  In the January starts (S grid) for ensemble members (M grid) 1-4 (corresponding to starts associated with dates Dec 12th, Dec 17th, Dec 22nd, and Dec 27th), for all variables, the data in these files were being wrongly associated with the January start of the previoius year.  For example, for the January 2014 start, data should be read from files named using the dates 12 Dec 2013 (ensemble member 1), 17 Dec 2013 (ensemble member 2), 22 Dec 2013 (ensemble member 3), 27 Dec 2013 (ensemble member 4), and 01 Jan 2014 (ensemble members 5-11).  However, continuing with this example, in the Data Library archive, the data from ensemble members 1-4 (dated Dec 12, 17, 22, and 27 2013) were being assigned to the January 2013 start, not the intended January 2014 start.  This means that in forecasts with a January monthly start time, ensemble members 1-4 would have been missing until the following January start, when these ensemble members 1-4 would have been filled with data intended for the next January monthly start, or remained missing in the case of the prec, sst, and tref variables from 2014 to 2016.  This error affected only ensemble members 1-4 of the January starts, but affected all variables and all hindcast and forecast years.  This error was the result of an archiving error in the Data Library, not any error in the original data files from NASA, and has been corrected as of 2 November 2016.  Send any questions to help@iri.columbia.edu .",
                        "NASANASAGMAO062012MONTHLYreferences": "Kirtman_etal2014",
                        "NASANASAGMAO062012MONTHLYdata_availability": "/mark/SOURCES/.Models/.NMME/.NASA-GMAO-062012/.MONTHLY/.fileavail/S2/exch%5BS1%5Dtable:/mark/:table/.html",
                        "NASANASAGMAO062012MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "NASANASAGMAO062012HINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean NASA-GMAO hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "NASANASAGMAO062012HINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean NASA-GMAO hindcast sst and ERSSTv5 sst during 1981-2010",
                        "NASANASAGMAO062012HINDCASTSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean NASA-GMAO hindcast sst and ERSSTv4 sst during 1981-2010",
                        "NASANASAGMAO062012HINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean NASA-GMAO hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "MontrealGEMNEMOHINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean GEM-NEMO hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "MontrealGEMNEMOHINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean GEM-NEMO hindcast sst and ERSSTv5 sst during 1981-2010",
                        "MontrealGEMNEMOHINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean GEM-NEMO hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "MontrealGEMNEMOHINDCASTsc8110description": "1981-2010 Seasonal Climatology",
                        "MontrealGEMNEMOHINDCASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "MontrealGEMNEMOHINDCASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealGEMNEMOHINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealGEMNEMOHINDCASTmc8110description": "1981-2010 Monthly Climatology",
                        "MontrealGEMNEMOFORECASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "MontrealGEMNEMOFORECASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealGEMNEMOFORECASTMONTHLYexpires": "1617260400",
                        "MontrealGEMNEMOFORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealGEMNEMOdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "MontrealCMC2CanCM4HINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CMC2-CanCM4 hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "MontrealCMC2CanCM4HINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean CMC2-CanCM4 hindcast sst and ERSSTv5 sst during 1981-2010",
                        "MontrealCMC2CanCM4HINDCASTSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean CMC2-CanCM4 hindcast sst and ERSSTv4 sst during 1981-2010",
                        "MontrealCMC2CanCM4HINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CMC2-CanCM4 hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "MontrealCMC2CanCM4HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCMC2CanCM4HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCMC2CanCM4FORECASTMONTHLYorigreferences": "Kirtman_etal2014",
                        "MontrealCMC2CanCM4FORECASTMONTHLYorigdescription": "original entry",
                        "MontrealCMC2CanCM4FORECASTMONTHLYorigACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCMC2CanCM4FORECASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCMC2CanCM4FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCMC1CanCM3HINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CMC1-CanCM3 hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "MontrealCMC1CanCM3HINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean CMC1-CanCM3 hindcast sst and ERSSTv5 sst during 1981-2010",
                        "MontrealCMC1CanCM3HINDCASTSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean CMC1-CanCM3 hindcast sst and ERSSTv4 sst during 1981-2010",
                        "MontrealCMC1CanCM3HINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CMC1-CanCM3 hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "MontrealCMC1CanCM3HINDCASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCMC1CanCM3HINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCMC1CanCM3FORECASTMONTHLYorigdescription": "original entry",
                        "MontrealCMC1CanCM3FORECASTMONTHLYorigACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCMC1CanCM3FORECASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCMC1CanCM3FORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCanCM4iHINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CanCM4i hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "MontrealCanCM4iHINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean CanCM4i hindcast sst and ERSSTv5 sst during 1981-2010",
                        "MontrealCanCM4iHINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean CanCM4i hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "MontrealCanCM4iHINDCASTsc8110description": "1981-2010 Seasonal Climatology",
                        "MontrealCanCM4iHINDCASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "MontrealCanCM4iHINDCASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCanCM4iHINDCASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCanCM4iHINDCASTmc8110description": "1981-2010 Monthly Climatology",
                        "MontrealCanCM4iFORECASTMONTHLYdataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "MontrealCanCM4iFORECASTMONTHLYreferences": "Kirtman_etal2014",
                        "MontrealCanCM4iFORECASTMONTHLYexpires": "1617260400",
                        "MontrealCanCM4iFORECASTMONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "MontrealCanCM4idataset_documentation": "https://iridl.ldeo.columbia.edu/documentation/Models/NMME/CanSIPSv2/technote_cansips-v2_20190703_e.pdf",
                        "GFDLGFDLCM2p5FLORA06MONTHLYhistory": "FERRET V6.72   7-Jun-12",
                        "GFDLGFDLCM2p5FLORA06MONTHLYdataset_documentation": "http://www.gfdl.noaa.gov/cms-filesystem-action/user_files/gav/publications/jetal_14_flor_tsandpr.pdf",
                        "GFDLGFDLCM2p5FLORA06MONTHLYreferences": "Kirtman_etal2014",
                        "GFDLGFDLCM2p5FLORA06MONTHLYexpires": "1612162800",
                        "GFDLGFDLCM2p5FLORA06MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                        "GFDLGFDLCM2p5FLORA06MONTHLYConventions": "CF-1.0",
                        "GFDLGFDLCM2p5FLORA06MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "GFDLGFDLCM2p5FLORA06HINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean GFDL-CM2p5-FLOR-A06 hindcast temperature and GHCN-CAMS temperature during 1981-2010",
                        "GFDLGFDLCM2p5FLORA06HINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean GFDL-CM2p5-FLOR-A06 hindcast sst and ERSSTv5 sst during 1981-2010",
                        "GFDLGFDLCM2p5FLORA06HINDCASTSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean GFDL-CM2p5-FLOR-A06 hindcast sst and ERSSTv4 sst during 1981-2010",
                        "GFDLGFDLCM2p5FLORA06HINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean GFDL-CM2p5-FLOR-A06 hindcast precipitation and CAMS-OPI precipitation during 1981-2010",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearum_version": "10.1",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearforecast_type": "hindcast",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearmodel_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearsource": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearmodeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearphysics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearinstitution": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyeartitle": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearConventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearcontributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearinstitute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearcontact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearassociated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28_multiyearassociated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28um_version": "10.1",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28initialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28forecast_type": "hindcast",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28model_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28source": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28modeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28physics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28institution": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28title": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28Conventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28contributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28institute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28contact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28associated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftnchindcast_ens28associated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftncforecastum_version": "10.1",
                        "ExeterUKMOGloSea5d1x1shiftncforecastinitialization_description": "Atmos:Met Office NWP 4DVar; Ocean & Sea-ice: Met Office FOAM NEMOVAR",
                        "ExeterUKMOGloSea5d1x1shiftncforecastforecast_type": "forecast",
                        "ExeterUKMOGloSea5d1x1shiftncforecastmodel_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftncforecastsource": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftncforecastmodeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1shiftncforecastexpires": "1615420800",
                        "ExeterUKMOGloSea5d1x1shiftncforecastphysics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1shiftncforecastinstitution": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftncforecasttitle": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1shiftncforecastConventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1shiftncforecastcontributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1shiftncforecastinstitute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1shiftncforecastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1shiftncforecastassociated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1shiftncforecastassociated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1shiftncdescription": "GloSea5 hindcasts & forecasts for forecast start times starting from Apr 2019",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearassociated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearum_version": "10.1",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearinstitute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearcontact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearmodeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearsource": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearassociated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearinstitution": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearConventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyeartitle": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearmodel_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearcontributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearforecast_type": "hindcast",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28_multiyearphysics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28um_version": "10.1",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28initialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28forecast_type": "hindcast",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28model_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28source": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28modeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28physics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28institution": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28title": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28Conventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28contributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28institute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28contact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28associated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcast_ens28associated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1nchindcastum_version": "10.1",
                        "ExeterUKMOGloSea5d1x1nchindcastinitialization_description": "Atmos:ERA-I; Ocean & Sea-ice: GS5 OSIA NEMOVAR",
                        "ExeterUKMOGloSea5d1x1nchindcastforecast_type": "hindcast",
                        "ExeterUKMOGloSea5d1x1nchindcastmodel_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcastsource": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1nchindcastmodeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1nchindcastphysics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1nchindcastinstitution": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcasttitle": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1nchindcastConventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1nchindcastcontributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1nchindcastinstitute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1nchindcastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1nchindcastassociated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1nchindcastassociated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1ncforecastassociated_model": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1ncforecastum_version": "10.1",
                        "ExeterUKMOGloSea5d1x1ncforecastinstitute_id": "UKMO",
                        "ExeterUKMOGloSea5d1x1ncforecastinitialization_description": "Atmos:Met Office NWP 4DVar; Ocean & Sea-ice: Met Office FOAM NEMOVAR",
                        "ExeterUKMOGloSea5d1x1ncforecastcontact": "Contact the Met Office Monthly to Decadal Prediction team",
                        "ExeterUKMOGloSea5d1x1ncforecastmodeling_realm": "atmos",
                        "ExeterUKMOGloSea5d1x1ncforecastsource": "model-generated, GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1ncforecastassociated_experiment": "GloSea5-GC2",
                        "ExeterUKMOGloSea5d1x1ncforecastinstitution": "Met Office",
                        "ExeterUKMOGloSea5d1x1ncforecastConventions": "CF-1.6",
                        "ExeterUKMOGloSea5d1x1ncforecasttitle": "Operational seasonal forecast data from UK Met Office.",
                        "ExeterUKMOGloSea5d1x1ncforecastmodel_id": "HadGEM3-GC2.0",
                        "ExeterUKMOGloSea5d1x1ncforecastcontributor_name": "Met Office",
                        "ExeterUKMOGloSea5d1x1ncforecastforecast_type": "forecast",
                        "ExeterUKMOGloSea5d1x1ncforecastphysics_description": "See Williams et al, 2015 for GC2 description",
                        "ExeterUKMOGloSea5d1x1ncdescription": "GloSea5 hindcasts & forecasts for forecast start times from Dec 2016 to Mar 2019",
                        "ExeterGloSea": "UKMO",
                        "COLARSMASCOLARSMASCCSM4MONTHLYReferences": "Ben P. Kirtman, Dughong Min. (2009) Multimodel Ensemble ENSO Prediction with CCSM and CFS. Monthly Weather Review 137:9, 2908-2930",
                        "COLARSMASCOLARSMASCCSM4MONTHLYGenerator": "NCL v.5.0",
                        "COLARSMASCOLARSMASCCSM4MONTHLYComment": "Dughong Min (dmin@rsmas.miami.edu) and Ben Kirtman (bkirtman@rsmas.miami.edu)",
                        "COLARSMASCOLARSMASCCSM4MONTHLYTitle": "CCSM4.0 National Multi-Model Ensembles(NMME) project",
                        "COLARSMASCOLARSMASCCSM4MONTHLYCreated": "Wed May 7 20:32:28 EDT 2014",
                        "COLARSMASCOLARSMASCCSM4MONTHLYreferences": "Kirtman_etal2014",
                        "COLARSMASCOLARSMASCCSM4MONTHLYexpires": "1617237720",
                        "COLARSMASCOLARSMASCCSM4MONTHLYdata_availability": "fileavail/mark/exch/S2/exch[S1]table:/mark/:table/.html",
                        "COLARSMASCOLARSMASCCSM4MONTHLYConventions": "CF-1.0",
                        "COLARSMASCOLARSMASCCSM4MONTHLYACKNOWLEDGEMENTS": "  Besides the above acknowledgement, users should register any journal articles (or other scientific documents) that are based on NMME-Phase II results.",
                        "COLARSMASCOLARSMASCCSM4HINDCASTSEASONALGHCN_CAMSdescription": "Seasonal (3-month) anomaly correlation between ensemble mean COLA-RSMAS-CCSM4 hindcast temperature and GHCN-CAMS temperature during 1982-2010",
                        "COLARSMASCOLARSMASCCSM4HINDCASTSEASONALERSSTv5description": "Seasonal (3-month) anomaly correlation between ensemble mean COLA-RSMAS-CCSM4 hindcast sst and ERSSTv5 sst during 1982-2010",
                        "COLARSMASCOLARSMASCCSM4HINDCASTSEASONALERSSTv4description": "Seasonal (3-month) anomaly correlation between ensemble mean COLA-RSMAS-CCSM4 hindcast sst and ERSSTv4 sst during 1982-2010",
                        "COLARSMASCOLARSMASCCSM4HINDCASTSEASONALCAMSOPIdescription": "Seasonal (3-month) anomaly correlation between ensemble mean COLA-RSMAS-CCSM4 hindcast precipitation and CAMS-OPI precipitation during 1982-2010",
                        "Conventions": "IRIDL"
                    },
                    "Washington": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Washington",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NCEPCFSv2": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NCEP-CFSv2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PENTAD_SAMPLES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PENTAD_SAMPLES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SEASONAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEASONAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "GHCN_CAMS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "GHCN_CAMS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "correlation": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "correlation",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "cNZ": "0",
                                                "history": "[[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1982, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                                "CS": "-1",
                                                "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                                "file_missing_value": "9.99900026E20",
                                                "long_name": "correlation",
                                                "missing_value": "NaN",
                                                "colorscalename": "correlationcolorscale",
                                                "pointwidth": "0",
                                                "scale_min": "-1.0",
                                                "standard_name": "air_temperature",
                                                "units": "unitless",
                                                "maxncolor": "254",
                                                "CE": "1",
                                                "gribfield": "1",
                                                "ncolor": "254",
                                                "scale_max": "1.0"
                                            }
                                        },
                                        "ERSSTv5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERSSTv5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "correlation": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "correlation",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "cNZ": "7",
                                                "history": "[[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1982, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                                "CS": "-1",
                                                "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                                "file_missing_value": "0.0",
                                                "long_name": "correlation",
                                                "missing_value": "NaN",
                                                "colorscalename": "correlationcolorscale",
                                                "pointwidth": "0",
                                                "scale_min": "-1.0",
                                                "standard_name": "sea_surface_temperature",
                                                "units": "unitless",
                                                "maxncolor": "254",
                                                "CE": "1",
                                                "gribfield": "1",
                                                "fnname": "maskge",
                                                "ncolor": "254",
                                                "scale_max": "1.0"
                                            }
                                        },
                                        "ERSSTv4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERSSTv4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "correlation": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "correlation",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "cNZ": "7",
                                                "history": "[[(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version4 sst ]) [(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1982, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version4 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                                "CS": "-1",
                                                "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                                "file_missing_value": "0.0",
                                                "long_name": "correlation",
                                                "missing_value": "NaN",
                                                "colorscalename": "correlationcolorscale",
                                                "pointwidth": "0",
                                                "scale_min": "-1.0",
                                                "standard_name": "sea_surface_temperature",
                                                "units": "unitless",
                                                "maxncolor": "254",
                                                "CE": "1",
                                                "gribfield": "1",
                                                "fnname": "maskge",
                                                "ncolor": "254",
                                                "scale_max": "1.0"
                                            }
                                        },
                                        "CAMSOPI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CAMS-OPI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "correlation": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "correlation",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "cNZ": "0",
                                                "history": "[[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1982, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                                "CS": "-1",
                                                "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                                "file_missing_value": "9.99900026E20",
                                                "long_name": "correlation",
                                                "missing_value": "NaN",
                                                "colorscalename": "correlationcolorscale",
                                                "pointwidth": "0",
                                                "scale_min": "-1.0",
                                                "standard_name": "lwe_precipitation_rate",
                                                "units": "unitless",
                                                "maxncolor": "254",
                                                "CE": "1",
                                                "gribfield": "1",
                                                "ncolor": "254",
                                                "scale_max": "1.0"
                                            }
                                        }
                                    },
                                    "sc8210": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sc8210",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Near-Surface Temperature",
                                            "units": "Celsius_scale",
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                            "gribcenter": "7",
                                            "gribparam": "11",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "missing_value": "NaN",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "air_temperature",
                                            "grib_name": "TMP",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "21",
                                            "gribleveltype": "105"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "pointwidth": "3",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                            "gribcenter": "7",
                                            "gribparam": "11",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "long_name": "Sea Surface Temperature",
                                            "missing_value": "NaN",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "Celsius_scale",
                                            "grib_name": "TMP",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "21",
                                            "gribleveltype": "1"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010]) (Averaged in L with overlapping interval 3)]",
                                            "gribcenter": "7",
                                            "gribparam": "59",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "long_name": "Total Precipitation",
                                            "missing_value": "NaN",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "precipitation_rate",
                                            "units": "mm/day",
                                            "grib_name": "PRATE",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "13",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "MONTHLY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MONTHLY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "air_temperature",
                                            "long_name": "Reference Temperature",
                                            "missing_value": "NaN",
                                            "units": "Kelvin_scale",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "file_missing_value": "9.99900026E20",
                                            "cNZ": "0",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "long_name": "Forecast Time",
                                            "pointwidth": "1.0",
                                            "units": " months since 1960-01-01"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Celsius_scale",
                                            "missing_value": "NaN",
                                            "fnname": "maskge",
                                            "long_name": "Sea Surface Temperature",
                                            "file_missing_value": "0.0",
                                            "standard_name": "sea_surface_temperature",
                                            "cNZ": "7",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "lwe_precipitation_rate",
                                            "long_name": "Total Precipitation",
                                            "missing_value": "NaN",
                                            "units": "mm/day",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "file_missing_value": "9.99900026E20",
                                            "cNZ": "0",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "mc8210": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mc8210",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Near-Surface Temperature",
                                            "units": "Celsius_scale",
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                            "gribcenter": "7",
                                            "gribparam": "11",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "air_temperature",
                                            "grib_name": "TMP",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "21",
                                            "gribleveltype": "105"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "pointwidth": "1",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                            "gribcenter": "7",
                                            "gribparam": "11",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "long_name": "Sea Surface Temperature",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "Celsius_scale",
                                            "grib_name": "TMP",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "21",
                                            "gribleveltype": "1"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "[(Averaged over M[0.5, 24.5]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010])]",
                                            "gribcenter": "7",
                                            "gribparam": "59",
                                            "center": "US Weather Service - National Met. Center",
                                            "PDS_TimeRange": "3",
                                            "long_name": "Total Precipitation",
                                            "PTVersion": "2",
                                            "process": " run.",
                                            "pointwidth": "0",
                                            "standard_name": "precipitation_rate",
                                            "units": "mm/day",
                                            "grib_name": "PRATE",
                                            "GRIBgridcode": "3",
                                            "gribfield": "1",
                                            "gribNumBits": "13",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "FORECAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FORECAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PENTAD_SAMPLES": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PENTAD_SAMPLES",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "MONTHLY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MONTHLY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "air_temperature",
                                            "long_name": "Reference Temperature",
                                            "missing_value": "NaN",
                                            "units": "Kelvin_scale",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "file_missing_value": "9.99900026E20",
                                            "cNZ": "0",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "pointwidth": "1",
                                            "calendar": "360",
                                            "long_name": "Forecast Time",
                                            "units": "months since 1960-01-01"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Celsius_scale",
                                            "missing_value": "NaN",
                                            "fnname": "maskge",
                                            "long_name": "Sea Surface Temperature",
                                            "standard_name": "sea_surface_temperature",
                                            "file_missing_value": "0.0",
                                            "cNZ": "7",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "lwe_precipitation_rate",
                                            "long_name": "Total Precipitation",
                                            "missing_value": "NaN",
                                            "units": "mm/day",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "file_missing_value": "9.99900026E20",
                                            "cNZ": "0",
                                            "gribfield": "1",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "NASA": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NASA",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NASAGMAO062012": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NASA-GMAO-062012",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Reference Temperature",
                                    "standard_name": "air_temperature",
                                    "units": "Kelvin_scale",
                                    "missing_value": "9.99999987E14",
                                    "pointwidth": "0"
                                },
                                "t2mmin": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmin",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999987E14",
                                    "units": "Celsius_scale",
                                    "long_name": "Minimum Temperature",
                                    "standard_name": "air_temperature",
                                    "pointwidth": "0"
                                },
                                "t2mmax": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmax",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999987E14",
                                    "units": "Celsius_scale",
                                    "long_name": "Maximum Temperature",
                                    "standard_name": "air_temperature",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999987E14",
                                    "units": "Celsius_scale",
                                    "long_name": "Sea Surface Temperature",
                                    "standard_name": "sea_surface_temperature",
                                    "pointwidth": "0"
                                },
                                "runoff": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "runoff",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/s",
                                    "long_name": "Runoff",
                                    "standard_name": "runoff_flux",
                                    "missing_value": "9.99999987E14",
                                    "pointwidth": "0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999987E14",
                                    "long_name": "Total Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "pointwidth": "0"
                                },
                                "mmdd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mmdd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "evap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W m-2",
                                    "long_name": "Evaporation",
                                    "missing_value": "9.99999987E14",
                                    "pointwidth": "0"
                                }
                            },
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "defaultvalue": "695.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99999987E14",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "0",
                                            "scale_min": "-1.0",
                                            "standard_name": "air_temperature",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "defaultvalue": "696.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99999987E14",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "0",
                                            "scale_min": "-1.0",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[[(NOAA NCDC ERSST version4 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version4 sst ]) [(NOAA NCDC ERSST version4 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version4 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "defaultvalue": "695.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99999987E14",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "0",
                                            "scale_min": "-1.0",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "defaultvalue": "695.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99999987E14",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "0",
                                            "scale_min": "-1.0",
                                            "standard_name": "lwe_precipitation_rate",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "Montreal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Montreal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GEMNEMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GEM-NEMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from GEM-NEMO_tref_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "air_temperature",
                                            "units": "unitless",
                                            "grib_name": "TMP",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from GEM-NEMO_ERSSTv5_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "unitless",
                                            "grib_name": "WTMP",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from GEM-NEMO_prcp_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "lwe_pecipitation_rate",
                                            "units": "unitless",
                                            "grib_name": "PRATE",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    }
                                },
                                "sc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "grib_name": "TMP",
                                        "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "air_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "41.850006",
                                        "scale_min": "-8.1499939",
                                        "units": "Celsius_scale",
                                        "grib_name": "WTMP",
                                        "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "sea_surface_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "history": "[(mean [ Models NMME GEM-NEMO HINDCAST MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                },
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Meridional Wind",
                                        "units": "m s-1",
                                        "grib_name": "VGRD",
                                        "standard_name": "northward_wind",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Zonal Wind",
                                        "units": "m s-1",
                                        "grib_name": "UGRD",
                                        "standard_name": "eastward_wind",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Reference Temperature",
                                        "units": "K",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "850 hPa Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "units": "K",
                                        "grib_name": "WTMP",
                                        "standard_name": "sea_surface_temperature",
                                        "scale_min": "260.0",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "units": "Pa",
                                        "grib_name": "PRMSL",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "PRATE",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Geopotential Height",
                                        "units": "gpm",
                                        "grib_name": "HGT",
                                        "standard_name": "geopotential_height",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "300.0"
                                    }
                                },
                                "mc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "grib_name": "TMP",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "air_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "41.850006",
                                        "scale_min": "-8.1499939",
                                        "units": "Celsius_scale",
                                        "grib_name": "WTMP",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "sea_surface_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "FORECAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FORECAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Meridional Wind",
                                        "units": "m s-1",
                                        "grib_name": "VGRD",
                                        "standard_name": "northward_wind",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Zonal Wind",
                                        "units": "m s-1",
                                        "grib_name": "UGRD",
                                        "standard_name": "eastward_wind",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Reference Temperature",
                                        "units": "K",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "850 hPa Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Minimum Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMIN",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Maximum Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMAX",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "expires": "1617260400",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0",
                                        "defaultvalue": "734.0",
                                        "bounds": "S"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "units": "K",
                                        "grib_name": "WTMP",
                                        "standard_name": "sea_surface_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "units": "Pa",
                                        "grib_name": "PRMSL",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "PRATE",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "expires": "1617260400",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Geopotential Height",
                                        "units": "gpm",
                                        "grib_name": "HGT",
                                        "standard_name": "geopotential_height",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "300.0"
                                    }
                                }
                            }
                        },
                        "CMC2CanCM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMC2-CanCM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "11",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "history": "[[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "105",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "80",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "history": "[[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP"
                                        }
                                    },
                                    "ERSSTv4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "80",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "history": "[[(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version4 sst ]) [(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version4 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "59",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "lwe_precipitation_rate",
                                            "history": "[[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRATE"
                                        }
                                    }
                                },
                                "sc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "air_temperature",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "3",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "sea_surface_temperature",
                                        "grib_name": "WTMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "lwe_precipitation_rate",
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    }
                                },
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrgd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrgd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "34",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "VGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Meridional Wind",
                                        "standard_name": "northward_wind",
                                        "gribvariable": "34",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "34",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "VGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Meridional Wind",
                                        "standard_name": "northward_wind",
                                        "gribvariable": "34",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "33",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "UGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Zonal Wind",
                                        "standard_name": "eastward_wind",
                                        "gribvariable": "33",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Reference Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "11",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "850 hPa Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "16",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMIN",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Minimum Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "15",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMAX",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Maximum Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "WTMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Sea Surface Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "sea_surface_temperature",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "soilw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/m2",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "127",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "IMGD",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                        "gribcenter": "54",
                                        "standard_name": "soil_moisture_content",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "2",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRMSL",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "gribcenter": "54",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribleveltype": "102",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRATE",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Total Precipitation",
                                        "gribcenter": "54",
                                        "standard_name": "lwe_precipitation_rate",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                },
                                "mc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "air_temperature",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "sea_surface_temperature",
                                        "grib_name": "WTMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "lwe_precipitation_rate",
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    }
                                }
                            },
                            "FORECAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FORECAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY vgrd",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "34",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "VGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Meridional Wind",
                                        "standard_name": "northward_wind",
                                        "gribvariable": "34",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY ugrd",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "33",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "UGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Zonal Wind",
                                        "standard_name": "eastward_wind",
                                        "gribvariable": "33",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tref",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Reference Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmp",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "units": "Kelvin_scale",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "850 hPa Temperature",
                                        "standard_name": "air_temperature",
                                        "gribvariable": "11",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Minimum Temperature",
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmin",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "16",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMIN",
                                        "PDS_TimeRange": "2",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Maximum Temperature",
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmax",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "15",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMAX",
                                        "PDS_TimeRange": "2",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY sst",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "WTMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Sea Surface Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "sea_surface_temperature",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "soilw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY soilw",
                                        "units": "kg/m2",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "127",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "IMGD",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                        "gribcenter": "54",
                                        "standard_name": "soil_moisture_content",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prmsl",
                                        "units": "Pa",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "2",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRMSL",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "gribcenter": "54",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribleveltype": "102",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prec",
                                        "missing_value": "NaN",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRATE",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Total Precipitation",
                                        "gribcenter": "54",
                                        "standard_name": "lwe_precipitation_rate",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "orig": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "orig",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "vgrd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vgrd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "34",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "VGRD",
                                            "gribfield": "1",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "Meridional Wind",
                                            "standard_name": "northward_wind",
                                            "gribvariable": "34",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "ugrd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ugrd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "33",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "UGRD",
                                            "gribfield": "1",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "Zonal Wind",
                                            "standard_name": "eastward_wind",
                                            "gribvariable": "33",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "11",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Reference Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "gribleveltype": "105",
                                            "pointwidth": "0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "11",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "850 hPa Temperature",
                                            "standard_name": "air_temperature",
                                            "gribvariable": "11",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "tmin": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmin",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "16",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMIN",
                                            "PDS_TimeRange": "2",
                                            "long_name": "Minimum Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "tmax": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmax",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "15",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMAX",
                                            "PDS_TimeRange": "2",
                                            "long_name": "Maximum Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "80",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Sea Surface Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "gribleveltype": "1",
                                            "pointwidth": "0"
                                        },
                                        "soilw": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilw",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "127",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "IMGD",
                                            "PDS_TimeRange": "0",
                                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                            "gribcenter": "54",
                                            "standard_name": "soil_moisture_content",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "prmsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prmsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "2",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRMSL",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Pressure Reduced to Mean Sea Level",
                                            "gribcenter": "54",
                                            "standard_name": "air_pressure_at_sea_level",
                                            "gribleveltype": "102",
                                            "pointwidth": "0"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "NaN",
                                            "units": "mm/day",
                                            "file_missing_value": "9.99900026E20",
                                            "gribfield": "1",
                                            "gribNumBits": "16",
                                            "gribparam": "59",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRATE",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Total Precipitation",
                                            "gribcenter": "54",
                                            "standard_name": "lwe_precipitation_rate",
                                            "gribleveltype": "1",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            }
                        },
                        "CMC1CanCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CMC1-CanCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "11",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "history": "[[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "105",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "80",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "history": "[[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP"
                                        }
                                    },
                                    "ERSSTv4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "80",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "history": "[[(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version4 sst ]) [(NOAA NCDC ERSST version4 sst) [(Version 4 based on Version 3b) (Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version4 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version4 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "long_name": "correlation",
                                            "pointwidth": "0",
                                            "gribparam": "59",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "maxncolor": "254",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "standard_name": "lwe_precipitation_rate",
                                            "history": "[[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "gribleveltype": "1",
                                            "scale_min": "-1.0",
                                            "file_missing_value": "9.99900026E20",
                                            "units": "unitless",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "gribfield": "1",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRATE"
                                        }
                                    }
                                },
                                "sc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "air_temperature",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "3",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "sea_surface_temperature",
                                        "grib_name": "WTMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]",
                                        "gribcenter": "54",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "lwe_precipitation_rate",
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    }
                                },
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrgd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrgd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "34",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "VGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Meridional Wind",
                                        "standard_name": "northward_wind",
                                        "gribvariable": "34",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "33",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "UGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Zonal Wind",
                                        "standard_name": "eastward_wind",
                                        "gribvariable": "33",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Reference Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "11",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "850 hPa Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "16",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMIN",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Minimum Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "15",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMAX",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Maximum Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "WTMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Sea Surface Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "sea_surface_temperature",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "soilw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/m2",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "127",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "IMGD",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                        "gribcenter": "54",
                                        "standard_name": "soil_moisture_content",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "2",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRMSL",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "gribcenter": "54",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribleveltype": "102",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRATE",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Total Precipitation",
                                        "gribcenter": "54",
                                        "standard_name": "lwe_precipitation_rate",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    }
                                },
                                "mc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "air_temperature",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Celsius_scale",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "sea_surface_temperature",
                                        "grib_name": "WTMP",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "gribcenter": "54",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "PDS_TimeRange": "10",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "missing_value": "NaN",
                                        "pointwidth": "0",
                                        "standard_name": "lwe_precipitation_rate",
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1"
                                    }
                                }
                            },
                            "FORECAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FORECAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY vgrd",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "34",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "VGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Meridional Wind",
                                        "standard_name": "northward_wind",
                                        "gribvariable": "34",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY ugrd",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "33",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "UGRD",
                                        "gribfield": "1",
                                        "units": "m/s",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "Zonal Wind",
                                        "standard_name": "eastward_wind",
                                        "gribvariable": "33",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tref",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Reference Temperature at 2 Meters",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "105",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmp",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "11",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMP",
                                        "gribfield": "1",
                                        "units": "Kelvin_scale",
                                        "PDS_TimeRange": "10",
                                        "gribcenter": "54",
                                        "long_name": "850 hPa Temperature",
                                        "standard_name": "air_temperature",
                                        "gribvariable": "11",
                                        "gribleveltype": "100",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Minimum Temperature",
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmin",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "16",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMIN",
                                        "PDS_TimeRange": "2",
                                        "gribcenter": "54",
                                        "standard_name": "air_temperature",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Maximum Temperature",
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY tmax",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "15",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "TMAX",
                                        "PDS_TimeRange": "2",
                                        "gribcenter": "54",
                                        "standard_name": "air temperature",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY sst",
                                        "units": "Kelvin_scale",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "80",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "WTMP",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Sea Surface Temperature",
                                        "gribcenter": "54",
                                        "standard_name": "sea_surface_temperature",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "soilw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY soilw",
                                        "units": "kg/m2",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "127",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "IMGD",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                        "gribcenter": "54",
                                        "standard_name": "soil_moisture_content",
                                        "gribleveltype": "119",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prmsl",
                                        "units": "Pa",
                                        "gribfield": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "16",
                                        "gribparam": "2",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRMSL",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "gribcenter": "54",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribleveltype": "102",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "S:  0000 1 Dec 2015 to 0000 1 Jul 2019 appended from Models NMME Cansips FORECAST MONTHLY prec",
                                        "missing_value": "NaN",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribfield": "1",
                                        "gribNumBits": "16",
                                        "gribparam": "59",
                                        "center": "Montreal (RSMC)",
                                        "grib_name": "PRATE",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Total Precipitation",
                                        "gribcenter": "54",
                                        "standard_name": "lwe_precipitation_rate",
                                        "gribleveltype": "1",
                                        "pointwidth": "0"
                                    },
                                    "orig": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "orig",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "vgrd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vgrd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "34",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "VGRD",
                                            "gribfield": "1",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "Meridional Wind",
                                            "standard_name": "northward_wind",
                                            "gribvariable": "34",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "ugrd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ugrd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "33",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "UGRD",
                                            "gribfield": "1",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "Zonal Wind",
                                            "standard_name": "eastward_wind",
                                            "gribvariable": "33",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "tref": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tref",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "11",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Reference Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "gribleveltype": "105",
                                            "pointwidth": "0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "11",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMP",
                                            "gribfield": "1",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "gribcenter": "54",
                                            "long_name": "850 hPa Temperature",
                                            "standard_name": "air_temperature",
                                            "gribvariable": "11",
                                            "gribleveltype": "100",
                                            "pointwidth": "0"
                                        },
                                        "tmin": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmin",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "16",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMIN",
                                            "PDS_TimeRange": "2",
                                            "long_name": "Minimum Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air_temperature",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "tmax": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmax",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "15",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "TMAX",
                                            "PDS_TimeRange": "2",
                                            "long_name": "Maximum Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "air temperature",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "80",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "WTMP",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Sea Surface Temperature",
                                            "gribcenter": "54",
                                            "standard_name": "sea_surface_temperature",
                                            "gribleveltype": "1",
                                            "pointwidth": "0"
                                        },
                                        "soilw": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilw",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "127",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "IMGD",
                                            "PDS_TimeRange": "0",
                                            "long_name": "Soil Moisture Content 0-10cm Below Surface",
                                            "gribcenter": "54",
                                            "standard_name": "soil_moisture_content",
                                            "gribleveltype": "119",
                                            "pointwidth": "0"
                                        },
                                        "prmsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prmsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribfield": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "16",
                                            "gribparam": "2",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRMSL",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Pressure Reduced to Mean Sea Level",
                                            "gribcenter": "54",
                                            "standard_name": "air_pressure_at_sea_level",
                                            "gribleveltype": "102",
                                            "pointwidth": "0"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "missing_value": "NaN",
                                            "units": "mm/day",
                                            "file_missing_value": "9.99900026E20",
                                            "gribfield": "1",
                                            "gribNumBits": "16",
                                            "gribparam": "59",
                                            "center": "Montreal (RSMC)",
                                            "grib_name": "PRATE",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Total Precipitation",
                                            "gribcenter": "54",
                                            "standard_name": "lwe_precipitation_rate",
                                            "gribleveltype": "1",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            }
                        },
                        "CanCM4i": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CanCM4i",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) [(X regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Y regridded on anomaly [ NOAA NCEP CPC GHCN_CAMS gridded deg0p5 temp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from CanCM4i_tref_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "air_temperature",
                                            "units": "unitless",
                                            "grib_name": "TMP",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCDC ERSST version5 sst ]) [(X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from CanCM4i_ERSSTv5_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "unitless",
                                            "grib_name": "WTMP",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "[([[(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(NOAA NCEP CPC CAMS_OPI v0208 mean prcp) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) [(X regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Y regridded on anomaly [ NOAA NCEP CPC CAMS_OPI v0208 mean prcp ]) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from CanCM4i_prcp_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "scale_max": "1.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "scale_min": "-1.0",
                                            "pointwidth": "0",
                                            "gribPDSpattern": "04XXXX",
                                            "standard_name": "lwe_pecipitation_rate",
                                            "units": "unitless",
                                            "grib_name": "PRATE",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    }
                                },
                                "sc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "grib_name": "TMP",
                                        "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "air_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "41.850006",
                                        "scale_min": "-8.1499939",
                                        "units": "Celsius_scale",
                                        "grib_name": "WTMP",
                                        "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "sea_surface_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "history": "[(mean [ Models NMME CanCM4i HINDCAST MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                },
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Meridional Wind",
                                        "units": "m s-1",
                                        "grib_name": "VGRD",
                                        "standard_name": "northward_wind",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Zonal Wind",
                                        "units": "m s-1",
                                        "grib_name": "UGRD",
                                        "standard_name": "eastward_wind",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Reference Temperature",
                                        "units": "K",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "850 hPa Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "units": "K",
                                        "grib_name": "WTMP",
                                        "standard_name": "sea_surface_temperature",
                                        "scale_min": "260.0",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "units": "Pa",
                                        "grib_name": "PRMSL",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "PRATE",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Geopotential Height",
                                        "units": "gpm",
                                        "grib_name": "HGT",
                                        "standard_name": "geopotential_height",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "300.0"
                                    }
                                },
                                "mc8110": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mc8110",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Near-Surface Temperature",
                                        "units": "Celsius_scale",
                                        "grib_name": "TMP",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "air_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "41.850006",
                                        "scale_min": "-8.1499939",
                                        "units": "Celsius_scale",
                                        "grib_name": "WTMP",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "sea_surface_temperature",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/day",
                                        "grib_name": "PRATE",
                                        "history": "[(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)]",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "file_missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "gribPDSpattern": "04XXXX",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "FORECAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "FORECAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vgrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vgrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Meridional Wind",
                                        "units": "m s-1",
                                        "grib_name": "VGRD",
                                        "standard_name": "northward_wind",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "ugrd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ugrd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Zonal Wind",
                                        "units": "m s-1",
                                        "grib_name": "UGRD",
                                        "standard_name": "eastward_wind",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "650.0"
                                    },
                                    "tref": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tref",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Reference Temperature",
                                        "units": "K",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "850 hPa Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMP",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Minimum Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMIN",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "tmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Maximum Temperature",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TMAX",
                                        "standard_name": "air_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Time",
                                        "expires": "1617260400",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0",
                                        "defaultvalue": "734.0",
                                        "bounds": "S"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Sea Surface Temperature",
                                        "units": "K",
                                        "grib_name": "WTMP",
                                        "standard_name": "sea_surface_temperature",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "prmsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prmsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Pressure Reduced to Mean Sea Level",
                                        "units": "Pa",
                                        "grib_name": "PRMSL",
                                        "standard_name": "air_pressure_at_sea_level",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "PRATE",
                                        "standard_name": "lwe_pecipitation_rate",
                                        "expires": "1617260400",
                                        "units": "mm/day",
                                        "file_missing_value": "9.99900026E20",
                                        "gribPDSpattern": "04XXXX",
                                        "defaultvalue": "734.0",
                                        "pointwidth": "0"
                                    },
                                    "hgt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hgt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "9.99900026E20",
                                        "long_name": "Geopotential Height",
                                        "units": "gpm",
                                        "grib_name": "HGT",
                                        "standard_name": "geopotential_height",
                                        "expires": "1617260400",
                                        "gribPDSpattern": "04XXXX",
                                        "pointwidth": "300.0"
                                    }
                                }
                            }
                        }
                    },
                    "GFDL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GFDL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GFDLCM2p5FLORA06": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GFDL-CM2p5-FLOR-A06",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1612162800",
                                    "missing_value": "-9.99999979E33",
                                    "long_name": "Reference Temperature",
                                    "units": "Kelvin_scale",
                                    "standard_name": "air_temperature",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                },
                                "t_ref_min": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t_ref_min",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1612162800",
                                    "missing_value": "-9.99999979E33",
                                    "long_name": "Minimum Temperature",
                                    "units": "Kelvin_scale",
                                    "standard_name": "air_temperature",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                },
                                "t_ref_max": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t_ref_max",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1612162800",
                                    "missing_value": "-9.99999979E33",
                                    "long_name": "Maximum Temperature",
                                    "units": "Kelvin_scale",
                                    "standard_name": "air_temperature",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "expires": "1612162800",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "732.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1612162800",
                                    "missing_value": "-9.99999979E33",
                                    "long_name": "Sea Surface Temperature",
                                    "units": "Celsius_scale",
                                    "standard_name": "sea_surface_temperature",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-9.99999979E33",
                                    "expires": "1612162800",
                                    "long_name": "Total Precipitation",
                                    "standard_name": "lwe_precipitation_rate",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                },
                                "hght": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hght",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1612162800",
                                    "missing_value": "-9.99999979E33",
                                    "long_name": "Geopotential Height at 200 hPa",
                                    "units": "m",
                                    "standard_name": "geopotential_height",
                                    "defaultvalue": "732.0",
                                    "pointwidth": "0"
                                }
                            },
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME GFDL-CM2p5-FLOR-A06 sc8110 tref) ([(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY tref ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "units": "unitless",
                                            "scale_min": "-1.0",
                                            "standard_name": "air_temperature",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "gribfield": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1981, 2010] minimum 0.0% data present)]] (X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)]) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "defaultvalue": "711.0",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "-9.99999979E33",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "0",
                                            "scale_min": "-1.0",
                                            "standard_name": "sea_surface_temperature",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([([[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME GFDL-CM2p5-FLOR-A06 sc8110 sst) ([(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY sst ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from GFDL_FLORA06_sst_anomcorr_s8110_Jul_Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "-999.0",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "1.0",
                                            "standard_name": "sea_surface_temperature",
                                            "scale_min": "-1.0",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([([[(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME GFDL-CM2p5-FLOR-A06 sc8110 prec) ([(mean [ Models NMME GFDL-CM2p5-FLOR-A06 MONTHLY prec ]) [(FERRET V6.72   7-Jun-12) (Averaged over M[0.5, 12.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 1999 - 15 Dec 2000] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1980 - 15 Dec 1981, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from GFDL_FLORA06_prcp_anomcorr_s8110_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "-999.0",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "bounds": "T",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "1.0",
                                            "standard_name": "time",
                                            "scale_min": "-1.0",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "Exeter": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Exeter",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "UKMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "UKMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "GloSea5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "GloSea5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "d2p5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "d2p5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hindcast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "132",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "132",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Meridional Velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "131",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "131",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Zonal Velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "130",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "130",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "t1p5m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t1p5m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "167",
                                            "gribfield": "1",
                                            "gribleveltype": "105",
                                            "scale_max": "307.56787",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "scale_min": "218.74658",
                                            "gribparam": "167",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "1.5m Air Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "34",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "34",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Sea Surface Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2/s",
                                            "gribvariable": "228",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "228",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "precipitation",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "mslp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mslp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribvariable": "151",
                                            "gribfield": "1",
                                            "gribleveltype": "102",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "151",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Mean Sea Level Pressure",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "gz": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gz",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "gribvariable": "129",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "129",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Geopotential Height",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "forecast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "132",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "132",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Meridional velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "131",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "131",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Zonal velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "130",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "130",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "t1p5m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t1p5m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "167",
                                            "gribfield": "1",
                                            "gribleveltype": "105",
                                            "scale_max": "307.56787",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "scale_min": "218.74658",
                                            "gribparam": "167",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "1.5m Air Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "34",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "34",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Sea Surface Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2/s",
                                            "gribvariable": "228",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "228",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "precipitation",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "mslp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mslp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribvariable": "151",
                                            "gribfield": "1",
                                            "gribleveltype": "102",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "151",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Mean Sea Level Pressure",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "gz": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gz",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "gribvariable": "129",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "129",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Geopotential Height",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        }
                                    }
                                },
                                "d1x1shiftnc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "d1x1shiftnc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hindcast_ens28_multiyear": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast_ens28_multiyear",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0",
                                            "defaultvalue": "733.0",
                                            "bounds": "S"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "Sp5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sp5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "Sp1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sp1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "defaultvalue": "733.0",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "hindcast_ens28": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast_ens28",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "forecast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "missing_value": "1.00000002E20",
                                            "um_stash_source": "m01s15i202",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "units": "m/s",
                                            "standard_name": "northward_wind",
                                            "grid_mapping": "latitude_longitude",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "missing_value": "1.00000002E20",
                                            "um_stash_source": "m01s15i201",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "units": "m/s",
                                            "standard_name": "eastward_wind",
                                            "grid_mapping": "latitude_longitude",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "expires": "1615420800",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0",
                                            "bounds": "S"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "expires": "1615420800",
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "pointwidth": "0.0"
                                        }
                                    }
                                },
                                "d1x1nc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "d1x1nc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hindcast_ens28_multiyear": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast_ens28_multiyear",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0",
                                            "defaultvalue": "710.0",
                                            "bounds": "S"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "Sp5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sp5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "Sp1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sp1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "defaultvalue": "710.0",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "hindcast_ens28": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast_ens28",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "hindcast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "y_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "y_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "x_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "x_wind",
                                            "units": "m/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_sea_level",
                                            "units": "Pa",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "forecast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "y_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Meridional Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "northward_wind",
                                            "units": "m/s",
                                            "pointwidth": "0.0"
                                        },
                                        "y_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "y_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "missing_value": "1.00000002E20",
                                            "um_stash_source": "m01s15i202",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "long_name": "Meridional Velocity on Pressure Levels",
                                            "units": "m/s",
                                            "standard_name": "northward_wind",
                                            "grid_mapping": "latitude_longitude",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s15i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time pressure_1 realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i201",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Zonal Velocity on Pressure Levels, Through Aug 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "eastward_wind",
                                            "units": "m/s",
                                            "pointwidth": "0.0"
                                        },
                                        "x_wind": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "x_wind",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "missing_value": "1.00000002E20",
                                            "um_stash_source": "m01s15i201",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "long_name": "Zonal Velocity on Pressure Levels",
                                            "units": "m/s",
                                            "standard_name": "eastward_wind",
                                            "grid_mapping": "latitude_longitude",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "standard_name": "time",
                                            "long_name": "Time",
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0",
                                            "bounds": "S"
                                        },
                                        "surface_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "surface_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i024",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Surface Temperature",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "surface_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "sea_ice_area_fraction": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sea_ice_area_fraction",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s00i031",
                                            "missing_value": "-1.07374182E09",
                                            "long_name": "Sea Ice Area Fraction",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "sea_ice_area_fraction",
                                            "units": "unitless",
                                            "pointwidth": "0.0"
                                        },
                                        "precipitation_flux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precipitation_flux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s05i216",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Precipitation Flux",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "precipitation_flux",
                                            "units": "kg/m2/s",
                                            "pointwidth": "0.0"
                                        },
                                        "geopotential_height": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geopotential_height",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i202",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Geopotential Height",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "geopotential_height",
                                            "units": "m",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0_old": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0_old",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels, Through Feb 2017",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature_0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature_0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s30i204",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Air Temperature on Pressure Levels",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "air_temperature": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_temperature",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s03i236",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Near-Surface Air Temperature",
                                            "coordinates": "forecast_period forecast_reference_time height realization",
                                            "standard_name": "air_temperature",
                                            "units": "Kelvin_scale",
                                            "pointwidth": "0.0"
                                        },
                                        "air_pressure_at_sea_level": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "air_pressure_at_sea_level",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "cell_methods": "time: mean (interval: 1 hour)",
                                            "grid_mapping": "latitude_longitude",
                                            "um_stash_source": "m01s16i222",
                                            "missing_value": "1.00000002E20",
                                            "long_name": "Mean Sea Level Pressure",
                                            "coordinates": "forecast_period forecast_reference_time realization",
                                            "standard_name": "air_pressure_at_mean_sea_level",
                                            "units": "Pa",
                                            "pointwidth": "0.0"
                                        }
                                    }
                                },
                                "d1x1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "d1x1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "hindcast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hindcast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "132",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "132",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Meridional Velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "131",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "131",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Zonal Velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "130",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "130",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "t1p5m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t1p5m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "167",
                                            "gribfield": "1",
                                            "gribleveltype": "105",
                                            "scale_max": "307.56787",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "scale_min": "218.74658",
                                            "gribparam": "167",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "1.5m Air Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "34",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "34",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Sea Surface Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2/s",
                                            "gribvariable": "228",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "228",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "precipitation",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "mslp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mslp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribvariable": "151",
                                            "gribfield": "1",
                                            "gribleveltype": "102",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "151",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Mean Sea Level Pressure",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        },
                                        "gz": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gz",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "gribvariable": "129",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "129",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Geopotential Height",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "fnname": "flagrange",
                                            "pointwidth": "0.0"
                                        }
                                    },
                                    "forecast": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecast",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "132",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "132",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Meridional velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s",
                                            "gribvariable": "131",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "131",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Zonal velocity",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "130",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "130",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "t1p5m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t1p5m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "167",
                                            "gribfield": "1",
                                            "gribleveltype": "105",
                                            "scale_max": "307.56787",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "scale_min": "218.74658",
                                            "gribparam": "167",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "1.5m Air Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "calendar": "360",
                                            "units": "months since 1960-01-01",
                                            "pointwidth": "1.0"
                                        },
                                        "sst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "gribvariable": "34",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "0.0",
                                            "gribNumBits": "12",
                                            "gribparam": "34",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Sea Surface Temperature",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "kg/m2/s",
                                            "gribvariable": "228",
                                            "gribfield": "1",
                                            "gribleveltype": "1",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "228",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "precipitation",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "mslp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "mslp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "gribvariable": "151",
                                            "gribfield": "1",
                                            "gribleveltype": "102",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "151",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Mean Sea Level Pressure",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        },
                                        "gz": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gz",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "gribvariable": "129",
                                            "gribfield": "1",
                                            "gribleveltype": "100",
                                            "missing_value": "9.99900026E20",
                                            "gribNumBits": "12",
                                            "gribparam": "129",
                                            "PTVersion": "1",
                                            "process": "1",
                                            "center": "U.K. Met Office - Exeter",
                                            "calendar": "standard",
                                            "long_name": "Geopotential Height",
                                            "PDS_TimeRange": "3",
                                            "gribcenter": "74",
                                            "pointwidth": "0.0"
                                        }
                                    }
                                }
                            },
                            "GloSea4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "GloSea4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "hindcast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "gribvariable": "132",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "132",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Meridional Velocity",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "gribvariable": "131",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "131",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Zonal Velocity",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "130",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "0.0",
                                        "gribNumBits": "12",
                                        "gribparam": "130",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "t1p5m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t1p5m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "167",
                                        "gribfield": "1",
                                        "gribleveltype": "105",
                                        "scale_max": "307.56787",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "scale_min": "218.74658",
                                        "gribparam": "167",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "1.5m Air Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "34",
                                        "gribfield": "1",
                                        "gribleveltype": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "34",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Sea Surface Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/m2/s",
                                        "gribvariable": "228",
                                        "gribfield": "1",
                                        "gribleveltype": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "228",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "precipitation",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "mslp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mslp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "gribvariable": "151",
                                        "gribfield": "1",
                                        "gribleveltype": "102",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "151",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Mean Sea Level Pressure",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m",
                                        "gribvariable": "129",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "129",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Geopotential Height",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "fnname": "flagge",
                                        "pointwidth": "0.0"
                                    },
                                    "dirname": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dirname",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    }
                                },
                                "forecast": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecast",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "gribvariable": "132",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "132",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Meridional velocity",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "gribvariable": "131",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "131",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Zonal velocity",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "130",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "0.0",
                                        "gribNumBits": "12",
                                        "gribparam": "130",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "t1p5m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t1p5m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "167",
                                        "gribfield": "1",
                                        "gribleveltype": "105",
                                        "scale_max": "307.56787",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "scale_min": "218.74658",
                                        "gribparam": "167",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "1.5m Air Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0"
                                    },
                                    "sst": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sst",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "gribvariable": "34",
                                        "gribfield": "1",
                                        "gribleveltype": "1",
                                        "missing_value": "0.0",
                                        "gribNumBits": "12",
                                        "gribparam": "34",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Sea Surface Temperature",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "kg/m2/s",
                                        "gribvariable": "228",
                                        "gribfield": "1",
                                        "gribleveltype": "1",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "228",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "precipitation",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "mslp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mslp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa",
                                        "gribvariable": "151",
                                        "gribfield": "1",
                                        "gribleveltype": "102",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "151",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Mean Sea Level Pressure",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m",
                                        "gribvariable": "129",
                                        "gribfield": "1",
                                        "gribleveltype": "100",
                                        "missing_value": "9.99900026E20",
                                        "gribNumBits": "12",
                                        "gribparam": "129",
                                        "PTVersion": "1",
                                        "process": "1",
                                        "center": "U.K. Met Office - Exeter",
                                        "calendar": "standard",
                                        "long_name": "Geopotential Height",
                                        "PDS_TimeRange": "3",
                                        "gribcenter": "74",
                                        "pointwidth": "0.0"
                                    }
                                }
                            }
                        }
                    },
                    "COLARSMAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "COLA-RSMAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "COLARSMASCCSM4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "COLA-RSMAS-CCSM4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tsmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tsmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.96920997E36",
                                    "cell_method": "time: maximum",
                                    "long_name": "Maximum surface temperature over output period",
                                    "units": "Kelvin_scale",
                                    "lon": "358.75",
                                    "standard_name": "air_temperature",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "tsmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tsmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.96920997E36",
                                    "cell_method": "time: minimum",
                                    "long_name": "Minimum surface temperature over output period",
                                    "units": "Kelvin_scale",
                                    "lon": "358.75",
                                    "standard_name": "air_temperature",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "tref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.96920997E36",
                                    "cell_method": "time: mean",
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference Temperature",
                                    "standard_name": "air_temperature",
                                    "lon": "358.75",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "expires": "1617237720",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "defaultvalue": "734.0",
                                    "bounds": "S"
                                },
                                "sst": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "89.5",
                                    "missing_value": "9.96920997E36",
                                    "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc",
                                    "long_name": "Sea Surface Temperature",
                                    "units": "Celsius_scale",
                                    "standard_name": "sea_surface_temperature",
                                    "cell_methods": "time: mean",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "soilw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.99999962E35",
                                    "sum_op_ncl": "dim_sum over dimension(s): levgrnd",
                                    "cell_method": "time: mean",
                                    "lon": "358.75",
                                    "long_name": " merely sum of soil liquid water over levels",
                                    "units": "kg/m2",
                                    "standard_name": "soil_moisture_content",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "runoff": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "runoff",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.99999962E35",
                                    "long_name": "surface runoff + sub-surface drainage + surface runoff at glaciers, wetlands, lakes",
                                    "units": "mm/s",
                                    "lon": "358.75",
                                    "standard_name": "runoff_flux",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.96920997E36",
                                    "units": "mm/day",
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "long_name": "Total Precipitation",
                                    "lon": "358.75",
                                    "standard_name": "lwe_precipitation_rate",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "gz": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gz",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.96920997E36",
                                    "units": "m",
                                    "long_name": "Geopotential Height (above sea level)",
                                    "lon": "358.75",
                                    "standard_name": "geopotential_height",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                },
                                "evap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1617237720",
                                    "lat": "90.0",
                                    "missing_value": "9.99999962E35",
                                    "cell_method": "time: mean",
                                    "long_name": "canopy evaporation",
                                    "units": "W/m2",
                                    "lon": "358.75",
                                    "defaultvalue": "734.0",
                                    "pointwidth": "0"
                                }
                            },
                            "HINDCAST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HINDCAST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEASONAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SEASONAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "GHCN_CAMS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "GHCN_CAMS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME COLA-RSMAS-CCSM4 sc8210 tref) ([(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY tref ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "units": "unitless",
                                            "scale_min": "-1.0",
                                            "standard_name": "air_temperature",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "gribfield": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "ERSSTv5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "defaultvalue": "711.0",
                                            "scale_max": "1.0",
                                            "CE": "1",
                                            "CS": "-1",
                                            "pointwidth": "0",
                                            "long_name": "correlation",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "cell_methods": "time: mean",
                                            "maxncolor": "254",
                                            "lat": "89.5",
                                            "standard_name": "sea_surface_temperature",
                                            "history": "[([[(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(mean [ NOAA NCDC ERSST version5 sst ]) [(NOAA NCDC ERSST version5 sst) [(Averaged in T with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over T2[1982, 2010] minimum 0.0% data present)]] (X regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Y regridded on anomaly [ NOAA NCDC ERSST version5 sst ]) (Boxes with less than 0.0% dropped)]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]",
                                            "file_missing_value": "9.96920997E36",
                                            "units": "unitless",
                                            "scale_min": "-1.0",
                                            "colorscalename": "correlationcolorscale",
                                            "ncolor": "254",
                                            "missing_value": "NaN",
                                            "spatial_op": "Conservative remapping: 1st order: destarea: NCL: /homes/min/bin/ncl/POP_REMAP/map_gx1v3_to_1x1d_aave_da-010821.nc"
                                        }
                                    },
                                    "ERSSTv4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERSSTv4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([([[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME COLA-RSMAS-CCSM4 sc8210 sst) ([(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY sst ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from RSMAS_CCSM4_sst_anomcorr_s8210_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "-999.0",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "1.0",
                                            "standard_name": "sea_surface_temperature",
                                            "scale_min": "-1.0",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    },
                                    "CAMSOPI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CAMS-OPI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "correlation": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "correlation",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "history": "[([([[(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)]] [(Models NMME COLA-RSMAS-CCSM4 sc8210 prec) ([(mean [ Models NMME COLA-RSMAS-CCSM4 MONTHLY prec ]) [(Averaged over M[0.5, 10.5] minimum 0.0% data present) (Averaged in L with overlapping interval 3) (Boxes with less than 0.0% dropped)] (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0.0% data present)])]]) (Averaged over S2[16 Dec 1981 - 15 Dec 1982, 16 Dec 2009 - 15 Dec 2010] minimum 0% data present)]) (S:  0000 1 Jul to 0000 1 Dec 1960 appended from RSMAS_CCSM4_prcp_anomcorr_s8210_Jul-Dec.nc correlation)]",
                                            "CS": "-1",
                                            "colormap": "[None 0 8388608 [16711680 25] [16760576 26] [13959039 39] [10025880 26] 11920639 [11920639 26] 65535 [36095 38] [255 38] [128 39] 2763429]",
                                            "file_missing_value": "-999.0",
                                            "long_name": "correlation",
                                            "missing_value": "NaN",
                                            "bounds": "T",
                                            "colorscalename": "correlationcolorscale",
                                            "pointwidth": "1.0",
                                            "standard_name": "time",
                                            "scale_min": "-1.0",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "CE": "1",
                                            "ncolor": "254"
                                        }
                                    }
                                }
                            }
                        }
                    },
                    "S_25": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_25",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time"
                    },
                    "S_24": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_24",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "standard_name": "forecast_reference_time"
                    },
                    "L_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "standard_name": "forecast_period",
                        "pointwidth": "1.0"
                    },
                    "S_23": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_23",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "standard_name": "forecast_reference_time",
                        "calendar": "360",
                        "pointwidth": "0"
                    },
                    "L_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "standard_name": "forecast_period"
                    },
                    "L_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "3.0",
                        "standard_name": "forecast_period"
                    },
                    "S_22": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_22",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0"
                    },
                    "L_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "long_name": "Lead",
                        "standard_name": "forecast_period"
                    },
                    "S_21": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_21",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0"
                    },
                    "S_20": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_20",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "defaultvalue": "714.0"
                    },
                    "S_19": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_19",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0"
                    },
                    "zlev": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "zlev",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level",
                        "pointwidth": "650.0"
                    },
                    "S_18": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_18",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0"
                    },
                    "P_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level",
                        "pointwidth": "650.0"
                    },
                    "P2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level",
                        "pointwidth": "300.0"
                    },
                    "S_17": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_17",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "expires": "1617260400",
                        "defaultvalue": "734.0",
                        "calendar": "360",
                        "pointwidth": "0",
                        "long_name": "Forecast Start Time",
                        "standard_name": "forecast_reference_time"
                    },
                    "S_16": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_16",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "expires": "1612162800",
                        "defaultvalue": "732.0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "pointwidth": "0"
                    },
                    "S_15": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_15",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0.0"
                    },
                    "hdate_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hdate_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "12.0"
                    },
                    "S_14": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_14",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "Y_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "1.0"
                    },
                    "X_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "pointwidth": "1.0"
                    },
                    "S_13": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_13",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "expires": "1615420800",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "S_12": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_12",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "defaultvalue": "710.0",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "hdate": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hdate",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "12.0"
                    },
                    "pressure_0_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_0_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "pointwidth": "300.0"
                    },
                    "M_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "standard_name": "realization",
                        "long_name": "Ensemble Member",
                        "pointwidth": "1.0"
                    },
                    "pressure_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure"
                    },
                    "S_11": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_11",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "pressure_2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure"
                    },
                    "S_10": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_10",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "pressure_1": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_1",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure"
                    },
                    "pressure_0": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_0",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "pointwidth": "300.0"
                    },
                    "S_09": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_09",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "pressure_3": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure_3",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure"
                    },
                    "S_08": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_08",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "pressure": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pressure",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure"
                    },
                    "Y_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "1.0"
                    },
                    "S_07": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_07",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "long_name": "Forecast Start Time",
                        "pointwidth": "0.0"
                    },
                    "M_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "S_06": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_06",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0.0"
                    },
                    "Y_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "1.0"
                    },
                    "L_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "M_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "S_05": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_05",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0.0"
                    },
                    "M_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "P_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "S_04": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_04",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0.0"
                    },
                    "P_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "P_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "Z_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "2.5"
                    },
                    "L_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "pointwidth": "2.5"
                    },
                    "M_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "S_03": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_03",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0.0"
                    },
                    "P_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "pointwidth": "350.0"
                    },
                    "Z_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "standard_name": "height",
                        "long_name": "Height",
                        "pointwidth": "0"
                    },
                    "P": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "P",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "hPa",
                        "gridtype": "0",
                        "standard_name": "air_pressure",
                        "long_name": "Pressure Level",
                        "pointwidth": "0"
                    },
                    "L_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "standard_name": "forecast_period",
                        "pointwidth": "1.0"
                    },
                    "M": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "realization"
                    },
                    "S_02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "defaultvalue": "734.0",
                        "expires": "1617237720",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "pointwidth": "0"
                    },
                    "Z": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Z",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "m",
                        "gridtype": "0",
                        "long_name": "Height",
                        "pointwidth": "0",
                        "standard_name": "height"
                    },
                    "S_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "calendar": "360",
                        "standard_name": "forecast_reference_time",
                        "pointwidth": "0",
                        "defaultvalue": "677.0"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "shiftlag": "0.0",
                        "long_name": "Lead",
                        "pointwidth": "1.0",
                        "standard_name": "forecast_period"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "modulus": "360.0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "S": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "S",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "pointwidth": "0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "dir": "SOURCES/IRI/Analyses/ICPAC/Models"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Models"
                ]
            },
            "LandDAAC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "LandDAAC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MODISversion_005SSAUruguaymonthlyclimlong_name": "2005-2014 monthly climatology",
                    "MODISversion_005SSAlong_name": "Southern South America",
                    "MODISversion_005NSAlong_name": "Northern South America",
                    "MODIS1km8dayversion_005TerraSSAUruguay_Daymonthlyclimlong_name": "2005-2014 monthly climatology",
                    "Conventions": "IRIDL"
                },
                "MODIS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MODIS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "version_005": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version_005",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "SSA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SSA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Uruguay": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Uruguay",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthlyclim": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyclim",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDWI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDWI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "history": "Averaged over T2[2005, 2014] minimum 0.0% data present",
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "monthlyavg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyavg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDWI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDWI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "history": "Boxes with less than 90.0% dropped",
                                        "pointwidth": "0"
                                    }
                                }
                            },
                            "Chile": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Chile",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthlystdanomcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlystdanomcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "history": "[(Boxes with less than 0.0% dropped) (Averaged over T[Dec 2001, Dec 2012] minimum 0.0% data present)]",
                                        "iridlhasSemantics": "iridl:NDVI",
                                        "maxncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "colormap": "2304",
                                        "ncolor": "254",
                                        "pointwidth": "0"
                                    }
                                },
                                "monthlysdcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlysdcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_min": "0.0",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "valid_max": "1.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI"
                                    }
                                },
                                "monthlysd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlysd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_min": "0.0",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "valid_max": "1.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI"
                                    }
                                },
                                "monthlypctavgcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlypctavgcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "scale_max": "400.0",
                                        "CE": "400",
                                        "CS": "0",
                                        "long_name": "NDVI Percent of Normal",
                                        "missing_value": "NaN",
                                        "units": "percent",
                                        "history": "[(Boxes with less than 0.0% dropped) (Averaged over T[Dec 2001, Dec 2012] minimum 0.0% data present)]",
                                        "iridlhasSemantics": "iridl:NDVI",
                                        "maxncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "colormap": "2304",
                                        "ncolor": "254",
                                        "pointwidth": "0"
                                    }
                                },
                                "monthlyclimcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyclimcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_min": "-0.2",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "valid_max": "1.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI",
                                        "history": "[(Boxes with less than 0.0% dropped) (Averaged over T[Dec 2001, Dec 2012] minimum 0.0% data present)]"
                                    }
                                },
                                "monthlyclim": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyclim",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_min": "-0.2",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "valid_max": "1.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI",
                                        "history": "[(Boxes with less than 0.0% dropped) (Averaged over T[Dec 2001, Dec 2012] minimum 0.0% data present)]"
                                    }
                                },
                                "monthlyavg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyavg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "iridlhasSemantics": "iridl:NDVI",
                                        "maxncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "colormap": "2304",
                                        "ncolor": "254",
                                        "CE": "1.0",
                                        "CS": "-0.2",
                                        "pointwidth": "0"
                                    }
                                },
                                "Countrymask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Countrymask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mask_coarse": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mask_coarse",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Chile mask coarse monthly",
                                        "missing_value": "NaN",
                                        "fnname": "maskle",
                                        "history": "Averaged over objectid=243 minimum 0.0% data present",
                                        "scale_max": "1.0",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "ncolor": "254",
                                        "colorscalename": "halfgreyscale",
                                        "maxncolor": "254",
                                        "colormap": "253",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    }
                                }
                            }
                        },
                        "NSA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NSA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Peru": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Peru",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthlystdanomcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlystdanomcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "history": "[([(Boxes with less than 0.0% dropped) (Averaged over T minimum 90.0% data present)]) (Boxes with less than 80.0% dropped) (Boxes with less than 80.0% dropped)]",
                                        "iridlhasSemantics": "iridl:NDVI",
                                        "maxncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "colormap": "2304",
                                        "ncolor": "254",
                                        "pointwidth": "0"
                                    }
                                },
                                "monthlysdcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlysdcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "maxncolor": "254",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "colorscalename": "ndvi_colorsMODIS"
                                    }
                                },
                                "monthlyclimcoarse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyclimcoarse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "modulus": "12.0",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "modulo": "12.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI",
                                        "history": "[([(Boxes with less than 0.0% dropped) (Averaged over T minimum 90.0% data present)]) (Boxes with less than 80.0% dropped) (Boxes with less than 80.0% dropped)]"
                                    }
                                },
                                "monthlyclim": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyclim",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "valid_min": "-0.2",
                                        "missing_value": "NaN",
                                        "ncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "valid_max": "1.0",
                                        "maxncolor": "254",
                                        "pointwidth": "0",
                                        "units": "unitless",
                                        "colormap": "[None 16711680 [16776960 22] [16777215 22] 12446186 [12446186 11] 9753559 [9753559 10] 7847370 [7847370 10] 5091247 [5091247 11] 371072 [371072 21] 32524 [32524 20] 24064 [24064 21] 80640 [80640 21] 2304 [2304 83] 2304 2304]",
                                        "long_name": "NDVI",
                                        "history": "[(Boxes with less than 0.0% dropped) (Averaged over T minimum 90.0% data present)]"
                                    }
                                },
                                "monthlyavg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthlyavg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NDVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NDVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "unitless",
                                        "history": "Boxes with less than 0.0% dropped",
                                        "iridlhasSemantics": "iridl:NDVI",
                                        "maxncolor": "254",
                                        "colorscalename": "ndvi_colorsMODIS",
                                        "colormap": "2304",
                                        "ncolor": "254",
                                        "CE": "1.0",
                                        "CS": "-0.2",
                                        "pointwidth": "0"
                                    }
                                },
                                "Countrymask": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Countrymask",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mask_coarse": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mask_coarse",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Peru mask coarse",
                                        "missing_value": "NaN",
                                        "fnname": "maskle",
                                        "history": "Averaged over objectid=121 minimum 0.0% data present",
                                        "scale_max": "1.0",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "ncolor": "254",
                                        "colorscalename": "halfgreyscale",
                                        "maxncolor": "254",
                                        "colormap": "253",
                                        "PGtype": "bytea",
                                        "OpenGISSimpleFeature": "MULTIPOLYGON",
                                        "SpatialReferenceSystemWKT": "]]"
                                    }
                                }
                            }
                        }
                    },
                    "km": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "1km",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "day": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "8day",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "version_005": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "version_005",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Terra": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Terra",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SSA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SSA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Uruguay_Day": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Uruguay_Day",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "monthlyclim": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "monthlyclim",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "LST": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LST",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "Averaged over T2[2005, 2014] minimum 0.0% data present",
                                                    "missing_value": "NaN",
                                                    "units": "Kelvin_scale",
                                                    "maxncolor": "254",
                                                    "colormap": "255",
                                                    "ncolor": "254",
                                                    "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "monthlyavg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "monthlyavg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "LST": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LST",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "NaN",
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 90.0% dropped",
                                                    "CE": "330",
                                                    "CS": "255",
                                                    "maxncolor": "254",
                                                    "colormap": "255",
                                                    "ncolor": "254",
                                                    "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    }
                                },
                                "Aqua_night": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Aqua_night",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "WAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "valid_max": "1037.5499",
                                        "valid_min": "-123.14999",
                                        "units": "Celsius_scale",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua WAF Night LST",
                                        "missing_value": "NaN",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    },
                                    "SAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "valid_max": "1037.5499",
                                        "valid_min": "-123.14999",
                                        "units": "Celsius_scale",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua SAF Night LST",
                                        "missing_value": "NaN",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    },
                                    "EAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "valid_max": "1037.5499",
                                        "valid_min": "-123.14999",
                                        "units": "Celsius_scale",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua EAF Night LST",
                                        "missing_value": "NaN",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    }
                                },
                                "Aqua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Aqua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "WAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua_reconstructed WAF tmax_rec",
                                        "missing_value": "NaN",
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    },
                                    "SAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua_reconstructed SAF tmax_rec",
                                        "missing_value": "NaN",
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    },
                                    "EAF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EAF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "-10.0",
                                        "scale_max": "50.0",
                                        "CE": "50",
                                        "CS": "-10",
                                        "history": "Y regridded on USGS LandDAAC MODIS 1km 8day version_005 Aqua_reconstructed EAF tmax_rec",
                                        "missing_value": "NaN",
                                        "long_name": "reconstructed tmax",
                                        "units": "Celsius_scale",
                                        "maxncolor": "254",
                                        "colormap": "255",
                                        "ncolor": "254",
                                        "iridlhasSemantics": "iridl:LandSurfaceTemperature",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    }
                },
                "Y_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.002662043"
                },
                "X_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.002662043"
                },
                "T_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "Y_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.002662043"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "X_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.002662043"
                },
                "Y_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.01"
                },
                "X_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.01000001"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "Y_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.00208723"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "X_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.00208723"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.01"
                },
                "X_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.01"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.01064817"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.01064817"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "long_name": "Longitude",
                    "pointwidth": "0.1"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "long_name": "Latitude",
                    "pointwidth": "0.1"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "long_name": "Longitude",
                    "pointwidth": "0.1"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "long_name": "Latitude",
                    "pointwidth": "0.1"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "long_name": "Longitude",
                    "pointwidth": "0.1"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2003-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "standard_name": "time"
                },
                "dir": "SOURCES/IRI/Analyses/LandDAAC"
            },
            "Locust": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Locust",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "CMORPH": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CMORPH",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthlysum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthlysum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 100.0% dropped",
                        "file_missing_value": "-9999.0",
                        "long_name": "Estimated precipitation",
                        "pointwidth": "0"
                    },
                    "monthlyavg": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthlyavg",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "history": "Boxes with less than 90.0% dropped",
                        "units": "mm/hr",
                        "file_missing_value": "-9999.0",
                        "long_name": "Estimated precipitation",
                        "pointwidth": "0"
                    },
                    "dekadsum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dekadsum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "cmorph_dekad_colors",
                        "colormap": "2237106",
                        "scale_max": "300.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "300",
                        "CS": "0",
                        "long_name": "Estimated Dekadal Precipitation",
                        "missing_value": "NaN",
                        "units": "mm",
                        "history": "Boxes with less than 100.0% dropped",
                        "file_missing_value": "-9999.0",
                        "pointwidth": "0"
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.25"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2002-12-07 00:00:00",
                    "gridtype": "0",
                    "calendar": "standard"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "0.25"
                },
                "dir": "SOURCES/IRI/Analyses/Locust"
            },
            "MDG": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "MDG",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "Africa": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Africa",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "queriesCMAPlatest": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "queriesCMAPlatest",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "cabaseline_full": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "cabaseline_full",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Country-Average CMAP 12-Month WASP Baseline",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                            "ncolor": "254",
                            "colorscalename": "std_wasp_colors",
                            "maxncolor": "254",
                            "colormap": "360960",
                            "file_missing_value": "-999.0",
                            "standard_name": "lwe_precipitation_rate"
                        }
                    }
                },
                "BaseYears": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "BaseYears",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "standard_name": "time",
                    "calendar": "360",
                    "pointwidth": "12.0"
                },
                "Baseline": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Baseline",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "long_name": "Month of the year baseline starts",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "12.0",
                    "standard_name": "time"
                },
                "country": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "country",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "gridtype": "2",
                    "units": "ids"
                },
                "dir": "SOURCES/IRI/Analyses/MDG"
            },
            "NOAA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0totaldescription": "CPC GOB monthly precipitation regridded to 1.0 deg. lat/lon resolution to match NMME",
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0resampledseasonality_retainedSPIcorreldescription": "In this dataset the Start Time designates the latest month with real observations, NOT a forecast start time at 0000 1 Jan, for example.  So, for SPI3, with a Jan start time and lead of 1, the forecast is for Feb, and there are 2 months of overlap (Dec and Jan) between SPI3 and SPI2.  For SPI3 with a Jan start time and a lead of 2, the forecast is for Mar, and there is 1 month of overlap (Jan) between SPI3 and SPI1",
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0correl_diffNMME_MME_prcphind_obs_OptPersistSPI9description": "In this dataset SPI values calculated on merged NMME_MME_prcp hindcast data and observed monthly GOB data over Jan 1982-Dec 2010 are correlated with SPI calculated from GOB alone, and this correlation is compared to the equivalent correlation from the optimal persistence calculation to flag which is larger.  This flag will be used to make a skill mask for the MME/Optimal Persistence drought forecast tool.  In this dataset the start time corresponds to the last calendar month of observations before forecast data are appended, NOT a 0000 1 Jan forecast start, for example.",
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0correl_diffNMME_MME_prcphind_obs_OptPersistSPI6description": "In this dataset SPI values calculated on merged NMME_MME_prcp hindcast data and observed monthly GOB data over Jan 1982-Dec 2010 are correlated with SPI calculated from GOB alone, and this correlation is compared to the equivalent correlation from the optimal persistence calculation to flag which is larger.  This flag will be used to make a skill mask for the MME/Optimal Persistence drought forecast tool.  In this dataset the start time corresponds to the last calendar month of observations before forecast data are appended, NOT a 0000 1 Jan forecast start, for example.",
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0correl_diffNMME_MME_prcphind_obs_OptPersistSPI3description": "In this dataset SPI values calculated on merged NMME_MME_prcp hindcast data and observed monthly GOB data over Jan 1982-Dec 2010 are correlated with SPI calculated from GOB alone, and this correlation is compared to the equivalent correlation from the optimal persistence calculation to flag which is larger.  This flag will be used to make a skill mask for the MME/Optimal Persistence drought forecast tool.  In this dataset the start time corresponds to the last calendar month of observations before forecast data are appended, NOT a 0000 1 Jan forecast start, for example.",
                    "NCEPCPCGOBV0pxNMME_droughtmonthlyNMME_deg1p0correl_diffNMME_MME_prcphind_obs_OptPersistSPI12description": "In this dataset SPI values calculated on merged NMME_MME_prcp hindcast data and observed monthly GOB data over Jan 1982-Dec 2010 are correlated with SPI calculated from GOB alone, and this correlation is compared to the equivalent correlation from the optimal persistence calculation to flag which is larger.  This flag will be used to make a skill mask for the MME/Optimal Persistence drought forecast tool.  In this dataset the start time corresponds to the last calendar month of observations before forecast data are appended, NOT a 0000 1 Jan forecast start, for example.",
                    "Conventions": "IRIDL"
                },
                "NCEP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NCEP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CPC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CPC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "GOB": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GOB",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "V0px": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "V0px",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NMME_drought": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NMME_drought",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NMME_deg1p0": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NMME_deg1p0",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "total": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "total",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "precipitation": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "precipitation",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "precipitation",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 25.0% dropped",
                                                    "units": "mm/month",
                                                    "file_missing_value": "-999.0",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "resampled": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "resampled",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "seasonality_retained": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "seasonality_retained",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "SPIcorrel": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "SPIcorrel",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "spi9": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi9",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "corrSPI9": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "corrSPI9",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi6": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi6",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "corrSPI6": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "corrSPI6",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi3": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi3",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "corrSPI3": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "corrSPI3",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi12": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi12",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "corrSPI12": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "corrSPI12",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "units": "unitless",
                                                                "modulo": "12.0",
                                                                "modulus": "12.0",
                                                                "pointwidth": "1.0"
                                                            }
                                                        }
                                                    },
                                                    "forecast": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "forecast",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "spi9": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi9",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sigma": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sigma",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "long_name": "sigma",
                                                                "fnname": "sqrt",
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "mean": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mean",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "history": "L:  8.0 months to 8.0 months appended from   spi   prob   pcpn_accum [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 total precipitation ]       * [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 resampled seasonality_retained SPIcorrel spi9 corrSPI9 ]",
                                                                "long_name": "mean",
                                                                "missing_value": "NaN",
                                                                "units": "unitless",
                                                                "maxncolor": "254",
                                                                "colormap": "45",
                                                                "ncolor": "253",
                                                                "file_missing_value": "-9.9899998",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "forecasttime": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "forecasttime",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "standard_name": "time",
                                                                "long_name": "Forecast Time",
                                                                "calendar": "360",
                                                                "units": "months since 1960-01-01",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi6": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi6",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sigma": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sigma",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "long_name": "sigma",
                                                                "fnname": "sqrt",
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "mean": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mean",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "history": "L:  5.0 months to 5.0 months appended from   spi   prob   pcpn_accum [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 total precipitation ]       * [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 resampled seasonality_retained SPIcorrel spi6 corrSPI6 ]",
                                                                "long_name": "mean",
                                                                "missing_value": "NaN",
                                                                "units": "unitless",
                                                                "maxncolor": "254",
                                                                "colormap": "45",
                                                                "ncolor": "253",
                                                                "file_missing_value": "-9.9899998",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "forecasttime": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "forecasttime",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "standard_name": "time",
                                                                "long_name": "Forecast Time",
                                                                "calendar": "360",
                                                                "units": "months since 1960-01-01",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi3": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi3",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sigma": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sigma",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "long_name": "sigma",
                                                                "fnname": "sqrt",
                                                                "units": "unitless",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "mean": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mean",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "history": "L:  2.0 months to 2.0 months appended from   spi   prob   pcpn_accum [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 total precipitation ]       * [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 resampled seasonality_retained SPIcorrel spi3 corrSPI3 ]",
                                                                "long_name": "mean",
                                                                "missing_value": "NaN",
                                                                "units": "unitless",
                                                                "maxncolor": "254",
                                                                "colormap": "45",
                                                                "ncolor": "253",
                                                                "file_missing_value": "-9.9899998",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "forecasttime": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "forecasttime",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "standard_name": "time",
                                                                "long_name": "Forecast Time",
                                                                "calendar": "360",
                                                                "units": "months since 1960-01-01",
                                                                "pointwidth": "1.0"
                                                            }
                                                        },
                                                        "spi12": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "spi12",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sigma": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sigma",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "long_name": "sigma",
                                                                "fnname": "sqrt",
                                                                "units": "unitless",
                                                                "modulo": "12.0",
                                                                "modulus": "12.0",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "mean": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mean",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "history": "L:  11.0 months to 11.0 months appended from   spi   prob   pcpn_accum [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 total precipitation ]       * [ IRI Analyses NOAA NCEP CPC GOB V0px NMME_drought monthly NMME_deg1p0 resampled seasonality_retained SPIcorrel spi12 corrSPI12 ]",
                                                                "long_name": "mean",
                                                                "missing_value": "NaN",
                                                                "units": "unitless",
                                                                "maxncolor": "254",
                                                                "colormap": "45",
                                                                "ncolor": "253",
                                                                "file_missing_value": "-9.9899998",
                                                                "pointwidth": "1.0"
                                                            },
                                                            "forecasttime": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "forecasttime",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "standard_name": "time",
                                                                "long_name": "Forecast Time",
                                                                "calendar": "360",
                                                                "units": "months since 1960-01-01",
                                                                "pointwidth": "1.0"
                                                            }
                                                        }
                                                    }
                                                }
                                            },
                                            "correl_diff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "correl_diff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "NMME_MME_prcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "NMME_MME_prcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "hind_obs_OptPersist": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "hind_obs_OptPersist",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "SPI9": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "SPI9",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sep": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sep",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "oct": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "oct",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "nov": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "nov",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "may": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "may",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "mar": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mar",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jun": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jun",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jul": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jul",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jan": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jan",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "feb": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "feb",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "dec": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "dec",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "aug": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "aug",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "apr": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "apr",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            }
                                                        },
                                                        "SPI6": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "SPI6",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sep": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sep",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "oct": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "oct",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "nov": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "nov",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "may": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "may",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "mar": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mar",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jun": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jun",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jul": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jul",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jan": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jan",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "feb": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "feb",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "dec": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "dec",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "aug": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "aug",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "apr": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "apr",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            }
                                                        },
                                                        "SPI3": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "SPI3",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sep": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sep",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "oct": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "oct",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "nov": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "nov",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "may": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "may",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "mar": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mar",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jun": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jun",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jul": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jul",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jan": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jan",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "feb": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "feb",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "dec": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "dec",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "aug": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "aug",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "apr": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "apr",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            }
                                                        },
                                                        "SPI12": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "SPI12",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "sep": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "sep",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "oct": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "oct",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "nov": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "nov",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "may": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "may",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "mar": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "mar",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jun": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jun",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jul": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jul",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "jan": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "jan",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "feb": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "feb",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "dec": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "dec",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "aug": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "aug",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            },
                                                            "apr": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "apr",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "flag": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "flag",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "units": "unitless",
                                                                    "pointwidth": "1.0"
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            },
                                            "amplitudebiasfactor": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "amplitudebiasfactor",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "NMME_MMprcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "NMME_MMprcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "c8210": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "c8210",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "_global": {
                                                            "iridl_type": "DataSet",
                                                            "iridl_ds_name": "global",
                                                            "banned": [
                                                                "dir",
                                                                "invalid",
                                                                "parent",
                                                                "name",
                                                                "banned",
                                                                "banned_long",
                                                                "iridl_ds_name",
                                                                "iridl_type"
                                                            ],
                                                            "lead_0month": {
                                                                "iridl_type": "DataSet",
                                                                "iridl_ds_name": "lead_0month",
                                                                "banned": [
                                                                    "dir",
                                                                    "invalid",
                                                                    "parent",
                                                                    "name",
                                                                    "banned",
                                                                    "banned_long",
                                                                    "iridl_ds_name",
                                                                    "iridl_type"
                                                                ],
                                                                "sep": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "sep",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "oct": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "oct",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "nov": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "nov",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "may": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "may",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "mar": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "mar",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "jun": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "jun",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "jul": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "jul",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "jan": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "jan",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "feb": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "feb",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "dec": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "dec",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "aug": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "aug",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                },
                                                                "apr": {
                                                                    "iridl_type": "DataSet",
                                                                    "iridl_ds_name": "apr",
                                                                    "banned": [
                                                                        "dir",
                                                                        "invalid",
                                                                        "parent",
                                                                        "name",
                                                                        "banned",
                                                                        "banned_long",
                                                                        "iridl_ds_name",
                                                                        "iridl_type"
                                                                    ],
                                                                    "correction_factor": {
                                                                        "iridl_type": "DataSet",
                                                                        "iridl_ds_name": "correction_factor",
                                                                        "banned": [
                                                                            "dir",
                                                                            "invalid",
                                                                            "parent",
                                                                            "name",
                                                                            "banned",
                                                                            "banned_long",
                                                                            "iridl_ds_name",
                                                                            "iridl_type"
                                                                        ],
                                                                        "units": "unitless",
                                                                        "missing_value": "-9999.0"
                                                                    }
                                                                }
                                                            }
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                },
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mm/month",
                                        "missing_value": "NaN",
                                        "history": "T:  Nov 2014 to Feb 2021 appended from NOAA NCEP CPC GOB V0px daily REALTIME prcp",
                                        "file_missing_value": "-999.0",
                                        "long_name": "blended daily precipitation",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        }
                    }
                },
                "NCDC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NCDC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "USHCN": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "USHCN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MinpctilAT2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MinpctilAT2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "percentile": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "percentile",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "8",
                                    "colormap": "2763429",
                                    "scale_max": "4.0",
                                    "ncolor": "8",
                                    "scale_min": "0.0",
                                    "CE": "4",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "ids",
                                    "long_name": "Min Apparent Temperature Percentile Category",
                                    "CLIST": "\\xe2\\x89\\xa5 95th"
                                }
                            },
                            "Minpctil2mt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Minpctil2mt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "percentile": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "percentile",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "8",
                                    "colormap": "2763429",
                                    "scale_max": "4.0",
                                    "ncolor": "8",
                                    "scale_min": "0.0",
                                    "CE": "4",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "ids",
                                    "long_name": "MinT Heat Percentile Category",
                                    "CLIST": "\\xe2\\x89\\xa5 95th"
                                }
                            },
                            "MaxpctilAT2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MaxpctilAT2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "percentile": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "percentile",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "8",
                                    "colormap": "2763429",
                                    "scale_max": "4.0",
                                    "ncolor": "8",
                                    "scale_min": "0.0",
                                    "CE": "4",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "ids",
                                    "long_name": "Max Apparent Temperature Percentile Category",
                                    "CLIST": "\\xe2\\x89\\xa5 95th"
                                }
                            },
                            "Maxpctil2mt": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Maxpctil2mt",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "percentile": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "percentile",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "8",
                                    "colormap": "2763429",
                                    "scale_max": "4.0",
                                    "ncolor": "8",
                                    "scale_min": "0.0",
                                    "CE": "4",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "ids",
                                    "long_name": "MaxT Heat Percentile Category",
                                    "CLIST": "\\xe2\\x89\\xa5 95th"
                                }
                            },
                            "HWlength_2mtmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HWlength_2mtmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heatwave_length": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heatwave_length",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "11",
                                    "colormap": "6303920",
                                    "scale_max": "7.0",
                                    "ncolor": "11",
                                    "scale_min": "0.0",
                                    "CE": "7",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "days",
                                    "long_name": "MinT Heatwave Length in Consecutive Days",
                                    "CLIST": "\\xe2\\x89\\xa5 9 dy"
                                }
                            },
                            "HWlength_2mtmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HWlength_2mtmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heatwave_length": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heatwave_length",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "11",
                                    "colormap": "6303920",
                                    "scale_max": "7.0",
                                    "ncolor": "11",
                                    "scale_min": "0.0",
                                    "CE": "7",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "days",
                                    "long_name": "MaxT Heatwave Length in Consecutive Days",
                                    "CLIST": "\\xe2\\x89\\xa5 9 dy"
                                }
                            },
                            "HWlength_2mATmin": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HWlength_2mATmin",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heatwave_length": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heatwave_length",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "11",
                                    "colormap": "6303920",
                                    "scale_max": "7.0",
                                    "ncolor": "11",
                                    "scale_min": "0.0",
                                    "CE": "7",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "days",
                                    "long_name": "Min Apparent Temperature Heatwave Length in Consecutive Days",
                                    "CLIST": "\\xe2\\x89\\xa5 9 dy"
                                }
                            },
                            "HWlength_2mATmax": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "HWlength_2mATmax",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "heatwave_length": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "heatwave_length",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "11",
                                    "colormap": "6303920",
                                    "scale_max": "7.0",
                                    "ncolor": "11",
                                    "scale_min": "0.0",
                                    "CE": "7",
                                    "CS": "0",
                                    "missing_value": "9.0",
                                    "units": "days",
                                    "long_name": "Max Apparent Temperature Heatwave Length in Consecutive Days",
                                    "CLIST": "\\xe2\\x89\\xa5 9 dy"
                                }
                            }
                        }
                    }
                },
                "L_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "L_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "L_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "long_name": "Start Time",
                    "pointwidth": "1.0"
                },
                "L_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start Time",
                    "pointwidth": "1.0"
                },
                "L_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "lead",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360"
                },
                "L_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Lead",
                    "pointwidth": "1.0"
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Lead",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Lead",
                    "pointwidth": "1.0"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "latitude",
                    "pointwidth": "1.0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Lead",
                    "pointwidth": "1.0"
                },
                "T_13": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_13",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "1.0"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "1.0"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.25"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.25"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "julian_day",
                    "gridtype": "0",
                    "calendar": "standard",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "dir": "SOURCES/IRI/Analyses/NOAA"
            },
            "SPI": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SPI",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "SPIUEA_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-UEA_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-UEA_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPIUEA_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-UEA_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-UEA_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPIUEA_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-UEA_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-UEA_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPIUEA_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-UEA_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-UEA_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPIUEA_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-UEA_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-UEA_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPITS2p1_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-TS2p1_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-TS2p1_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPITS2p1_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-TS2p1_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-TS2p1_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPITS2p1_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-TS2p1_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-TS2p1_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPITS2p1_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-TS2p1_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-TS2p1_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPITS2p1_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-TS2p1_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-TS2p1_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPIPRECL0p5_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-PRECL0p5_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-PRECL0p5_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "standard_name": "lwe_precipitation_rate",
                    "expires": "1617235200",
                    "pointwidth": "0"
                },
                "SPIPRECL0p5_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-PRECL0p5_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-PRECL0p5_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "standard_name": "lwe_precipitation_rate",
                    "expires": "1617235200",
                    "pointwidth": "0"
                },
                "SPIPRECL0p5_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-PRECL0p5_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-PRECL0p5_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "standard_name": "lwe_precipitation_rate",
                    "expires": "1617235200",
                    "pointwidth": "0"
                },
                "SPIPRECL0p5_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-PRECL0p5_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-PRECL0p5_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "standard_name": "lwe_precipitation_rate",
                    "expires": "1617235200",
                    "pointwidth": "0"
                },
                "SPIPRECL0p5_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-PRECL0p5_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-PRECL0p5_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "standard_name": "lwe_precipitation_rate",
                    "expires": "1617235200",
                    "pointwidth": "0"
                },
                "SPIGPCPv2OPI_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GPCPv2OPI_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-GPCPv2OPI_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "technique": "OPI",
                    "pointwidth": "0"
                },
                "SPIGPCPv2OPI_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GPCPv2OPI_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-GPCPv2OPI_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "technique": "OPI",
                    "pointwidth": "0"
                },
                "SPIGPCPv2OPI_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GPCPv2OPI_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-GPCPv2OPI_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "technique": "OPI",
                    "pointwidth": "0"
                },
                "SPIGPCPv2OPI_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GPCPv2OPI_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-GPCPv2OPI_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "technique": "OPI",
                    "pointwidth": "0"
                },
                "SPIGPCPv2OPI_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GPCPv2OPI_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-GPCPv2OPI_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "technique": "OPI",
                    "pointwidth": "0"
                },
                "SPIGOBv0px1deg_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GOBv0px1deg_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "17920",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "drought_monitor_colors1",
                    "CE": "3.5",
                    "long_name": "9-Month Standardized Precipitation Index",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "history": "Boxes with less than 25.0% dropped",
                    "pointwidth": "1.0"
                },
                "SPIGOBv0px1deg_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GOBv0px1deg_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "17920",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "drought_monitor_colors1",
                    "CE": "3.5",
                    "long_name": "6-Month Standardized Precipitation Index",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "history": "Boxes with less than 25.0% dropped",
                    "pointwidth": "1.0"
                },
                "SPIGOBv0px1deg_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GOBv0px1deg_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "17920",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "drought_monitor_colors1",
                    "CE": "3.5",
                    "long_name": "3-Month Standardized Precipitation Index",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "history": "Boxes with less than 25.0% dropped",
                    "pointwidth": "1.0"
                },
                "SPIGOBv0px1deg_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GOBv0px1deg_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "17920",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "drought_monitor_colors1",
                    "CE": "3.5",
                    "long_name": "12-Month Standardized Precipitation Index",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "history": "Boxes with less than 25.0% dropped",
                    "pointwidth": "1.0"
                },
                "SPIGOBv0px1deg_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-GOBv0px1deg_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "17920",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "drought_monitor_colors1",
                    "CE": "3.5",
                    "long_name": "1-Month Standardized Precipitation Index",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "history": "Boxes with less than 25.0% dropped",
                    "pointwidth": "1.0"
                },
                "SPICMAP0407v1_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CMAP0407v1_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CMAP0407v1_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPICMAP0407v1_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CMAP0407v1_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CMAP0407v1_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPICMAP0407v1_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CMAP0407v1_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CMAP0407v1_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPICMAP0407v1_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CMAP0407v1_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CMAP0407v1_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPICMAP0407v1_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CMAP0407v1_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CMAP0407v1_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998"
                },
                "SPICAMSOPI_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CAMSOPI_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CAMS_OPI_9-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "expires": "1617235200",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360",
                    "bounds": "T"
                },
                "SPICAMSOPI_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CAMSOPI_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CAMS_OPI_6-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "expires": "1617235200",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360",
                    "bounds": "T"
                },
                "SPICAMSOPI_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CAMSOPI_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CAMS_OPI_3-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "expires": "1617235200",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360",
                    "bounds": "T"
                },
                "SPICAMSOPI_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CAMSOPI_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CAMS_OPI_12-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "expires": "1617235200",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360",
                    "bounds": "T"
                },
                "SPICAMSOPI_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SPI-CAMSOPI_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "3.0999999",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-3.0999999",
                    "CS": "-3.0999999",
                    "CE": "3.0999999",
                    "colormap": "360960",
                    "long_name": "SPI-CAMS_OPI_1-month",
                    "units": "unitless",
                    "missing_value": "NaN",
                    "file_missing_value": "-9.9899998",
                    "expires": "1617235200",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360",
                    "bounds": "T"
                },
                "T_29": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_29",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_28": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_28",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_27": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_27",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_26": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_26",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_25": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_25",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "T_24": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_24",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_23": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_23",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_22": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_22",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_21": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_21",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_20": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_20",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "T_19": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_19",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_18": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_17": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_17",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_16": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_16",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude",
                    "long_name": "Latitude"
                },
                "T_15": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_15",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1617235200",
                    "pointwidth": "1.0",
                    "long_name": "Time",
                    "standard_name": "time"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude",
                    "long_name": "Longitude"
                },
                "T_14": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_14",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_13": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_13",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "T_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "calendar": "360",
                    "expires": "1617235200"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/IRI/Analyses/SPI"
            },
            "TS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "TS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "AR4history": " (20C3M) experiment are used. To obtain an estimate of the forced response, we average together the 20th-century global mean temperature records from the members of this ensemble, which here includes 23 (nearly all) of the IPCC GCMs. The multimodel mean signal is further processed, by lowpass filtering.",
                    "description": "Time Scales",
                    "Conventions": "IRIDL"
                },
                "AR4": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AR4",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tas": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tas",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "Kelvin_scale",
                        "long_name": "temperature at surface"
                    }
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "12"
                },
                "dir": "SOURCES/IRI/Analyses/TS"
            },
            "Tailored": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/Analyses/Tailored",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "Tailored",
                "restriction": "Public",
                "Bangladesh": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Tailored/Bangladesh",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Bangladesh",
                    "restriction": "Public",
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1951, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Bangladesh/precipitation"
                    },
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "88.0",
                            "scale_max": "93.0",
                            "units": "degree_east",
                            "missing_value": "999.0"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "long_name": "location",
                            "SpatialReferenceSystemWKT": "]]",
                            "scale_min": "88",
                            "scale_max": "93",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "20.0",
                            "scale_max": "27.0",
                            "units": "degree_north",
                            "missing_value": "999.0"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "maxncolor": "254",
                            "colormap": "255",
                            "long_name": "Minimum Temperature",
                            "history": "Averaged over T[Jan 1979, 2400 31 Jan 2011] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "file_missing_value": "999.0"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "999.0",
                            "units": "m"
                        },
                        "IWMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IWMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Bangladesh/temperature"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "precipitation",
                        "temperature"
                    ]
                },
                "Ethiopia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Ethiopia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[11-31 Jan 1983, 2400 31 Jan 2010]",
                            "pointwidth": "1.0"
                        }
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "standard_name": "longitude",
                        "pointwidth": "0.1"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "0.09999999"
                    },
                    "dir": "SOURCES/IRI/Analyses/Tailored/Ethiopia"
                },
                "Lao": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Tailored/Lao",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Lao",
                    "restriction": "Public",
                    "CCROMASEAN": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/Analyses/Tailored/Lao/CCROM-ASEAN",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "CCROM-ASEAN",
                        "restriction": "Public",
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "108.0",
                                "scale_min": "100.0",
                                "units": "degree_east",
                                "long_name": "Longitude"
                            },
                            "location": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "location",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OpenGISSimpleFeature": "Point",
                                "SpatialReferenceSystemWKT": "]]",
                                "long_name": "location",
                                "scale_max": "108.0",
                                "scale_min": "100.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "23.0",
                                "scale_min": "13.5",
                                "units": "degree_north",
                                "long_name": "Latitude"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "label"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan 1980, 2400 31 Jan 2010] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-999.0"
                            },
                            "Station": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Station",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2"
                            },
                            "dir": "SOURCES/IRI/Analyses/Tailored/Lao/CCROM-ASEAN/precipitation"
                        },
                        "temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "108.0",
                                "scale_min": "100.0",
                                "units": "degree_east",
                                "long_name": "Longitude"
                            },
                            "location": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "location",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OpenGISSimpleFeature": "Point",
                                "SpatialReferenceSystemWKT": "]]",
                                "long_name": "location",
                                "scale_max": "108.0",
                                "scale_min": "100.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "23.0",
                                "scale_min": "13.5",
                                "units": "degree_north",
                                "long_name": "Latitude"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "label"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "maxncolor": "254",
                                "colormap": "255",
                                "long_name": "Minimum Temperature",
                                "history": "Averaged over T[Jan 1980, 2400 31 Jan 2010] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "units": "Celsius_scale",
                                "file_missing_value": "-999.0"
                            },
                            "Station": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Station",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2"
                            },
                            "dir": "SOURCES/IRI/Analyses/Tailored/Lao/CCROM-ASEAN/temperature"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "precipitation",
                            "temperature"
                        ]
                    },
                    "aphroditeV1101": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "aphroditeV1101",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan 1951, 2400 31 Jan 2007] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "pointwidth": "0"
                            }
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Lao/aphroditeV1101"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "CCROMASEAN",
                        "aphroditeV1101"
                    ]
                },
                "Monsoon_Asia": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Tailored/Monsoon_Asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Monsoon_Asia",
                    "restriction": "Public",
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1951, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Monsoon_Asia/precipitation"
                    },
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Chilling Degree Days",
                            "history": "Averaged over T[Jan 1961, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "units": "86400 (degree_Kelvin above 273.15) second",
                            "fnname": "abs",
                            "file_missing_value": "-99.900002",
                            "maxncolor": "254",
                            "colorscalename": "temp_colors",
                            "colormap": "255",
                            "ncolor": "254",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Monsoon_Asia/temperature"
                    },
                    "temperature2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Mean Temperature",
                            "history": "Averaged over T[Jan 1961, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "file_missing_value": "-99.900002",
                            "maxncolor": "254",
                            "colorscalename": "temp_colors",
                            "colormap": "255",
                            "ncolor": "254",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Monsoon_Asia/temperature2"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "precipitation",
                        "temperature",
                        "temperature2"
                    ]
                },
                "NE_Brazil": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NE_Brazil",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-42.0",
                            "scale_max": "-37.5",
                            "units": "degree_east",
                            "long_name": "longitude"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "long_name": "location",
                            "SpatialReferenceSystemWKT": "]]",
                            "scale_min": "-42.0",
                            "scale_max": "-37.5",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-8.0",
                            "scale_max": "-2.5",
                            "units": "degree_north",
                            "long_name": "latitude"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1973, 2400 31 Jan 2002] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-1.0"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "units": "m",
                            "long_name": "Elevation"
                        }
                    },
                    "STNID": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STNID",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "long_name": "Station"
                    },
                    "dir": "SOURCES/IRI/Analyses/Tailored/NE_Brazil"
                },
                "Nepal": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Tailored/Nepal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Nepal",
                    "restriction": "Public",
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1951, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Nepal/precipitation"
                    },
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "79.5",
                            "scale_max": "88.5",
                            "units": "degree_east",
                            "missing_value": "999.0"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "long_name": "location",
                            "SpatialReferenceSystemWKT": "]]",
                            "scale_min": "79.5",
                            "scale_max": "88.5",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "26.0",
                            "scale_max": "31.0",
                            "units": "degree_north",
                            "missing_value": "999.0"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "maxncolor": "254",
                            "colormap": "255",
                            "long_name": "Minimum Temperature",
                            "history": "Averaged over T[Jan 1979, 2400 31 Jan 2011] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "file_missing_value": "999.0"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "999.0",
                            "units": "m"
                        },
                        "IWMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IWMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Nepal/temperature"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "precipitation",
                        "temperature"
                    ]
                },
                "Northern_India": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Tailored/Northern_India",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Northern_India",
                    "restriction": "Public",
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan 1951, 2400 31 Jan 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-99.900002",
                            "pointwidth": "0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "0.25"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "0.25"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Northern_India/precipitation"
                    },
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "IMD_temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IMD_temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "maxncolor": "254",
                                "colormap": "255",
                                "long_name": "Minimum Temperature",
                                "history": "Averaged over T[Jan 1979, 2400 31 Jan 2005] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "units": "Celsius_scale",
                                "file_missing_value": "99.900002",
                                "calendar": "standard",
                                "pointwidth": "1.0",
                                "standard_name": "air_temperature",
                                "step": "1.0"
                            }
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "maxncolor": "254",
                            "colormap": "255",
                            "long_name": "Minimum Temperature",
                            "history": "Averaged over T[Jan 1979, 2400 31 Jan 2005] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "units": "Celsius_scale",
                            "file_missing_value": "99.900002",
                            "calendar": "standard",
                            "pointwidth": "1.0",
                            "standard_name": "air_temperature",
                            "step": "1.0"
                        },
                        "GSOD_temperature": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GSOD_temperature",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "73.0",
                                "scale_max": "89.0",
                                "units": "degree_east",
                                "missing_value": "999.0"
                            },
                            "location": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "location",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OpenGISSimpleFeature": "Point",
                                "long_name": "location",
                                "SpatialReferenceSystemWKT": "]]",
                                "scale_min": "73",
                                "scale_max": "89",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "24.0",
                                "scale_max": "33.0",
                                "units": "degree_north",
                                "missing_value": "999.0"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ncolor": "254",
                                "colorscalename": "temp_colors",
                                "maxncolor": "254",
                                "colormap": "255",
                                "long_name": "Minimum Temperature",
                                "history": "Averaged over T[Jan 1979, 2400 31 Jan 2011] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "units": "Celsius_scale",
                                "file_missing_value": "999.0"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "999.0",
                                "units": "m"
                            }
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "0",
                            "standard_name": "longitude",
                            "pointwidth": "1.0"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude",
                            "pointwidth": "1.0"
                        },
                        "IWMO_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IWMO_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "IWMO": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "IWMO",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/IRI/Analyses/Tailored/Northern_India/temperature"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "precipitation",
                        "temperature"
                    ]
                },
                "Philippines": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Philippines",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PAGASA_precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PAGASA_precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "114.0",
                                "scale_max": "132.0",
                                "units": "degree_east",
                                "long_name": "Longitude"
                            },
                            "location": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "location",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OpenGISSimpleFeature": "Point",
                                "long_name": "location",
                                "SpatialReferenceSystemWKT": "]]",
                                "scale_min": "114.0",
                                "scale_max": "132.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "3.0",
                                "scale_max": "22.0",
                                "units": "degree_north",
                                "long_name": "Latitude"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan-Apr 1977, 2400 30 Apr 2007] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9.8999996"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Elevation",
                                "missing_value": "-999.90002",
                                "units": "m"
                            }
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "114.0",
                            "scale_max": "132.0",
                            "units": "degree_east",
                            "long_name": "Longitude"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "long_name": "location",
                            "SpatialReferenceSystemWKT": "]]",
                            "scale_min": "114.0",
                            "scale_max": "132.0",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "3.0",
                            "scale_max": "22.0",
                            "units": "degree_north",
                            "long_name": "Latitude"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan-Apr 1977, 2400 30 Apr 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.8999996"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Elevation",
                            "missing_value": "-999.90002",
                            "units": "m"
                        },
                        "APHRODITE_precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "APHRODITE_precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan-Apr 1951, 2400 30 Apr 2007] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "precip_prov": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip_prov",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "PAGASA_precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PAGASA_precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "114.0",
                                "scale_max": "132.0",
                                "units": "degree_east",
                                "long_name": "Longitude"
                            },
                            "location": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "location",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "OpenGISSimpleFeature": "Point",
                                "long_name": "location",
                                "SpatialReferenceSystemWKT": "]]",
                                "scale_min": "114.0",
                                "scale_max": "132.0",
                                "units": "degree_east"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "3.0",
                                "scale_max": "22.0",
                                "units": "degree_north",
                                "long_name": "Latitude"
                            },
                            "label": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "label",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan-Apr 1977, 2400 30 Apr 2007] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9.8999996"
                            },
                            "elev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "elev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Elevation",
                                "missing_value": "-999.90002",
                                "units": "m"
                            }
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "114.0",
                            "scale_max": "132.0",
                            "units": "degree_east",
                            "long_name": "Longitude"
                        },
                        "location": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "location",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "OpenGISSimpleFeature": "Point",
                            "long_name": "location",
                            "SpatialReferenceSystemWKT": "]]",
                            "scale_min": "114.0",
                            "scale_max": "132.0",
                            "units": "degree_east"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "3.0",
                            "scale_max": "22.0",
                            "units": "degree_north",
                            "long_name": "Latitude"
                        },
                        "label": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "label",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids"
                        },
                        "historical": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "historical",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "ncolor": "254",
                            "long_name": "Precipitation",
                            "units": "mm",
                            "history": "Averaged over T[Jan-Apr 1977, 2400 30 Apr 2007] minimum 0.0% data present",
                            "missing_value": "NaN",
                            "file_missing_value": "-9.8999996"
                        },
                        "elev": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "elev",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Elevation",
                            "missing_value": "-999.90002",
                            "units": "m"
                        },
                        "APHRODITE_precipitation": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "APHRODITE_precipitation",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "the_geom": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "the_geom",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Provinces Geometry",
                                "units": "unitless",
                                "PGtype": "bytea",
                                "OpenGISSimpleFeature": "MULTIPOLYGON",
                                "SpatialReferenceSystemWKT": "]]"
                            },
                            "historical": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "historical",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "long_name": "Precipitation",
                                "units": "mm",
                                "history": "Averaged over T[Jan-Apr 1951, 2400 30 Apr 2007] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-99.900002",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "standard_name": "longitude",
                        "pointwidth": "0.25"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "0.25"
                    },
                    "STNID": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "STNID",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids",
                        "gridtype": "0",
                        "long_name": "Station",
                        "pointwidth": "1.0"
                    },
                    "gid": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "gid",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "dir": "SOURCES/IRI/Analyses/Tailored/Philippines"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Bangladesh",
                    "Ethiopia",
                    "Lao",
                    "Monsoon_Asia",
                    "NE_Brazil",
                    "Nepal",
                    "Northern_India",
                    "Philippines"
                ]
            },
            "USGS": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "USGS",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ADDSNDVINDVIgdeg0p1monthlysd8204description": "1982-2004 standard deviation of monthly maximum NDVIg data",
                    "ADDSNDVINDVIgdeg0p1monthlysd8204long_name": "1982-2004 standard deviation",
                    "ADDSNDVINDVIgdeg0p1monthlyc8204description": "1982-2004 climatology of monthly NDVIg data",
                    "ADDSNDVINDVIgdeg0p1monthlyc8204long_name": "1982-2004 climatology",
                    "Conventions": "IRIDL"
                },
                "VCAP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "VCAP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "eightday": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "eight-day",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "v200906": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "v200906",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "vcap_coarse": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vcap_coarse",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "8388608",
                                "scale_max": "50.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "50.0",
                                "CS": "0.0",
                                "long_name": "Vectorial Capacity",
                                "history": "Y regridded on USGS VCAP eight-day v200906 vcap",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "unitless",
                                "iridlhasSemantics": "iridl:Malaria",
                                "pointwidth": "0"
                            }
                        }
                    }
                },
                "ADDS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ADDS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NDVIg": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NDVIg",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "deg0p1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "deg0p1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "sd8204": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd8204",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "sdNDVImonmax": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sdNDVImonmax",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "1982-2004 SD of Monthly Maximum NDVI",
                                            "missing_value": "99999.0",
                                            "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                            "maxncolor": "254",
                                            "colormap": "2304",
                                            "ncolor": "254",
                                            "grid_mapping": "Projection",
                                            "standard_name": "normalized_difference_vegetation_index",
                                            "iridlhasSemantics": "iridl:NDVI",
                                            "units": "unitless"
                                        },
                                        "sdNDVImonavg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sdNDVImonavg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "1982-2004 SD of Monthly Average NDVI",
                                            "missing_value": "99999.0",
                                            "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "colormap": "2304",
                                            "ncolor": "254",
                                            "grid_mapping": "Projection",
                                            "standard_name": "normalized_difference_vegetation_index",
                                            "iridlhasSemantics": "iridl:NDVI"
                                        }
                                    },
                                    "maximum": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "maximum",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NDVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NDVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Monthly Maximum NDVIg",
                                            "history": "max over T[1.0, 3.0]",
                                            "missing_value": "NaN",
                                            "file_missing_value": "99999.0",
                                            "maxncolor": "254",
                                            "colormap": "2304",
                                            "scale_max": "1.0",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CE": "1.0",
                                            "CS": "0.0",
                                            "valid_max": "0.999984",
                                            "valid_min": "0.0",
                                            "grid_mapping": "Projection",
                                            "standard_name": "normalized_difference_vegetation_index",
                                            "iridlhasSemantics": "iridl:NDVI",
                                            "units": "unitless"
                                        }
                                    },
                                    "c8204": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "c8204",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "avgNDVImonmax": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "avgNDVImonmax",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "1982-2004 Avg. of Monthly Maximum NDVI",
                                            "missing_value": "99999.0",
                                            "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                            "maxncolor": "254",
                                            "colormap": "2304",
                                            "ncolor": "254",
                                            "grid_mapping": "Projection",
                                            "standard_name": "normalized_difference_vegetation_index",
                                            "iridlhasSemantics": "iridl:NDVI",
                                            "units": "unitless"
                                        },
                                        "avgNDVImonavg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "avgNDVImonavg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "1982-2004 Avg. of Monthly Average NDVI",
                                            "missing_value": "99999.0",
                                            "history": "Averaged over T2[1982, 2004] minimum 0.0% data present",
                                            "units": "unitless",
                                            "maxncolor": "254",
                                            "colormap": "2304",
                                            "ncolor": "254",
                                            "grid_mapping": "Projection",
                                            "standard_name": "normalized_difference_vegetation_index",
                                            "iridlhasSemantics": "iridl:NDVI"
                                        }
                                    }
                                }
                            }
                        }
                    }
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "long_name": "Latitude",
                    "pointwidth": "0.1"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "long_name": "Longitude",
                    "pointwidth": "0.1"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2004-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "standard_name": "time"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "defaultvalue": "539.5",
                    "bounds": "T2",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.1"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.1"
                },
                "dir": "SOURCES/IRI/Analyses/USGS"
            },
            "WASP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WASP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "references": "Lyon2004 Lyon_Barnston2005",
                    "description": "Weighted Anomaly of Standardized Precipitation Index analyses of multiple global precipitation data sets",
                    "Conventions": "IRIDL",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.Analyses/.WASP/.dataset_documentation.html"
                },
                "WASPUEATS2p1_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-UEA-TS2p1_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "UEA-TS2p1_WASP9",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "WASPUEATS2p1_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-UEA-TS2p1_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "UEA-TS2p1_WASP6",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "WASPUEATS2p1_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-UEA-TS2p1_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "UEA-TS2p1_WASP3",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "WASPUEATS2p1_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-UEA-TS2p1_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "UEA-TS2p1_WASP12",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "WASPUEATS2p1_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-UEA-TS2p1_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "UEA-TS2p1_WASP1",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99.900002"
                },
                "WASPGPCPv2SatGauge_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-GPCPv2Sat-Gauge_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "GPCPv2Sat-Gauge_WASP9",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99999.0",
                    "technique": "Satellite-Gauge",
                    "pointwidth": "0"
                },
                "WASPGPCPv2SatGauge_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-GPCPv2Sat-Gauge_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "GPCPv2Sat-Gauge_WASP6",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99999.0",
                    "technique": "Satellite-Gauge",
                    "pointwidth": "0"
                },
                "WASPGPCPv2SatGauge_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-GPCPv2Sat-Gauge_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "GPCPv2Sat-Gauge_WASP3",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99999.0",
                    "technique": "Satellite-Gauge",
                    "pointwidth": "0"
                },
                "WASPGPCPv2SatGauge_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-GPCPv2Sat-Gauge_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "GPCPv2Sat-Gauge_WASP12",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99999.0",
                    "technique": "Satellite-Gauge",
                    "pointwidth": "0"
                },
                "WASPGPCPv2SatGauge_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-GPCPv2Sat-Gauge_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "GPCPv2Sat-Gauge_WASP1",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-99999.0",
                    "technique": "Satellite-Gauge",
                    "pointwidth": "0"
                },
                "WASPCMAPlatestv2_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CMAPlatestv2_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CMAP-latest_WASP9",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "standard_name": "lwe_precipitation_rate"
                },
                "WASPCMAPlatestv2_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CMAPlatestv2_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CMAP-latest_WASP6",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "standard_name": "lwe_precipitation_rate"
                },
                "WASPCMAPlatestv2_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CMAPlatestv2_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CMAP-latest_WASP3",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "standard_name": "lwe_precipitation_rate"
                },
                "WASPCMAPlatestv2_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CMAPlatestv2_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CMAP-latest_WASP12",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "standard_name": "lwe_precipitation_rate"
                },
                "WASPCMAPlatestv2_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CMAPlatestv2_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CMAP-latest_WASP1",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "standard_name": "lwe_precipitation_rate"
                },
                "WASPCAMSOPIv0208_9Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CAMS-OPI-v0208_9-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CAMS-OPI-v0208_WASP9",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "bounds": "T"
                },
                "WASPCAMSOPIv0208_6Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CAMS-OPI-v0208_6-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CAMS-OPI-v0208_WASP6",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "bounds": "T"
                },
                "WASPCAMSOPIv0208_3Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CAMS-OPI-v0208_3-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CAMS-OPI-v0208_WASP3",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "bounds": "T"
                },
                "WASPCAMSOPIv0208_12Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CAMS-OPI-v0208_12-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CAMS-OPI-v0208_WASP12",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "bounds": "T"
                },
                "WASPCAMSOPIv0208_1Month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WASP-CAMS-OPI-v0208_1-Month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "CAMS-OPI-v0208_WASP1",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "bounds": "T"
                },
                "T_19": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_19",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_18": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_17": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_17",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_16": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_16",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "T_15": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_15",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "T_14": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_14",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_13": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_13",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "6.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "12.0",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "T_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "9.0",
                    "standard_name": "time"
                },
                "T_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "6.0",
                    "standard_name": "time"
                },
                "T_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "time"
                },
                "T_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "12.0",
                    "standard_name": "time"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1",
                    "standard_name": "time"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "9.0",
                    "standard_name": "time"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "6.0",
                    "standard_name": "time"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "3.0",
                    "standard_name": "time"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "12.0",
                    "standard_name": "time"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "expires": "1617235200"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/IRI/Analyses/WASP"
            },
            "WFP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "WFP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "FooDSECuREPhilippinesClim_Typesc7807Clusterdescription": "Cluster analysis of 1978-2007 APHRODITE by Province",
                    "FooDSECuREPhilippinesClim_Typesc7807Clusterhistory": "",
                    "Conventions": "IRIDL"
                },
                "FooDSECuRE": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FooDSECuRE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Philippines": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Philippines",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Clim_Types": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Clim_Types",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "c7807Cluster": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c7807Cluster",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vartot": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vartot",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "0.000144 meter2 year-2",
                                    "long_name": "precipitation"
                                },
                                "var_misfit": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "var_misfit",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "fraction"
                                },
                                "var_fit": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "var_fit",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "fraction",
                                    "long_name": "precipitation"
                                },
                                "Ts": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Ts",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/month",
                                    "long_name": "precipitation"
                                },
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "NC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "clusters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clusters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ncolor": "7",
                                    "colormap": "65535",
                                    "maxncolor": "254",
                                    "units": "ids",
                                    "long_name": "k_mean clusters"
                                }
                            }
                        }
                    }
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "cluster": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "cluster",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/IRI/Analyses/WFP"
            },
            "WORLDCLIM": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/Analyses/WORLDCLIM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "WORLDCLIM",
                "restriction": "Public",
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ]
            },
            "Water_Balance": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/Analyses/Water_Balance",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "Water_Balance",
                "restriction": "Public",
                "Brazil": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/Analyses/Water_Balance/Brazil",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Brazil",
                    "restriction": "Public",
                    "Rio_Grande_do_Sul": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/Analyses/Water_Balance/Brazil/Rio_Grande_do_Sul",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "Rio_Grande_do_Sul",
                        "restriction": "Public",
                        "Crop_Cultivar": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Crop_Cultivar",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "Kc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Kc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "crop coefficient",
                                "history": "Crop:  Soybean to Soybean appended from   mean [ ( IRI Analyses Water_Balance Brazil Rio_Grande_do_Sul Crop_Cultivar myvar 2.0 ) ]   + [   maskgt ( { int_dI + 0. } , 150.0 )   * 0. ]",
                                "units": "unitless",
                                "pointwidth": "1.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gridtype": "0",
                                "long_name": "days since planting",
                                "units": "days",
                                "pointwidth": "1.0"
                            },
                            "Crop": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Crop",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "dir": "SOURCES/IRI/Analyses/Water_Balance/Brazil/Rio_Grande_do_Sul/Crop_Cultivar"
                        },
                        "TAW": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/Analyses/Water_Balance/Brazil/Rio_Grande_do_Sul/TAW",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "TAW",
                            "restriction": "Public",
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "Crop_Cultivar",
                            "TAW"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "Rio_Grande_do_Sul"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Brazil"
                ]
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CSMT",
                "ENSORP",
                "Fire",
                "ICPAC",
                "LandDAAC",
                "Locust",
                "MDG",
                "NOAA",
                "SPI",
                "TS",
                "Tailored",
                "USGS",
                "WASP",
                "WFP",
                "WORLDCLIM",
                "Water_Balance"
            ]
        },
        "EPPF": {
            "iridl_type": "DataSet",
            "iridl_ds_name": "EPPF",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "NC_GLOBAL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NC_GLOBAL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "weekly_fishingdefinitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.weekly_fishing.definitions_and_explanations.html",
                "weekly_fishingdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.weekly_fishing.dataset_documentation.html",
                "environmentdefinitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.environment.definitions_and_explanations.html",
                "environmentdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.environment.dataset_documentation.html",
                "economicsdefinitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.economics.definitions_and_explanations.html",
                "economicsdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.economics.dataset_documentation.html",
                "catchdefinitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.catch.definitions_and_explanations.html",
                "catchdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.catch.dataset_documentation.html",
                "anchovetadefinitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.anchoveta.definitions_and_explanations.html",
                "anchovetadataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.anchoveta.dataset_documentation.html",
                "definitions_and_explanationshtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.definitions_and_explanations.html",
                "long_name": "Eastern Pacific Pelagic Fisheries",
                "references": "Csirke_etal1996",
                "description": "Fisheries data from the Pacific Coast of South America",
                "Conventions": "IRIDL",
                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.EPPF/.dataset_documentation.html"
            },
            "weekly_fishing": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "weekly_fishing",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "Peru": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Peru",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "total": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "total Peru fishing: w1 1993 - w21 1998"
                    },
                    "Privates": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Privates",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "Privates Peru fishing: w1 1993 - w21 1998"
                    },
                    "ports": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ports",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "total Peru fishing: w1 1993 - w21 1998"
                        },
                        "Privates": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Privates",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "Privates Peru fishing: w1 1993 - w21 1998"
                        },
                        "Pesca": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Pesca",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "Pesca Peru fishing: w1 1993 - w21 1998"
                        }
                    },
                    "Pesca": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Pesca",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "Pesca Peru fishing: w1 1993 - w21 1998"
                    }
                },
                "Chile": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Chile",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "total": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "Chile fishing total: w1 1993 - w21 1998"
                    },
                    "south": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "south",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "Chile fishing south: w1 1993 - w21 1998"
                    },
                    "north": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "north",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "Chile fishing north: w1 1993 - w21 1998"
                    }
                }
            },
            "Steve_filter": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Steve_filter",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "anchoveta": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "anchoveta",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PeruII": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PeruII",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "biomass": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "biomass",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "tonne",
                                "long_name": "biomass (5 year filter): 1953-1985"
                            }
                        },
                        "recruits": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "recruits",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number*10^9",
                            "long_name": "recruits (5 year filter): 1953-1985"
                        },
                        "egg_production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "egg_production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number*10^9",
                            "long_name": "egg production (5 year filter): 1953-1985"
                        }
                    },
                    "catch": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "catch",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "nominal_catch": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nominal_catch",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne/month",
                            "long_name": "nominal catch (5 year filter): 1953-1987"
                        },
                        "condition_factor": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "condition_factor",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "unitless",
                            "long_name": "condition factor (5 year filter): 1953-1987"
                        }
                    }
                }
            },
            "environment": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "environment",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "xbtpc2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "xbtpc2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "unitless",
                    "long_name": "XBTPC2: 1960-1986"
                },
                "xbtpc1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "xbtpc1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "unitless",
                    "long_name": "XBTPC1: 1960-1986"
                },
                "wind_velocity": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "wind_velocity",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meters/second",
                    "long_name": "wind velocity: 1953-1982"
                },
                "weekly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "weekly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "long_name": "NINO12 sea surface temperature: w1 1982 - w25 1998"
                    }
                },
                "velocity": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "velocity",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meters/second",
                    "long_name": "velocity: 1953-1984"
                },
                "upwelling": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "upwelling",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meter^3/second",
                    "long_name": "upwelling: 1953-1986"
                },
                "turbulence": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "turbulence",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meters^3/seconds^3",
                    "long_name": "turbulence index: 1953-1984"
                },
                "thermocline_depth": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "thermocline_depth",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meters",
                    "long_name": "thermocline depth: 1951-1984"
                },
                "sst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "Celsius_scale",
                    "long_name": "sea surface temperature: 1953-1984"
                },
                "SOI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SOI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "milibar",
                    "long_name": "southern oscillation index: 1948-1985"
                },
                "sea_level": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sea_level",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "999.0",
                    "units": "cm",
                    "long_name": "sea level anomalies: varies"
                },
                "rossby_radius": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "rossby_radius",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "kilometer",
                    "long_name": "rossby radius: 1953-1982"
                },
                "primary_production": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "primary_production",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "gC/meter/day",
                    "long_name": "primary production: 1953-1984"
                },
                "oceanic": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "oceanic",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "VDM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "VDM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "primary_production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "primary_production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "gC/meter/day",
                            "long_name": "primary production"
                        }
                    },
                    "flux_derived": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "flux_derived",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "VDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "ConcBakun_VDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Conc*Bakun_VDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "ConcBakun_CDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Conc*Bakun_CDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "CDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        }
                    },
                    "CDM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CDM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "primary_production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "primary_production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "gC/meter/day",
                            "long_name": "primary production: 1953-1982"
                        }
                    }
                },
                "NO3": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NO3",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "mM/meter^3",
                    "long_name": "NO3: 1953-1982"
                },
                "mean_relat_cld_cvr": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "mean_relat_cld_cvr",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "meters",
                    "long_name": "mean relative cloud cover: 1953-1984"
                },
                "lasker_events": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lasker_events",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "numbers",
                    "long_name": "lasker events: 1953-1985"
                },
                "coastal": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "coastal",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "VDM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "VDM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "primary_production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "primary_production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "gC/meter/day",
                            "long_name": "primary production: 1953-1982"
                        }
                    },
                    "flux_derived": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "flux_derived",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "VDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "ConcTrujUp_VDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Conc*TrujUp_VDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "ConcTrujUp_CDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Conc*TrujUp_CDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        },
                        "CDM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CDM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NO3": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NO3",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "Mm/meter/day",
                                "long_name": "NO3: 1953-1982"
                            }
                        }
                    },
                    "CDM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CDM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "primary_production": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "primary_production",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "gC/meter/day",
                            "long_name": "primary production: 1953-1982"
                        }
                    }
                },
                "absorbed_solar_radiation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "absorbed_solar_radiation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "NaN",
                    "units": "Watt/meter/day",
                    "long_name": "absorbed solar radiation: 1953-1984"
                }
            },
            "economics": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "economics",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "yearly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "yearly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "exports": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "exports",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number",
                            "long_name": "Total Fish Flour and Oil Exports: 1968-1995"
                        }
                    },
                    "capacity": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "capacity",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total_capacity": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total_capacity",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne*10^3/hours",
                            "long_name": "total capacity: 1950-1996"
                        },
                        "ship_hold": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ship_hold",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne*10^3",
                            "long_name": "ship hold: 1950-1996"
                        },
                        "num_plants": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "num_plants",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number",
                            "long_name": "number of plants: 1950-1996"
                        },
                        "num_boats": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "num_boats",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number",
                            "long_name": "number of boats: 1950-1996"
                        }
                    }
                },
                "prices": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prices",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "soyameal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soyameal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "soyameal prices: w49 1993 - w21 1998"
                    },
                    "fishmeal": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fishmeal",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "fishmeal prices: w49 1993 - w21 1998"
                    }
                },
                "FOB": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FOB",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "soyomeal_Brasil": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "soyomeal_Brasil",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "soyomeal FOB Brasil: w49 1993 - w21 1998"
                    },
                    "prices_Peru": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prices_Peru",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "FOB Peru: w49 1993 - w21 1998"
                    },
                    "ind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "FOB index: w49 1993 - w21 1998"
                    }
                }
            },
            "catch": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "catch",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "yearly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "yearly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sardina": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sardina",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "yearly sardina catch: 1950-1996"
                    },
                    "jurel": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "jurel",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "yearly jurel catch: 1950-1996"
                    },
                    "human_consumption": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "human_consumption",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number",
                            "long_name": "Catch for Indirect Human Consumption: 1968-1995"
                        },
                        "ports": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ports",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "number",
                            "long_name": "Catch for Indirect Human Consumption by Port: 1968-1995"
                        }
                    },
                    "caballa": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "caballa",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "yearly caballa catch: 1950-1996"
                    },
                    "anchoveta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anchoveta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "yearly anchoveta catch: 1950-1996"
                    }
                }
            },
            "anchoveta": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "anchoveta",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "yearly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "yearly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "recruits": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "recruits",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "recruits: 1962-1993"
                        },
                        "adult_stock": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "adult_stock",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "adult stock: 1962-1993"
                        }
                    }
                },
                "predators": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "predators",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "total_natural_mortality": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total_natural_mortality",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "10^6",
                        "long_name": "total natural mortality: 1953-1982"
                    },
                    "species": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "species",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "total": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "total",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "consumption": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "consumption",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "tonne",
                                "long_name": "consumption: 1953-1982"
                            }
                        },
                        "numbers": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "numbers",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "10^6",
                            "long_name": "numbers: 1953-1982"
                        },
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1982"
                        },
                        "anchovy": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anchovy",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "consumption": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "consumption",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "NaN",
                                "units": "tonne",
                                "long_name": "consumption: 1953-1982"
                            }
                        },
                        "abundance": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "abundance",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "abundance: 1953-1982"
                        }
                    },
                    "PeruII": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PeruII",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "baseline_natural_mortality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "baseline_natural_mortality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "10^6",
                            "long_name": "baseline natural mortality: 1953-1982"
                        }
                    },
                    "PeruI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PeruI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "baseline_natural_mortality": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "baseline_natural_mortality",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "Mo",
                            "long_name": "baseline natural mortality: 1953-1982"
                        }
                    },
                    "nominal_catch": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nominal_catch",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne",
                        "long_name": "nominal catch: 1953-1982"
                    }
                },
                "PeruII": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PeruII",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "total": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1985"
                        }
                    },
                    "recruits": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "recruits",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "number*10^9",
                        "long_name": "recruits: 1953-1985"
                    },
                    "mature_male_female": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mature_male_female",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1985"
                        }
                    },
                    "mature_female": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mature_female",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1985"
                        }
                    },
                    "egg_production": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "egg_production",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "number*10^9",
                        "long_name": "egg production: 1953-1985"
                    },
                    "biomass": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biomass",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dist": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dist",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "percent",
                            "long_name": "distribution by cm length class: 1953-1985"
                        }
                    }
                },
                "PeruI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PeruI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "total": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "total",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1982"
                        }
                    },
                    "recruits": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "recruits",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "number*10^9",
                        "long_name": "recruits: 1953-1982"
                    },
                    "mature_male_female": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mature_male_female",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1982"
                        }
                    },
                    "mature_female": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mature_female",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "biomass": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "biomass",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "tonne",
                            "long_name": "biomass: 1953-1982"
                        }
                    },
                    "egg_production": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "egg_production",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "number*10^9",
                        "long_name": "egg production: 1953-1982"
                    },
                    "biomass": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "biomass",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "dist": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "dist",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "units": "percent",
                            "long_name": "distribution by cm length class: 1953-1982"
                        }
                    }
                },
                "eggs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "eggs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "sardine_biomass": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "sardine_biomass",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne*10^6",
                        "long_name": "sardine biomass: 1964-1986"
                    },
                    "parent_stock": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "parent_stock",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne*10^6",
                        "long_name": "Anchoveta parent stock: 1964-1986"
                    },
                    "mortality": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "mortality",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "day^-1",
                        "long_name": "mortality: 1964-1986"
                    },
                    "map_standing_stock": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "map_standing_stock",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "N*10^12",
                        "long_name": "map standing stock: 1964-1986"
                    },
                    "est_mortality": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "est_mortality",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "day^-1",
                        "long_name": "estimated mortality: 1964-1986"
                    },
                    "egg_dvlp_time": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "egg_dvlp_time",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "days",
                        "long_name": "egg developement time: 1964-1986"
                    },
                    "daily_reprod_output": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily_reprod_output",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne*10^12",
                        "long_name": "daily reproductive output: 1964-1986"
                    }
                },
                "catch": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "catch",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "nominal_catch": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "nominal_catch",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "tonne/month",
                        "long_name": "nominal catch: 1953-1987"
                    },
                    "dist": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dist",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "percent: 1953-1987",
                        "long_name": "distribution by cm length class"
                    },
                    "condition_factor": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "condition_factor",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "NaN",
                        "units": "unitless",
                        "long_name": "condition factor: 1953-1987"
                    }
                }
            },
            "T_06": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_06",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "time",
                "pointwidth": "1.0"
            },
            "T_05": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_05",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "7.0",
                "long_name": "time",
                "add_offset": "2444976.0"
            },
            "T_04": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_04",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "time",
                "pointwidth": "1.0"
            },
            "loc": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "loc",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "port"
            },
            "T_03": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_03",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "julian_day",
                "gridtype": "0",
                "calendar": "standard",
                "pointwidth": "7.0",
                "long_name": "time",
                "add_offset": "2449330.0"
            },
            "port": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "port",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "port"
            },
            "T_02": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_02",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "time",
                "pointwidth": "12.0"
            },
            "T_01": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T_01",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "time",
                "pointwidth": "12.0"
            },
            "species": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "species",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "ids",
                "gridtype": "2",
                "long_name": "species"
            },
            "len": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "len",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "cm",
                "gridtype": "0",
                "long_name": "length",
                "pointwidth": "1.0"
            },
            "T": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "T",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "units": "months since 1960-01-01",
                "gridtype": "0",
                "calendar": "360",
                "long_name": "time",
                "pointwidth": "1.0"
            },
            "dir": "SOURCES/IRI/EPPF"
        },
        "FD": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/IRI/FD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "FD",
            "restriction": "Public",
            "AgMIP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "AgMIP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "WAmonthlysimall_JJAS_95_07053_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_95_02649_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_95_00747_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_50_07053_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_50_02649_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_50_00747_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_05_07053_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_05_02649_WA_003nc4runNo": "003",
                    "WAmonthlysimall_JJAS_05_00747_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_95_07053_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_95_02649_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_95_00747_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_50_07053_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_50_02649_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_50_00747_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_05_07053_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_05_02649_WA_003nc4runNo": "003",
                    "WAdailysimall_JJAS_05_00747_WA_003nc4runNo": "003",
                    "WAdocumentation": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.AgMIP/.WA/Greene_AgMIP_WA.pdf",
                    "SIR3_MAMmonthlysimall_MAM_95_06728_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_95_01693_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_95_01359_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_50_06728_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_50_01693_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_50_01359_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_05_06728_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_05_01693_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMmonthlysimall_MAM_05_01359_SI_R3_001nc4runNo": "R3_001",
                    "SIR3_MAMdailysimall_MAM_95_06728_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_95_01693_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_95_01359_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_50_06728_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_50_01693_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_50_01359_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_05_06728_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_05_01693_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR3_MAMdailysimall_MAM_05_01359_SI_R3_001dnc4runNo": "R3_001d",
                    "SIR2_ONDmonthlysimall_OND_95_09583_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_95_06339_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_95_02030_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_50_09583_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_50_06339_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_50_02030_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_05_09583_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_05_06339_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDmonthlysimall_OND_05_02030_SI_R2_001nc4runNo": "R2_001",
                    "SIR2_ONDdailysimall_OND_95_09583_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_95_06339_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_95_02030_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_50_09583_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_50_06339_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_50_02030_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_05_09583_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_05_06339_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR2_ONDdailysimall_OND_05_02030_SI_R2_001dnc4runNo": "R2_001d",
                    "SIR1_JJASmonthlysimall_JJAS_95_04970_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_95_03950_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_95_00964_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_50_04970_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_50_03950_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_50_00964_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_05_04970_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_05_03950_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASmonthlysimall_JJAS_05_00964_SI_R1_001nc4runNo": "R1_001",
                    "SIR1_JJASdailysimall_JJAS_95_04970_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_95_03950_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_95_00964_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_50_04970_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_50_03950_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_50_00964_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_05_04970_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_05_03950_SI_R1_001dnc4runNo": "R1_001d",
                    "SIR1_JJASdailysimall_JJAS_05_00964_SI_R1_001dnc4runNo": "R1_001d",
                    "SIdocumentation": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.AgMIP/.SI/Greene_AgMIP_SI.pdf",
                    "Conventions": "IRIDL"
                },
                "WA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "WA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "simall_JJAS_95_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_95_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_95_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_50_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_50_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_50_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_05_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_05_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        },
                        "simall_JJAS_05_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            }
                        }
                    },
                    "daily": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "daily",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "simall_JJAS_95_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_95_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_95_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_95_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_50_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_50_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_50_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_50_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_05_07053_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_07053_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_05_02649_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_02649_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        },
                        "simall_JJAS_05_00747_WA_003nc4": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "simall_JJAS_05_00747_WA_003.nc4",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "wind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "wind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "m s-1"
                            },
                            "vp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "hPa"
                            },
                            "tmx": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmx",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "tmn": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tmn",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            },
                            "rsds": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "rsds",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "MJ m-2 day-1"
                            },
                            "pre": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "pre",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "mm/day"
                            },
                            "hur": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hur",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "percent"
                            },
                            "dewp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dewp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "1.00000002E20",
                                "units": "Celsius_scale"
                            }
                        }
                    }
                },
                "SI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "R3_MAM": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "R3_MAM",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_MAM_95_06728_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_06728_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_95_01693_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_01693_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_95_01359_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_01359_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_50_06728_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_06728_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_50_01693_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_01693_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_50_01359_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_01359_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_05_06728_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_06728_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_05_01693_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_01693_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_MAM_05_01359_SI_R3_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_01359_SI_R3_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_MAM_95_06728_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_06728_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_95_01693_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_01693_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_95_01359_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_95_01359_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_50_06728_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_06728_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_50_01693_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_01693_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_50_01359_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_50_01359_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_05_06728_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_06728_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_05_01693_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_01693_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_MAM_05_01359_SI_R3_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_MAM_05_01359_SI_R3_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            }
                        }
                    },
                    "R2_OND": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "R2_OND",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_OND_95_09583_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_09583_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_95_06339_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_06339_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_95_02030_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_02030_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_50_09583_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_09583_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_50_06339_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_06339_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_50_02030_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_02030_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_05_09583_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_09583_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_05_06339_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_06339_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_OND_05_02030_SI_R2_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_02030_SI_R2_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_OND_95_09583_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_09583_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_95_06339_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_06339_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_95_02030_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_95_02030_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_50_09583_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_09583_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_50_06339_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_06339_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_50_02030_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_50_02030_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_05_09583_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_09583_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_05_06339_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_06339_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_OND_05_02030_SI_R2_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_OND_05_02030_SI_R2_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            }
                        }
                    },
                    "R1_JJAS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "R1_JJAS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_JJAS_95_04970_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_04970_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_95_03950_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_03950_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_95_00964_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_00964_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_50_04970_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_04970_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_50_03950_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_03950_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_50_00964_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_00964_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_05_04970_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_04970_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_05_03950_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_03950_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            },
                            "simall_JJAS_05_00964_SI_R1_001nc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_00964_SI_R1_001.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                }
                            }
                        },
                        "daily": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "daily",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "simall_JJAS_95_04970_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_04970_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_95_03950_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_03950_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_95_00964_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_95_00964_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_50_04970_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_04970_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_50_03950_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_03950_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_50_00964_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_50_00964_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_05_04970_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_04970_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_05_03950_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_03950_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            },
                            "simall_JJAS_05_00964_SI_R1_001dnc4": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "simall_JJAS_05_00964_SI_R1_001d.nc4",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "m s-1"
                                },
                                "vp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "hPa"
                                },
                                "tmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "tmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                },
                                "rsds": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rsds",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "MJ m-2 day-1"
                                },
                                "pre": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pre",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "mm/day"
                                },
                                "hur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "percent"
                                },
                                "dewp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dewp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "1.00000002E20",
                                    "units": "Celsius_scale"
                                }
                            }
                        }
                    }
                },
                "lon_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.5"
                },
                "lat_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5"
                },
                "time_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "time_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1901-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "time": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "time",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1901-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "1.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.5"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5"
                },
                "dir": "SOURCES/IRI/FD/AgMIP"
            },
            "CCM3": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CCM3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Historyclimatologyc6998iridlhasSemantics": "iridl:climatology",
                    "Historyclimatologyc6998long_name": "1968-1998",
                    "ForecastiridlhasSemantics": "iridl:forecast",
                    "description": "CCM3.2 ensemble forecasts and simulations of precipitation rate, 2m temperature, and 500mb heights",
                    "iridlhasSemantics": "iridl:NCAR",
                    "Conventions": "IRIDL",
                    "long_name": "ccm3.2",
                    "references": "Hack_etal1998 Hurrell_etal1998 Kiehl_etal1998"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "anomaly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "anomaly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "Forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "psst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "long_name": "precipitation rate"
                                }
                            }
                        }
                    },
                    "asst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "asst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "long_name": "precipitation rate"
                                }
                            }
                        }
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/IRI/FD/CCM3"
            },
            "CCM3v6": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CCM3v6",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HistoryensembleMONTHLYtotal_air_columnexpires": "1491350400",
                    "HistoryensembleMONTHLYtoaexpires": "1491350400",
                    "HistoryensembleMONTHLYtoalong_name": "top of atmosphere",
                    "HistoryensembleMONTHLYsurfaceexpires": "1491350400",
                    "HistoryensembleMONTHLYparametersexpires": "1491350400",
                    "HistoryensembleMONTHLYlsmparametersexpires": "1491350400",
                    "HistoryensembleMONTHLYlsmdescription": "land surface model",
                    "HistoryensembleMONTHLYlsmSource": "Land Surface Model: lsm1.1",
                    "HistoryensembleMONTHLYlsmhistory": "Data created 06/10/04 10:29:31 $",
                    "HistoryensembleMONTHLYlsmcase_title": "ccm3bld : ccm3bld",
                    "HistoryensembleMONTHLYhybrid_levexpires": "1491350400",
                    "HistoryensembleMONTHLYcase": "ccm3bld",
                    "HistoryensembleMONTHLYlogname": "daved",
                    "HistoryensembleMONTHLYsource": "CCM",
                    "HistoryensembleMONTHLYexpires": "1491350400",
                    "HistoryensembleMONTHLYtitle": "ccm3bld",
                    "HistoryensembleMONTHLYConventions": "NCAR-CSM",
                    "HistoryensembleMONTHLYhost": "mako1.ldgo.colum",
                    "HistoryensembleDAILYlogname": "daved",
                    "HistoryensembleDAILYsource": "CCM",
                    "HistoryensembleDAILYtitle": "ccm3bld",
                    "HistoryensembleDAILYConventions": "NCAR-CSM",
                    "HistoryensembleDAILYhost": "mako1.ldgo.colum",
                    "Historyclimatologyc7100long_name": "1971-2000",
                    "Historyclimatologyc6998iridlhasSemantics": "iridl:climatology",
                    "Historyclimatologyc6998long_name": "1969-1998",
                    "Forecastssstensemblemonthlyexpires": "1491307200",
                    "ForecastssstensembleMONTHLYtotal_air_columnexpires": "1491307200",
                    "ForecastssstensembleMONTHLYtoaexpires": "1491307200",
                    "ForecastssstensembleMONTHLYtoalong_name": "top of atmosphere",
                    "ForecastssstensembleMONTHLYsurfaceexpires": "1491307200",
                    "ForecastssstensembleMONTHLYPressureLevelexpires": "1491307200",
                    "ForecastssstensembleMONTHLYparametersexpires": "1491307200",
                    "ForecastssstensembleMONTHLYhybrid_levexpires": "1491307200",
                    "ForecastssstensembleMONTHLYcase": "ccm3bld_200410",
                    "ForecastssstensembleMONTHLYlogname": "forecast",
                    "ForecastssstensembleMONTHLYsource": "CCM",
                    "ForecastssstensembleMONTHLYexpires": "1491307200",
                    "ForecastssstensembleMONTHLYtitle": "ccm3bld",
                    "ForecastssstensembleMONTHLYConventions": "NCAR-CSM",
                    "ForecastssstensembleMONTHLYhost": "mako1.ldgo.colum",
                    "Forecastpsstensemblemonthlyexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYtotal_air_columnexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYtoaexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYtoalong_name": "top of atmosphere",
                    "ForecastpsstensembleMONTHLYsurfaceexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYPressureLevelexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYparametersexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYhybrid_levexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYcase": "ccm3bld_200410",
                    "ForecastpsstensembleMONTHLYlogname": "forecast",
                    "ForecastpsstensembleMONTHLYsource": "CCM",
                    "ForecastpsstensembleMONTHLYexpires": "1491307200",
                    "ForecastpsstensembleMONTHLYtitle": "ccm3bld",
                    "ForecastpsstensembleMONTHLYConventions": "NCAR-CSM",
                    "ForecastpsstensembleMONTHLYhost": "mako1.ldgo.colum",
                    "Forecastca_sstensembleMONTHLYtotal_air_columnexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYtoaexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYtoalong_name": "top of atmosphere",
                    "Forecastca_sstensembleMONTHLYsurfaceexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYparametersexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYmean_sea_levelexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYhybrid_levexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYabove_groundexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYsource": "CCM",
                    "Forecastca_sstensembleMONTHLYexpires": "1491004800",
                    "Forecastca_sstensembleMONTHLYtitle": "ccm3bld",
                    "Forecastca_sstensembleMONTHLYConventions": "NCAR-CSM",
                    "Forecastca_sstdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.CCM3v6/.Forecast.ca_sst.dataset_documentation.html",
                    "Forecastca_sstiridlhasSemantics": "iridl:NCAR",
                    "Forecastca_sstreferences": "vandenDool1994 vandenDool2007",
                    "ForecastiridlhasSemantics": "iridl:forecast",
                    "description": "CCM3.6 ensemble forecasts and simulations",
                    "iridlhasSemantics": "iridl:NCAR",
                    "Conventions": "IRIDL",
                    "CCM3v6guide": "http://www.cgd.ucar.edu/cms/ccm3/ccm3lsm_doc/ccm3_doc/cover.html",
                    "references": "Hack_etal1998 Hurrell_etal1998 Kiehl_etal1998"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            }
                        },
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "CNVCLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CNVCLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Total convective cloud amount",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated total cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated mid-level cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated low cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated high cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "toa": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "toa",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net solar flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net solar flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clear-sky Flux Shortwave Near-IR Absorbed at toa",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Flux Shortwave Near-IR Absorbed at toa >= 0.7 microns",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Flux Shortwave Near-IR Absorbed at TOA",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface friction velocity",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "TS4      subsoil temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "TS3      subsoil temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "TS2      subsoil temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "TS1      subsoil temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Reference height temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional surface stress",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal surface stress",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net radiative flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar downward visible diffuse to surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar downward visible direct  to surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar downward near infrared diffuse to surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar downward near infrared direct  to surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar insolation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Water equivalent snow depth",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "sea ice thickness",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface sensible heat flux",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface water flux",
                                    "units": "kg/m2/s",
                                    "pointwidth": "1.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Sea level pressure",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "surface pressure",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Convective precipitation rate",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "instantaneous",
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "pointwidth": "1.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "PBL height",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "instantaneous",
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "FLAG",
                                    "pointwidth": "1.0"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Liquid water scale height",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface latent heat flux",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net solar flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Flux Shortwave Downwelling Surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net longwave flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net longwave flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Geopotential Height (above sea level)",
                                    "pointwidth": "1.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional wind",
                                    "pointwidth": "1.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal wind",
                                    "pointwidth": "1.0"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "temperature",
                                    "pointwidth": "1.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Relative humidity",
                                    "pointwidth": "1.0"
                                }
                            },
                            "parameters": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "parameters",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "time_written": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "time_written",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsteph": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsteph",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "current timestep",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "nscur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nscur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "current seconds of current day",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds of base day",
                                    "units": "unitless"
                                },
                                "ndcur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndcur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "current day (from base day)",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base day",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds of base date",
                                    "units": "unitless"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base date (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "timestep",
                                    "units": "s"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "current seconds of current date",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "date_written": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date_written",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "current date (YYYYMMDD)",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "lsm": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lsm",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "surface_type": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface_type",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface type",
                                    "units": "unitless"
                                },
                                "S_DOWN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "S_DOWN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "incident solar radiation",
                                    "long_name": "incident solar radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "RSSUN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RSSUN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "minimum",
                                    "level_flag": "single_level",
                                    "Title": "sunlit leaf stomatal resistance",
                                    "long_name": "sunlit leaf stomatal resistance",
                                    "units": "s/m",
                                    "pointwidth": "1.0"
                                },
                                "RSSHA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RSSHA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "minimum",
                                    "level_flag": "single_level",
                                    "Title": "shaded leaf stomatal resistance",
                                    "long_name": "shaded leaf stomatal resistance",
                                    "units": "s/m",
                                    "pointwidth": "1.0"
                                },
                                "QVEGT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVEGT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "canopy transpiration",
                                    "long_name": "canopy transpiration",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QVEGE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVEGE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "canopy evaporation",
                                    "long_name": "canopy evaporation",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QSOIL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QSOIL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "ground evaporation",
                                    "long_name": "ground evaporation",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QPRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QPRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "large-scale precipitation",
                                    "long_name": "large-scale precipitation",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QPRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QPRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "convective precipitation",
                                    "long_name": "convective precipitation",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QOVER": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QOVER",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "surface runoff",
                                    "long_name": "surface runoff",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QMELT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QMELT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "snow melt",
                                    "long_name": "snow melt",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QINTR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QINTR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "interception",
                                    "long_name": "interception",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QINFL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QINFL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "infiltration",
                                    "long_name": "infiltration",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QGCM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QGCM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "atmospheric specific humidity",
                                    "long_name": "atmospheric specific humidity",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "QDRIP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QDRIP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "throughfall",
                                    "long_name": "throughfall",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "QDRAI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QDRAI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "sub-surface drainage",
                                    "long_name": "sub-surface drainage",
                                    "units": "mm/s",
                                    "pointwidth": "1.0"
                                },
                                "PGCM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PGCM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "atmospheric pressure",
                                    "long_name": "atmospheric pressure",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "parameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "parameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "nhtfrq": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nhtfrq",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "frequency of model writes (timesteps)",
                                        "units": "unitless"
                                    },
                                    "msbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "msbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds to complete base day",
                                        "units": "s"
                                    },
                                    "mdbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mdbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base day for this case",
                                        "units": "unitless"
                                    },
                                    "mbsec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mbsec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds to complete base date",
                                        "units": "s"
                                    },
                                    "mbdate": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mbdate",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base date as 6 digit integer (YYMMDD)",
                                        "units": "unitless"
                                    },
                                    "inifil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "inifil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "input initial data",
                                        "units": "unitless"
                                    },
                                    "flnfil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "flnfil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "fractional land data",
                                        "units": "unitless"
                                    },
                                    "dtlsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dtlsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491350400",
                                        "long_name": "model timestep",
                                        "units": "s",
                                        "pointwidth": "1.0"
                                    },
                                    "datesec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "datesec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491350400",
                                        "long_name": "seconds into current date",
                                        "units": "s",
                                        "pointwidth": "1.0"
                                    },
                                    "date": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491350400",
                                        "long_name": "current date as 6 digit integer (YYMMDD)",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "NDVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NDVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "surface ndvi",
                                    "long_name": "surface ndvi",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "mask2d": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mask2d",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "reduced grid 2d mask array",
                                    "units": "unitless"
                                },
                                "L_DOWN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "L_DOWN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "incident longwave radiation",
                                    "long_name": "incident longwave radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "H2OSOI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "H2OSOI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "multi_level",
                                    "Title": "volumetric soil water",
                                    "long_name": "surface temperature at height z0h+d",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "H2OSNO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "H2OSNO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "snow depth (liquid water)",
                                    "long_name": "snow depth (liquid water)",
                                    "units": "mm",
                                    "pointwidth": "1.0"
                                },
                                "H2OCAN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "H2OCAN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "intercepted water",
                                    "long_name": "intercepted water",
                                    "units": "mm",
                                    "pointwidth": "1.0"
                                },
                                "FSR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "reflected solar radiation",
                                    "long_name": "reflected solar radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "snow melt heat flux",
                                    "long_name": "snow melt heat flux",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "sensible heat",
                                    "long_name": "sensible heat",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "absorbed solar radiation",
                                    "long_name": "absorbed solar radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FRMS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRMS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "stem maintenance respiration",
                                    "long_name": "stem maintenance respiration",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FRMR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRMR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "root maintenance respiration",
                                    "long_name": "root maintenance respiration",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FRMF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRMF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "foliage maintenance respiration",
                                    "long_name": "foliage maintenance respiration",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FRG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FRG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "growth respiration",
                                    "long_name": "growth respiration",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FPSN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FPSN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "photosynthesis",
                                    "long_name": "photosynthesis",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FMICR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FMICR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "microbial respiration",
                                    "long_name": "microbial respiration",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "latent heat",
                                    "long_name": "latent heat",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FIRE": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FIRE",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "emitted infrared (longwave) radiation",
                                    "long_name": "emitted infrared (longwave) radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FIRA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FIRA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "net infrared (longwave) radiation",
                                    "long_name": "net infrared (longwave) radiation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FGR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FGR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "heat flux into soil",
                                    "long_name": "heat flux into soil",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FGEV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FGEV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "ground evaporation",
                                    "long_name": "ground evaporation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FCTR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCTR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "canopy transpiration",
                                    "long_name": "canopy transpiration",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FCO2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCO2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "net co2 flux",
                                    "long_name": "net co2 flux",
                                    "units": "micro mol/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "FCEV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FCEV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "canopy evaporation",
                                    "long_name": "canopy evaporation",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "EVAP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EVAP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "total evaporative flux",
                                    "long_name": "total evaporative flux",
                                    "units": "kg/m2/s",
                                    "pointwidth": "1.0"
                                },
                                "ESAI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ESAI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "exposed one-sided stem area index",
                                    "long_name": "exposed one-sided stem area index",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ERRSOL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ERRSOL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "solar radiation conservation error",
                                    "long_name": "solar radiation conservation error",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "ERRSOI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ERRSOI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "soil/lake energy conservation error",
                                    "long_name": "soil/lake energy conservation error",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "ERRSEB": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ERRSEB",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "surface energy conservation error",
                                    "long_name": "surface energy conservation error",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "ERRH2O": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ERRH2O",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "total water conservation error",
                                    "long_name": "total water conservation error",
                                    "units": "mm",
                                    "pointwidth": "1.0"
                                },
                                "ELAI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ELAI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "exposed one-sided leaf area index",
                                    "long_name": "exposed one-sided leaf area index",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "DTV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DTV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "change in tv last iteration",
                                    "long_name": "change in tv last iteration",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "DTG": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DTG",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "change in tg last iteration",
                                    "long_name": "change in tg last iteration",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "DMI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DMI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "net primary production",
                                    "long_name": "net primary production",
                                    "units": "micro g/(m2 s)",
                                    "pointwidth": "1.0"
                                },
                                "CN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "neutral momentum drag coefficient",
                                    "long_name": "neutral momentum drag coefficient",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "momentum drag coefficient",
                                    "long_name": "momentum drag coefficient",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "BTRAN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BTRAN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "transpiration beta factor",
                                    "long_name": "transpiration beta factor",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "BEVAP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BEVAP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "ground evaporation beta factor",
                                    "long_name": "ground evaporation beta factor",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "BASIN_RUNOFF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BASIN_RUNOFF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "long_name": "total runoff to various basins",
                                    "units": "kg/sec",
                                    "pointwidth": "1.0"
                                },
                                "basin_name": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "basin_name",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "expires": "1491350400"
                                },
                                "ASDIR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ASDIR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "albedo solar - direct",
                                    "long_name": "albedo solar - direct",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ASDIF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ASDIF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "albedo - solar diffuse",
                                    "long_name": "albedo - solar diffuse",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ALDIR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALDIR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "albedo longwave - direct",
                                    "long_name": "albedo longwave - direct",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ALDIF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALDIF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "1.00000002E30",
                                    "field_type": "average",
                                    "level_flag": "single_level",
                                    "Title": "albedo - longwve diffuse",
                                    "long_name": "albedo - longwve diffuse",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Geopotential Height (above sea level)",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "VT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Meridional heat transport",
                                    "units": "Km/s",
                                    "pointwidth": "1.0"
                                },
                                "VQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Meridional water transport",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "SETLWP": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SETLWP",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Specified liquid water path lengths",
                                    "units": "G/M2",
                                    "pointwidth": "1.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Relative humidity",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "QRS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QRS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Solar heating rate",
                                    "units": "degree_Kelvin/s",
                                    "pointwidth": "1.0"
                                },
                                "QRL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QRL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Longwave heating rate",
                                    "units": "degree_Kelvin/s",
                                    "pointwidth": "1.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Q constituent tracer",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertical velocity (pressure)",
                                    "units": "Pa/s",
                                    "pointwidth": "1.0"
                                },
                                "MQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Water vapor mass in layer",
                                    "units": "kg/m2",
                                    "pointwidth": "1.0"
                                },
                                "hybm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid B coefficient at layer midpoints",
                                    "units": "unitless"
                                },
                                "hybi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid B coefficient at layer interfaces",
                                    "units": "unitless"
                                },
                                "hyam": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hyam",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid A coefficient at layer midpoints",
                                    "units": "unitless"
                                },
                                "hyai": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hyai",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid A coefficient at layer interfaces",
                                    "units": "unitless"
                                },
                                "ETADOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ETADOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "vertical (eta) velocity",
                                    "units": "1/S",
                                    "pointwidth": "1.0"
                                },
                                "EFFCLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EFFCLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Effective cloud fraction",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLOUD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLOUD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491350400",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Cloud fraction",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            }
                        },
                        "DAILY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "DAILY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated total cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated mid-level cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated low cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertically-integrated high cloud",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net solar flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net solar flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net longwave flux at top",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional surface stress",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal surface stress",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Water equivalent snow depth",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface sensible heat flux",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Sea level pressure",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "surface pressure",
                                    "units": "Pa",
                                    "pointwidth": "1.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Convective precipitation rate",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total precipitation rate",
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "pointwidth": "1.0",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Surface latent heat flux",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net solar flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Flux Shortwave Downwelling Surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Net longwave flux at surface",
                                    "units": "W/m2",
                                    "pointwidth": "1.0"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 History ensemble DAILY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Geopotential Height (above sea level)",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 History ensemble DAILY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 History ensemble DAILY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 History ensemble DAILY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 History ensemble DAILY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Relative humidity",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "parameters": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "parameters",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "time_written": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "time_written",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsteph": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsteph",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current timestep",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "nscur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nscur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current seconds of current day",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds of base day",
                                    "units": "unitless"
                                },
                                "ndcur": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndcur",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current day (from base day)",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base day",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds of base date",
                                    "units": "unitless"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base date (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "timestep",
                                    "units": "s"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current seconds of current date",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "date_written": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date_written",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date (YYYYMMDD)",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Geopotential Height (above sea level)",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "meridional wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "zonal wind",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Relative humidity",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Q constituent tracer",
                                    "units": "unitless",
                                    "pointwidth": "1.0"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Pressure",
                                    "units": "mb",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "1.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Vertical velocity (pressure)",
                                    "units": "Pa/s",
                                    "pointwidth": "1.0"
                                },
                                "hybm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid B coefficient at layer midpoints",
                                    "units": "unitless"
                                },
                                "hybi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid B coefficient at layer interfaces",
                                    "units": "unitless"
                                },
                                "hyam": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hyam",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid A coefficient at layer midpoints",
                                    "units": "unitless"
                                },
                                "hyai": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hyai",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hybrid A coefficient at layer interfaces",
                                    "units": "unitless"
                                },
                                "ETADOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ETADOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "vertical (eta) velocity",
                                    "units": "1/s",
                                    "pointwidth": "1.0"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "long_name": "Reference height temperature",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "units": "m",
                                "file_missing_value": "9.99999962E35",
                                "time_op": "average",
                                "long_name": "Geopotential Height (above sea level)",
                                "pointwidth": "1.0"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "Forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 Forecast ssst ensemble MONTHLY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "expires": "1491307200",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "expires": "1491307200",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation rate",
                                    "units": "m/s",
                                    "missing_value": "NaN",
                                    "expires": "1491307200",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "CNVCLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CNVCLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Total convective cloud amount",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDMED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDMED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated mid-level cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDLOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDLOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated low cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDHGH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDHGH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated high cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "toa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "toa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net solar flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNRTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNRTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clear-sky Flux Shortwave Near-IR Absorbed at toa",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNIRTSQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNIRTSQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Near-IR Absorbed at toa >= 0.7 microns",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNIRT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNIRT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Near-IR Absorbed at TOA",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "USTAR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "USTAR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface friction velocity",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "TS4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS4      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS3      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS2      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS1      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional surface stress",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal surface stress",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "SRFRAD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRFRAD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net radiative flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLSD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLSD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward visible diffuse to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward visible direct  to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward near infrared diffuse to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward near infrared direct  to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar insolation",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SNOWH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "SICTHK": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICTHK",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "sea ice thickness",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "QFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface water flux",
                                        "units": "kg/m2/s",
                                        "pointwidth": "0"
                                    },
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Sea level pressure",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "surface pressure",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "PRECSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Convective snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PHIS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PHIS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "instantaneous",
                                        "long_name": "surface geopotential",
                                        "units": "m2/s2",
                                        "pointwidth": "0"
                                    },
                                    "PBLH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PBLH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "PBL height",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "ORO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ORO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "instantaneous",
                                        "long_name": "ocean (0), land (1), sea ice (2) flag",
                                        "units": "FLAG",
                                        "pointwidth": "0"
                                    },
                                    "LWSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LWSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Liquid water scale height",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net solar flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Downwelling Surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "forecasttime": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecasttime",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "calendar": "360",
                                        "long_name": "Forecast Time",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0",
                                        "standard_name": "time"
                                    },
                                    "FLNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net longwave flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net longwave flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "history": "toS: regridded lev to IRI FD CCM3v6 Forecast ssst ensemble MONTHLY hybrid_lev P",
                                        "file_missing_value": "9.99999962E35",
                                        "expires": "1491307200",
                                        "time_op": "average",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "0"
                                    }
                                },
                                "parameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "parameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "time_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "P0": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P0",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference pressure",
                                        "units": "Pa"
                                    },
                                    "ntrn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter N",
                                        "units": "unitless"
                                    },
                                    "ntrm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter M",
                                        "units": "unitless"
                                    },
                                    "ntrk": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrk",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter K",
                                        "units": "unitless"
                                    },
                                    "nsteph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsteph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current timestep",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "nscur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nscur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current seconds of current day",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "nsbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base day",
                                        "units": "unitless"
                                    },
                                    "ndcur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndcur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current day (from base day)",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "ndbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base day",
                                        "units": "unitless"
                                    },
                                    "nbsec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbsec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base date",
                                        "units": "unitless"
                                    },
                                    "nbdate": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbdate",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base date (YYYYMMDD)",
                                        "units": "unitless"
                                    },
                                    "mdt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mdt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "timestep",
                                        "units": "s"
                                    },
                                    "gw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "gauss weights",
                                        "units": "unitless"
                                    },
                                    "datesec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "datesec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current seconds of current date",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "date_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "date": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current date (YYYYMMDD)",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "VT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Meridional heat transport",
                                        "units": "Km/s",
                                        "pointwidth": "0"
                                    },
                                    "VQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Meridional water transport",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "SETLWP": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SETLWP",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Specified liquid water path lengths",
                                        "units": "G/M2",
                                        "pointwidth": "0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Relative humidity",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "QRS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QRS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar heating rate",
                                        "units": "degree_Kelvin/s",
                                        "pointwidth": "0"
                                    },
                                    "QRL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QRL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Longwave heating rate",
                                        "units": "degree_Kelvin/s",
                                        "pointwidth": "0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Q constituent tracer",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure",
                                        "long_name": "Pressure",
                                        "missing_value": "NaN",
                                        "expires": "1491307200",
                                        "units": "Pa",
                                        "file_missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "pointwidth": "0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "pointwidth": "0"
                                    },
                                    "MQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Water vapor mass in layer",
                                        "units": "kg/m2",
                                        "pointwidth": "0"
                                    },
                                    "hybm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hybi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer interfaces",
                                        "units": "unitless"
                                    },
                                    "hyam": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyam",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hyai": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyai",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer interfaces",
                                        "units": "unitless"
                                    },
                                    "ETADOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ETADOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "vertical (eta) velocity",
                                        "units": "1/S",
                                        "pointwidth": "0"
                                    },
                                    "EFFCLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EFFCLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Effective cloud fraction",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLOUD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLOUD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Cloud fraction",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "forecasttime": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecasttime",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491307200",
                                    "calendar": "360",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "standard_name": "time"
                                }
                            }
                        }
                    },
                    "psst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "missing_value": "NaN",
                                    "history": "toS: regridded lev to IRI FD CCM3v6 Forecast psst ensemble MONTHLY hybrid_lev P",
                                    "file_missing_value": "9.99999962E35",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "expires": "1491307200",
                                    "missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "expires": "1491307200",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation rate",
                                    "units": "m/s",
                                    "missing_value": "NaN",
                                    "expires": "1491307200",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "CNVCLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CNVCLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Total convective cloud amount",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDMED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDMED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated mid-level cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDLOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDLOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated low cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDHGH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDHGH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated high cloud",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "toa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "toa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net solar flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNRTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNRTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clear-sky Flux Shortwave Near-IR Absorbed at toa",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNIRTSQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNIRTSQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Near-IR Absorbed at toa >= 0.7 microns",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNIRT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNIRT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Near-IR Absorbed at TOA",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "USTAR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "USTAR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface friction velocity",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "TS4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS4      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS3      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS2      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "TS1      subsoil temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional surface stress",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal surface stress",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "SRFRAD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRFRAD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net radiative flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLSD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLSD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward visible diffuse to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward visible direct  to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward near infrared diffuse to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar downward near infrared direct  to surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SOLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar insolation",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "SNOWH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "SICTHK": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICTHK",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "sea ice thickness",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "QFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface water flux",
                                        "units": "kg/m2/s",
                                        "pointwidth": "0"
                                    },
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Sea level pressure",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "surface pressure",
                                        "units": "Pa",
                                        "pointwidth": "0"
                                    },
                                    "PRECSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Convective snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "PHIS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PHIS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "instantaneous",
                                        "long_name": "surface geopotential",
                                        "units": "m2/s2",
                                        "pointwidth": "0"
                                    },
                                    "PBLH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PBLH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "PBL height",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "ORO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ORO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "instantaneous",
                                        "long_name": "ocean (0), land (1), sea ice (2) flag",
                                        "units": "FLAG",
                                        "pointwidth": "0"
                                    },
                                    "LWSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LWSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Liquid water scale height",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net solar flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Flux Shortwave Downwelling Surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "forecasttime": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "forecasttime",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "calendar": "360",
                                        "long_name": "Forecast Time",
                                        "units": "months since 1960-01-01",
                                        "pointwidth": "1.0",
                                        "standard_name": "time"
                                    },
                                    "FLNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net longwave flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Clearsky net longwave flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "0"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "history": "toS: regridded lev to IRI FD CCM3v6 Forecast psst ensemble MONTHLY hybrid_lev P",
                                        "file_missing_value": "9.99999962E35",
                                        "expires": "1491307200",
                                        "time_op": "average",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "0"
                                    }
                                },
                                "parameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "parameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "time_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "P0": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P0",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference pressure",
                                        "units": "Pa"
                                    },
                                    "ntrn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter N",
                                        "units": "unitless"
                                    },
                                    "ntrm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter M",
                                        "units": "unitless"
                                    },
                                    "ntrk": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrk",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter K",
                                        "units": "unitless"
                                    },
                                    "nsteph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsteph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current timestep",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "nscur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nscur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current seconds of current day",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "nsbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base day",
                                        "units": "unitless"
                                    },
                                    "ndcur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndcur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current day (from base day)",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "ndbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base day",
                                        "units": "unitless"
                                    },
                                    "nbsec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbsec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base date",
                                        "units": "unitless"
                                    },
                                    "nbdate": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbdate",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base date (YYYYMMDD)",
                                        "units": "unitless"
                                    },
                                    "mdt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mdt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "timestep",
                                        "units": "s"
                                    },
                                    "gw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "gauss weights",
                                        "units": "unitless"
                                    },
                                    "datesec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "datesec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current seconds of current date",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "date_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "date": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "long_name": "current date (YYYYMMDD)",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "0"
                                    },
                                    "VT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Meridional heat transport",
                                        "units": "Km/s",
                                        "pointwidth": "0"
                                    },
                                    "VQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "VQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Meridional water transport",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "pointwidth": "0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "0"
                                    },
                                    "SETLWP": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SETLWP",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Specified liquid water path lengths",
                                        "units": "G/M2",
                                        "pointwidth": "0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Relative humidity",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "QRS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QRS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Solar heating rate",
                                        "units": "degree_Kelvin/s",
                                        "pointwidth": "0"
                                    },
                                    "QRL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QRL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Longwave heating rate",
                                        "units": "degree_Kelvin/s",
                                        "pointwidth": "0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Q constituent tracer",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "P_i": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_i",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure",
                                        "long_name": "Pressure",
                                        "missing_value": "NaN",
                                        "expires": "1491307200",
                                        "units": "Pa",
                                        "file_missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "pointwidth": "0"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure",
                                        "long_name": "Pressure",
                                        "missing_value": "NaN",
                                        "expires": "1491307200",
                                        "units": "Pa",
                                        "file_missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "pointwidth": "0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "pointwidth": "0"
                                    },
                                    "MQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "MQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Water vapor mass in layer",
                                        "units": "kg/m2",
                                        "pointwidth": "0"
                                    },
                                    "hybm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hybi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer interfaces",
                                        "units": "unitless"
                                    },
                                    "hyam": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyam",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hyai": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyai",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer interfaces",
                                        "units": "unitless"
                                    },
                                    "ETADOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ETADOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "vertical (eta) velocity",
                                        "units": "1/S",
                                        "pointwidth": "0"
                                    },
                                    "EFFCLD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "EFFCLD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Effective cloud fraction",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLOUD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLOUD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491307200",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Cloud fraction",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "forecasttime": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecasttime",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491307200",
                                    "calendar": "360",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0",
                                    "standard_name": "time"
                                }
                            }
                        }
                    },
                    "ca_sst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ca_sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "toa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "toa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at top",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional surface stress",
                                        "units": "Pa",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal surface stress",
                                        "units": "Pa",
                                        "pointwidth": "1.0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "ORO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ORO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "instantaneous",
                                        "long_name": "ocean (0), land (1), sea ice (2) flag",
                                        "units": "FLAG",
                                        "pointwidth": "1.0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "parameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "parameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "time_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "P0": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P0",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference pressure",
                                        "units": "Pa"
                                    },
                                    "ntrn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter N",
                                        "units": "unitless"
                                    },
                                    "ntrm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter M",
                                        "units": "unitless"
                                    },
                                    "ntrk": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ntrk",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "spectral truncation parameter K",
                                        "units": "unitless"
                                    },
                                    "nsteph": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsteph",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "long_name": "current timestep",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "nscur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nscur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "long_name": "current seconds of current day",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "nsbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nsbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base day",
                                        "units": "unitless"
                                    },
                                    "ndcur": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndcur",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "long_name": "current day (from base day)",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "ndbase": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ndbase",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base day",
                                        "units": "unitless"
                                    },
                                    "nbsec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbsec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "seconds of base date",
                                        "units": "unitless"
                                    },
                                    "nbdate": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nbdate",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "base date (YYYYMMDD)",
                                        "units": "unitless"
                                    },
                                    "mdt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "mdt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "timestep",
                                        "units": "s"
                                    },
                                    "gw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "gauss weights",
                                        "units": "unitless"
                                    },
                                    "datesec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "datesec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "long_name": "current seconds of current date",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "date_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "date": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "date",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "long_name": "current date (YYYYMMDD)",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "mean_sea_level": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mean_sea_level",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Sea level pressure",
                                        "units": "Pa",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "1.0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Relative humidity",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Q constituent tracer",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "pointwidth": "1.0"
                                    },
                                    "hybm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hybi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer interfaces",
                                        "units": "unitless"
                                    },
                                    "hyam": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyam",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer midpoints",
                                        "units": "unitless"
                                    },
                                    "hyai": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyai",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer interfaces",
                                        "units": "unitless"
                                    }
                                },
                                "forecasttime": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "forecasttime",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "expires": "1491004800",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491004800",
                                        "missing_value": "9.99999962E35",
                                        "time_op": "average",
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    }
                                }
                            }
                        }
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "time_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "time_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0"
                },
                "lev_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lev_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "basins": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "basins",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "time_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "time_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1491350400",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "time": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "time",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1946-01-01 00:00:00",
                    "gridtype": "0",
                    "calendar": "365",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "lead time",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "lead time",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1491307200",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "pointwidth": "0"
                },
                "lev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hybrid_sigma_pressure",
                    "gridtype": "0"
                },
                "ilev": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ilev",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hybrid_sigma_pressure",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "lead time",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1491004800",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time",
                    "pointwidth": "0"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "lon": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lon",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "lat": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "lat",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "dir": "SOURCES/IRI/FD/CCM3v6"
            },
            "COLA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "COLA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "T63Historyclimatologyc7100long_name": "1971-2000",
                    "T63Historyclimatologyc6998long_name": "1969-1998",
                    "T63HistoryclimatologyiridlhasSemantics": "iridl:climatology",
                    "T63Forecastssstensemblemonthlyexpires": "1491868800",
                    "T63Forecastssstensemblemonthlyrunoffset": "533.0",
                    "T63ForecastiridlhasSemantics": "iridl:forecast",
                    "description": "COLA C2.2 ensemble forecasts and simulations of precipitation rate and temperature at canapy air space",
                    "about_COLA": "http://www.iges.org/cola.html",
                    "iridlhasSemantics": "iridl:COLA",
                    "Conventions": "IRIDL",
                    "long_name": "COLA",
                    "references": "Kinter_etal1988 Dewitt1996 Schneider2002"
                },
                "T63": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T63",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble_mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "missing_value": "-9999.0",
                                    "long_name": "temperature at canopy air space"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        },
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-9999.0",
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature at canopy air space"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        },
                        "climatology": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatology",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "c7100": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c7100",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "missing_value": "-9999.0",
                                    "long_name": "temperature at canopy air space"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            },
                            "c6998": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c6998",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "missing_value": "-9999.0",
                                    "long_name": "temperature at canopy air space"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "Kelvin_scale",
                                        "long_name": "Temperature at 2m",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast Time",
                                        "pointwidth": "1",
                                        "expires": "1491868800",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "mm/day",
                                        "long_name": "precipitation rate",
                                        "missing_value": "-999.0",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "Kelvin_scale",
                                        "long_name": "Temperature at 2m"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast Time",
                                        "pointwidth": "1",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "missing_value": "NaN",
                                        "units": "mm/day",
                                        "long_name": "precipitation rate"
                                    }
                                }
                            }
                        }
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1491868800",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "1.875"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/IRI/FD/COLA"
            },
            "COLA2p2p6": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "COLA2p2p6",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "COLA AGCM V2.2.6",
                    "Conventions": "IRIDL",
                    "long_name": "COLA2.2.6"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "1.875"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "dir": "SOURCES/IRI/FD/COLA2p2p6"
            },
            "CPT": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CPT",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "W_S_Americaexpires": "1552089600",
                    "W_S_Americahistory": "Output from CPT for 12 3-month running seasons for 1973-2001 between ECHAM4p5 GCM and CRU dataset, CPT recompiled on Mac 9.04 version",
                    "PAGASAhistory": "Output from CPT for 12 3-month running seasons for 1977-2003 between Echam4.5 CASST GCM and PAGASA stations dataset, CPT recompiled on Mac 9.04 version",
                    "PAGASAexpires": "1552089600",
                    "NEBrazilexpires": "1552089600",
                    "NEBrazilhistory": "Output from CPT for 12 3-month running seasons for 1973-2001 between ECHAM4p5 GCM and CRU dataset, CPT recompiled on Mac 9.04 version",
                    "Monsoon_Asiatemperatureminimumexpires": "1552089600",
                    "Monsoon_Asiatemperatureminimumhistory": "Output from CPT for 12 3-month running seasons for 1979-2008 with UEA CRU TS3p1 monthly dataset, CPT v10",
                    "Monsoon_Asiatemperaturemaximumexpires": "1552089600",
                    "Monsoon_Asiatemperaturemaximumhistory": "Output from CPT for 12 3-month running seasons for 1979-2008 with UEA CRU TS3p1 monthly dataset, CPT v10",
                    "Monsoon_Asiatemperatureaverageexpires": "1552089600",
                    "Monsoon_Asiatemperatureaveragehistory": "Output from CPT for 12 3-month running seasons for 1979-2008 with UEA CRU TS3p1 monthly dataset, CPT v10",
                    "Monsoon_Asiaprecipitationexpires": "1552089600",
                    "Monsoon_Asiaprecipitationhistory": "Output from CPT for 12 3-month running seasons for 1972-2007 between ECHAM4p5 GCM and RIHN aphrodite V1003R1 Monsoon Asia gridded daily precipitation dataset, CPT v10",
                    "Indonesiaunknown_obsexpires": "1552089600",
                    "IndonesiaGPCC_obsHistorydescription": "Predicand, Hindcast and Skill",
                    "IndonesiaGPCC_obsHistoryexpires": "1552089600",
                    "IndonesiaGPCC_obsForecastdescription": "Forecast and Error",
                    "IndonesiaGPCC_obsForecastexpires": "1552089600",
                    "IndonesiaGPCC_obsexpires": "1552089600",
                    "IndonesiaCMAP_obsHistorydescription": "Predicand, Hindcast and Skill",
                    "IndonesiaCMAP_obsHistoryexpires": "1552089600",
                    "IndonesiaCMAP_obsForecastdescription": "Forecast and Error",
                    "IndonesiaCMAP_obsForecastexpires": "1552089600",
                    "IndonesiaCMAP_obsexpires": "1552089600",
                    "IndonesiaCHIRPS_obsHistorydescription": "Predicand, Hindcast and Skill",
                    "IndonesiaCHIRPS_obsHistoryexpires": "1552089600",
                    "IndonesiaCHIRPS_obsForecastdescription": "Forecast and Error",
                    "IndonesiaCHIRPS_obsForecastexpires": "1552089600",
                    "IndonesiaCHIRPS_obsexpires": "1552089600",
                    "IndonesiaAPHR_obsHistorydescription": "Predicand, Hindcast and Skill",
                    "IndonesiaAPHR_obsHistoryexpires": "1552089600",
                    "IndonesiaAPHR_obsForecastdescription": "Forecast and Error",
                    "IndonesiaAPHR_obsForecastexpires": "1552089600",
                    "IndonesiaAPHR_obsexpires": "1552089600",
                    "Indonesiaexpires": "1552089600",
                    "GHAGPCCHistorydescription": "Predictand, Hindcast and Skill",
                    "GHAGPCCForecastdescription": "Forecast and Error",
                    "GHAGPCCForecastexpires": "1552089600",
                    "FooDSECuRESudanJJASHistorydescription": "Predicand, Hindcast and Skill",
                    "FooDSECuRESudanJJASForecastdescription": "Forecast and Error",
                    "FooDSECuRESudanJJASForecastexpires": "1586131200",
                    "FooDSECuRESudanJJASdescription": "JJAS Forecasts",
                    "FooDSECuREPhilippinesJFMAForecastexpires": "1617667200",
                    "FooDSECuREPhilippinesAMJJAForecastexpires": "1617667200",
                    "FooDSECuRENigerJJASHistorydescription": "Predicand, Hindcast and Skill",
                    "FooDSECuRENigerJJASForecastdescription": "Forecast and Error",
                    "FooDSECuRENigerJJASForecastexpires": "1586131200",
                    "FooDSECuRENigerJJASdescription": "JJAS Forecasts",
                    "ChileIVStreamflowobshistory": "Output from CPT http://iri.columbia.edu/CPT/v10/",
                    "ChileIVStreamflowobsexpires": "1552089600",
                    "ChileIVStreamflowCFShistory": "Output from CPT http://iri.columbia.edu/CPT/v10/",
                    "ChileIVStreamflowCFSexpires": "1585785600",
                    "ChileIVPrecipitationhistory": "Output from CPT http://iri.columbia.edu/CPT/v10/",
                    "ChileIVPrecipitationexpires": "1585785600",
                    "description": "Climate Prediction Tool",
                    "Conventions": "IRIDL"
                },
                "W_S_America": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "W_S_America",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "expires": "1552089600",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "standard_name": "forecast_reference_time"
                    },
                    "PredErrorVars": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PredErrorVars",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "prediction error variance",
                        "scale_min": "0.0",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "PearsonR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PearsonR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "-1.0",
                        "ncolor": "254",
                        "CS": "-0.9960159",
                        "colorscalename": "correlationcolorscale",
                        "CE": "0.9960159",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "units": "unitless",
                        "long_name": "Pearson correlation skill values",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "InputObs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "InputObs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "input observations",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "hindcast_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hindcast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "prcp_0to500_colors",
                        "colormap": "341760",
                        "scale_max": "500.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "500",
                        "CS": "0",
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "current forecast",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "CrossValHind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CrossValHind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "cross-validated hindcasts",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "PAGASA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PAGASA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "expires": "1552089600",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "bounds": "S",
                        "standard_name": "forecast_reference_time"
                    },
                    "PredErrorVars": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PredErrorVars",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1552089600",
                        "units": "mm/day",
                        "long_name": "prediction error variance",
                        "scale_min": "0.0",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "PearsonR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PearsonR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "-1.0",
                        "ncolor": "254",
                        "CS": "-0.9960159",
                        "colorscalename": "correlationcolorscale",
                        "CE": "0.9960159",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "units": "unitless",
                        "long_name": "Pearson correlation skill values",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "lon": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lon",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "114.0",
                        "units": "degree_east",
                        "long_name": "longitude",
                        "scale_max": "132.0"
                    },
                    "location": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "location",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "OpenGISSimpleFeature": "Point",
                        "long_name": "location",
                        "SpatialReferenceSystemWKT": "]]",
                        "scale_min": "114.0",
                        "units": "degree_east",
                        "scale_max": "132.0"
                    },
                    "lat": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "lat",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_min": "3.0",
                        "units": "degree_north",
                        "long_name": "latitude",
                        "scale_max": "22.0"
                    },
                    "label": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "label",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "ids"
                    },
                    "InputObs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "InputObs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "long_name": "input observations",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "hindcast_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hindcast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "prcp_0to500_colors",
                        "colormap": "341760",
                        "scale_max": "500.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "500",
                        "CS": "0",
                        "expires": "1552089600",
                        "units": "mm/day",
                        "long_name": "current forecast",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "CrossValHind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CrossValHind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/day",
                        "long_name": "cross-validated hindcasts",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "NEBrazil": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NEBrazil",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "forecast time",
                        "expires": "1552089600",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "pointwidth": "3.0"
                    },
                    "PredErrorVars": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PredErrorVars",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "prediction error variance",
                        "scale_min": "0.0",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "PearsonR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PearsonR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "-1.0",
                        "ncolor": "254",
                        "CS": "-0.9960159",
                        "colorscalename": "correlationcolorscale",
                        "CE": "0.9960159",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "units": "unitless",
                        "long_name": "Pearson correlation skill values",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "InputObs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "InputObs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "input observations",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    },
                    "hindcast_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hindcast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "prcp_0to500_colors",
                        "colormap": "341760",
                        "scale_max": "500.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "500",
                        "CS": "0",
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "current forecast",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "CrossValHind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CrossValHind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "cross-validated hindcasts",
                        "missing_value": "-999.0",
                        "pointwidth": "1.0"
                    }
                },
                "Monsoon_Asia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Monsoon_Asia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "temperature": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temperature",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "minimum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "minimum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "pointwidth": "3.0"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "40.0",
                                "ncolor": "254",
                                "scale_min": "-40.0",
                                "CS": "-40",
                                "colorscalename": "temp_colors",
                                "CE": "40",
                                "maxncolor": "254",
                                "colormap": "255",
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            }
                        },
                        "maximum": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "maximum",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "pointwidth": "3.0"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "40.0",
                                "ncolor": "254",
                                "scale_min": "-40.0",
                                "CS": "-40",
                                "colorscalename": "temp_colors",
                                "CE": "40",
                                "maxncolor": "254",
                                "colormap": "255",
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            }
                        },
                        "average": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "average",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "pointwidth": "3.0"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "40.0",
                                "ncolor": "254",
                                "scale_min": "-40.0",
                                "CS": "-40",
                                "colorscalename": "temp_colors",
                                "CE": "40",
                                "maxncolor": "254",
                                "colormap": "255",
                                "expires": "1552089600",
                                "units": "Celsius_scale",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Celsius_scale",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "1.0"
                            }
                        }
                    },
                    "precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "forecast time",
                            "expires": "1552089600",
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "pointwidth": "3.0"
                        },
                        "PredErrorVars": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PredErrorVars",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1552089600",
                            "units": "mm/day",
                            "long_name": "prediction error variance",
                            "scale_min": "0.0",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "PearsonR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PearsonR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "scale_min": "-1.0",
                            "ncolor": "254",
                            "CS": "-0.9960159",
                            "colorscalename": "correlationcolorscale",
                            "CE": "0.9960159",
                            "maxncolor": "254",
                            "colormap": "2763429",
                            "units": "unitless",
                            "long_name": "Pearson correlation skill values",
                            "missing_value": "-999.0",
                            "pointwidth": "1.0"
                        },
                        "InputObs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "InputObs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "long_name": "input observations",
                            "missing_value": "-999.0",
                            "pointwidth": "1.0"
                        },
                        "hindcast_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hindcast_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "hindcast time",
                            "pointwidth": "3",
                            "calendar": "360",
                            "units": "months since 1960-01-01"
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colorscalename": "prcp_0to500_colors",
                            "colormap": "341760",
                            "scale_max": "500.0",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CE": "500",
                            "CS": "0",
                            "expires": "1552089600",
                            "units": "mm/day",
                            "long_name": "current forecast",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "CrossValHind": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CrossValHind",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "long_name": "cross-validated hindcasts",
                            "missing_value": "-999.0",
                            "pointwidth": "1.0"
                        }
                    }
                },
                "Indonesia": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Indonesia",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "unknown_obs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "unknown_obs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "forecast time",
                            "pointwidth": "3",
                            "expires": "1552089600",
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "bounds": "S",
                            "standard_name": "forecast_reference_time"
                        },
                        "PredErrorVars": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PredErrorVars",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1552089600",
                            "units": "mm/month",
                            "long_name": "prediction error variance",
                            "scale_min": "0.0",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "PearsonR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PearsonR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "scale_min": "-1.0",
                            "ncolor": "254",
                            "CS": "-0.9960159",
                            "colorscalename": "correlationcolorscale",
                            "CE": "0.9960159",
                            "maxncolor": "254",
                            "colormap": "2763429",
                            "units": "unitless",
                            "long_name": "Pearson correlation skill values",
                            "missing_value": "-999.0",
                            "modulo": "12.0",
                            "modulus": "12.0",
                            "pointwidth": "1.0"
                        },
                        "InputObs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "InputObs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "scale_max": "16.0",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CE": "16",
                            "CS": "0",
                            "units": "mm/month",
                            "long_name": "input observations",
                            "missing_value": "-999.0",
                            "modulo": "12.0",
                            "modulus": "12.0",
                            "pointwidth": "1.0"
                        },
                        "hindcast_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hindcast_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "hindcast time",
                            "pointwidth": "3",
                            "calendar": "360",
                            "units": "months since 1960-01-01"
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colorscalename": "precip_colors",
                            "colormap": "290304",
                            "scale_max": "16.0",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CE": "16",
                            "CS": "0",
                            "expires": "1552089600",
                            "units": "mm/month",
                            "long_name": "current forecast",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "CrossValHind": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CrossValHind",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/month",
                            "long_name": "cross-validated hindcasts",
                            "missing_value": "-999.0",
                            "modulo": "12.0",
                            "modulus": "12.0",
                            "pointwidth": "1.0"
                        }
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "expires": "1552089600",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "bounds": "S",
                        "standard_name": "forecast_reference_time"
                    },
                    "PredErrorVars": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PredErrorVars",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "prediction error variance",
                        "scale_min": "0.0",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "PearsonR": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PearsonR",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "-1.0",
                        "ncolor": "254",
                        "CS": "-0.9960159",
                        "colorscalename": "correlationcolorscale",
                        "CE": "0.9960159",
                        "maxncolor": "254",
                        "colormap": "2763429",
                        "units": "unitless",
                        "long_name": "Pearson correlation skill values",
                        "missing_value": "-999.0",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "pointwidth": "1.0"
                    },
                    "InputObs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "InputObs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "precip_colors",
                        "colormap": "290304",
                        "scale_max": "16.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "16",
                        "CS": "0",
                        "units": "mm/month",
                        "long_name": "input observations",
                        "missing_value": "-999.0",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "pointwidth": "1.0"
                    },
                    "hindcast_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "hindcast_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "hindcast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01"
                    },
                    "GPCC_obs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GPCC_obs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "History": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "History",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "units": "mm/month",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/month",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "3",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "mm/month",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "expires": "1552089600",
                                "units": "mm/month",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "precip_colors",
                        "colormap": "290304",
                        "scale_max": "16.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "16",
                        "CS": "0",
                        "expires": "1552089600",
                        "units": "mm/month",
                        "long_name": "current forecast",
                        "missing_value": "-999.0",
                        "pointwidth": "0"
                    },
                    "CrossValHind": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CrossValHind",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "mm/month",
                        "long_name": "cross-validated hindcasts",
                        "missing_value": "-999.0",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "pointwidth": "1.0"
                    },
                    "CMAP_obs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CMAP_obs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "History": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "History",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "units": "mm/day",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "3",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "CHIRPS_obs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CHIRPS_obs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "History": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "History",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "units": "mm/day",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "3",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "APHR_obs": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "APHR_obs",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "History": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "History",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "units": "mm/day",
                                "long_name": "input observations",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "3",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "scale_max": "16.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "16",
                                "CS": "0",
                                "expires": "1552089600",
                                "units": "mm/day",
                                "long_name": "current forecast",
                                "missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        }
                    }
                },
                "GHA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GHA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GPCC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GPCC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "History": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "History",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "-1.0",
                                "scale_max": "1.0",
                                "CE": "1",
                                "CS": "-1",
                                "ncolor": "254",
                                "colorscalename": "correlationcolorscale",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "missing_value": "-999.0",
                                "long_name": "Pearson correlation skill values",
                                "units": "unitless",
                                "pointwidth": "0"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "missing_value": "-999.0",
                                "long_name": "input observations",
                                "units": "mm/day",
                                "pointwidth": "0"
                            },
                            "hindcast_length": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_length",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length of hindcast time",
                                "history": "Averaged in T with overlapping interval 3",
                                "units": "days",
                                "missing_value": "NaN",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "3",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "precip_colors",
                                "colormap": "290304",
                                "ncolor": "254",
                                "missing_value": "-999.0",
                                "long_name": "cross-validated hindcasts",
                                "units": "mm/day",
                                "pointwidth": "0"
                            }
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_length": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_length",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Length of forecast time",
                                "history": "Averaged in T with overlapping interval 3",
                                "units": "days",
                                "missing_value": "NaN",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "3",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "256",
                                "ncolor": "254",
                                "colormap": "12632256",
                                "colorscalename": "rainbowcolorscale",
                                "missing_value": "-999.0",
                                "long_name": "prediction error variance",
                                "units": "mm2/day2",
                                "expires": "1552089600",
                                "pointwidth": "0"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "maxncolor": "254",
                                "colormap": "25600",
                                "scale_max": "1000.0",
                                "ncolor": "254",
                                "scale_min": "0.0",
                                "CE": "1000",
                                "CS": "0",
                                "long_name": "forecast",
                                "missing_value": "NaN",
                                "expires": "1552089600",
                                "units": "mm",
                                "history": "Averaged in T with overlapping interval 3",
                                "file_missing_value": "-999.0",
                                "pointwidth": "0"
                            }
                        }
                    }
                },
                "FooDSECuRE": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "FooDSECuRE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Sudan": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Sudan",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "JJAS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "JJAS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "History": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "History",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PearsonR_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PearsonR_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-1.0",
                                    "scale_max": "1.0",
                                    "CE": "1",
                                    "CS": "-1",
                                    "ncolor": "254",
                                    "colorscalename": "correlationcolorscale",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "units": "unitless",
                                    "long_name": "Precipitation Pearson\\'s Correlation",
                                    "pointwidth": "0"
                                },
                                "Input_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Input_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "Precipitation input observations",
                                    "units": "mm/month",
                                    "pointwidth": "0"
                                },
                                "hindcast_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hindcast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "calendar": "360",
                                    "standard_name": "forecast_reference_time"
                                },
                                "CrossValPred_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CrossValPred_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "Precipitation cross-validated hindcasts",
                                    "units": "mm/month",
                                    "pointwidth": "0"
                                }
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "target_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "target_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "forecast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "expires": "1586131200",
                                    "calendar": "360",
                                    "bounds": "S",
                                    "standard_name": "forecast_reference_time"
                                },
                                "PredErrVar_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PredErrVar_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "expires": "1586131200",
                                    "units": "mm2/month2",
                                    "long_name": "Precipitation prediction error variance",
                                    "pointwidth": "0"
                                },
                                "Forecast_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Forecast_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "expires": "1586131200",
                                    "units": "mm/month",
                                    "long_name": "Precipitation current forecast",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "Philippines": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Philippines",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "JFMA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "JFMA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "History": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "History",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "regcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "regcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Region Code",
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "PGtype": "float8"
                                },
                                "provname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "PearsonR_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PearsonR_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-1.0",
                                    "scale_max": "1.0",
                                    "CE": "1",
                                    "CS": "-1",
                                    "ncolor": "254",
                                    "colorscalename": "correlationcolorscale",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD1 Pearson\\'s Correlation",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "Input_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Input_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD1 input observations",
                                    "units": "days",
                                    "pointwidth": "0"
                                },
                                "hindcast_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hindcast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "calendar": "360",
                                    "standard_name": "forecast_reference_time"
                                },
                                "CrossValPred_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CrossValPred_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD1 cross-validated hindcasts",
                                    "units": "days",
                                    "pointwidth": "0"
                                }
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "TercileProb_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TercileProb_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "colorscalename": "tercileclassesscale",
                                    "colormap": "6303920",
                                    "scale_max": "100.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CE": "100",
                                    "CS": "0",
                                    "missing_value": "-1.0",
                                    "long_name": "WD1 Tercile Probability",
                                    "units": "percent",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "target_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "target_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "forecast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "expires": "1617667200",
                                    "calendar": "360",
                                    "bounds": "S",
                                    "standard_name": "forecast_reference_time"
                                },
                                "regcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "regcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Region Code",
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "PGtype": "float8"
                                },
                                "provname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "PredErrVar_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PredErrVar_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD1 prediction error variance",
                                    "units": "days2",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "Forecast_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Forecast_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD1 current forecast",
                                    "units": "days",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "DomTercileProb_WD1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DomTercileProb_WD1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "long_name": "WD1 Dominant Tercile Probabilities",
                                    "colormap": "25600",
                                    "scale_max": "33.0",
                                    "ncolor": "254",
                                    "scale_min": "1.0",
                                    "CE": "33",
                                    "CS": "1",
                                    "CLIST": ">80 Above",
                                    "missing_value": "NaN",
                                    "fnname": "maskle",
                                    "history": "dominant_class over C[Below Normal, Above Normal]",
                                    "expires": "1617667200",
                                    "units": "ids",
                                    "file_missing_value": "0",
                                    "colorscalename": "halfgreyscale",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "AMJJA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "AMJJA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "History": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "History",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "regcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "regcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Region Code",
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "PGtype": "float8"
                                },
                                "provname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "PearsonR_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PearsonR_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-1.0",
                                    "scale_max": "1.0",
                                    "CE": "1",
                                    "CS": "-1",
                                    "ncolor": "254",
                                    "colorscalename": "correlationcolorscale",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD5 Pearson\\'s Correlation",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "Input_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Input_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD5 input observations",
                                    "units": "days",
                                    "pointwidth": "0"
                                },
                                "hindcast_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hindcast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "5",
                                    "calendar": "360",
                                    "standard_name": "forecast_reference_time"
                                },
                                "CrossValPred_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CrossValPred_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD5 cross-validated hindcasts",
                                    "units": "days",
                                    "pointwidth": "0"
                                }
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "the_geom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "the_geom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Provinces Geometry",
                                    "units": "unitless",
                                    "PGtype": "bytea",
                                    "OpenGISSimpleFeature": "MULTIPOLYGON",
                                    "SpatialReferenceSystemWKT": "]]"
                                },
                                "TercileProb_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TercileProb_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "colorscalename": "tercileclassesscale",
                                    "colormap": "6303920",
                                    "scale_max": "100.0",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CE": "100",
                                    "CS": "0",
                                    "missing_value": "-1.0",
                                    "long_name": "WD5 Tercile Probability",
                                    "units": "percent",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "target_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "target_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "forecast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "5",
                                    "expires": "1617667200",
                                    "calendar": "360",
                                    "bounds": "S",
                                    "standard_name": "forecast_reference_time"
                                },
                                "regcode": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "regcode",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Region Code",
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "PGtype": "float8"
                                },
                                "provname": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "provname",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Province Name",
                                    "units": "ids",
                                    "PGtype": "varchar"
                                },
                                "PredErrVar_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PredErrVar_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD5 prediction error variance",
                                    "units": "days2",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "label": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "label",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "PGtype": "text"
                                },
                                "Forecast_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Forecast_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "wetday_freq_colors",
                                    "colormap": "255",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "WD5 current forecast",
                                    "units": "days",
                                    "expires": "1617667200",
                                    "pointwidth": "0"
                                },
                                "DomTercileProb_WD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "DomTercileProb_WD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "maxncolor": "254",
                                    "long_name": "WD5 Dominant Tercile Probabilities",
                                    "colormap": "25600",
                                    "scale_max": "33.0",
                                    "ncolor": "254",
                                    "scale_min": "1.0",
                                    "CE": "33",
                                    "CS": "1",
                                    "CLIST": ">80 Above",
                                    "missing_value": "NaN",
                                    "fnname": "maskle",
                                    "history": "dominant_class over C[Below Normal, Above Normal]",
                                    "expires": "1617667200",
                                    "units": "ids",
                                    "file_missing_value": "0",
                                    "colorscalename": "halfgreyscale",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "Niger": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Niger",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "JJAS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "JJAS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "History": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "History",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PearsonR_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PearsonR_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "-1.0",
                                    "scale_max": "1.0",
                                    "CE": "1",
                                    "CS": "-1",
                                    "ncolor": "254",
                                    "colorscalename": "correlationcolorscale",
                                    "maxncolor": "254",
                                    "colormap": "2763429",
                                    "units": "unitless",
                                    "long_name": "Precipitation Pearson\\'s Correlation",
                                    "pointwidth": "0"
                                },
                                "Input_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Input_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "Precipitation input observations",
                                    "units": "mm/month",
                                    "pointwidth": "0"
                                },
                                "hindcast_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hindcast_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "hindcast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "calendar": "360",
                                    "standard_name": "forecast_reference_time"
                                },
                                "CrossValPred_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CrossValPred_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "long_name": "Precipitation cross-validated hindcasts",
                                    "units": "mm/month",
                                    "pointwidth": "0"
                                }
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "target_date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "target_date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "forecast time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "4",
                                    "expires": "1586131200",
                                    "calendar": "360",
                                    "bounds": "S",
                                    "standard_name": "forecast_reference_time"
                                },
                                "PredErrVar_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PredErrVar_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "expires": "1586131200",
                                    "units": "mm2/month2",
                                    "long_name": "Precipitation prediction error variance",
                                    "pointwidth": "0"
                                },
                                "Forecast_prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Forecast_prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "maxncolor": "254",
                                    "colorscalename": "precip_colors",
                                    "colormap": "290304",
                                    "ncolor": "254",
                                    "missing_value": "-9999.0",
                                    "expires": "1586131200",
                                    "units": "mm/month",
                                    "long_name": "Precipitation current forecast",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "ChileIV": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ChileIV",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Streamflow": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Streamflow",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "obs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "obs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "4",
                                "expires": "1552089600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "expires": "1552089600",
                                "units": "m3/s",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "pointwidth": "0"
                            },
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "missing_value": "-999.0",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-69.800003",
                                "scale_min": "-71.5",
                                "units": "degree_east",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-29.299999",
                                "scale_min": "-32.0",
                                "units": "degree_north",
                                "long_name": "latitude"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3/s",
                                "long_name": "input observations",
                                "missing_value": "-999.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "4",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "LST_colors",
                                "colormap": "255",
                                "ncolor": "254",
                                "missing_value": "-999.0",
                                "expires": "1552089600",
                                "units": "m3/s",
                                "long_name": "current forecast",
                                "pointwidth": "0"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3/s",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0"
                            }
                        },
                        "CFS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CFS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "target_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "target_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "forecast time",
                                "pointwidth": "4",
                                "expires": "1585785600",
                                "calendar": "360",
                                "units": "months since 1960-01-01",
                                "bounds": "S",
                                "standard_name": "forecast_reference_time"
                            },
                            "PredErrorVars": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PredErrorVars",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-999.0",
                                "expires": "1585785600",
                                "units": "m3/s",
                                "long_name": "prediction error variance",
                                "scale_min": "0.0",
                                "pointwidth": "0"
                            },
                            "PearsonR": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PearsonR",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "1.0",
                                "scale_min": "-1.0",
                                "ncolor": "254",
                                "CS": "-0.9960159",
                                "colorscalename": "correlationcolorscale",
                                "CE": "0.9960159",
                                "maxncolor": "254",
                                "colormap": "2763429",
                                "missing_value": "-999.0",
                                "units": "unitless",
                                "long_name": "Pearson correlation skill values"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-69.800003",
                                "scale_min": "-71.5",
                                "units": "degree_east",
                                "long_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_max": "-29.299999",
                                "scale_min": "-32.0",
                                "units": "degree_north",
                                "long_name": "latitude"
                            },
                            "InputObs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "InputObs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3/s",
                                "long_name": "input observations",
                                "missing_value": "-999.0"
                            },
                            "hindcast_date": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hindcast_date",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "hindcast time",
                                "pointwidth": "4",
                                "calendar": "360",
                                "units": "months since 1960-01-01"
                            },
                            "Forecast": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Forecast",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "scale_min": "0.0",
                                "CS": "0",
                                "maxncolor": "254",
                                "colorscalename": "LST_colors",
                                "colormap": "255",
                                "ncolor": "254",
                                "missing_value": "-999.0",
                                "expires": "1585785600",
                                "units": "m3/s",
                                "long_name": "current forecast",
                                "pointwidth": "0"
                            },
                            "CrossValHind": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "CrossValHind",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m3/s",
                                "long_name": "cross-validated hindcasts",
                                "missing_value": "-999.0"
                            }
                        }
                    },
                    "Precipitation": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Precipitation",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "forecast time",
                            "pointwidth": "4",
                            "expires": "1585785600",
                            "calendar": "360",
                            "units": "months since 1960-01-01",
                            "standard_name": "forecast_reference_time"
                        },
                        "PredErrorVars": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PredErrorVars",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "-999.0",
                            "expires": "1585785600",
                            "units": "mm",
                            "long_name": "prediction error variance",
                            "scale_min": "0.0",
                            "pointwidth": "0"
                        },
                        "PearsonR": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PearsonR",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.0",
                            "scale_min": "-1.0",
                            "ncolor": "254",
                            "CS": "-0.9960159",
                            "colorscalename": "correlationcolorscale",
                            "CE": "0.9960159",
                            "maxncolor": "254",
                            "colormap": "2763429",
                            "missing_value": "-999.0",
                            "units": "unitless",
                            "long_name": "Pearson correlation skill values",
                            "pointwidth": "0"
                        },
                        "lon": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lon",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "-69.800003",
                            "scale_min": "-71.5",
                            "units": "degree_east",
                            "long_name": "longitude"
                        },
                        "lat": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "lat",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "-29.299999",
                            "scale_min": "-32.0",
                            "units": "degree_north",
                            "long_name": "latitude"
                        },
                        "InputObs": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "InputObs",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm",
                            "long_name": "input observations",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        },
                        "hindcast_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "hindcast_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "hindcast time",
                            "pointwidth": "4",
                            "calendar": "360",
                            "units": "months since 1960-01-01"
                        },
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colorscalename": "prcp_0to500_colors",
                            "colormap": "341760",
                            "scale_max": "500.0",
                            "ncolor": "254",
                            "scale_min": "0.0",
                            "CE": "500",
                            "CS": "0",
                            "missing_value": "-999.0",
                            "expires": "1585785600",
                            "units": "mm",
                            "long_name": "current forecast",
                            "pointwidth": "0"
                        },
                        "CrossValHind": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CrossValHind",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm",
                            "long_name": "cross-validated hindcasts",
                            "missing_value": "-999.0",
                            "pointwidth": "0"
                        }
                    }
                },
                "S_25": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_25",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "expires": "1552089600",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "Y_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "X_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "STNID_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STNID_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "Station",
                    "pointwidth": "1.0"
                },
                "S_24": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_24",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "STNID": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "STNID",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "Station",
                    "pointwidth": "1.0"
                },
                "T2_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "S_23": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_23",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "Y_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "T2_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "X_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "S_22": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_22",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "T2_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "S_21": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_21",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "Y_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "0.5"
                },
                "T2_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "X_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "0.5"
                },
                "S_20": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_20",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "Y_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "T2_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "X_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.5"
                },
                "Y_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "2.5"
                },
                "X_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "2.5"
                },
                "Y_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.05"
                },
                "X_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.05"
                },
                "S_19": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_19",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Forecast Issue Date",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_18": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_18",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0.0"
                },
                "Y_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.25"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.25"
                },
                "S_17": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_17",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Forecast Issue Date",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_16": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_16",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "long_name": "Hindcast Issue Date",
                    "pointwidth": "0"
                },
                "S_15": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_15",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0.0"
                },
                "Y_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "L_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Forecast Lead Time in Months",
                    "pointwidth": "1.0"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.5"
                },
                "S_14": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_14",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Forecast Issue Date",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.5"
                },
                "S_13": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_13",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "modulo": "12.0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "S_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "modulo": "12.0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "C": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "C",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2",
                    "long_name": "Tercile Classes"
                },
                "gid_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "S_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1617667200",
                    "calendar": "360",
                    "pointwidth": "0",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time"
                },
                "gid": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "gid",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "2"
                },
                "S_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "modulo": "12.0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "long_name": "Latitude",
                    "pointwidth": "0.5"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "long_name": "Longitude",
                    "pointwidth": "0.5"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1586131200",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1552089600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "T2_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1585785600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "T2_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "ID_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ID_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1585785600",
                    "calendar": "360",
                    "long_name": "Start time",
                    "standard_name": "forecast_reference_time",
                    "pointwidth": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "T2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Training period",
                    "pointwidth": "12"
                },
                "ID": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ID",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "dir": "SOURCES/IRI/FD/CPT"
            },
            "ECHAM3": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/FD/ECHAM3",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ECHAM3",
                "restriction": "Public",
                "Forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/ECHAM3/Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Forecast",
                    "restriction": "requires dlauth tokens"
                },
                "History": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/ECHAM3/History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "History",
                    "restriction": "Public",
                    "MONTHLY": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "MONTHLY",
                        "restriction": "Public",
                        "R25004": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25004",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25004/25004fcst_%4d.01",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25004/.griblist.html"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated meridional velocity",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-480666.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "468635.0",
                                    "gribparam": "111"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1925.5742",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2353.3718",
                                    "gribparam": "113"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated zonal velocity",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-333873.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "599607.25",
                                    "gribparam": "110"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1918.8711",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1988.2036",
                                    "gribparam": "112"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated specific humidity",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-6.4091949",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "86.696793",
                                    "gribparam": "230"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.0",
                                    "gribparam": "164"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vertically integrated liquid water content",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.9643555",
                                    "gribparam": "231"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "1192.5",
                                        "gribparam": "178"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "0",
                                        "long_name": "longwave flux",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-379.13428",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "-68.352051",
                                        "gribparam": "179"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "solar flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-684.40796",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "105"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "solar flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "1193.7188",
                                            "gribparam": "103"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "longwave flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-379.13428",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.352051",
                                            "gribparam": "104"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Geopotential",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "59908.211",
                                    "gribparam": "129"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "u*^3",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "1.28755784E-15",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "3.57389450E-04",
                                    "gribparam": "159"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "TSLIN heat",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2149.8203",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1142.7476",
                                    "gribparam": "220"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "soil temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "184.98486",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "321.37402",
                                    "gribparam": "209"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "soil temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "181.06958",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "326.56592",
                                    "gribparam": "208"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "soil temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.65356",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "339.92017",
                                    "gribparam": "207"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "deep soil temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "192.80615",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "316.14502",
                                    "gribparam": "170"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.4604301",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "4.6445599",
                                    "gribparam": "181"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.6259575",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "4.4954176",
                                    "gribparam": "180"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "maximum air temperature (surface)",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.71631",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "341.80078",
                                    "gribparam": "214"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "minimum air temperature (surface)",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.64746",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "331.18115",
                                    "gribparam": "215"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "air temperature (surface)",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.66211",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "338.1499",
                                    "gribparam": "169"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Surface Temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.65356",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "339.92017",
                                    "gribparam": "139"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "surface runoff",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.45391857E-06",
                                    "gribparam": "160"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-691.87061",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "0.9914551",
                                    "gribparam": "204"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "soil wetness",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "0.2000008",
                                    "gribparam": "140"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "snow melt",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.28692079E-06",
                                    "gribparam": "218"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Snow Depth",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "13.99585",
                                    "gribparam": "141"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "151",
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25004 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Surface Pressure",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "46227.625",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "109555.19",
                                    "gribparam": "134"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Large Scale Precipitation",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.65421113E-06",
                                    "gribparam": "142"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "260",
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Convective Precipitation",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "3.19129322E-06",
                                    "gribparam": "143"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "0",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-14.222672",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "998.04688",
                                        "gribparam": "176"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "0",
                                        "long_name": "longwave flux",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-291.77075",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "121.18408",
                                        "gribparam": "177"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1481.6172",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1301.637",
                                    "gribparam": "146"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2451.7578",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "430.98242",
                                    "gribparam": "147"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Evaporation",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-9.80478944E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.64414075E-07",
                                    "gribparam": "182"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "274",
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "273",
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "solar flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-2278.4609",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "0.03125",
                                            "gribparam": "106"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "longwave flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-727.72119",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "-58.949463",
                                            "gribparam": "107"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "solar flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "1011.5781",
                                            "gribparam": "101"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "0",
                                            "long_name": "longwave flux",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-291.77075",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "59.243164",
                                            "gribparam": "102"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Albedo (surface)",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.04891968",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "0.8019387",
                                    "gribparam": "175"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribparam": "130"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vorticity",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribparam": "138"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "148",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "135",
                                    "long_name": "vertical pressure velocity",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Specific Humidity",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribparam": "133"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Divergence",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribparam": "155"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "149",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Temperature",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-22.848301",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "409.66205",
                                    "gribparam": "130"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vorticity",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.68606730E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.36537871E-05",
                                    "gribparam": "138"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "148",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "units": "meter2 second-1",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.68606730E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.36537871E-05"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "units": "m",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "135",
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25004 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Log Surface Pressure",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.03099993",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "16.256054",
                                    "gribparam": "152"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Specific Humidity",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.008156321",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "0.01511904",
                                    "gribparam": "133"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Divergence",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.17277375E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.06693835E-06",
                                    "gribparam": "155"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "149",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "units": "meter2 second-1",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.17277375E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.06693835E-06"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "cloud cover",
                                    "calendar": "360",
                                    "process": "31",
                                    "units": "unitless",
                                    "scale_min": "0.0",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "1.0",
                                    "gribparam": "223"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "10m windspeed",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.005932529",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "39.517067",
                                    "gribparam": "171"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "V-wind at 10",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-35.15921",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "33.774658",
                                    "gribparam": "166"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "U-wind at 10",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-32.999084",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "35.353714",
                                    "gribparam": "165"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Dewpoint at 2 m",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "169.07593",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "304.90161",
                                    "gribparam": "168"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "max 2m temp",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.78467",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "329.95337",
                                    "gribparam": "201"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "min 2m temp",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.68628",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "325.12134",
                                    "gribparam": "202"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Temperature at 2 m",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.73608",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "327.67871",
                                    "gribparam": "167"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25004"
                        },
                        "R25005": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25005",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25005/25005fcst_%4d.01",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25005/.griblist.html"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-449085.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "477803.56",
                                    "gribparam": "111",
                                    "process": "31"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2046.0117",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2458.4805",
                                    "gribparam": "113",
                                    "process": "31"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-358273.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "629064.69",
                                    "gribparam": "110",
                                    "process": "31"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1710.4648",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1847.939",
                                    "gribparam": "112",
                                    "process": "31"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-6.5536499",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "88.415474",
                                    "gribparam": "230",
                                    "process": "31"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.0",
                                    "gribparam": "164",
                                    "process": "31"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.9521484",
                                    "gribparam": "231",
                                    "process": "31"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "1192.4688",
                                        "gribparam": "178",
                                        "process": "31"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-376.65625",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "-67.124756",
                                        "gribparam": "179",
                                        "process": "31"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-683.52295",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "process": "31"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "1193.6875",
                                            "gribparam": "103",
                                            "process": "31"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-376.65625",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.124756",
                                            "gribparam": "104",
                                            "process": "31"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "1.21634948E-15",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "3.70047987E-04",
                                    "gribparam": "159",
                                    "process": "31"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1863.3438",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1086.4329",
                                    "gribparam": "220",
                                    "process": "31"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.95459",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "321.37036",
                                    "gribparam": "209",
                                    "process": "31"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.87109",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "326.70557",
                                    "gribparam": "208",
                                    "process": "31"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.53418",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "339.44629",
                                    "gribparam": "207",
                                    "process": "31"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "192.47876",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "316.17139",
                                    "gribparam": "170",
                                    "process": "31"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.8241749",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "3.6891708",
                                    "gribparam": "181",
                                    "process": "31"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.3125763",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "4.8918047",
                                    "gribparam": "180",
                                    "process": "31"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.5625",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "341.3645",
                                    "gribparam": "214",
                                    "process": "31"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.52832",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "330.27173",
                                    "gribparam": "215",
                                    "process": "31"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.53931",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "337.82812",
                                    "gribparam": "169",
                                    "process": "31"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.53418",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "339.44629",
                                    "gribparam": "139",
                                    "process": "31"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.28331191E-06",
                                    "gribparam": "160",
                                    "process": "31"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-755.42407",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.291748",
                                    "gribparam": "204",
                                    "process": "31"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.87964179E-06",
                                    "gribparam": "218",
                                    "process": "31"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "10.0",
                                    "gribparam": "141",
                                    "process": "31"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "151",
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25005 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "46466.312",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "109496.06",
                                    "gribparam": "134",
                                    "process": "31"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "2.47487333E-06",
                                    "gribparam": "142",
                                    "process": "31"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "260",
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "process": "31"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "3.06649599E-06",
                                    "gribparam": "143",
                                    "process": "31"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-32.947937",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "999.125",
                                        "gribparam": "176",
                                        "process": "31"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-290.17456",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1",
                                        "scale_max": "105.60205",
                                        "gribparam": "177",
                                        "process": "31"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1381.8281",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "849.07471",
                                    "gribparam": "146",
                                    "process": "31"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1996.9023",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "435.73828",
                                    "gribparam": "147",
                                    "process": "31"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-7.98539077E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "1.58640546E-07",
                                    "gribparam": "182",
                                    "process": "31"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "274",
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "process": "31"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "273",
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "process": "31"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-2649.0859",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "process": "31"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-724.5979",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "-58.779541",
                                            "gribparam": "107",
                                            "process": "31"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "1017.6562",
                                            "gribparam": "101",
                                            "process": "31"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-290.17456",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1",
                                            "scale_max": "44.848877",
                                            "gribparam": "102",
                                            "process": "31"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.04906815",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "0.8019523",
                                    "gribparam": "175",
                                    "process": "31"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribparam": "130",
                                    "process": "31"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribparam": "138",
                                    "process": "31"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "148",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "135",
                                    "long_name": "vertical pressure velocity",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribparam": "133",
                                    "process": "31"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribparam": "155",
                                    "process": "31"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "149",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "process": "31"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "process": "31"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-23.157942",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "409.7746",
                                    "gribparam": "130",
                                    "process": "31"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.66701084E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.32847542E-05",
                                    "gribparam": "138",
                                    "process": "31"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "148",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "units": "meter2 second-1",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.66701084E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "2.32847542E-05",
                                    "process": "31"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "units": "m",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "process": "31"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "process": "31"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "135",
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25005 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "process": "31"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.03152702",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.008007026",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "0.01507445",
                                    "gribparam": "133",
                                    "process": "31"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.14723718E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "1.96223755E-06",
                                    "gribparam": "155",
                                    "process": "31"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "149",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "units": "meter2 second-1",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.14723718E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "1.96223755E-06",
                                    "process": "31"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "units": "unitless",
                                    "scale_min": "0.0",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109",
                                    "scale_max": "1.0",
                                    "gribparam": "223",
                                    "process": "31"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.006682973",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "34.791058",
                                    "gribparam": "171",
                                    "process": "31"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-31.870132",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "32.882111",
                                    "gribparam": "166",
                                    "process": "31"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-33.390701",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "32.952484",
                                    "gribparam": "165",
                                    "process": "31"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "169.68677",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "304.38574",
                                    "gribparam": "168",
                                    "process": "31"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.57227",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "330.27783",
                                    "gribparam": "201",
                                    "process": "31"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.40527",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "325.43384",
                                    "gribparam": "202",
                                    "process": "31"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.46313",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "328.93896",
                                    "gribparam": "167",
                                    "process": "31"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25005"
                        },
                        "R25006": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25006",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25006/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25006/25006fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "478127.0",
                                    "gribparam": "111",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-434749.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2402.9756",
                                    "gribparam": "113",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1932.8789",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "608848.19",
                                    "gribparam": "110",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-299621.81",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1971.3162",
                                    "gribparam": "112",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1843.5312",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "85.219368",
                                    "gribparam": "230",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-6.2508087",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "164",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.8405151",
                                    "gribparam": "231",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1192.4688",
                                        "gribparam": "178",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-66.82959",
                                        "gribparam": "179",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-374.65918",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-685.43237",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1193.6562",
                                            "gribparam": "103",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-66.82959",
                                            "gribparam": "104",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-374.65918",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.97145748E-04",
                                    "gribparam": "159",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "1.34949628E-15",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1009.9243",
                                    "gribparam": "220",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2086.1914",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "321.12891",
                                    "gribparam": "209",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "183.11572",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.3335",
                                    "gribparam": "208",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.19312",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.67798",
                                    "gribparam": "207",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "177.8938",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.302",
                                    "gribparam": "170",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "191.48096",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "5.5244732",
                                    "gribparam": "181",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.3637857",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.3828039",
                                    "gribparam": "180",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.2395811",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "341.61133",
                                    "gribparam": "214",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "177.91113",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.31567",
                                    "gribparam": "215",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "177.89355",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "337.96387",
                                    "gribparam": "169",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "177.89893",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.67798",
                                    "gribparam": "139",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "177.8938",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.39926158E-06",
                                    "gribparam": "160",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.1320801",
                                    "gribparam": "204",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-697.42505",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.23674579E-06",
                                    "gribparam": "218",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "15.161621",
                                    "gribparam": "141",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25006 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109461.88",
                                    "gribparam": "134",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "46482.125",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.33156607E-06",
                                    "gribparam": "142",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.12004704E-06",
                                    "gribparam": "143",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "999.57812",
                                        "gribparam": "176",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-11.206589",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "103.47583",
                                        "gribparam": "177",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-282.46265",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1010.9685",
                                    "gribparam": "146",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1568.8477",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "401.51489",
                                    "gribparam": "147",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2011.1836",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.50800361E-07",
                                    "gribparam": "182",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-8.04237061E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-2437.0117",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-56.693848",
                                            "gribparam": "107",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-724.52295",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1022.5312",
                                            "gribparam": "101",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "46.420166",
                                            "gribparam": "102",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-282.88818",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019494",
                                    "gribparam": "175",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.04899573",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "409.56641",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-22.708986",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.39773999E-05",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.73379340E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.39773999E-05",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.73379340E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25006 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.0305445",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01515977",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.008108891",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.04394200E-06",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.08850565E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.04394200E-06",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.08850565E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "223",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "38.048679",
                                    "gribparam": "171",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.008250136",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "33.242691",
                                    "gribparam": "166",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-31.796066",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "37.011673",
                                    "gribparam": "165",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-36.122818",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "304.2146",
                                    "gribparam": "168",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "167.9624",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "329.49878",
                                    "gribparam": "201",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.448",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "325.09375",
                                    "gribparam": "202",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.39575",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.32471",
                                    "gribparam": "167",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.41187",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25006"
                        },
                        "R25007": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25007",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25007/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "460819.0",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column VVI",
                                    "gribparam": "111",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-467332.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2520.8372",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column VQVI",
                                    "gribparam": "113",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-2005.9727",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "604443.06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column UVI",
                                    "gribparam": "110",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-339541.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2011.5613",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column UQVI",
                                    "gribparam": "112",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-1859.0195",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "91.118973",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column QVI",
                                    "gribparam": "230",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-6.4927979",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column cltm",
                                    "gribparam": "164",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.9045715",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 total_air_column ALWCVI",
                                    "gribparam": "231",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "process": "31",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1192.4688",
                                        "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 top net swflx",
                                        "gribparam": "178",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "PTVersion": "0",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "process": "31",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-69.439209",
                                        "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 top net lwflx",
                                        "gribparam": "179",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "PTVersion": "0",
                                        "scale_min": "-378.37573",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "process": "31",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 top clear_sky upward solr",
                                            "gribparam": "105",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "-684.42969",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1193.6562",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 top clear_sky net solr",
                                            "gribparam": "103",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-69.439209",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 top clear_sky net lwflx",
                                            "gribparam": "104",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "-378.37573",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface zg",
                                    "gribparam": "129",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.18504870E-04",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface u*3",
                                    "gribparam": "159",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "5.29799627E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "989.71167",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface TSLIN",
                                    "gribparam": "220",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-1912.6367",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "321.33911",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface TD5",
                                    "gribparam": "209",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "185.18921",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.21753",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface TD4",
                                    "gribparam": "208",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "181.40894",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.67969",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface TD3",
                                    "gribparam": "207",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "180.21704",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.38452",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface td",
                                    "gribparam": "170",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "191.54346",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.1279154",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface tauv",
                                    "gribparam": "181",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-3.7660151",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.7298355",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface tauu",
                                    "gribparam": "180",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-4.5387793",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "342.64307",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface Tasmx",
                                    "gribparam": "214",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "180.23022",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.86792",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface tasmn",
                                    "gribparam": "215",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "180.2041",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "338.94116",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface tas",
                                    "gribparam": "169",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "180.21338",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.67969",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface stemp",
                                    "gribparam": "139",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "180.21704",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.47242860E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface srun",
                                    "gribparam": "160",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.6994629",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface SRADSU",
                                    "gribparam": "204",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-741.28516",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface soilm",
                                    "gribparam": "140",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.47184653E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface SNMEL",
                                    "gribparam": "218",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "11.056885",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface snd",
                                    "gribparam": "141",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25007 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109374.44",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface pss",
                                    "gribparam": "134",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "46468.5",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.56992644E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface prl",
                                    "gribparam": "142",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface prc",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.14606586E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface prc",
                                    "gribparam": "143",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1007.6094",
                                        "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface net swflx",
                                        "gribparam": "176",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "PTVersion": "0",
                                        "scale_min": "-5.6693115",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "process": "31",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "112.10278",
                                        "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface net lwflx",
                                        "gribparam": "177",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "PTVersion": "0",
                                        "scale_min": "-282.13184",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "process": "31",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "933.40601",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface hfss",
                                    "gribparam": "146",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-1370.832",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "404.24146",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface hfls",
                                    "gribparam": "147",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-2087.0781",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.54082045E-07",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface evs",
                                    "gribparam": "182",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-8.34568709E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface pss",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface pss",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface clear_sky upward solr",
                                            "gribparam": "106",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "-2633.3867",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-59.709961",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface clear_sky upward lwflx",
                                            "gribparam": "107",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "-734.06714",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1015.0938",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface clear_sky net solr",
                                            "gribparam": "101",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "47.539795",
                                            "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface clear_sky net lwflx",
                                            "gribparam": "102",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "PTVersion": "0",
                                            "scale_min": "-282.13184",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "process": "31",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019526",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 surface ALBEDO",
                                    "gribparam": "175",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.04886818",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "process": "31",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "grib_name": "ta",
                                    "process": "31"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "grib_name": "rvort",
                                    "process": "31"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "grib_name": "hus",
                                    "process": "31"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "grib_name": "div",
                                    "process": "31"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev rvort",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev rvort",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "409.53256",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev ta",
                                    "gribparam": "130",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-23.23621",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.37318236E-05",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev rvort",
                                    "gribparam": "138",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-1.69907362E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.37318236E-05",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev rvort",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-1.69907362E-05",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev hus",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev logpsl",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25007 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev logpsl",
                                    "gribparam": "152",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-0.03144214",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01532626",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev hus",
                                    "gribparam": "133",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-0.008086637",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.02316573E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev div",
                                    "gribparam": "155",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-2.17241495E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.02316573E-06",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev div",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-2.17241495E-06",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 hybrid_lev ACLCAC",
                                    "gribparam": "223",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "ACLCAC",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "36.995594",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground wind10",
                                    "gribparam": "171",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "0.005953394",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "32.687515",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground vas",
                                    "gribparam": "166",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-32.601196",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "32.788483",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground uas",
                                    "gribparam": "165",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "-34.030426",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "305.20972",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground td2m",
                                    "gribparam": "168",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "169.99731",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.79175",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground t2mmx",
                                    "gribparam": "201",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "184.89185",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "325.89648",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground t2mmn",
                                    "gribparam": "202",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "184.80298",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "328.27563",
                                    "history": "T:  0000 1 Jan 1925 to 1800 30 Dec 1929 appended from /mstore/iri/forecast/data/echam/history/25007/25007fcst_%4d.01 above_ground t2m",
                                    "gribparam": "167",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "scale_min": "184.83301",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "process": "31",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25007"
                        },
                        "R25008": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25008",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25008/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25008/25008fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "493604.44",
                                    "gribparam": "111",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-485520.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2256.4504",
                                    "gribparam": "113",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2099.4844",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "619632.38",
                                    "gribparam": "110",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-364576.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1981.9138",
                                    "gribparam": "112",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1789.4531",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "88.049217",
                                    "gribparam": "230",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-6.3419495",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "164",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.9219971",
                                    "gribparam": "231",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1192.5",
                                        "gribparam": "178",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-67.211182",
                                        "gribparam": "179",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-374.0061",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-684.1958",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1193.6562",
                                            "gribparam": "103",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-67.211182",
                                            "gribparam": "104",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-374.0061",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.18156385E-04",
                                    "gribparam": "159",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "7.54308039E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1022.7419",
                                    "gribparam": "220",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2425.8359",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "321.51685",
                                    "gribparam": "209",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.17236",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.07397",
                                    "gribparam": "208",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "179.99194",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.99219",
                                    "gribparam": "207",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "178.64966",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.30518",
                                    "gribparam": "170",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "192.40649",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.8717413",
                                    "gribparam": "181",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.0070276",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.9424572",
                                    "gribparam": "180",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.4226437",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "342.02002",
                                    "gribparam": "214",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "178.65576",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.85303",
                                    "gribparam": "215",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "178.62451",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "338.55981",
                                    "gribparam": "169",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "178.6355",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.99219",
                                    "gribparam": "139",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "178.64966",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.66486313E-06",
                                    "gribparam": "160",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.9619141",
                                    "gribparam": "204",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-679.93994",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.66428106E-06",
                                    "gribparam": "218",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.945312",
                                    "gribparam": "141",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25008 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109437.81",
                                    "gribparam": "134",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "46424.5",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.46474519E-06",
                                    "gribparam": "142",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.83984298E-06",
                                    "gribparam": "143",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "999.73438",
                                        "gribparam": "176",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-13.859985",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "105.30835",
                                        "gribparam": "177",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-315.26172",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1090.2732",
                                    "gribparam": "146",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1923.1602",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "356.6936",
                                    "gribparam": "147",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2224.8398",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.34059576E-07",
                                    "gribparam": "182",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-8.89674993E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02734375",
                                            "gribparam": "106",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-2191.4727",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-57.627686",
                                            "gribparam": "107",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-730.33252",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1011.7969",
                                            "gribparam": "101",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "51.492676",
                                            "gribparam": "102",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-315.26172",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.801943",
                                    "gribparam": "175",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.04904336",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "409.50806",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-22.783413",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.33916853E-05",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.73417611E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.33916853E-05",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.73417611E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25008 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.03099901",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01513811",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.008050728",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.98069984E-06",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.32712273E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "1.98069984E-06",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.32712273E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "223",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "37.6077",
                                    "gribparam": "171",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.007634297",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "36.310181",
                                    "gribparam": "166",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-35.464081",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "32.223206",
                                    "gribparam": "165",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-35.156708",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "304.75464",
                                    "gribparam": "168",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "168.11133",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "328.64917",
                                    "gribparam": "201",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.63501",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "325.19531",
                                    "gribparam": "202",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.56958",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.55835",
                                    "gribparam": "167",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.58911",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25008"
                        },
                        "R25009": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25009",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25009/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25009/25009fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "467932.31",
                                    "gribparam": "111",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-490315.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2218.7336",
                                    "gribparam": "113",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2626.3594",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "607632.69",
                                    "gribparam": "110",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-302972.75",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2289.7646",
                                    "gribparam": "112",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1813.1719",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "88.092567",
                                    "gribparam": "230",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-5.268692",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "164",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.017334",
                                    "gribparam": "231",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1192.3438",
                                        "gribparam": "178",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-66.940918",
                                        "gribparam": "179",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-376.12451",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-685.02124",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1193.625",
                                            "gribparam": "103",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-66.940918",
                                            "gribparam": "104",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-376.12451",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.86416912E-04",
                                    "gribparam": "159",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "3.53458379E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "959.77759",
                                    "gribparam": "220",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1996.3945",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "321.28247",
                                    "gribparam": "209",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "184.13013",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.68896",
                                    "gribparam": "208",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "180.46338",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.34937",
                                    "gribparam": "207",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.18701",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.36792",
                                    "gribparam": "170",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "192.27319",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "5.1649532",
                                    "gribparam": "181",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.3528652",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.4213371",
                                    "gribparam": "180",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.8254166",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "342.48633",
                                    "gribparam": "214",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.21509",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.51685",
                                    "gribparam": "215",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.17212",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "338.73267",
                                    "gribparam": "169",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.1853",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.34937",
                                    "gribparam": "139",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.18701",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.32120510E-06",
                                    "gribparam": "160",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.5183105",
                                    "gribparam": "204",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-751.44043",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.05420656E-06",
                                    "gribparam": "218",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "13.348877",
                                    "gribparam": "141",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25009 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109870.12",
                                    "gribparam": "134",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "46256.938",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.89495802E-06",
                                    "gribparam": "142",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.22150299E-06",
                                    "gribparam": "143",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1004.2656",
                                        "gribparam": "176",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-8.5990906",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "108.47925",
                                        "gribparam": "177",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-284.60181",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "882.33228",
                                    "gribparam": "146",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1353.832",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "390.42456",
                                    "gribparam": "147",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2116.9766",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.48259005E-07",
                                    "gribparam": "182",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-8.46561306E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-2608.4375",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-58.340332",
                                            "gribparam": "107",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-730.86182",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1009.5",
                                            "gribparam": "101",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "53.355225",
                                            "gribparam": "102",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-284.60181",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019441",
                                    "gribparam": "175",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.04904038",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "409.52737",
                                    "gribparam": "130",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-22.849165",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.38848534E-05",
                                    "gribparam": "138",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.84280307E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.38848534E-05",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.84280307E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25009 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.03091387",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01512086",
                                    "gribparam": "133",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.007998929",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.03414243E-06",
                                    "gribparam": "155",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.18189825E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.03414243E-06",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.18189825E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "223",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "36.322193",
                                    "gribparam": "171",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.005152076",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "32.609451",
                                    "gribparam": "166",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-32.401703",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "31.73584",
                                    "gribparam": "165",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-36.24617",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "304.30884",
                                    "gribparam": "168",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "168.35742",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "328.56152",
                                    "gribparam": "201",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "182.91675",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "325.01514",
                                    "gribparam": "202",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "182.85986",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.45239",
                                    "gribparam": "167",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "182.88135",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25009"
                        },
                        "R25010": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25010",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25010/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25010/25010fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "445616.31",
                                    "gribparam": "111",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-465519.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2191.1255",
                                    "gribparam": "113",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1966.2148",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "621150.56",
                                    "gribparam": "110",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-312240.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2166.5793",
                                    "gribparam": "112",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1660.2461",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "87.926834",
                                    "gribparam": "230",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-6.1117554",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "164",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.9179993",
                                    "gribparam": "231",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1192.4688",
                                        "gribparam": "178",
                                        "PTVersion": "0",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-67.564941",
                                        "gribparam": "179",
                                        "PTVersion": "0",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-381.35205",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-683.22144",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1193.6875",
                                            "gribparam": "103",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-67.541504",
                                            "gribparam": "104",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-381.35205",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.13237309E-04",
                                    "gribparam": "159",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "9.63926670E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1038.0132",
                                    "gribparam": "220",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1665.0625",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "320.99585",
                                    "gribparam": "209",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "184.67383",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.55664",
                                    "gribparam": "208",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "180.58838",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.80957",
                                    "gribparam": "207",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.15137",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.16187",
                                    "gribparam": "170",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "192.55615",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.7001305",
                                    "gribparam": "181",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.7978182",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.1663103",
                                    "gribparam": "180",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-3.8647652",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "341.15454",
                                    "gribparam": "214",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.26318",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.32666",
                                    "gribparam": "215",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.15112",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "337.55273",
                                    "gribparam": "169",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.20166",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "339.80957",
                                    "gribparam": "139",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "179.15137",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.38086795E-06",
                                    "gribparam": "160",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "47.150635",
                                    "gribparam": "204",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-756.11377",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.96852488E-06",
                                    "gribparam": "218",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "17.749512",
                                    "gribparam": "141",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25010 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109442.62",
                                    "gribparam": "134",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "46457.688",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.44344119E-06",
                                    "gribparam": "142",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.26324550E-06",
                                    "gribparam": "143",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1000.3281",
                                        "gribparam": "176",
                                        "PTVersion": "0",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-267.20264",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "126.73267",
                                        "gribparam": "177",
                                        "PTVersion": "0",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "process": "31",
                                        "scale_min": "-289.01807",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "874.24365",
                                    "gribparam": "146",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1155.792",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "385.11011",
                                    "gribparam": "147",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2151.832",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.45395745E-07",
                                    "gribparam": "182",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-8.60508408E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-2692.8398",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-58.383057",
                                            "gribparam": "107",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-721.09204",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1012.4531",
                                            "gribparam": "101",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "48.513916",
                                            "gribparam": "102",
                                            "PTVersion": "0",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "process": "31",
                                            "scale_min": "-289.01807",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019529",
                                    "gribparam": "175",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.04872704",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "ta"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "rvort"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "hus"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "grib_name": "div"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "409.57468",
                                    "gribparam": "130",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-22.929979",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.40235804E-05",
                                    "gribparam": "138",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.67076851E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.40235804E-05",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-1.67076851E-05",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25010 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.03186858",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01517402",
                                    "gribparam": "133",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-0.007945029",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.04045386E-06",
                                    "gribparam": "155",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.19304707E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.04045386E-06",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-2.19304707E-06",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.0",
                                    "gribparam": "223",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "ACLCAC",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "39.201103",
                                    "gribparam": "171",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "0.008588158",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "31.874802",
                                    "gribparam": "166",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-39.171387",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "33.695572",
                                    "gribparam": "165",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "-34.695984",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "304.90918",
                                    "gribparam": "168",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "169.15479",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "328.83057",
                                    "gribparam": "201",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.92529",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "325.27539",
                                    "gribparam": "202",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.78784",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.66235",
                                    "gribparam": "167",
                                    "PTVersion": "0",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "process": "31",
                                    "scale_min": "183.82983",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25010"
                        },
                        "R25011": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25011",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25011/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25011/25011fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "478046.0",
                                    "gribparam": "111",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-551080.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2667.3711",
                                    "gribparam": "113",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2798.6602",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "905412.0",
                                    "gribparam": "110",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-540668.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2509.2832",
                                    "gribparam": "112",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1812.3945",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "149.71355",
                                    "gribparam": "230",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-6.1803436",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "164",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.4591675",
                                    "gribparam": "231",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1779.8438",
                                        "gribparam": "178",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-68.689209",
                                        "gribparam": "179",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-655.0022",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "105",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-1010.3528",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1789.4375",
                                            "gribparam": "103",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-68.669434",
                                            "gribparam": "104",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-655.0022",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.08543444E-04",
                                    "gribparam": "159",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "4.80633811E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "873.14453",
                                    "gribparam": "220",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1778.9375",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "321.87402",
                                    "gribparam": "209",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.34644",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.81226",
                                    "gribparam": "208",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "181.57397",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.94824",
                                    "gribparam": "207",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.36328",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.6499",
                                    "gribparam": "170",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "193.56714",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.689868",
                                    "gribparam": "181",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.7032957",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.3592548",
                                    "gribparam": "180",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.0622053",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "343.04688",
                                    "gribparam": "214",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.40796",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.92334",
                                    "gribparam": "215",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.36084",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "629.96118",
                                    "gribparam": "169",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.38159",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.94824",
                                    "gribparam": "139",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.36328",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.25845724E-06",
                                    "gribparam": "160",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.536377",
                                    "gribparam": "204",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-956.12451",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.02038791E-06",
                                    "gribparam": "218",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "19.662109",
                                    "gribparam": "141",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25011 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109503.25",
                                    "gribparam": "134",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "46332.0",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.74012564E-06",
                                    "gribparam": "142",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.40823317E-06",
                                    "gribparam": "143",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1454.0938",
                                        "gribparam": "176",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-17.505707",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "107.88086",
                                        "gribparam": "177",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-340.33081",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1007.4453",
                                    "gribparam": "146",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1374.9336",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "373.59595",
                                    "gribparam": "147",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2130.3047",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.35732989E-07",
                                    "gribparam": "182",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-8.51853656E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-2472.3906",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-59.929688",
                                            "gribparam": "107",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-1114.6746",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1455.5",
                                            "gribparam": "101",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "38.006348",
                                            "gribparam": "102",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-366.68091",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019527",
                                    "gribparam": "175",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.04915214",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "410.25278",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-23.461668",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.34272065E-05",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.74529323E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.34272065E-05",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.74529323E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25011 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.03005534",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01572531",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.00848219",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.20168658E-06",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.03210629E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.20168658E-06",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.03210629E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "223",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "units": "unitless",
                                    "scale_min": "0.0",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "41.92942",
                                    "gribparam": "171",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.007747378",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "32.036606",
                                    "gribparam": "166",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-35.580582",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "41.55455",
                                    "gribparam": "165",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-36.319748",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "601.30786",
                                    "gribparam": "168",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "170.12061",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.10742",
                                    "gribparam": "201",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.29517",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.42285",
                                    "gribparam": "202",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.82349",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "624.72925",
                                    "gribparam": "167",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.97974",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25011"
                        },
                        "R25012": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25012",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25012/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25012/25012fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "482960.0",
                                    "gribparam": "111",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-560480.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2588.9761",
                                    "gribparam": "113",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2746.9531",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "877223.31",
                                    "gribparam": "110",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-312549.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2114.4414",
                                    "gribparam": "112",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2027.1133",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "149.30864",
                                    "gribparam": "230",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5.3901062",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "164",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.1980591",
                                    "gribparam": "231",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1781.8125",
                                        "gribparam": "178",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-73.2146",
                                        "gribparam": "179",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-654.6709",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.009277344",
                                            "gribparam": "105",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-1026.9282",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1790.8438",
                                            "gribparam": "103",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-73.2146",
                                            "gribparam": "104",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-654.6709",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.52747738E-04",
                                    "gribparam": "159",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "2.71116951E-15",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1272.6885",
                                    "gribparam": "220",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1668.8594",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "322.37012",
                                    "gribparam": "209",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "187.86011",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "327.8125",
                                    "gribparam": "208",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "184.20874",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.58057",
                                    "gribparam": "207",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.83423",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "316.69897",
                                    "gribparam": "170",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "195.09912",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "5.0930653",
                                    "gribparam": "181",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.7569294",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.8333006",
                                    "gribparam": "180",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.8743963",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "342.11035",
                                    "gribparam": "214",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.87769",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "331.323",
                                    "gribparam": "215",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.82935",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "635.38135",
                                    "gribparam": "169",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.85303",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.58057",
                                    "gribparam": "139",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "182.83423",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.38756184E-06",
                                    "gribparam": "160",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8793945",
                                    "gribparam": "204",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1013.7268",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.38599023E-06",
                                    "gribparam": "218",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "35.978516",
                                    "gribparam": "141",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25012 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109296.62",
                                    "gribparam": "134",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "45825.188",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.12243355E-06",
                                    "gribparam": "142",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "4.45393380E-06",
                                    "gribparam": "143",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1448.9688",
                                        "gribparam": "176",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-4.7123108",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "126.76147",
                                        "gribparam": "177",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-340.26489",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "891.74829",
                                    "gribparam": "146",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1531.7031",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "487.15845",
                                    "gribparam": "147",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2216.9102",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.85056706E-07",
                                    "gribparam": "182",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-8.86484486E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-2801.2188",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-63.289551",
                                            "gribparam": "107",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-1154.5693",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1450.7812",
                                            "gribparam": "101",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "0.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "55.964355",
                                            "gribparam": "102",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-383.84961",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8018755",
                                    "gribparam": "175",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.04915786",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "410.32977",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-23.437391",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.36937940E-05",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.65099373E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.36937940E-05",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.65099373E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25012 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.03067389",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01574094",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.008453883",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.02659749E-06",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.90319497E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.02659749E-06",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.90319497E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "223",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "units": "unitless",
                                    "scale_min": "0.0",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "45.97438",
                                    "gribparam": "171",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.008206341",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "38.025314",
                                    "gribparam": "166",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-45.625076",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "36.12674",
                                    "gribparam": "165",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-45.353729",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "602.68652",
                                    "gribparam": "168",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "171.89331",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.729",
                                    "gribparam": "201",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "187.20923",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.61426",
                                    "gribparam": "202",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "187.01831",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "629.81812",
                                    "gribparam": "167",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "187.09375",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25012"
                        },
                        "R25013": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "R25013",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "Conventions": "IRIDL",
                                "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM3/.History/.MONTHLY/.R25013/.griblist.html",
                                "filepattern": "/mstore/iri/forecast/data/echam/history/25013/25013fcst_%4d.01"
                            },
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "VVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "453236.81",
                                    "gribparam": "111",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-454893.0",
                                    "units": "kg m s-1",
                                    "grib_name": "VVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "VQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "VQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2339.2837",
                                    "gribparam": "113",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated meridional moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2376.4609",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "VQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "649641.88",
                                    "gribparam": "110",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal velocity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-314595.0",
                                    "units": "kg m-1 s-1",
                                    "grib_name": "UVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "UQVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "UQVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2344.5933",
                                    "gribparam": "112",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated zonal moisture flux",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1937.3984",
                                    "units": "kg m s-1",
                                    "grib_name": "UQVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "QVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "143.7459",
                                    "gribparam": "230",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated specific humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-6.2583466",
                                    "units": "kg/m2",
                                    "grib_name": "QVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "cltm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cltm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "164",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover total mean[0-1]",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "cltm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "ALWCVI": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALWCVI",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.536377",
                                    "gribparam": "231",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vertically integrated liquid water content",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "kg/m2",
                                    "grib_name": "ALWCVI",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1778.9688",
                                        "gribparam": "178",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (top)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "0.0",
                                        "units": "Wm-2",
                                        "grib_name": "rst",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "-70.909668",
                                        "gribparam": "179",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-654.37744",
                                        "units": "Wm-2",
                                        "grib_name": "rlt",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "27919.611",
                                            "gribparam": "105",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-682.84131",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0U",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "28569.141",
                                            "gribparam": "103",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-1559.8594",
                                            "units": "W/m2",
                                            "grib_name": "SRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1417295.9",
                                            "gribparam": "104",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-59920.125",
                                            "units": "W/m2",
                                            "grib_name": "TRAF0",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "59908.211",
                                    "gribparam": "129",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Geopotential",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-5387.7891",
                                    "units": "m2 s-2",
                                    "grib_name": "zg",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "u3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u*3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.81900167E-04",
                                    "gribparam": "159",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "u*^3",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "8.90759329E-16",
                                    "units": "unitless",
                                    "grib_name": "u*3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TSLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TSLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "958.58374",
                                    "gribparam": "220",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "TSLIN heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2017.3828",
                                    "units": "W/m2",
                                    "grib_name": "TSLIN",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "322.51636",
                                    "gribparam": "209",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.57715",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD5",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "328.02026",
                                    "gribparam": "208",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "181.8418",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD4",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "TD3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TD3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.87817",
                                    "gribparam": "207",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.58667",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TD3",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "317.2998",
                                    "gribparam": "170",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "deep soil temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "194.35352",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.5823364",
                                    "gribparam": "181",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-3.6576271",
                                    "units": "Nm-2",
                                    "grib_name": "tauv",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tauu": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauu",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.9693193",
                                    "gribparam": "180",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-component of Surface Wind Stress",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-4.0555048",
                                    "units": "Nm-2",
                                    "grib_name": "tauu",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "Tasmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Tasmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "343.03125",
                                    "gribparam": "214",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "maximum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.62134",
                                    "units": "Kelvin_scale",
                                    "grib_name": "Tasmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tasmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tasmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "331.23755",
                                    "gribparam": "215",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "minimum air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.58667",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tasmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "tas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "626.58154",
                                    "gribparam": "169",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "air temperature (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.60327",
                                    "units": "Kelvin_scale",
                                    "grib_name": "tas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "340.87817",
                                    "gribparam": "139",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "180.58667",
                                    "units": "unitless",
                                    "grib_name": "stemp",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "srun": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "srun",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.25793337E-06",
                                    "gribparam": "160",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "surface runoff",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "srun",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SRADSU": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRADSU",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.0227051",
                                    "gribparam": "204",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "shortwave radiation upward (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1003.7019",
                                    "units": "W/m2",
                                    "grib_name": "SRADSU",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "soilm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soilm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.2000008",
                                    "gribparam": "140",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "soil wetness",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "unitless",
                                    "grib_name": "soilm",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "SNMEL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNMEL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.11247243E-06",
                                    "gribparam": "218",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "snow melt",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "SNMEL",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "snd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "snd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "19.360352",
                                    "gribparam": "141",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Snow Depth",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m",
                                    "grib_name": "snd",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "mean sea level pressure",
                                    "gribleveltype": "102",
                                    "gribparam": "151",
                                    "Z": "Z_05",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25013 hybrid_lev P",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "pss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "109462.19",
                                    "gribparam": "134",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "46602.125",
                                    "units": "Pa",
                                    "grib_name": "pss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.75153434E-06",
                                    "gribparam": "142",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Large Scale Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prl",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "grib_name": "totprcp",
                                    "gribparam": "260",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "prc": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prc",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "3.44734872E-06",
                                    "gribparam": "143",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Convective Precipitation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.0",
                                    "units": "m/s",
                                    "grib_name": "prc",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "1454.8438",
                                        "gribparam": "176",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Net Shortwave Radiation (surface)",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-43.462997",
                                        "units": "Wm-2",
                                        "grib_name": "rss",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "138.80029",
                                        "gribparam": "177",
                                        "process": "31",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave flux",
                                        "PDS_TimeRange": "0",
                                        "calendar": "360",
                                        "scale_min": "-336.84814",
                                        "units": "Wm-2",
                                        "grib_name": "rls",
                                        "PTVersion": "0",
                                        "gribleveltype": "1"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "889.01709",
                                    "gribparam": "146",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Sensible Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1262.2461",
                                    "units": "Wm-2",
                                    "grib_name": "hfss",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "371.19263",
                                    "gribparam": "147",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Surface Flux of Latent Heat",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2309.4492",
                                    "units": "Wm-2",
                                    "grib_name": "hfls",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "1.30959052E-07",
                                    "gribparam": "182",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Evaporation",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-9.23644620E-07",
                                    "units": "m (H2O)",
                                    "grib_name": "evs",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Meridional Deriv. of Surface Pres.",
                                    "grib_name": "dpsdy",
                                    "gribparam": "274",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "dpsdx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "dpsdx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Zonal Deriv. of Surface Pres.",
                                    "grib_name": "dpsdx",
                                    "gribparam": "273",
                                    "units": "kilogram meter-2 second-2",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "clear_sky": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "clear_sky",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "upward": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "upward",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03125",
                                            "gribparam": "106",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-64549.062",
                                            "units": "W/m2",
                                            "grib_name": "SRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-10.289062",
                                            "gribparam": "107",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-14684.289",
                                            "units": "W/m2",
                                            "grib_name": "TRAFSU",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "solr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "solr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "882255.0",
                                            "gribparam": "101",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "solar flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "360",
                                            "scale_min": "-365521.0",
                                            "units": "W/m2",
                                            "grib_name": "SRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "3697670.8",
                                            "gribparam": "102",
                                            "process": "31",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "0",
                                            "calendar": "360",
                                            "scale_min": "-300281.25",
                                            "units": "W/m2",
                                            "grib_name": "TRAFS",
                                            "PTVersion": "0",
                                            "gribleveltype": "1"
                                        }
                                    }
                                },
                                "ALBEDO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ALBEDO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.8019445",
                                    "gribparam": "175",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Albedo (surface)",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.07235706",
                                    "units": "unitless",
                                    "grib_name": "ALBEDO",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "PTVersion": "0"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "PTVersion": "0"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "kilogram meter-1 second-3",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "vertical pressure velocity",
                                    "gribparam": "135",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "PTVersion": "0"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "PTVersion": "0"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "NaN",
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "gribleveltype": "100",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0"
                                }
                            },
                            "hybrid_lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hybrid_lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "gribparam": "132",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "gribparam": "131",
                                    "units": "m/s",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "410.18787",
                                    "gribparam": "130",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-23.32205",
                                    "units": "Kelvin_scale",
                                    "grib_name": "ta",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.34751969E-05",
                                    "gribparam": "138",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "vorticity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.68117149E-05",
                                    "units": "s-1",
                                    "grib_name": "rvort",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "Rv": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rv",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for moist air"
                                },
                                "Rd": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Rd",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "J/kg/K",
                                    "long_name": "gas constant for dry air"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "gribparam": "148",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.34751969E-05",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-1.68117149E-05",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "gribparam": "156",
                                    "units": "m",
                                    "fnname": "max",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "pressure",
                                    "units": "Pa",
                                    "fnname": "eexp",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s",
                                    "gribparam": "135",
                                    "history": "Z regridded on IRI FD ECHAM3 History SIX-HOURLY R25013 hybrid_lev omegahalf",
                                    "grib_name": "ua",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "logpsl": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "logpsl",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "16.256054",
                                    "gribparam": "152",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Log Surface Pressure",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.03126689",
                                    "units": "unitless",
                                    "grib_name": "logpsl",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "0.01570506",
                                    "gribparam": "133",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Specific Humidity",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-0.00855885",
                                    "units": "unitless",
                                    "grib_name": "hus",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "gravity": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gravity",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s2",
                                    "long_name": "earth\\'s gravity"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.04053094E-06",
                                    "gribparam": "155",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Divergence",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.18568857E-06",
                                    "units": "s-1",
                                    "grib_name": "div",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "gribparam": "149",
                                    "units": "meter2 second-1",
                                    "scale_max": "2.04053094E-06",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-2.18568857E-06",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "BC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "BC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "ACLCAC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ACLCAC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "2.0",
                                    "gribparam": "223",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "cloud cover",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "units": "unitless",
                                    "scale_min": "0.0",
                                    "grib_name": "ACLCAC",
                                    "PTVersion": "0",
                                    "gribleveltype": "109"
                                },
                                "AC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "AC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "wind10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "wind10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "47.258011",
                                    "gribparam": "171",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "10m windspeed",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "0.009316683",
                                    "units": "unitless",
                                    "grib_name": "wind10",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "vas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "36.788528",
                                    "gribparam": "166",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "V-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-44.740768",
                                    "units": "m/s",
                                    "grib_name": "vas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "uas": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "uas",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "39.467575",
                                    "gribparam": "165",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "U-wind at 10",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "-39.257034",
                                    "units": "m/s",
                                    "grib_name": "uas",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "td2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "td2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "601.61157",
                                    "gribparam": "168",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Dewpoint at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "170.6123",
                                    "units": "Kelvin_scale",
                                    "grib_name": "td2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "330.20801",
                                    "gribparam": "201",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "max 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.58472",
                                    "units": "unitless",
                                    "grib_name": "t2mmx",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2mmn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2mmn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "326.35962",
                                    "gribparam": "202",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "min 2m temp",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.55591",
                                    "units": "unitless",
                                    "grib_name": "t2mmn",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_max": "620.87329",
                                    "gribparam": "167",
                                    "process": "31",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "long_name": "Temperature at 2 m",
                                    "PDS_TimeRange": "0",
                                    "calendar": "360",
                                    "scale_min": "185.56567",
                                    "units": "Kelvin_scale",
                                    "grib_name": "t2m",
                                    "PTVersion": "0",
                                    "gribleveltype": "1"
                                }
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/R25013"
                        },
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "height"
                            },
                            "vqint": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "vqint",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unknown",
                                "long_name": "integrated meridional moisture flux"
                            },
                            "v": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "long_name": "meridional velocity"
                            },
                            "uqint": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "uqint",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unknown",
                                "long_name": "integrated zonal moisture flux"
                            },
                            "u": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "u",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m/s",
                                "long_name": "zonal velocity"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "grib_name": "va",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "grib_name": "ua",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Temperature",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "grib_name": "ta",
                                    "gribparam": "130",
                                    "process": "31"
                                },
                                "rvort": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rvort",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "vorticity",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "grib_name": "rvort",
                                    "gribparam": "138",
                                    "process": "31"
                                },
                                "psi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "psi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "148",
                                    "long_name": "streamfunction",
                                    "grib_name": "strm",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "grib_name": "zg",
                                    "fnname": "max",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "process": "31"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Specific Humidity",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "grib_name": "hus",
                                    "gribparam": "133",
                                    "process": "31"
                                },
                                "Div": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Div",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "s-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "long_name": "Divergence",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "grib_name": "div",
                                    "gribparam": "155",
                                    "process": "31"
                                },
                                "chi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "chi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "meter2 second-1",
                                    "history": "Boxes with less than 0.0% dropped",
                                    "missing_value": "NaN",
                                    "gribleveltype": "100",
                                    "gribparam": "149",
                                    "long_name": "velocity potential",
                                    "grib_name": "vpot",
                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                    "PDS_TimeRange": "0",
                                    "PTVersion": "0",
                                    "calendar": "360",
                                    "process": "31"
                                }
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            },
                            "M_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "member"
                            },
                            "M_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "member"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "M_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "member"
                            },
                            "P_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0"
                            },
                            "M_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "calendar": "standard"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "member"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/ensemble"
                        },
                        "ensemble_mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "standard_name": "longitude",
                                "pointwidth": "2.8125"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "standard_name": "time",
                                "pointwidth": "1.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM3/History/MONTHLY/ensemble_mean"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "R25004",
                            "R25005",
                            "R25006",
                            "R25007",
                            "R25008",
                            "R25009",
                            "R25010",
                            "R25011",
                            "R25012",
                            "R25013",
                            "ensemble",
                            "ensemble_mean"
                        ]
                    },
                    "SIXHOURLY": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM3/History/SIX-HOURLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "SIX-HOURLY",
                        "restriction": "requires dlauth tokens"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "MONTHLY",
                        "SIXHOURLY"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Forecast",
                    "History"
                ]
            },
            "ECHAM4p5": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/FD/ECHAM4p5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "ECHAM4p5",
                "restriction": "Public",
                "Forecast": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "Forecast",
                    "restriction": "Public",
                    "ECMWFSST": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ECMWF-SST",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "note": "When using the data, please include the acknowledgement: The computing for this project was provided (or partially provided) by a grant from the NCAR CSL program to the IRI",
                            "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.ECMWF-SST/.dataset_documentation.html",
                            "iridlhasSemantics": "iriref:Li_S",
                            "Conventions": "IRIDL"
                        },
                        "SST_scenarios": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SST_scenarios",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble24": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble24",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": "newton/ meter2",
                                        "missing_value": "-999.0"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": "newton/ meter2",
                                        "missing_value": "-999.0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "long_name": "Forecast Time",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "pointwidth": "1.0"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": "pascals",
                                        "missing_value": "-999.0"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "missing_value": "-999.0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "unitless",
                                        "missing_value": "-999.0"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "unitless",
                                        "missing_value": "-999.0"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at toa",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "missing_value": "-999.0"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "units": "fraction",
                                        "missing_value": "-999.0"
                                    }
                                }
                            }
                        },
                        "SST_ensemble_mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SST_ensemble_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble24": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble24",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": "newton/ meter2",
                                        "missing_value": "-999.0"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": "newton/ meter2",
                                        "missing_value": "-999.0"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "calendar": "360",
                                        "long_name": "Forecast Time",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "pointwidth": "1.0"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "-999.0"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": "pascals",
                                        "missing_value": "-999.0"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "missing_value": "-999.0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "unitless",
                                        "missing_value": "-999.0"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "unitless",
                                        "missing_value": "-999.0"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at toa",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": "W/m2",
                                        "missing_value": "-999.0"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "missing_value": "-999.0"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "meters/second",
                                        "missing_value": "-999.0"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "units": "fraction",
                                        "missing_value": "-999.0"
                                    }
                                }
                            }
                        },
                        "Z": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Z",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "long_name": "Pressure"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0",
                            "standard_name": "latitude"
                        },
                        "L": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "L",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months",
                            "gridtype": "0",
                            "standard_name": "forecast_period",
                            "long_name": "Lead Time",
                            "pointwidth": "1.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "standard_name": "longitude",
                            "pointwidth": "2.8125"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "unitless",
                            "gridtype": "0",
                            "long_name": "ensemble member",
                            "pointwidth": "1.0"
                        },
                        "S": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "S",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "standard_name": "forecast_reference_time",
                            "long_name": "Start Time",
                            "pointwidth": "0"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ECMWF-SST"
                    },
                    "asst": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "asst",
                        "restriction": "Public",
                        "SIXHOURLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SIX-HOURLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sep2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "sep2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.sep2001/.griblist.html",
                                "oct2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "oct2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.oct2001/.griblist.html",
                                "nov2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "nov2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.nov2001/.griblist.html",
                                "may2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "may2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.may2002/.griblist.html",
                                "mar2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "mar2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.mar2002/.griblist.html",
                                "jan2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "jan2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.jan2002/.griblist.html",
                                "feb2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "feb2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.feb2002/.griblist.html",
                                "dec2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "dec2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.dec2001/.griblist.html",
                                "aug2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "aug2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.aug2001/.griblist.html",
                                "apr2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "apr2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.SIX-HOURLY/.apr2002/.griblist.html",
                                "Conventions": "IRIDL"
                            },
                            "sep2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sep2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02369691",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100.541",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8454.8711",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-814.09155",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.0",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-403.40381",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.068115",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2031.1562",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2420.2266",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.25",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-403.40381",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.935303",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-96.768417",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.054245",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-749.04761",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.147461",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.0189714",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.4329119",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7.503911",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "8.6344156",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.64001",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "340.53094",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.55408",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "348.875",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.74563274E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-706.68433",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.19348988E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.901367",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46502.473",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112836.48",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.28300324E-07",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.15917112E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.78634377E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-484390.56",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "509471.81",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "978.32812",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-302.75366",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "82.91745",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03195572",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258551",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-929.09717",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1316.8865",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1723.9268",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "241.52393",
                                        "gribparam": "147"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-6.89350031E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.65756328E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2094.5542",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2580.5107",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-340792.62",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "695053.62",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "983.07812",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-302.75366",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "44.574326",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.27393",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.6774",
                                        "gribparam": "183"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.61873",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.63721",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01011254",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03295235",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.011106",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.94366",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62981305E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92021253E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62981305E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92021253E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY sep2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01011254",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03295235",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.37861764E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.38590428E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.37861764E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.38590428E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01415058",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.516331",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02882166",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "41.043995",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-34.856873",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.763214",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-40.969223",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.12175",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.16980469E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.05351752",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.40935",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "342.56317",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.11377",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "327.08813",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.14806",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "339.06738",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "oct2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "oct2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02203228",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "97.0998",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8482.9023",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-810.30127",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.2188",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-400.74683",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.802002",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-1957.4448",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2299.8687",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.5938",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-400.74683",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.700439",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-94.052689",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.05557251",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-747.0625",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.853271",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.1365061",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.7102699",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7.0213451",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.9920235",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "181.14819",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "341.20801",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "181.02661",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "349.04868",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.88605134E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-707.29663",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.07992673E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.987793",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46776.164",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112785.89",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.57195539E-07",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.10458347E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.64645871E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-460414.25",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "508835.19",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "977.35938",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-295.22241",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "70.311279",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03259419",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258545",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-890.92603",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1198.384",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1597.8557",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "254.5874",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-6.38937763E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.01801135E-07",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2280.9502",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2280.686",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-360390.5",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "672458.38",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "978.76562",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-295.22241",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "38.007263",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.41071",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.67343",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "194.27815",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "319.96912",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "181.02661",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "344.80453",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.85321",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "315.01315",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009740736",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03203419",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.189262",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.87601",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.58565126E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92014068E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.58565126E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92014068E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY oct2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009740736",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03203419",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.27378064E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.23643383E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.27378064E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.23643383E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01781493",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.639454",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03018009",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.720284",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-33.841614",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "35.07431",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-37.529984",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.455627",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.81825167E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.05472569",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.88918",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "337.99075",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.71666",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "324.14752",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.79305",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "334.52423",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "nov2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nov2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02195099",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "91.349518",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8504.8242",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-813.31763",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.1875",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-411.72266",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.874023",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2074.7466",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2300.6279",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.4688",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-411.72266",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.023193",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-95.060181",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.06510925",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-763.8208",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-59.332275",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.3768969",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.8446803",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.7599573",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.6744623",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.07471",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "339.87646",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.06883",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "350.53156",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.89177592E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-730.10181",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.17495074E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "17.072754",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46531.035",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112788.16",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.41172175E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.18589264E-06",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.05659876E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.80700392E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.51756296E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-461046.0",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "507801.25",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "981.1875",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-296.24609",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "63.776657",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03177311",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258644",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-935.2561",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1699.0305",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1958.4976",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "245.13257",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.83148323E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.80207346E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2260.6941",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2505.0957",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-366529.12",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "683574.56",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "981.1875",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-296.24609",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "32.215759",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.37915",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.65991",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "194.48915",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "320.0416",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.06883",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "345.9339",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.94403",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.66507",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.008954212",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.02971217",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.111877",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.25348",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.42175786E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91621493E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.42175786E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91621493E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY nov2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.008954212",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.02971217",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.26730322E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.42827673E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.26730322E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.42827673E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01585075",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "37.488258",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03440671",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.766277",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-33.275696",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "33.913086",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-35.306305",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "35.903198",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "2.79916108E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04161635",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.40092",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "335.47098",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.05199",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "326.17755",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.09607",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "335.47015",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "may2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "may2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02268085",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "101.35134",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8458.2578",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-805.75977",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1169.875",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-417.64819",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.590576",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-1810.627",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2380.5686",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1171.8438",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-417.64819",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-67.590576",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-97.054443",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.009368896",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-750.39209",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-57.69043",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.2450733",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "5.4910698",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.0852108",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.4828739",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "178.73286",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "339.703",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "178.76479",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "346.00079",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.80930169E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-735.98218",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.23571954E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "17.172363",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "47327.711",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112742.3",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.05294919E-06",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.55270857E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.47685728E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-460175.5",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "502922.94",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "968.90625",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-282.00977",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "81.45018",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03288324",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258514",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-973.62573",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1404.5789",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1614.4563",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "256.06665",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-6.45575938E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.02396484E-07",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2166.262",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2226.4883",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-316039.31",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "667932.44",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "970.17188",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-282.00977",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "47.673096",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.46811",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.25977",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "193.23495",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "319.41663",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "178.76479",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "341.909",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.56224",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.13382",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01359124",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03245457",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.402082",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.79141",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62070719E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.90237552E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62070719E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.90237552E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY may2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01359124",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03245457",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.18547507E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.25758959E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.18547507E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.25758959E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01807361",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.802582",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03341689",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "37.801003",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-35.386703",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "32.557709",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-36.726135",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.20784",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "2.65481823E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04376921",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.77348",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "340.74591",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.47511",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "328.30576",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.53017",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "336.63055",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "mar2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mar2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02092659",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100.37366",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8459.9219",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-809.87915",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1179.2188",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-416.10107",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.513672",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2221.127",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2266.5801",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.8438",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-416.10107",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.201172",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-99.271332",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.01947021",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-741.67822",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.109375",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.3640909",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.6285334",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7.3651667",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "8.413579",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.62958",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "339.54669",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.63219",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "347.69504",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.77705226E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-730.26562",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.28964894E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "17.050781",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46515.105",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112935.03",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.06352172E-06",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.91412437E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.62630428E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.56440149E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-474417.56",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "518819.19",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "984.1875",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-296.59326",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "77.221848",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03155754",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258539",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-854.45996",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1805.426",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2318.238",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "239.09888",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-9.26998553E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.56092094E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2032.45",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2188.0452",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-348064.38",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "717521.06",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "984.1875",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-296.59326",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "54.60672",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.42003",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.6062",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "195.02078",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "319.58698",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.63219",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "343.31613",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.50362",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.41003",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01531013",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03264626",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.176682",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.77588",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.59884912E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.88163303E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.59884912E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.88163303E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY mar2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01531013",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03264626",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.36894539E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.28596105E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.36894539E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.28596105E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0159791",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "42.27898",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02674647",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "42.813232",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-35.251785",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "37.360947",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-42.186966",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.328003",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.03914973E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.03910954",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.76421",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "341.79041",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.7029",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "329.12115",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.75308",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "336.15546",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "jan2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "jan2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02704778",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "99.05706",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8457.8008",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-810.58423",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.1875",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-411.1792",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.566406",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2064.3323",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2299.7405",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.5312",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-411.1792",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.566406",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-93.540085",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.05239868",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-760.85596",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.435791",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.4310846",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.2612991",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.8249741",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.5346527",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.83926",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "341.70184",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.79222",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "349.86002",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.90316405E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-723.51343",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.30294939E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.998535",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46702.785",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "113060.6",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.41172175E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.09270434E-06",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.96745236E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.49077924E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.68647409E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-463740.62",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "496806.38",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "983.51562",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-314.95898",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "80.493744",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03236537",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258587",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1032.5278",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1547.8467",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1624.7356",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "238.63062",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-6.49686342E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.54233599E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2131.4304",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2284.9915",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-357191.88",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "666316.19",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "983.51562",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-314.95898",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "46.585953",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.38565",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.6785",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "195.19817",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "319.1582",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.79222",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "345.82489",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.92708",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.04733",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009485044",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03199366",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-21.953468",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.57355",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62666965E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.70162366E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62666965E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.70162366E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY jan2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009485044",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03199366",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.30605565E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.26322118E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.30605565E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.26322118E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02115323",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "37.692329",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03339912",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.737904",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-34.371262",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "35.957397",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-34.347733",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.203125",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.84435701E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.041143",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.48193",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "344.71381",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.08356",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "328.38965",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.25795",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "337.98111",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "feb2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "feb2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03488032",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "99.846771",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8455.1797",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-813.09912",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1179.7812",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-397.24756",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.805908",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2247.2288",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2203.4553",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.1875",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-397.24756",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.860596",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-95.238434",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.01913452",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-753.16504",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.475342",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.4546604",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.4612103",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.9264154",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.6453075",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.87392",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "340.32678",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.81883",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "348.68488",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.73317585E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-735.54175",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.23851351E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.998535",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46560.832",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112875.64",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.37710695E-07",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.04583489E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.62630428E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.50068547E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-445982.81",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "496051.56",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "979.3125",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-277.52539",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "84.088242",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.0311103",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258545",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-856.79688",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1366.1519",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1703.7241",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "238.58105",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-6.81271615E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.54036636E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-1809.0818",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2185.7769",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-350935.25",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "664182.56",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "980.625",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-277.56885",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "49.658936",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.38564",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.67847",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "194.97694",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "320.0224",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.81883",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "344.43097",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.70685",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.1283",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01137783",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03360097",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.187309",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.76309",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.61985918E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.85822773E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.61985918E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.85822773E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY feb2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01137783",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03360097",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.38839561E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.26970610E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.38839561E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.26970610E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01536447",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.656155",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02947626",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.055088",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-37.634888",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "37.456253",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-37.424118",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "38.367371",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.75571254E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04436133",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.55582",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "341.68939",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.24422",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "328.03485",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.2849",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "337.36197",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "dec2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dec2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03557465",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "92.073624",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8489.2148",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-812.79492",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.0938",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-408.59521",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-73.749023",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2118.4343",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2453.8953",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.2812",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-408.59521",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.573242",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-91.146027",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.08717346",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-746.68018",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-63.656494",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.9358654",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.397995",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7.0853472",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "8.6395912",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "183.15521",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "341.13153",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.9679",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "348.00699",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.67187579E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-735.00732",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.26363011E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "17.081543",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46447.082",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112766.77",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-5.29395617E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.40657571E-07",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.07052426E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.80700392E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.54814097E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-488946.94",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "505826.25",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "985.25",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-290.83179",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "77.640167",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03202488",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258549",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-874.28247",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1383.1174",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1499.7095",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "254.64087",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-5.99691873E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.01822934E-07",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2342.7966",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2289.6626",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-382793.56",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "652948.62",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "985.25",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-290.83179",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "38.681763",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.38374",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.67249",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "196.28421",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "318.47131",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.9679",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "343.60812",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.90562",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.66095",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01055825",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03030396",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.004139",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.06427",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.50287642E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.87862588E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.50287642E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.87862588E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY dec2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.01055825",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03030396",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.37937661E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.37325298E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.37937661E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.37325298E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01584013",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.124069",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0237495",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "41.731964",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-34.219193",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.452301",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-35.024048",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.749634",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "3.52528815E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04341219",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "186.1965",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "339.62634",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "185.91681",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "327.91937",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "185.94714",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "338.0726",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "aug2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aug2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01789523",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "98.627937",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8454.8867",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-804.1272",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1169.9062",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-402.04858",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.137695",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-1755.1604",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2748.3533",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1172.3438",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-402.04858",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.132324",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-96.058121",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.008560181",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-749.34399",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-61.129639",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.2699871",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "5.8405657",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.5451746",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.1268787",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "181.30821",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "340.80145",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "181.18692",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "349.67676",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.73226488E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-676.07812",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7168884",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.39148324E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.913086",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "47520.363",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112918.14",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.12964665E-06",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.07356766E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.80700392E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.52658311E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-459463.94",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "473930.75",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "964.21875",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-289.14624",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "83.518982",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.03160577",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.25857",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-967.3894",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1555.7266",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2187.0928",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "275.37305",
                                        "gribparam": "147"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-8.74557202E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.10111927E-07",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2310.3999",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2661.9663",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-338603.44",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "680255.56",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "968.32812",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-289.14624",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "47.128067",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.27872",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.66962",
                                        "gribparam": "183"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.64293",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.47345",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009193584",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03196654",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-20.251757",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.93295",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62243377E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92037551E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.62243377E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.92037551E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY aug2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009193584",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03196654",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.23289680E-06",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.21615664E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.23289680E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.21615664E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.01865815",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "39.309048",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.03494264",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "40.877903",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-34.906662",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "34.587128",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-37.760162",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "36.860809",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "2.75820398E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04707075",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.89082",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "342.06573",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.77397",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "328.68161",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "184.80574",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "341.6304",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "apr2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "apr2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vertically integrated specific humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02459955",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100.46806",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum height of convective cloud tops",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "8477.4883",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (top)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-800.5625",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1165.4062",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-403.13745",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.485352",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-2131.5298",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2519.9031",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.0625",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-403.13745",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.000977",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Geopotential",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "TSLIN heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-94.686401",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.009674072",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "longwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-741.37354",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "-59.938477",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-5.3738956",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "6.3319511",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-6.7149887",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "7.8551531",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "air temperature (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.45923",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "340.00369",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.45122",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "346.99146",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "surface runoff",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.90132823E-06",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-721.07202",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil wetness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "snow melt",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.23851351E-06",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.952148",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice depth",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sfc roughness",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "sea ice cover",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "46750.191",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "112855.17",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Snow Fall",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.80280561E-07",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Large Scale Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "2.20188167E-06",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Convective Precipitation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-1.53595383E-23",
                                        "grib_name": "prc",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.72678222E-06",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Primary wave mean period",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-455568.81",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "504181.31",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "948.26562",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave flux",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-280.39526",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "81.313919",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "land-sea mask",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Log Surface Pressure",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.0317284",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "16.25852",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1013.5713",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "1431.041",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1967.2639",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "238.1958",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vegetation type",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Evaporation",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "24",
                                        "scale_min": "-7.86653800E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "9.52467474E-08",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-1987.9719",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "2117.3147",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-366108.75",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "692607.75",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "solar flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "948.26562",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-280.39526",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "49.933517",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Albedo (surface)",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "8",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "PTVersion": "128",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temp level CL",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "209.53712",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "310.49008",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "193.93007",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "319.547",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "180.45122",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "342.85083",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "deep soil temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "208.74364",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "PTVersion": "128",
                                        "gribleveltype": "111",
                                        "scale_max": "314.63263",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009347893",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "scale_max": "0.03162933",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-22.370047",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "410.88324",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "vorticity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.59607007E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.89484126E-05",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-1.59607007E-05",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "1.89484126E-05"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "1"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst SIX-HOURLY apr2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "gribleveltype": "109"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Specific Humidity",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-0.009347893",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03162933",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Divergence",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.38020630E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.35597895E-06",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-2.38020630E-06",
                                        "PTVersion": "128",
                                        "gribleveltype": "109",
                                        "scale_max": "2.35597895E-06"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "10m windspeed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.008328676",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "40.846344",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "maximum 10m wind speed",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "0.02697593",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "41.234123",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "V-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-35.419174",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "35.488831",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "U-wind at 10",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "-39.464005",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "35.195572",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Dewpoint at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "2.82435053E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04385199",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "max 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.38966",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "340.75372",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "min 2m temp",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.08791",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "327.32294",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "long_name": "Temperature at 2 m",
                                        "calendar": "standard",
                                        "subcenter": "255",
                                        "process": "50",
                                        "gribNumBits": "16",
                                        "scale_min": "182.1909",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "PTVersion": "128",
                                        "gribleveltype": "105",
                                        "scale_max": "335.41809",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "T_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "454.75"
                            },
                            "S_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "484.75"
                            },
                            "S_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "515.75"
                            },
                            "S_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "333.75"
                            },
                            "S_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "272.75"
                            },
                            "S_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "576.75"
                            },
                            "S_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "607.75"
                            },
                            "S_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "545.75"
                            },
                            "S_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "333.75"
                            },
                            "S_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "1.0"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "1.0"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "303.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "modulus": "360.0",
                                "pointwidth": "2.8125"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/SIX-HOURLY"
                        },
                        "apr2002": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/apr2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "apr2002",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc24_%6d.01",
                                    "mem24year0": "200210",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc23_%6d.01",
                                    "mem23year0": "200210",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc22_%6d.01",
                                    "mem22year0": "200210",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc21_%6d.01",
                                    "mem21year0": "200210",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc20_%6d.01",
                                    "mem20year0": "200210",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc19_%6d.01",
                                    "mem19year0": "200210",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc18_%6d.01",
                                    "mem18year0": "200210",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc17_%6d.01",
                                    "mem17year0": "200210",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc16_%6d.01",
                                    "mem16year0": "200210",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc15_%6d.01",
                                    "mem15year0": "200210",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc14_%6d.01",
                                    "mem14year0": "200210",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc13_%6d.01",
                                    "mem13year0": "200210",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc12_%6d.01",
                                    "mem12year0": "200210",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc11_%6d.01",
                                    "mem11year0": "200210",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc10_%6d.01",
                                    "mem10year0": "200210",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc09_%6d.01",
                                    "mem09year0": "200210",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc08_%6d.01",
                                    "mem08year0": "200210",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc07_%6d.01",
                                    "mem07year0": "200210",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc06_%6d.01",
                                    "mem06year0": "200210",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc05_%6d.01",
                                    "mem05year0": "200210",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc04_%6d.01",
                                    "mem04year0": "200210",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc03_%6d.01",
                                    "mem03year0": "200210",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc02_%6d.01",
                                    "mem02year0": "200210",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.apr2002/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri/forecast/data/echam4/asst/apr02/30008fc01_%6d.01",
                                    "mem01year0": "200210",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03627859",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.148956",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8523.2344",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-783.91235",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1161.2188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-395.60986",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-77.218018",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1749.3152",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1952.9929",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.2812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-395.60986",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.280029",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.007629",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009674072",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.64282",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.735596",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.681591",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.8996019",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.1196175",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.3276234",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.39154",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "339.10242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.40321",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.46848",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21048492E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-696.64722",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.21051562E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.487793",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47201.867",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112165.81",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.45708838E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.81813107E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.53595383E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.38858570E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-428172.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "447176.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "936.65625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-238.60886",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "67.148941",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03145241",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258434",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-658.01636",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1097.7483",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1340.1887",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "181.70947",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.35903951E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.26613223E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1596.1526",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1775.0283",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-243549.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "671596.56",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "936.65625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-238.60886",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "34.822845",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.24059",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.89545",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.8936",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.745",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.40321",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.71066",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.38182",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.79504",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00486014",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02996711",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.880489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52521",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58640032E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83171051E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58640032E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83171051E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00486014",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02996711",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.02520437E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99295164E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.02520437E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99295164E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02652667",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.811302",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04409317",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "38.089733",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.837341",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.605087",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-37.231339",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.047394",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.45237116E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03597466",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.34941",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.41708",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.8222",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.03113",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.85246",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.69202",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02459955",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "98.870628",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8489.6484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-785.60938",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1163.25",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-391.51099",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-70.525146",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1562.1396",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1973.1355",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.7812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-391.51099",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-70.345459",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-93.312469",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008773804",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.27197",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.866455",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.8795147",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.0811443",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.5557623",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.9474549",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.69714",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.76422",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.4045",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.99146",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.12399584E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-691.95386",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.01423939E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.666016",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47578.738",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112444.18",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.29395617E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.06403739E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.81027406E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.72678222E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-418921.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "478715.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "928.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-253.49649",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.708206",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03004393",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258476",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-671.32617",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "968.99951",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1346.0564",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "177.54761",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.38250220E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.09968901E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1488.7334",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1907.3376",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-278086.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "659325.94",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "934.34375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-253.49649",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "31.810074",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.54117",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.1088",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.60117",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.90411",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.4045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "342.85083",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.77115",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.00952",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004564557",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03162933",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.868237",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.53522",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54397985E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85088866E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54397985E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85088866E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004564557",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03162933",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.00627119E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08002939E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.00627119E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08002939E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0258178",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.2225",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0533101",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.830452",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.678604",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "35.488831",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.585358",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.946671",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.63529872E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03707661",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.54939",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.94232",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.15999",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.8736",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.34132",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.83789",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03901024",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.237259",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8518.1172",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-796.3855",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1165.2188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.97974",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.356201",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1959.1589",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1790.9146",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.2188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.97974",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.264648",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.979904",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009033203",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.62598",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.94751",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7121153",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.5417352",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6751099",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.266324",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.9631",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.53479",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.92494",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.51178",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21613698E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-717.16406",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.10856490E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.675049",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47204.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112657.03",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.31466707E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "2.02944443E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.29403702E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-401384.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "474824.69",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "941.8125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-263.42773",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "72.966461",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0317284",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258392",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-684.42505",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1040.2339",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1374.7517",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "180.03101",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.49724689E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.19887794E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1458.5359",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1781.7429",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-330238.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "638178.06",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "941.8125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-263.42773",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "39.817215",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.42857",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.55554",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.20354",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.40216",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.92494",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.63873",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.36971",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.633",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003462188",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02848081",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.848389",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.172",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57988052E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79769013E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57988052E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79769013E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003462188",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02848081",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.86073805E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92335301E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.86073805E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92335301E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02709888",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.299248",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04974181",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.7356",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.605194",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.658203",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.49054",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.974091",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.71530717E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.04020831",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.4312",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.74847",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.35759",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.93115",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.38605",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.02142",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05193512",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.193306",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8514.5273",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-791.61987",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1162.625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-393.9856",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-77.386963",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2131.5298",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2361.949",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.4688",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-393.9856",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-77.914551",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.691818",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.00869751",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-735.83325",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-67.147217",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.8210649",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.7531404",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.7149887",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.11022",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.64415",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.21466",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.6779",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.43146",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21365656E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-699.73999",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.007568359",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13327405E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.558594",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47104.195",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112054.72",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.61122999E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "2.14566739E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.31836134E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-425286.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "424593.75",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "930.92188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-280.39526",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "63.459305",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0312387",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258366",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-671.30151",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "992.51001",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1160.9504",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "192.29883",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.64231562E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.68964128E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1716.2632",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2074.7163",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-264486.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "662644.06",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "935.89062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280.39526",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "34.862076",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.0269",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.05298",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "198.17204",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.36807",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.6779",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.3299",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.48401",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.41125",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004848529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03123225",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.908205",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.60532",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58919065E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74960969E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58919065E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74960969E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004848529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03123225",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.38020630E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01945295E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.38020630E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01945295E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02733697",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.300312",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05433573",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.80513",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.950668",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.754959",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.846085",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.593246",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.07414564E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.04052566",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "189.24924",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.5033",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.90219",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.32294",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.99925",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.67578",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03993061",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.478439",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8551.4805",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-799.625",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1163.5938",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.22192",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.358887",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1906.9905",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2017.6917",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.9375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.22192",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.263916",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.491119",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009307861",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.0459",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.047607",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9627523",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "3.5000877",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.6572523",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.3679981",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.15778",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.60889",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.10625",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.93671",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16216586E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-666.73267",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.04919309E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.36084",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47365.758",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112171.95",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.89317185E-30",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.31122782E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.49681171E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.17455236E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.37232962E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-446191.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "419767.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "933.03125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-271.46289",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.684296",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03104872",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-768.89673",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "826.32861",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1248.8982",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "164.29199",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.99399448E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "6.56962698E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1917.4736",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2077.2239",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-300193.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "608946.44",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "944.32812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-271.46289",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "27.995422",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.53712",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.68164",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.61838",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.0072",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.10625",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.31171",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.74364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.17139",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003853964",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0306637",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.168953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.46375",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.51836630E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83732573E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.51836630E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83732573E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003853964",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0306637",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.97706777E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14203692E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.97706777E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14203692E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02983372",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.757587",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06051524",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.702366",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.879715",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.732941",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-37.565506",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "31.400482",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.95735052E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03807382",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.07111",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.68628",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.87204",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.08368",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.9476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.92078",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04303698",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "91.348541",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8518.6367",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-791.41797",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1161.6875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.4873",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.300293",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1829.8682",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2519.9031",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1166.0625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.4873",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.139893",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.323959",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009353638",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.74146",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.243164",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.3234224",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "3.9024134",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9026203",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.7632637",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.89685",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.10349",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.92517",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.39465",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.38701523E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-686.06421",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.18056778E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.715088",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47515.355",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112756.33",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.36156358E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.76309857E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.21796120E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-435120.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "434923.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "941.3125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-240.2489",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "66.15358",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03112894",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.85156",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1397.8811",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1967.2639",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "238.1958",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.86653800E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.52467474E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1964.3911",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1944.5405",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-325653.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "633899.62",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "941.3125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-240.2489",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "27.15155",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.42233",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.88522",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.79343",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.63763",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.92517",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "336.54309",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.6938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.68109",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004232366",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0282158",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.274216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.41989",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56099177E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88040704E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56099177E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88040704E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004232366",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0282158",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.14717397E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07267226E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.14717397E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07267226E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03041011",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.078278",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05671916",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.456184",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.958847",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.42749",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.305099",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.64502",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.91974639E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03492945",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.84273",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.84106",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.27533",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.23157",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.32986",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.50275",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04101126",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.08596",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8517.9258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-795.42065",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1162.7812",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.59009",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.104736",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1879.8738",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1765.1277",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.5",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.59009",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.770752",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.306839",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008514404",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.01147",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.274902",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.9795876",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.0742331",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6609936",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.7626929",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.20239",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.75903",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.19865",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.96436",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26150780E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-682.03784",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.11089321E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.48584",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47372.73",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112412.98",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.80280561E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.82562815E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.42301546E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.41785449E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-405300.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "445482.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "935.625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-261.18237",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "68.358765",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02915773",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-670.43408",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "910.98022",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1222.5098",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "189.11572",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.88847377E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.56198233E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1809.4314",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1940.5793",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-279403.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "617394.94",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "939.40625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-261.18237",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "35.083038",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.31544",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.24707",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.03979",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.89798",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.19865",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.84131",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.29239",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.8855",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.009347893",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02819964",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.509649",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.24139",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59207593E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85462322E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59207593E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85462322E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.009347893",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02819964",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.30564160E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99038300E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.30564160E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99038300E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03575553",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.519421",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06431341",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "39.117733",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.087845",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "32.360046",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.896317",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.919983",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.42359864E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03680121",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.97688",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.64795",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.75427",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.30072",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.79369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "332.88184",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03659699",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "91.45507",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8478.5781",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-789.28467",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1165.4062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-403.13745",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.934814",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1763.4604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2135.2605",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.4062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-403.13745",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.802002",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-94.315781",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009628296",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-724.73218",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.289307",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.2230682",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.4407997",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3103552",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.5759048",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.9525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.99298",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.99185",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.26096",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.38229086E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-681.73511",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.21787889E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.054932",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47501.148",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112417.41",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.73161534E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.34387436E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.65268671E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.48465142E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-406743.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "454053.81",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "933.15625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-259.73657",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.648773",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03131089",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258379",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1013.5713",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "945.7251",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1156.6265",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "234.76685",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.62502555E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.38796063E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1491.6008",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1783.1257",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-292513.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "618900.12",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "934.35938",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-259.74927",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "38.564148",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.12006",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.29047",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.98254",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.43365",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.99185",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.2258",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.15858",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.31189",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005203657",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02928355",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.93755",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.37985",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54989884E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84380242E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54989884E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84380242E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005203657",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02928355",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.87245678E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09458972E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.87245678E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09458972E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.01902881",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.852341",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02697593",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.432152",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.586624",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.730209",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.359894",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.91304",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.39119548E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03849806",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.42506",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.10727",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.16843",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.46802",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.18327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.5845",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03239161",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.549843",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8500.6445",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-789.12158",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.5",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-389.7981",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.656494",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1713.4277",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2001.5286",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.3125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-389.7981",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.609619",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-91.70575",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.007965088",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.00806",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.253662",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.5865507",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.8119993",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.2396288",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.839942",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.91658",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.46707",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.91646",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.49811",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32915170E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-683.03857",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13769784E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.598145",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47152.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112855.17",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.95789652E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.55087707E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.22410574E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-425969.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "430210.94",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "948.26562",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-268.26147",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "67.848679",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03080785",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258408",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-679.92188",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "983.68506",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1472.9768",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "194.36865",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.89002184E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.77248488E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1491.8547",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2012.9202",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-289958.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "672495.81",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "948.26562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-268.40674",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "31.856934",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.04552",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "308.94559",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.92912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.29572",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.91646",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.53717",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.03236",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.14557",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00685313",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0308288",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.550734",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44028",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59032097E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78370283E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59032097E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78370283E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00685313",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0308288",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17917909E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08066422E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17917909E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08066422E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.030589",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.769672",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05507858",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.384418",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.80603",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.067093",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.449051",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.757095",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.26239816E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03630194",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.3307",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.60797",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.02136",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.73172",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.10753",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.3573",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03512947",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "100.46806",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8532.1406",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-791.06079",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1163.2188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.6377",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.414062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1658.48",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1708.9458",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.4688",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.6377",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.015625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-93.38382",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009597778",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-726.83887",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.031494",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.6341724",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.1077127",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.7169638",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.5309181",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.79463",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.33118",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.66354",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.00107",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.13905014E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-661.37329",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13921124E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.263184",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47589.035",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112449.95",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.73161534E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.84967199E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.63506809E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.41709393E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-429263.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "443231.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "934.65625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-250.80386",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "81.313919",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0310252",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25843",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-668.72168",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "920.37378",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1399.1733",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "177.8042",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.59490218E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.11006862E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1769.1882",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2020.4529",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-270233.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "639934.38",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "934.65625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-250.80386",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "33.340561",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.14941",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.4931",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.11737",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.8653",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.66354",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "339.56747",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.08759",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.23611",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006514385",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02911441",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.62188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.48895",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.53734727E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79654198E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.53734727E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79654198E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006514385",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02911441",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93231745E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91183608E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93231745E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91183608E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02065541",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.911312",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03317188",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.822472",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.635101",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "32.127365",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.80304",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.041702",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.54388535E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03778274",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.39259",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.87418",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.12982",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.50183",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.14215",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.18787",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03991813",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.80703",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8478.4922",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-796.3291",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.0312",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-388.91406",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.125244",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1769.2209",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2134.2803",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.4375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-388.91406",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.203369",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.282913",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009063721",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-719.47925",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.636475",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.820097",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.0618095",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.7108974",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.5767136",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.72482",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.76776",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.66173",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.33371",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.42156318E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-672.96509",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.14142313E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.390137",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47450.312",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112781.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.31981004E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.58916282E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.44842688E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.35959681E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-446407.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "441880.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "936.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-262.77661",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "74.054825",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0306636",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25841",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-688.20801",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1431.041",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1684.8704",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "220.57275",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.73732472E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.81977940E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1546.7065",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1931.6453",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-262044.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "626748.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "938.42188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-262.77661",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "43.645691",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.1292",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.30124",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "194.55466",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.10046",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.66173",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.13254",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.04555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.30353",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004902184",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0279946",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.910177",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.46445",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57638096E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77908714E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57638096E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77908714E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004902184",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0279946",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17015122E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03396576E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17015122E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03396576E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02179695",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.436974",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04707358",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.050003",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.678802",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.154251",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.379028",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.853104",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.78490803E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03589486",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.37177",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.18732",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.19308",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.44824",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.23666",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.66223",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04660582",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.247231",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8505.375",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-795.10913",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.5625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.86523",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.751221",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1899.8164",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2200.6743",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.3438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.86523",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-80.266357",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-85.037994",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008621216",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.65137",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.773438",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.6645813",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.7966251",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.5465584",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.7632618",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.36566",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.06784",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.33679",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.02118",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29361945E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-695.34595",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.00216130E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.952148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47415.652",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112783.51",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.85005773E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "2.03751301E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.48257038E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-412242.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "405432.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "931.03125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-263.08301",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.1082",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03056035",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258505",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-679.29565",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1200.5361",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1627.3806",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "210.34863",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.50743914E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.41111500E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1784.1311",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2063.4109",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-285209.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "677776.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "934.26562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-263.08301",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "48.600586",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.90398",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.49008",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.05373",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.547",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.33679",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.34927",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.39993",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.63263",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005137093",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03089631",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.161226",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.88324",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57203394E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79652543E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57203394E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79652543E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005137093",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03089631",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.34894856E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06611776E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.34894856E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06611776E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02290366",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.765766",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04388163",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.213707",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.342178",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.078171",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.579636",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.435272",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "9.91271349E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03760876",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.8206",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.04352",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.69492",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.58325",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.7612",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.6532",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03350377",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.62442",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8489.25",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-789.87524",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1160.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.28662",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-70.485352",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1813.7671",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1827.5251",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.28662",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-70.000977",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-94.13559",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008117676",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-707.68945",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-60.600098",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3738956",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.3912811",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.9379225",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.0997114",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.01407",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "335.88245",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.99878",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.53238",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.43682018E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-692.95898",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.01493788E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.852051",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47341.145",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112107.55",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.74535181E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.76682488E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.29734769E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-402245.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "466009.69",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "932.07812",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-267.49561",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "69.782166",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03094661",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-735.02173",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1160.1282",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1693.8923",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "220.323",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.77340154E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.81014728E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1980.5737",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1990.6643",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-271278.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "687383.38",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "937.51562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-267.57275",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "49.933517",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.01451",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.99512",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.99687",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.29434",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.99878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.298",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.87514",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.84189",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004026297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0288512",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.71361",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44614",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52403691E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79802464E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52403691E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79802464E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004026297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0288512",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99249325E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.35597895E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99249325E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.35597895E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02764439",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.331028",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05633492",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.509285",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.150391",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.73587",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.612488",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.025803",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.24204680E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03579079",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.1768",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.34943",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.77364",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.72528",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.78525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.33856",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03720867",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.61869",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8522.0195",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-798.46289",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.9062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.76733",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.369629",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1596.5273",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2101.7866",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.9062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.76733",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.268066",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-94.686401",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009063721",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-741.37354",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.908203",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2028971",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.3305235",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1441755",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.7074299",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.92404",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "340.00369",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.83701",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.30737",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.51408915E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-659.08472",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.11915870E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.521729",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47712.27",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112672.03",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.02525767E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.55532143E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.41776218E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-419532.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "500458.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "941.85938",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-277.8501",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "73.006409",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02986393",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.2584",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-674.71387",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1123.5544",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1254.6582",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "180.86841",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.01702743E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.23287314E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1987.9719",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1941.0579",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-294780.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "623320.62",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "941.85938",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-277.8501",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "37.302933",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.62575",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.58456",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.82095",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.60635",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.83701",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "339.35034",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.46455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.55206",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005938847",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02857718",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.693485",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.42438",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59607007E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73115805E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59607007E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73115805E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005938847",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02857718",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.00608861E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99695364E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.00608861E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99695364E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.022109",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.839085",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04956756",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.616554",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.331299",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.403442",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.299744",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.720612",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "9.37129130E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.04346215",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.715",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.97134",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.43599",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.61786",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.59218",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "334.05447",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03777539",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "99.510597",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8518.3398",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-795.96973",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1162.375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-378.33716",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-71.991455",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1984.7434",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1787.3799",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-378.33716",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-71.439453",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.219376",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008300781",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.09741",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-60.014404",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3045835",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "3.7702875",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.6601534",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "7.8551531",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.50195",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.46753",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.49174",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.31717",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.90132823E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-704.72192",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "9.98668838E-07",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.37207",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47414.613",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112237.09",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.86823455E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "2.20188167E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.42538920E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-399521.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "462547.25",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "934.42188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-240.73732",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "68.856064",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03094104",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258411",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-666.58618",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1293.427",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1511.0798",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "223.21021",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.04238551E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.97854511E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1555.9319",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1788.0273",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-272088.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "648743.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "936.07812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-240.73732",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "45.56308",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.15417",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.07019",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.93007",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.14905",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.49174",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.24295",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.88196",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.99017",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003082571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02937465",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.801489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.13678",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.51762506E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80159186E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.51762506E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80159186E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003082571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02937465",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.83409531E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97643908E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.83409531E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97643908E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02465612",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.791508",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03899628",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.742413",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.419174",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.486847",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.569397",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.258606",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.32324994E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03996732",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.33495",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.37805",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.97168",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.72763",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.17424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "332.20419",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04092359",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "92.928825",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8477.4883",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-793.91797",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1165.25",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.49365",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.770996",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1682.3726",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2122.0393",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.49365",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.143555",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.33638",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.00944519",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-725.30542",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.679443",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.7479124",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.7751904",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.84587",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.8396034",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.6019",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.16113",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.44714",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.63654",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.54419172E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-669.78906",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.17006130E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.629883",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47930.047",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112189.52",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.43198370E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.59489070E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.46801756E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-455568.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "413195.19",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "937.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-251.35263",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "69.120438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03105404",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258465",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.74805",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1195.5969",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1265.1101",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "213.98291",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.05882099E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.55655173E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1965.552",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2117.3147",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-279126.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "621088.12",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "938.98438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-252.3257",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "37.453552",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.2652",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "308.95074",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.2623",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.25763",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.44714",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.35529",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.50562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.28119",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005804721",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0307179",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.633232",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.61325",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.49581674E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81226333E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.49581674E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81226333E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005804721",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0307179",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.98700627E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10568192E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.98700627E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10568192E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02998615",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.510921",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0554593",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.514301",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.356415",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.535355",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.776505",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.293869",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8.23673645E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03632406",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.54773",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.43698",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.08665",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.95065",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.29047",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "334.43665",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04529924",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.087654",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8483.0625",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-789.39795",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1165.25",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.14038",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.020996",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1692.2327",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1681.019",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.14038",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.31543",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.945618",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008407593",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.73291",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.311279",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1772776",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.9135103",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.5000591",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.8621206",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.24687",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.8284",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.15356",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.53204",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.34362563E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-681.02661",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.08283712E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.997803",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47624.996",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112344.84",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.18478191E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.95353664E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.30079809E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-447660.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "461708.75",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "929.75",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-252.59955",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "72.030655",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0300294",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258438",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-685.8335",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "903.4873",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1327.4255",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "195.05151",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.30800321E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.79946561E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1855.6016",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2049.8787",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-283919.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "653254.56",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "929.92188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-252.59955",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "49.894608",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.36423",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.80563",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.6915",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.59351",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.15356",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.76953",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.49959",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.32111",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004289951",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03023825",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.72757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.67609",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54932313E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89484126E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54932313E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89484126E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004289951",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03023825",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96906490E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01639227E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96906490E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01639227E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.008328676",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.144417",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02916894",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.457752",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.578537",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.631149",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.700165",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "35.195572",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.10924103E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.04385199",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.72069",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.81165",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.68315",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.69745",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.70293",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.04056",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02960935",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.472145",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8524.5117",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-795.90942",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1165.0",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.31934",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.928467",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1639.1538",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1646.6848",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.31934",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.701416",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.957977",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.009567261",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-721.80688",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.458008",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.068306",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.2929535",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7372818",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.6343164",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.52043",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.97156",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.4966",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.18042",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30390902E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-697.07764",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13071292E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.177734",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47361.051",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112010.8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.78131471E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.77478455E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.02773335E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.31304148E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-413983.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "460490.19",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "938.40625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-257.68359",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.888077",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03064918",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258434",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-906.18945",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1116.7324",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1611.7651",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "208.21118",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.44499778E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.32569356E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1830.343",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1836.1873",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280829.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "672246.12",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "939.70312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-260.41577",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "39.479675",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.37369",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.73892",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.08278",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.61978",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.4966",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.26636",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.66171",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.41071",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00547599",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02924974",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.673056",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44095",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55156977E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84473301E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55156977E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84473301E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00547599",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02924974",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91558252E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.12312193E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91558252E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.12312193E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03589405",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.241856",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05884494",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.397331",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.577072",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.740829",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.344696",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "31.730438",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.47391482E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03599248",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.12172",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.04614",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.7177",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.56503",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.85127",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "335.41809",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03152031",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.452423",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8524.6875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-792.68555",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.92822",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.998535",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1991.3086",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1988.6287",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.9688",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-388.31592",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.086182",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.380493",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008514404",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.02441",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.723877",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2747183",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.9546909",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.8894777",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.9654369",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.66342",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.82288",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.52245",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.48358",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.51822701E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-686.49219",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.06505468E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "13.988281",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47255.484",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112422.84",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.63959776E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.20973093E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "2.03002264E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.39890210E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-414398.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "417848.62",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "936.9375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-244.75374",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "65.463501",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03101481",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258387",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-926.44092",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "970.95654",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1546.7542",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "215.45142",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.18503691E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.61523688E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1473.1694",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2053.4302",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-338282.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "692607.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "940.64062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-244.75374",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "42.840515",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.09023",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.3031",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "198.46538",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.22241",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.52245",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.50702",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.48723",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.74503",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004641026",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02958141",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.370047",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74066",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58235071E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80325551E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58235071E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80325551E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004641026",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02958141",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.98887642E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98603902E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.98887642E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98603902E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0304443",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.085705",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05735423",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.272125",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.963074",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.338394",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.265106",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.303391",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.66074698E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03861117",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.96304",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.29993",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.82076",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.35577",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.82343",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.70093",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03605735",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.431412",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8484.7812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-793.34204",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1162.5312",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.02124",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.5896",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2065.8008",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1820.4502",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.5312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.02124",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.5896",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-92.084656",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008132935",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-728.2395",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.591553",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.5870457",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.5369625",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0982971",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "7.4924746",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.46017",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.67242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.46136",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.50153",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32606010E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-721.07202",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.07145752E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "13.136719",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46750.191",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112265.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.03751527E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.68592658E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.26971941E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-414857.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "420229.62",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "929.65625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-252.17979",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.292053",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02978467",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258486",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-699.29932",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1224.4534",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1711.7449",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "185.75684",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.84478891E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.42770681E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1374.2615",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1909.1243",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-366108.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "652938.69",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "933.34375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-255.16867",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "47.792297",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.31898",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.93039",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.86673",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.31512",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.46136",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.22833",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.55833",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.21619",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00664258",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02898406",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.839323",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68506",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54824811E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81722207E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54824811E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81722207E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00664258",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02898406",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.13638396E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02102819E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.13638396E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02102819E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02725686",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.331867",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05261023",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.813015",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.764191",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "35.189957",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.65921",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.474869",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.90056715E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03545133",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.77502",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "340.75372",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.71112",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.02145",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.71632",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "332.24335",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03307148",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "95.999802",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8517.7344",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-800.5625",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.3125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-384.76025",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-71.773438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1701.7109",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1777.4355",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.7812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.21436",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-71.240967",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-93.788239",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008590698",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-732.24341",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-59.938477",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9598465",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.936533",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.5813532",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.4304857",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.45923",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.7489",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.45122",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.16492",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.23528196E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-675.36646",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.20329787E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.682861",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47871.238",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112393.02",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.33194270E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.57240549E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.07290842E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.26654925E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-403193.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "448493.19",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "937.23438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-250.92404",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "66.230957",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03105561",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258383",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-796.92407",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1153.5298",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1357.2017",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "198.23779",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.42706914E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.92696824E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1518.8611",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1888.9104",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-294263.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "653850.81",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "937.23438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-250.92404",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "33.124527",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.21255",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.94904",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "194.28372",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.29745",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.45122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.99109",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.16824",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.55231",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006084036",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03004619",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.593603",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.30182",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56452461E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75563910E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56452461E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75563910E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006084036",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03004619",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.09166342E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90662820E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.09166342E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90662820E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0208987",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "40.846344",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0465067",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "41.234123",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.774368",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.320801",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-39.464005",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.691574",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.82435053E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03564991",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.5701",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.67444",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.44012",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.90656",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.45073",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.21817",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03059787",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.995544",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8500.1367",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-780.36084",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1164.6875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-388.36011",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.769287",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1670.3254",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1751.0156",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1165.4375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-389.68579",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.860596",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-94.332504",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008224487",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-719.37354",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.119385",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2146616",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.2608585",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9211969",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.4515162",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.06325",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.86365",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.00282",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.38202",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.80755285E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-664.71118",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.23851351E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "13.831787",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47363.723",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112688.59",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.64697809E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.36357935E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.80756581E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.41305736E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-407831.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "504181.31",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "932.25",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-248.94284",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "60.057114",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03109005",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25852",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-830.50293",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1006.416",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1490.7393",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "214.66406",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.96104883E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.58392184E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1635.9639",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2054.2886",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-270703.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "641440.31",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "932.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-249.13109",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "34.778519",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.41583",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.9881",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.52847",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.7088",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.00282",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.67108",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.51045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.3894",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006348886",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02876055",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.518559",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.12747",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55473372E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80532279E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55473372E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80532279E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006348886",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02876055",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92746711E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02011347E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92746711E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02011347E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02942631",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.736862",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04633677",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.17514",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.580399",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.543777",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.830505",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.530304",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.79083901E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03410744",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.56148",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.58167",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.81645",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.75571",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.9608",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.89062",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03254087",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "90.980011",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8541.0977",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-792.43237",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1162.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.41138",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.041992",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1879.873",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1796.2861",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.7188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.65308",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.041992",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-86.398865",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008956909",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-716.26465",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-64.669434",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3659678",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "6.3319511",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.1347218",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.1672411",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.88605",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.83447",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.82028",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.40259",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30698106E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-686.51709",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "9.56817530E-07",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.756104",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47894.355",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112576.96",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.51342008E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.68301290E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.25761460E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-416245.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "426382.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "930.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-235.70496",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.320572",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03151661",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258463",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-713.69531",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1105.3835",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1537.8005",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "201.13184",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.14923408E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.04283218E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1642.0623",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1981.9111",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-287006.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "630764.56",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "939.625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-235.70496",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "40.049561",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.91696",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.71579",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.06844",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "316.97455",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.82028",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "335.70547",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.06052",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.97717",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004304886",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02839269",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.960825",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.60532",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56024689E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82692602E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56024689E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82692602E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004304886",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02839269",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.07188782E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10166718E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.07188782E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10166718E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02530534",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.897972",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03852065",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.36945",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.203064",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.253937",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.210953",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.147354",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.36002824E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.04047823",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "182.38966",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.71124",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "182.08791",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.86108",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.1909",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.99121",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03967282",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.298286",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8523.1289",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-786.88672",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1163.9375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-400.95996",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.80835",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1835.9365",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2269.5825",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1164.9375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-400.95996",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.80957",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-94.282104",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.008407593",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-713.44287",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.012207",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0278273",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "3.7287235",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8627081",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.7300968",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.86731",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.73975",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.88388",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.27887",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.24014718E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-713.83228",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.01869227E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.643799",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47749.289",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112708.81",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.29995747E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.87066905E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.43979605E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-396976.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "437979.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "931.09375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-241.43286",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "79.032547",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03018327",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258457",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-766.79468",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1060.8723",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1480.4631",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "225.16724",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.91995786E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.00364796E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1760.2402",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1824.6965",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-267350.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "683060.44",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "943.26562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-241.43286",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "36.252975",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.61252",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.11987",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.65523",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.71252",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.88388",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.25934",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.76393",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.30414",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006617144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03126534",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.782598",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.50278",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52218881E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85910903E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52218881E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85910903E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst apr2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006617144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03126534",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88534989E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10272106E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88534989E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10272106E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02743905",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.393349",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03815768",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "34.715351",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.321854",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.394455",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.715561",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.211304",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.13231429E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03771548",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.52554",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.35016",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.38184",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.39337",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.5114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "334.19153",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2002-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "303.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/apr2002/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "aug2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "aug2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYPressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24year0": "200111",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc24_%6d.01",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23year0": "200111",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc23_%6d.01",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22year0": "200111",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc22_%6d.01",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21year0": "200111",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc21_%6d.01",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20year0": "200111",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc20_%6d.01",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19year0": "200111",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc19_%6d.01",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18year0": "200111",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc18_%6d.01",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17year0": "200111",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc17_%6d.01",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16year0": "200111",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc16_%6d.01",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15year0": "200111",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc15_%6d.01",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14year0": "200111",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc14_%6d.01",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13year0": "200111",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc13_%6d.01",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12year0": "200111",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc12_%6d.01",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11year0": "200111",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc11_%6d.01",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10year0": "200111",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc10_%6d.01",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09year0": "200111",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc09_%6d.01",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08year0": "200111",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc08_%6d.01",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07year0": "200111",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc07_%6d.01",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06year0": "200111",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc06_%6d.01",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05year0": "200111",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc05_%6d.01",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04year0": "200111",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc04_%6d.01",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03year0": "200111",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc03_%6d.01",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02year0": "200111",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc02_%6d.01",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01year0": "200111",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/asst/aug01/30000fc01_%6d.01",
                                "SIXHOURLYgriblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.aug2001/.SIX-HOURLY/.griblist.html",
                                "description": "forecast starting aug2001",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.01789523",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "98.627937",
                                        "gribparam": "230",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "8454.8867",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "gribparam": "217",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "164",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-804.1272",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "203",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1169.9062",
                                            "gribparam": "178",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-402.04858",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.137695",
                                            "gribparam": "179",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-1755.1604",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "2748.3533",
                                                "gribparam": "105",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1172.3438",
                                                "gribparam": "187",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-402.04858",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.132324",
                                                "gribparam": "188",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "gribparam": "129",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-96.058121",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "0.008560181",
                                        "gribparam": "220",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-749.34399",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "-61.129639",
                                        "gribparam": "205",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-5.2699871",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "5.8405657",
                                        "gribparam": "181",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-5.5451746",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "9.1268787",
                                        "gribparam": "180",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "181.30821",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "340.80145",
                                        "gribparam": "169",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "181.18692",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "349.67676",
                                        "gribparam": "139",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "scale_max": "1.73226488E-06",
                                        "gribparam": "160",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-676.07812",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "gribparam": "204",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7168884",
                                        "gribparam": "140",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "1.39148324E-06",
                                        "gribparam": "218",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "16.913086",
                                        "gribparam": "141",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_08",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "gribparam": "211",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "gribparam": "173",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "210",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "47520.363",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "112918.14",
                                        "gribparam": "134",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "scale_max": "1.12964665E-06",
                                        "gribparam": "144",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "scale_max": "2.07356766E-06",
                                        "gribparam": "142",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-1.80700392E-23",
                                        "units": "m/s",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "scale_max": "1.52658311E-06",
                                        "gribparam": "143",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-459463.94",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "473930.75",
                                        "gribparam": "108",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "964.21875",
                                            "gribparam": "176",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-289.14624",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "83.518982",
                                            "gribparam": "177",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "gribparam": "172",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-0.03160577",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribleveltype": "1",
                                        "gribNumBits": "16",
                                        "scale_max": "16.25857",
                                        "gribparam": "152",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-967.3894",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "1555.7266",
                                        "gribparam": "146",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-2187.0928",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "scale_max": "275.37305",
                                        "gribparam": "147",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-8.74557202E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "gribleveltype": "1",
                                        "scale_max": "1.10111927E-07",
                                        "gribparam": "182",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-2310.3999",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "2661.9663",
                                                "gribparam": "106",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-338603.44",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "680255.56",
                                                "gribparam": "107",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "968.32812",
                                                "gribparam": "185",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-289.14624",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "47.128067",
                                                "gribparam": "186",
                                                "PTVersion": "128",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "gribparam": "175",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "209.27872",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "gribleveltype": "111",
                                        "scale_max": "310.66962",
                                        "gribparam": "183",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "208.64293",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "gribleveltype": "111",
                                        "scale_max": "314.47345",
                                        "gribparam": "170",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "gribparam": "130",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "gribparam": "138",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-0.009193584",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "scale_max": "0.03196654",
                                        "gribparam": "133",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "gribNumBits": "16",
                                        "gribparam": "155",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    }
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0515791",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.502472",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8489.3477",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-787.68994",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.4062",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-396.04932",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.956299",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1390.3782",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1969.865",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0625",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-396.04932",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.276611",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-89.419418",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008499146",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-731.49487",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.97583",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.6230211",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9684801",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.209548",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2490902",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.83569",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.00549",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.77106",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.71838",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06470668E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-664.8208",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.91858542E-07",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.334717",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48363.43",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112307.42",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.92119067E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72185389E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.35525294E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39814790E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-426050.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "418790.38",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "958.57812",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-280.76025",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "72.521652",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03153695",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258421",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-789.47144",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "837.12354",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1101.0654",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "204.50122",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.40285248E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.17712191E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1463.4897",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2244.52",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-266424.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "622635.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "959.9375",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-280.76025",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.380951",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.13875",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.9024",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.23442",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.11435",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.002913667",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02878369",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.026999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.38504",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.55357629E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81051564E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.55357629E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81051564E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.002913667",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02878369",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.91086087E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84239400E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.91086087E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84239400E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02478118",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.209949",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0514927",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.221008",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.444702",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "28.744659",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-33.771286",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.82579",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8.24602466E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03604253",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.30717",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.37115",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.95168",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.19702",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "188.26764",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.0954",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03720367",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.348129",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8534.6133",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-797.84326",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.75",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-391.69604",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.762695",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1276.0691",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2142.7576",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5625",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-391.69604",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.708008",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-89.977707",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008331299",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-749.34399",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.113281",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.4691896",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7177048",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.6885023",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0899515",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.56169",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.80145",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.47786",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "341.07272",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73226488E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-663.99341",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04546780E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.595215",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48206.766",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112398.88",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.91681180E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68921872E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40481200E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-430421.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "417228.81",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "960.84375",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-248.60091",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "66.670807",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03160577",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258512",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-967.3894",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "982.91675",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1269.7117",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "183.58716",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.07722120E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.34115986E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1749.0522",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1999.9668",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-275271.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "636417.75",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "960.84375",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-248.60091",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.67305",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.38464",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89636",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.55934",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.1311",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005682319",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0286475",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.864216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.59805",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59922347E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77089441E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59922347E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77089441E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005682319",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0286475",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.84372652E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13637372E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.84372652E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13637372E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03335582",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.225739",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.071473",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.248302",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.899109",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.830734",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-37.031921",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.708282",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "4.35252616E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03675942",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.27806",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.17786",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.1416",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.75299",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.27708",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.01605",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03692907",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.323853",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8515.7695",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-793.53101",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.1562",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-400.49829",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.707275",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1539.7163",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2159.0369",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.4375",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-400.49829",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.502686",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-85.784531",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00730896",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-743.33936",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.859131",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.2901068",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3925591",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.6374302",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4800501",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.02536",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.21634",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.01198",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.56479",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13227532E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-668.19702",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13231363E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.460693",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48291.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112039.11",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.08177459E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.07356766E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36218557E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-442588.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "450630.0",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "957.5625",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-269.22876",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "72.372345",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.030943",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258387",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-936.20459",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1117.96",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1505.4851",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.03516",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-6.02001364E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.35907406E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-2310.3999",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2110.7935",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-230436.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "625885.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "957.5625",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-269.22876",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.826279",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.45621",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.75775",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.58087",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.66156",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.007422742",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03196654",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.902422",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.83179",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56539427E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84755518E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56539427E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84755518E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.007422742",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03196654",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.11200745E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04741946E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.11200745E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04741946E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03534606",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.949249",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05071428",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.748497",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.307877",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.673187",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-35.001251",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.231445",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "6.58673684E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04701485",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.73802",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "341.63062",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.22868",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.68744",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.25793",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "341.6304",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03514523",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.860741",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8459.0781",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-798.42993",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.0",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-390.24585",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.552246",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1547.145",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2017.229",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.9375",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-390.24585",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.715332",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-87.295029",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006958008",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-718.70532",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.06958",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.8384171",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8168526",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.4456549",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3837366",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.94283",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.34583",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.89653",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "343.29715",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39112865E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-666.56787",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39148324E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.364258",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47520.363",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112018.95",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.22187451E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49449102E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26136570E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-447243.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "414588.62",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "956.96875",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-254.3614",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "66.868317",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03069728",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258463",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-686.51904",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "922.63208",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1225.7649",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "192.92139",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.90149034E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.71449322E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1822.0012",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2211.522",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-248962.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "612509.5",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "960.67188",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-259.15576",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.885666",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.93272",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.3844",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.26697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.36783",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004195653",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02849989",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.933016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.91534",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.52236635E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89374841E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.52236635E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89374841E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004195653",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02849989",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.84359021E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80090649E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.84359021E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80090649E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03639754",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.792423",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06254905",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.297112",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-29.796143",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.426712",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-35.246964",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.173058",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.20778395E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03466794",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "190.26938",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.55615",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "189.54178",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.43985",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "189.77464",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.83221",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03866864",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "98.627937",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8502.2852",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-793.59009",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.0312",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-390.06738",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.714844",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1418.8621",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2034.4001",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.875",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-390.06738",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.566406",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.249756",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00692749",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-712.6687",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.05249",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.1583366",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8886576",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.4079924",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2083845",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.63857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.74167",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.61304",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "343.9483",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10779649E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-662.01245",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10222027E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.255859",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47987.711",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112612.22",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.31551631E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.77777281E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20625327E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-378904.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "434450.81",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "961.90625",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-251.00494",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "78.400284",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03053686",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258463",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-816.09888",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "971.64209",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1386.8057",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "182.36914",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.54544783E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.29262126E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1820.7454",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1875.1362",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-255317.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640387.0",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.90625",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-251.00494",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "33.920502",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.27872",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.81421",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "208.64293",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.55176",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004477467",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02860137",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.975584",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.82178",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56351362E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88245613E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56351362E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88245613E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004477467",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02860137",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.99238389E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11599604E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.99238389E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11599604E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02152784",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.066631",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0398512",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.377182",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.358337",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.424835",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.422211",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.353348",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "9.24286496E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04027221",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.08136",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.24277",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.71545",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.54608",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.96584",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.6767",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04262778",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "96.147697",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8483.4961",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-804.1272",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.1562",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-395.77783",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.622803",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1755.1604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2748.3533",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.3125",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-395.77783",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.857178",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-90.675964",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008544922",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-725.75952",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.807861",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.2699871",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6966934",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.6815405",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1877384",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "188.13304",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.2439",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "188.12976",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.54047",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16362548E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-673.37842",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6533661",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14110298E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.604248",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48373.738",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112613.75",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.32089439E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59740284E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.48676946E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20978598E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-437488.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "450934.75",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "960.96875",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-269.75439",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "67.220795",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03112814",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.25857",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-742.13574",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "907.5188",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1216.137",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "229.40137",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.86299086E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.17306977E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-2029.6868",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2240.6074",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-279580.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627778.81",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "965.17188",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-269.85059",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "25.930542",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.44554",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.23267",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.85231",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.00629",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005375572",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03047922",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.650827",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.93295",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58417952E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91357412E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58417952E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91357412E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005375572",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03047922",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97063923E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96933070E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97063923E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96933070E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.01865815",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.020447",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05361824",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.51923",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.863419",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.720856",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-33.712601",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.012161",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.22654171E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04571583",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "190.82932",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.22974",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "190.51503",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "322.69717",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "190.68375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.94482",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04029992",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.985886",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8479.9219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-791.94604",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.875",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-380.86963",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.989502",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1574.0615",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2476.8088",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.75",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-380.86963",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.012939",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-91.784912",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007598877",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-726.97412",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.281494",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.4126024",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1130314",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.5127096",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9088888",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.47401",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.21973",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.28317",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.22266",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42716851E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-660.47607",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18336175E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.377441",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48142.379",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112397.72",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.43031171E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58325292E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.26089413E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27756857E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-449838.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "452322.75",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "957.95312",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-273.94336",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "74.904404",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03086661",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258289",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-737.57422",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1134.3591",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1299.5688",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "275.37305",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.19661228E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10111927E-07",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-2308.4822",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2132.2307",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-279367.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "661374.75",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.34375",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-273.94336",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.164474",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.13966",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.28613",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.25827",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.74768",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005396057",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03098723",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.932522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70508",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.53264718E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83864886E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.53264718E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83864886E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005396057",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03098723",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.93689903E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97950067E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.93689903E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97950067E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03311963",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.041348",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05248883",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.790573",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.127609",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.967865",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.400864",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.614426",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "5.21389438E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04498143",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "189.2722",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.13983",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.91663",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.72382",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "188.93127",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.41077",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04656384",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.300041",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8536.8164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-794.40405",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.2812",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-393.19922",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.151367",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1325.6548",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2206.2202",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1172.0312",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-393.19922",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.081055",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.989639",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008285522",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-725.81079",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.629883",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.5079012",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3560152",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.6323547",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6262102",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.60263",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.15851",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.51683",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.16797",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21284927E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-659.77319",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6838379",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04965875E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.905762",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48378.395",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112639.62",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.29098645E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.86662794E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23016923E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-439614.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "473930.75",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "957.5625",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-266.25781",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "78.572922",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.02918809",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258448",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-743.8877",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1099.7068",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1300.1018",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "185.93433",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.19874277E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.43515045E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1589.5623",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1996.5566",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-291494.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627660.38",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "959.29688",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-266.25781",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.36554",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.02803",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.44403",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.17677",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.12576",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005992085",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02972812",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.006802",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.789",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.48722156E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86130055E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.48722156E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86130055E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005992085",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02972812",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.95227199E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06973345E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.95227199E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06973345E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02887729",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.402393",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04415586",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.099499",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-28.833679",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.03595",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.353516",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.628235",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "7.68371251E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03598361",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.52017",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.33044",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.07755",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.3844",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.14769",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.38599",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03757982",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.427788",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8494.6328",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-789.25269",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.8438",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-400.29956",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.322754",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1341.4268",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1929.3428",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.4688",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-400.29956",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.408691",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.91153",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008102417",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-720.39819",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.419922",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.2804918",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1886501",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.5451746",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4006453",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.78362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.76379",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.63301",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.93335",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31558113E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-666.59595",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13729038E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.489746",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48064.145",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112164.3",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.02712100E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56261217E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.03902716E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32244884E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-400468.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "460543.81",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "964.21875",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-266.47876",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "78.336655",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03146613",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258392",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-729.94092",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1555.7266",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2187.0928",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "192.21582",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.74557202E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68636710E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1770.6411",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2661.9663",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-245368.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "616549.75",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "964.3125",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-266.47876",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.741013",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.86035",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.46973",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "208.98189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.31836",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004273631",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02835153",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.146965",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74237",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58765470E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87278783E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58765470E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87278783E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004273631",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02835153",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.92746325E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05960441E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.92746325E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05960441E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03357822",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.621872",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.07019055",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.943516",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.213699",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.371399",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-36.071442",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.867691",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "3.04173291E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03541768",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.52611",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "342.06573",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.33499",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.37341",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.33957",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.763",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03781841",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.111786",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8516.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-800.62622",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.4688",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-390.55298",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.460449",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1515.8213",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1956.3811",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.3125",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-390.55298",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.569824",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-92.975861",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007247925",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-747.16357",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.129639",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.0893764",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9988155",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.7796535",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2585025",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.30821",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.69598",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.18692",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "349.67676",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11060331E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-669.08594",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01575279E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.945801",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47740.953",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112200.95",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.34864875E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.86817704E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33303115E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-379616.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "423566.5",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "954.70312",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-289.14624",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "69.33429",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03094388",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258448",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-732.65942",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "995.04443",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1501.7451",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "185.42041",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-6.00505871E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.41432302E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1955.2976",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2287.0176",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-295374.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "667537.81",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "964.45312",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-289.14624",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.952499",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.20049",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.78687",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.37515",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.79745",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.008126404",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02935555",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.127817",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65192",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.55383223E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83452175E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.55383223E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83452175E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.008126404",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02935555",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.99682904E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98379075E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.99682904E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98379075E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02516389",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.52388",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03494264",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "40.877903",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.283615",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.015488",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.667114",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.644409",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "5.39492753E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04398182",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "185.24361",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.74231",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "184.86858",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.54288",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.02313",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.32431",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04341244",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.39534",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8454.8867",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-792.27832",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.2812",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-392.06763",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.604248",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1325.8257",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2089.9668",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5312",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-392.06763",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.476318",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-91.577621",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008483887",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-744.97925",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.206543",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.7931738",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8570013",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.0254936",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5476179",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.63739",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.8371",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.52348",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.73541",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28080569E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-671.36621",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6760406",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22413621E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.394775",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48644.391",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112309.22",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.27885072E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45206798E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.62630428E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36358608E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-423705.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "430251.56",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "960.54688",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-272.30322",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "64.414673",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03115814",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258411",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-678.65991",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "886.29077",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1350.8518",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "217.31372",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.40167775E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.68948860E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1842.1414",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2125.9009",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-259423.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "610488.0",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "960.54688",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-272.30322",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.1008",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.31915",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.49884",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.47",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.26013",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005901825",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03097559",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.934704",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.59531",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58556286E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74158631E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58556286E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74158631E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005901825",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03097559",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.96881388E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84601595E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.96881388E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84601595E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03226512",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.036728",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06386524",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.823467",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.993942",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.099915",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-34.644958",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.698807",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "6.13366637E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04552379",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.83087",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.76001",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.39818",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.04449",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.39818",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.13101",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03564486",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.11174",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8515.1016",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-789.89673",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.625",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-392.23486",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.183594",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1320.4421",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2562.6748",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.6875",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-392.84131",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.183594",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.6138",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00730896",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-712.70361",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.162842",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.327013",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5054665",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.4558277",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.031085",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.57344",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.41449",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.56461",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "342.89948",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15190619E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-673.26074",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6700287",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11860572E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.913086",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48181.398",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112144.56",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.65660638E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.04605590E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30213141E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-390574.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "432374.69",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "960.01562",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-273.32959",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "79.655411",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03006638",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258377",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-702.77466",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1055.2634",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1401.0095",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "217.47656",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.60224521E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.69583801E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1774.9604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2291.647",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-270785.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635046.44",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "960.29688",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-275.37158",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "33.820465",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.88824",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.52533",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "208.96399",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.0733",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.003840312",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0281175",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.91927",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.84769",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.50277456E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80927855E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.50277456E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80927855E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.003840312",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0281175",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97284112E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09316545E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97284112E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09316545E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03696674",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.011555",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06446868",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.238159",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-34.906662",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.399948",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-37.123688",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.135361",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8.47624619E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04707075",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.95497",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.9136",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.7453",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.16156",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.79736",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.05609",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04613349",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "97.391968",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8503.543",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-798.17676",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.75",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-387.58276",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.664062",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1646.2141",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2198.6804",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.8125",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-387.58276",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.842773",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.062744",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007766724",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-721.05884",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.0354",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.7822781",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8954601",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.3011112",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0362921",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.8522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.71127",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.80034",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.41577",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19972003E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-665.6106",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16115552E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.677246",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48120.145",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112165.38",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.56876239E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.79484289E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19127185E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-403988.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "401838.69",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "955.65625",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-276.90845",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "64.116653",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03076117",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258467",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-665.71411",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1008.9993",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1384.4314",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "233.49976",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.53595385E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.33701472E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1729.8469",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2162.7825",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-273577.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "598350.38",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "957.07812",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-277.61548",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.648087",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.11128",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.19135",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.36104",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.08417",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005880672",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03161234",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.834826",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65158",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.54139525E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77415368E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.54139525E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77415368E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005880672",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03161234",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.90100195E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89693742E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.90100195E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89693742E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03310617",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.160297",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06876171",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.452457",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.196259",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.901093",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-36.485641",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.539093",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.54276165E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03426967",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.79115",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.86722",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.40823",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.8783",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "188.42776",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.74554",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03967568",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.852394",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8478.5078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-795.50439",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.8125",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-391.86255",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.137695",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1246.5061",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2439.1064",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.6562",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-391.86255",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.132324",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-85.557663",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-743.8125",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.164062",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.4239473",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0922327",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.1541491",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.7743645",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.40698",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.46368",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.42432",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "341.98102",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22391953E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-674.42578",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22393249E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.274902",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47735.629",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112351.11",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.92858338E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64604262E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29629620E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-422030.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "425384.69",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "955.57812",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-264.84058",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "74.176193",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03100655",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.25843",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-765.00415",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "955.36914",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1385.5881",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "238.27759",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.54057863E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.52805124E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1895.8816",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1897.4175",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-338603.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "619909.62",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.32812",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-264.84058",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.541702",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.5632",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.88385",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.80731",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.69614",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004879571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03103255",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.900963",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.866",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.57704853E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86239595E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.57704853E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86239595E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004879571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03103255",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.14626334E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85671058E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.14626334E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85671058E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02009317",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "39.309048",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04949378",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "40.378372",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-29.43248",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.196594",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-37.760162",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.736313",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "5.84143258E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03559441",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "184.89082",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.73474",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "184.77397",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.68161",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.80574",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.90924",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03481611",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "97.61322",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8529.7969",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-797.44556",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.5625",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-388.19971",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.275879",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1280.1138",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1853.1277",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.125",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-388.19971",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.275879",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-92.550385",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008560181",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-723.83008",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.406006",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.9519606",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.7605314",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.8483353",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.38908",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "182.98566",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.12152",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "182.98219",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.66415",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19349033E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-670.03857",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168579",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09762186E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.146484",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47991.168",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112689.19",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46262174E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40812904E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30215869E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-416350.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "419455.19",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "951.96875",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-248.24506",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "67.935791",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.0307496",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258442",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-813.79443",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "796.40723",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1319.729",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "174.1665",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.27722705E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.96421694E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1995.3215",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1890.1892",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-282437.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "620205.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "955.15625",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-248.59332",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.593384",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.17728",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.20267",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.34129",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.67273",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005055789",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0284679",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.813108",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.6091",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59209740E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82207696E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59209740E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82207696E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005055789",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0284679",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.93745200E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92124548E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.93745200E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92124548E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02283666",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.099304",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03813545",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.818707",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-29.59758",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.472214",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.49202",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.012573",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "4.87873102E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03745127",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.27261",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.62436",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "185.98476",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.96631",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.05264",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.47073",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04558111",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.092339",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8516.7188",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-795.91895",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.3125",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-387.2876",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.178223",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1466.3154",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1818.3999",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.0312",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-387.2876",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.178223",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-93.156418",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006851196",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-734.52686",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.01709",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.1710682",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5248823",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.9179029",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5852337",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.15056",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.65311",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "184.11711",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "343.74295",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24514531E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-659.69434",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6737213",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04727224E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.491455",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48447.027",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112354.61",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.72214378E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56134979E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.80700392E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38450935E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-449870.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "425841.5",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "961.01562",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-251.65804",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "70.943085",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03069667",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258476",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-756.69165",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1038.8188",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1301.1301",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "224.625",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.20285482E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.98212704E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1837.9265",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1983.928",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-296737.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "680255.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.65625",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-252.15152",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.851303",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.3338",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.53302",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.67659",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.52258",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.003838741",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02833218",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.030651",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.92191",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.54400313E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86621437E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.54400313E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86621437E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.003838741",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02833218",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97522195E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02622186E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.97522195E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02622186E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03373763",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.130836",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06036199",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.894215",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.368362",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "27.918365",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.213181",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.713669",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "5.82630548E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03743863",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "188.04436",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.349",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.74263",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.67679",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.75108",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.51392",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03517635",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.668839",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8489.3867",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-797.30176",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.9688",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-393.12793",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.209473",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1296.4817",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2333.6589",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1172.3438",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-393.12793",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.771973",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-89.627426",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-739.19214",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.5354",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.5383425",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.691494",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.9987555",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9848824",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.09326",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.914",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.04968",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.01083",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09911730E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-669.67725",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7123108",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08807581E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.861084",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48052.77",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112509.86",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.12655435E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32940966E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27027931E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-431171.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "452631.81",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "962.57812",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-267.03491",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "70.165039",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03109925",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258337",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-792.6543",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "924.44702",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1332.509",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "206.58179",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.32832985E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.26071300E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-2048.1848",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2205.4263",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-231804.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "602698.62",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "962.57812",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-267.03491",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.433105",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.31403",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05475",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.47182",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.07916",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004782464",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02999657",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.101488",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.48999",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.62243377E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87354763E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.62243377E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87354763E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.004782464",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02999657",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.88952367E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21377854E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.88952367E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21377854E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03202853",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.950382",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05985192",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.857407",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.390259",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.587128",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-33.839127",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.385681",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "7.58664100E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04277638",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.50656",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.29031",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.15089",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.3772",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.15295",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.47058",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03832833",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "90.852272",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8535.9062",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-791.5813",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.9062",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-386.7373",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.259277",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1475.4744",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2404.1624",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.7812",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-386.7373",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.759277",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-89.694946",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007583618",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-735.31592",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.179199",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.6686745",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2017612",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.9405413",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6369982",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.05103",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.61963",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.0751",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "343.34119",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33110882E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-668.64185",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33135472E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.026855",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48038.598",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112239.06",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.04293405E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58471107E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52658311E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-424241.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "426823.94",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "955.32812",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-286.44507",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "67.942307",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.02993716",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258459",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-719.15576",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1263.5232",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1547.1462",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "261.24585",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-6.18660408E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04467063E-07",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1875.719",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2311.5061",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-259819.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "628105.12",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.3125",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-286.44507",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.897003",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.23271",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.09015",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.54002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.16748",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.009193584",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03132462",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.965832",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.84216",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56791048E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82082113E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56791048E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82082113E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.009193584",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03132462",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.04300068E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21615664E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.04300068E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21615664E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.04265173",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.745544",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06084841",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.155041",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-28.288895",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.214691",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-34.096786",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.773941",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.41364865E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03507928",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "190.8121",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "339.08405",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "190.59053",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.4097",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "190.59335",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.60425",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03096338",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.142593",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8536.4219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-796.47363",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.5312",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-396.86499",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.921875",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1360.0461",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2106.978",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.7812",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-396.86499",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.523438",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-91.997559",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008331299",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-742.34717",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.546143",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.1999226",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.6102495",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.3593464",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8863707",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.90764",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.25714",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.95682",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.28864",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32296202E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-676.07812",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14450813E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.836914",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48314.953",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112221.95",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.81286917E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62623110E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18282969E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-416094.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "469685.94",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "951.45312",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-286.07373",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "73.290451",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.02953475",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258356",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-726.09644",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "876.35938",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1258.9399",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "187.48193",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.03414810E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49695914E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1929.0986",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2320.7759",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-260272.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615904.81",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "953.17188",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-286.07373",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.853546",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.95282",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.66962",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.01553",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.47345",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005304933",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03128016",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.251757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55316",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.60652780E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74555298E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.60652780E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74555298E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005304933",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03128016",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.94677341E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99798797E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.94677341E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99798797E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03203366",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.566845",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05675222",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.749786",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.0616",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.091446",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.982742",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.40918",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.00038164E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03413464",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.68591",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.19189",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.37849",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.21036",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.57793",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.37372",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04937177",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "96.610733",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8458.6719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-792.0022",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.4062",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-393.91064",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-81.494141",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1295.9902",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1943.9036",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.3438",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-393.91064",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-81.304443",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-90.818863",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008377075",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-730.37891",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.261719",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.6293125",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8304205",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.7192116",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8193035",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.67201",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.69037",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.50378",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.84717",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44878959E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-672.62451",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6533661",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00344187E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.029785",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47954.977",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112573.76",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12964665E-06",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75460275E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47952414E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-397096.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "420577.75",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "957.78125",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-266.5376",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "78.044312",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.02918461",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258356",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-729.16675",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "940.66455",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1494.9124",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "169.15601",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.97773635E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.76378988E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1534.3352",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2079.8467",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-263260.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "646724.44",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "957.78125",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-266.5376",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.568069",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.21835",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.10703",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.37245",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.96429",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005054839",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02893314",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.715223",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.58044",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56504011E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92037551E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56504011E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92037551E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005054839",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02893314",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.23289680E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83103657E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-2.23289680E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83103657E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02818051",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.827576",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04851267",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.137196",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.074142",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.187592",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-34.134872",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.860809",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.33118533E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03538367",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "191.79327",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.14325",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "191.47289",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.70844",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "191.63455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.60611",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04316976",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "96.671486",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8489.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-793.57739",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.8125",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-391.84741",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.695312",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1523.9856",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2128.9626",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.7188",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-391.84741",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.497803",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-96.058121",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007705688",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-729.95459",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.006592",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.5929079",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.6767759",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.1299191",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2482176",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.97424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.78394",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.92728",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.54883",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41487612E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-664.19482",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.650177",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08173117E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.731689",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47887.219",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112918.14",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68250743E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.95040479E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17477475E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-459463.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "404358.94",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "955.34375",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-259.17798",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "76.202774",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.029931",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258438",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-948.36133",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "892.69873",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1302.668",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "163.44092",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.20900414E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.53582504E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-2028.8489",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2084.3997",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-244997.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "614864.81",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.23438",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-259.17798",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.983902",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.08191",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.35199",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.14067",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.22906",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005579222",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03029954",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.02375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55765",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.60663931E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79887211E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.60663931E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79887211E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005579222",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03029954",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.83953864E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08880283E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.83953864E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08880283E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.0304205",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.512447",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04414386",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.626076",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.335159",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.731552",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.621353",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.30899",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "2.88214537E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03559331",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.56049",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.46146",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "186.31674",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.5051",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "186.3409",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "335.46252",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.04408936",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "94.75106",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8476.8711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-788.18872",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.5625",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-386.7915",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.394531",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1411.9531",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1894.4688",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-388.10913",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.582031",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-88.659805",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008056641",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-732.12573",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.439209",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.0576048",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "3.7733574",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.4367619",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6182814",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.90761",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.19104",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.8073",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.3941",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13413591E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-667.49414",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11880945E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.670654",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48209.648",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111979.96",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.80616381E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.80616041E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.35525294E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36802930E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-405845.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "449725.06",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "962.09375",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-257.51489",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "61.782867",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03097113",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258484",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-773.71729",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1126.4158",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1314.6858",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "159.41724",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.25706071E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.37476205E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1690.6228",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1973.9719",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-253891.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "672955.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "962.09375",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-257.77808",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.908859",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.35362",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.24426",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.63432",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.22018",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005324714",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02871624",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-20.166105",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.79279",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56248698E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81628002E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.56248698E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81628002E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005324714",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02871624",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.75606294E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82671863E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.75606294E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82671863E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03627097",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.111164",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0559615",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.730503",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-29.14978",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.050873",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-34.851486",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.491928",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "9.62239710E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03847663",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "189.83794",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.38367",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "189.5327",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.47968",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "189.54568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.23303",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.03440752",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.901711",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8525.7773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-797.80029",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.4062",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-402.04858",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.82959",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1523.6743",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1893.4158",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.4062",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-402.04858",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.774902",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-92.549927",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007110596",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-732.04639",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.397461",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.1113863",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0237293",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.0230522",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3839722",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.52063",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.04034",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "181.45631",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.00369",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33042113E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-665.43408",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6829071",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00614852E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.756348",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "48478.594",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112412.94",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.21152207E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43562886E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33994979E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-428278.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "440287.44",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "961.51562",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-278.5354",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "75.268692",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03047107",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.2584",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-759.37646",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "917.7998",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1271.1587",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "169.76416",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.08300786E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.78826098E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1845.0322",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2044.8064",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-286479.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "645005.56",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.51562",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-280.38721",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "47.128067",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.85835",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.01105",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "208.96236",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90906",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005917057",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02891647",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.552084",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.75446",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59009705E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80108382E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.59009705E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80108382E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005917057",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02891647",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.89773743E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92265566E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.89773743E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92265566E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.03003817",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.897312",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0557458",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.426144",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.194809",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.65184",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-32.242813",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.640976",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "2.75820398E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03799369",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "185.44023",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "338.68842",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "185.31055",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.33725",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "185.41882",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.63998",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.01789523",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.775757",
                                            "PTVersion": "128",
                                            "gribparam": "230",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "8495.4414",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PTVersion": "128",
                                            "gribparam": "217",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-795.38623",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "203",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.2812",
                                                "PTVersion": "128",
                                                "gribparam": "178",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-388.72388",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.193359",
                                                "PTVersion": "128",
                                                "gribparam": "179",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1461.9722",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1822.9722",
                                                    "PTVersion": "128",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.9688",
                                                    "PTVersion": "128",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-388.72388",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.748047",
                                                    "PTVersion": "128",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PTVersion": "128",
                                            "gribparam": "129",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-90.381668",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006912231",
                                            "PTVersion": "128",
                                            "gribparam": "220",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-726.46533",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.882568",
                                            "PTVersion": "128",
                                            "gribparam": "205",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.3253355",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8405657",
                                            "PTVersion": "128",
                                            "gribparam": "181",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-4.6843452",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.1268787",
                                            "PTVersion": "128",
                                            "gribparam": "180",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.37685",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.48398",
                                            "PTVersion": "128",
                                            "gribparam": "169",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "183.34595",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.95837",
                                            "gribparam": "139",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27012390E-06",
                                            "gribparam": "160",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-660.0918",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PTVersion": "128",
                                            "gribparam": "204",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7023468",
                                            "gribparam": "140",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13516580E-06",
                                            "PTVersion": "128",
                                            "gribparam": "218",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.414795",
                                            "PTVersion": "128",
                                            "gribparam": "141",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PTVersion": "128",
                                            "gribparam": "211",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PTVersion": "128",
                                            "gribparam": "173",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "47950.457",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112610.98",
                                            "PTVersion": "128",
                                            "gribparam": "134",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.14268310E-07",
                                            "gribparam": "144",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.77612549E-06",
                                            "PTVersion": "128",
                                            "gribparam": "142",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20480138E-06",
                                            "PTVersion": "128",
                                            "gribparam": "143",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-419494.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "429479.0",
                                            "PTVersion": "128",
                                            "gribparam": "108",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "959.95312",
                                                "PTVersion": "128",
                                                "gribparam": "176",
                                                "process": "50",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "scale_min": "-278.771",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "83.518982",
                                                "PTVersion": "128",
                                                "gribparam": "177",
                                                "process": "50",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PTVersion": "128",
                                            "gribparam": "172",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.03114224",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258347",
                                            "PTVersion": "128",
                                            "gribparam": "152",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-702.06494",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1323.7126",
                                            "PTVersion": "128",
                                            "gribparam": "146",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1385.8418",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "186.43262",
                                            "PTVersion": "128",
                                            "gribparam": "147",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-5.54159328E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.45476143E-08",
                                            "PTVersion": "128",
                                            "gribparam": "182",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-1782.0159",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2153.7517",
                                                    "PTVersion": "128",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-225052.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "665011.12",
                                                    "PTVersion": "128",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "959.95312",
                                                    "PTVersion": "128",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "scale_min": "-278.771",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.783813",
                                                    "PTVersion": "128",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PTVersion": "128",
                                            "gribparam": "175",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "210.51982",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.01007",
                                            "PTVersion": "128",
                                            "gribparam": "183",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "209.61876",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90274",
                                            "PTVersion": "128",
                                            "gribparam": "170",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005076483",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03041875",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-19.796242",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44614",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58814601E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83202483E-05",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.58814601E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83202483E-05",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-0.005076483",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03041875",
                                            "PTVersion": "128",
                                            "gribparam": "133",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.91779600E-06",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95129360E-06",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-1.91779600E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95129360E-06",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "0.02843878",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.404736",
                                            "gribparam": "171",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "0.05114594",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.205086",
                                            "PTVersion": "128",
                                            "gribparam": "216",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-30.295547",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.495789",
                                            "PTVersion": "128",
                                            "gribparam": "166",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "-31.385956",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.837234",
                                            "PTVersion": "128",
                                            "gribparam": "165",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "9.20232424E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03650392",
                                            "PTVersion": "128",
                                            "gribparam": "168",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.38249",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.55487",
                                            "gribparam": "201",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "scale_min": "187.15407",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "321.77676",
                                            "gribparam": "202",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "scale_min": "187.2619",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.65747",
                                            "PTVersion": "128",
                                            "gribparam": "167",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-20.251757",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "scale_max": "410.93295",
                                        "gribparam": "130",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-1.62243377E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "scale_max": "1.92037551E-05",
                                        "gribparam": "138",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-1.62243377E-05",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "scale_max": "1.92037551E-05",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "gribleveltype": "1",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst aug2001 SIX-HOURLY hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-0.009193584",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03196654",
                                        "gribparam": "133",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-2.23289680E-06",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "scale_max": "2.21615664E-06",
                                        "gribparam": "155",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-2.23289680E-06",
                                        "gribleveltype": "109",
                                        "gribNumBits": "16",
                                        "scale_max": "2.21615664E-06",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.01865815",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "39.309048",
                                        "gribparam": "171",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "0.03494264",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "40.877903",
                                        "gribparam": "216",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-34.906662",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "34.587128",
                                        "gribparam": "166",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "-37.760162",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "36.860809",
                                        "gribparam": "165",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "2.75820398E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04707075",
                                        "gribparam": "168",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "184.89082",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "342.06573",
                                        "gribparam": "201",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "184.77397",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "328.68161",
                                        "gribparam": "202",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "PDS_TimeRange": "10",
                                        "calendar": "standard",
                                        "scale_min": "184.80574",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "gribleveltype": "105",
                                        "scale_max": "341.6304",
                                        "gribparam": "167",
                                        "PTVersion": "128",
                                        "process": "50",
                                        "subcenter": "255"
                                    }
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                }
                            },
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    }
                                }
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "1.0"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "333.75"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "30.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/aug2001"
                        },
                        "dec2001": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/dec2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "dec2001",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc24_%6d.01",
                                    "mem24year0": "200206",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc23_%6d.01",
                                    "mem23year0": "200206",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc22_%6d.01",
                                    "mem22year0": "200206",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc21_%6d.01",
                                    "mem21year0": "200206",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc20_%6d.01",
                                    "mem20year0": "200206",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc19_%6d.01",
                                    "mem19year0": "200206",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc18_%6d.01",
                                    "mem18year0": "200206",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc17_%6d.01",
                                    "mem17year0": "200206",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc16_%6d.01",
                                    "mem16year0": "200206",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc15_%6d.01",
                                    "mem15year0": "200206",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc14_%6d.01",
                                    "mem14year0": "200206",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc13_%6d.01",
                                    "mem13year0": "200206",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc12_%6d.01",
                                    "mem12year0": "200206",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc11_%6d.01",
                                    "mem11year0": "200206",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc10_%6d.01",
                                    "mem10year0": "200206",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc09_%6d.01",
                                    "mem09year0": "200206",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc08_%6d.01",
                                    "mem08year0": "200206",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc07_%6d.01",
                                    "mem07year0": "200206",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc06_%6d.01",
                                    "mem06year0": "200206",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc05_%6d.01",
                                    "mem05year0": "200206",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc04_%6d.01",
                                    "mem04year0": "200206",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc03_%6d.01",
                                    "mem03year0": "200206",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc02_%6d.01",
                                    "mem02year0": "200206",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.dec2001/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri/forecast/data/echam4/asst/dec01/30004fc01_%6d.01",
                                    "mem01year0": "200206",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06096204",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "85.145218",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8517.6875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-812.79492",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.9062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-408.59521",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.334229",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1994.8833",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2453.8953",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-408.59521",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-82.648926",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.958328",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08622742",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.77393",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-70.262207",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.3541059",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.203434",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9790316",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5867071",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.80547",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.19366",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.75711",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.26279",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16986666E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-711.33618",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.10012479E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.483887",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47457.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111979.53",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.15900080E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.88662079E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32624473E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-422523.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "456099.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.14062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-259.07764",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "54.328339",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03090196",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258459",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-823.79932",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "904.60693",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1158.9258",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "254.64087",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.63421941E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01822934E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1537.2131",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1971.9771",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-240733.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "614434.38",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.5",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-259.07764",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "29.278534",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.14009",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.86597",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.65204",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.52112",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.75711",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.26865",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.29054",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.04819",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.008421674",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02731079",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.619717",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.74146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.49430680E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73479475E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.49430680E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73479475E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.008421674",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02731079",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02339606E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16499052E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02339606E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16499052E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03225516",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.570789",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05807275",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.236824",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.357147",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.55629",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.210922",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.894958",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.44533658E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03511378",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.24055",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.07202",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.03262",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.91937",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "191.10744",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.0726",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04809247",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "83.603096",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8532.3047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.23071",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1180.0938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.94849",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.456055",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1857.4272",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1845.3665",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.94849",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.573242",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.947968",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08650208",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-721.8252",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.656494",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.1407127",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7197123",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.3756132",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.098033",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.15521",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.99832",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "182.9679",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.21222",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41195301E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.80615",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.13467104E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.725098",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46752.414",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112027.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.46515980E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.62992546E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.45544436E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-448245.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "475537.25",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.98438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-269.21924",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "59.726212",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02921172",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258408",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-712.10059",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1093.6541",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1287.5906",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "184.56885",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.14871374E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.38026813E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1706.3857",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1826.9666",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-305576.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "595068.94",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.98438",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-269.21924",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "21.904037",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.43694",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.11887",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "196.85962",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.60779",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "182.9679",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.12628",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.59476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.09341",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004936144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02735369",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.744495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.4635",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48357867E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76626781E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48357867E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76626781E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004936144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02735369",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.93547385E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.11934525E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.93547385E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.11934525E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02965785",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.872066",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04734129",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.129158",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.432312",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.575363",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.404434",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.616058",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.26546013E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03419112",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.49188",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.62927",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.39978",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.53995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.40202",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.56821",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0627625",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.773941",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8523.8906",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.38818",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.7188",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-399.70874",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.46582",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1573.5667",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1912.8499",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-399.70874",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.996094",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.244965",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08688354",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-725.22021",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.908203",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8791819",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9420853",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.0600166",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.000206",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.46889",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.396",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.51134",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.79813",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.09024177E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.00732",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.04962965E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.518555",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46911.602",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112358.28",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.73385977E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.76411561E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.69388268E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.40647080E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-430579.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "458448.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "979.53125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-273.74316",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.863205",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03170276",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258448",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-814.59766",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1022.8718",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1190.8362",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "174.44409",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.76182038E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.97567373E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1729.3818",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2014.5042",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-307208.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "638189.19",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "979.53125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-273.74316",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "25.756241",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.40376",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.78098",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "197.48206",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.38712",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.51134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.73563",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.71509",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.61041",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005028557",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02662344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.591936",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.651",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.45263648E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.70983512E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.45263648E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.70983512E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005028557",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02662344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99413716E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06452160E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99413716E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06452160E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02500544",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.952812",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04946072",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.589531",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.066772",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.293537",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.220093",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.238907",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.02625734E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03706392",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.92841",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.46442",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.86655",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.95917",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.88518",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.34363",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05504033",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "86.070854",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8523.3203",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.47046",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-399.72412",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-80.200439",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1716.7693",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1940.9482",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-399.72412",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-82.966553",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.98053",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08656311",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.02588",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-69.929443",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6614733",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.4990263",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7.0853472",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.5778656",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.55455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.70398",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.60176",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.88275",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67187579E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-719.68164",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.09508983E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.672363",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46567.797",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112655.47",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.40657571E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.70002511E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31230433E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-481123.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "436748.69",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "985.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-290.83179",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "57.605087",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03071016",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258497",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-714.63281",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1156.9846",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1257.4463",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "193.65845",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.02817613E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.74405464E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2314.0518",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1790.3352",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-284287.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "569503.31",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "985.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-290.83179",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "37.364334",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.90863",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.28745",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "200.26495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.99139",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.60176",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.55811",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "208.98009",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.83887",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004752699",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02731708",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.802567",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.67343",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.39779531E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80809202E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.39779531E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80809202E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004752699",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02731708",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.91332651E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16355738E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.91332651E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16355738E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02895582",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.151005",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05474818",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.262691",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.949539",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.23761",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.221893",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.868805",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "2.36829010E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03743666",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.97949",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.20496",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.75224",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.77869",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.80943",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.45682",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05849198",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "83.101624",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8518.7773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.07153",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.3125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-396.47803",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.852295",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1720.7314",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2099.1194",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.2812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.47803",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.075684",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.376785",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08711243",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-726.70752",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.40625",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6608181",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8466101",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.8277884",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.1991692",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.80887",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.1759",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.90878",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.69806",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31695890E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-692.47192",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.67149390E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.392578",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47223.762",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112600.88",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.18671253E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67958694E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.58326734E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41105727E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-427817.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "443090.75",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.15625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-283.94873",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "57.75882",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03123624",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258453",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-741.19775",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1094.363",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1397.2529",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "172.12305",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.58722320E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.88271484E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1788.2271",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1679.6418",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-332401.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "605582.12",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.28125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-283.94873",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "20.256989",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.38374",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.9671",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.01906",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.1806",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.90878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.58087",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "208.98683",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.88025",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005370736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02746325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.720346",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.90408",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.42391009E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87862588E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.42391009E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87862588E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005370736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02746325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03458603E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17357547E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03458603E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17357547E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03232504",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.151905",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05092988",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.312412",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.761475",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.452301",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.024048",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.990784",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "7.08861307E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03710635",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.92108",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.66437",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.38873",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.27972",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.4214",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.65787",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0566018",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "82.962677",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8523.1914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.16138",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.4688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-387.82471",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.894287",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1390.9648",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1950.7715",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.82471",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.894287",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-85.975052",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08651733",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-725.10718",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.124268",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.2919264",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7251263",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.4390144",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.7333679",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.91495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.09192",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.81511",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.33429",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26182999E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.49854",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.05632353E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.787842",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46953.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112112.92",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.00102839E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.83573275E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37527513E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-425190.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "497514.94",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "977.78125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-275.24805",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "63.088913",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03037764",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258512",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.52075",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "893.8313",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1435.4321",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "181.36865",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.73989155E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.25254381E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1589.1792",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1785.0232",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-276790.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "587743.81",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.78125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-275.24805",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "25.877335",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.32417",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.21429",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.21069",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.15344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.81511",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.1507",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.59361",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.82495",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005031977",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02701995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.625135",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.74731",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50187379E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.71652191E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50187379E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.71652191E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005031977",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02701995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.15786781E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08229153E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.15786781E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08229153E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03585748",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.787472",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0639863",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.324402",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.491272",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.19014",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.560349",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.849136",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "4.76864521E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03486459",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.1136",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.94528",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.9407",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.4892",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.97723",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.92084",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06044411",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "89.536278",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.2188",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-810.27417",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.55737",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.20752",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1630.0928",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2148.3042",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.55737",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.212891",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.631165",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08670044",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.54712",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.002686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.9331226",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.2807579",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.9643316",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0791826",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.16322",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.09198",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.15852",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.81757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.53148744E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-699.43457",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.91654815E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.583496",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47388.816",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112276.57",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.29395617E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.90260458E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.60162358E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.28448359E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27216356E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-445442.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "441815.44",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "969.57812",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.99683",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "60.632904",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03068788",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258465",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-874.28247",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1120.0581",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1183.001",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "175.68872",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.73048942E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.02545435E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1726.2222",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1847.5225",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-308002.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "601824.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "970.14062",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266.99683",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "38.681763",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.20697",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.50412",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.73198",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.47131",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.15852",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.78058",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.52249",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.31604",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005522326",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02686184",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.98522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.41",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48412601E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.71684151E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48412601E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.71684151E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005522326",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02686184",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.92302196E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16090461E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.92302196E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.16090461E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03359575",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.958454",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05696904",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.464363",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.878555",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.216354",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.364792",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.474854",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8.44646593E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03493489",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.04449",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.46008",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.95668",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.22925",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.03229",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.04028",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06420493",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "87.776962",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8519.9844",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.51978",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-390.62329",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.640869",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1901.6128",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1792.0806",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.1562",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.1792",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.809326",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.079437",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08674622",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-728.81348",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.974121",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8919106",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8377085",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6051626",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.4023972",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.55408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.4989",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.52197",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.22134",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37941174E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.5647",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.17448508E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.014404",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47249.863",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111868.31",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.12283168E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.50722008E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.33630988E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-439787.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "450838.56",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "967.45312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.61475",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "70.521301",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0309034",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258486",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.81348",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1198.1335",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1258.594",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "185.01318",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.03276510E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.39806296E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1864.2021",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2090.6504",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-331987.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "610701.75",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "968.6875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.76074",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "24.940979",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.0061",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.62988",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.8475",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.3288",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.52197",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.20059",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.1756",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.66095",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003534186",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02590337",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.514158",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.05011",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47315723E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72532600E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47315723E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72532600E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003534186",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02590337",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.96628275E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.95646066E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.96628275E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.95646066E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02563937",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.906998",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04239379",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.18259",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.516022",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.167648",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.797501",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.583481",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8.06544449E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04103574",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.14731",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.94727",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.79805",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.3869",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.84128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.9317",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04475382",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.073624",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.7969",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.79126",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2188",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-384.05762",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.025879",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1852.9453",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1648.0598",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9688",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-384.05762",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.049316",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-91.146027",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08717346",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-715.34106",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.194336",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4073153",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.584569",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6270523",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.3061514",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.01892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "336.86026",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.18265",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.16077",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27432077E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-694.2915",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.22725032E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.54834",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46977.926",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112597.11",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.51453808E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.06758351E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.70654266E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26503596E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-461004.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "475125.88",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.78125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-265.19141",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "65.048111",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03002039",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258503",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.16284",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1141.5098",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1226.9839",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "194.38452",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.90636467E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.77291120E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1682.1335",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2021.4438",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-272953.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "639934.75",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-265.19141",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "22.334854",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.92035",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.40622",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.0491",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.21268",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.18265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.40686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.12224",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "312.99054",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00577959",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02921944",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.126907",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.81949",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.38841260E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.62524266E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.38841260E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.62524266E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00577959",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02921944",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97145459E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.95438724E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97145459E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.95438724E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02211021",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.793827",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05098586",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.308655",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.804947",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.57988",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.576691",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.629272",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "3.52528815E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03821049",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.62793",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.86438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.70796",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.51166",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.72757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.7951",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03694575",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "86.135887",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8524.4844",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.88159",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.06812",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.92749",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1604.6804",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1846.511",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.06812",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.311768",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.287003",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08638",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-744.58057",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.663818",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2207432",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9885788",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.1928129",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1859379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.89301",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.18866",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.89517",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.39395",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37074778E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-727.08813",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16325100E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.249023",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47469.641",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112074.95",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.16497106E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.73242927E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.15196482E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29987791E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-427260.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "429928.62",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "969.98438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-264.01636",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.612244",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03060628",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258471",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-747.44189",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1258.6179",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1318.7041",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "162.37622",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.27312807E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.45952696E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1633.8684",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1880.3647",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-276964.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "595162.5",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "970.70312",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-264.01636",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "25.3685",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.07954",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.75433",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "197.29602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.0892",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.89517",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.29044",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.1265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.70123",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004576042",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0281147",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.608002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.94379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47180954E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.68231145E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47180954E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.68231145E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004576042",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0281147",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.35462471E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.02825800E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.35462471E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.02825800E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.01584013",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.272411",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0237495",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.821777",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.070328",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.46965",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.768112",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.456161",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8.50336619E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03408257",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.05255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.21631",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.83302",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.35614",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.85571",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.03912",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03557465",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "84.739861",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8512.9961",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.06152",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-393.80908",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.43457",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1498.7102",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1845.239",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9688",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-393.80908",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.414062",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.727005",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08644104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-736.08911",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.824707",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.4511776",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.5484161",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3231936",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0702553",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.01724",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.58453",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.00012",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.89362",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.48369702E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-705.90039",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.05224899E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.404785",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47214.723",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112474.75",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.07251843E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.54700797E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.39504175E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-434591.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "493870.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.0625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-275.68481",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "50.680496",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03119552",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258484",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-812.51147",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1015.4075",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1152.7952",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "179.2854",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.60970455E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.16889588E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1768.887",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1911.1938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-365237.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "652532.62",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.4375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-275.69849",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "30.396408",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28131",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.62042",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "196.32599",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.56329",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.00012",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.8858",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.56404",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.47601",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007046875",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02749709",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.913252",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.65686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46959028E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72165146E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46959028E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72165146E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007046875",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02749709",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02195679E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.24969676E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02195679E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.24969676E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02722542",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.776497",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05913763",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.128517",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.361267",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.91713",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.810883",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.27417",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.09273003E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03741221",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.94194",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.49924",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.87688",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.715",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.88803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.48474",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05610841",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "84.467232",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8489.2148",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.53394",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.1562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-395.38208",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.845947",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1805.8477",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1852.762",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.75",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-395.38208",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.290527",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-81.927643",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08702087",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-728.79712",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.056396",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6264524",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.0519886",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3234978",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7432785",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.58969",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.30002",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.63504",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.63852",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.06751725E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-694.05005",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.99949407E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "17.081543",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47143.379",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112081.98",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.51453808E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.00534940E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67078588E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.80700392E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.49852917E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-405278.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "465212.38",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.85938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.37769",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "77.640167",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02996168",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25844",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.09668",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1067.3723",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1125.7214",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "213.27856",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.50144483E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.52867572E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1998.8901",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1722.0137",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-309973.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "646284.69",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.85938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.37769",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "18.11972",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.81984",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.61371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "196.58774",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.53534",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.63504",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.54517",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.03796",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.35034",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00457092",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02696809",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.004139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.06427",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.45158519E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76964822E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.45158519E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76964822E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00457092",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02696809",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03373725E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.01178364E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03373725E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.01178364E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02041094",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.124069",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03888946",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "41.731964",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.446213",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.556549",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.344193",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.749634",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "9.71957093E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03624657",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.54678",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.02063",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.26025",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.31137",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.35323",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.99225",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04182852",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.241371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8519.1875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-810.36108",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.4062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.0498",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.581055",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1825.9119",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1681.3674",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.0498",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.960449",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.904999",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08631897",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-717.35522",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.366943",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2187557",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.1657438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9342966",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1990433",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.04517",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.82664",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.32605",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31789466E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-693.96313",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19063770E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.94043",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46447.082",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112379.68",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.55230872E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.84232852E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.07290842E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30602973E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-404976.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "454269.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "968.84375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-273.26416",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "57.710327",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02900807",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258549",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.73462",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1135.0269",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1499.7095",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "160.54321",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.99691873E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.41959446E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1765.0947",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1898.469",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-318781.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "587355.81",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "969.79688",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-273.28882",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "20.59967",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.03592",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.32373",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.44125",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "315.8866",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.82664",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.99323",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.12932",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.43185",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005600169",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02726537",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.828037",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.81775",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46320253E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78194678E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46320253E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78194678E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005600169",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02726537",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.82640883E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03771492E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.82640883E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03771492E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02719831",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.430428",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04808723",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.633633",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.33786",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "28.965561",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.149994",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.012238",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.14420800E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03884415",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.60036",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.24432",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.31119",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.96021",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.3506",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.0481",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04832854",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "85.115372",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8518.5195",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.07837",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-393.95801",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.609863",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1751.8008",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1632.5022",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.70996",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.940186",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-85.134354",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08680725",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-740.83569",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.49707",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0758696",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7395105",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4267035",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.6395912",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.75562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.13153",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.53094",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.62766",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01630587E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-714.42017",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.61328624E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.560791",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47156.047",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112153.02",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.03988917E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.52783844E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.28680438E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-414103.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "444052.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.98438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.14453",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "59.328857",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03022772",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258484",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-761.7334",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1083.5649",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1367.5454",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "185.50098",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.46843125E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.41790700E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1437.3369",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1917.0464",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-256517.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "614921.12",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.98438",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.14453",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "26.846802",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.57579",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.8631",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "199.32698",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.95819",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.53094",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.60812",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.8447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.64893",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006836332",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02704061",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.404545",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.6976",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48369691E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76593549E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48369691E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.76593549E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006836332",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02704061",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.37937661E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00181535E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.37937661E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00181535E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02956201",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.125961",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05163336",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.421349",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.359634",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.528763",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.693756",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.79837",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.65702374E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.0380118",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.55002",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.71661",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.00848",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "319.98517",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.00848",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.09869",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05321715",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "89.56115",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8501.3984",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.28931",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1180.0938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.87451",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.232178",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1980.2576",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1872.8713",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.87451",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.488281",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.96022",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08627319",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-717.35571",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.860107",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.2563295",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.3065081",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.4221487",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.0898933",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.70508",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "335.80853",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.62563",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.54782",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.12427449E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-700.25171",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.11971167E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.208984",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46921.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112560.16",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.73161534E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.57965665E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.87842511E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.25624947E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37462621E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-440709.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "451888.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-284.65527",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "77.343048",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02949839",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258539",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.96411",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1167.6611",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1195.6921",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "185.92578",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.66653091E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.43489750E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1623.1101",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1939.5935",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-313932.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "638496.44",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-284.65527",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.742355",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.29166",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.23685",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "196.28421",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.85828",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "184.62563",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.41501",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.66847",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.67462",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005434398",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02713685",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.278648",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.93411",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47778946E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.62583710E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47778946E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.62583710E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005434398",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02713685",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01551529E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06936670E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01551529E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06936670E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02550181",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.147903",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04131255",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.258045",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.382828",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.448975",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.15918",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.717255",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.10157544E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03599995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.10641",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.56384",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.85217",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.75146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.94858",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.81149",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05413573",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "88.38488",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.89746",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.5938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.74146",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.749023",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1776.0593",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1782.1973",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.74146",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.237793",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.279221",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0869751",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-724.49146",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-70.175537",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9193687",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.2636194",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5056372",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.607749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.69534",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.27686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.69867",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.39062",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.36767608E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.03149",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.11619011E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.73291",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47238.078",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111934.08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.41083852E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.52906910E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.22727704E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-482765.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "459394.94",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "966.79688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-263.87646",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "56.404587",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03202488",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-858.37939",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1183.0249",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1269.0542",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "180.35059",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.07459220E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.21177571E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1505.9207",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1819.1614",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-315441.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "590211.38",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.42188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-263.92578",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.697922",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.16641",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.51031",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "197.59271",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.92044",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.69867",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.29492",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.22108",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.32269",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003917776",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02685288",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.643211",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.63751",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.43707375E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.68979695E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.43707375E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.68979695E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003917776",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02685288",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94973813E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.12504438E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94973813E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.12504438E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02553649",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.964989",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04480355",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.443504",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.324997",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.135681",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.799179",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.792267",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "5.68191787E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04341219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.74536",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.50604",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.58191",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.40005",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.58257",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.18326",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0498033",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "86.512062",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8513.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.87695",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-384.86792",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.959473",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1853.6362",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1972.1089",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-384.86792",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.424805",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.130112",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08703613",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.73389",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.993652",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.9358654",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.3185329",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.8548717",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.123621",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.54065",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.77609",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.48949",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.19128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27508258E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.89478",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26363011E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.954834",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47169.93",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112296.81",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.24857045E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.78680534E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.54814097E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-407954.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "473789.38",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.07812",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-277.51709",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "55.152695",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03103033",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258423",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-813.34888",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1383.1174",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1437.8906",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "206.43066",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.74972205E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.25470750E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2342.7966",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1825.2693",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-293375.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "649283.38",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.28125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-277.51709",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "22.261887",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.27263",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.09918",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.12381",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.02881",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.48949",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.06628",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.36327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.24713",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004138488",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02912056",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.868626",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.57193",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44785727E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.69489540E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44785727E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.69489540E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004138488",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02912056",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02557089E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.37325298E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02557089E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.37325298E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03182838",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.897617",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05299102",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.644585",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.219193",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.619751",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.387665",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.139069",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "9.81439712E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03801184",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.05281",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.07776",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.89684",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.3739",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.90558",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.85242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04741511",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "88.284286",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8523.8047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.99268",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.1875",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-381.65405",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.959961",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1913.1572",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2007.2388",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-381.65405",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.718994",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.407364",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08709717",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-746.68018",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.478027",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8596201",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.4589396",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.721797",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.8696308",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.75117",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.51929",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.65381",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.49103",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.46031175E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-702.19092",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.03685306E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.192383",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47318.527",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112766.77",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.23909261E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.07052426E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.24385747E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-410919.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "455246.94",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "969.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-262.40112",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "71.272263",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03066769",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258392",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.6731",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "832.4126",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1136.429",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "223.87305",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.54426157E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.95186076E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1699.5693",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1927.1382",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-382793.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "588411.06",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.82812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-263.11426",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "31.554672",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.25874",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.06815",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "197.30563",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.02979",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "183.65381",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.5047",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.62914",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.92303",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004736818",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0288047",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.91576",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.50632",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47198343E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.75062360E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47198343E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.75062360E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004736818",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0288047",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02556726E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.21233245E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02556726E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.21233245E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03065771",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.615463",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0635193",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.342854",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.840057",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.762024",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.158798",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.427155",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "7.34708010E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03506192",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.12833",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.0546",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.7312",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.63269",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "187.86038",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.03683",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0578686",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "85.736069",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.8125",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.73193",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-387.26855",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.060547",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1926.251",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1834.9126",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.26855",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.631592",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.242142",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08676147",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-726.52515",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.250244",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6725864",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8316889",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4968729",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1069813",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.70668",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.67975",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.64095",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.0329",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31837260E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.28345",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.10099791E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.047852",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46991.188",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111839.44",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.42827581E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.85978570E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.36863798E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-404571.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "442147.56",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.51562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-260.43481",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "60.864288",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0305633",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258392",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-705.81738",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1034.2935",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1125.9412",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "190.61792",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.50232363E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.62249215E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1770.0518",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1994.5457",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-315860.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "618525.06",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.51562",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-260.43481",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "30.842361",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.94521",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.67249",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "197.51076",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.4248",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.64095",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.39227",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.08003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.57584",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005337454",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02747997",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.941751",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.95206",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44362875E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78243990E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44362875E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78243990E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005337454",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02747997",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.82400618E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.97795930E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.82400618E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.97795930E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02530574",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.365665",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04451274",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.675068",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.913818",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.313629",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.228088",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.128204",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.17251886E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03529721",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.54718",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.50061",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.28238",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.40112",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "188.28738",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.99841",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04390636",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "88.494125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.8242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-810.07593",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.4688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-385.92358",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-78.300781",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1453.2324",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1729.0837",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.92358",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.209473",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.490036",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08674622",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.15894",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.875488",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.7494955",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.5746412",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5354843",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7538548",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.1554",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.25714",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.00171",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.95853",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.11175700E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-707.55835",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.02727790E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.165283",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47533.344",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112728.86",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.03811020E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.51214567E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.20818743E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-488946.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "482359.38",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.39062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.45508",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "63.441635",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03007261",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258471",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-722.03174",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1193.0566",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1298.396",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "206.32446",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.19192213E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.25061193E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1395.8342",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1759.3198",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-317681.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "560669.5",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "975.0625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.45508",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "32.882263",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.21001",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.05325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.8111",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.08557",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.00171",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.91556",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.45262",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.81842",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004937336",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02809255",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.671879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.75009",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.41088867E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73106964E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.41088867E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73106964E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004937336",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02809255",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89894786E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92928610E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89894786E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92928610E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0313176",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.777016",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04916658",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.459019",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.60083",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.842178",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.721725",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.429245",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.54371548E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03513223",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.02856",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.59772",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.75717",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.41388",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.80602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.17218",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05436542",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "82.55925",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.7969",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.84424",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.4688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-395.92163",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.643555",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1839.2119",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2359.054",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.85303",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.353027",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.464615",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08680725",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.84058",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.073242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.8660107",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.2187691",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2071953",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.312007",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.25391",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.31952",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.25941",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.75391",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.15760452E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.4397",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.08024688E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.778564",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47065.195",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112042.95",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163066E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.51022355E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.80928453E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.03902716E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.36528377E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-415327.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "463183.81",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "966.14062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-281.83032",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "69.360535",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03019963",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258429",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-758.05103",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "857.49561",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1159.0459",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "194.31128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.63470030E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.76978766E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2031.0005",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2289.6626",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-316610.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "652948.62",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.40625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-282.40723",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "26.983429",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.11546",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.3623",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.1032",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.01965",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.25941",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.42578",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.286",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.97394",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.01055825",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03030396",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.69525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.76044",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50287642E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72700820E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50287642E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72700820E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.01055825",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03030396",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98092630E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.13496082E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98092630E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.13496082E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.01853678",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.713219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0425308",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.316925",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.266663",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.595856",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.574081",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.296097",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.36981612E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03355908",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.1965",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.62634",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "185.91681",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.93292",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.94714",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.52106",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05896141",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "86.972015",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8512.7656",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.24658",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.3125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-382.85181",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.313477",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2118.4343",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2401.9768",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.01855",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.633545",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.147629",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08630371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.65698",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.270264",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2433395",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.397995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.5000496",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.2625055",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.42099",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.27899",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.44853",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.00699",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.10778103E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-700.86206",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.02334889E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.888184",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "46657.898",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111658.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.19169884E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.72013745E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.03902716E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26754765E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-403409.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "505826.25",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-277.88135",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "55.276291",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0311228",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258507",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-718.8938",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1034.7104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1355.3547",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "167.19434",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.41968461E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.68545397E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2008.9448",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1925.3584",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-306884.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "621471.56",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-277.98242",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "17.543243",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28671",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.27167",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.65067",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.92255",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.44853",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.45621",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.58839",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.11963",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00568828",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02742949",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.443005",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.65927",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46820230E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.74566176E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46820230E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.74566176E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00568828",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02742949",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.25888880E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.07468702E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.25888880E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.07468702E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03042387",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.49617",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04951522",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.364025",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.349167",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.425552",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.198212",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.683655",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8.73153567E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03629125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.58881",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.07715",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.41214",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.98657",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.48634",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.58423",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04491301",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.663857",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8518.332",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "99999.984",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.33276",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.875",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-382.56299",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-79.866455",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1599.667",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1918.5347",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-383.66528",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.343994",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.449203",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.08662415",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-730.23291",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.878418",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2236843",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8073578",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.2065973",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8635817",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.85286",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.36176",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.46997",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.72211",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.14391935E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-703.42236",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.31293471E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.773193",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47407.211",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112142.98",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.00702367E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.45716763E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.46877471E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-434077.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "475616.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.40625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-279.42871",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "52.135757",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02954675",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258471",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-765.43481",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1021.8035",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1276.5872",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "184.50293",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.10471466E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.37783239E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1579.0559",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2029.655",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-350539.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "585172.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.40625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-279.46973",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "32.745941",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.81882",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.95746",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "198.59674",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "316.94104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.46997",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.51562",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "208.90562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.50848",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005718019",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.028378",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.257761",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.62131",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44227652E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.70953663E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44227652E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.70953663E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005718019",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.028378",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.09789391E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17130446E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.09789391E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17130446E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03461502",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.507328",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05859202",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.376053",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.767975",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.766159",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.641495",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.831604",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.21057496E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03370344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.48521",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.24774",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.37456",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.14944",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "189.38301",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.97366",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05072445",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "87.294205",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "8511.7539",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.60815",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.1562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.28833",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.313965",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1912.9836",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2054.4441",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.28833",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.126953",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.30661",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0868988",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-716.86914",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.201416",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4074945",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.3097076",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.612855",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5417938",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.07951",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.07513",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.0546",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.3848",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19399260E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.7627",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.05198706E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.661133",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "47130.465",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112344.6",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.66861035E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.53183510E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.33778121E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-471467.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "471988.69",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "scale_min": "-270.7063",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "60.277176",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03006977",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258492",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.97827",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "997.1897",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1324.9443",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "218.729",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "212",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.29808176E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.74662476E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1642.5115",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1918.467",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-311553.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "608373.5",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "process": "50",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-270.7063",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "34.238342",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "210.50818",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.06149",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "199.16801",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.05606",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "185.0546",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.05667",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "209.66765",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.91928",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006932687",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0270142",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.650505",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "409.79636",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44958149E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.67411108E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.44958149E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.67411108E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst dec2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006932687",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0270142",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.24190535E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.04435491E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.24190535E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.04435491E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02307386",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.402786",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05570711",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.825317",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.65715",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.622787",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.581894",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.024536",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "7.98306701E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03740445",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.45447",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.2601",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "process": "50",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.37027",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.88104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "process": "50",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "scale_min": "186.72334",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.10425",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2001-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "545.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/dec2001/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "ensemble": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/ensemble/MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "MONTHLY",
                                "restriction": "Public",
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/ensemble/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY",
                                "SIXHOURLY"
                            ]
                        },
                        "ensemble_mean": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/ensemble_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble_mean",
                            "restriction": "requires dlauth tokens"
                        },
                        "feb2002": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "feb2002",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "Public",
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem01/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc01_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03488032",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.077095",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8458.4922",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-805.22119",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-389.98022",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.057861",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1648.1514",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1904.2825",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.98022",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.128174",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-95.238434",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01908875",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-728.72241",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.304932",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.4381027",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.212512",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.4564505",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "7.4811993",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.21982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.33496",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.21048",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.34692",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28818090E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-702.94678",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17931631E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.750732",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47164.758",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112628.94",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36718562E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44748992E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42796773E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-402558.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "444864.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "971.53125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-254.89418",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "84.088242",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03090336",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258432",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-756.97974",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1076.3059",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1111.0049",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "197.44116",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.44259740E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.89542867E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1767.1284",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1781.8442",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-324796.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "655723.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.73438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-255.40681",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.216766",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.50764",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06464",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "196.72845",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "318.52817",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.21048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "340.58716",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.00009",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.71103",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.005170345",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02917336",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.732273",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.5939",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.51960394E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76433114E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.51960394E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76433114E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.005170345",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02917336",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.90294668E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01958028E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.90294668E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01958028E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02341348",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.368389",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04330809",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.757362",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.156937",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.130432",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-32.238602",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.371033",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "6.68954954E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03295515",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.12122",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.54208",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.09016",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "322.61832",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.11751",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.47418",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem01"
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem02/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc02_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "98.81926",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04276282",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8522.7812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-804.95459",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.7188",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-75.303711",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-385.35254",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1672.5664",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1894.8735",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-78.598389",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.35254",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01832581",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-89.792328",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-67.27417",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-740.28052",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.2595749",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-3.9084082",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "6.2958317",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.2600908",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "339.67004",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "185.72554",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "348.68488",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.67429",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.25729969E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-704.36572",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.17599848E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "14.708496",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112075.73",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "46993.48",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.95344761E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-4.41163143E-28",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.53729138E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.30737408E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "445456.56",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-416438.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "974.39062",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "66.287186",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-267.56079",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258471",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.02897309",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1123.5874",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-726.65234",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "236.85815",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1223.1711",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "9.47138972E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-4.89111926E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1693.5654",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1290.5366",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "618190.88",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-313905.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "975.10938",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "48.082016",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-267.57568",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "309.94876",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.81793",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "319.67297",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "198.08801",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "344.43097",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "185.67429",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "313.40765",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.32759",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "scale_max": "0.02953452",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.009155676",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.42059",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.727173",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.78297742E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55095840E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.78297742E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55095840E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02953452",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.009155676",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.05900392E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.20497554E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.05900392E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.20497554E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "38.656155",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0280535",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "39.055088",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04866822",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "31.653625",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-30.330078",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.395279",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-34.236343",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03649212",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "5.09457969E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "335.68982",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.79263",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "322.91681",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.68698",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "331.19968",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "188.69518",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem02"
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem03/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc03_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "97.067986",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0453477",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8534.5938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-804.80054",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1178.75",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-75.208008",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-389.01929",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1693.8364",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1654.6855",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-80.130859",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.01929",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01850891",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-87.004517",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-71.790527",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-714.99146",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.6253538",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-3.6376038",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.083396",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-6.9264154",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "335.90915",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "188.78645",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "344.00842",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.80197",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.26288126E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-704.74585",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.04648643E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "13.797607",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "111908.62",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "46989.82",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "9.20112029E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-3.52930514E-27",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.60706190E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.19927290E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "451984.88",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-430271.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "969.32812",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "75.512619",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-247.5403",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258539",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.02990128",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1087.707",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-783.06226",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "167.61938",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1170.8308",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "6.70280826E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-4.68182463E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1855.8188",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1671.4058",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "613777.75",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-318953.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "973.10938",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "36.449326",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-247.5403",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.26587",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.29163",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "318.26569",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "200.58659",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "340.02405",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "188.80197",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "313.44214",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.09277",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "scale_max": "0.03105408",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.005720329",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.48273",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.892567",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.68562638E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.60753152E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.68562638E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.60753152E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03105408",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.005720329",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.03613263E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.96227234E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.03613263E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.96227234E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "35.659973",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02030093",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "37.710258",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0385045",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "30.49704",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-37.634888",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "35.467438",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-34.10054",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03587871",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8.18392891E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "337.90747",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.13155",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "326.13458",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.75394",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "331.23178",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "191.0553",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem03"
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem04/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc04_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "93.30706",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04274746",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8504.1016",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-809.25",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.1875",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-75.342041",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-396.22339",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "2203.4553",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1606.4102",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-78.19043",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-396.22339",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01908875",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-92.937485",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-67.860107",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-753.16504",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.6651421",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.9504795",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.8506784",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.6977844",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "340.32678",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.15236",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "348.2435",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.13531",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.53536507E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-697.95557",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.01450132E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "15.683594",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112154.83",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "47332.309",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.62668435E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-3.36580767E-33",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.58677381E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.14991451E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-1.31007763E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "460176.0",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-415616.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "969.60938",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "72.51088",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-274.88647",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258425",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.0311103",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1168.7429",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-812.97998",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "212.9043",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1630.6382",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.51344453E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-6.52046538E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1793.4373",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1548.6409",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "631980.69",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-303636.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "971.75",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "34.735001",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-274.88647",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.35019",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.11488",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "318.85413",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "197.94704",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "344.30765",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.13531",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "313.18585",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.62923",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "scale_max": "0.02935112",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.006896093",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.30768",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-22.143236",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.85822773E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55192811E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.85822773E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55192811E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02935112",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.006896093",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.05270430E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.89607056E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.05270430E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.89607056E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "35.176552",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03049442",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "36.981773",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04651314",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "32.998367",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-30.302185",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "33.799072",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-32.074417",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.04050127",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8.43855901E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "336.70117",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.14931",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "328.03485",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.99518",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "331.65948",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "189.03857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem04"
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem05/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc05_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "95.323235",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04527728",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8523.957",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-808.08813",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.4062",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-75.203125",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-391.21216",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1561.5371",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1534.4172",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1181.1875",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-75.27832",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-391.21216",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01856995",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-87.021927",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-64.257812",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-715.33105",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.2615089",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.4836702",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.7107639",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.2324572",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "336.99268",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.59457",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "342.9382",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.51051",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.26149621E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-691.81543",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.02113700E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "13.072754",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112875.64",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "47597.289",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.62480454E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-5.04871003E-33",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.51581628E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.34308459E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-1.62630428E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "441579.0",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-406589.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "966.75",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "70.373535",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-239.74797",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.25845",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.03106262",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1103.4629",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-727.62964",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "211.19556",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1670.2886",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.44501642E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-6.67901645E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1744.9028",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1442.71",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "627734.31",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-248225.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "967.34375",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "29.137375",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-239.74797",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.05676",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.21242",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "318.55118",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "198.16426",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "339.04535",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.51051",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "312.44067",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.83183",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "scale_max": "0.02730217",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.005546246",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.37088",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.499807",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.75738551E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.61985918E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.75738551E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.61985918E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02730217",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.005546246",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.87506669E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.86478064E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.87506669E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.86478064E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "35.993969",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02184784",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "36.412357",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.03938604",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "32.876312",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-30.391632",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.489197",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-32.618927",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03904601",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "4.21688142E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "338.93958",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.22169",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "326.19196",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.00183",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "336.37604",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "187.19719",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem05"
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem06/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc06_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "99.648224",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04191466",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8458.5352",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-806.74609",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.1875",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-74.78125",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-386.22974",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1958.9626",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1745.3997",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-74.79834",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.22974",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0188446",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-91.375854",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-64.260498",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-729.40381",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "3.8375072",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.4187765",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.4871817",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.531146",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "338.53845",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.61624",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "344.25897",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.57129",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.26435680E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-713.85815",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.16316369E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "14.031494",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112605.67",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "46769.922",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.68565371E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-3.52930514E-27",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.75610990E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.26455689E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "438615.88",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-435148.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "976.6875",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "75.971725",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-266.64014",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258545",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.02984527",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1279.0212",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-768.94556",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "215.29956",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1320.1326",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.60904095E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-5.27884083E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "2185.7769",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1614.4695",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "631635.19",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-281691.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "976.6875",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "40.929367",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-269.84839",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.67847",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.94679",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "319.28741",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "196.36455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "340.25116",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.57129",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "313.95959",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.30139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "scale_max": "0.02983397",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.00436943",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.44958",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.867619",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.84561268E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.57175364E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.84561268E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.57175364E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02983397",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.00436943",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.11346492E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.38839561E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.11346492E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.38839561E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.999798",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03152627",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "36.499302",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.06772685",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "30.781418",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-31.389969",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "32.767883",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-34.956711",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03959474",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "7.39723873E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "337.69025",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.71094",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "323.17072",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.97527",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "332.35071",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.06921",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem06"
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem07/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc07_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "94.97744",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04520214",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8455.1797",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-809.1438",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.3438",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-74.495361",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-389.70483",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1627.5615",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1805.8469",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-74.393799",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.94556",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01896667",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-86.138794",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-63.660156",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-714.81787",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.3032789",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.8586245",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.8389177",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.7107058",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "336.867",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.24281",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "341.99014",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.17583",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.32176478E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-697.44873",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.14279101E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.287598",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112416.41",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "46828.113",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.17218222E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-7.05861028E-27",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.49931066E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.23925781E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "450047.31",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-397412.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "969.64062",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "80.334854",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-244.33914",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258478",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.03017085",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1093.9358",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-716.08325",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "205.20532",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1107.7986",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.20560331E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-4.42977608E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1806.9419",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1757.4438",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "619208.62",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-301141.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "972.42188",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "36.059479",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-244.33914",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.05597",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.25484",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "316.99335",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "196.2019",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "338.38663",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "183.17583",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "312.12515",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.59976",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "scale_max": "0.02806846",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.003661568",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.14438",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.652559",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.73745539E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.58541643E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.73745539E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.58541643E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02806846",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.003661568",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.05745755E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.94625500E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.05745755E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.94625500E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.170635",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02473689",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.807312",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04560766",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "29.913406",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-29.729843",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "33.348816",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-34.677658",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03826763",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "4.00979197E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "332.90881",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.32143",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "322.91327",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.85199",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "330.61954",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.87843",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem07"
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem08/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc08_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "92.789284",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04560963",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8515.3945",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-808.41626",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.1875",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-73.5896",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-390.08984",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1774.1982",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1841.1257",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-73.591553",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.08984",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01841736",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-88.532257",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-62.357666",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-729.56689",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "5.2393627",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.4302969",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.6453075",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.2534657",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "338.64459",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "182.2478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "343.43018",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "182.237",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.35714947E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-694.77612",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.06781954E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "15.036133",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112240.66",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "47059.43",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.79405752E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-7.05861028E-27",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.69983434E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.28635531E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "456138.06",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-420124.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "975.64062",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "79.064728",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-248.86343",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258516",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.03020328",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1084.2874",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-790.81372",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "197.43042",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1511.5088",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "7.89489150E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-6.04410047E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "2145.0815",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1803.2527",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "626133.62",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-268477.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "978.14062",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "43.24614",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.9095",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "310.10614",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.26604",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "319.03015",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "196.73662",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "339.87939",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "182.237",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "313.15405",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.63452",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "scale_max": "0.02949612",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.007123571",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.30734",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.861467",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.71975753E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.60222135E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.71975753E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.60222135E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02949612",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.007123571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.01052353E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.05218544E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.01052353E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.05218544E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "37.302349",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0264616",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "37.953617",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04259541",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "31.080963",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-34.325241",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "34.630035",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-37.424118",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03962543",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.16015258E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "336.41339",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.23291",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "323.54242",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.10732",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "329.82025",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.12779",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem08"
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem09/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc09_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "97.322105",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04032446",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8524.3242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-809.47363",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1179.2188",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-73.195068",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-385.06152",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1963.7295",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1798.2959",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-73.288818",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.06152",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01873779",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-91.952087",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-61.618652",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-732.62256",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.7925215",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-5.2736444",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "6.2713909",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.4755507",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "339.71597",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "181.70511",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "347.76172",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "181.70885",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.42729061E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-709.41626",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "9.60164471E-07",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "15.769531",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112007.73",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "46560.832",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.58618648E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-8.82326093E-28",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.68092322E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.29294165E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "466568.88",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-445130.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "972.0",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "69.770813",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-257.89038",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258442",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.02922774",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "879.9231",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-697.14795",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "222.2251",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1299.6917",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.88620946E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-5.19710341E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1968.1167",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1579.5769",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "597574.5",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-315619.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "972.0",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "29.348907",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-257.89038",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "309.48621",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.17307",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "318.42572",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "195.51579",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "343.69922",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "181.70885",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "312.28436",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.65222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "scale_max": "0.02991978",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.004838075",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.26453",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-21.389551",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.78445534E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55661255E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.78445534E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.55661255E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02991978",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.004838075",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.97638474E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.00544173E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.97638474E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-2.00544173E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "37.264683",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02811874",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "38.101879",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04231608",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "32.079865",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-31.659882",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "30.437515",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-35.64949",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03537877",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8.56950919E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "335.69638",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.30931",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "323.80768",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.17531",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "329.84607",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "185.18958",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem09"
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "year0": "200208",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem10/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc10_%6d.01"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "94.477043",
                                            "gribparam": "230",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.03746678",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "8517.6562",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-806.64478",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "1178.0625",
                                                "gribparam": "178",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "-75.802002",
                                                "gribparam": "179",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-387.61523",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1918.8186",
                                                    "gribparam": "105",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1704.4329",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "-78.403809",
                                                    "gribparam": "188",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.0481",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.01913452",
                                            "gribparam": "220",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-87.541565",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "-68.654053",
                                            "gribparam": "205",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-734.41748",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "4.6782875",
                                            "gribparam": "181",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.4819717",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "6.2275352",
                                            "gribparam": "180",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-4.7704659",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "337.67484",
                                            "gribparam": "169",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.67175",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "348.35706",
                                            "gribparam": "139",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.64255",
                                            "subcenter": "255",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.15294608E-06",
                                            "gribparam": "160",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "srun",
                                            "gribleveltype": "1"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-699.69702",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.12128328E-06",
                                            "gribparam": "218",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.166992",
                                            "gribparam": "141",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "gribparam": "151",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "112606.4",
                                            "gribparam": "134",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "47313.863",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.26263999E-07",
                                            "gribparam": "144",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "units": "unitless",
                                            "scale_min": "-3.52930514E-27",
                                            "subcenter": "255",
                                            "grib_name": "prs",
                                            "gribleveltype": "1"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.70797432E-06",
                                            "gribparam": "142",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "gribparam": "260",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.25821305E-06",
                                            "gribparam": "143",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "474018.69",
                                            "gribparam": "108",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-445982.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "973.3125",
                                                "gribparam": "176",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "scale_max": "63.400589",
                                                "gribparam": "177",
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "subcenter": "255",
                                                "scale_min": "-260.00513",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "16.258425",
                                            "gribparam": "152",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "-0.02972448",
                                            "subcenter": "255",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1358.167",
                                            "gribparam": "146",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-781.69922",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "211.83472",
                                            "gribparam": "147",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1446.8623",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "units": "unitless",
                                            "scale_min": "0.0",
                                            "subcenter": "255",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "8.47041122E-08",
                                            "gribparam": "182",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "subcenter": "255",
                                            "scale_min": "-5.78559707E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "gribparam": "274",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "gribparam": "273",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "1910.0908",
                                                    "gribparam": "106",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-1606.1335",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "608417.88",
                                                    "gribparam": "107",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-293880.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "976.125",
                                                    "gribparam": "185",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "scale_max": "36.101044",
                                                    "gribparam": "186",
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.87842",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "309.21326",
                                            "gribparam": "183",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "210.28976",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "318.15918",
                                            "gribparam": "209",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "198.91429",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "343.90317",
                                            "gribparam": "207",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "186.64255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "312.03534",
                                            "gribparam": "170",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "209.86931",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "scale_max": "0.02842269",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.007144462",
                                            "units": "unitless",
                                            "grib_name": "hus"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "missing_value": "NaN",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "gribparam": "132",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "gribparam": "131",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "410.27731",
                                            "gribparam": "130",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-22.075171",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "1.72541677E-05",
                                            "gribparam": "138",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.56366605E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "gribparam": "148",
                                            "units": "meter2 second-1",
                                            "scale_max": "1.72541677E-05",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.56366605E-05",
                                            "gribleveltype": "109"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "gribparam": "156",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "gribparam": "135",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.02842269",
                                            "gribparam": "133",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-0.007144462",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "2.14816964E-06",
                                            "gribparam": "155",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.92894504E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "gribparam": "149",
                                            "units": "meter2 second-1",
                                            "scale_max": "2.14816964E-06",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-1.92894504E-06",
                                            "gribleveltype": "109"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "35.397903",
                                            "gribparam": "171",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02507722",
                                            "subcenter": "255",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "38.391483",
                                            "gribparam": "216",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "0.04738655",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "31.742569",
                                            "gribparam": "166",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-33.480743",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "38.367371",
                                            "gribparam": "165",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "-35.707062",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "0.03984717",
                                            "gribparam": "168",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "9.34953732E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "341.68939",
                                            "gribparam": "201",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.70744",
                                            "subcenter": "255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "326.24609",
                                            "gribparam": "202",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.64722",
                                            "subcenter": "255",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "332.62216",
                                            "gribparam": "167",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "subcenter": "255",
                                            "scale_min": "189.66231",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem10"
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem11/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc11_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03971796",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "91.025414",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8515.4492",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-808.4856",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-385.51416",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.380127",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1860.083",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1655.6941",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.51416",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.288086",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-92.057434",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01876831",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-733.07495",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.92627",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.4546604",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6790428",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.6239223",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4707422",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.38908",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.42114",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.39259",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.78513",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44804756E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-695.5188",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.68895620E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.50415",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "46961.715",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112433.67",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.32469050E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57677118E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39206304E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-420794.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "422455.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.23438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-260.323",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "57.73439",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03029409",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-793.30835",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1116.5159",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1369.1597",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "238.58105",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.47488582E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.54036636E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1561.717",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1961.5229",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-272453.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635946.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "980.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-260.323",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.692978",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.57622",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89426",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "196.37498",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "319.30334",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.39259",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.52383",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.06892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.815",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.008112136",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02939897",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.551443",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.423",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.58716630E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74406887E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.58716630E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74406887E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.008112136",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02939897",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.88692684E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02307479E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.88692684E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02307479E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03319329",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.385342",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06484956",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.232479",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.401413",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.012939",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-32.610733",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.997467",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "5.81832040E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03627416",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.99541",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.35559",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.34279",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.9892",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.5999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.53247",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem11"
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem12/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc12_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04547535",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.863571",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8530.5586",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-802.67407",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-391.61792",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.543945",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1959.1526",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1664.3015",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.32593",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.255127",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-85.067215",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01890564",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-724.23755",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.052734",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.3967266",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2995119",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.1604929",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6173849",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.15768",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.80884",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.19888",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.8576",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25195481E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-702.08203",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21456105E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.753906",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47345.164",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112317.02",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.65286416E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55695534E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36911626E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-440615.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "456415.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "970.42188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-265.28882",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "75.59198",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03072255",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-734.90918",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1144.0374",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1445.678",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "227.40527",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.78086201E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.09344635E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1573.9883",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1702.8406",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-301266.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "616329.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.96875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.28882",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.590469",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.04556",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29547",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "195.5347",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "318.65295",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.19888",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "340.55096",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.64536",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.08148",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.008144587",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02789818",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.583612",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.32736",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.56206970E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71268603E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.56206970E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71268603E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.008144587",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02789818",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.94551671E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10762914E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.94551671E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10762914E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03496195",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.744625",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04887621",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.008606",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.780365",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.021164",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-32.791122",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.554306",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "9.74868613E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03686246",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.06981",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.99908",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.8204",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.58749",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "186.86913",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.75116",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem12"
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem13/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc13_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04566569",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "97.857491",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8519.9922",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-805.34448",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-392.2981",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.906982",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1692.4331",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1889.3792",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.2981",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.598633",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-89.357376",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01882935",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-728.24072",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.326172",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.7112055",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6411533",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-6.2549582",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.112978",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.67355",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.14178",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.66278",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.84174",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73317585E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-696.56323",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00160833E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.998535",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "46999.652",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112104.97",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.21151446E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64443622E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28556724E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-422308.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "468759.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-262.76855",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "63.375916",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.0301673",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258501",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-781.26025",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1122.6265",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1400.095",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "192.12646",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.59858734E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68231132E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1548.9558",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1748.5432",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-350935.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "637249.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.76855",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.553436",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.82065",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59686",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "197.10612",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.39111",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.66278",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.67963",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.17693",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.23944",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.005342346",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03203404",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-22.09362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.34879",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.55676662E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79882118E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.55676662E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79882118E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.005342346",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03203404",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.80973439E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10759526E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.80973439E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10759526E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02518647",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.127953",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04315287",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.731323",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.095871",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.528641",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-32.372269",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.199234",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "7.40247401E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03649069",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.79118",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "333.21643",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.50235",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "322.33588",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "187.75281",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.89478",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem13"
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem14/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc14_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03879613",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "99.846771",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8512.2227",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-812.47632",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-388.52222",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.843994",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1973.9509",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2130.5188",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.52222",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.072998",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-88.925079",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01829529",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-731.646",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.515869",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.575984",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3185196",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.7019062",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4772339",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.20253",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.03101",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.22194",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.17007",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50694973E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-705.42871",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11039844E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.334961",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47363.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112685.27",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.37710695E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73538297E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31397019E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-412895.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "450425.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "969.5",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-259.5481",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "65.811981",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.02951626",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258507",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-722.47974",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1294.3457",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1703.7241",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "217.79248",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-6.81271615E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.70883810E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1470.1814",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2090.2761",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-319690.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "634588.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.5",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-259.5481",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.2379",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.28348",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59766",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "197.70985",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "319.37753",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.22194",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.13867",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.86739",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.11346",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006574143",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03062735",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.793133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.33841",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.52874672E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81516316E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.52874672E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81516316E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006574143",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03062735",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.96935298E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88972047E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.96935298E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88972047E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02018339",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.531559",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.05210032",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.087399",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-34.068634",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.600204",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-29.667709",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.99614",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8.83770213E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03675773",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.24223",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.07837",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.49481",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.64001",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "187.51477",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.14398",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem14"
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem15/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc15_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04030621",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.552299",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8518.8984",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-803.52246",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-391.23755",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.382324",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1768.3682",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1615.8145",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-391.23755",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.562012",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-88.047073",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01858521",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-739.9104",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.082275",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.163847",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2479296",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.1419029",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.505475",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.91759",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.99573",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.0399",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "348.22748",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57302247E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-696.88281",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10588735E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.137207",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47385.332",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112391.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.82311417E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55908083E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25626445E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-421510.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "437075.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "979.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-267.88989",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "76.306259",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.02944251",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258526",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-728.98022",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1150.1521",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1486.7383",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "222.28345",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.94505025E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.88879583E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1350.7048",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1666.1345",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-266466.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "664182.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-267.88989",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.044907",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.07243",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.76514",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "197.73033",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "319.30533",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.0399",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "344.00275",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.49835",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.21783",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.01137783",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03360097",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.685377",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.47101",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.59266820E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72469390E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.59266820E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72469390E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.01137783",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03360097",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.07443190E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95581674E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.07443190E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95581674E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0267345",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.243908",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03395388",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.870758",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-34.412262",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.456253",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-36.926376",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.244766",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "7.62226477E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04436133",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.26192",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.51465",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.92419",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.74838",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "187.99831",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.51465",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem15"
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem16/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc16_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04422385",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.343781",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8478.6055",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-802.42725",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-390.37305",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.278564",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-2003.9387",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1990.9253",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.37305",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.083984",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-87.774139",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01876831",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-733.97778",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.793945",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.2330132",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5071793",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.1486702",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "7.4476709",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.00945",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.68469",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.01306",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.08862",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57986187E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-701.08643",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23851351E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.646973",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "46926.887",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112257.91",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.11897314E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.94595054E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34364677E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-408295.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "490131.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "968.48438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-268.6377",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "77.0905",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03038144",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258541",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-836.48462",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1075.6292",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1203.186",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.16626",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.81120424E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36445429E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1647.6885",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2167.7158",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-286051.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "616413.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.48438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-268.6377",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.274582",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.92268",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.37616",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "195.23721",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "318.34674",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.01306",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.63745",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.39633",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.32797",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006739642",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0298213",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-22.187309",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.76309",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.51709082E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79186136E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.51709082E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79186136E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006739642",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0298213",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00851059E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07736070E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00851059E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07736070E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02163803",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.432945",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.05523648",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.18335",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-30.111053",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.271317",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-36.146652",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.445847",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "5.64501086E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03399777",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.53459",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.32538",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.38838",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.06573",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "187.49272",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.44049",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem16"
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem17/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc17_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03619625",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "93.332062",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8480.207",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-813.09912",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-393.96875",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.805908",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-2247.2288",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1741.8501",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.18384",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-70.860596",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-89.683609",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01869202",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-748.12402",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.475342",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.6563587",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3808193",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.9627609",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6853914",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "180.87392",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.11646",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "180.81883",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "348.03735",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58398586E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-698.82349",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04057835E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.005859",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47218.07",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112062.82",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.92490334E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.69942223E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24618714E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-429533.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "468215.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "969.76562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-277.52539",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "79.353973",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03026057",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-740.83057",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "940.87305",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1235.4656",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "187.73364",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.94028143E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.50701759E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1809.0818",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1755.8606",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-284850.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "618210.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.76562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-277.56885",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.682648",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.00525",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.62451",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "196.20677",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "319.0101",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "180.81883",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.84506",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.52437",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.46185",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.00777626",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02791874",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.593433",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.15887",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.61034386E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81336709E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.61034386E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81336709E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.00777626",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02791874",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.15222894E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00771160E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.15222894E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00771160E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03311005",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.200039",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0591724",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.730003",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.367416",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.410751",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-37.069183",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.654556",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "4.61523229E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03348602",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "183.55582",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.32233",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "183.24422",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.87592",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.2849",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.67523",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem17"
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem18/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc18_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0432536",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "90.054497",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8547.0273",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-805.43579",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-385.57251",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.419434",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1846.7776",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1643.2515",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.82056",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.419434",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-87.093979",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01864624",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-736.01904",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.027344",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.4970922",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0192785",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.5726786",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7917986",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.4409",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.16528",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.40289",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.56863",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22156337E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-699.12598",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05437357E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.491699",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "46947.215",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112119.42",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.65385630E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62625668E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33085666E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-407014.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "471819.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "971.78125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-262.04126",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "76.498856",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03035204",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25852",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-702.37988",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1004.7976",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1430.9187",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.27124",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.72184319E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36820027E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1599.105",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1786.343",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-300843.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "660891.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.6875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.05518",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.527649",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.21176",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.49942",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "195.9144",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.2215",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.40289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.5434",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.73444",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "311.89957",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.004676051",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02941443",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.68063",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.25211",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.53297369E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81102496E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.53297369E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81102496E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.004676051",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02941443",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.97541226E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07478797E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.97541226E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07478797E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03264575",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.952175",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04982528",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.700592",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-28.579178",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.438751",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-35.866135",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.521744",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "3.75571254E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03918955",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.57626",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.42346",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.16808",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.1076",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "186.21103",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.51642",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem18"
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem19/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc19_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04979943",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.030197",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8522.0859",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-805.18896",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-397.24756",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.815674",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1842.0481",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1556.0312",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-397.24756",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.971924",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-85.726349",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.019104",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-723.67114",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.814209",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.4466925",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8579388",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.0262041",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4762659",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.6676",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.88058",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.53455",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.28467",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19281412E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-735.54175",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03842467E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.717529",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47256.035",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112399.16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.56212728E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74736090E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44149487E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-426273.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "426726.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "971.1875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-275.90527",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "73.644653",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03009525",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-703.38989",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1054.8357",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1617.7383",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "192.38794",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-6.46888282E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.69276483E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1680.3882",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1701.0757",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-280587.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630957.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.1875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-277.4231",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "49.658936",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.3241",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.21655",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "197.74638",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "318.34705",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.53455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.36481",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.70119",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.12109",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.003698813",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03102643",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.693596",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.3443",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.54293248E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72573600E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.54293248E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72573600E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.003698813",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03102643",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.93176447E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10999974E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.93176447E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10999974E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02980011",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.815674",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04700363",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.246487",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-30.72876",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.708389",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-33.598007",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.437592",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "7.80850655E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03494457",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.9599",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "338.5014",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.24738",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.54892",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.30319",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.23859",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem19"
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem20/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc20_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04721825",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "95.239792",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8532.4766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-801.14453",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-383.41016",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.028564",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1630.3757",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1829.9702",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-383.41016",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.955811",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-90.832672",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01911926",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-745.78418",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.638672",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.2079821",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3215284",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.6489906",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2728491",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.93419",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.40302",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.79375",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "348.13818",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65669735E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-701.40088",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04287756E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.521484",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47032.113",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112455.38",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.05278682E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.70029364E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.17455236E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22555571E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-433983.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "483176.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "976.6875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-266.09766",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "77.37204",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03066443",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258488",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-772.96899",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1178.5049",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1438.9141",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "194.60181",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.75381421E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.78152298E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1739.8279",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1925.7007",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-321661.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635262.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.6875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-266.09766",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.860794",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.38564",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.96997",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "194.97694",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.62067",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "183.79375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.98975",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "208.70685",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "311.49854",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006048303",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02921246",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.828112",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.12607",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.56102760E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82233034E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.56102760E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82233034E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006048303",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02921246",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00980321E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08688380E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00980321E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08688380E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02515552",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.353672",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06672525",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.073124",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.214249",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.956772",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-32.653183",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.850937",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "4.75210129E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03433353",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.26361",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.36197",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.00362",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.81534",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "186.06644",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "337.36197",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem20"
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem21/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc21_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.05752024",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "98.356857",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8519.4492",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-805.43408",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-394.63892",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.158447",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1776.4946",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1613.6619",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.63892",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.677979",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-85.154007",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01832581",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-726.87109",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.570557",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.9431372",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7379322",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.7269564",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1294985",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.94495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.3898",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.9619",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.90826",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13043791E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-697.01538",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04409992E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.572754",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47380.914",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112456.56",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.01760166E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.84512805E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50068547E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-404129.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "496051.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "972.32812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-249.84319",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "63.847488",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03073005",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258497",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-727.05493",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1127.467",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1210.5498",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "190.32544",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.84064969E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.61071703E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1442.3811",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1813.9158",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-321107.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635973.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.04688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-249.88515",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "23.99147",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.9111",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29297",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "198.64383",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "320.0224",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.9619",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "340.79694",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.48497",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.1283",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.007486403",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02964471",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.424946",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.51761",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.48114095E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79897852E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.48114095E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79897852E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.007486403",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02964471",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.06279924E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.23808661E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.06279924E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.23808661E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02488391",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.591034",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04686807",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.129704",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-30.448425",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.171936",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-33.016083",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.249344",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8.16950205E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03834465",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.20699",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.77051",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.06142",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "321.81796",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "189.08229",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.3884",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem21"
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem22/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc22_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0385423",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "91.68515",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8481.3633",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-806.36768",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-384.93164",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.03418",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1923.8003",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1513.8752",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.93164",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.66333",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-88.415146",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01875305",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-728.76392",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.221436",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.705698",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "7.4612103",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.9681273",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0165997",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "181.42435",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "340.07693",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "181.40503",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.78061",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37495419E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-694.71631",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01310434E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.639648",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "46762.82",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112366.53",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.50767890E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.04583489E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20157290E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-425264.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "490630.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "968.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-255.69225",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "62.846939",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.02999176",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258453",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-776.14966",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1366.1519",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1429.5635",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "200.88647",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.71642374E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.03313753E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1701.0334",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1749.8396",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-337354.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "626532.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.17188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.2959",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "26.100662",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.40489",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.78448",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "195.64877",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.71588",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "181.40503",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.65756",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.48387",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.28662",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006928936",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02765715",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-22.061617",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.22931",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.52107077E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74756224E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.52107077E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74756224E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.006928936",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02765715",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.09172140E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26970610E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.09172140E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26970610E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01536447",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.441578",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03377423",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.436737",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-30.439865",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.107086",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-33.236115",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.130722",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "6.44949409E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03746915",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.06287",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.52805",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.03304",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "321.87463",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.06287",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "336.52805",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem22"
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem23/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc23_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.03567115",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "91.995598",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8512.2422",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-809.32495",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-386.06226",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.540527",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1687.5352",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1403.4602",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.06226",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.438965",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-88.428894",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01913452",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-719.84204",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.206055",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-4.2196655",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2135963",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.1027727",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.30196",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.12036",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.52823",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.12129",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.68323",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59250260E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-696.91748",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.97970346E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.632324",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47271.816",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112234.11",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-8.82327826E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.74273565E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65151789E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23002701E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-394089.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "462051.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "972.76562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-254.1398",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "79.692001",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.03105781",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258482",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-771.59668",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1173.9685",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1253.8079",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "205.55688",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.01362706E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.21968342E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1370.9836",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1847.3733",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-278015.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627232.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.09375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-254.1398",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.620773",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.43504",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.11169",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "195.85025",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.22675",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "182.12129",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.6507",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.51457",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "311.9306",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.004145872",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02905769",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.943607",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.22552",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.58958046E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74009529E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.58958046E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74009529E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.004145872",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02905769",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.90063668E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09907603E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.90063668E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09907603E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02228612",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.557777",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.04366729",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.893261",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-33.47435",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.280258",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-37.42041",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.917694",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "5.19664276E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03676822",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.09262",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.67667",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.32697",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.73996",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "184.55055",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.83716",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem23"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                        "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.feb2002/.SIX-HOURLY/.mem24/.griblist.html",
                                        "Conventions": "IRIDL",
                                        "filepattern": "/mstore/iri/forecast/data/echam4/asst/feb02/30006fc24_%6d.01",
                                        "year0": "200208"
                                    },
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.05364768",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "99.082947",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "8518.5156",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-804.46606",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-389.48169",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.771484",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1988.2046",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1842.4702",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.48169",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.871826",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-85.499924",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01831055",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-719.91699",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.439941",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.0191488",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7083797",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.1626644",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8764572",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.86497",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.69098",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.88556",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.13892",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29305101E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-700.81226",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08696986E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.497803",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "47155.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "112702.78",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.14384998E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.87069236E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23031748E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-419247.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "426683.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "967.90625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_min": "-254.45477",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "69.947937",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.02955252",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258469",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-856.79688",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1025.6418",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1297.6865",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "185.67065",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-5.18908507E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.42474526E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-1341.9639",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1810.5801",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-256077.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "660511.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_min": "-254.45477",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.611328",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "210.13968",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.87695",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "198.95137",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "319.05112",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "185.88556",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.09454",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "209.73093",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.13275",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.007042486",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03041704",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-21.772392",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "410.73926",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.54915288E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77279762E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-1.54915288E-05",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77279762E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst feb2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-0.007042486",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03041704",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00409363E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13811586E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-2.00409363E-06",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13811586E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02311429",
                                            "grib_name": "wind10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.722454",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "0.02947626",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.324894",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-30.461014",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.121185",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "-31.273605",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.53598",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "1.23189409E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03471608",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.50206",
                                            "grib_name": "t2mmx",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "334.84827",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.41159",
                                            "grib_name": "t2mmn",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.87366",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_min": "190.42464",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.07886",
                                            "gribparam": "167"
                                        }
                                    },
                                    "Z_10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "Z_09": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_09",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_08": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_08",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_07": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_07",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "Z_06": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_06",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "cm_down",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Depth"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "pressure"
                                    },
                                    "sp_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "C": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "C",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "ids",
                                        "gridtype": "2",
                                        "long_name": "complex"
                                    },
                                    "Z_05": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_05",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_04": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_04",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "Z_03": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_03",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Height"
                                    },
                                    "sp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0"
                                    },
                                    "Z_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "0.0"
                                    },
                                    "Z_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Z": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m_above_gnd",
                                        "gridtype": "0",
                                        "pointwidth": "0",
                                        "long_name": "Height"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 2001-01-01 00:00:00",
                                        "gridtype": "0",
                                        "pointwidth": "0.25",
                                        "calendar": "standard",
                                        "defaultvalue": "607.75"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "modulus": "360.0"
                                    },
                                    "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/feb2002/SIX-HOURLY/mem24"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "mem01",
                                    "mem02",
                                    "mem03",
                                    "mem04",
                                    "mem05",
                                    "mem06",
                                    "mem07",
                                    "mem08",
                                    "mem09",
                                    "mem10",
                                    "mem11",
                                    "mem12",
                                    "mem13",
                                    "mem14",
                                    "mem15",
                                    "mem16",
                                    "mem17",
                                    "mem18",
                                    "mem19",
                                    "mem20",
                                    "mem21",
                                    "mem22",
                                    "mem23",
                                    "mem24"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "jan2002": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/jan2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "jan2002",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc24_%6d.01",
                                    "mem24year0": "200207",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc23_%6d.01",
                                    "mem23year0": "200207",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc22_%6d.01",
                                    "mem22year0": "200207",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc21_%6d.01",
                                    "mem21year0": "200207",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc20_%6d.01",
                                    "mem20year0": "200207",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc19_%6d.01",
                                    "mem19year0": "200207",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc18_%6d.01",
                                    "mem18year0": "200207",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc17_%6d.01",
                                    "mem17year0": "200207",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc16_%6d.01",
                                    "mem16year0": "200207",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc15_%6d.01",
                                    "mem15year0": "200207",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc14_%6d.01",
                                    "mem14year0": "200207",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc13_%6d.01",
                                    "mem13year0": "200207",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc12_%6d.01",
                                    "mem12year0": "200207",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc11_%6d.01",
                                    "mem11year0": "200207",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc10_%6d.01",
                                    "mem10year0": "200207",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc09_%6d.01",
                                    "mem09year0": "200207",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc08_%6d.01",
                                    "mem08year0": "200207",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc07_%6d.01",
                                    "mem07year0": "200207",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc06_%6d.01",
                                    "mem06year0": "200207",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc05_%6d.01",
                                    "mem05year0": "200207",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc04_%6d.01",
                                    "mem04year0": "200207",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc03_%6d.01",
                                    "mem03year0": "200207",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc02_%6d.01",
                                    "mem02year0": "200207",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jan2002/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri/forecast/data/echam4/asst/jan02/30005fc01_%6d.01",
                                    "mem01year0": "200207",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03279812",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "97.225235",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8500.2812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.89868",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5938",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-395.25537",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.350342",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1632.6357",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1577.9519",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8438",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-395.25537",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.894531",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-85.914627",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05238342",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.14819",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.22998",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0943336",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2203341",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.354372",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.9699869",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.00592",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.00983",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.06052",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "348.37756",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17132845E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-690.50195",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17407762E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.450684",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47256.039",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112357.41",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.26761720E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51063603E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57770251E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-438272.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "432658.06",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "973.59375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-270.00464",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "80.493744",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03084312",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258516",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-718.38354",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1125.4028",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1568.3291",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "171.06714",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.27130930E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.84055692E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1792.4719",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1913.467",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-289124.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615150.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.59375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-270.00464",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "45.660675",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.14034",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.87772",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.26282",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.31683",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.06052",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.97131",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.35413",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.1217",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004251331",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03199366",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.438604",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.34326",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.60094605E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.59809952E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.60094605E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.59809952E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004251331",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03199366",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.30605565E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11836937E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.30605565E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11836937E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03376244",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.521477",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05518175",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.099377",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.202881",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.820618",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.347733",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.849823",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.81673180E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03302071",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.48289",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "341.30835",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.98793",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.15393",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.99562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.68643",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04006007",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "92.057632",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8519.0508",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.69653",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5938",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-392.00024",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.692139",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1584.6614",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1881.8127",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.00024",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.535889",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.635284",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.051651",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-745.65698",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.435791",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1146107",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.202817",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.3115196",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6078076",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.83926",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.57379",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.84174",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "348.33826",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42241299E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-692.87988",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08595123E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.549805",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47081.293",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112359.53",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02190177E-06",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53074677E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46323271E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-463740.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "475793.06",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "969.20312",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-261.90186",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "75.64595",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02875724",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.70483",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1228.6924",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1390.3154",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "175.25854",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.55948247E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.00810858E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1533.7637",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1781.7795",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-283966.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "623171.06",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "982.35938",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-261.90186",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.206696",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.43488",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.11285",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.2632",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.62549",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.84174",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "344.10956",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.72362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.28027",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003125117",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03018439",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.733534",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.24762",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58440580E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63477907E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58440580E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63477907E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003125117",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03018439",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.28358658E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13500539E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.28358658E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13500539E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02137032",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.921795",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04602501",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.851433",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.580704",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.08461",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.899567",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.246017",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.66346978E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.041143",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.91922",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "336.85797",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.86748",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.52509",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.88808",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.34811",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05126878",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.104141",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8485.9648",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.71387",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0312",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-391.87744",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.266602",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1750.5046",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2117.6084",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.87744",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.571289",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.635254",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05221558",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.56177",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.435059",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0646782",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1932049",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2460251",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.060936",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.5253",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.40137",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.48264",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.76971",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25546626E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-708.54492",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.76433512E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.593262",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47149.25",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112263.62",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.76716478E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37047084E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44606906E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-444396.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "475064.81",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "972.65625",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-246.76799",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "67.669724",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03163538",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25848",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-741.47046",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1046.9246",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1392.4131",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "204.3335",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.56787029E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.76335014E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1786.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1888.1938",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-335424.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "599436.06",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.65625",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-247.5544",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.194534",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.40459",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.78571",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.30493",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.40085",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.48264",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "339.65253",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.78809",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.96973",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004741929",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0288264",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.85808",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.30319",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58756866E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.61638636E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58756866E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.61638636E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004741929",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0288264",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.97664053E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15659702E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.97664053E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15659702E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02938361",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.99411",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05482521",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.446007",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.400024",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.957397",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.795868",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.70639",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.19425522E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03667312",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.78923",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.7359",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.47435",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.17978",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.47763",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.15173",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03611544",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "90.966675",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.1953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.50562",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6562",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-408.27173",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.88916",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1706.1235",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1782.1711",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4062",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-408.27173",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.641602",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-91.60318",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05215454",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.73145",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.888428",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3289557",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6718168",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.5546198",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3105526",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.89104",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.48611",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.88492",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.98593",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.90316405E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.58252",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08539825E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.663086",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47111.961",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "113060.6",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.03516309E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.69953591E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36645599E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-418641.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "470164.56",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "983.51562",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-268.87183",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "66.934845",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03134108",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258432",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-725.3623",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1193.4043",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1231.1169",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "204.17041",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.92289246E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.16447994E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1980.0046",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2128.6934",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-296588.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "633484.12",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "983.51562",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-268.87183",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.345459",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.91118",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.2933",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.19817",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.07098",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.88492",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.05304",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.04863",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.82599",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004750445",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02762971",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.743299",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.31079",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55550915E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56345213E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55550915E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56345213E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004750445",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02762971",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93227766E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25611598E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93227766E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25611598E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02800023",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.1007",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04699022",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.336403",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.028549",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.132065",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.618958",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.874207",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.93001835E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03735365",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.09473",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.39551",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "184.89044",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.38965",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.96484",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.52753",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04498257",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "90.544495",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8554.6836",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.15161",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-405.1394",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.142822",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1482.03",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1802.7585",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-405.1394",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.174072",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.207062",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05163574",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.34668",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.14624",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2932177",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3532238",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.861042",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5176497",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.36237",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.33081",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.37109",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.4317",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29262412E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.51343",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21825724E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.375977",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46882.258",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112402.22",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.05872196E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52536506E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45871786E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-445410.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "435317.5",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "978.07812",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.00171",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.31485",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03051428",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258429",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-860.63208",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1121.8218",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1315.4978",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "192.27686",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.26030760E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68854420E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1677.7432",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1890.4641",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-293880.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "578967.44",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "978.07812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.01392",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.392975",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.38565",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.97159",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.61125",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.05743",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.37109",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.17194",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.03781",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.41086",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006879296",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02972195",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.367874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.2345",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57540962E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55899907E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57540962E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55899907E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006879296",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02972195",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88441993E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95235702E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88441993E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95235702E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03565289",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.650909",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04870835",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.742775",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.371262",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.316101",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.623749",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.270294",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.76401354E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04108543",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.54251",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.34613",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.48283",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.71625",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.49136",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.34357",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05060116",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "99.05706",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8457.8008",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.25732",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-401.82642",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.196045",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1945.0286",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1925.5295",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0938",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-401.82642",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.417236",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.077042",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05221558",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.03101",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.163086",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9406404",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4874477",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.909688",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0060225",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.72763",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.77493",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.56387",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "348.14719",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23699851E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.46558",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15102739E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.705078",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46922.699",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112676.48",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.79904803E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58186208E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39460064E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-433913.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "466470.5",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "969.53125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-295.24146",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "64.778366",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02979471",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258453",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-789.5874",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "879.54395",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1222.7153",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "190.55273",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.88929629E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.61966987E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1618.0498",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1705.9099",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-242484.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "666316.19",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.20312",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-295.24146",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.731064",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.32439",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.21576",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.79915",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.03992",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.56387",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.85422",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.63492",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.1564",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004803076",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03144464",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.868572",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.57181",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52222947E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58550938E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52222947E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58550938E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004803076",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03144464",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92358925E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.17095726E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92358925E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.17095726E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02262837",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.194168",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03729128",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.546478",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.542221",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.133606",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.608994",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.625443",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.17230059E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03793859",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.40215",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.8631",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.72005",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.96393",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.77191",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.04657",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03899765",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "89.061218",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8511.5977",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.31982",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4062",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.51367",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.829346",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1758.3281",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1588.8745",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9062",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.51367",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.516846",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.098999",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05218506",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-737.85498",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.5271",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9464703",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3121967",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.0395536",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.2973509",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.10489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.24951",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.02737",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "348.38504",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21316873E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.9585",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21380435E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.452637",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46992.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112072.17",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09270434E-06",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.79728238E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53576866E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-420203.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "496806.38",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "966.17188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-276.07349",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "73.992004",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0305696",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.55298",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "894.33398",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1354.4272",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "172.93457",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.41597558E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.91497348E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1913.7119",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1799.7153",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-306146.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "567819.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.32812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-276.07349",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.765656",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.21188",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.49744",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.43736",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.10278",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.02737",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "344.16629",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.53528",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.38098",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005792174",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02837262",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.744999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.25244",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50210390E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63083678E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50210390E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63083678E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005792174",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02837262",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09455106E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05732658E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09455106E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05732658E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02800053",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.196156",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04838804",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.501789",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.181412",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.630005",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.465454",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.52066",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.33332596E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03433188",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.17746",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.94928",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.07631",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.07098",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.08644",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.60229",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03966185",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "92.447487",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8477.8047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.14062",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-395.68066",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.176758",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1818.2913",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2122.9744",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-395.68066",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.176758",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-93.540085",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05215454",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-730.9751",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.003662",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.5814095",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0994453",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.4713268",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.2417889",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.74713",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.94653",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.71964",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.51416",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29032742E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.92236",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04110222E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.040771",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46848.309",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112192.61",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.65673712E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.78467337E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45444085E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-443597.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "439058.31",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "968.5625",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-293.12402",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "78.429672",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03014309",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258453",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-704.18457",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1143.5249",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1496.7195",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "202.25415",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.98496229E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.08732921E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2131.4304",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2109.075",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-339525.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "625059.06",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.64062",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-293.12402",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.67514",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.00504",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.62341",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.40877",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.30923",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.71964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "341.31567",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.25827",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.04733",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004841097",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02909963",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.66663",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.49863",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59029278E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.66425070E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59029278E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.66425070E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004841097",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02909963",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93792152E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04340199E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93792152E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04340199E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02963049",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.104858",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04266725",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.345242",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.740768",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.518311",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.060211",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.32489",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.33830916E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03351516",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.59526",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "336.04593",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.37758",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.9519",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.49203",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.65894",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0356346",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.446312",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.4531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.83984",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.3125",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-388.77002",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.566406",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1956.4802",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1769.3997",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.2188",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-397.87695",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-70.566406",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.790436",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05197144",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-735.62451",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.554199",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0827684",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.2612991",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8833761",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5485878",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.01338",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.07169",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.79222",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "346.39389",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21750145E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.24194",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22151687E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.773438",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47242.879",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112508.13",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.47398929E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.92768357E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29040836E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-398324.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "458848.25",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "969.79688",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-272.77295",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.074371",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03236537",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258587",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-784.30127",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1341.2334",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1440.4893",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "173.48145",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.76011359E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.93687525E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1711.0359",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1795.8096",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-299680.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "601905.62",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.07812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-272.77295",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.63269",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.92264",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.37616",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.3829",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.46155",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.79222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.36655",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.20789",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "311.88171",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004022695",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02859046",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.491917",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.30942",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.61573480E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.57902414E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.61573480E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.57902414E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004022695",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02859046",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04243588E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06388791E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04243588E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06388791E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03171047",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.44099",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05216129",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.471706",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.626251",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.868515",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.207779",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.785187",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.48028697E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03664187",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.36783",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.34235",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.27301",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.62311",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.29552",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.56342",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05597227",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.933403",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.1484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-810.3125",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.1875",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.65747",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.790527",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1576.4248",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1430.7568",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.65747",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.532715",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.71405",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05183411",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-760.85596",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.495117",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.643796",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2671671",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.65306",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2528014",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.89026",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.70184",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.83757",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "349.86002",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28474221E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.22217",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16458978E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.285645",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46702.785",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112107.2",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.90381932E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46359673E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34745017E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-442532.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "438224.12",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "976.78125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.60718",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "64.658478",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02995696",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.23242",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "900.22534",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1370.3633",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "177.78052",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.47969876E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.10916765E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1679.4573",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1719.6831",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-291717.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "588296.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.78125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.60718",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.552109",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.07327",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.76413",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.90617",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.28162",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.83757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "345.82489",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.14102",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.73282",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009485044",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02740366",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.876225",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.46927",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53322853E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62049073E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53322853E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62049073E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009485044",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02740366",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.85698366E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05982178E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.85698366E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05982178E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03155332",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.762329",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05714053",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.663895",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.822418",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.692535",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.649582",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.993393",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.93519837E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03924335",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.10191",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.31281",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.94115",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.94342",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.94115",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.81061",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04938572",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "90.727654",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8504.4961",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.76221",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.02197",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.771484",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1771.354",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1912.9563",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.02197",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.862793",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.807205",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05213928",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.3855",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.494873",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5844803",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9598546",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2690716",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4266367",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.58937",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.88647",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.56416",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "346.3302",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44870296E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.71509",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16619049E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.390869",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47023.828",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112199.43",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.80253686E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.92273160E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14813179E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-430034.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "459570.31",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "974.875",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-268.66089",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "73.835495",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03020157",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258501",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-878.58374",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1089.5068",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1159.3208",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "195.67798",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.63579909E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.82475524E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1894.9229",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1751.0674",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-335053.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "619088.38",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "983.29688",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-269.1853",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.68663",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28362",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59756",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.91042",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "316.59357",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.56416",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.13684",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.58946",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.84143",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005498942",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02744494",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.664064",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.23621",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53595756E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.67605667E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53595756E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.67605667E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005498942",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02744494",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00473028E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04061121E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00473028E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04061121E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03332272",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.155285",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04762281",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.727703",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.120178",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.435349",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.892334",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.639771",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.33502096E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03793893",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.43275",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "338.40424",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.23453",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.44659",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.39766",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.01019",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03409821",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.502769",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8514.9414",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.2356",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6875",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-411.1792",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.308594",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1895.583",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1855.5569",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-411.1792",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.308594",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.09433",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05212402",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-739.21899",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.095703",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5563583",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9443369",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4869928",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7466087",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.53238",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.92249",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.47168",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "348.17508",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32881075E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-703.95483",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05498475E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.998535",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46868.449",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112079.42",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.32926617E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51699612E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40192287E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-426770.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "455653.69",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "967.84375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-314.95898",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "78.17305",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03043221",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-690.81055",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "967.75854",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1373.167",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "174.42236",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.49090998E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.97449707E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1912.5901",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1814.6387",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-282337.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "644283.5",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.59375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-314.95898",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.593521",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.82104",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59723",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.15997",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.50259",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.47168",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.87625",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.05002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.4758",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007330321",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03081967",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.320656",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.26556",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.62245615E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48649196E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.62245615E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48649196E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007330321",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03081967",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04192793E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13113867E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04192793E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13113867E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0223157",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.20401",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03619342",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.585072",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.990356",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.881088",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.507782",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.5168",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.85105431E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03785572",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.97919",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "344.71381",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.82626",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.79913",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.97919",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.91821",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.02704778",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.398422",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8482.8242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.84839",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9062",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.7627",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.842529",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1909.1248",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1547.0107",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.92944",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.574951",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-92.033768",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05213928",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-704.625",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.902832",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0119781",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4134712",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6073332",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9822607",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "181.95769",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.5004",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.04222",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.48111",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32596904E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.52124",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15370494E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.808105",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46923.617",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112509.55",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46217324E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48276956E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48447759E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-411764.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "485170.0",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "968.25",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-261.16699",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "63.818146",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03074288",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258425",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1032.5278",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "991.00806",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1335.8572",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "184.62354",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.34171932E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.38276640E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1569.3582",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1758.4185",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-357191.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "599382.81",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.32812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-261.16699",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.750778",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.04518",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29541",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.78352",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "315.74091",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.04222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "341.52502",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.17505",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.39185",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00599841",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02891124",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.697838",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.14056",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55716261E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68355782E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55716261E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68355782E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00599841",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02891124",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04385469E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08635220E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04385469E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08635220E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02115323",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.892544",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04966527",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.22068",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.678558",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.451752",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.114853",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.056549",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.84435701E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03647654",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "184.83257",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.96512",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "184.08356",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.6228",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.25795",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.88434",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04218566",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "91.303787",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8517.3633",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.5874",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5938",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.89526",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.699463",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2064.3323",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1864.8279",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.89526",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.56665",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.192719",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05210876",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.62939",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.654297",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6626625",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9591379",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0629911",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2269163",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.22867",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.76599",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.19493",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "346.64899",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65341612E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.58423",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01278420E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.537109",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46932.477",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112227.91",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.16188651E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.69701559E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.34095262E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22080144E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-424263.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "442846.19",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "969.625",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-256.8772",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "62.120911",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03040779",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-888.04956",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "846.32764",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1206.8157",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "196.17847",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.82571863E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.84432359E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1884.7866",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1955.9961",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-336994.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "597975.69",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.01562",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256.8772",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.757523",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.57643",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89383",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.27771",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.1582",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.19493",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.28458",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.88618",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.98578",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006261572",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03119425",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.498901",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.45477",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57569502E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68601400E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57569502E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68601400E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006261572",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03119425",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09248401E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01493049E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09248401E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01493049E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02573823",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.195007",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05046295",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.401577",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.666992",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.449127",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.644287",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.895599",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.23577989E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03420636",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.79378",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.09125",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.51808",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.08624",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.52065",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.29376",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04414987",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.771675",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8504.4922",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.14648",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.4062",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.54834",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.707764",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1655.5645",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1535.7678",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.49365",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.418701",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-89.27742",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05149841",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.43579",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.592285",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7693205",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6260643",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.2384787",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3612852",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.12581",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.70551",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.09435",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.77435",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17960053E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.93848",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07489177E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.248047",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46913.012",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112075.81",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.52167523E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73657793E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16029355E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-388502.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "452151.94",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "976.57812",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-262.63135",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.832169",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02934751",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258493",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.30908",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "982.99414",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1534.5149",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "190.27539",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.13609529E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60851435E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1528.4319",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1612.4421",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-317798.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "596853.31",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.57812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.27417",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.871521",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28973",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.21228",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.75945",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.37695",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.09435",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.64502",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.95753",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.77588",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006482229",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0282005",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.835667",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.38226",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56462283E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.51251052E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56462283E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.51251052E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006482229",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0282005",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89728985E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26322118E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89728985E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26322118E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03244055",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.988735",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04464823",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.407391",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.402298",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.580032",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.413437",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.025604",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.37112107E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03653794",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.64999",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.98254",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.17793",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.61426",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.17793",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.06702",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04614032",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "92.514168",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.8047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-810.58423",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1875",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-388.93237",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.442627",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1897.4287",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1812.728",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.93237",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.442627",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-92.112137",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05224609",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.90869",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.865723",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8388367",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5554543",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.8249741",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.1821613",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.35645",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.51422",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.30656",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.62476",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.80100710E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.35474",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06365769E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.715332",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47230.652",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112215.58",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.01387785E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.70521253E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17190871E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-442281.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "433112.81",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "976.73438",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-267.6272",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "62.00946",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03049485",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258425",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-784.40137",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1284.3999",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1581.0083",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "219.11768",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.32200965E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.76215154E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1757.6069",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1894.9675",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-296595.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591633.44",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.73438",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-270.90698",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "22.280106",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.17378",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.48572",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.86752",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.22565",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.30656",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "341.46655",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.24294",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.79565",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006971192",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02715807",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.278519",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.57147",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56006463E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58825642E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56006463E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58825642E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006971192",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02715807",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.85703766E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00471914E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.85703766E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00471914E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02789206",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.117619",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05609382",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.070274",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.551178",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.439209",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.14975",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.113373",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.77322384E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03683176",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.40707",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.66171",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.29153",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.75635",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.36113",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.48541",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05403472",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "97.768181",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8523.0781",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.10059",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4688",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-399.81494",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.330811",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1860.6182",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1977.2305",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-399.81494",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.733154",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.235764",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05209351",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.64258",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.655518",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4534636",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4356747",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.1733646",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8793154",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.00966",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.95096",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.9626",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.18298",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21402934E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-694.37109",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02564809E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.991699",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46987.027",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112547.71",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68794962E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.96745236E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.58326734E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68647409E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-424217.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "436854.31",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "968.17188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.99219",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "62.329636",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03045795",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258444",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-706.98291",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1088.6675",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1613.6641",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "162.33398",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.45259036E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.49145875E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1750.0569",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1927.0166",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-278473.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591021.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.85938",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.99219",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.1241",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.26651",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.10553",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.82089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.33484",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.9626",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "343.08044",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.39912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.35809",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00491865",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02879396",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.348112",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.19617",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57802988E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50224841E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57802988E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50224841E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00491865",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02879396",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90265860E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89156651E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90265860E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89156651E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03528754",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.692329",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05359773",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.572929",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.779816",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.216873",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.351868",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.212585",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.23061454E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03695253",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.65788",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "339.17105",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.20444",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.33344",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.42421",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.33252",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03605553",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "89.509308",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8536.4141",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.34131",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.86133",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.600586",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1616.2898",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1888.9238",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.86133",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.936523",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.401733",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05227661",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-737.20068",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.482422",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0461493",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8971701",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1601133",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6567783",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.22368",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.82547",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.10495",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.03714",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30477611E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-704.7937",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30294939E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.197754",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47077.98",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112364.7",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.29395617E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.53446272E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67835958E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.26089413E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22891424E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-391688.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "451744.19",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "971.40625",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-249.99353",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "68.62941",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03098821",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-747.93066",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "944.7749",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1348.2615",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "203.38794",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.39131975E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.13269594E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1625.0085",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1680.2285",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-295384.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "629478.81",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.65625",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-249.99353",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.495377",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.25461",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05753",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.82031",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.67786",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.10495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.78827",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.63701",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.25226",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006320141",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02859681",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.768345",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.10501",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53425553E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.69213108E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53425553E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.69213108E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006320141",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02859681",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88246622E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01711782E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88246622E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01711782E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02531172",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.175854",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04556179",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.344608",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.822845",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.660461",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.518097",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.707794",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.62810828E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0372132",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.07147",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.95773",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.58464",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "321.89133",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.61833",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.30457",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04874225",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "98.421356",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8531.4297",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.45361",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.66235",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.237549",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1650.155",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2017.9797",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0938",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.66235",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.241211",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.817841",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05148315",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.23145",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.475098",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.4429245",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0998211",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7600975",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.319418",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.33348",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.75192",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.35077",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.16177",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22711754E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-709.42554",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05996151E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.946533",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47260.566",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112032.58",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.51159484E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55424971E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.49077924E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63122502E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-412197.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "458816.38",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "973.78125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-274.99902",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.419022",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0303196",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-780.40576",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1016.458",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1252.823",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "196.11743",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.00968895E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.84241081E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1523.5752",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2284.9915",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-317867.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "611444.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.78125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.78174",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.529205",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.94676",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.6785",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.2005",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.87231",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.35077",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.98209",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.14098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82458",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00595966",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0311178",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.953468",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.30457",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56364313E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.53520868E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56364313E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.53520868E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00595966",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0311178",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94796439E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11104248E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94796439E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11104248E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03342896",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.85685",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05077953",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.737904",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.113052",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.912766",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.752579",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.203125",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.06056973E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03392826",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.27612",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.9805",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.0318",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.27905",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.06033",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.98111",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0445964",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.7882",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8524.3438",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-801.09766",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1562",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.88403",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.644775",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2011.8225",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2031.509",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0938",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.25708",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.62915",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-90.06041",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05239868",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.41211",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.65625",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.5776205",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3731356",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6289701",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3961868",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.53214",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.43054",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.38744",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.01642",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32723994E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.25366",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09651592E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.210938",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47416.82",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112183.82",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.87477370E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43939963E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26918974E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-446150.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "425485.62",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "967.42188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.69482",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "76.303299",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03030113",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-730.80762",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1142.9199",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1189.2068",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "179.89551",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.75530499E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.19379329E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1736.7664",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1840.3982",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-268744.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "624381.31",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.71875",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-262.19092",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.616394",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.21236",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05704",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.37326",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.46515",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.38744",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "341.27032",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.48595",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.78284",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004980434",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02886491",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.835546",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.35947",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59279898E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56204296E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59279898E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56204296E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004980434",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02886491",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99958163E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06741220E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99958163E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06741220E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03338828",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.349583",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05666662",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.117123",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.896454",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.030029",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.075546",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.323654",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.93093511E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03490199",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.38229",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "338.66315",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.7036",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "322.77542",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.89119",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.32916",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04908485",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "91.789597",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.1719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.37939",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6875",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-388.43408",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.151367",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1767.2705",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1904.4141",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.43408",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.32666",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.314774",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05224609",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.83325",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.151123",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.4310846",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0010128",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.6712866",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3827791",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.25935",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.7182",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.23154",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "346.58411",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21380197E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.18652",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08455424E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.729004",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47121.355",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112358.91",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.04031117E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.79799588E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23547125E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-420490.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "476893.75",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "966.84375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-256.24365",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "76.789505",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03026856",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258471",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.03516",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1076.3977",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1474.2642",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "187.4187",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.89516958E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49417950E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1936.8181",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1907.5146",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-332268.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591512.88",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.82812",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256.60278",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.052032",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.11485",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.35098",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.18584",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.0878",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.23154",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.39661",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.31364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.24921",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003503979",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02834012",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.358381",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.53555",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58753828E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58417315E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58753828E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58417315E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003503979",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02834012",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88473894E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99224792E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88473894E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99224792E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02334919",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.324478",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04029099",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.036888",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.797104",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.956955",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.662659",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.642548",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.97745656E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03626347",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.70351",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.65561",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.63727",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.5",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.65932",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.86627",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03888816",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.818436",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8532.1836",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.19434",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.3438",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.56494",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.677979",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1461.5278",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1679.533",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.5312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.56494",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.677979",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-89.737167",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05213928",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.00977",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.669434",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.8425198",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3218298",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3176908",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.5346527",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.22136",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.91541",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.25844",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "345.70758",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27990563E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.1272",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14939758E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.932129",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47094.793",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112797.95",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.84349459E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49832749E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.17455236E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.54046688E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-413327.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "455002.56",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "970.35938",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-254.58681",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.34729",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02986815",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-760.03101",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1137.5684",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1603.552",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "198.06567",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.41215593E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.85367433E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1625.0674",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2061.8118",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-347516.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "608180.31",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.9375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-254.98",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.227951",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.29164",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.26508",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.52803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.48767",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.25844",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "341.60764",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.73802",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.22046",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.008416511",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03170512",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.631538",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.57355",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59093797E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70162366E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.59093797E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70162366E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.008416511",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03170512",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.02356955E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04615048E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.02356955E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04615048E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02525222",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.011684",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05357008",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.653114",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.932541",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.933014",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.350296",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.824188",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.78225058E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03402502",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.57471",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.14569",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.44406",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.66605",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.55554",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.8316",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04283427",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.013771",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8485.2617",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.92944",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4062",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-398.68555",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.822266",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1621.4053",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1839.0784",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.1562",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-398.68555",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.464355",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.592575",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05197144",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.95923",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.514648",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.3195877",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3174629",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.1522007",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8812227",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.92535",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.69073",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.84503",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "347.18256",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38425560E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.91382",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25277438E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.827637",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46888.219",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112675.24",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.16775844E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.61342052E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52901930E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-444703.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "454519.75",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "975.1875",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-294.35107",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.985886",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03017535",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258394",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-754.63916",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1102.9612",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1489.3342",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "186.68896",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.95543042E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46494493E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1540.6165",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1925.1445",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-262390.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "599799.56",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.1875",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-294.35107",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "46.585953",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.81747",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.94843",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.4393",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.53467",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.84503",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "342.7702",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.92708",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.96613",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006867442",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02938985",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.5478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.5083",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.62666965E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48525323E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.62666965E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48525323E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006867442",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02938985",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.15438467E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26295447E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.15438467E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26295447E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02168142",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.86187",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03339912",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.074627",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.864487",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.253052",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.24678",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.483414",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.22318170E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03773588",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.82751",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "339.29404",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.29436",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.63757",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.6481",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.09454",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04409193",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "91.617813",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8513.1914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.99854",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4688",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-386.47314",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.358154",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1546.0066",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2299.7405",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-386.47314",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.264404",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-89.800339",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.05238342",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-735.51343",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.820312",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2508774",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9066935",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.3047886",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3555784",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.3044",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.29962",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.2473",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "344.59583",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51761787E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.15015",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14319846E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.822754",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46835.125",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112517.27",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.02887541E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56984845E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29922944E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-447561.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "475817.94",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "969.71875",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "process": "50",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-251.55209",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "63.991547",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03153343",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258469",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.63452",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1547.8467",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1624.7356",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "238.63062",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.49686342E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.54233599E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1507.386",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2110.5459",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-302183.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "610031.94",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.09375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "process": "50",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-251.55209",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "23.24823",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.50774",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06244",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.12741",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.10074",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.2473",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "340.87317",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.74632",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.34009",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004592661",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03026059",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.342884",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.53833",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54697045E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58903222E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54697045E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58903222E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jan2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004592661",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03026059",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09767768E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89318041E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.09767768E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89318041E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0283514",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.488647",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05477377",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.84407",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.235947",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.364716",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.000931",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.793594",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.95265499E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03794711",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "184.48193",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.57458",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "184.29979",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.30627",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "process": "50",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.44638",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.8252",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2001-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "576.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/jan2002/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "jul2001": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/jul2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "jul2001",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong24.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem24year0": "200110",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong23.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem23year0": "200110",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong22.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem22year0": "200110",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong21.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem21year0": "200110",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong20.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem20year0": "200110",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong19.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem19year0": "200110",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong18.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem18year0": "200110",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong17.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem17year0": "200110",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong16.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem16year0": "200110",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong15.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem15year0": "200110",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong14.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem14year0": "200110",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong13.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem13year0": "200110",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong12.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem12year0": "200110",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong11.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem11year0": "200110",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong10.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem10year0": "200110",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong9.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem09year0": "200110",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong8.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem08year0": "200110",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong7.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem07year0": "200110",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong6.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem06year0": "200110",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem05year0": "200110",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem04year0": "200110",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong3.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem03year0": "200110",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong2.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem02year0": "200110",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.jul2001/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong1.D/AnomSSTFcst2sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                    "mem01year0": "200110",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03866624",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.791679",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8458.0547",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-784.69067",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.5625",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-395.76733",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.441162",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1321.0066",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1799.5298",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.9062",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-395.76733",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.917725",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-92.429016",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009216309",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-717.14648",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.208252",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.8965282",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.6507511",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.686492",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8821621",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.69197",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.2355",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.59848",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.03546",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13039755E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-690.21729",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7160492",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05897197E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.345703",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48662.617",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112095.48",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.80591143E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59876367E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.17455236E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33237836E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-395871.0",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "441107.25",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "924.54688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-262.28101",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.044647",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03061344",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-664.30908",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "957.49951",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1409.9768",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "174.51221",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.63810261E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.96549307E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1907.1758",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2040.2917",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-268943.75",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "610605.31",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.54688",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-262.28101",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.167313",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.26273",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.38382",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.42175",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.03983",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007428661",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02841302",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.591063",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.78589",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.56475617E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89177445E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56475617E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89177445E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007428661",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02841302",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.94894324E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85466070E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94894324E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85466070E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02591996",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.07021",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04684515",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.405247",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-33.347534",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.164551",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-36.103256",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.603653",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.65357492E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03569947",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.33195",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.9967",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.66733",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.44217",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.74684",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.44592",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03844948",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "101.17027",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8536.3984",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-772.47461",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.0",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-398.72339",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.787354",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1370.7817",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2266.3049",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.9062",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-398.72339",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.334229",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-89.409012",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008056641",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-722.9375",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.447266",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7465982",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5289555",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9978037",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9899683",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.52776",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.77539",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.35402",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.45941",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23170378E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-678.68237",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6806335",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23181962E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.58252",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48712.418",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112300.16",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.14820282E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67549479E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.93852012E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34583536E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-412702.69",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "437121.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "928.10938",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-254.73161",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.215347",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0300893",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258419",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-722.81055",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "856.79761",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1325.543",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "212.2085",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.30047544E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.48532409E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2074.5251",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2392.3755",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-279106.88",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630042.06",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "933.90625",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254.73161",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.351028",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.50047",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.75244",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.81976",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.70746",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00714374",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03197506",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-19.713448",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.79175",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.59464344E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82137701E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.59464344E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82137701E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00714374",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03197506",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.98916450E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84850228E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.98916450E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84850228E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03321928",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.880623",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05638257",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.551842",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.046677",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.407852",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-36.505432",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.224243",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.84875249E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03728871",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.52885",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.73303",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.58665",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.46716",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.76131",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.0033",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04849542",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.604218",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8458.2734",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-776.76855",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.6875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-412.96924",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.394043",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1464.2444",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2259.9675",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.3125",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-412.96924",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.300293",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-93.23233",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008712769",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-742.17017",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.812012",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7971601",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1234818",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1058397",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8892441",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.76189",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.56207",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.73726",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "343.03235",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24292171E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-701.02368",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17631862E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.468018",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48382.582",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112497.88",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.52435502E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.53700988E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49000618E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36490701E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-449221.0",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "431755.69",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "928.6875",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-266.53955",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "64.828613",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0298923",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258471",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-840.12378",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "937.30615",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1433.6448",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "198.14941",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.73274463E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.92341552E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1861.9026",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2065.5769",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-298588.38",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "659826.38",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.67188",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-266.53955",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.156174",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.46231",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.57169",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.59503",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.66721",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007412553",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02954119",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.720533",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.67642",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.55261005E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86996367E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55261005E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86996367E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007412553",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02954119",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.83218276E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93438223E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83218276E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93438223E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03889553",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.507786",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.08091432",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.293713",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.251297",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.601639",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.787476",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.868576",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.26349265E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03543973",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.30057",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.7515",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.39931",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.89813",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.63255",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.2287",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03989686",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.465836",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8478.1836",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-774.22046",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.1875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-400.28979",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.550293",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1514.6235",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2352.7463",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-400.28979",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.425293",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-89.519699",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008895874",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-727.01416",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.445801",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6929989",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.498539",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1224594",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4617529",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.49461",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.36914",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.515",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.06055",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30605474E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-684.38159",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30696571E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.371094",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48519.934",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112606.97",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.03416197E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73524063E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42755914E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-460868.44",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "438294.81",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "918.375",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-249.91837",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.952835",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03140584",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-768.01392",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "943.43384",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1145.3845",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "197.08154",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.58007150E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88072327E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1734.8196",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1959.1404",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-285902.62",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "649081.75",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "923.96875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-249.91837",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.572708",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.93538",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.11505",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.24294",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.78339",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00452242",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03080042",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.174923",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52692",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.52460889E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83872689E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52460889E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83872689E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00452242",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03080042",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.80544998E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96009114E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.80544998E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96009114E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02913274",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.227104",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.07799965",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.244335",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-35.624176",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "27.923935",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-36.848404",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.526199",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.94501682E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03642153",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.27066",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.99139",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.16499",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.95267",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.16678",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.12845",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0359844",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.653503",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8502.2734",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-783.46533",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-397.75732",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.295166",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1551.8926",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1930.2683",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.4375",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-397.75732",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.115234",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-91.292374",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008575439",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-724.62183",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.755371",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5830278",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4161539",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6325598",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.3359842",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.03728",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.05646",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.81032",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.72742",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28159922E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-695.75952",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7235718",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04520586E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.245605",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48380.793",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112181.57",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.67212100E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47130856E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53136034E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-416865.25",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "411222.38",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "923.07812",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-255.8905",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "61.709946",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02948213",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25849",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-826.38477",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1236.5505",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1275.5908",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "171.91357",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.10073107E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.87465445E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1754.519",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1754.6467",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-286993.31",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635082.25",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-255.8905",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.562012",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.29379",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.52426",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "208.61066",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.38245",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008699935",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02880456",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.662691",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.76691",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.57272680E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84359978E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57272680E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84359978E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008699935",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02880456",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.13626186E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92747098E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.13626186E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92747098E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03540614",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.338215",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05963349",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "39.340786",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.290176",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.697449",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-37.129379",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.825897",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "9.77121317E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04144982",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.59723",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.30682",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.48744",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.54041",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.52884",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.20148",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.038732",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100.20322",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8517.0312",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-767.66675",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.125",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-392.90088",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.021484",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1283.0557",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2025.3125",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.90088",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.865479",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-91.817291",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008682251",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-720.91479",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.715088",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.752964",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6480732",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6035347",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0071869",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "181.05554",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.75623",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "181.04097",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.203",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58945977E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-691.86694",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00434409E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.608398",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48541.773",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112194.62",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.10290750E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.51937102E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63717050E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.67976602E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36639994E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-400449.0",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "452345.44",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "944.79688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-276.28784",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "65.159576",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03102097",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25841",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-714.7334",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "930.72754",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1366.1072",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "199.79736",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.46268041E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.98933115E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1781.4431",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1978.2292",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-248135.75",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "606193.62",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "947.8125",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-276.48462",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.452118",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.38626",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.12845",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.4509",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.57465",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004787728",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02875421",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.357212",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.72925",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.60634863E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76438316E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.60634863E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76438316E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004787728",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02875421",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.00044087E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93773644E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00044087E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93773644E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03763886",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.137035",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06418443",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.791328",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.700333",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.755539",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-35.074692",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.609222",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.60731985E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0353042",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "184.1353",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "341.21796",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "184.03157",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.77441",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.06358",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.87814",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0445215",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.951385",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8536.1562",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-775.68188",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.3438",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-392.4375",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.991455",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1265.7939",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2402.0977",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.8125",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.4375",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.968018",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-86.820984",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00881958",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-736.44165",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.095703",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1329565",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2564545",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.779376",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5563612",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.91451",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.35297",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.92442",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.39569",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19278798E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-667.55444",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6918182",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16086449E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.365234",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48182.223",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111945.35",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.41172175E-26",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.67987536E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.03632612E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39755502E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-403104.0",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "441287.31",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "928.51562",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-264.79688",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.388031",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0312351",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25844",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-681.22241",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1048.3491",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1524.2534",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "267.17627",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-6.09506230E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06836183E-07",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1521.946",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2152.1919",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-277091.56",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "652764.25",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "928.96875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-264.92114",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.621948",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.28032",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.08502",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.49255",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.89227",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005027343",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03110487",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.668598",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.81073",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.53242472E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84431210E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.53242472E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84431210E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005027343",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03110487",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.00952809E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98886869E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00952809E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98886869E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02248749",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.185589",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05810932",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.550922",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-29.053238",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "26.911591",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-33.905167",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.544163",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "5.01773627E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03481604",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.18031",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.56708",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.68405",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.05774",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.72867",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.27795",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04017264",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "97.05407",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8455.1211",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-769.41797",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.1562",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-392.97266",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.137939",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1404.9734",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1781.3145",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.625",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.97266",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.04248",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-87.791977",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008590698",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-733.30029",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.247314",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1660814",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0492172",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9812565",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.711813",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.36412",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.07947",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.33275",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.2326",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09177768E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-727.77148",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7085266",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05632353E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.924805",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48446.73",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112325.54",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.59399404E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63030393E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.93852012E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29357625E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-408915.75",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "436202.75",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "922.76562",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-271.74316",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.659576",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0305462",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-805.88208",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "944.28613",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1242.8596",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "242.55298",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.96984740E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.69895098E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1808.4873",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1934.0405",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-240296.19",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "656218.44",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.10938",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-271.74316",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.478638",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.12805",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.25696",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.31114",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.24927",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003355325",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.028828",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.561535",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.61844",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.48494228E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84783748E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.48494228E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84783748E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003355325",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.028828",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.88081469E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89431103E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.88081469E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89431103E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03450508",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.10535",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05833186",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.823601",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-29.170517",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.837357",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.502289",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.064102",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.74068178E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03752092",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.31563",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "340.56342",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.1776",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.10477",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.19762",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.66724",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04908027",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.20977",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8461.8086",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.80664",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-394.64209",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-80.508301",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1412.886",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2423.8904",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.4375",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-394.64209",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.398926",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-88.05545",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009231567",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-731.41992",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.182617",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4566841",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4499197",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-6.2210569",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4564934",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.67117",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.13397",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.59906",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.64417",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26910356E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-702.10132",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007080078",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27081876E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.500488",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48485.691",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112927.09",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-8.41451733E-34",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.13840961E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.14469014E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24785561E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-405953.19",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "422807.75",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "927.53125",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-248.96336",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.710312",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02891107",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258558",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-656.79785",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "974.60107",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1435.7776",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.96118",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.74127228E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51590221E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1755.6223",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2090.3137",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-308121.31",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "629608.62",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "927.53125",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-248.96336",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "46.218842",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.06314",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.33853",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.34193",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.4967",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005404826",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03197567",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.41507",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.73755",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.58948806E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82201675E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58948806E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82201675E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005404826",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03197567",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.95598273E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81225130E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.95598273E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81225130E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03276161",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "41.064026",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06462514",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "41.418961",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-28.877167",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.065674",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-39.686447",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.264587",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.08764539E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03491605",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.07005",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.97113",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.77318",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.91891",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.86201",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.75",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03723556",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.15667",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8489.3281",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-771.24316",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-395.88599",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.206543",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1443.0676",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1788.3577",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.6875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-395.88599",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.808105",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-91.673172",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009094238",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-725.58032",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.051025",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1218185",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9294486",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7619591",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8176727",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.48752",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.71661",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.32143",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.62775",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44610556E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-669.60254",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15169678E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.886963",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48302.504",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "113119.16",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.47852107E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49321522E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.10678976E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27584383E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-419720.94",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "447204.94",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "925.79688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-249.45203",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "79.338928",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03134177",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258396",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-670.87671",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "900.16406",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1205.5957",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "237.29907",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.82083976E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.48900833E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1771.2585",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1977.75",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-295614.06",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "620319.5",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "926.07812",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-249.51799",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.663101",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.33493",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.44431",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.45415",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.07495",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005061593",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02808245",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.776009",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74066",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.56854567E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83744214E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56854567E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83744214E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005061593",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02808245",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.85347733E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00923228E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85347733E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00923228E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03609338",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.475132",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05502368",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.597672",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.655975",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.872772",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.732468",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.017609",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.21893798E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0463423",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.81743",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.6503",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.30321",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.25388",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.37892",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.6221",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03933365",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "97.481758",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8488.8594",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-768.42798",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.0312",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-393.38257",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.470947",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1564.0144",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2156.8115",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.6562",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-394.83179",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.287354",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-87.954865",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009368896",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-731.60425",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.758301",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.0727701",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.6694193",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.9839334",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8885708",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.4048",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.45126",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.30838",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.38019",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62469109E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-690.05298",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7126617",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13408896E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.334229",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48654.406",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112190.04",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.39301129E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66245229E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33023150E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-437885.06",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "449998.69",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "917.42188",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-261.45874",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "67.037399",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03143585",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258379",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-758.29639",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "899.12354",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1351.3931",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "230.36401",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.40384292E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.21138792E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1725.5747",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2044.5747",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-269136.75",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591277.25",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "918.84375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-261.45874",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.043228",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.32704",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.14929",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.48315",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.9296",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006034922",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02907164",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.4692",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.94055",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.56079586E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83928132E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56079586E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83928132E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006034922",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02907164",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.00293221E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13764815E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00293221E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13764815E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02854237",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.786034",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0443835",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.091854",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.209976",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.14006",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-33.394211",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.657013",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.69078872E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03696682",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.44681",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.26031",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.03934",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.43869",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.08319",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.79416",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04840228",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.371292",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8458.3828",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-786.22461",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-390.69702",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.33252",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1229.3081",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2091.032",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.2812",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-390.69702",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.030029",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-89.714172",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008071899",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-737.23584",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.390625",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.1104698",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6775856",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6960783",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6064339",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.67075",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.48322",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.51544",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.97314",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12156317E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-651.07861",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7140961",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12253474E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.89502",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48804.527",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112653.75",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.26357450E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75639184E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.93852012E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19953813E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-433375.25",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "408009.94",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "923.4375",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-251.39241",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "75.058105",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03080191",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-813.46729",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1010.5339",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1383.4592",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "180.68213",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.53206576E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.22521918E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1694.1392",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1958.7466",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-269862.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "632321.38",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "926.78125",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-251.39241",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.785034",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.99486",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.43628",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "208.97614",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.31488",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005558744",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03046042",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.649439",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70059",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.47942728E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85221015E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.47942728E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85221015E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005558744",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03046042",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.22429185E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91454274E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.22429185E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91454274E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.0356882",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.96669",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06203354",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.46624",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.694763",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.611923",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-33.669266",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.276764",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "5.83086326E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03853726",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.55382",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.1203",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.8754",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.00977",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.98273",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.36972",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.02532538",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.539642",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8515.9141",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-783.88477",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.6875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-402.03491",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.566406",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1436.3232",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2020.3394",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.0938",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-403.17847",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.386719",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-89.59993",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009140015",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-748.48145",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.442383",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.631937",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6870098",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5645571",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2049408",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.44447",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.76099",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.40347",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.41284",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30677404E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-615.7937",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04887295E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.696289",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48776.84",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112735.47",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.30872299E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.23728953E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56466456E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.35525294E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36494521E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-449596.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "447300.12",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "915.375",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-297.86865",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "70.817017",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03164469",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258392",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-820.87744",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "923.39014",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1400.2048",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.51465",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.59902730E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49845697E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2045.7019",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2123.3887",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-265681.25",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "664714.69",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "918.39062",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-298.0376",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.627197",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.19997",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.03784",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.26904",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.14368",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005822729",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03023264",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.58482",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.95679",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.61413227E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81252126E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.61413227E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81252126E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005822729",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03023264",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.00468912E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09799828E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00468912E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09799828E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03288228",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.574673",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05927195",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.892193",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.063431",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.334869",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.624771",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.420258",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.44554427E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03793689",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.62289",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "340.30179",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.21321",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.2901",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.22479",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.57492",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03217979",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.013046",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8530.2031",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.52271",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.5625",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-393.80249",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.229004",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1396.6143",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2179.6438",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5938",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-393.80249",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.01709",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-96.488113",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008377075",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-742.44336",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.761475",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9148817",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.606617",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-6.0502892",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7436113",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.05183",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.85291",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.04301",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.69897",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51672486E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-722.96387",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14564318E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.249756",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48522.27",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112053.77",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51442940E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52602854E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37181530E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-414899.75",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "429346.5",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "927.17188",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-257.06982",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "76.164642",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03027284",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258467",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-771.22778",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "930.17969",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1156.6121",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "203.54297",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.62496757E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.13926135E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1871.2622",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2000.7358",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-258081.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "614624.81",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "928.21875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-257.66846",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.12291",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.71535",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.82666",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.93716",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.94043",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004427478",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02988843",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.573942",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.78104",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.53752299E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90772189E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.53752299E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90772189E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004427478",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02988843",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.93182746E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10085727E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.93182746E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10085727E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02878696",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "39.613327",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04239569",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "40.013149",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.143372",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.727219",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-37.382843",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.957184",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.63914648E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03602914",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.76601",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.08917",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.49309",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.51978",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.50793",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.09436",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04429697",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.865334",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8480.707",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-788.67651",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.125",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-390.66846",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.656982",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1277.3838",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2503.7336",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.7188",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-390.66846",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.605469",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-88.873734",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009277344",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-730.53711",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.257324",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4239683",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4644508",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.8332233",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0275173",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.74077",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.12427",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.65256",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.70404",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32670687E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-721.31519",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7285461",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18563185E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.137695",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48012.43",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112082.7",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.81961455E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53932785E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38430278E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-425097.19",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "434971.94",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "920.875",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-246.54448",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "72.59584",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03069156",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258484",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-665.57178",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "970.95166",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1301.5823",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "243.33813",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.20466301E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.73014380E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1729.0991",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2218.7983",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-256921.44",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "634465.38",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "920.875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-246.54448",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.089066",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.38385",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "308.97174",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.5791",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.5498",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005944118",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02958372",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.651768",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74341",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.56704391E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91882627E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56704391E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91882627E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005944118",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02958372",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.85929241E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02117963E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85929241E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02117963E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03304035",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.975025",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06590325",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.460419",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.508011",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.352341",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.738647",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.554001",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.12266775E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0398944",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.1772",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.47272",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.84512",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.91907",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.91588",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.05005",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03283389",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.563148",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8517.5273",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-768.43164",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.9688",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-427.58081",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.189453",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1382.7883",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1971.3877",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-427.58081",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.186768",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-88.415817",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008499146",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-731.71167",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.912598",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.523489",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9068928",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.0208473",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.5387058",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.32651",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.2666",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.28992",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.27411",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13357669E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-682.97363",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.730484",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.46398359E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.494385",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48126.828",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111973.78",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326131E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.13933423E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68534416E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58848457E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-382619.25",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "423878.81",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "919.79688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-278.65942",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.85202",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03049102",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258423",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-655.43213",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "995.8877",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1423.3184",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "209.1748",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.69145186E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.36428171E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1713.6006",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2024.373",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-275053.38",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "628635.06",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "923.23438",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-278.65942",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.127594",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.29773",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.18445",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.38268",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.11014",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005650211",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02844969",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.667046",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.79761",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.56398037E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86281195E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56398037E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86281195E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005650211",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02844969",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.22779818E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25020403E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.22779818E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25020403E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03290601",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.591824",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06576139",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.842953",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.981415",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.370422",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-33.705765",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.850082",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "5.74934163E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04346872",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.31091",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.87537",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.87938",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.46277",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.8875",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.93933",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03337663",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.912262",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8522.3906",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5231934",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.14136",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.8125",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-410.81689",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.576172",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.0",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-410.81689",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.537109",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-15.154223",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "43.746696",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.0722103",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "277.9632",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-17.823105",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.93503",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.53559102E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.39763069E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "303.04688",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-90.115936",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009277344",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-741.95288",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.317871",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.11267",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.55548",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5416307",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9100618",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.4004345",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.27882",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.41188",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.74863",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.10217",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.01239",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.20403",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.71686",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.10217",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.78976",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27762235E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.20478236E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-658.94897",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7088776",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17954914E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.864746",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48594.809",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112581.31",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.85311306E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47864876E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.35525294E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13883937E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "924.54688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-263.06543",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.959091",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03096185",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258379",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-719.35474",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "959.38647",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1446.2053",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "197.02222",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.78297033E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.87847512E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.18142225E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.39069924E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.54688",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-263.06543",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.518036",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "4.04217863E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "234.63707",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.40817",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.85349",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "195.06148",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.12262",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.72324",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "325.478",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "182.10217",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.0632",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.31631",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.93988",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005308017",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02828111",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.67959",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.56595",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.55174712E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78144037E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55174712E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78144037E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-6.11814989E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.004081011",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005308017",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02828111",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.91373420E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81467908E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.91373420E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81467908E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02172698",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.770164",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04067012",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.385948",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.087326",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "27.969711",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-37.3116",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.399643",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.49197318E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03678159",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.11745",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.08353",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "184.82327",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.43494",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.83029",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.12683",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06022272",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.088554",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8516.0703",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.4874878",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-774.96191",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.2812",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-389.40283",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.612793",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.125",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.87744",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.612793",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-17.168991",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "35.153812",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-10.698472",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "294.38",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-18.493835",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "17.356386",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "3.78559014E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.89622355E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "303.01562",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-91.402115",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009246826",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-726.71533",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.986328",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.14359",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.51501",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7124147",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6247072",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.8711166",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1769791",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.35689",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.93613",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.1985",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "332.68036",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.24818",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.39182",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.22618",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.19598",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29061448E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.45672419E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-650.23584",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.692749",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18714524E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.009277",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48631.727",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112022.46",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.31497835E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74275249E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31759577E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "930.01562",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-247.68413",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "82.146881",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03046585",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-747.64771",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1017.9626",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1330.3401",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "225.98218",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.31965725E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.03692126E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.19259664E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.39498956E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.40625",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-248.5674",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "48.295715",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "3.22661654E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "157.73102",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.30827",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.84149",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "198.86456",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.73291",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "190.21162",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "325.0882",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.22618",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.80722",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.50377",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.61713",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003217094",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02995804",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.734795",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.77243",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.62061278E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76006033E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62061278E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76006033E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003650665",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003217094",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02995804",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.86127318E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08556730E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.86127318E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08556730E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03598734",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.143314",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06929022",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.600399",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-29.687576",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.58638",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.99295",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.51767",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.25613383E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03655168",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.16714",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.13394",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.991",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.49219",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.99657",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.73145",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04238306",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.642677",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8531.7617",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.480835",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-776.16895",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.4062",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-396.85474",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.847412",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.0625",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-396.85474",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.52124",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-21.707321",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "36.382092",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.6032867",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.13196",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-19.214172",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "19.590309",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.72990748E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.33817506E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.98438",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-90.368927",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008132935",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-743.81982",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.605225",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.51637",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.54675",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.3852043",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8144016",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6546488",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6922846",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.00732",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.12161",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.43509",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.00757",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.645",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.44446",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.43509",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.12161",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27583303E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.03330165E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-665.15894",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12256384E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.865967",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48476.223",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112383.74",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.36245716E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.97701638E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19898812E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "920.125",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-253.60663",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "67.554596",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03113657",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25835",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-753.26465",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1043.344",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1454.1531",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.88599",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.81475092E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51299467E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.15285263E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.53121140E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.1875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-253.60663",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.879013",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.60472579E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "167.19554",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.10065",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.48541",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "196.87401",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.64154",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.57434",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "325.15936",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.43509",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.14114",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.15656",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.6745",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007803429",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0304874",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.553558",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.79556",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.58260555E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84709897E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58260555E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84709897E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-2.37169225E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003404975",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007803429",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0304874",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.84668738E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83718498E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.84668738E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83718498E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03226318",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.460506",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05263296",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.661808",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-30.351196",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.650391",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.739059",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.463013",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "6.91102855E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.034218",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.70412",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.12756",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.35602",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.30249",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.52327",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.21732",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03965659",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.725357",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8489.6055",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5319214",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-775.71924",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.75",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-389.53394",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.599854",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.7812",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.53394",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.576416",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-22.15448",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "32.03928",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.2451363",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.61572",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-17.998428",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "17.56962",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.02015801E-14",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.37349081E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-93.532776",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008407593",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-710.68115",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.594238",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.46379",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.47623",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6556988",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1213846",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3650742",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7934027",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.60634",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.25714",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.42886",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "330.69879",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.54716",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.28021",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.52344",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.25714",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20238008E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.45255229E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-682.30713",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05629442E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.031006",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48629.902",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112331.82",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.73661646E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68829013E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27704618E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "924.10938",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-251.63374",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.183121",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03221143",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258526",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.20361",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1068.1404",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1330.8467",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "168.89355",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.32168258E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.75360070E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.05856680E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.77895946E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.10938",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-251.63374",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.350906",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "3.90099594E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "185.03143",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.28989",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.8309",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "196.83333",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.53308",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.11951",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "323.58319",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.52344",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.30792",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.39355",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.96271",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004883453",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02959209",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.381405",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55765",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.55134094E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84031051E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55134094E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84031051E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-3.04931861E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003566802",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004883453",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02959209",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.70181022E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96120482E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.70181022E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96120482E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02229773",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.623329",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04553663",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.149559",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.314438",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.15715",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-32.961472",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.339188",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.98284532E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04325588",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.93748",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.27155",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.81839",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.51752",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.81947",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.76953",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03965659",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.725357",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8489.6055",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5319214",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-775.71924",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.75",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-389.53394",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.599854",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.7812",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.53394",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.576416",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-22.15448",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "32.03928",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.2451363",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.61572",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-17.998428",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "17.56962",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.02015801E-14",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.37349081E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-93.532776",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008407593",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-710.68115",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.594238",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.46379",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.47623",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6556988",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1213846",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3650742",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7934027",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.60634",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.25714",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.42886",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "330.69879",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.54716",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.28021",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.52344",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.25714",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20238008E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.45255229E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-682.30713",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05629442E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.031006",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48629.902",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112331.82",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.73661646E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68829013E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27704618E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "924.10938",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-251.63374",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.183121",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03221143",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258526",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.20361",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1068.1404",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1330.8467",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "168.89355",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.32168258E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.75360070E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.05856680E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.77895946E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.10938",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-251.63374",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.350906",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "3.90099594E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "185.03143",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.28989",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.8309",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "196.83333",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.53308",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.11951",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "323.58319",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "184.52344",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.30792",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.39355",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.96271",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004883453",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02959209",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.381405",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55765",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.55134094E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84031051E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55134094E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84031051E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-3.04931861E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003566802",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004883453",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02959209",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.70181022E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96120482E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.70181022E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96120482E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02229773",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.623329",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.04553663",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.149559",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.314438",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.15715",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-32.961472",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.339188",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.98284532E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04325588",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.93748",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.27155",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.81839",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.51752",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.81947",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.76953",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05130441",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.983559",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8482.0781",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5237427",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-783.64722",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.625",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-390.60791",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-80.642822",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-390.60791",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.244385",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-17.845016",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "32.99757",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.6964426",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.01147",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-19.827087",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "19.79771",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.51042430E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.91559505E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.90625",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-87.390915",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008758545",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-717.80151",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.673584",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.26888",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.66357",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6311111",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.5728674",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3641615",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9221754",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.42162",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.36346",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.3148",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "333.21631",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.36565",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.43027",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.41995",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.10175",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30842795E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.88315257E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-686.00439",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6802826",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07625965E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.665283",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "47879.23",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112453.33",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.79611071E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48088009E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42710769E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "923.70312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-265.48242",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "67.420425",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02861967",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258467",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-726.65137",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1195.2725",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1222.4697",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "185.63599",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.88831347E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.42297743E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.07686526E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.05025605E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "925.84375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-265.48242",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.429596",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "5.15678112E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "179.56769",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.44093",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.79443",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "199.46628",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.79797",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "191.54892",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "325.0993",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.41995",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.23065",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.70879",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.17587",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00709584",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03005824",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.73111",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.73859",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.49648258E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91827949E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.49648258E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91827949E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-2.42674939E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003364027",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00709584",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03005824",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.01142393E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98215844E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.01142393E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98215844E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03159591",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.721218",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06188007",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "39.048077",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-32.539886",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.850937",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-37.726334",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.320038",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.92375978E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04260585",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "191.18503",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.67395",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "190.88098",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.02948",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "190.96939",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.49368",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0473386",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.873032",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8458.2773",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.489563",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-782.15088",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.25",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-410.0376",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.168457",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5938",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-410.0376",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.30127",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-16.326721",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "36.262691",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1453772",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "290.77237",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-27.600876",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "21.570705",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "5.94496173E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.43436205E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.88281",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-93.977386",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008728027",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-743.41162",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.599365",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.19409",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.41553",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3718309",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2219677",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.256506",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9116631",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.37343",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.18109",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.19054",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.50946",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.30476",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.30402",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.19054",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.15863",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21751088E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.90150945E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-701.36157",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6777344",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04407081E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.763916",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48473.176",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112238.88",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.47492641E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71401553E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.53595383E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56046315E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "917.51562",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-262.18945",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "74.761597",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03044843",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258472",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-652.41455",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1015.7163",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1526.9507",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "217.60669",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-6.10584834E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.70171561E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.05572497E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.73644842E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "917.89062",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-262.34985",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.637604",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "4.10627981E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "156.21527",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.95088",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.66962",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "197.93391",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.52905",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "189.5766",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "326.1366",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "185.19054",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "339.29047",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.05228",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.37689",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003868971",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03098351",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.536451",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70096",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.53716483E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87640253E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.53716483E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87640253E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-2.87183874E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003305256",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003868971",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03098351",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-2.04573644E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05583319E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-2.04573644E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05583319E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02913099",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.422844",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.05914741",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.947113",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-31.865845",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.394409",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-35.488556",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.071655",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "7.33656975E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03441639",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.68925",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.54782",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.5437",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.6474",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "188.62469",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.93634",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.03542735",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "92.294037",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8501.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5317383",
                                            "gribparam": "231",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-778.37036",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.0625",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-392.18311",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.933594",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.0625",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.18311",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.037354",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-15.098826",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "38.884876",
                                            "gribparam": "196",
                                            "subcenter": "255"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-6.2071724",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.51431",
                                            "gribparam": "197",
                                            "subcenter": "255"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-34.930496",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.862984",
                                            "gribparam": "195",
                                            "subcenter": "255"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.98432939E-15",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.56191599E-04",
                                            "gribparam": "159",
                                            "subcenter": "255"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "302.85938",
                                            "gribparam": "206",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-92.462402",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008758545",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-728.81567",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.256104",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.52376",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.61102",
                                            "gribparam": "213",
                                            "subcenter": "255"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6204357",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5090351",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7630177",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3875837",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.6655",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.22662",
                                            "gribparam": "214",
                                            "subcenter": "255"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.55576",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "332.90753",
                                            "gribparam": "215",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.61375",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.41394",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.55576",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.98163",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27398289E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.37386454E-20",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-675.27588",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.72995",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.49803507E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.355713",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "48585.273",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112140.91",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57470104E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67310895E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35607615E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "927.07812",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "scale_min": "-253.18074",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "75.027817",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03011305",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258421",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-772.10669",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "992.42236",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1216.6543",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "177.8667",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-4.86505996E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.91687205E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-9.51778190E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.60436399E-07",
                                            "gribparam": "221",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "931.71875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "scale_min": "-253.18074",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "45.01358",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "4.73403343E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "165.32451",
                                            "gribparam": "145",
                                            "subcenter": "255"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "210.64793",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.8042",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "197.07135",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.43671",
                                            "gribparam": "209",
                                            "subcenter": "255"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "187.25841",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "325.36063",
                                            "gribparam": "208",
                                            "subcenter": "255"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "183.55576",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.91718",
                                            "gribparam": "207",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "209.76311",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.98569",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005212318",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03007861",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.623816",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.71338",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.58047915E-05",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87443384E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58047915E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87443384E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst jul2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "lwc153",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003121912",
                                            "gribparam": "153",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005212318",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03007861",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "scale_min": "-1.82750216E-06",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.17028742E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-1.82750216E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.17028742E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.04041508",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.006927",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "0.07258308",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.777504",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-32.632538",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.755646",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "-36.812592",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.89537",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "8.71338557E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03552293",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.39018",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "338.56036",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.14958",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.1257",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "scale_min": "186.22188",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.4451",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "Z_11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2001-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "303.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/jul2001/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "mar2002": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/mar2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "mar2002",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc24_%6d.01",
                                    "mem24year0": "200209",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc23_%6d.01",
                                    "mem23year0": "200209",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc22_%6d.01",
                                    "mem22year0": "200209",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc21_%6d.01",
                                    "mem21year0": "200209",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc20_%6d.01",
                                    "mem20year0": "200209",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc19_%6d.01",
                                    "mem19year0": "200209",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc18_%6d.01",
                                    "mem18year0": "200209",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc17_%6d.01",
                                    "mem17year0": "200209",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc16_%6d.01",
                                    "mem16year0": "200209",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc15_%6d.01",
                                    "mem15year0": "200209",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc14_%6d.01",
                                    "mem14year0": "200209",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc13_%6d.01",
                                    "mem13year0": "200209",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc12_%6d.01",
                                    "mem12year0": "200209",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc11_%6d.01",
                                    "mem11year0": "200209",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc10_%6d.01",
                                    "mem10year0": "200209",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc09_%6d.01",
                                    "mem09year0": "200209",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc08_%6d.01",
                                    "mem08year0": "200209",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc07_%6d.01",
                                    "mem07year0": "200209",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc06_%6d.01",
                                    "mem06year0": "200209",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc05_%6d.01",
                                    "mem05year0": "200209",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc04_%6d.01",
                                    "mem04year0": "200209",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc03_%6d.01",
                                    "mem03year0": "200209",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc02_%6d.01",
                                    "mem02year0": "200209",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.mar2002/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri/forecast/data/echam4/asst/mar02/30007fc01_%6d.01",
                                    "mem01year0": "200209",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04754281",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.341301",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8521.4102",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.21265",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.75",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.22583",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.111572",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2221.127",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1926.2983",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.1875",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.76782",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-77.234619",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.742233",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01947021",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-724.19165",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.283447",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0603971",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "6.2216749",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.4360762",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.6515484",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.32774",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.55438",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.30338",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.98407",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.36775486E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-705.88916",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.08015956E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.421875",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47233.566",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112273.55",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.55909548E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.50232802E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.19816923E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-448240.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "443036.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "968.03125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-243.26703",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "77.221848",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03023003",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258482",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-782.41357",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1030.6042",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1319.7405",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "191.45801",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.27727252E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.65564891E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2027.6836",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2188.0452",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-281167.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "665904.94",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "968.03125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-243.28212",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "42.834335",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.14821",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.84546",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.52856",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.81439",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.30338",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.85126",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.69685",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.38629",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007335637",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02955588",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.831352",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.54282",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56703372E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87111473E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56703372E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87111473E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007335637",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02955588",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92347079E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03031823E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92347079E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03031823E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02506856",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.260632",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05273244",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "41.466881",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.590149",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.432022",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-40.977753",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.272415",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8.34953653E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03475721",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.75551",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "341.79041",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.44475",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.40283",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.45799",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.52228",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04691476",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "95.096382",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8502.3047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-796.12012",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.5625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.40308",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.458252",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1949.7722",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2098.0786",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.5938",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.40308",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.458252",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.531082",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01852417",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-731.58032",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-64.052002",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.7624636",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "6.6285334",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6423788",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "7.5459757",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.4884",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.89279",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.43924",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.32602",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.59480828E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-689.64429",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13097485E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.638672",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47058.383",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112510.22",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.69165058E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.61135256E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.25059000E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-448229.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "454444.81",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "961.375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-265.66748",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.454178",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03068943",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258539",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.65576",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1144.1279",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1591.4897",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "160.15625",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.36392144E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "6.40424673E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1634.1755",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1936.0427",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-299268.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "621422.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "961.375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-265.75171",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "39.797897",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.44894",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.06808",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.16121",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.86658",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.43924",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.32602",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.85127",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.91675",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005704965",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02929225",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.779034",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.35776",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55806974E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84610490E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55806974E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84610490E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005704965",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02929225",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95948883E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09577615E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95948883E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09577615E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.01888761",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.090897",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03596604",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.70956",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.427643",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.07423",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.433258",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.41304",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.87005092E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03368207",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.3775",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.59283",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.30219",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.07437",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.32614",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.84396",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03844709",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "100.37366",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8488.7617",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-802.24902",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.7188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.43701",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.644531",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1656.1023",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1819.4463",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.0312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-388.05884",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.406494",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-91.570999",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01858521",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.90649",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-64.776367",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8893442",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.2531347",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.3651667",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "4.9822741",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.03618",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.27234",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.12866",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.98297",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.34344361E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-713.54785",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.09383836E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.571777",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47148.457",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112566.67",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.05594732E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.75860680E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.62630428E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.36838696E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-437419.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "518819.19",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "969.73438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-265.33447",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "75.045853",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03091465",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258533",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-705.40991",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "960.97485",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1266.8074",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "236.16699",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.06560809E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.44377803E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1543.1389",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1711.3569",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-289333.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "615192.81",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "972.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-265.34814",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "35.771378",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.41811",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.74622",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.12062",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.23822",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.12866",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.74225",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.65755",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.56378",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004822947",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03199761",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.893072",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.36984",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57618397E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79592516E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57618397E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79592516E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004822947",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03199761",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.26584712E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15717478E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.26584712E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15717478E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02566165",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.726582",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04519049",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.316055",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.472961",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.812378",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.124985",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.525726",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.98559629E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03691598",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.0916",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.94421",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.24579",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.83762",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.56384",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.54547",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04270843",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "90.823051",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8459.9219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-799.97827",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.4688",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-393.91821",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.289062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1706.9021",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1786.4829",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.5312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-393.91821",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-77.283936",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-85.860764",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01922607",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-715.3877",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.151367",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.346776",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.4258146",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9077454",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.444725",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.30531",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.03961",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.28307",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.05731",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.60087313E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.26562",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.08816312E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.577637",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47134.715",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112416.77",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.91517073E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.76947560E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.38093969E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-393478.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "436874.69",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "967.92188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-248.08197",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.31424",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02929568",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258471",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-777.24707",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1103.0132",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1688.1111",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "237.18311",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.75028389E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.48438981E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2032.45",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1816.0334",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-311480.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "688014.69",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "967.92188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-249.60362",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "54.60672",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.92168",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.22638",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.63622",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.43958",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.28307",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.09497",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.25766",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.99203",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005160533",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02933502",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.995832",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.46927",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57323830E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82474869E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57323830E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82474869E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005160533",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02933502",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.11527322E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97285408E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.11527322E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97285408E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.01955993",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.073524",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03069167",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.699867",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.193344",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "32.596016",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.482422",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.732697",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.44158228E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03557161",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.82191",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.28577",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.642",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.93961",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.67934",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.34735",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03475691",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "92.010193",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8520.8398",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-803.97144",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1177.125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.05371",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.101807",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1715.5874",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1722.8157",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.05371",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.630615",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-93.915787",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01860046",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-727.03247",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.868652",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0259399",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.9755478",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.389472",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.9844046",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.87108",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.75427",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.88924",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.17065",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.55473197E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-692.81445",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.07113738E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.430176",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46515.105",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112262.3",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82321856E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.58565420E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.45391880E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.32523940E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-419850.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "503507.81",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "963.01562",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-250.41635",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "75.239395",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02989981",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258369",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-837.92334",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "904.21387",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1353.135",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "205.53149",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.41080851E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.21883361E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1655.7078",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2011.2485",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-286912.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "638821.81",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "967.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-258.47754",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "51.682968",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.42003",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.93762",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.54362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.19455",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.88924",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "342.672",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.50362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.47821",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006268881",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02924746",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.749727",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44406",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57944251E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81408941E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57944251E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81408941E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006268881",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02924746",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.01388707E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.28361637E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.01388707E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.28361637E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02891413",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.834324",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05618504",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.355099",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.251785",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.850876",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.98526",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.192368",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.69999924E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03771923",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.55444",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.28299",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.35606",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.04016",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.39114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.04755",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04778979",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "90.556282",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8522.2773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-799.26636",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.6562",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.80298",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-78.176025",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1755.1665",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1763.1455",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.8438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.80298",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-77.746338",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.791183",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01902771",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-718.39575",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-68.222412",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2596836",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.6411352",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.5715351",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.3542757",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.38551",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.18225",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.42076",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.0481",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.60478032E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-698.81006",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.03746424E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.748291",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47019.387",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112255.05",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.11687142E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.68457950E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.43265299E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-409044.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "467049.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "963.20312",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-249.09195",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "74.233337",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03026633",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258425",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-854.45996",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1214.8538",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1454.665",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "209.46118",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.81679842E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.37584651E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1604.0024",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1975.5737",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-261099.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "717521.06",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "966.10938",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-249.09195",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "34.389114",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.33318",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.15936",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "198.19498",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.81125",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.42076",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.54224",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.65761",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.2572",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00640643",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02956207",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.85544",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.63708",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54306726E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81546038E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54306726E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81546038E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00640643",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02956207",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88042372E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05963875E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88042372E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05963875E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0272871",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.15646",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03967245",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.356575",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.193314",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.954056",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.016953",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.656143",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8.79457502E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03426508",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.57425",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.19647",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.41302",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.15378",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.41588",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "332.61166",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03679684",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "95.16774",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8504.9531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.81616",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.1562",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-405.22974",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.989258",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1611.8435",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1617.189",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.3438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-405.22974",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.120117",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.234299",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01852417",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-719.71851",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.406494",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.5875034",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.2874937",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.3869152",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.5734758",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.26831",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.93231",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.31403",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.40631",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.38915163E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-693.24927",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.14322756E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.549316",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47045.785",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112607.23",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.29395617E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.27518442E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.57898739E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.31948411E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-427017.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "436902.75",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "964.95312",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-296.59326",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.13356",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03054896",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25845",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-698.24292",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1025.7017",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1116.0767",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "189.53979",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.46287800E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.57885914E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1663.5774",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1723.9768",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-308064.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "633711.44",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "964.95312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-296.59326",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "50.510971",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.22313",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.4751",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.8779",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.8392",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.31403",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.47272",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.52452",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.87567",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006507855",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02993545",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.76438",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.25211",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55072521E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74984743E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55072521E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74984743E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006507855",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02993545",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99224246E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25933309E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99224246E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25933309E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03170333",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.902176",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05586799",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "38.86747",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.897675",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.675842",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-37.816742",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.220367",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.70466199E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03910954",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.92668",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.87012",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.65704",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.91663",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.66696",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.26398",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03727553",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "92.141922",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8531.2812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.87915",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.1875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.52734",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.618652",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1726.1323",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1766.1357",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.52734",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.6521",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.33313",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01890564",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-711.97656",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.705322",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2395468",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.1173067",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.6544209",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.3139019",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.21413",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.52802",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.20935",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.18613",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.25007034E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-683.38867",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.12803536E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.025879",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47060.566",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112870.52",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.98582050E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.60357320E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.29179443E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-420038.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "412486.25",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "965.5",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-246.59886",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "75.086319",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03021595",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258505",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-694.88135",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1051.6401",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1129.553",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "224.30664",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.51676613E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.96935717E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1682.5095",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1931.4663",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-307938.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "649342.19",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "969.375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-247.97058",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "48.021927",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.01906",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.57764",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.00522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.11667",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.20935",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "339.49863",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.41878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.14374",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006317925",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03088918",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.126228",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.5939",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52951216E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81586711E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52951216E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81586711E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006317925",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03088918",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.97536474E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00699151E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.97536474E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00699151E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02615915",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.470741",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05385183",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.104183",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.893967",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.838669",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.501556",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.174393",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.03914973E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03628107",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.68712",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.85712",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.51758",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.38879",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.52937",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.737",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03519696",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "98.516273",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8522.2188",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.88135",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.0",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-391.10254",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.224121",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1943.29",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1776.2712",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.9375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-391.10254",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.221436",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-86.509277",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01863098",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-717.85962",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.351562",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3772354",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.4742355",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.4527798",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.7464905",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.07841",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.94",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.92297",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.08243",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.47883725E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-684.85791",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.28964894E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.688965",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46986.906",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112935.03",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.90390095E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.73390151E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.26418695E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-427015.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "477843.12",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "965.90625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-263.95654",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "72.837692",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03053102",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258465",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-759.96826",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1049.406",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1335.3384",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "173.09106",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.33964453E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "6.92123763E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1444.6702",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1935.7705",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-281614.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "645575.62",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "965.90625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-264.09424",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "41.330887",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.9388",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.25128",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "198.37871",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.0994",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.92297",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.98828",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.43878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "311.91144",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004900657",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03078407",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.855637",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.20514",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.50738460E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83513039E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.50738460E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83513039E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004900657",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03078407",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17638035E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22958715E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17638035E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22958715E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02014949",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.686871",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03933249",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "38.307087",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.388184",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "36.530365",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.394058",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "35.126236",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "9.62619993E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03775876",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.93126",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.27289",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.43068",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.31293",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.46887",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.85638",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03648594",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "93.977074",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8543.8594",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.80396",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1177.875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-392.6084",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.432861",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1717.1489",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1762.5752",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-392.6084",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.688232",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.45076",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01899719",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-721.90649",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.54541",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7615223",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.3199987",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1104517",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.614542",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.10512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.95291",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.08003",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.91315",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29540308E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-679.87573",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.09325629E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.123535",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47354.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112353.22",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.15031740E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.63630318E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.58326734E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.24459370E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-474417.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "467604.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "961.29688",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-261.26587",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "73.340027",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03144456",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258472",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-785.28491",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1242.5964",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1424.3689",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "211.19092",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.69565259E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.44476915E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1568.3723",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1741.9714",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280921.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "639137.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "970.95312",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-262.78198",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "33.428528",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.07544",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.72192",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.02078",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.02637",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.08003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.48828",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.17804",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "311.87512",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007231247",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0285748",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.621754",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.20203",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57968589E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83763823E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57968589E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83763823E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007231247",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0285748",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.12533928E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01201442E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.12533928E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01201442E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03150917",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.452557",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05513394",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "34.600075",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.318878",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.546249",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.898438",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.905243",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.01940818E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03637855",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.04982",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.48364",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.97688",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.67438",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.04982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.04547",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03510009",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.939537",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8523.6641",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-803.41821",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1179.125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.15674",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.854004",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1524.0991",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1726.2253",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.3438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.15674",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.372559",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.731674",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01890564",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-741.67822",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.153809",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.3640909",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.3122358",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.0454197",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.6793776",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.08301",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "339.48999",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.1339",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.65887",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30991691E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-689.1333",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.20335608E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.432129",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46961.703",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112560.56",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.41065252E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.49278947E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.44554531E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-412219.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "463197.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "968.76562",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-267.38037",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "62.998032",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03027913",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258369",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-789.95923",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1397.8521",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1992.2896",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "198.05151",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.96660856E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.91969228E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1669.5547",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1653.748",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-292684.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "634430.44",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "968.76562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-267.53223",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "31.843582",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.29468",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.55481",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.18712",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.97141",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.1339",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "342.73804",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.16452",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.84949",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005859714",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02939265",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.508808",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.19443",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55912621E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77455167E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55912621E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77455167E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005859714",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02939265",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91849449E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26302950E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91849449E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.26302950E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02731653",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.109871",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04573407",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "34.471863",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.741776",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.407669",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.069366",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.16095",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.14532862E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03841985",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.59045",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.68329",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.41774",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.57986",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.50816",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.02509",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0377695",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.509949",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8520.2266",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-798.70166",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1176.5",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-396.39575",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.463379",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2008.4175",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1647.8726",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.3125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-396.39575",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.002441",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.234299",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01893616",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-724.86743",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.213135",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.5946178",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.6908092",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.4338627",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "8.413579",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.13141",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.21313",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.10741",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.63791",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.36021799E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-688.57715",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.21191260E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "17.050781",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47094.68",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "111887.95",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.57779241E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.72861576E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.19431877E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-428528.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "436538.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "967.07812",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-244.5675",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.592606",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03003527",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258387",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-729.927",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1166.0076",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1652.313",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "191.35791",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.60713738E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.56518261E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1462.6704",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2089.5864",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-268309.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "644226.81",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "967.07812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-247.11102",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "31.145493",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.82561",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.52094",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.59222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.72192",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.10741",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "337.18478",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.91962",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.28986",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006008193",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02853684",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.176682",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.15128",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57069171E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74624620E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57069171E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74624620E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006008193",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02853684",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.07687572E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.20605966E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.07687572E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.20605966E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02681318",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.520927",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06644392",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.13345",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.157883",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.320465",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.280594",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.781815",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.22741123E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03649625",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.04875",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.94696",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.91537",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.75403",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.9814",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.3233",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03724229",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "98.891525",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8489.2812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.46216",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.7188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.66772",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.416016",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1833.9773",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2113.7041",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.7812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.66772",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.548828",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-91.383072",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01911926",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-722.85181",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.994873",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.5553713",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.3214226",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1992092",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.6661139",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.54424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.00439",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.58138",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.77856",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.47694402E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-704.83545",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "9.93662979E-07",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.713379",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47277.5",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "111963.28",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.05244612E-06",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.61306230E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.51017275E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-406706.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "441795.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "984.1875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-264.83301",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "68.253052",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03098834",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258423",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-788.1377",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1062.7244",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1510.9087",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "239.09888",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.04170054E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "9.56092094E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1620.4805",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2107.0393",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-348064.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "661188.31",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "984.1875",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-264.83301",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "33.240707",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.0578",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.24335",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.74629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.47168",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.58138",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.05243",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.31085",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.729",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002640346",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02884547",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.985346",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.42612",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56077240E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88163303E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.56077240E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88163303E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002640346",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02884547",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85943259E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00028262E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85943259E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00028262E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02676001",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.714577",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04523289",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.780003",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.207108",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.054718",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.130951",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "35.870071",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "9.45974534E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03706153",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.20807",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.38239",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "188.0513",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.91968",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.15834",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "332.96002",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03250629",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.023201",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8531.6016",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-803.22217",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.8438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-398.69849",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.946045",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1746.4124",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2054.4292",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.8125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-398.69849",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.729492",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.438873",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01937866",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-722.23828",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-63.786133",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6009645",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.8808613",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7313566",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.1991911",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.33763",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.84933",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.19624",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.69504",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.49566256E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-684.74805",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.15562580E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.55542",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47029.18",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112562.47",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.88658747E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.61384003E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.56440149E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-419448.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "423097.88",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "964.73438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-243.10561",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "68.75264",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03031763",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258398",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-786.31836",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1044.6785",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1292.4272",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "177.66724",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.16805528E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.10438144E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1705.5349",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1897.1316",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-246105.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "625701.06",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "964.73438",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-244.13966",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "41.561569",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.58786",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.84763",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.84477",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.56201",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.19624",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "343.31613",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.49477",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.31293",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.01073239",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02968022",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.616987",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.47238",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54675745E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83899174E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54675745E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83899174E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.01073239",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02968022",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92979769E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22665722E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92979769E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22665722E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02999003",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.247349",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04610953",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "38.88324",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.885849",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "35.045868",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.563995",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.92186",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.52769927E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03324893",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.99763",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.15433",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.58533",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.34253",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "186.82938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "336.15546",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03877548",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "90.935982",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8522.293",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.41284",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.5938",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-384.47192",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.785889",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1805.4854",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2105.3967",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.4375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.68945",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-72.239502",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-85.986511",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01893616",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-735.23706",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.709717",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.5426722",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.1600561",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6716509",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.589694",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.82544",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "339.54669",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.82063",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.18219",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.08506640E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-697.15723",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.01031037E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.34082",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46692.543",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112334.72",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.51453808E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.06352172E-06",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.77587208E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.41359135E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-445923.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "439217.44",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "974.9375",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-260.48755",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.638901",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03155754",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258474",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-775.00024",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1073.897",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1237.1619",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "220.89331",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.94706455E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.83291875E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1816.8335",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2134.9001",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-284073.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "603612.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "974.9375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-261.4231",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "40.979568",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.32738",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.17505",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.08067",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.03888",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.82063",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "342.12164",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.51459",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.8432",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005770437",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02787953",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.870874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.21896",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58217299E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87206715E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58217299E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87206715E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005770437",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02787953",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.36894539E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06816912E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.36894539E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06816912E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.01834553",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.587952",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0385133",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.948421",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.408707",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "37.360947",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.863129",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.049118",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8.19178467E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03487116",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.243",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.31036",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.11549",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.24963",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.17976",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.01471",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0395121",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.677483",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8533.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-806.9668",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1177.2188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.29956",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-70.683105",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1460.1301",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1618.8872",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.875",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.29956",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-70.30127",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.68544",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01875305",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.91919",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-60.109375",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.8860102",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "5.1662054",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.0860233",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "6.8123274",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.62958",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.20728",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.63219",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.8493",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21694734E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-686.26587",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.03065395E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.739746",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47420.625",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112762.05",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.37863482E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.40768416E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.68033080E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.62630428E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.25027168E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-399424.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "442166.44",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "961.65625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-244.58606",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "69.743698",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03017837",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258413",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-698.31445",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "955.82544",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1446.1104",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "209.08521",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.78259005E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.36085974E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1455.8169",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1746.7493",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-346612.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "624739.69",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "967.26562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-244.59938",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "32.566406",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.17847",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.34839",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.66518",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.01416",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "180.63219",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "341.21844",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.51801",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "311.69769",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.008874662",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02870618",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.65259",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.17407",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57832565E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79599974E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.57832565E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79599974E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.008874662",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02870618",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.19144704E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94885160E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.19144704E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94885160E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0159791",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "42.27898",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02674647",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "42.813232",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.959106",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.994812",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-42.186966",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "32.939941",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.08181648E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03508811",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "182.76421",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.49985",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "182.7029",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.0174",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.75308",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.00104",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04329312",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "88.728363",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8484.4258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.86719",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.3438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-388.99927",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.243652",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2004.8669",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1801.4336",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-388.99927",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.136475",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-93.770142",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01905823",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-718.07666",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-65.763672",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7966862",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.5511379",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.4322176",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.8929205",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.68172",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.0528",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.627",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.71155",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21583525E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-715.37402",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.13202259E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.015381",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47023.066",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112397.7",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.68727318E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.73617150E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.32787659E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-411185.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "452132.06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "967.28125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-252.79146",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "69.536377",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03065424",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258438",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-692.65137",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1131.3503",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1305.3667",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "215.11475",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.21979530E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.60189004E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1801.1665",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1686.7603",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-270719.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "641255.5",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "972.89062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-253.42238",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "39.094589",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.27252",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.0658",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.88699",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.36761",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.627",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "339.02991",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.44507",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "311.65186",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007058393",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02819547",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.751657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.34256",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58491548E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82799358E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58491548E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82799358E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007058393",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02819547",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85259637E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02986098E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85259637E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02986098E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03059433",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.027313",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04828746",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "34.470348",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.279388",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.85318",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.484695",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.586517",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.11916562E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03839756",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.57788",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.65219",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.40157",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.34821",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.4222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "328.8082",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03504387",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.014297",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8530.3398",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.54761",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1179.1875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.55786",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-71.81665",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1639.8552",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1677.0188",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.7812",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.55786",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-71.362549",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.299133",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.0186615",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-715.39746",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.80957",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2125835",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.8175173",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.567317",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.6205225",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.54103",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "336.86835",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.38385",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.94037",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.40685268E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.83838",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.15617877E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "16.186035",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46648.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112526.7",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.97704240E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.56466547E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.37667155E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-432396.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "447368.75",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "971.53125",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-257.63062",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "64.16597",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03080552",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-839.1792",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1004.5891",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1317.438",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "218.17456",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.26806559E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.72407213E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1568.3967",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1597.9326",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-259120.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "630227.19",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "971.53125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-257.69434",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "34.983322",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.26985",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.01007",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.25706",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.58289",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.38385",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.82904",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.45264",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.01318",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004231554",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02910995",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.309614",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.21964",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52746525E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80112529E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52746525E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80112529E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004231554",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02910995",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96581323E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97366057E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96581323E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97366057E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02309363",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.860489",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03603535",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "37.415173",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.07225",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.33519",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-36.057007",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "31.784805",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "7.29318685E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03492091",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "186.01904",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.3735",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.7977",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.86859",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.89366",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.10443",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03658603",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "94.336617",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8536.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.71289",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.7188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.44385",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-74.92749",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1892.3337",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2088.6335",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.44385",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-74.779053",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-89.764862",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01872253",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.0354",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.462158",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2063894",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.3932762",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6738873",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.5644026",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.3358",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.55438",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.41191",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.49982",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.77705226E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-678.35059",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.22585334E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.040039",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47140.543",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112708.09",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.86712156E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.58536966E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.29052296E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-399361.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "450951.69",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "967.39062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-245.99329",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "71.791336",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02993955",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258423",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-721.98267",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1720.1833",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2318.238",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "198.48877",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.26998553E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.93724553E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1436.0715",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1769.4602",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-319837.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "649891.69",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "967.39062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-247.29054",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "43.589081",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.96751",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.6062",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.82698",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.37646",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.41191",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.99426",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.27296",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.81305",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007308207",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02883676",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.485014",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.48654",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59884912E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76674203E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59884912E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76674203E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007308207",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02883676",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.15499676E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96075416E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.15499676E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96075416E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02723352",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.58815",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05003832",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "39.83984",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.227203",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.652939",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-37.856384",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "36.328003",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.69965214E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03489356",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.55379",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.6507",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.24239",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.48883",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.50806",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "331.55319",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03860666",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "88.927582",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8512.0703",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-803.8479",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1179.0625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-394.74585",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-72.418213",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1783.084",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1610.0457",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.9375",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-394.74585",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-71.844482",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-99.271332",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01876831",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-734.52759",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.039795",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.8661995",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "6.401803",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1861134",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.2054176",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.30579",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "339.38184",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.22636",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "342.99957",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.15690432E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-719.46899",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.09491521E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "13.247803",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47141.977",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112234.86",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.16407214E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.44373735E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.20566710E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-417830.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "449264.31",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "958.46875",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-241.12677",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "61.672775",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02967686",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258411",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-820.11011",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1264.6648",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1821.2014",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "198.53491",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.28247471E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.93833692E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2003.3313",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1751.7437",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-284666.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "624266.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "961.65625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-241.12677",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "27.768646",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.22319",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.98688",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.25529",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.24298",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.22636",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.75665",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.14561",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.00922",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002905212",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02880867",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.932968",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.28284",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59142892E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75285913E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.59142892E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75285913E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002905212",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02880867",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88544891E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03975674E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88544891E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03975674E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02688815",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.440971",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04948776",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.042339",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.638412",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "33.352829",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.450546",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "31.924896",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.14617389E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03832285",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.8615",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.81995",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "183.64848",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.69318",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "183.65837",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.04169",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.02092659",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "96.557022",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8535.5312",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.8313",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1179.2188",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.68848",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-70.513672",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1925.0872",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2034.7417",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.1562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-388.52856",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-70.201172",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-92.902832",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01864624",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.60181",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-61.611328",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8797112",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.8931398",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.1178675",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.8199081",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.72778",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.85254",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.74757",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.80609",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.34869197E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-686.97437",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.09217945E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.676025",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47158.965",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112217.56",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.59592012E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.80976724E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.55854176E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.53899498E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-408551.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "438526.25",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "961.65625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-280.74048",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "68.28772",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03052596",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-700.06372",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1041.7634",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1425.7498",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "203.39307",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.70117436E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.13331553E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1958.3167",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2110.3064",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-316407.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "637398.75",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "961.65625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280.76099",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "36.437286",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.12349",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.26605",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.43539",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.03992",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "181.74757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.81586",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.42099",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.13849",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005289529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03264626",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.832613",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.5687",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.53738420E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86312409E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.53738420E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86312409E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005289529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03264626",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95220241E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03948684E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95220241E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03948684E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02490082",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.697979",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05323829",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.890591",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.22789",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.942963",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.57431",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.633957",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "5.89695546E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03696558",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.02594",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.66699",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.60095",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.41071",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.60095",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "330.52631",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03167232",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "92.26329",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8530.4141",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.99634",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1177.8438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-416.10107",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-73.313721",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1881.3667",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "2266.5801",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1179.6562",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-416.10107",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-73.282471",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-88.469284",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01924133",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-735.09375",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-62.418213",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7601194",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.3565798",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8192739",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.8415728",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.35112",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "338.4538",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.26195",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.31305",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41769374E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-687.36621",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.06391963E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "13.830322",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47230.668",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112399.47",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.84049689E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.72528712E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.24231504E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.20727361E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-406896.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "421455.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "963.32812",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-249.48067",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "67.615173",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03017506",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258472",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-707.8186",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1068.8008",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1306.2974",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "210.37378",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.22351741E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.41172039E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1720.9631",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "2142.7078",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-311795.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "663761.44",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "966.125",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-249.62996",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "35.359055",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.31509",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.22916",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.99973",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "319.58698",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "182.26195",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "338.98438",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.24747",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "314.41003",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005368207",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02937916",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.046568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.59909",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52661960E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80532370E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.52661960E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80532370E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.005368207",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02937916",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.14218221E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.28596105E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.14218221E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.28596105E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03411809",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.507126",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05222962",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "36.766167",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.063263",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "31.272766",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.26329",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.844559",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "4.25782538E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03586805",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.24419",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.4884",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "184.73384",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.12115",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "184.75621",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "333.08942",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03898449",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "92.385788",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8530.8164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-808.61377",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1177.4062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.1687",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-75.92334",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2108.7637",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1858.7432",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.5625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.1687",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-75.164307",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-87.066254",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01931763",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-736.88379",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-66.674316",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9423018",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.5014095",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.7408772",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.5622301",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.3658",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "339.11993",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.35664",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.35141",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.48117601E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-712.57739",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.07908272E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "14.884033",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47009.066",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112473.13",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.81754864E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.91412437E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.17667662E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-405362.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "430745.56",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "968.40625",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-235.10242",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "67.71669",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03023894",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258432",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-690.00464",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "1805.426",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2279.9255",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "210.31616",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.11678455E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "8.41017709E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1526.1265",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1860.7126",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-263772.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "640566.25",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "969.625",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-235.10242",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "41.994995",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.82527",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "309.92096",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "197.07549",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "317.80655",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.35664",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "336.91782",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.27028",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "312.54956",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007540252",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02736724",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.533073",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.56113",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54494664E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76047924E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.54494664E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76047924E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007540252",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02736724",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85238412E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10922826E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.85238412E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10922826E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02913061",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.19672",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0426123",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "39.853226",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.770645",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "30.00798",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-37.190628",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "33.476196",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.81479264E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03472746",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.75624",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.70721",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "187.56577",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.17685",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.65874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "334.70926",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03934226",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "scale_max": "99.625336",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "230",
                                            "gribNumBits": "16"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8477.1875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "scale_max": "100000.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "217",
                                            "gribNumBits": "16"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.52612",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "203",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "scale_max": "1178.8438",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "178",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-378.9187",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "scale_max": "-76.426758",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "179",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1601.178",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "scale_max": "1723.196",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "105",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "scale_max": "1180.0938",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "187",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-381.86719",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "scale_max": "-76.425293",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "188",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "scale_max": "58762.242",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "129",
                                            "gribNumBits": "16"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-90.398636",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "scale_max": "0.01940918",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "220",
                                            "gribNumBits": "16"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-718.18799",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "scale_max": "-67.4375",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "205",
                                            "gribNumBits": "16"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0984135",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "scale_max": "4.2428827",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "181",
                                            "gribNumBits": "16"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9088383",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "scale_max": "5.3310137",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "180",
                                            "gribNumBits": "16"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.87035",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "scale_max": "337.37054",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "169",
                                            "gribNumBits": "16"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.95042",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.26202",
                                            "gribparam": "139",
                                            "gribNumBits": "16"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30692422E-06",
                                            "gribparam": "160",
                                            "gribNumBits": "24"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-694.93066",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "scale_max": "0.0078125",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "204",
                                            "gribNumBits": "16"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "gribNumBits": "16"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "scale_max": "1.14116119E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "218",
                                            "gribNumBits": "16"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "scale_max": "15.637207",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "141",
                                            "gribNumBits": "16"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "scale_max": "1.5",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "211",
                                            "gribNumBits": "16"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "scale_max": "20.00148",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "173",
                                            "gribNumBits": "16"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "gribNumBits": "8"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46824.52",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "scale_max": "112249.19",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "134",
                                            "gribNumBits": "16"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.55717736E-07",
                                            "gribparam": "144",
                                            "gribNumBits": "24"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "scale_max": "1.73030469E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "142",
                                            "gribNumBits": "24"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "scale_max": "1.49208211E-06",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "143",
                                            "gribNumBits": "24"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-408537.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "scale_max": "414153.38",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "108",
                                            "gribNumBits": "16"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "scale_max": "958.89062",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "176",
                                                "gribNumBits": "16"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-237.05594",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "scale_max": "70.604034",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "gribparam": "177",
                                                "gribNumBits": "16"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "scale_max": "1.0",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "172",
                                            "gribNumBits": "8"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0296397",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25845",
                                            "gribparam": "152",
                                            "gribNumBits": "16"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-714.19043",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "scale_max": "906.16455",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "146",
                                            "gribNumBits": "16"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1205.9248",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "scale_max": "180.95361",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "147",
                                            "gribNumBits": "16"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212",
                                            "gribNumBits": "8"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.82215512E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "scale_max": "7.23560163E-08",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "182",
                                            "gribNumBits": "24"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1710.5007",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "scale_max": "1856.1567",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "106",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-245620.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "scale_max": "657009.31",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "107",
                                                    "gribNumBits": "16"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "scale_max": "958.89062",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "185",
                                                    "gribNumBits": "16"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-237.05594",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "scale_max": "29.895065",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "gribparam": "186",
                                                    "gribNumBits": "16"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "scale_max": "0.8004687",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "175",
                                            "gribNumBits": "8"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.51846",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "scale_max": "310.03604",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "183",
                                            "gribNumBits": "16"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "198.59216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "scale_max": "318.97089",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "209",
                                            "gribNumBits": "16"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.95042",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "scale_max": "340.19296",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "207",
                                            "gribNumBits": "16"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.94209",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "scale_max": "313.82526",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "170",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.01531013",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02805995",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.668716",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.77588",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "gribNumBits": "16"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58818111E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85673707E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "gribNumBits": "16"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.58818111E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85673707E-05",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst mar2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.01531013",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02805995",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "133",
                                            "gribNumBits": "16"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95944517E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11883253E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "gribNumBits": "16"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.95944517E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11883253E-06",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0331485",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.3424",
                                            "gribparam": "171",
                                            "gribNumBits": "16"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05416977",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "scale_max": "35.439045",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "216",
                                            "gribNumBits": "16"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.285217",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "scale_max": "29.715775",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "166",
                                            "gribNumBits": "16"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.512619",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "scale_max": "34.976257",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "165",
                                            "gribNumBits": "16"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "6.30142267E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "scale_max": "0.03549422",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "168",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.80666",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.74908",
                                            "gribparam": "201",
                                            "gribNumBits": "16"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "185.59688",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.19037",
                                            "gribparam": "202",
                                            "gribNumBits": "16"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "185.68089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "scale_max": "329.76306",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "167",
                                            "gribNumBits": "16"
                                        }
                                    }
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2002-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "272.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/mar2002/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "nov2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nov2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200205",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200205",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200205",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200205",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200205",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200205",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200205",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200205",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200205",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200205",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200205",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200205",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200205",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200205",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200205",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200205",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200205",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200205",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200205",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200205",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200205",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200205",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200205",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.nov2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/asst/nov01/30003fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200205",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0395265",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.349518",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8519.8008",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-808.21899",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-382.15747",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.057617",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1572.5862",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2028.5542",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-382.15747",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.440674",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-89.590683",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06489563",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-708.97363",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.9104",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1289835",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3713655",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.2044353",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7955074",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.83188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.40875",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.82512",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.25699",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59509705E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-696.09619",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.49147909E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.440674",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47333.309",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111853.36",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.69750317E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55050907E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19982644E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-404873.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "406227.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "970.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-270.10962",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.347656",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0312985",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258343",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-777.09351",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1699.0305",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1958.4976",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "190.15283",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.83148323E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60343255E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1845.0022",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1979.1833",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-357702.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615019.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.8125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-270.10962",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "15.183456",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.14055",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89313",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "196.43719",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.82544",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.82512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.46011",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.29866",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.1012",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008617736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02638229",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.825615",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.54395",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20503828E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85550452E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20503828E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85550452E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008617736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02638229",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.06764321E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95005578E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.06764321E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95005578E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02964078",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.241848",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05242581",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.7145",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.158539",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.675446",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.875595",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.283188",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "5.42675416E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0374468",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.95523",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.0903",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.59596",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.70544",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.67505",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.59702",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04377687",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.936676",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8521.0859",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-805.89697",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-394.60522",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.292969",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1890.8667",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1873.1519",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-395.95898",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.486816",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-83.419312",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06448364",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-712.52856",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.302002",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5043478",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1563978",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1222553",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0216503",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.83987",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.43683",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.76825",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.95844",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07345079E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-717.74023",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02899503E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.609863",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47608.051",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111652.52",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.25777625E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.93112010E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35202640E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-438630.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "435160.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "969.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-272.74756",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "56.976334",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03177311",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258451",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-872.25073",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "998.37891",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1023.3523",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "202.1084",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.09209889E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.48910054E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1593.2407",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2002.1934",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-337486.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "609937.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-272.79517",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.106979",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.43221",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.16486",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.13419",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.18292",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.76825",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.60687",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.56425",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.19525",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004764792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02790575",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.71586",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.25348",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23146037E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86857123E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23146037E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86857123E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004764792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02790575",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.91132381E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04684284E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.91132381E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04684284E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03132873",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.466949",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05607628",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.36438",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.90448",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.768326",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.601303",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.480072",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.48014806E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03607272",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "190.15334",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.20868",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.95059",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.40961",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.95842",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.08603",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04491321",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "88.172165",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8512.1953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.5979",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-389.55151",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.136719",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1942.7754",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2296.6631",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.55151",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.575195",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-94.194183",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06480408",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-723.05957",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.393799",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7888699",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8639698",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.5529203",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5278378",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.82501",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.73901",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.74971",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "347.70007",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20385437E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-710.90234",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02902413E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.557617",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47058.555",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112148.14",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.24662300E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.90429921E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30014337E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-410694.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "466764.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "972.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-264.40259",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "51.894287",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02974764",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258539",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-935.2561",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1195.7812",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1197.6418",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "219.07861",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.60879846E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.76038655E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2260.6941",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2505.0957",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-319104.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "636473.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.20312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-264.65479",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "8.7593231",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.36766",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.71515",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.5773",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.4472",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.74971",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "343.56921",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.63875",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.58905",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006039791",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02786039",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.428114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.38409",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28618467E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74136421E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28618467E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74136421E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006039791",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02786039",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94150743E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99278907E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94150743E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99278907E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02875257",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.354961",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05152575",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.919212",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.970673",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.815002",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.089233",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.788101",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.28506315E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03773331",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.13731",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.79437",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.99394",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.04388",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.00111",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.76746",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05004693",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.32402",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8523.4688",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-809.01538",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-390.06934",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.874023",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1482.4871",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1713.9937",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-390.06934",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.677246",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-86.627289",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06503296",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-710.47778",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.06665",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2683239",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8446803",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.7111912",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4761562",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.62363",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.47241",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.53784",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "343.78137",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20019990E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-697.84912",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04479841E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.48291",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47719.719",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111897.63",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.73218880E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47764933E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21816049E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-429762.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "458931.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "970.70312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-269.49634",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.82634",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03083586",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258465",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-741.11963",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1059.4609",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1166.3433",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "215.63159",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.66387974E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.62259242E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1656.4639",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1874.061",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-272364.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "659158.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.70312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-269.49634",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.10054",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.90067",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.30029",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.22716",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.90704",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.53784",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "339.95715",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "208.99916",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.88098",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004672695",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02752949",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.540199",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.79944",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28528136E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80124644E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28528136E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80124644E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004672695",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02752949",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94469999E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09170571E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94469999E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09170571E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02158911",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.117813",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04046643",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.268509",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.854294",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.311279",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.326111",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.998718",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.29714238E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03491021",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.98366",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.35004",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.72849",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.85327",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.83029",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.79117",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05230418",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.604362",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8556.4219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-803.98535",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-386.64355",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.616699",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1585.74",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2078.9053",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-386.64355",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.494385",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-82.677872",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06427002",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-748.19434",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.641113",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.872077",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9097357",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.8656282",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.6744623",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.6546",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.58997",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.58965",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "348.19873",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20582524E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-700.2561",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10644032E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.34082",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47073.766",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112176.58",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88233933E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.70648707E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.80914268E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35664561E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-402450.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "435635.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "971.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-266.30566",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.27272",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03046413",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25844",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-764.62842",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "889.70337",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1266.7439",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "170.42554",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.06535400E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.81508254E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1662.5291",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1832.0349",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-314046.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "660918.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.01562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-266.36475",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "26.694717",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.37915",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.92316",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "199.59152",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.98792",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.58965",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "344.10693",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "208.99112",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90424",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00408382",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02705628",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.403667",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.05496",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28438724E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91621493E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.28438724E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91621493E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00408382",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02705628",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.96766018E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05621564E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.96766018E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05621564E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03371577",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.494541",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05802181",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.454342",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.642181",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.641388",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.983826",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.501678",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.03655566E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03382499",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "190.21526",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.04138",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "190.13518",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.06979",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.17415",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.65817",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04487296",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.977745",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8540.0938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-808.79663",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-380.60327",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.610107",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1595.063",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2300.6279",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-381.44043",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.235107",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-88.047623",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06462097",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-727.10376",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.984131",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7509661",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2935266",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.6097755",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3730583",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.53049",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.31448",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.40607",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.39676",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26687144E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-693.83521",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08144013E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.698975",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47136.613",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112096.61",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.18834337E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46220634E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18245509E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-460506.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "459250.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "976.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-253.23213",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "49.951218",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0305268",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258425",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-731.80957",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1077.8921",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1433.9663",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "228.45679",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.73402986E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.11637335E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1776.1455",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2065.896",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-302278.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "635403.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.15625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254.71638",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "26.356522",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.32201",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.18848",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "199.0748",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.72568",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.40607",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.29129",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.60379",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82605",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005152542",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02615275",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.325024",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.72556",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22598840E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82096410E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22598840E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82096410E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005152542",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02615275",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03419631E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99992724E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03419631E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99992724E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02906288",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.169922",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05438431",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.895718",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.351776",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.362808",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.639175",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.903198",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "9.02742840E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04007169",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.72688",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.53391",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.61531",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.11514",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.62383",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.34827",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05134381",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.025902",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8507.0938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-805.50708",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-387.59229",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.952148",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1769.4084",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1639.0005",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-387.59229",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.676758",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-85.652817",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06497192",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-743.75293",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.800293",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2023935",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2266407",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.6060495",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.2311335",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.70547",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.91693",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.70518",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "348.62259",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21513176E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-704.68408",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03758066E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.476074",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47490.332",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112242.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88556292E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53456847E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34158415E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-425904.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "498046.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "981.1875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-268.76221",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "57.467896",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02993821",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258427",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-742.01245",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1147.1589",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1150.8896",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "245.13257",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.23786418E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.80207346E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1541.7537",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1671.1499",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-263742.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630572.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "981.1875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-268.76221",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.259232",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.22171",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.4707",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.93912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.84637",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.70518",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "344.22415",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.53891",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.30478",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008174233",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.0277974",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-22.111877",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.75388",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22552647E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83636712E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22552647E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83636712E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008174233",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0277974",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.86207956E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98717703E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.86207956E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98717703E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02816176",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.088776",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0515776",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.616676",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.191589",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.146088",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.811874",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.490601",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8.61567173E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03643609",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.07465",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.45441",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.04962",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "320.48325",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.07402",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.16153",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04542519",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.549454",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8521.1484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.45898",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-392.27588",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.377686",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1946.4866",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1828.9321",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.27588",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.97168",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-88.15036",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06497192",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-716.25732",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.558594",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6019297",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6930399",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5977373",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7870359",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.32451",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.00916",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.39496",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.83032",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23580969E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-704.74072",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17495074E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.107422",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47219.238",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112123.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.06583444E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64927576E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49051334E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-448228.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "507801.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "979.79688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-271.44971",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.051865",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0299061",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25849",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-767.74463",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1275.2473",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1276.8503",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "173.78491",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.50474715E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.94943196E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1759.7144",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1694.9199",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-366529.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "597005.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.79688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-271.44971",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "17.043228",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.99301",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.61148",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.67909",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.37103",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.39496",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.76065",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.15215",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.66507",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00500134",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02917994",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.58852",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.9234",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20293653E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78545961E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20293653E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78545961E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00500134",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02917994",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85513784E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93497158E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85513784E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93497158E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.01585075",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.730782",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0404783",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.636944",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.210251",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.009384",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.835297",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.963272",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.01932415E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03348062",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "190.1898",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.30792",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.94289",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "322.42474",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.03993",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.59271",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04802514",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.609077",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8524.8125",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-811.11279",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-394.66846",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.826416",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1715.0498",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2217.6448",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-394.66846",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.311523",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-85.296005",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06468201",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-707.51416",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.202881",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5133705",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0430813",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6649714",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0259762",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.41817",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.80869",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.32149",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.49783",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49629977E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-696.33545",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.68197128E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.584473",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47449.676",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112127.58",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.95891060E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.93710298E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.18798571E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39508643E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-441378.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "434859.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "969.03125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-286.26611",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "56.866379",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02997675",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-759.23389",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "965.31909",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1314.9521",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "196.42139",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.25812538E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.80102880E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1721.3457",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1898.3074",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-334612.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "616824.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.82812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-286.26611",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.657318",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.89767",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.3783",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.5126",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.77258",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.32149",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.17166",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.09067",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.05396",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00484702",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02719257",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.29071",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.82605",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22518950E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80655097E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22518950E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80655097E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00484702",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02719257",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.15030605E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14325246E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.15030605E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14325246E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03390134",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.872742",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.07133287",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.309345",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.936081",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.541153",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.3638",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.327011",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.50186850E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03427827",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.61478",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.4928",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.54645",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.04218",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.58578",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.06113",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.02195099",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "83.422897",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8525.1875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-808.43848",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-383.18481",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.416504",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1364.2039",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2171.7656",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-383.5813",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.45874",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-93.011612",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06480408",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-716.16138",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.270996",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2643795",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5025158",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.8497543",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9668961",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.33752",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.83124",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.34491",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.49374",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06471543E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-697.90503",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09281973E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.188965",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "46531.035",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111912.55",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.87933493E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.92737639E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26445798E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-459192.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "444848.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "971.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-266.66943",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "60.045242",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03095956",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-751.81055",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "973.82373",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1260.1665",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "199.84839",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.03905369E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.99161626E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1738.8108",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2102.2344",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-296471.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630706.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "977.9375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-266.66943",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "23.429214",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.09937",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.78473",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.1566",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.10504",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.34491",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.37265",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.15941",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.7197",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0063418",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02838232",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.677736",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.66721",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.25488032E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73419958E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.25488032E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73419958E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0063418",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02838232",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.97437430E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08807182E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.97437430E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08807182E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02090861",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.703945",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.03440671",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.569923",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.453537",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.118393",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.690445",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.017761",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "9.67276605E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04087082",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.40067",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.28583",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.26591",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "322.36029",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.26591",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.10138",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04052282",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.626099",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8518.5938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-802.50879",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.8125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-376.2002",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.355713",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1921.4502",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1772.2957",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-376.2002",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.545898",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-88.183243",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06478882",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-730.23853",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.891846",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4900064",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8905392",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3194017",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4349947",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.73869",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.86191",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.57715",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.25598",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.89177592E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-728.91699",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.77364834E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.400391",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47312.086",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112247.64",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.43138514E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.81725727E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25763734E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-446386.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "460132.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "974.79688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-254.22859",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.418335",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03117118",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-785.38574",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "943.78027",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1088.3262",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "180.16797",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.35191197E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.20419280E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1648.8127",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2031.9944",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-308537.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "614736.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.79688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254.22859",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "19.422791",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.29347",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.58527",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.69487",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.37595",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.57715",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.12708",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.5863",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.48312",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005417887",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02868472",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.767603",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.70175",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.42175786E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85129738E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.42175786E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85129738E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005417887",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02868472",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.18384025E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89614389E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.18384025E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89614389E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02726138",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.443451",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.06398636",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.364243",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.785721",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.544556",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.763062",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.733276",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.29247383E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03856341",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.58479",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.65283",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.4288",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "319.38324",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.48517",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.31027",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05089443",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "85.684723",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8513.2344",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-801.68237",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-383.13818",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.547852",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1975.3118",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1866.5652",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.16382",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.810059",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-87.08313",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06492615",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-725.03589",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.634766",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5977526",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9360046",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3826027",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5783863",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.88417",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.76379",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.93774",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.42279",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.86754892E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-701.82471",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.74468242E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "17.072754",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47395.922",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112241.55",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.99461645E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.93483538E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21747473E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-432331.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "431781.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "968.07812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-286.42407",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "58.633423",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03013983",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258446",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-762.25854",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1325.5566",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1422.1028",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "178.32764",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.68659061E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.13088184E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1555.397",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1983.1533",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-278402.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "648039.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.07812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-287.85083",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.32457",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.84424",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59735",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "196.57722",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.49628",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.93774",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.54132",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.04562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.34167",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005203471",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02705254",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.216829",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.79532",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.17310738E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85066365E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.17310738E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85066365E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005203471",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02705254",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00276236E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.42827673E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00276236E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.42827673E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03837647",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.585571",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.07345283",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.730774",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.303207",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.913086",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.133667",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.07988",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "4.99012742E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03847638",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.38065",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.47098",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "187.0507",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "320.04114",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "187.31786",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.47015",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.03549722",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "88.686806",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8506.7188",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-805.80005",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-392.19751",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.762207",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1479.9453",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1807.6582",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.19751",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.48877",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-95.060181",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06510925",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-721.13428",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.576172",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-6.3768969",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2417593",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2599421",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1116905",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.92871",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.1524",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.7507",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.09741",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21408425E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-700.62231",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.30958777E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.70752",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47154.672",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112016.5",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.03605906E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59930585E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43295620E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-402965.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "467117.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "967.03125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-255.66472",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.073273",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03034395",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-724.5708",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "975.22266",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1017.543",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "188.90332",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.06886898E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.55385940E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1770.4534",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1743.4583",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-315632.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "656078.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-255.66472",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "7.2911987",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.05313",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.33069",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.16054",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "320.0416",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.7507",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.7146",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.1718",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.43091",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004477791",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.026388",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.553371",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.79083",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.18893777E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86506950E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.18893777E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86506950E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004477791",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.026388",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.97091958E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97174859E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.97091958E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97174859E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03561451",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.806572",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04842442",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.304607",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.60881",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.060303",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.959793",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.8974",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8.72887540E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0352477",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.02638",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.27393",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.24182",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.51764",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "188.24182",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.3027",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04171022",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "85.888443",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8518.4062",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.08643",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-397.50269",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.988525",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1492.3533",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1926.76",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-397.50269",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.122803",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-80.738419",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06434631",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-740.31348",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.417236",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7506084",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6692095",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4813499",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8423328",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.47249",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.37012",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.41766",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "348.4834",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27188480E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-697.62036",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.83272912E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.498047",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47022.281",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112077.11",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.64245465E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73163585E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40337534E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-445047.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "468968.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "973.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-287.41992",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "52.544968",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02966277",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258484",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-730.01099",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1236.3237",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1232.5063",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "204.41333",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.61167019E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.17412911E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1631.9954",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2077.1562",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-290584.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "583064.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-287.59912",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "22.417419",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.5872",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.95685",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "200.84396",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.87402",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.41766",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "344.39984",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.81593",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.68451",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.002978202",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02648253",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.590261",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.93237",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.18186999E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89844432E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.18186999E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89844432E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.002978202",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02648253",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83433326E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83507382E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83433326E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83507382E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02012542",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.087059",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05165628",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.328903",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.466034",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.441666",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.98851",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.446991",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "2.38425855E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03686349",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "193.93782",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.98724",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "193.12865",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "322.93542",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "193.22409",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.80145",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.03999885",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.825432",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8519.8008",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.0603",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-389.11353",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.557373",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1681.0227",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1704.3257",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.11353",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.023193",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-89.801727",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06469727",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-716.49805",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-59.332275",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6060667",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8319721",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1886168",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3562117",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "180.07471",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.69104",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "180.06883",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.67911",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73459489E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-690.31958",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02655031E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.208496",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "46970.059",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112175.16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60801925E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.85767851E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24575240E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-428811.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "450234.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "966.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-272.45215",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.776657",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03158739",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258644",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-728.46265",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "903.38354",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1262.0073",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "160.97095",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-5.04641378E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.43698286E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2006.4561",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1899.395",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-293111.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630902.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.39062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-272.59546",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.215759",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.27135",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.18903",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "194.48915",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.63766",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "180.06883",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.79089",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.57686",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.655",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005083919",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02745394",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.539429",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.09778",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.29960899E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79182425E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.29960899E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79182425E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005083919",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02745394",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03644095E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25210124E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03644095E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.25210124E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02359791",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.851315",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04469295",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.06028",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.03923",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.711334",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.50116",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.820053",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "2.79916108E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03931992",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "184.40092",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.19376",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "184.05199",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "321.03223",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.09607",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.27649",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.02642297",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "83.331619",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8520.6094",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-813.31763",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-385.25757",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.897217",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1630.3572",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1917.3186",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-385.25757",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.388916",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-87.518539",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06478882",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-732.48901",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.706055",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.5230112",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4641914",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.4366245",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8947392",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.91609",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.03058",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.75851",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.66614",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43748491E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-702.47705",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.95176379E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.643311",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47050.754",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111808.86",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.02807995E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68828740E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42791839E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-442152.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "453857.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "977.23438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-276.48218",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "47.311905",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03014275",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258429",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-765.80054",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1124.4336",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1131.8635",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "195.63135",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.30517048E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.82260656E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2094.0889",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2208.3081",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-322438.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "586846.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "977.23438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-277.98242",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.12883",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.19145",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.3931",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "196.41655",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.4632",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "183.75851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.57434",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.27089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.29758",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00645091",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02924465",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.286209",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.66101",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22688016E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78894843E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.22688016E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78894843E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00645091",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02924465",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.09566224E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98902239E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.09566224E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98902239E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03069951",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.246132",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.06263906",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.653545",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.665283",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.802048",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-34.030579",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.829208",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "5.68123610E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03422546",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.54524",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.68817",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.06303",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.48877",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.24815",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.07904",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05012326",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.497993",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8521.7227",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-810.18921",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-401.43481",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.303467",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1571.7568",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1824.7625",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-401.43481",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.938232",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-88.847443",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06471252",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-718.36035",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.689697",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.972208",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0461025",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.0054998",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9435892",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.00583",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.39618",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.882",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.97839",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16709782E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-694.22266",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.86241503E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.005371",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "46973.129",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111979.59",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.61572835E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66385428E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28462364E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-461046.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "485010.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "971.23438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-273.81494",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "61.372253",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03130077",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258394",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-725.38599",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1047.7686",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1222.5852",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "194.65454",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.88877617E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.78341018E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1519.0046",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1941.1494",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-296230.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "645574.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-273.84351",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.449753",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.29649",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.1333",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.6331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.5209",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.882",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.4325",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.40669",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.25012",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008942015",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.0274215",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.965477",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.6907",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.33110316E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77423281E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.33110316E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77423281E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008942015",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0274215",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.26730322E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93166034E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.26730322E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93166034E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.0203337",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.391098",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04200533",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.893314",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.695496",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.473068",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.073242",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.159119",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "5.15375227E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03983427",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.21027",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.38177",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.00192",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.71313",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "188.10448",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.26462",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05399295",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.647263",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8531.1484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-804.52515",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-384.27905",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.328857",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1801.2344",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1638.8091",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-385.19849",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.557861",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-85.82872",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06495667",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-735.81982",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.398193",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.6367397",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.466506",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.0071154",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3186235",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.39833",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.10947",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.38303",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.75153",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21311336E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-718.24707",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.43691703E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.174316",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47618.488",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112125.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36179175E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46921798E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26487259E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-461007.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "463624.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "968.96875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-278.22974",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.601898",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02974646",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258505",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-711.90015",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1167.4983",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1753.7021",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "176.04199",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-7.01256397E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.03918772E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1504.8931",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1728.4663",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-259354.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "600408.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.25",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-278.22974",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "17.039307",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.25595",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.07251",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.2178",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.41342",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.38303",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.44147",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.65146",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.9552",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005387854",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02796195",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.63043",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.69934",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20003515E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83788852E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.20003515E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83788852E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005387854",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02796195",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.10755206E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94103018E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.10755206E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94103018E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03322472",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.828972",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0556691",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.066967",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.491882",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.291962",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.850113",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.366791",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "4.83842797E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0336073",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.87395",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.36145",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "186.57861",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.36035",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.85916",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.52448",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05039978",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.85434",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8506.0352",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.15015",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-411.72266",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.293945",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2074.7466",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1937.8281",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-411.72266",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.067871",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-86.226974",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06491089",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-763.8208",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.565674",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6781836",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6046572",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7046375",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6860967",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.29317",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.87646",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.26962",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "350.53156",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50093160E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-705.92847",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.80973709E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.968506",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47261.996",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112788.16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51588516E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.91116078E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.80700392E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51756296E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-414941.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "447733.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "969.34375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-296.24609",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "55.019913",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03024133",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258432",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-825.98828",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1056.7322",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1236.0247",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "218.68823",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.94251708E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.74456987E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2031.3955",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2080.7808",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-326954.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "683574.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.39062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-296.24609",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.047882",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.92369",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.65991",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.30219",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.75626",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.26962",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "345.9339",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.03738",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.58713",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005758125",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02971217",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.473675",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.59818",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23827604E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84204018E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23827604E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84204018E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005758125",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02971217",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.77869401E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91149229E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.77869401E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91149229E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03108513",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.488258",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04275884",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.766277",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.129974",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.771347",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-34.966003",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.63028",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.31239972E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04161635",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "191.38911",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.56418",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "191.11057",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.17755",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "191.15784",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.71179",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04696513",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.021484",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8519.0117",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-812.30249",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-374.83594",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.343262",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-2040.1733",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1580.7683",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-376.05078",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.375",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-87.277466",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06468201",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-715.78955",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.941162",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2701244",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5781918",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3775606",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9307938",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.55228",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.62582",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.52422",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.04926",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27336546E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-701.88623",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.76287993E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.107666",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47136.602",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112130.36",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.43889018E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.05659876E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29568912E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-426526.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "426835.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "974.01562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-249.26016",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "54.99855",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03008439",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-790.82471",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1031.4729",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1164.8984",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "221.99097",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.65810274E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.87657450E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1619.2275",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1999.5872",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-283188.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "602972.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.01562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-250.62895",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.238983",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.22334",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.11548",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.62643",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.35498",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.52422",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.82855",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.44478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82529",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006724898",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02809741",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.480265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.83432",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.21903186E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84792407E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.21903186E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84792407E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006724898",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02809741",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.02121964E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95868279E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.02121964E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95868279E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02663863",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.74464",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04316195",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.670494",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.402802",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.028229",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-34.348633",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.417313",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "9.45815373E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03459571",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.30501",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.23914",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.10489",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.22485",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "188.11188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.20251",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05514316",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.335487",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8532.3516",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-808.90186",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-384.93677",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.807373",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1637.3752",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1889.0864",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.93677",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.509766",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-87.920868",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06492615",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-726.41089",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.249512",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5424461",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0780926",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1247082",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7225456",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.42009",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.57489",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.4341",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.2009",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22549886E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-702.4231",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.38962330E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.779785",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47308.898",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111778.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.84330211E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.82338704E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41719613E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-405000.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "442254.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "974.625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-259.75757",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "55.265884",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03095638",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258415",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-735.1582",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "995.28467",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1056.354",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "178.47681",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.22406373E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.13686745E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1885.8872",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1970.9341",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-323054.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "625405.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-260.29395",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "15.926514",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.11842",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.33081",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.77045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.98959",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.4341",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.23801",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.29057",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.9953",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005075064",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02700973",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.620155",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.98175",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23968084E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78706759E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23968084E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78706759E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005075064",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02700973",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.05079255E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02953197E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-2.05079255E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02953197E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03361486",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.53286",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.05396182",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.143444",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.079102",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.343109",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-32.741653",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.884323",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.34880452E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03915901",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "190.28618",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.35333",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.92375",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "321.91272",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "190.11302",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.69873",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0456004",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "83.49942",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8522.8516",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-807.65503",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-378.48877",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.29834",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1784.8418",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1803.8789",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-378.48877",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.534912",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-82.087036",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06472778",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-702.25024",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.057373",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.8196039",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6999397",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-6.7599573",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1096735",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.30878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.18939",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.27138",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.28534",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28411659E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-698.50659",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01610203E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.874512",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47103.934",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112253.66",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.05734794E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.94003655E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32519801E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-447250.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "451254.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "973.89062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-261.28735",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "48.019485",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02992557",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-727.33154",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "925.32495",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1176.7839",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "180.38574",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.70562952E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.21281026E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1883.8315",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2175.8555",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-355172.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "607140.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.89062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-261.28735",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "19.057312",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.26729",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.26971",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "198.74512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.35059",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "186.27138",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.4787",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.57289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "314.19815",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008954212",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02711352",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.593397",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.66064",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.26135328E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85510999E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.26135328E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85510999E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.008954212",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02711352",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83427801E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19637195E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83427801E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19637195E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.0241781",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.214012",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04752328",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.143303",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.275696",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.657074",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-31.527893",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.744934",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "9.21028231E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03884846",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.86583",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.20312",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.70842",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.15982",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "188.79341",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.39764",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04995805",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "84.410393",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8520.6172",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-804.75439",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-390.16431",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.767822",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1600.2456",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1869.6614",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-391.9375",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.970215",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-88.13974",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06506348",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-728.13721",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.171143",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-3.2353249",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5328703",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.95753",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.532218",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.65039",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.71027",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.62109",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "347.15326",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51096935E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-698.68555",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.72271664E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.7854",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "46945.137",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112167.31",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18589264E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74413094E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25353904E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-435747.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "444610.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "971.84375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-272.25342",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.287125",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03084168",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258465",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-788.86523",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "852.2627",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1139.769",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "201.63428",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.55761722E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.06295191E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1512.1865",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2265.4104",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-323716.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "609447.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.0625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-272.25342",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "17.998322",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.82484",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.92072",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.1992",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.92258",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "185.62109",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.90692",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "208.94403",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.51508",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004572079",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02760608",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.581879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.53394",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23517975E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83533612E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23517975E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83533612E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004572079",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02760608",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94506515E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91174445E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94506515E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91174445E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.02383741",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.008316",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.04605382",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.924374",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-30.352905",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.924515",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-35.306305",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.0354",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.02585716E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03285892",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.66644",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.74219",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "189.45741",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "321.61292",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "189.64343",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.99991",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0491235",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.119492",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "8504.8242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-811.22998",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-385.68506",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.138184",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1651.5081",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1754.6663",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-385.68506",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.650635",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-84.819336",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.06469727",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-738.57178",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.987549",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3212223",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6466103",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-6.2279978",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.311492",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.83411",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.45209",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.8584",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.95557",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13348642E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-730.10181",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.84146027E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.626221",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "47492.062",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112145.22",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01200453E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57251714E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-9.26089413E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33190611E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-439765.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "456577.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "969.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "scale_min": "-272.6272",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "56.545898",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03002755",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-716.96777",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1156.4214",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1210.666",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "197.25317",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "scale_min": "-4.84111467E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88784860E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1514.1262",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1932.7605",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-332093.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630162.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.39062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "scale_min": "-272.6272",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.306396",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "210.48207",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.99835",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "197.37297",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.40701",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "184.8584",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.57022",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "209.64346",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "313.97488",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003873004",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "scale_max": "0.02816879",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-21.797405",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.49457",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23528171E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74620582E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.23528171E-05",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74620582E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst nov2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003873004",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02816879",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.99659644E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08975212E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-1.99659644E-06",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08975212E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "0.03089056",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.204842",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "0.07447839",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.395687",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-29.871277",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.400787",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "-33.079468",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.703613",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "9.81870016E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03864035",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.5575",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.36887",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "PTVersion": "128",
                                            "scale_min": "188.2914",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "321.08817",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_min": "188.30424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.22797",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "515.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/nov2001"
                        },
                        "oct2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oct2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200204",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200204",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200204",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200204",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200204",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200204",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200204",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200204",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200204",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200204",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200204",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200204",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200204",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200204",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200204",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200204",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200204",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200204",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200204",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200204",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200204",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200204",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200204",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.oct2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/asst/oct01/30002fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200204",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03556065",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.076698",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.8711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-810.22632",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.8438",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-379.37915",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.30127",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1582.2388",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1870.0557",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8438",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-379.37915",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.05127",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-93.735199",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05545044",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.1001",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.644531",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2540226",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.0737953",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3371391",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0029421",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.19215",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.45792",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.26401",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.35181",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27398482E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.73389",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.50109097E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.426025",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47297.473",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111788.16",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.07263427E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.61197806E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.58559192E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-413460.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "427074.12",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.51562",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-268.11401",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "60.39325",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03012665",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25843",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-758.86841",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1140.644",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1230.4187",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "193.54443",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.92009974E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.73956117E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1762.0076",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2233.7703",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-300307.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "629672.38",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.79688",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-268.51245",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "19.290115",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.07419",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.83179",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "195.63115",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.11838",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.26401",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.30286",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.12445",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.18573",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005262241",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02866632",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.418243",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.58286",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47803357E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87623482E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.47803357E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87623482E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005262241",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02866632",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05447486E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92596349E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05447486E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92596349E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.01958173",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.687096",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0489612",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.079746",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.557526",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.60321",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-36.655655",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.628601",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "6.88551154E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.0355764",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.22757",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.90341",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.07349",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "320.38974",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.17036",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.08044",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05394151",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.399704",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.1953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.19531",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.6875",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.6521",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-81.006104",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1783.2544",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2156.2029",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.6521",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-81.492432",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.256973",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05513",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-727.02295",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-70.898193",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4136953",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.3767576",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8105326",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7217932",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.13954",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.41238",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.02304",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.11972",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.63368111E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.8313",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.29954695E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.59375",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46776.164",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112305.36",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.01934539E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.73067338E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.40945610E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-405673.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "446090.06",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.17188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-269.31665",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "62.961502",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0301585",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258446",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.69434",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1163.7715",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1231.9553",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "180.87549",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.92624395E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.23257756E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1859.46",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1745.4023",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-259721.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "640010.88",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.17188",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-269.31665",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "28.35997",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.42131",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.06647",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "197.16469",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.58612",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.02304",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.87167",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.59555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.98401",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00549433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02852426",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.494555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.54593",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54970385E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87166625E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54970385E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87166625E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00549433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02852426",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99472106E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.15264185E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99472106E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.15264185E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0290317",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.19558",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04749682",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.02951",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.130173",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.682755",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.124207",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.333496",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.52256803E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03573588",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.03973",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.18567",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.74762",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.5257",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.79082",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.77618",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04591875",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.141876",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.8164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.45703",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5312",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-390.10498",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.216797",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1629.7024",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1852.0933",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7812",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-390.10498",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.535645",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-90.790222",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05516052",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-728.59229",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.192139",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6494265",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7929907",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4282942",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.8374195",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "182.87767",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.79419",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "182.87225",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.66003",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.82902374E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.63403",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.86371708E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.455322",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47457.316",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112009.62",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.55675296E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.95984035E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.07996707E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19175729E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-427473.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "449227.44",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.4375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-259.84326",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "56.653015",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02959177",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258505",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.23022",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1164.4739",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1255.5916",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "169.46191",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.02075920E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.77583216E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1552.6753",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1740.29",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266366.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "622320.0",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.875",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-263.15356",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "21.496704",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.41985",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.75067",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "197.5394",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.54715",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "182.87225",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.30066",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.76602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.66718",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003758011",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03203419",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.623262",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.5853",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56389397E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77562979E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56389397E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77562979E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003758011",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03203419",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.96002907E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93872802E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.96002907E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93872802E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02922441",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.362724",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06001596",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.720284",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.064407",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.457138",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.684799",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.590363",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.00475347E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03986669",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.32986",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.10516",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "186.15457",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.84814",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.15781",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.02222",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03563701",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.084106",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8530.6523",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.07495",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.5",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-399.26636",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.827881",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1775.8154",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1898.3254",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-399.26636",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-73.288818",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.660965",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0553894",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.65723",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.853027",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0660133",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.5891924",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5208464",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.021018",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.30731",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.49707",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.27612",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "347.37305",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19316860E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-700.88745",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.04826177E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.488281",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47156.031",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111891.34",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.27567078E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.47391984E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21416974E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-441841.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "440445.5",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.8125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-281.93408",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "55.815201",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03074046",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258522",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-790.79248",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1027.7517",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1164.3193",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "221.30371",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.65578751E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.84986093E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1639.5051",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2213.1731",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-315696.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "646413.56",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.8125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-281.93408",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "14.676285",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.80481",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.42542",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.55037",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.74579",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.27612",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.34021",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "208.93776",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.33264",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007056952",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0301719",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.132463",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.61877",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52140219E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85717472E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52140219E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85717472E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007056952",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0301719",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.12821783E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.99402393E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.12821783E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.99402393E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03544324",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.111729",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05257869",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.243675",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.356277",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.070312",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.538193",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.361801",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "6.72927740E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03941472",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.52966",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.39111",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.40295",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.1123",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.42384",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.87674",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04661126",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.239555",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8483.2578",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.41602",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.4375",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-391.7229",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.295166",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1748.5981",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1701.6462",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.7229",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.972656",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.8685",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0554657",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.68066",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-69.372314",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3237591",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7354536",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5113173",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.4560337",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.12744",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.53763",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.00671",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.43042",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16704302E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-693.75024",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.70277290E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.380859",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47163.543",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112278.91",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.32345870E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.57049226E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19164486E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-418613.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "443301.19",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-263.63818",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "57.032867",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02997776",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25844",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-738.78125",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "924.85376",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1069.4983",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "190.51221",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.27662371E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.61829142E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1622.551",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1783.5669",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-312211.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "591048.12",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.51465",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "25.941315",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.41071",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.9729",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.72205",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.05383",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.00671",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.65237",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.0751",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.96722",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005035587",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02861854",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.610947",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.57043",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50368314E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92014068E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50368314E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92014068E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005035587",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02861854",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.27378064E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92983384E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.27378064E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92983384E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02735737",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.130608",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04172738",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.680759",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.025696",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.904449",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.756897",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.827805",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "2.52848281E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03578662",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.76624",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.23984",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.02931",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.10809",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.58937",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.88828",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03585409",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "88.875877",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.8438",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.42065",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.4688",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-385.87939",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.120117",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1638.2922",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1881.3928",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9375",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.87939",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.073242",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-91.823853",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05537415",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-738.54053",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.538086",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1936359",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.880147",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0220728",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1160612",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.60278",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.79303",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.59018",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.84106",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.88605134E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-707.29663",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.17512807E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.692627",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47239.605",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112482.34",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.26878932E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.01181138E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.42301546E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.64645871E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-460414.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "508835.19",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.42188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-276.97095",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.125488",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03100306",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258402",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-740.50464",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "854.823",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1092.3384",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "230.44678",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.36795574E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.21468768E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1566.5369",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1816.3445",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-279194.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "645841.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.42188",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-276.97095",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "31.185806",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.25694",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.25507",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "195.75568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.11612",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.59018",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.79715",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.34624",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.12445",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007109549",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02719126",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.464148",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.77036",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.57983141E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84947730E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.57983141E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84947730E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007109549",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02719126",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04178764E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06248433E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04178764E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06248433E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02991377",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.301903",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06449956",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.423523",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.841614",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.492828",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.117279",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.288651",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "7.34424930E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03708382",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.87038",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.99075",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.6676",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.70227",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.7478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.27246",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05588791",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.738266",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8506.9336",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.77441",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.7812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-391.5332",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.9104",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1657.739",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1913.1921",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.5332",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-81.47998",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.396484",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05526733",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-744.46655",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-70.571777",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8211269",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7951145",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9305658",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.2384863",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.97804",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.52026",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.97408",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.8913",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67940834E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-700.96899",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.04081118E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.444824",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47053.477",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112214.2",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.84140695E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.10458347E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.49644973E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-420001.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "450465.94",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.54688",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-262.26636",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "56.106903",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0317715",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258427",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-740.72803",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1003.7153",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1223.8352",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "177.81543",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.89377385E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.11063421E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1599.2708",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2169.3127",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-307556.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "633681.69",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.54688",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.80347",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "38.007263",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.19467",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.44312",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.03996",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.06567",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.97408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "344.41547",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.47086",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.02051",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003860543",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02825151",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.189262",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.61981",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54765312E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84860837E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54765312E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84860837E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003860543",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02825151",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03815148E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.88860736E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.03815148E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.88860736E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02776494",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.492756",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05763875",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.867599",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.937317",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.43306",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.202454",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.203232",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "7.63417916E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03570107",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.23227",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.06732",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.45131",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.55548",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "191.16199",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.60934",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04055401",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "97.0998",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8518.5547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.12524",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1180.2188",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-400.19409",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-78.675781",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1681.698",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1603.3381",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-400.19409",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.480469",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.63472",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05540466",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-736.96387",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.656006",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3140669",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7371321",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.7921991",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.7002678",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.99677",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.3288",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.03865",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.11725",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29363093E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-702.68286",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.15053533E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.009033",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47372.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112490.66",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.89016415E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.53324230E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41997987E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31892671E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-413799.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "475070.94",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.0",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-287.29199",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.113266",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03017631",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258436",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-718.0979",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "886.95386",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1314.4111",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "215.05835",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.25596249E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.59943725E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1392.064",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1998.5393",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-303213.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "622975.75",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.0",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-287.29199",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.132111",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.96898",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.67343",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.20021",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.80338",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.03865",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "343.70905",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.11165",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "315.01315",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003630342",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0283272",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.522917",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.7106",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48870467E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77563197E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.48870467E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77563197E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003630342",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0283272",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06533969E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00197132E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06533969E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00197132E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02883802",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.946079",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05724224",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.291862",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.882065",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.814331",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.797241",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.406326",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.05030949E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03613374",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.70706",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.11398",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.34322",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.14752",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.40569",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.99902",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02203228",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.487328",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8482.9023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.48657",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.25",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-389.92188",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.866943",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1683.9282",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1997.0298",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-389.92188",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.970947",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-92.038651",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05514526",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-714.04028",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.829834",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0094643",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.1906013",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9553518",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.9027662",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.82309",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "336.95093",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.79367",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.01282",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.28268300E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.04028",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.37245204E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.67041",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47432.422",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112390.29",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.72809721E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.04480943E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.42301546E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37652592E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-438144.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "427191.75",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.75",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-277.52832",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "53.720367",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03259419",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258465",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-890.92603",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "937.12524",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1332.2424",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "187.11914",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.32726460E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.48264881E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2280.9502",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2247.6382",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-270074.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "607573.88",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "978.76562",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-277.52832",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "19.173523",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.92746",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.47229",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.99573",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.77322",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.79367",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.73157",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.17455",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.22717",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00520518",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02827307",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.755219",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.51553",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56288897E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81070754E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56288897E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81070754E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00520518",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02827307",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00288332E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87377907E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00288332E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87377907E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02196292",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.637127",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05683932",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.896271",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.544479",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.45285",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.888504",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.737198",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.26878547E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03388566",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.21027",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.03323",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.92871",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.58624",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.94803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.50378",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03553081",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.886925",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8541.8984",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.10815",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.7812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-400.74683",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.733154",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1732.0823",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1868.072",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4688",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-400.74683",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.143311",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.669815",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0549469",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-709.13647",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.695801",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.3998585",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.2708616",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7.0213451",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.9991536",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.93529",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "336.23218",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.91498",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.60437",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.08444067E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.74683",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.42978659E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.111816",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47487.945",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111819.47",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.31153329E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.53319922E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26358395E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-404935.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "440050.62",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "977.35938",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-280.09277",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "62.970322",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0316494",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258392",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-721.95117",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1171.5876",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1229.7051",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "169.53711",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.91724677E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.77956393E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1608.4663",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1899.0559",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-329467.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "636838.81",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.78125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-280.09277",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "18.352112",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.10234",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.85251",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.15219",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.29681",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.91498",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "339.6571",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.1709",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.82382",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004384514",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02871699",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.684017",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.56213",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54871959E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72574109E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54871959E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72574109E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004384514",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02871699",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.08226243E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.23643383E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.08226243E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.23643383E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02171261",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.900604",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03520089",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.653725",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.948349",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.659256",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.602829",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.447769",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.01110629E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03512064",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.27492",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.16855",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.21556",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.04968",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.26291",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.73492",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05133276",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.773895",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8507.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.93188",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-385.78271",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.933594",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1957.4448",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1794.3259",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.6875",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.78271",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.609375",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.036987",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05482483",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.02612",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.396484",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4853716",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.4756479",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.8142052",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.2049875",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.87749",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.74759",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.75537",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.22845",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.52160715E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.40063",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.77364073E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.430664",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47053.031",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112068.84",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.57195539E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.56064243E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.14795607E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.24703354E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-444509.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "455460.38",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.85938",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-264.24365",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.297455",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03234652",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25845",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-715.30737",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "862.83496",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1088.5251",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "182.00513",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.35270721E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.27814040E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1655.0505",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2072.0598",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-256561.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "604862.88",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.20312",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-270.73584",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "29.325638",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.27223",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.53873",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.56697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.11151",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.75537",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "344.0351",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.46194",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.41278",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00572297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02986223",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.317398",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.58597",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54590234E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89933671E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54590234E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89933671E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00572297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02986223",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06741311E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.18293076E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06741311E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.18293076E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0227608",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.29599",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04079376",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.353989",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.48735",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.584484",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.474365",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.049271",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.54826012E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03286504",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.97069",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.66858",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.85081",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.00772",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.86139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.81363",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0447759",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.385956",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.0938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-801.71973",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.625",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-395.88379",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.611084",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1680.25",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1889.2324",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.2188",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-395.88379",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.478271",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-94.052689",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05465698",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-717.73755",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.468018",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0955334",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.6326513",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0962439",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.1504402",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.58084",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.53711",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.46509",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.59711",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.33637479E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.78149",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.00451871E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.987793",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47321.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111965.67",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.77023808E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.62059882E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27206988E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-423371.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "429614.5",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.04688",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-295.22241",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "59.800781",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03083313",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258461",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-737.87012",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1006.6948",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1282.2595",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "181.33984",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.12739632E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.25150642E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1942.4526",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1817.9539",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-358056.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "660793.38",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.34375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-295.22241",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "20.509903",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.7708",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.64368",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.02666",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.00363",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.46509",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.56",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "208.85321",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.54987",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003981669",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02957159",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.747828",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.46616",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50394990E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.83494139E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.50394990E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.83494139E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003981669",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02957159",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.20833908E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.14299394E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.20833908E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.14299394E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02606535",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.276779",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05292246",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.573463",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.469971",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "28.663666",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.690842",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.316132",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8.04845968E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.038958",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.3168",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.06836",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.27005",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.0105",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.44989",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.21973",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03451034",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.096062",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8523.2891",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.1687",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.75",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-387.70459",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-71.229248",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1513.5459",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1891.8286",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.70459",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-71.030518",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.445618",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0546875",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-725.2478",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-60.853271",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3357105",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0820856",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3552227",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.9920235",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.14819",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.03027",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.02661",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.23007",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.38542612E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.74536",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.41305188E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.689941",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47400.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112213.45",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.92530045E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.53324675E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.31057209E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-399339.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "463005.31",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.45312",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-265.85938",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "53.26416",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03037176",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258413",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-848.37085",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1015.2009",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1311.0286",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "178.1438",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.24243603E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.12349504E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1759.6763",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1995.7017",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-325823.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "621920.19",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "975.10938",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-265.85938",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "19.060013",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.06294",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.30692",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.09694",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.7196",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.02661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.32773",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.23561",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.4213",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.009740736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02693312",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.665604",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.61014",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53027358E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86753168E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53027358E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86753168E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.009740736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02693312",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89267882E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03071136E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89267882E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03071136E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02966275",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.781994",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05663419",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.962513",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.391632",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.359146",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.377274",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.207458",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "6.33199306E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04467133",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "183.88918",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.30652",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "183.71666",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.42712",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "183.79305",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.81702",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04254697",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.903107",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.75",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "99999.992",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.56104",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.7188",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-389.0354",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.832031",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1812.8987",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2299.8687",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.5938",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-389.0354",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.101074",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.962585",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05548096",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.8396",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.474365",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1558352",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7202425",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.7173615",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.476058",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.88042",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.92834",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.79231",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.47729",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.10779968E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-694.24927",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01132900E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.379883",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47032.367",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112031.8",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.38101505E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.51521954E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41088390E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-445441.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "428097.94",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.6875",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.4812",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "65.194534",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03066293",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258539",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.50854",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "881.3457",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1255.4878",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "199.60864",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.02034482E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.98206372E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1734.7751",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1851.8005",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-282489.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "628438.81",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.75",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266.4812",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "34.083328",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.56258",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.90839",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.71008",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.42465",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.79231",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.44995",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.78409",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.49438",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006019317",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02722386",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.607988",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.56973",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52289776E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90405572E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52289776E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90405572E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006019317",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02722386",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.12857026E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92762309E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.12857026E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92762309E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0248052",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.89222",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05227948",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.614788",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.416595",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.800903",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.90686",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.371292",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.36806420E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03384752",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.10236",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.23376",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.86423",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.22528",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.90134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.03925",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04549057",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.099411",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.2695",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.57397",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2188",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-384.14453",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.790771",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1942.6494",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1664.8679",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4062",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.52637",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.412842",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.398788",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05551147",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-747.0625",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-69.087646",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6870441",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5443697",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.9971085",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5970678",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.98045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.30902",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.95398",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.17743",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.11526469E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.40015",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.49614332E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.228516",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47423.84",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112367.13",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.86254645E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.79681751E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29022737E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-429099.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "410656.75",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.46875",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-269.70483",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.75415",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03038796",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258461",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-716.78003",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1166.8555",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1438.3662",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "249.01611",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.75162346E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.95806886E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1881.5024",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2200.8057",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-318062.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "660626.25",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.46875",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-269.76025",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "21.727692",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.2139",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.22812",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.00357",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.30402",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.95398",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "344.01923",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.51408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.47052",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006394606",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02918842",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.591246",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.50482",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.57580362E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81084142E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.57580362E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81084142E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006394606",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02918842",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00551881E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17857132E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00551881E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.17857132E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03284679",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.890022",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04562311",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.092606",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.885254",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.793503",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.711456",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.696793",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.21671007E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03476393",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.90305",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.87122",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.75505",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.38654",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.76123",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.95599",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05668406",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.767639",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8489.5859",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.99756",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.9375",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.68042",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.501709",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1621.3237",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1976.3191",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9062",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.68042",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.043457",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.975586",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05557251",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.76636",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.868408",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4824429",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7081747",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4050732",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.5066414",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.11279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.17438",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.06438",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.52161",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30639773E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.34814",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01825572E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.583984",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47137.156",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112450.81",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.65639322E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.69202826E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30392004E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-459926.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "432845.06",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.54688",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-252.53777",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "69.166092",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0305946",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258545",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.47412",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1198.384",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1203.615",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "254.5874",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.42676111E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01801135E-07",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1523.8364",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1954.593",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-330724.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "622607.19",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.34375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-252.54738",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "16.879395",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.23097",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.4574",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.80792",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.09262",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.06438",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.66547",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.37904",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.25",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007533539",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02949619",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.675928",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.59253",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55577436E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79059989E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55577436E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79059989E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007533539",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02949619",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02518640E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.91269760E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02518640E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.91269760E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02150415",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.359005",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06276882",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.558067",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.897705",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.448944",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.907013",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.055008",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.18499543E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03515016",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.44151",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.93463",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.95099",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.80286",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.17628",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.45178",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03757494",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.281471",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8519.9023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.53394",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-390.29785",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.317871",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1470.4019",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1840.6353",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.625",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-390.29785",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.702393",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.662598",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05474854",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-722.89819",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.671631",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8334446",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.7102699",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.006424",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.3747959",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.62054",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.56818",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.62886",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.91739",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.08558686E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-699.20581",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01016485E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.895752",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47315.574",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112163.55",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.39660458E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.53370888E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32565083E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-422260.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "472911.38",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.67188",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-248.58737",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "68.313599",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03075092",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.77515",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1062.7197",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1597.8557",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "177.54004",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.38937763E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.09918879E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1562.6226",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1817.0649",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-296393.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "617447.94",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.3125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-250.66545",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "14.371475",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.3324",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.08643",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.14879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.20605",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.62886",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.99161",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.53423",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.06891",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00217602",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02936832",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.371305",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.61774",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55748858E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79694707E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55748858E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79694707E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00217602",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02936832",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.91943082E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.19275262E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.91943082E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.19275262E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02729005",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.442764",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04598387",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.448315",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.986008",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.092041",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.495529",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.381088",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "6.64944650E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03714996",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.75365",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.52423",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "187.40614",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.22357",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.55992",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.52423",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04953362",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "89.248306",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.1523",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.77295",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2188",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-397.55957",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.888916",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1567.1479",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2235.7063",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-397.55957",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.618896",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.143448",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05532837",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-721.25146",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.457031",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0189495",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.3130522",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.9331989",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.3463793",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.61478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.88269",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.53331",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.10419",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.35672417E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-693.16553",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.07992673E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.175293",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47266.988",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112133.96",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.36078243E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.68041072E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.18798571E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30814442E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-432934.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "454228.06",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "968.59375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-284.58789",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "55.89006",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02946099",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258533",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-827.29102",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1189.5776",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1356.9309",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "183.97412",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.42598627E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.35692254E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1610.0391",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1833.5852",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-293269.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "649304.75",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "968.59375",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-284.58789",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "10.126678",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.32622",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.9881",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.53456",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.58508",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.53331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.17661",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.72139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.63098",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007131781",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02831351",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.525621",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.87601",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52596167E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81884607E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52596167E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81884607E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007131781",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02831351",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02622437E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00495356E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.02622437E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.00495356E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02270576",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.01326",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05847291",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.766212",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.394852",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.802063",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.531799",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.188522",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.73016247E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03288948",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.10335",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.68658",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.86403",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.02411",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.88756",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.53583",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04539018",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.532455",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.6758",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.89771",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5312",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.19775",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.679932",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1662.2874",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1752.345",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.25",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.19775",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.039307",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.803101",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0546875",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-719.80103",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.684326",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0479212",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9004631",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6585398",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.9569349",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.02661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.49905",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.95114",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.13483",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.51025233E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-699.4502",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.86590749E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.983398",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46900.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112144.76",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.70954614E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.75400339E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.17497416E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-434262.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "471414.56",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.04688",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-261.83911",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "70.311279",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03043355",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258406",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-729.37256",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1138.7249",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1221.7825",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "177.3252",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.88556566E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.09083281E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1649.9138",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1822.396",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-340472.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "672458.38",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.89062",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.86182",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "31.062271",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.91795",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.66095",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "196.36812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.47797",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.95114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "340.39264",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.06274",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.50565",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004123263",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02871648",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.738447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.5939",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56048245E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81689084E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56048245E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.81689084E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004123263",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02871648",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01877856E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.05028573E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01877856E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.05028573E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02189908",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.16518",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03227971",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.347752",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.452408",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.07431",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-36.296982",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.408066",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.75126388E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.05472569",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.31142",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.29663",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.13336",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.52216",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.23824",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.71124",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04699672",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.435707",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8485.3516",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-810.30127",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.8438",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.40332",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-71.196533",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1901.7986",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1941.8428",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-394.68188",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-80.775635",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.367233",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05488586",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.92334",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-71.200195",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.1365061",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.5061951",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.6687393",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.0247517",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.4476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.01474",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.34424",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.86206",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.28510919E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.9812",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.75443220E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.095947",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47455.5",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112785.89",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.84353801E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.64671758E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37533800E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-408132.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "436886.38",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.25",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-279.63379",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "51.414032",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03142015",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258509",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-712.92725",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1109.0383",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1126.5564",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "183.71924",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.32016748E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.34644061E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2066.6584",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1986.6487",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-286223.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "607224.38",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.25",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-279.90649",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "28.560547",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.27922",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.06448",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.45415",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.46588",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.34424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "342.56503",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.61809",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.68121",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006113529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03078049",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.3818",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.70752",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54960417E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82415497E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54960417E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82415497E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006113529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03078049",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83607870E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08309757E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83607870E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08309757E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02317021",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.639454",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03948258",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.86689",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.745621",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.203918",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-37.529984",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.507385",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.93040535E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03887141",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.93921",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.54755",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "191.25058",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.02881",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "191.39207",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.41998",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04498928",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.753548",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.9766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.20825",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.4688",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-394.98877",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.62207",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1674.5786",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2100.113",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5312",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-394.98877",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-83.558105",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-85.127396",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05509949",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.50537",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.73877",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8528585",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7791634",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6249084",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.4120102",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.80353",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.20801",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.69003",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "349.04868",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.59269052E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.00342",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.75064870E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.708984",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47270.07",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112283.79",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.97981079E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.06192885E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.28555894E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-441917.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "452791.56",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "966.53125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.22852",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "61.195969",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03005389",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258438",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-813.84717",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1174.6499",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1479.5544",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "182.42676",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.91632386E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.29444025E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1986.5566",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2112.6899",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-360390.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "616627.88",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "968.5",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.67065",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.245483",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.1443",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.34888",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "197.24629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.68323",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.69003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "344.80453",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.36174",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.04388",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005051315",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02900226",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.682272",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.79004",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56125752E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79286653E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56125752E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.79286653E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005051315",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02900226",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05506149E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03585569E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05506149E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03585569E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.01781493",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.300774",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03018009",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.63512",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.847977",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.437256",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.189667",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.926041",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.48899858E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03564795",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.46275",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.42838",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "189.29253",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.42831",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.29765",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.80457",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04678661",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.860626",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.3945",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.92896",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.7812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-385.47827",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.166504",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1720.6614",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1780.8491",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.125",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.63135",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.749023",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-90.615784",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0546875",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-729.36743",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-68.990234",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.195755",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.0281897",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.1299648",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.54389",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.91306",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.75601",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.88655",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.23248",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.88411752E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-692.48779",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.49134119E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.816162",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47151.129",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112141.33",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.38241840E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.03070954E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.26816826E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-417500.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "464588.31",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "969.78125",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.63257",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "58.277313",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03072499",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25845",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-842.69214",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "875.14746",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1137.6387",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "207.54077",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.54909809E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.78430547E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1598.7737",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2280.686",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-346320.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "610788.81",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "969.78125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266.63257",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "28.645096",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.24171",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.29718",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.78133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "319.96912",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.88655",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "339.62457",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.51195",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.25446",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007612608",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02800445",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.381708",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.53763",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54776462E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82606400E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54776462E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82606400E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007612608",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02800445",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00694012E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.02780461E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.00694012E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.02780461E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02227442",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.525867",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06364477",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.93383",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.502426",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.654221",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.868988",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.774933",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.14667216E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03444135",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.53172",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.80136",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "190.24889",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.81818",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.38995",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.67084",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0310233",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.490601",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8535.5117",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.0105",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1177.5",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.70728",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-70.802002",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1546.9941",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2030.5439",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7812",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.70728",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-70.700439",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-92.782166",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05535889",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-745.13696",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-61.067383",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6475477",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.2792931",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3348551",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.9253387",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.32945",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.79401",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.50122",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.45755",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29455464E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.38257",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.63408786E-07",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.712646",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47346.543",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112039.45",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.76503350E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.47020012E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.23820246E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-427280.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "423949.19",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.25",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-276.28882",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "69.416321",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02996946",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-853.81738",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1007.5278",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1363.6494",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "168.8562",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.45285218E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.75178455E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1586.9705",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1663.7219",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-325027.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "646418.0",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.28125",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-279.33765",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "13.944885",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.78993",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.92896",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "194.27815",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "318.2912",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "181.50122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "344.2056",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "208.85913",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.67499",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005671285",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02845663",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.35758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.539",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55233338E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.83559569E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55233338E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.83559569E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005671285",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02845663",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01166063E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.10764165E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01166063E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.10764165E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02805898",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.098331",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0495261",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.74292",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.692596",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.692703",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.642029",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.455627",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "3.81825167E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03719732",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "184.65482",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.43832",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "184.53316",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.49591",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.65135",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.29791",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04401235",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "87.234222",
                                            "subcenter": "255",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8517.1836",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "subcenter": "255",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.4751",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2812",
                                                "subcenter": "255",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-395.79614",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-78.731934",
                                                "subcenter": "255",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1676.4197",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1700.001",
                                                    "subcenter": "255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.6562",
                                                    "subcenter": "255",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.36523",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.457764",
                                                    "subcenter": "255",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "subcenter": "255",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.764389",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05493164",
                                            "subcenter": "255",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.86157",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.732178",
                                            "subcenter": "255",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5956078",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.1020269",
                                            "subcenter": "255",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0014648",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5143309",
                                            "subcenter": "255",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.09532",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "335.94202",
                                            "subcenter": "255",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.0705",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.14001",
                                            "subcenter": "255",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27045314E-06",
                                            "subcenter": "255",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.41309",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "subcenter": "255",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "subcenter": "255",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.04794162E-06",
                                            "subcenter": "255",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.602051",
                                            "subcenter": "255",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "subcenter": "255",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "subcenter": "255",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47523.496",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112442.88",
                                            "subcenter": "255",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.64697809E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.30752788E-07",
                                            "subcenter": "255",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.44590433E-06",
                                            "subcenter": "255",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16113199E-06",
                                            "subcenter": "255",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-401938.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "463971.81",
                                            "subcenter": "255",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.34375",
                                                "subcenter": "255",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-259.35938",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "69.6884",
                                                "subcenter": "255",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "subcenter": "255",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03113084",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258507",
                                            "subcenter": "255",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-772.64087",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1146.5381",
                                            "subcenter": "255",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1138.5818",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "189.3064",
                                            "subcenter": "255",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.9492188",
                                            "subcenter": "255",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.32992920E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.56961924E-08",
                                            "subcenter": "255",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1877.9282",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1985.8586",
                                                    "subcenter": "255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-300217.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "652809.06",
                                                    "subcenter": "255",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.51562",
                                                    "subcenter": "255",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-259.35938",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.353348",
                                                    "subcenter": "255",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "subcenter": "255",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.49364",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.98322",
                                            "subcenter": "255",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.25217",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "317.91174",
                                            "subcenter": "255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.0705",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "341.85291",
                                            "subcenter": "255",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.66975",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.61325",
                                            "subcenter": "255",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003474446",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02960173",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.306887",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.47031",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.58565126E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.67873022E-05",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.58565126E-05",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.67873022E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst oct2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003474446",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02960173",
                                            "subcenter": "255",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99429655E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93552319E-06",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99429655E-06",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93552319E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02519028",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.165134",
                                            "subcenter": "255",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05206452",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.174938",
                                            "subcenter": "255",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.077103",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.488647",
                                            "subcenter": "255",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.670837",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.891968",
                                            "subcenter": "255",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.40172688E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03804414",
                                            "subcenter": "255",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.81299",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.94571",
                                            "subcenter": "255",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "units": "unitless",
                                            "gribNumBits": "16",
                                            "scale_min": "188.68121",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.00891",
                                            "subcenter": "255",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.73938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.58444",
                                            "subcenter": "255",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "484.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/oct2001"
                        },
                        "sep2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sep2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200203",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200203",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200203",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200203",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200203",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200203",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200203",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200203",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200203",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200203",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200203",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200203",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200203",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200203",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200203",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200203",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200203",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200203",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200203",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200203",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200203",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200203",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200203",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.asst/.sep2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/asst/sep01/30001fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200203",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03333972",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "89.79657",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8485.6367",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.83203",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.02808",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.30127",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1798.969",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1914.2991",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.41797",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.39502",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.443771",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05383301",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-741.55981",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.053467",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6694527",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.7434864",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7015676",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.6557646",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.74899",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.28687",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.70522",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.76697",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.41730538E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-694.39868",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.05830259E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.399902",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47062.496",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112297.27",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.03299690E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.61923765E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.35371397E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-420523.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "475253.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "978.29688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-258.90942",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.671356",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.030907",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258486",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-888.2002",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1025.8806",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1483.6184",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "192.82666",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.93257482E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.71089219E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1621.6724",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2051.9143",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-325267.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "624837.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "983.07812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258.90942",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "19.352417",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.17204",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.93701",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.40707",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.42227",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005153257",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02900496",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.513353",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.74619",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.52020948E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85081153E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.52020948E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85081153E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005153257",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02900496",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.14572583E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.96830683E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.14572583E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.96830683E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03464732",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.636948",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0506332",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.049194",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.50647",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.267944",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.922287",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.077484",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.01937758E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04132221",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.6855",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.9873",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.3141",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.1098",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.32907",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.41553",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04541773",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.635506",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8537.0977",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.98096",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.9353",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.013428",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1378.8152",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1870.7122",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.9353",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-75.982178",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.882355",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05354309",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-722.40161",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.329102",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9454947",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.9004393",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6212873",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.1963358",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.39433",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.72736",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.29559",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.00125",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27267197E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-703.92285",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.43822670E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.566895",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47384.949",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112535.88",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.24595395E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.79332812E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.35525294E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.24924588E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-412235.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "456520.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "969.46875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-250.07924",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.996033",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03034382",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258369",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-718.68799",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "979.51929",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1091.1475",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "176.01074",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.36319283E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.03797980E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1588.0393",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1941.3687",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-308193.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "645584.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.90625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250.1076",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "40.531189",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.37424",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.13858",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.47357",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.94662",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007673785",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02895456",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.011106",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.69336",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57224695E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85408171E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57224695E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85408171E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007673785",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02895456",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.18130140E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.98268299E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.18130140E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.98268299E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02212631",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "39.516331",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04976841",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "41.043995",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.987076",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.237335",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-40.969223",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.345367",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.54565121E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.0379759",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.83609",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.26398",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.16275",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.30365",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.23561",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.19775",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02754778",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "95.358322",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8489.1719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-801.31152",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1180.0",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.9646",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-78.945557",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1764.1396",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1960.4341",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.54077",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.860107",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.959167",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05337524",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-723.19141",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-69.488037",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5801773",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.7155304",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7295141",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.6429176",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.22256",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.65665",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.25499",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.28943",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.25611291E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-700.32373",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.03408820E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.469971",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47326.035",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112013.2",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.33791524E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.60782406E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29124078E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-422674.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "467043.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.82812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-244.052",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "68.751709",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02994926",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258516",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-794.3855",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1118.9688",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1598.7571",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "215.31519",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.39298207E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.61008118E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1616.8672",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2081.7266",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-261705.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "621954.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.82812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244.052",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "34.823288",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.47708",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.80579",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.66504",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.70697",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00471089",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03105669",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.663233",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.94366",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58861931E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77265938E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58861931E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77265938E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00471089",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03105669",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.87697663E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.98854536E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.87697663E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.98854536E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02703583",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.823109",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04217181",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.011875",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.570908",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.661224",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.479935",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.147858",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.04365427E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.0366869",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.25659",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.22668",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.13225",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.42822",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.15025",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "328.24799",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04362864",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "97.412292",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.5547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-807.56372",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.11108",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.939453",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1465.991",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2366.5447",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.11108",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.543213",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.454254",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05360413",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-726.49561",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.859375",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.0189714",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.6957846",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7363033",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1008959",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.34164",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.21732",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.3324",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.2746",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.23543236E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-704.5144",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.04753417E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.368164",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47211.734",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112157.73",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.07274830E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.90783612E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.42898136E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-417395.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "431396.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.70312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-246.79285",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "71.448807",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03018205",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258446",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-817.16162",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1018.6514",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1203.5391",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "217.54541",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.81261566E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.69923156E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1972.5549",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2428.9851",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-296160.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "653301.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.70312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.34911",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "29.718475",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.8643",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.453",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.97052",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.36615",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00308621",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03002472",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.954576",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.7493",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58447710E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80355291E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58447710E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80355291E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00308621",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03002472",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.95464236E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.88808315E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.95464236E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.88808315E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.01415058",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.872505",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02882166",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.421604",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.40686",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.889175",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.624374",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.13961",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.70296335E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03966194",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.40817",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.02472",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.31158",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.14883",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.31158",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.09311",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04253824",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.290161",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.8164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-814.09155",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-395.9021",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.977539",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1744.9551",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2203.3389",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.9021",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-79.907471",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.376495",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05381775",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-729.8606",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-69.236572",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8283739",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0135794",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.6579132",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.1392212",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.06464",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.89728",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.00491",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.51419",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.18857122E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-696.68213",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19348988E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.375",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47357.469",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111817.91",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.27903079E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.61712069E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27692203E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-408449.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "458890.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-284.47925",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "67.028305",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02984313",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258551",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-798.15552",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1196.229",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1186.0942",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "214.41699",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.50924176E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.57415614E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1713.8979",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2056.2134",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-283826.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "632701.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.92188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-284.67432",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "35.147934",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.27393",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.90942",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.61873",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.00412",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.009797968",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.0299685",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.082191",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.87772",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.52554921E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89570401E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.52554921E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89570401E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.009797968",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0299685",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05718766E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90693265E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05718766E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90693265E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02614428",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.587543",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05401262",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.201504",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.088089",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.722717",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.822754",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.563126",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.25290342E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03482777",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.80234",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.67084",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.54529",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.54102",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.57327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.24673",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03444625",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.941353",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8522.5586",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-807.57642",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.052",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.415771",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1434.3296",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2195.3279",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.05396",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-75.982178",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.801178",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05340576",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-738.20386",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.813232",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8571501",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0167646",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8638315",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.6605015",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.92369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.07843",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.72575",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.53442",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.22139681E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.24878",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.72882845E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.628418",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46991.238",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112184.86",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.51453808E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.92917092E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.68039151E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.48882270E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-457319.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "487728.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-261.95947",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "76.197845",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03033108",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258463",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-703.76807",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1156.2156",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1455.0264",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "215.65308",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.81824281E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.62325464E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1628.5696",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2002.7261",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-291767.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "648707.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-263.16797",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "30.554901",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.2859",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.23654",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.46616",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.02435",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003096846",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03046459",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.667664",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.86081",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61032094E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85663666E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61032094E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85663666E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003096846",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03046459",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.81204564E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93078699E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.81204564E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93078699E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02673494",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.236225",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04899606",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.594727",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.741226",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.182755",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.895386",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.091537",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.22905042E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03912389",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.47771",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.53912",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.70844",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.85938",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.93684",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.40564",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04387504",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.387337",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8488.75",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-801.32788",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.85645",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.256592",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1440.2114",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2305.5725",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.85645",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-75.840332",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.972549",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05380249",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.77295",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.188477",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8940086",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.3723459",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9305038",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.1954832",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.65489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.65656",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.4614",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.70721",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.12103271E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-700.61816",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.49614332E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.391602",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47046.891",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112712.17",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.74769796E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.66119128E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.61106470E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-414847.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "450464.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "974.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-267.98413",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "67.978256",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02973013",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258463",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-781.82471",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1030.7371",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1134.8298",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "207.72998",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.53786640E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.30664248E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1632.6028",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2182.8157",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-291146.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "623290.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.75",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-267.98413",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "40.744965",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.17899",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.38928",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.36783",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.90613",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00299255",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.0296615",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.448734",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.70648",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60750551E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86141151E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60750551E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86141151E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00299255",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0296615",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00646946E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03783657E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00646946E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03783657E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02111036",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.234646",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0429005",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.53175",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.111877",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.077408",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.778152",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.506454",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.21026176E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03738553",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.11494",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.83789",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.5963",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.55115",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.61011",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.6925",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03244368",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "98.318527",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8519.125",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-807.2605",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-388.53027",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.850098",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1903.2488",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2104.7739",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.2188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.53027",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-73.920654",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-96.768417",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05366516",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.21704",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.070068",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2610626",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.4858122",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0941582",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.6538477",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.1851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.52023",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.12497",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.43323",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.28579995E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.34863",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.48172931E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.933594",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47283.766",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111994.61",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.28300324E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.75545142E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.37228028E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-430579.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "446031.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-269.00977",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.338867",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03020754",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258484",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-883.54175",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1003.9341",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1457.9075",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "185.89502",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.82976384E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.43336273E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1965.0977",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1920.3193",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-274955.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "658097.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.71875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-275.53857",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "35.788559",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.01341",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.55209",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.22369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.61105",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.002218492",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02785916",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.730328",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.78656",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.51861468E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92021253E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.51861468E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.92021253E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.002218492",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02785916",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99081228E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06227696E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99081228E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.06227696E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02344779",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.839066",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04857624",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.596294",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.62941",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.704697",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.896591",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.931412",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.30393674E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03653548",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.45998",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.89093",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.45366",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.40918",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.48813",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.0246",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02936906",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.086044",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.3359",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.96362",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.53076",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.067627",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2031.1562",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2104.6245",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.23315",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.794434",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.870544",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05355835",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-733.04224",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.667969",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2437754",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9415264",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0331316",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.7981787",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.98689",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.32764",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80405",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.34314",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.20674542E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-698.74487",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.20481398E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.606934",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47035.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112080.53",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.04420154E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "2.15917112E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32752098E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-447135.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "453516.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "972.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-271.08496",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "68.274246",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03049162",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258419",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-755.60815",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1203.915",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1264.6067",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "227.32446",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.05680816E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.09032565E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1577.9392",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1942.3557",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-334376.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "641423.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-276.24268",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "28.618439",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.8163",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.62836",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.87592",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.78949",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007950705",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03012365",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.373631",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.69992",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60825148E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85834106E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60825148E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85834106E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007950705",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03012365",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.01037051E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90228877E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.01037051E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90228877E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02987995",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.755455",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05650249",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.31612",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.731293",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.763214",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.299026",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.12175",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.68914264E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03677966",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.99875",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.06683",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.64461",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "324.36032",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.64903",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.06738",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03397455",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.657951",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8522.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-807.84204",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.71265",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.75",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1901.1831",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2130.585",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.16919",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.210938",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.850632",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0539093",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-732.68628",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-63.785156",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3952484",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9307547",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2834301",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.8863487",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.35732",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.97473",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.17487",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "343.30862",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.18581488E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-700.73828",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.01496698E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.04834",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46502.473",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112749.59",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.40855057E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.76246022E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.40694885E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-406851.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "500251.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-269.24878",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.790634",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02937959",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258423",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-804.19946",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1316.8865",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1723.9268",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "200.80957",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.89350031E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.03012483E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2094.5542",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2218.6714",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-307203.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "635994.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "970.73438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-269.27734",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "39.461899",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.15176",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.72083",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.3089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.42206",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004858594",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02856627",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.978331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.702",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56965125E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73024491E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56965125E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.73024491E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004858594",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02856627",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86155489E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.38590428E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86155489E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.38590428E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02903918",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.299713",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04292373",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.046947",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.859467",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.000519",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.66893",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.895828",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.61740387E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04087063",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.64139",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.13635",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.50951",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.6228",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.51411",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.71185",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03707891",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "98.031197",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8454.8711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.07031",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.04346",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.486084",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1505.9893",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2088.1409",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.04346",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-74.462646",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-92.941116",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.054245",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-723.92896",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.195557",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1006622",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.0526104",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7189417",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.8333588",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.55484",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.02368",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.43675",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.9819",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.48074855E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-696.06201",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16592855E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.384277",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47443.25",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112186.09",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.71337056E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.97803365E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.22180552E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-401422.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "447360.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.71875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-258.30029",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "64.136063",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03135274",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25839",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-781.04443",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1100.3782",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1156.2559",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "220.46167",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.62354365E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.81587710E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1817.5669",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2136.7124",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258859.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "636432.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.71875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258.30029",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.085312",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.20215",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.50299",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.34668",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.28131",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004341003",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.0304011",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.173098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.77933",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59002448E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77476777E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59002448E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.77476777E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004341003",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0304011",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.93851702E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.18448213E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.93851702E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.18448213E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03035263",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.960529",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05023803",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.456764",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.233582",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.418442",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.12146",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.515411",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.61925901E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03888815",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.34921",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.06836",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.91711",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.93402",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.93217",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "329.58136",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02745004",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.483147",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8480.6875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-811.66626",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.90967",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-71.068115",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1610.3005",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1819.5403",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-393.146",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-70.935303",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-93.760712",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05332947",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.38403",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-60.147461",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.4188318",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.26019",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8654823",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.3157597",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.64001",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.7135",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.55408",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.38251",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.23979862E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-696.69604",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.92585376E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.901367",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46863.191",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112232.59",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.74391446E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.54558882E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30206638E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-460103.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "450904.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "976.125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-273.20239",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "73.443466",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03030397",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-863.36548",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1138.3611",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1307.7527",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "214.88892",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.22933647E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.59261320E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1841.1311",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1913.6326",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-310109.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "620312.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "976.125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-273.20239",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "44.574326",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.73271",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.63983",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.6953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.63721",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005334251",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02913024",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.749138",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.52451",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.51439344E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85988501E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.51439344E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85988501E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005334251",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02913024",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94958125E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08460710E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94958125E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.08460710E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02914146",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.362946",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04733003",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.340046",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.96022",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.746109",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.054688",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.71965",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.22025819E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03586302",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "183.40935",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.18872",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "183.11377",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.63043",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.14806",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.13684",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03372873",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.195816",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8536.3672",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.93701",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.58643",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-74.625977",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1752.7463",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2217.7388",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.32642",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.168213",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.22374",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05381775",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-737.13721",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-67.331299",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9715376",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5552301",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8096304",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.9389696",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.7796",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.59119",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.71172",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.7558",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.10874771E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-697.4563",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.28280463E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.688965",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47260.848",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112836.48",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.43100452E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.56395527E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.78634377E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-436489.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "449034.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-265.83154",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "61.902863",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03138838",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258482",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-740.30811",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1039.9871",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1327.4888",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "221.04443",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.30825560E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.83864288E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1762.186",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2084.9216",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-326055.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "683345.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "978.85938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.8645",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "29.857971",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.04723",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.30569",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.20525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.42072",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005144577",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02841418",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.882099",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.76791",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55356574E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80176867E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55356574E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80176867E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005144577",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02841418",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.10381427E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93848246E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.10381427E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.93848246E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03224008",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.748024",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06078397",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.687229",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.274826",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.434265",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.65033",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.141861",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.11192945E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03628698",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.54147",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "338.23645",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.32571",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.33252",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.35892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.2373",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03995082",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "96.387573",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8520.7812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.87524",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.4375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.88525",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.213867",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1758.7522",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1830.1177",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.31787",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-78.043457",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.448517",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05349731",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-744.7417",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.971436",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6952686",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9172945",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.124712",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.6638279",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.49364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.52209",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.46603",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.85983",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19340643E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-702.59888",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.00341547E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.330078",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46865.438",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112241.81",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.23700327E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.69544830E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.33025617E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-409662.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "468448.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.84375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-279.43164",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "74.151794",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03075874",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258371",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.48267",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "966.46851",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1250.9219",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "213.91089",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.00208671E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.55364988E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1700.0718",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2117.8616",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-278100.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "649620.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "974.29688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-279.43164",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "30.618683",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.48798",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.87238",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.56943",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.73465",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004682686",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02983798",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.732323",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.70026",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56689803E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82235053E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56689803E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82235053E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004682686",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02983798",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.12547161E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.14485112E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.12547161E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.14485112E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02199136",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.582611",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03252205",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.053772",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.641815",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.073044",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-37.440033",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.86171",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.99974566E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03833693",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.70869",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "333.97601",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.68156",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "320.90118",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.70279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.89426",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03267239",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "90.756607",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8506.4531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.54077",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.41235",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.697998",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1656.896",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2040.4102",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.41235",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-73.697998",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.846161",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05383301",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-724.57324",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-62.74707",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3916359",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.4329119",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6163692",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.9991064",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.54964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.56976",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.5305",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.82394",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.35046957E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-697.89185",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.33345291E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.129395",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47681.879",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112075.92",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.45345631E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67921667E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.29632838E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-427734.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "509471.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.90625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-255.2827",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "66.163544",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03104406",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258512",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.64111",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "961.79443",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1233.6533",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "187.20679",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.93303446E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.48609921E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1536.6904",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2188.2139",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-245578.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "650531.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "977.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-255.2827",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "28.98381",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.20587",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.18872",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.54828",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.3175",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01011254",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02758659",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.647509",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.52899",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62821343E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82699096E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62821343E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.82699096E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01011254",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02758659",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.88229899E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85718943E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.88229899E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85718943E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03109664",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.491699",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05952264",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.732983",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.704941",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.425461",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.939133",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.535355",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.11578013E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03596534",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.52367",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.40558",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.44588",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.32812",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.48212",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.41077",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04718875",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "94.728447",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8520.0703",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.99707",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.08301",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.85791",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1569.5122",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2028.4062",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.08301",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.449463",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.003342",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0541687",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-733.35962",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.99292",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3691587",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.3625946",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6243467",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.2909985",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.54926",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.3172",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.51543",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "341.62985",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.74563274E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-698.9248",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.86387022E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.560303",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47256.469",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112164.2",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.05638138E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.73032379E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.43029320E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-407102.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "471549.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.04688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-247.67723",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "68.523285",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03060651",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258415",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.21411",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "830.50879",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1180.5667",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "190.35547",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.72075556E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.61190222E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1600.1702",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2580.5107",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-275001.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "656111.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.04688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-247.67723",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "32.349442",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.22922",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.57108",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.38315",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.58447",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004192725",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02843927",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.539289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.76758",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57041522E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87802925E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57041522E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.87802925E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004192725",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02843927",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00780437E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.12805708E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00780437E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.12805708E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02892857",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.946213",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03843931",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.90184",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.796494",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.942001",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.592758",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.323257",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.25929489E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04979833",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.22826",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.2493",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.93282",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.85834",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.93861",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.49133",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03788232",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "96.605049",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8485.7031",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.04077",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.53857",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-73.347656",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1603.2207",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2126.155",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.53857",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-73.347656",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.329773",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05355835",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-732.36938",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-60.838379",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7207489",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5420475",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.2118387",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.212595",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.13399",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "338.84155",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.04146",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.75128",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.11384759E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-702.59546",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.51971742E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.848633",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47112.625",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112190.5",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.12381984E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.67803569E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.17596410E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19219249E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-484390.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "436891.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "968.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-265.75049",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "63.801727",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03048415",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258389",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-761.49707",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "926.16333",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1194.448",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "180.54688",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.77626315E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.21927336E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1587.3608",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1877.3606",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-242736.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "632310.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.01562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.75049",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "29.533432",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.19244",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.92889",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.19142",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.3465",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007859364",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02869187",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.369684",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.59045",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62391298E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84935161E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62391298E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84935161E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007859364",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02869187",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.22685412E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.96077713E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.22685412E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.96077713E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02027928",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.01897",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04473521",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.160889",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.922195",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.428818",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.523712",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.180435",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.29590897E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.04054868",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.61417",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "339.20789",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.26691",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "325.81357",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.28523",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.33118",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0378552",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "93.059753",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8532.5547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-806.29785",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.8125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.0542",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-79.987061",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1661.979",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2420.2266",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.0542",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-81.237793",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.791931",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05343628",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.3252",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-70.451904",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.080471",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.8476944",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.503911",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.4758992",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.89345",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.0567",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.87831",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.43054",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.20253014E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-703.62476",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.27117071E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.09375",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47386.281",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111973.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.25350105E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.69471855E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.43342959E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-382521.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "467806.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "968.4375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-278.02515",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "72.270477",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02926996",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.09253",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1253.2952",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1624.5659",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "241.52393",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.49618414E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.65756328E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1581.7827",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1974.2173",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-283686.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "632725.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "968.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-278.02515",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "39.813705",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.25046",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.03644",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.51782",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.047",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003798352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02991354",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.750633",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.87393",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57049199E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84206347E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57049199E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.84206347E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003798352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02991354",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.37861764E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.13560475E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.37861764E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.13560475E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03179173",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.123291",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04739379",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.52372",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.884949",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.88913",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.624664",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.275406",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.72678426E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03707086",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "191.58609",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "342.56317",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "191.47047",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "322.67453",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "191.48134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.01947",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02369691",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.149155",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8488.5508",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-807.03271",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.33472",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-72.233154",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1784.1553",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1835.5598",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.33472",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-72.139404",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.120728",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05386353",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-744.93213",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-60.936035",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8103018",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.0082302",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1649628",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.6344156",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.218",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.45361",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.13567",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.22632",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.39894360E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-706.68433",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.71660484E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.82251",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47291.973",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111957.33",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.81081985E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.61599803E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.22781387E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-438614.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "446876.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "973.57812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-275.65503",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "71.245544",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02960088",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258404",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-759.37305",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1014.6699",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1299.2588",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "185.26343",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.19537195E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.40831467E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1530.3516",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2070.9985",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-328807.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "621208.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "973.57812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-275.65503",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "43.16861",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.89426",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.6774",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.98935",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.44452",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.009287704",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03089843",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.495785",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.57422",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57102768E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86837588E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57102768E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86837588E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.009287704",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03089843",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94904737E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90527157E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94904737E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90527157E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02557461",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.586151",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04614459",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.041634",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.047974",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.401291",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.27005",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "32.432236",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.92708515E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.05351752",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.88435",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.56915",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.65903",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.47687",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.66394",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.56976",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03660281",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "95.001457",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.7539",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-804.27539",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.74097",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.040039",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1557.1968",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2130.7246",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.74097",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.977539",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.136032",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05397034",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-734.72192",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.506348",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.4730148",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.0703011",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6830387",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.5186043",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.2227",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.11816",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.35286",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.40143",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.03804905E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.82959",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.49890818E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.090576",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46793.66",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112042.4",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.22725474E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.55856117E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.19933816E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-411042.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "470740.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "975.28125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-264.88452",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "75.64975",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02977413",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258516",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-783.21167",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1111.04",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1196.6936",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "214.7666",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.78524328E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.58809130E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1735.2542",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2114.8347",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-328398.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "633457.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "975.28125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-266.50122",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "38.12973",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.15547",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.15314",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.27499",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.07593",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005407084",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.03295235",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.6173",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.92261",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59070714E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89719940E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59070714E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.89719940E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005407084",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.03295235",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96362930E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90184539E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96362930E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.90184539E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02254581",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.043343",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05010664",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "38.460327",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.265594",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.270996",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.30368",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "33.920151",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.29437791E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03808666",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.65796",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.12781",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.74577",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.9317",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.78459",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "334.78271",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04381614",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.825623",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8480.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.04346",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-397.52124",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-77.117188",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1892.7644",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2248.9485",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1181.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-397.52124",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-76.175781",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.488724",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0533905",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-731.06104",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.827881",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.201395",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.8220062",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.4908991",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.5788898",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.43723",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.01685",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.42111",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "345.98401",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16824981E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-699.03735",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16825686E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.724609",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47083.359",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "111872.95",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.09180130E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.81134658E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.32676746E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-423257.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "462339.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "978.32812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-281.46362",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "70.52562",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03195572",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258436",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-745.00391",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "958.99707",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1302.3977",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "234.93701",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.20792412E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "9.39439246E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1543.7798",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2415.252",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-319396.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "649807.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "978.32812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-281.46362",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "32.782394",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.0937",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.35345",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.18231",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.09781",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004947353",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02950403",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.707693",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.69473",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61224161E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78906703E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61224161E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.78906703E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004947353",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02950403",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00692466E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.32322668E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.00692466E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.32322668E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.01877716",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.200462",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03344744",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.456291",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.905701",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "31.05159",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.825043",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.048019",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.16980469E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03772562",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.22249",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "337.58124",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.71429",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "323.85449",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.02316",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.63684",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04644083",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "92.864349",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.1289",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-809.88354",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-392.38867",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.821533",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1557.989",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "2025.489",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.38867",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-75.867188",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.606659",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0537262",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-728.46729",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-65.615723",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2441959",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.9613848",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9563742",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "6.0404482",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.56599",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "339.1991",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.54004",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "346.68195",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.14383954E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.66455",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.83082976E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "13.728027",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47331.188",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112561.57",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.04115928E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.66361974E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.27820590E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-424378.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "454323.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "970.84375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-262.71875",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "82.91745",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03006251",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258451",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-929.09717",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1075.3301",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1477.8901",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "203.98071",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.90966920E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.15659575E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1791.3064",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1981.4548",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-340792.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "695053.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "972.9375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.71875",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "32.671356",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.3317",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.24277",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.60394",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "314.24637",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005440474",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02885242",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.82453",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.76758",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57434733E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80518673E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57434733E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.80518673E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005440474",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02885242",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94453014E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85818874E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94453014E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.85818874E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02495284",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.070187",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04407012",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "37.537182",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.31604",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.943909",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.624237",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.562057",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.42861630E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03709922",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.81598",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "336.0152",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.48438",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "326.31696",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.53349",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "331.11633",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04610364",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100.541",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8489.4219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-804.4729",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.9375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.78784",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-75.553467",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1563.5171",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1714.5835",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.78784",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-75.553467",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.726944",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0537262",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-720.28589",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-64.273926",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2738342",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "4.4844236",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5905428",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.5454073",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.78087",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "337.92725",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.61523",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "344.82483",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.21263372E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-701.63208",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.16316369E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "14.724609",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47338.121",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112138.73",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.93367258E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.58510511E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.25232941E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-415184.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "437607.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "971.26562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-271.11841",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "73.827728",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03071187",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-772.99829",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "990.00269",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1299.3789",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "186.62329",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.19585285E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "7.46254614E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1381.3953",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1926.7542",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-318245.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "598342.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "971.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-271.11841",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "34.083954",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.87227",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "310.02094",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.0083",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.81543",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00801792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.0288716",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.805542",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.63672",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58550247E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86847246E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58550247E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.86847246E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00801792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.0288716",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.06224763E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.26577458E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.06224763E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.26577458E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02643111",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "35.072338",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05224082",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.097046",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.917999",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "29.768295",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.919617",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.20694",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.63829117E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03617814",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.58667",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "332.29773",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.47867",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "327.08813",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.57889",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.57642",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04689721",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "91.522499",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8517.9727",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-808.55029",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "1178.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-403.40381",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "-76.393799",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1416.4199",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1878.3855",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1180.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-403.40381",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "-77.553223",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.978165",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.05335999",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-749.04761",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "-66.213867",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2044525",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.9891548",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6868782",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "5.6431222",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.98293",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "340.53094",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.93228",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "348.875",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.30786179E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-699.36938",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.78528226E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "15.539307",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46975.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "112247.26",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326863E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.04821241E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.59242961E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.18711523E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-439575.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "447067.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "975.28125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PDS_TimeRange": "10",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-302.75366",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "scale_max": "70.155548",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03063845",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "16.25848",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-751.19946",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "1173.4709",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1434.2834",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "201.97437",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.73529746E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "8.07663696E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1960.2568",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "1800.5986",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-264846.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "648985.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "975.875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PDS_TimeRange": "10",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-302.75366",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "scale_max": "23.83992",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.48917",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "309.98029",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.56004",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "scale_max": "313.74261",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007300414",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "scale_max": "0.02932348",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "PTVersion": "128"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.570492",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "410.40125",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62981305E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72516447E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62981305E-05",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "1.72516447E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "PTVersion": "128"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast asst sep2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007300414",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "0.02932348",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99705937E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03325544E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99705937E-06",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "scale_max": "2.03325544E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03090989",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.902489",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05952122",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "36.02454",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.856873",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "30.424377",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.358292",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "34.483109",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.51717346E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "0.03806496",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.58417",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "335.86096",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.13959",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "321.17078",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.2412",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "scale_max": "330.90234",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "454.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/asst/sep2001"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "SIXHOURLY",
                            "apr2002",
                            "aug2001",
                            "dec2001",
                            "ensemble",
                            "ensemble_mean",
                            "feb2002",
                            "jan2002",
                            "jul2001",
                            "mar2002",
                            "nov2001",
                            "oct2001",
                            "sep2001"
                        ]
                    },
                    "ca_sst": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ca_sst",
                        "restriction": "Public",
                        "ensemble24": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst/ensemble24",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble24",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "ECHAM4.5 AMIP2a",
                                    "note3": " S (1 Dec 2005) (1 Dec 2006) (1 Jun 2008) VALUES updated 9 Jul 2009 after SST field changes",
                                    "Conventions": "IRIDL",
                                    "note": "M 2 VALUE S (1 Mar-May 1957-2002) VALUES updated 16 Jan 2008 previously identical to M 1 VALUE",
                                    "description": "ECHAM4.5 AMIP2a Jan 1957 to Jul 2008",
                                    "expires": "1491004800",
                                    "note2": "S (1 Jun 1957-2002) VALUES updated 11 Aug 2008 reread 7 Jul 2009"
                                },
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "meridional velocity",
                                    "units": "meters/second",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "zonal velocity",
                                    "units": "meters/second",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature",
                                    "units": "Kelvin_scale",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "tauy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface meridional wind stress",
                                    "units": "newton/ meter2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "taux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface zonal wind stress",
                                    "units": "newton/ meter2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "expires": "1491004800",
                                    "calendar": "360",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "pointwidth": "1.0"
                                },
                                "st": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "st",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface temperature",
                                    "units": "Kelvin_scale",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "sea level pressure",
                                    "units": "pascals",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "sh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface sensible heat flux",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "specific humidity",
                                    "units": "kg/kg",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "prec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total precipitation",
                                    "units": "meters/second",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "omg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "vertical pressure velocity",
                                    "units": "unitless",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "olr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "olr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "outgoing longwave radiation",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "nswt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nswt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "net shortwave at toa",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "nswg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nswg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "net shortwave at ground",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "nlwg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlwg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "net longwave at ground",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "lh": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lh",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface latent heat flux",
                                    "units": "W/m2",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "gz": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gz",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "evap": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evap",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "evaporation",
                                    "units": "meters/second",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "cld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "total cloud cover",
                                    "units": "fraction",
                                    "missing_value": "-999.0",
                                    "expires": "1491004800"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "Pressure"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "L": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "L",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months",
                                    "gridtype": "0",
                                    "standard_name": "forecast_period",
                                    "long_name": "Lead Time",
                                    "pointwidth": "1.0"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "standard_name": "longitude",
                                    "pointwidth": "2.8125"
                                },
                                "M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "long_name": "ensemble member",
                                    "pointwidth": "1.0"
                                },
                                "S": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "S",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "expires": "1491004800",
                                    "defaultvalue": "686.0",
                                    "calendar": "360",
                                    "standard_name": "forecast_reference_time",
                                    "long_name": "Start Time",
                                    "pointwidth": "0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst/ensemble24/MONTHLY"
                            },
                            "NEWMONTHLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst/ensemble24/NEWMONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "NEWMONTHLY",
                                "restriction": "Public",
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "RETRODAILY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst/ensemble24/RETRODAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "RETRODAILY",
                                "restriction": "requires dlauth tokens"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ca_sst/ensemble24/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY",
                                "NEWMONTHLY",
                                "RETRODAILY",
                                "SIXHOURLY"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "ensemble24"
                        ]
                    },
                    "psst": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "psst",
                        "restriction": "Public",
                        "SIXHOURLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SIX-HOURLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sep2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "sep2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.sep2001/.griblist.html",
                                "oct2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "oct2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.oct2001/.griblist.html",
                                "nov2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "nov2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.nov2001/.griblist.html",
                                "may2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "may2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.may2002/.griblist.html",
                                "mar2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "mar2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.mar2002/.griblist.html",
                                "jan2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "jan2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.jan2002/.griblist.html",
                                "feb2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "feb2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.feb2002/.griblist.html",
                                "dec2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "dec2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.dec2001/.griblist.html",
                                "aug2001PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "aug2001griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.aug2001/.griblist.html",
                                "apr2002PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "apr2002griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.SIX-HOURLY/.apr2002/.griblist.html",
                                "Conventions": "IRIDL"
                            },
                            "sep2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sep2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02675952",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "98.027283",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8454.8711",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-807.78491",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.2812",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-394.55273",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.422119",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1642.3042",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2394.239",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.25",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-395.40063",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.148682",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-96.768417",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.008773804",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-742.55737",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.77124",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.5797396",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.5130663",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.3352833",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.6216545",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "181.07883",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "340.28433",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "181.0106",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "347.65399",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.97186046E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-705.15063",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.19348988E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.901367",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "47259.504",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112674.24",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.00763850E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.95142502E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.26490257E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.48595677E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-467034.19",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "500450.38",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "980.95312",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-283.09961",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "82.91745",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.0322413",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258581",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-847.39209",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1548.4207",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2217.2468",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "282.2207",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-8.86614998E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.12849904E-07",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1904.4919",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2658.1777",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-355499.69",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "667672.88",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "982.17188",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-283.13843",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "44.574326",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.22966",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.63077",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.51408",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.88159",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01011254",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.03143527",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev P 0000 1 Sep 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-20.762323",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "410.95264",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.62926281E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.90296505E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.62926281E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.90296505E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY sep2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01011254",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03143527",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.16365311E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.29792022E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.16365311E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.29792022E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0198893",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.516331",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03099272",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "41.043995",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-33.160538",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "34.265396",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-40.969223",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.766022",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "3.16980469E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.06269276",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.18021",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "342.56317",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.11377",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "327.08813",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.14806",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "339.06738",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "oct2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "oct2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02532358",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "97.0998",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8482.9023",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-812.85449",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1179.9688",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-398.38818",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.321045",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1981.8438",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2319.2236",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.8438",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-401.7605",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.219971",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-94.963409",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.1412659",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-755.38843",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-59.62207",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.9431276",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.3846102",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.1174212",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.9823017",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.23595",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "343.21497",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.23483",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "350.35269",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.49791038E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-704.17896",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "8.78804713E-07",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.731934",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46381.449",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112785.89",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.41172175E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.02557133E-07",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.06687014E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.42301546E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.44568605E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-475950.62",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "515550.75",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "985.20312",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-287.13306",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "70.311279",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03178613",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258541",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-905.55591",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1568.7869",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1633.4429",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "243.98193",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.53168058E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.75652767E-08",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2107.9561",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2451.3916",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-412809.5",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "697046.69",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "985.20312",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-287.13306",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "38.007263",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.35989",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.67767",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "195.25513",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "320.00723",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.23483",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "346.26202",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.92145",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.80859",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.0091842",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.03203419",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev P 0000 1 Oct 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-21.305241",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "410.87601",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.58565126E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.94022377E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.58565126E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.94022377E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY oct2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.0091842",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03203419",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.18449895E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.14428928E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.18449895E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.14428928E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02211624",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.66766",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03484546",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "41.704437",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-34.214188",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.083893",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-41.294098",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "36.2836",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "5.68374681E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.05472569",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.45302",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "340.33936",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.2149",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "324.33856",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.27003",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "332.17661",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "nov2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nov2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02897478",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "91.119492",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8506.8164",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-814.46289",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.2812",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-396.57568",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.629395",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2082.031",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2343.5667",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.3438",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-396.57568",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.235107",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-95.060181",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.1220703",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-748.66064",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-64.706055",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.6356659",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.6379089",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.0730581",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.8652382",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.91609",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "341.75732",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.75851",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "350.34375",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.51222321E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-705.98486",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.56204827E-07",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.788574",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46670.445",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112788.16",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.02622403E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.22824360E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.12937729E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.55036389E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-495777.5",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "503977.12",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "988.57812",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-285.18848",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "62.073273",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03106722",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258642",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-871.84424",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1389.5564",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1469.2402",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "231.9043",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.87508055E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.27279586E-08",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2061.6406",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2250.6633",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-368597.44",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "683574.56",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "988.57812",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-285.18848",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "29.449753",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.37526",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.66711",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "196.41655",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "320.0416",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.75851",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "345.77344",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.89868",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.65875",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009461354",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.02924465",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev P 0000 1 Nov 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.277485",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "410.25348",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.38407277E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91621493E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.38407277E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91621493E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY nov2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009461354",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.02924465",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.30498040E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.23253710E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.30498040E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.23253710E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01714108",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "37.488258",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03471962",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "41.149761",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-33.458328",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "40.883301",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-37.727036",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "37.195724",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "5.42675416E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04161635",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "186.54524",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "333.74219",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "186.06303",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "324.11514",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "186.24815",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "329.52448",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "may2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "may2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03230006",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "99.619659",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8442.457",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-786.51758",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1143.1562",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-410.11841",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.824707",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1893.1602",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2234.824",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.7812",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-410.11841",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.730957",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-96.05278",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.009643555",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-745.07227",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-59.236084",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-4.9343863",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.1748343",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.4116545",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.0489841",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "179.9239",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "340.41003",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "179.83885",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "344.6886",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.61604282E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-742.47534",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.24797225E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.94873",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "47327.711",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112848.98",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-8.82326131E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.04256299E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.89231218E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.80700392E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.67417977E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-510563.75",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "458631.31",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "921.70312",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-267.56323",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "89.562332",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.0330243",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258512",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-951.53662",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1683.3306",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2184.1958",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "243.98315",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-8.73398790E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.75645946E-08",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1983.4014",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2325.5039",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-308541.5",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "654894.88",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "923.3125",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-267.56323",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "57.811752",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.68915",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "309.94629",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "194.01117",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "319.76636",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "179.83885",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "340.7511",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.04109",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "313.55145",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009192508",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.03511711",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev P 0000 1 May 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.402082",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "411.01651",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.60297241E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.86958714E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.60297241E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.86958714E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY may2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009192508",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03511711",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.38163011E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.53811641E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.38163011E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.53811641E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02496704",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.065479",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.04006128",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "40.626591",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-35.103088",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "32.407578",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-38.867264",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.220764",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "2.88788300E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04648352",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.23242",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "343.9458",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.01016",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "328.22156",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.18022",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "337.83026",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "mar2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mar2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.04025863",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "94.798889",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8478.1602",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-809.71289",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1179.2188",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-403.94409",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-73.722656",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2363.5962",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1742.8357",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.8438",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-403.94409",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.477539",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-90.750397",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.01948547",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-741.67822",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-63.298828",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.3640909",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.401803",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.3523474",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.0257902",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "182.92757",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "339.48999",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "182.89119",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "347.69504",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.57667262E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-730.40015",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.31814159E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "17.073242",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46515.105",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112518.74",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.18883986E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.10211329E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.69871771E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-447896.38",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "518819.19",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "984.1875",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-280.74048",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "75.209213",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03192077",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258533",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-839.1792",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1242.5964",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1725.1414",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "259.80542",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.89835815E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.03891153E-07",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1786.2104",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2235.7981",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-346718.69",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "640566.25",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "984.1875",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-280.76099",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "40.887802",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.42003",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.6062",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "195.75774",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "318.42767",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "182.89119",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "343.31613",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.58095",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "311.91644",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.00786357",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.02992407",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev P 0000 1 Mar 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.303123",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "410.68713",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.49694706E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.55838552E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.49694706E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.55838552E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY mar2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.00786357",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.02992407",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.32273146E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.19199524E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.32273146E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.19199524E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01356976",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.594917",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.026906",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "40.923443",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-34.793106",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "36.530365",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-39.121613",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.055817",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "3.60467887E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04173303",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "185.7489",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "339.258",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.62885",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "327.64273",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.63171",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "333.04205",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "jan2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "jan2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.05089009",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "87.449677",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8506.3477",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-809.41406",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.25",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-395.70093",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.634277",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2238.6836",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2017.9797",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.4688",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-396.69556",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-85.724854",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-86.620575",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.07272339",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-747.58325",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-69.446533",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.9926596",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.9778156",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.6627359",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.4628172",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.2211",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "341.7485",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.23528",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "350.25449",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.68765985E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-705.87329",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.22567872E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.876465",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46470.082",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "111911.56",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.23525665E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.01607361E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.12876239E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.08420222E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.45486126E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-456165.69",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "544784.06",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "981.71875",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-289.09937",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "58.867676",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03153343",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258497",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-829.37671",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1306.1624",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1495.8433",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "220.28662",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.98145846E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "8.80851871E-08",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2022.1917",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2284.9915",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-357191.88",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "633704.94",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "981.71875",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-289.21826",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "18.377762",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.38564",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.68155",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "200.26634",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "318.40887",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.23528",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "346.05508",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.92708",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.04733",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.007022448",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.0276714",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev P 0000 1 Jan 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.323158",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "408.19223",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.29132850E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.48435247E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.29132850E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.48435247E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY jan2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.007022448",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.0276714",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.38375742E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.20701941E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.38375742E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.20701941E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0201621",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "37.114346",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03541747",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "40.754135",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-34.894867",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.438934",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-35.359024",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.55825",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.14605655E-07",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.03985489",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "189.17281",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "332.99371",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "189.02597",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "324.16617",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "189.05995",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "328.77908",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "feb2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "feb2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.04531902",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "89.894363",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8506.418",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-815.17896",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.0938",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-398.36865",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.51123",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2265.9478",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1885.8657",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.375",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-401.73267",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.343506",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-90.174973",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0191803",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-748.12402",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-66.02124",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.5612984",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.4372473",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.2171583",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.4476709",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.84857",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "339.44397",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.83022",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "348.89621",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.43446050E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-736.93677",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.15783769E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "17.012695",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46758.566",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112325.24",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.41172175E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.01254739E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.88695344E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.49853292E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-452230.56",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "481113.44",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "980.29688",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-289.31958",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "62.726913",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.0311002",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.25861",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-877.20044",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1586.1001",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1827.2275",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "281.35327",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.30657177E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.12508246E-07",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1834.356",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2089.2336",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-409798.69",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "660290.56",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "980.29688",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-289.31958",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "28.88147",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.38564",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.67847",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "198.23935",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "318.64191",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "184.83022",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "344.6019",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.35205",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "312.58832",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01137783",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.02822993",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev P 0000 1 Feb 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.37188",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "409.3392",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.46271250E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.50166761E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.46271250E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.50166761E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY feb2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01137783",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.02822993",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.15222894E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.21983646E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.15222894E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.21983646E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01865",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "36.905354",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03395388",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.824055",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-34.078751",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.883316",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-35.11441",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.444321",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "7.12433348E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.0407541",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.41034",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "337.21838",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.04173",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "326.42932",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "187.14845",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "332.20551",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "dec2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "dec2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03557465",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "85.517365",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8504.3516",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-814.6604",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1180.2188",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-407.38525",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.893799",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2076.9307",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2453.8953",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1181.3438",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-408.37305",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-81.27832",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-87.678955",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.1198273",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-756.25635",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-71.043213",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.1158295",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "7.562603",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.155098",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "8.8722048",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "188.26215",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "340.70599",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "188.34218",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "350.49249",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.63761581E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-705.33081",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.04148057E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.882324",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46739.148",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112297.41",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.77932707E-26",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.99380859E-07",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.07052426E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.44560339E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.50856579E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-488946.94",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "541537.06",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "979.54688",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-292.07739",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "64.581787",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03201964",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258547",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-903.37134",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1557.7366",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1566.4011",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "254.64087",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.52619838E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.01822934E-07",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2081.2212",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2457.2051",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-420790.25",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "652948.62",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "979.98438",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-292.07739",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "20.203918",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.3855",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.7048",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "197.59271",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "319.67255",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "188.34218",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "346.01025",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.90558",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.66095",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009891991",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.02828454",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev P 0000 1 Dec 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.133425",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "408.77298",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.32589512E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.87862588E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.32589512E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.87862588E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY dec2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009891991",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.02828454",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.48600418E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.32882508E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.48600418E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.32882508E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01757254",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.668488",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03816917",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "40.807304",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-33.633957",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.576279",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-39.316528",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "39.284714",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.66128132E-07",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.0407531",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "191.33049",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "330.79932",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "190.97353",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "320.13037",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "191.12912",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "325.95905",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "aug2001": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "aug2001",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02373542",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "99.291595",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8457.4062",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-806.104",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1170.9062",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-402.04858",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.496338",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1632.0957",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2625.0793",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1171.9375",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-402.04858",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.277588",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-101.36821",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.008422852",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-744.97925",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-58.893555",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.3972616",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.1380692",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.7984362",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "8.6588364",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "179.67944",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "340.52393",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "179.65771",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "347.00082",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.63710229E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-679.14038",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7208099",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.28766987E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.898438",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "47771.461",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "113249.98",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.05861028E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.15578632E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.26006773E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.80700392E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.47213234E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-475545.06",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "486040.94",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "967.0",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-273.38354",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "82.075119",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03253441",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.258543",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-903.77734",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1454.0613",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2024.3599",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "265.61133",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-8.09484902E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.06216703E-07",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2049.4016",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2592.7175",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-319260.94",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "667745.0",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "967.28125",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-273.88867",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "57.703751",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.29396",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.60968",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "208.77449",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "314.67493",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009553272",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.03130891",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev P 0000 1 Aug 2001",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-20.342131",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "411.09247",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.62246179E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91071304E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.62246179E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.91071304E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY aug2001 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.009553272",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03130891",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.34326603E-06",
                                        "units": "s-1",
                                        "grib_name": "div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.43119848E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.34326603E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.43119848E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01373887",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "37.961048",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.03435826",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.831455",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-35.250473",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "33.678421",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-37.79332",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.109436",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "3.01464880E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.04571583",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.63565",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "341.63062",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.09006",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "328.67679",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.20528",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "341.6304",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "apr2002": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "apr2002",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "QVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vertically integrated specific humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.032493",
                                        "units": "kg/m2",
                                        "grib_name": "QVI",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "98.325005",
                                        "subcenter": "255",
                                        "gribparam": "230"
                                    },
                                    "CLTOPMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLTOPMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum height of convective cloud tops",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "8454.8906",
                                        "units": "Pa",
                                        "grib_name": "CLTOPMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "100000.0",
                                        "subcenter": "255",
                                        "gribparam": "217"
                                    },
                                    "cltm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cltm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "cloud cover total mean[0-1]",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "cltm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "164"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "SRAD0U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRAD0U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (top)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-800.5625",
                                        "units": "W/m2",
                                        "grib_name": "SRAD0U",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "203"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (top)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rst",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "1165.4062",
                                            "subcenter": "255",
                                            "gribparam": "178"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-407.6106",
                                            "units": "Wm-2",
                                            "grib_name": "rlt",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.800781",
                                            "subcenter": "255",
                                            "gribparam": "179"
                                        }
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-2370.5212",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0U",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2122.054",
                                                "subcenter": "255",
                                                "gribparam": "105"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.0625",
                                                "subcenter": "255",
                                                "gribparam": "187"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-407.6106",
                                                "units": "W/m2",
                                                "grib_name": "TRAF0",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.675781",
                                                "subcenter": "255",
                                                "gribparam": "188"
                                            }
                                        }
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Geopotential",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7517.7578",
                                        "units": "m2 s-2",
                                        "grib_name": "zg",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "58762.242",
                                        "subcenter": "255",
                                        "gribparam": "129"
                                    },
                                    "TSLIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSLIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "TSLIN heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-95.014877",
                                        "units": "W/m2",
                                        "grib_name": "TSLIN",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.009719849",
                                        "subcenter": "255",
                                        "gribparam": "220"
                                    },
                                    "TRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "longwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-736.02197",
                                        "units": "W/m2",
                                        "grib_name": "TRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "-60.528564",
                                        "subcenter": "255",
                                        "gribparam": "205"
                                    },
                                    "tauv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-5.6633472",
                                        "units": "Nm-2",
                                        "grib_name": "tauv",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.0525007",
                                        "subcenter": "255",
                                        "gribparam": "181"
                                    },
                                    "tauu": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauu",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-component of Surface Wind Stress",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-6.7108974",
                                        "units": "Nm-2",
                                        "grib_name": "tauu",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "6.7884426",
                                        "subcenter": "255",
                                        "gribparam": "180"
                                    },
                                    "tas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "air temperature (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.88474",
                                        "units": "Kelvin_scale",
                                        "grib_name": "tas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "339.91193",
                                        "subcenter": "255",
                                        "gribparam": "169"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.94144",
                                        "units": "unitless",
                                        "grib_name": "stemp",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "346.99146",
                                        "subcenter": "255",
                                        "gribparam": "139"
                                    },
                                    "srun": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "srun",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "surface runoff",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "srun",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.69583768E-06",
                                        "subcenter": "255",
                                        "gribparam": "160"
                                    },
                                    "SRADSU": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SRADSU",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "shortwave radiation upward (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-709.19971",
                                        "units": "W/m2",
                                        "grib_name": "SRADSU",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.0078125",
                                        "subcenter": "255",
                                        "gribparam": "204"
                                    },
                                    "soilm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soilm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil wetness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "soilm",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.7324371",
                                        "subcenter": "255",
                                        "gribparam": "140"
                                    },
                                    "SNMEL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNMEL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "snow melt",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m/s",
                                        "grib_name": "SNMEL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.18691241E-06",
                                        "subcenter": "255",
                                        "gribparam": "218"
                                    },
                                    "snd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "snd",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.949219",
                                        "subcenter": "255",
                                        "gribparam": "141"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "mean sea level pressure",
                                        "gribleveltype": "102",
                                        "Z": "Z_10",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "SICED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SICED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice depth",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "m",
                                        "grib_name": "SICED",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.5",
                                        "subcenter": "255",
                                        "gribparam": "211"
                                    },
                                    "sfr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sfr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sfc roughness",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "1.49999996E-05",
                                        "units": "m",
                                        "grib_name": "sfr",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "20.00148",
                                        "subcenter": "255",
                                        "gribparam": "173"
                                    },
                                    "SEAICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SEAICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "sea ice cover",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "SEAICE",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "210"
                                    },
                                    "pss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "46750.191",
                                        "units": "Pa",
                                        "grib_name": "pss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "112850.72",
                                        "subcenter": "255",
                                        "gribparam": "134"
                                    },
                                    "prs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Snow Fall",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-8.82326131E-27",
                                        "units": "unitless",
                                        "grib_name": "prs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.05749643E-06",
                                        "subcenter": "255",
                                        "gribparam": "144"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Large Scale Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "grib_name": "prl",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "2.03002264E-06",
                                        "subcenter": "255",
                                        "gribparam": "142"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "260",
                                        "long_name": "Total Precipitation",
                                        "grib_name": "totprcp",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Convective Precipitation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.71665347E-23",
                                        "grib_name": "prc",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.72059788E-06",
                                        "subcenter": "255",
                                        "gribparam": "143"
                                    },
                                    "PERPW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PERPW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Primary wave mean period",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-489213.69",
                                        "units": "s",
                                        "grib_name": "PERPW",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "566326.31",
                                        "subcenter": "255",
                                        "gribparam": "108"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Net Shortwave Radiation (surface)",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "0.0",
                                            "units": "Wm-2",
                                            "grib_name": "rss",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "948.26562",
                                            "subcenter": "255",
                                            "gribparam": "176"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave flux",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "scale_min": "-280.39526",
                                            "units": "Wm-2",
                                            "grib_name": "rls",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1",
                                            "scale_max": "86.111893",
                                            "subcenter": "255",
                                            "gribparam": "177"
                                        }
                                    },
                                    "lsm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lsm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "land-sea mask",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "(0,1)",
                                        "grib_name": "lsm",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1.0",
                                        "subcenter": "255",
                                        "gribparam": "172"
                                    },
                                    "logpsl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "logpsl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Log Surface Pressure",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.03119388",
                                        "units": "unitless",
                                        "grib_name": "logpsl",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "16.25852",
                                        "subcenter": "255",
                                        "gribparam": "152"
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Sensible Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-855.44995",
                                        "units": "Wm-2",
                                        "grib_name": "hfss",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "1391.8533",
                                        "subcenter": "255",
                                        "gribparam": "146"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Surface Flux of Latent Heat",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1782.3899",
                                        "units": "Wm-2",
                                        "grib_name": "hfls",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "249.79688",
                                        "subcenter": "255",
                                        "gribparam": "147"
                                    },
                                    "FOREST": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FOREST",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vegetation type",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.0",
                                        "units": "unitless",
                                        "grib_name": "FOREST",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.9492188",
                                        "subcenter": "255",
                                        "gribparam": "212"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Evaporation",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-7.12727854E-07",
                                        "units": "m (H2O)",
                                        "grib_name": "evs",
                                        "gribNumBits": "24",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "9.98880409E-08",
                                        "subcenter": "255",
                                        "gribparam": "182"
                                    },
                                    "dpsdy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "274",
                                        "long_name": "Meridional Deriv. of Surface Pres.",
                                        "grib_name": "dpsdy",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "dpsdx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "dpsdx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "273",
                                        "long_name": "Zonal Deriv. of Surface Pres.",
                                        "grib_name": "dpsdx",
                                        "units": "kilogram meter-2 second-2",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "clear_sky": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "clear_sky",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "upward": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "upward",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-1969.5259",
                                                "units": "W/m2",
                                                "grib_name": "SRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "2209.1868",
                                                "subcenter": "255",
                                                "gribparam": "106"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-346517.44",
                                                "units": "W/m2",
                                                "grib_name": "TRAFSU",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "654521.62",
                                                "subcenter": "255",
                                                "gribparam": "107"
                                            }
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "solr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "solr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "solar flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "0.0",
                                                "units": "W/m2",
                                                "grib_name": "SRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "948.26562",
                                                "subcenter": "255",
                                                "gribparam": "185"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "calendar": "standard",
                                                "scale_min": "-280.39526",
                                                "units": "W/m2",
                                                "grib_name": "TRAFS",
                                                "gribNumBits": "16",
                                                "PDS_TimeRange": "10",
                                                "gribleveltype": "1",
                                                "scale_max": "48.05394",
                                                "subcenter": "255",
                                                "gribparam": "186"
                                            }
                                        }
                                    },
                                    "ALBEDO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ALBEDO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Albedo (surface)",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.06999999",
                                        "units": "unitless",
                                        "grib_name": "ALBEDO",
                                        "gribNumBits": "8",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "scale_max": "0.8004687",
                                        "subcenter": "255",
                                        "gribparam": "175"
                                    }
                                },
                                "soil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "soil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TDCL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TDCL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temp level CL",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.53712",
                                        "units": "m (H2O)",
                                        "grib_name": "TDCL",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "310.3031",
                                        "subcenter": "255",
                                        "gribparam": "183"
                                    },
                                    "TD5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "193.64977",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD5",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "319.36224",
                                        "subcenter": "255",
                                        "gribparam": "209"
                                    },
                                    "TD3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TD3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "180.94144",
                                        "units": "Kelvin_scale",
                                        "grib_name": "TD3",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "342.85083",
                                        "subcenter": "255",
                                        "gribparam": "207"
                                    },
                                    "td": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "deep soil temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "209.54129",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "111",
                                        "scale_max": "312.52908",
                                        "subcenter": "255",
                                        "gribparam": "170"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01031893",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "scale_max": "0.03092351",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribleveltype": "100",
                                        "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev P 0000 1 Apr 2002",
                                        "missing_value": "NaN",
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "subcenter": "255"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "grib_name": "va",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "grib_name": "ua",
                                        "units": "m/s",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-22.298481",
                                        "units": "Kelvin_scale",
                                        "grib_name": "ta",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "411.11975",
                                        "subcenter": "255",
                                        "gribparam": "130"
                                    },
                                    "rvort": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rvort",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "vorticity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.61389162E-05",
                                        "units": "s-1",
                                        "grib_name": "rvort",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.65046131E-05",
                                        "subcenter": "255",
                                        "gribparam": "138"
                                    },
                                    "Rv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for moist air"
                                    },
                                    "Rd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Rd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "J/kg/K",
                                        "long_name": "gas constant for dry air"
                                    },
                                    "psi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "psi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "148",
                                        "long_name": "streamfunction",
                                        "grib_name": "strm",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-1.61389162E-05",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "1.65046131E-05",
                                        "subcenter": "255"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "grib_name": "zg",
                                        "units": "m",
                                        "fnname": "max",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "pressure",
                                        "units": "Pa",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "1",
                                        "subcenter": "255"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst SIX-HOURLY apr2002 hybrid_lev omegahalf",
                                        "grib_name": "ua",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "subcenter": "255"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Specific Humidity",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-0.01031893",
                                        "units": "unitless",
                                        "grib_name": "hus",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "0.03092351",
                                        "subcenter": "255",
                                        "gribparam": "133"
                                    },
                                    "gravity": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gravity",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s2",
                                        "long_name": "earth\\'s gravity"
                                    },
                                    "Div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Divergence",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.15694172E-06",
                                        "units": "s-1",
                                        "grib_name": "Div",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.37903055E-06",
                                        "subcenter": "255",
                                        "gribparam": "155"
                                    },
                                    "chi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "chi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "149",
                                        "long_name": "velocity potential",
                                        "grib_name": "vpot",
                                        "units": "meter2 second-1",
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-2.15694172E-06",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "109",
                                        "scale_max": "2.37903055E-06",
                                        "subcenter": "255"
                                    },
                                    "BC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless"
                                    },
                                    "AC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "AC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Pa"
                                    }
                                },
                                "filepattern": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "filepattern",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless"
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "10m windspeed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.01627278",
                                        "units": "unitless",
                                        "grib_name": "wind10",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "37.804264",
                                        "subcenter": "255",
                                        "gribparam": "171"
                                    },
                                    "WIMAX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIMAX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "maximum 10m wind speed",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "0.02776488",
                                        "units": "m/s",
                                        "grib_name": "WIMAX",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "38.050068",
                                        "subcenter": "255",
                                        "gribparam": "216"
                                    },
                                    "vas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "V-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-34.726364",
                                        "units": "m/s",
                                        "grib_name": "vas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "35.488831",
                                        "subcenter": "255",
                                        "gribparam": "166"
                                    },
                                    "uas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "U-wind at 10",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "-37.565506",
                                        "units": "m/s",
                                        "grib_name": "uas",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "36.2715",
                                        "subcenter": "255",
                                        "gribparam": "165"
                                    },
                                    "td2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "td2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Dewpoint at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "2.32839632E-08",
                                        "units": "Kelvin_scale",
                                        "grib_name": "td2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "0.05603361",
                                        "subcenter": "255",
                                        "gribparam": "168"
                                    },
                                    "t2mmx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "max 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.56944",
                                        "units": "unitless",
                                        "grib_name": "t2mmx",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "339.78613",
                                        "subcenter": "255",
                                        "gribparam": "201"
                                    },
                                    "t2mmn": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmn",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "min 2m temp",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.45233",
                                        "units": "unitless",
                                        "grib_name": "t2mmn",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "328.01984",
                                        "subcenter": "255",
                                        "gribparam": "202"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                        "long_name": "Temperature at 2 m",
                                        "process": "50",
                                        "PTVersion": "128",
                                        "calendar": "standard",
                                        "scale_min": "183.49049",
                                        "units": "Kelvin_scale",
                                        "grib_name": "t2m",
                                        "gribNumBits": "16",
                                        "PDS_TimeRange": "10",
                                        "gribleveltype": "105",
                                        "scale_max": "337.23273",
                                        "subcenter": "255",
                                        "gribparam": "167"
                                    }
                                }
                            },
                            "T_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "364.75"
                            },
                            "S_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "395.75"
                            },
                            "S_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "423.75"
                            },
                            "S_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "242.75"
                            },
                            "S_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "180.75"
                            },
                            "S_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "484.75"
                            },
                            "S_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "515.75"
                            },
                            "S_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "454.75"
                            },
                            "S_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "333.75"
                            },
                            "S_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "1.0"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "long_name": "Depth",
                                "pointwidth": "0"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "1.0"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "long_name": "Height",
                                "pointwidth": "0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "0.25",
                                "defaultvalue": "211.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "modulus": "360.0",
                                "pointwidth": "2.8125"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "long_name": "Start Time",
                                "pointwidth": "0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/SIX-HOURLY"
                        },
                        "apr2002": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "apr2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200207",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200207",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200207",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200207",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200207",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200207",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200207",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200207",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200207",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200207",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200207",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200207",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200207",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200207",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200207",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200207",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200207",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200207",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200207",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200207",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200207",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200207",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200207",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.apr2002/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/apr02/20008fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200207",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0340022",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.265114",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8542.7148",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-783.99072",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1161.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-406.44629",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.800781",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1749.3152",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1522.6057",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.2812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-406.44629",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-69.675781",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-94.182114",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008621216",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.38306",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.917236",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0589552",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8996019",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5685682",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7884426",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.22832",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.32648",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.27783",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.19241",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18743458E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-706.26831",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18691241E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.479736",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47201.867",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111761.02",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.45708838E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47602714E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35316907E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-461303.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "447176.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "936.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-243.54195",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.09668",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03000608",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-844.17896",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1090.0964",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1318.0317",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "205.4165",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.27044051E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.21377739E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1410.2454",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1846.4751",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-217770.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "618756.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "936.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-243.54195",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.398209",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.24059",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.6156",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.49573",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.85455",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.27783",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.60004",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.66048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.32901",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005646311",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.029008",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.887682",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55008",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57718059E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55371599E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57718059E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55371599E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005646311",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.029008",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.01900366E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05284755E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.01900366E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05284755E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02478636",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.903965",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04937333",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.728008",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.844284",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.380615",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.698486",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.047394",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.88660872E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03599198",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.72478",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.04077",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.42088",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.33582",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.56276",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.28107",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05572701",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "98.325005",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8501.2773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-785.49658",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1163.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.90186",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.170654",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1562.1396",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1381.0144",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.20972",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.204102",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-92.403702",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008789062",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-726.29224",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.529297",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7322979",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0564241",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0278282",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5327578",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.52846",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.12128",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.46675",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.99146",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23098232E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-663.82373",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00766192E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.713867",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47600.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112378.69",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.20812181E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38881944E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03678348E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23292364E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-403996.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "478715.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "928.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-254.50389",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "71.280823",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0302035",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258348",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-731.69141",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "866.27295",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1398.8821",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "214.2854",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.59373802E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.56860822E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1323.3083",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1693.2246",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-280353.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615777.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.34375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-254.50389",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.361618",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.54117",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.81461",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.05125",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.08521",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.46675",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.85083",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.26364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.16599",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005968649",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02876126",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.524664",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52625",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53662404E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56662663E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53662404E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56662663E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005968649",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02876126",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.79383539E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02302817E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.79383539E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02302817E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02412564",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.897408",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0539119",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.953163",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.441162",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.488831",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.406357",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.227661",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.56958150E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03466773",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.49399",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "338.28552",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.33783",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.67328",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.37663",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.82935",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.032493",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.978439",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8531.9375",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-796.3855",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-377.14258",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.516113",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1982.2378",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1545.3403",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.2188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-377.14258",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.303467",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.610535",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009033203",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-731.6355",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.528564",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1194344",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.0525007",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3167896",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5895214",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.88474",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.15878",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.94144",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.90906",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23431914E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-643.59863",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07529922E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.607666",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47218.898",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112234.61",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.02919351E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.02944443E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47537276E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-415728.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "566326.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "941.8125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-236.87914",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "80.297546",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03119388",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258337",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-793.04126",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1391.8533",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1782.3899",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "167.88086",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.12727854E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.71307703E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1458.5359",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1606.832",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-346517.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "597052.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "941.8125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-237.20343",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "46.562469",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.51573",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.50208",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "193.64977",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.94559",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.94144",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.03796",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.04529",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.57654",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02843412",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.704197",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.6564",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55793714E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62040578E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55793714E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62040578E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02843412",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.02278125E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94326617E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.02278125E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94326617E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0302454",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.976139",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06014676",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.835243",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.44165",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.461456",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.306412",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.516571",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.58101840E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03686575",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.74916",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.47009",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.66676",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.53784",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.70071",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.0856",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0400478",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.244553",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8479.2383",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-787.46411",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1162.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-395.98706",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.699219",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2131.5298",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1554.1636",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.98706",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.417969",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.948425",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009063721",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.09473",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.820557",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8883533",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7531404",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.1331339",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4843826",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.90369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.2081",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.798",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.43146",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07101835E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.354",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07393134E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.63623",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47104.195",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112055.95",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.41532233E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73455317E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35663959E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-394500.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "483069.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "930.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-280.39526",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "66.016617",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03035731",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258501",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-754.81787",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "993.66455",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1263.6042",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "229.12476",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.05279900E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.16186309E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1519.2048",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2074.7163",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-271034.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "598526.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "935.89062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-280.39526",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.37323",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.0269",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.94098",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.21016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.09381",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.798",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.3299",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.99165",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.84772",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006816525",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02967598",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.965364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.61774",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57702943E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55652306E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57702943E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55652306E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006816525",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02967598",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.81774237E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09640780E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.81774237E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09640780E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03503",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.765736",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0737282",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.037945",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.669464",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.376892",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.523315",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.746155",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.96043392E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03683333",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.04352",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.5882",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.87466",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.46359",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.88513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.38156",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05312976",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.193146",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8531.1211",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-799.625",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1163.5938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.93408",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.210449",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1621.9446",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1393.5659",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.93408",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.036621",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.118942",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008987427",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-718.83374",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.311523",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2411785",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4336014",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.6572523",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2531166",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.13785",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.22104",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.07704",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.67877",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.69583768E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-674.0708",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07201049E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.382812",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47365.758",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112221.91",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326131E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.19492903E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.73887599E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38553082E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-399696.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "413457.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "933.03125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-238.64015",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "86.111893",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03036484",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-654.77637",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1056.0891",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1117.3755",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "176.7688",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.46807178E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.06851040E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1309.2449",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1561.001",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-336542.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "599357.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "944.32812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-238.64015",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.657791",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.53712",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.68164",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.87894",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "315.77301",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.07704",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.33698",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.67355",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.99512",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005902644",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03091281",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.704393",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.44199",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57582508E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55327543E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57582508E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55327543E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005902644",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03091281",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94102518E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14203692E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94102518E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14203692E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02942398",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.804264",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05742679",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.050068",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.271973",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.100769",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-37.565506",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.423264",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.12588395E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03333522",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.93497",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.87195",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.87521",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.1702",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.88307",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.87195",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04945342",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.176506",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8477.1406",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-791.41797",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1161.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-385.68726",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.029541",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1481.0029",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1739.5376",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1166.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.68726",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.201416",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.564484",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008865356",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-724.83228",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.497559",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.3546391",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.4062376",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5167017",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.267313",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.8093",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.22363",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.77591",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.66785",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11874203E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-643.91309",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.78878234E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.727295",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47711.84",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112375.79",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.34915147E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45376998E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23620612E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-403935.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "434923.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "941.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-231.15738",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.788177",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03022835",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258482",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.78467",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1057.575",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1210.0789",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "240.63989",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.83876647E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.62256195E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1550.4731",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2107.4253",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-282457.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "587451.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "941.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-231.15738",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.743332",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.42233",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.88522",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.35751",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.66501",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.77591",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.95691",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.25955",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.52908",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005210128",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02793807",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.567921",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "411.11975",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55582111E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.65046131E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55582111E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.65046131E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005210128",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02793807",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.89729371E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07476569E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.89729371E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07476569E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03656483",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.812111",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06232781",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.354744",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.941498",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.96106",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.361633",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.937012",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.94508992E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03346878",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.61195",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.07617",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.57619",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.12698",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.59285",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.34476",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03809961",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.329857",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8513.6289",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-795.42065",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1162.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.80273",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.158691",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1731.1108",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1539.6475",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.5",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.80273",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.158691",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.612793",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.25488",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.263672",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8580618",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4033966",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6609936",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0825005",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.45831",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.21265",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.38493",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.96436",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48518359E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-667.53003",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17425225E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.431641",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47372.73",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112360.68",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.38310746E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.80051757E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65563938E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-449509.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "438634.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "935.625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-261.18237",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "85.305176",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03090977",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258324",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-835.54224",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1043.9771",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1311.1365",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "192.04541",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.24286804E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.67948052E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1415.877",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1769.9331",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-277342.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "589085.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "939.40625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-261.18237",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.937653",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.31544",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.24707",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.66327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.54108",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.38493",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.84131",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.75841",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.28745",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005881",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03067856",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.676695",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.61359",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60691379E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.53270939E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60691379E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.53270939E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005881",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03067856",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99669148E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87868466E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99669148E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87868466E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03772231",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.203545",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05040736",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.850239",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.773209",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.360046",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.210999",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.082489",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.67897188E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03291237",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "183.56944",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.21851",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "183.45233",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.55841",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.49049",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.40613",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04233764",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.679314",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8523.6719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-789.28467",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-392.60718",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.937012",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1832.6829",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1694.0049",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.60718",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.844238",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.641586",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009338379",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-734.37012",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.429932",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8449488",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2267942",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.3366766",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5895071",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.74208",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.2916",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80101",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.83432",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59369051E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-706.18945",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05777872E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.9729",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47504.684",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112220.66",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.31930436E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.78218750E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22425558E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-376121.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "431384.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "933.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-235.70993",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "75.444016",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03061864",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.2584",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-819.33398",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "995.25586",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1346.7021",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "202.78101",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.38508516E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.10848348E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1499.2942",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1918.1963",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-230228.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "645595.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.35938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-235.80698",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.067856",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.12447",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29047",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.07149",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.03354",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80101",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "339.21399",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.85483",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.29428",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007272065",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02917535",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.909332",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65674",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61389162E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.57593568E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61389162E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.57593568E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007272065",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02917535",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.80424092E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10327630E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.80424092E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10327630E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02340545",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.507999",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03501829",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.199242",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.776825",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.103058",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.169174",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.520966",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "2.32839632E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03455669",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.57494",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.23474",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.15109",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.48419",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.17871",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.23273",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04638639",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.98909",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8515.707",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-789.12158",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.53149",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.053223",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1692.802",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2076.0771",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.53149",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.758545",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.362976",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008560181",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-711.98657",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.535645",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.4408379",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2564163",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5863667",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2840338",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80544",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.0329",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80533",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.14966",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38593316E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-676.09741",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11243571E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.63916",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47152.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112850.72",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.27180748E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.81293159E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51505424E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.71665347E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64006394E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-432138.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "430210.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "948.26562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-268.26147",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.811783",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02992463",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258385",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-691.94971",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1145.4497",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1678.3347",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "218.65503",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.71119039E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.74317436E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1969.5259",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1605.1523",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-289958.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "582457.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "948.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-268.40674",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.467163",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.04552",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "308.90295",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "195.8405",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.74561",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80533",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.24731",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.75758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.8067",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01031893",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02894403",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.539818",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.55869",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55641719E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56100832E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55641719E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.56100832E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01031893",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02894403",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.08499682E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96381575E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.08499682E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96381575E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02914925",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.50061",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05611723",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.389973",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.926163",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.381836",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.172775",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.33519",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.75414878E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.033516",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.4991",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.76767",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.21016",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.98419",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.28783",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.10046",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04501491",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.417191",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.3203",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-791.06079",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1163.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-385.81372",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.412842",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1658.48",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1902.802",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.81372",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.498779",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.615936",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008651733",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-717.62207",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.900391",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.516119",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8208523",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0647297",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.107069",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.90894",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.00354",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.91298",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.00107",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13986744E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-676.87988",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08373933E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.158203",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47470.609",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112530.53",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.59659337E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.76155788E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62630428E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33664696E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-429263.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "429450.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "934.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-250.80344",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "73.369629",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0298631",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25843",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-775.52588",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1076.5962",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1226.7651",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "192.2373",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.90549041E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68723964E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1676.3777",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2113.5869",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-294410.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "578494.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250.80344",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.33252",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.15327",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.4931",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "195.5472",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.3974",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.91298",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "339.56747",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.58835",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.69724",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006450847",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03092351",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.422091",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.79968",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55792550E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58397888E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55792550E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58397888E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006450847",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03092351",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96794963E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01015473E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96794963E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01015473E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0265913",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.844368",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06381828",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.452248",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.246338",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.495056",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-36.252304",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.408585",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.03561486E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03586787",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.76881",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.6405",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.50307",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.32867",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.5504",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.12164",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05420644",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "92.138924",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8524.8047",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-796.3291",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.0312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.55981",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.657227",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2013.8237",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1703.5525",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.4375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.55981",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-84.067627",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.764526",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00932312",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-733.06689",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.855713",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3552341",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4640999",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.7108974",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2255306",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.81998",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.69086",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.547",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.57312",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55804071E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-682.37866",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03391358E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.373535",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47448.73",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112197.19",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.62500065E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.80464872E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25771885E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-409044.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "434399.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "936.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-227.61761",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "64.658478",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02919988",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25852",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.20801",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "917.1958",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1154.7229",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "188.7522",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.61741365E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.54740483E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1398.5325",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2046.0586",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-311173.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "559246.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "938.42188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-227.61761",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "45.715881",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.38522",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.30124",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.97394",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.36224",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.547",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.70984",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.26187",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.12515",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005417701",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02977891",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.910454",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68127",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56598308E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55192665E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56598308E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55192665E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005417701",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02977891",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05053516E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01264197E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05053516E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01264197E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02457232",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.059216",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05015126",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.051235",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.949478",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.951782",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.052017",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.20874",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.60387117E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03392267",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.61293",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "338.11038",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.99133",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.87305",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "190.99133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.54034",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05024743",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.821373",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8501.2773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-795.10913",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.08887",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.751221",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1880.3567",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2028.3523",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.08887",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.476562",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.578537",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00920105",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-706.7627",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.550049",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6719484",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9912148",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8585901",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7632618",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.83057",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "334.71851",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.83176",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.62634",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37154871E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-709.19971",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08274980E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.949219",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46841.043",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112289.69",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.34142793E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47647972E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.58326734E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53751046E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-444237.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "442712.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "931.03125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-234.39401",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "71.347549",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03044993",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258369",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-696.89307",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1171.6316",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1396.6626",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "245.1748",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.58486306E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.80411983E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1775.2451",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1893.1724",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-314397.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "578275.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "934.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-234.39401",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "48.019424",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.90398",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.23993",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.17953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.53122",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.83176",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "335.21228",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.54129",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.93582",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004412502",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02937157",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.123514",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52728",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.54945265E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62127981E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.54945265E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62127981E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004412502",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02937157",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.91785784E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19161302E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.91785784E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19161302E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02465909",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.767979",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0443335",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.424698",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.800797",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.780533",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.734924",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.112595",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.00133434E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03949521",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.87633",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.58276",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.24052",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.15015",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.30717",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.67242",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05720978",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "97.400276",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.4102",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-789.87524",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1160.875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-383.6416",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.133545",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1907.7166",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1400.7859",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-383.6416",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.994385",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.596634",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009475708",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-722.74658",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.578125",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6725092",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2563734",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0163784",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8918095",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.93802",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.76587",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.89145",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.35217",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23660755E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-698.89502",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18548633E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.906738",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47341.145",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112430.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.13624183E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.76682488E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29364264E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-430684.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "431815.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "932.07812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-228.2823",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.402588",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03018321",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-661.87891",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "872.89673",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1272.7915",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "249.79688",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.08953690E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.98880409E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1473.4685",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1801.9255",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250686.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "593069.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "937.51562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-228.2823",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.308151",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.15527",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.99512",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.29175",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.71762",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.89145",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.68091",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.0376",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.93994",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006098505",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02774436",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.603689",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65536",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53446508E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.59232095E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53446508E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.59232095E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006098505",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02774436",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.85676367E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07541234E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.85676367E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07541234E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03900692",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.949413",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05700291",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.362843",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.237854",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.348526",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.512527",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.118408",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.27607905E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0407261",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.68927",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.28638",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.62782",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.96533",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.67964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.83008",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04770952",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.502563",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.8672",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-798.46289",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.21216",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.496582",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1770.2764",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1645.0684",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.9062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.21216",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.441895",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.805344",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009124756",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-735.68115",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.142578",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0967293",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5094786",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.2075863",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4144888",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.95088",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.35873",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.97534",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.38837",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28469719E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-692.31641",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15128933E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.574951",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47712.27",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112246.61",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.29395617E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.05497996E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58641933E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21881567E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-415041.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "525347.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "943.21875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-246.99879",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "81.911545",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03055578",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.2584",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-638.67261",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1010.7708",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1401.2844",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "198.46826",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.60334456E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.93648951E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1582.0559",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1985.7417",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-294241.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "562163.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "943.21875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-252.67897",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "33.068054",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.68222",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.58456",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.74133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.80627",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.97534",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.60876",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.77161",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.1134",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008316208",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02891225",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.707773",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68161",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53601086E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63443910E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53601086E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63443910E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008316208",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02891225",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.15113960E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06841833E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.15113960E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06841833E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0328034",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.902332",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05837486",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.959743",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.570953",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.403442",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.834442",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.043152",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.38222229E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03535992",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.77495",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.77176",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.61649",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.83197",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.63425",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.68457",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03882649",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "91.77581",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.8398",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-795.96973",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1162.375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.16138",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.089111",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2370.5212",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1303.1387",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.16138",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.636719",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.492523",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008758545",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-723.79028",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.240723",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7585316",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2622356",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.6601534",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9182796",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.89891",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.59393",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.84303",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "343.62851",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46623597E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-680.23169",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07791857E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.313965",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47414.613",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112052.12",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.30495992E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.84047428E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52190091E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-489213.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "417314.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "933.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-234.19075",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "64.276428",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02969031",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258411",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-679.50073",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1011.3501",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1473.4316",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "210.27197",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.89184083E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.40843484E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1243.6421",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1788.0273",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-306053.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591646.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "936.07812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-234.34776",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.404846",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.43939",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "308.93744",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.10577",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.06671",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.84303",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.00937",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.06485",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.49438",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003588892",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.029016",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.70857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.49207",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53923993E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58334879E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53923993E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58334879E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003588892",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.029016",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.07504422E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14017314E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.07504422E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.14017314E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0287957",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.681175",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06403738",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.564381",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.575439",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.281174",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.654678",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.191452",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.30972236E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03696655",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.31041",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.25684",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.1523",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.086",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.16464",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.72876",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04862808",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.979523",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8454.8906",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-793.91797",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.35571",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.539307",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1710.1997",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1739.7209",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.35571",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.495605",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-95.014877",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009338379",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-728.80347",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.855957",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.149847",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0427151",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3280048",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.765995",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.16196",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.59256",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.21011",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.14178",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38303369E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.4978",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.86707164E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.694336",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47930.047",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111920.99",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.00854934E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.87754381E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30363651E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-383021.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "400167.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "937.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-239.78455",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "78.875534",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02966419",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258379",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.74805",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "962.6062",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1473.2483",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.66138",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.89110755E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.50428910E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1956.8215",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2209.1868",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-292366.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "602287.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "938.98438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-239.78455",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "33.231735",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.2652",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "308.95074",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.99002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.18134",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.21011",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.37595",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.07819",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.25983",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004268613",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.03058483",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.677006",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.8028",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53132041E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.64632766E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53132041E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.64632766E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004268613",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03058483",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.77501545E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98937391E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.77501545E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98937391E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03247675",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.631573",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0661664",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.427528",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.388916",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.785522",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.768265",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.951828",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.24677399E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03876933",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.13013",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.78613",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.79695",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.87006",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.89204",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.6817",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04204648",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "97.253334",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.7227",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-789.39795",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-407.6106",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.20752",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1692.2327",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1538.0554",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-407.6106",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.066895",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.296631",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008575439",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.53101",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.69751",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8513947",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0098429",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.5000591",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7496719",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.7159",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.40491",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.73798",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.77396",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10727422E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.99756",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10676046E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.856934",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47624.996",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112351.2",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.18478191E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39890028E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52873952E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-420230.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "412986.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "929.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-253.96117",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "72.60881",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02955442",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-855.44995",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "866.57593",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1212.6033",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "216.39526",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.84886073E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.65317986E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1855.6016",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1734.0664",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265018.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "576003.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "929.92188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-253.96117",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.307587",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.36423",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.80563",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.36989",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.05255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.73798",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.66263",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.18564",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.12256",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004455637",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02915772",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.70734",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65225",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56538208E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.60761938E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56538208E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.60761938E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004455637",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02915772",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.12142140E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83153577E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.12142140E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83153577E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03216352",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.068275",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06519455",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.526634",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.572144",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.810104",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.577393",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.681122",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.60641683E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03603609",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.28403",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.14056",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.19168",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.53992",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "190.24168",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.96899",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04415658",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "96.510994",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.1055",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-795.90942",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.0",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.31836",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.792725",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1521.4646",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1405.3599",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.31836",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.49585",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.416672",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009552002",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-735.58398",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.001465",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.4657888",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0018463",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.0118361",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4614258",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.13608",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.91193",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.12259",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.18042",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37646271E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-683.43994",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06004882E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.197754",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47361.051",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112358.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.47892500E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43998250E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33117442E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-400229.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "448378.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "938.40625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-257.68359",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.097275",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02938775",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258444",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-653.83716",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1019.0286",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1278.4727",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "200.479",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.11225437E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.01683768E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1195.6838",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1836.1873",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-251977.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "654521.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "939.70312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-260.41577",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "25.482269",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.37369",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.73892",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.86557",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.47482",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.12259",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.26636",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.9948",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.62958",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004228957",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02941245",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.886724",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.34222",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56440656E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.52938046E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56440656E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.52938046E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004228957",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02941245",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.84623593E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00664272E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.84623593E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00664272E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02581771",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.260529",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06232341",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.827919",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.162094",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.100388",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.527344",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.438065",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.03395971E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04122893",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.33739",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.80521",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.15848",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.80829",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.16153",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.93689",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03980851",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "92.147148",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8533.5273",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-792.68555",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.17139",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.907715",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2157.9243",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1811.9932",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.17139",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.728271",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.552673",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009490967",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-716.06348",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.715332",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3134365",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0373926",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.8894491",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4886007",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.51575",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.00613",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.48912",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.99854",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18490436E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-668.23608",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03237107E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.983398",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47255.484",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112627.78",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.28842758E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.03002264E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25706038E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-419703.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "415710.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "936.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-240.39018",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.804688",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03041294",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-677.11377",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1056.7336",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1525.8291",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "200.04688",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.10136283E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.99956013E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1368.4102",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1695.4336",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-338282.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "589259.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "940.64062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-240.43846",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.312622",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.09023",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.3031",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.35265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.15884",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.48912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.39893",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.78725",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.67004",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008339003",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02847138",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.298481",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52383",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59569609E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58088696E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59569609E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.58088696E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008339003",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02847138",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.82285896E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91075014E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.82285896E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91075014E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.04197911",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.441685",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06187246",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.471828",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.234833",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.709198",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.109375",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.090042",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.94978912E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03594882",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.05489",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.31851",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.97919",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "321.78424",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.00241",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.81134",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05408199",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "98.209518",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8483.7539",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-793.34204",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1162.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.22266",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.491211",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2068.6355",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2122.054",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.22266",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.209961",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.338455",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007888794",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-736.02197",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.414062",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.6633472",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2207985",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.4745092",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.711669",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.51132",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.38388",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.37366",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.50153",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39771544E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.80493",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02494960E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.081787",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46750.191",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112454.67",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.03751527E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41790872E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26862790E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-400234.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "407492.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "929.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-250.52437",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.745773",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0309442",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258383",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-787.04443",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "989.21997",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1188.8953",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "222.05981",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.75405955E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.87931151E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1816.7334",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1945.6729",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-259465.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "626494.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "933.34375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250.52437",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "48.05394",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.31898",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.69397",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.48645",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "319.04819",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.37366",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.22833",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.05824",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.37073",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003159958",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02920287",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.784462",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.80832",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61187218E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.51413506E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61187218E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.51413506E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003159958",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02920287",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.97178520E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98339171E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.97178520E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98339171E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02032182",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.061443",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03090714",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.885239",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.460251",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.189957",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.736481",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.2715",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.18518699E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.05603361",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.0976",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.76807",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.76022",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.022",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.77585",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.54987",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04742164",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "95.172249",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.7305",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-800.5625",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-388.75391",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.446289",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1701.7109",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1752.5601",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.31519",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.892822",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.066818",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009719849",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-720.86182",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.24585",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8196545",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6592197",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7576685",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2322836",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.45203",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.65063",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.4567",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.15375",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18289290E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-660.87158",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18295429E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.658691",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47789.348",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111877.28",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.59221087E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67505027E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41614771E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-440546.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "448493.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "937.23438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-242.33896",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "73.316467",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02904196",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258436",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-636.07666",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1217.301",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1575.2197",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.95264",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.29886244E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51600453E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1554.1379",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1936.8396",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-293051.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "622930.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "937.23438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-242.33896",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.068985",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.21466",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.94904",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.25558",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.60913",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.4567",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.11859",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.36427",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.80566",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005187687",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02863819",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.611568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.6312",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56447713E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63177738E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56447713E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.63177738E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005187687",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02863819",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05896640E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85358942E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05896640E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85358942E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0208987",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.819275",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0465067",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.652294",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.726364",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.222443",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.571701",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.959839",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.68774307E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0365851",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.88297",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.95209",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.71059",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.03717",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.75731",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.68991",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04457022",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.110756",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8544.0117",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-782.67578",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1164.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.52148",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.969238",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1921.2556",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1454.7134",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1165.4375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.52148",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.984863",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.502808",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009567261",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-723.14893",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.397949",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8517103",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8564167",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0500956",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6583776",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.44398",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.64569",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.36707",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.59558",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49231710E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-706.68652",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17468880E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.967529",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47363.723",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112170.71",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05749643E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71776333E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21849359E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-422760.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "424686.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "932.25",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-251.3456",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "75.767487",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02934251",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25852",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-722.15234",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1001.137",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1352.696",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "209.16211",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.40905319E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.36380707E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1543.176",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1861.5574",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-273413.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "601749.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "932.25",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-251.3456",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.24498",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.41583",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.9881",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.69037",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.72247",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.36707",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.5401",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.05124",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "312.01413",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005218945",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02791422",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.741707",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74963",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55318285E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.54620793E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55318285E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.54620793E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005218945",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02791422",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94782297E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01172361E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94782297E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01172361E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01702334",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.771624",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.02776488",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.856625",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.274384",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.543777",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.181946",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.440887",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.43233014E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03371933",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.9794",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.66635",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.71536",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.39496",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.7301",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.60199",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04885752",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.642387",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8501.2734",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-792.43237",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1162.875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.55811",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.1604",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1916.4573",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1594.9426",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.479",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.210938",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.72049",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008377075",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.49072",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.396729",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7334614",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3319511",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9880381",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4164877",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.82018",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.47009",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.75206",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.30804",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41916132E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-697.50415",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02131162E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.668945",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47869.25",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112144.52",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.05449440E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53452356E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72059788E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-405222.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "450295.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "930.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-238.68222",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "69.191956",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03047282",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-668.42188",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1020.0488",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1108.7593",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "213.67065",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.43361785E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.62711636E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1676.8088",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1936.958",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-281943.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "582607.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "939.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-238.68222",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.300293",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.91696",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.71579",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.03439",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.28876",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.75206",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.68304",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.67766",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.38861",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005389169",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02941351",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.9286",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70233",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56961378E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62775577E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56961378E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62775577E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005389169",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02941351",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.15694172E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.37903055E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.15694172E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.37903055E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02882907",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.825966",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06296664",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.576004",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.03302",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.64502",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.136581",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.662521",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.31988543E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03578028",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.74712",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.50031",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.63802",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.76654",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.69864",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.54971",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04944203",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "93.114403",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.2656",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-786.88672",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1163.9375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-399.22314",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.544189",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1573.4243",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1813.5881",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1164.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-399.22314",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.544189",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.764923",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009185791",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-725.7688",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.757568",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2765961",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.6157875",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6930389",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.57763",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.31726",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.51367",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.09311",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.73151",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33328058E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-676.38086",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07372762E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.612305",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47621.621",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112038.44",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.24166477E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48919742E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19651145E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-412607.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "467679.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "931.09375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-243.96315",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.580292",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03034955",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-748.49438",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1148.509",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1559.146",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "182.38232",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.23458789E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.29268947E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1423.9385",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1632.854",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-247598.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "605154.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "943.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-243.96315",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.493729",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.61252",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.7883",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.38446",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.89618",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.09311",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.14948",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.32697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.88889",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006617144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02913981",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.764208",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.42715",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59987485E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62948345E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.59987485E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62948345E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst apr2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006617144",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02913981",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.80255074E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97113309E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.80255074E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97113309E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01627278",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.416428",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03448251",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.383236",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.976227",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.358734",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.412216",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.06105",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.73857209E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03654908",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.89197",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.25128",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.52037",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.01984",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.52422",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.2677",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "211.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/apr2002"
                        },
                        "aug2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "aug2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200111",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200111",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200111",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200111",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200111",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200111",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200111",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200111",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200111",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200111",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200111",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200111",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200111",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200111",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200111",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200111",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200111",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200111",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200111",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200111",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200111",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200111",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200111",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.aug2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/aug01/20000fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200111",
                                "description": "forecast starting aug2001",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05180212",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.736214",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8489.125",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.27734",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.2188",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-396.04932",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.371582",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1401.7197",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2188.6816",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.04932",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.371582",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.656128",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006881714",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.07007",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.808594",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6536055",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6581497",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.401866",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.382792",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.70549",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "337.64307",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.63472",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "347.00082",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09102939E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-673.79712",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7051239",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06371590E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.34082",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48255.273",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112591.44",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.28117038E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45102467E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31118088E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-428570.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "426791.75",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "957.15625",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-261.02026",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "66.368835",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03111663",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25841",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-754.60718",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1063.75",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1484.1841",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "188.66943",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.93483719E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.54455982E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1633.9258",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2374.0378",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-289912.12",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "658422.19",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.28125",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-261.02026",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.909134",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28879",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.79269",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.72231",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.8208",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007885862",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02856605",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.90275",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.62845",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52886951E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82860877E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52886951E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82860877E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007885862",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02856605",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.87325941E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96566657E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.87325941E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96566657E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03556496",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.396709",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.07804418",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.829075",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.566147",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.503448",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.345108",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.256027",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.38426799E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03866787",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.06807",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "339.49969",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.97133",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.71631",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "188.99722",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "331.90442",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04457512",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.883423",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8487.7539",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-793.56006",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.7188",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-384.39331",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.532471",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1248.5576",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1911.9094",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-384.39331",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.618164",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.334137",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008163452",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-724.56006",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.057617",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1630917",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "3.5613813",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.7880573",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8981953",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.19664",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.11761",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.14618",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "342.72351",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40376790E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-667.7002",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05725485E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.578125",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48119.008",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112370.53",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.26353846E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46028424E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40481200E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-455223.25",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "428285.31",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "958.76562",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-256.33203",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "72.199799",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02933774",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258486",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.30957",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1413.4509",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2024.3599",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "227.61279",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.09484902E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.10139022E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1692.6665",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2096.8179",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262624.69",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "607217.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "959.75",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-256.33203",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.498642",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.37885",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.17572",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.73222",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.3446",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005321987",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02821732",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.132162",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.64432",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.61200205E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91071304E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.61200205E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91071304E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005321987",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02821732",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89471484E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88952549E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89471484E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88952549E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.01676636",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.868431",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03435826",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.823128",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.400742",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.617203",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.248611",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.158981",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.23960490E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0345672",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.70624",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "337.17786",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.46657",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.9281",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.48894",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.83444",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02373542",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "96.25145",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8485.3047",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-789.39136",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.3438",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-400.49829",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.496338",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1396.4612",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1950.8325",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5312",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-400.49829",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-69.277588",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-92.131973",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007141113",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.32715",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.672119",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8776617",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0256329",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3684597",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.5498714",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.08838",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.71075",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.17401",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.64148",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19817696E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-677.50024",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19837932E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.460693",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48083.164",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112029.6",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.73161534E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.01690157E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "2.07356766E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29557054E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-427558.25",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "467467.31",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "960.70312",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-262.32324",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "64.710602",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.030943",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258459",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-844.80469",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "786.84985",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1207.0154",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "201.38354",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.82651672E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.05294462E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1805.0562",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2092.5376",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-309362.44",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "642455.0",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "960.70312",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.52026",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.489182",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.38243",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.83411",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.56107",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.92822",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00914539",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02788312",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.112692",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.90466",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55174621E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89108232E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55174621E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89108232E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00914539",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02788312",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.79150993E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92222706E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.79150993E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92222706E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02264655",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.62923",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03602238",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.748497",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.978516",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.673187",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.377319",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.231445",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "3.95764630E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03737932",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.16595",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "341.63062",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.68094",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.68744",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.88728",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "341.6304",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03514523",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "95.562981",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.7695",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.25415",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.4688",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-391.91553",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.947754",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1340.9272",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2081.1287",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5938",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.91553",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.908691",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.274216",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008026123",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-730.69019",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.586426",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.7618656",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1380692",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5392523",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2912979",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.56155",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.73914",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.50755",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "346.33154",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23515156E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-663.59888",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7134705",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23985228E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.37207",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47815.82",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "111968.88",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.10290750E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.59062914E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.77577340E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35908238E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-410491.5",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "477294.38",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "956.03125",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-257.4021",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "59.251038",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03005792",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.2584",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-813.15698",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "873.21631",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1255.698",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "203.0332",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.02118496E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.11848224E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1759.4966",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2150.0061",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-244307.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "642254.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.71875",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-257.4021",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.194244",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.94617",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.32333",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.06572",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.11243",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003549861",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02972752",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.670925",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.93884",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54578229E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84410401E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54578229E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84410401E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003549861",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02972752",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04134017E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.43119848E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04134017E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.43119848E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.01373887",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.43713",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03486102",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.481869",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.696793",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.472336",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.885849",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.462921",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "9.99495455E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03804987",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.07666",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "340.31848",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.87541",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.43985",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.8923",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "330.20996",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05870539",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "97.897835",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8537.168",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-793.74854",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1170.0",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-387.51318",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.966309",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1326.1096",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2125.9563",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.375",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.51318",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.978516",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-85.357193",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007263184",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-719.40088",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.981201",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1022148",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8372679",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2261887",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0957317",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "186.9129",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "337.11249",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "186.91505",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "340.55975",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11281861E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-674.38892",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11284317E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.291504",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48207.156",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "113249.98",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51581752E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55806788E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30612000E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-398197.75",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "432403.0",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "950.25",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-241.50061",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "74.443665",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03099153",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258415",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-716.78638",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "862.73438",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1330.7205",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "173.76758",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.32117838E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.94851110E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1820.7454",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2244.1104",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-238277.31",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "631030.88",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "952.65625",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-241.50061",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "42.793198",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.29396",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.84082",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "208.77449",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82031",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007528611",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.03077303",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.039972",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.90396",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52358116E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85329100E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52358116E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85329100E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007528611",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03077303",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07912012E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00148816E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07912012E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00148816E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02152784",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.903652",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0398512",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.831455",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.931519",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "29.854416",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.481216",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.109436",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8.97066457E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03694167",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.83519",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.40521",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.69151",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.39502",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "189.69513",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "330.56036",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03768979",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "91.888855",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8536.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-793.59058",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.2812",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-393.42896",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.019043",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1424.4707",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2625.0793",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-393.42896",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.320801",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-91.538025",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007858276",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.40674",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.897461",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.5407352",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4583635",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5896626",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9021168",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "182.66136",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.31238",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "182.6745",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "345.00098",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30343415E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-675.92065",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6886749",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14110298E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.604248",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48217.93",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112560.23",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.00974201E-32",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.16019656E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75473849E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21372318E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-432339.88",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "448370.88",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "958.03125",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-247.01788",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "78.197754",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03033473",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258423",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.14551",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1030.8074",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1329.7744",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "230.50244",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.31739545E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.21738206E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1966.5767",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2592.7175",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-264061.06",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "663747.12",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.4375",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-247.01788",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.697556",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.31781",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.27716",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.48427",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.40594",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006611705",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.03069389",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.134457",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.8187",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59487372E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76593294E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59487372E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76593294E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006611705",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03069389",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83980228E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86003319E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83980228E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86003319E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.01865815",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.401608",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05361824",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.763863",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.408051",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.010056",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.386856",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.243881",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.03096113E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04571583",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.31477",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "337.53711",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.21263",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "321.80173",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "185.25235",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "328.13303",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04363173",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.4161",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8477.8828",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-795.21216",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.5938",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-393.57959",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.740234",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1496.6479",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2156.3328",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.4062",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-393.57959",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.951172",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.417786",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008422852",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-743.70557",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.900879",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3177376",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2127218",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.260191",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3453693",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.80118",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "340.52393",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.69173",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "344.52191",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22183371E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-657.93652",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7208099",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18336175E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.397949",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47982.492",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112418.22",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.04871003E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.56174074E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.85249053E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.26490257E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18265325E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-437780.44",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "395557.56",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "951.21875",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-259.95996",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "74.904404",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0308677",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258356",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-687.48145",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1026.7559",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1504.9766",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "184.66895",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.01797979E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.38442338E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1831.9036",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2146.918",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-310394.19",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "630101.06",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "952.34375",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.54395",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.626724",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.18491",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.25522",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.43578",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.38092",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006271575",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02897854",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.782267",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.67331",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59915216E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85312128E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59915216E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85312128E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006271575",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02897854",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.86636146E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94857580E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.86636146E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94857580E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02472485",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.164547",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04111031",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.495472",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.793839",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "30.564331",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.948898",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.983261",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.18116873E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03475595",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.99731",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "335.4953",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.84062",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.72382",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.88383",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "330.95831",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03297512",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "92.138458",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8501.4766",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.104",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.75",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-389.58594",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.60791",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1357.2681",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2196.0298",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.75",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-389.72852",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.60791",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-96.927673",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008255005",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-727.65039",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.125977",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8715239",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2868347",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2274923",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6281595",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.3985",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.28922",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.41823",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "344.73071",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17467812E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-666.35767",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6532135",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17655145E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "14.889648",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48137.336",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112496.16",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.73840930E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "2.00359250E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14563693E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-427925.12",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "431224.88",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "958.15625",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-273.38354",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "73.520767",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03107029",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258404",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-894.89673",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "926.47461",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1326.011",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "174.94604",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.30234729E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.99571672E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1761.2227",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1977.6057",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-251333.25",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "628935.56",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.20312",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-273.88867",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.539276",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.97746",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.50122",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.08057",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.59021",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006463725",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02922503",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.074018",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.61462",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53848996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78636965E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53848996E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78636965E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006463725",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02922503",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.10736175E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92065545E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.10736175E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92065545E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02216928",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "37.042149",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03454591",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.051464",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.250473",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "29.744461",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.28717",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.686371",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "3.57396495E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03961096",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.83261",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.40292",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.28244",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "324.22232",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.28244",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.39963",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03006675",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "97.636559",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8478.957",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-796.08887",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1170.9062",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-400.29956",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.88623",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1328.0127",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2262.1492",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-400.29956",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.690918",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.269806",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007476807",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-725.23999",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.844971",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.5720663",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3077135",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1711807",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3781157",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.92711",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.4035",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.97502",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "340.1366",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21716391E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-665.24268",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6913605",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12468842E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.48584",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48382.402",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112433.3",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.04871003E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.73760803E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45791614E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.03902716E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36198014E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-429377.69",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "466009.88",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "955.25",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-241.32683",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "70.037766",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03024516",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258543",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-729.94092",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "986.55884",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1362.9705",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "227.47168",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.45013791E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.09624873E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2000.5979",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2158.6484",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266173.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "605785.88",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "955.54688",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-241.32683",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.096329",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.88353",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.57886",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "208.99194",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.68842",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005480573",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02905129",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.038429",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.93399",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55314738E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84727451E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55314738E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84727451E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005480573",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02905129",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.19517074E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11920133E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.19517074E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.11920133E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02698077",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "37.432884",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0508466",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.1227",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.751297",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.763885",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.188095",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.040268",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "3.01464880E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03913843",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.23126",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "337.24573",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.55392",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.37341",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.89685",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "335.14651",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03330553",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "93.507042",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8483.4805",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-791.18042",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.4688",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-393.12671",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.204102",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1190.2102",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1926.3262",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.375",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-393.12671",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-70.197998",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.390579",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007354736",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-741.91553",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-58.893555",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8009911",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5265408",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2066889",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7436876",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "179.67944",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "340.1651",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "179.65771",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "341.79633",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16323838E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-667.18774",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6732025",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16325100E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.932617",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48243.801",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112217.41",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.58006820E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49932077E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33303115E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-392272.69",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "440802.56",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "954.75",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-244.70224",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "69.872955",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03253441",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258333",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-903.77734",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1067.1577",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1489.0452",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "177.25024",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.95427423E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.08747052E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1789.9897",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2065.3628",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-252515.69",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "638169.69",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "954.75",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-244.70224",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.952499",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.19662",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.73569",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.35046",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.5929",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006454706",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02752919",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.078033",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69058",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54622521E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85325971E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54622521E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85325971E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006454706",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02752919",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.76874767E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84822602E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.76874767E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84822602E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03150642",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.662991",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06412154",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.712887",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.100632",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "28.520966",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.233643",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.605713",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "5.58340076E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04209815",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.63565",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "338.46262",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.52539",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "324.54288",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.55202",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "332.90155",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03268417",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.562057",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8488.7656",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-798.53003",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.125",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.31787",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.60083",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1394.3127",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2338.9834",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.2188",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.31787",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.499268",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.044724",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00819397",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-744.97925",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.285156",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2865229",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9039288",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6421061",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.235672",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "182.96779",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "340.4325",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "182.9207",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "345.168",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04581079E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-665.59131",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7124023",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04607898E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.384521",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48363.973",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112345.27",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.41680651E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42719375E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.62630428E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20214929E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-422212.12",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "402217.38",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "956.57812",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-259.87646",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "71.522934",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03097053",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258345",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-712.49341",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1271.2229",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1403.8979",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "217.31372",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.61379466E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.68948860E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1894.998",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1952.4102",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-303339.88",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640953.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "957.07812",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-259.87646",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.511063",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.21126",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.60968",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.33047",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.67493",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006436687",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02867478",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.187696",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.59253",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56614642E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86027846E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56614642E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86027846E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006436687",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02867478",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.76040646E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89962554E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.76040646E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89962554E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02349142",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.866138",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05464086",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.974693",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.652863",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.697861",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-36.511963",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.656052",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "6.38755182E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03599031",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.4285",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "338.22174",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.31429",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "328.04449",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "186.32411",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.13101",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03662163",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "99.291595",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8488.8477",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-791.06226",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.7812",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-385.65381",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.758057",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1358.3125",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2090.0466",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.0312",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-385.65381",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.758057",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-91.915817",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00730896",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.28394",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.885498",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4157152",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5010948",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1229877",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.8334026",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.37862",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.51859",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.40221",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "346.85797",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25349220E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-672.18018",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7061005",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.41916369E-07",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.898438",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48063.598",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112320.77",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.10061749E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57855470E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.48676946E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27360681E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-460674.94",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "447810.5",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "962.35938",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-251.29413",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "78.624847",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03128931",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258339",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-691.68579",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1266.364",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1817.1418",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "187.29541",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.26624194E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.48960929E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1664.4263",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2057.3962",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-319260.94",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "667324.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "962.35938",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-251.29413",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "57.703751",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.94717",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.58975",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.10814",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.37988",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004193403",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02849529",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.707903",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.96335",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52892408E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84982764E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52892408E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84982764E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004193403",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02849529",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01980993E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95156576E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01980993E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95156576E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02728722",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.524326",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04021002",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.077335",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.906662",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.090927",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.462799",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.81723",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "5.76827830E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03748075",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.2588",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.38382",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.01691",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.16156",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.10664",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "332.08679",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03454624",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "92.972328",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8485.6172",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-795.8833",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1167.4688",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.7981",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.715332",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1509.2568",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2439.198",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.5",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.7981",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.669678",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.23877",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007125854",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.04639",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.301758",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.9568882",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2337523",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.956151",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.133872",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.65273",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.15845",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.42952",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "346.13611",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63710229E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-679.14038",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.653183",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16118463E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.677246",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47914.293",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112281.77",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.41451770E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.65587310E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.89975060E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.93852012E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30984006E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-449687.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "414466.75",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "962.71875",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.07983",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "74.579498",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03172308",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25839",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.20337",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "867.9856",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1249.7642",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "197.354",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.99745738E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.89167984E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2028.6104",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2173.5591",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267116.56",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "610550.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "962.71875",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.07983",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.785843",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.11458",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.19702",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.36086",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.96527",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003774062",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.03024249",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.778475",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.77933",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54851605E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84542514E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54851605E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84542514E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003774062",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03024249",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.34326603E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.36664437E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.34326603E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.36664437E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02468137",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "37.961048",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06419575",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "38.818699",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.9496",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "30.2798",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-37.79332",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.615738",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "4.75445958E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03868366",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.45695",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.07739",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.25462",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "324.8783",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "185.28709",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "329.67303",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03967568",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.681038",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8536.1211",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-792.39087",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1165.375",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.84497",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.137695",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1337.9277",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2295.709",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.9375",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.84497",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.132324",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.377945",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008178711",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.89233",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-61.164062",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3972616",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.406249",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3066654",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.6588364",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.40698",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.49475",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.42432",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "344.92395",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24526218E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-674.01807",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10801193E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "14.291992",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47870.531",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112078.33",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.48988441E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "2.04066191E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.06161469E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29629620E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-457113.94",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "456532.12",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "958.07812",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-271.03955",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "74.535034",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0304957",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258425",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-765.00415",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "948.45386",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1350.5786",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "214.05054",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.40058579E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.55951612E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1771.8076",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2010.3059",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-246647.12",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "661345.81",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.07812",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-271.03955",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.075851",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.40128",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.98193",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.32732",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.74957",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00405455",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.03103255",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.782812",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.5701",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52806042E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85661520E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.52806042E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85661520E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.00405455",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03103255",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89864681E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02901037E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.89864681E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02901037E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03035295",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.415199",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06583965",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.258583",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.595108",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "28.594406",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.920013",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.213257",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "5.84143258E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03745958",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.89082",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "335.42145",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.77397",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "328.23154",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.80574",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.53262",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03986086",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.098343",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8478.4453",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.95117",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1169.6562",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.19971",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.198242",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1399.175",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2101.4019",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.8125",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.19971",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.87793",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.00177",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008071899",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-726.61743",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.437988",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0222797",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "3.4908724",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4267273",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4539833",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.46384",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.38403",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.49869",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "342.61572",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30373417E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-659.44922",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7121277",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28766987E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.144043",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48256.691",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112042.78",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15578632E-06",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.79624976E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24460951E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-433574.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "420283.5",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "954.23438",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-261.94214",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "67.469452",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03052833",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258522",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-813.79443",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "946.24951",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1319.729",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "179.0061",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.27722705E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.15809563E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1480.8188",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2096.3506",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-282038.5",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "604019.38",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "954.23438",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.02295",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.118912",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.19858",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.21832",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.45404",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.72217",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004520874",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02848241",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.642534",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.62534",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59723095E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78233477E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59723095E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78233477E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004520874",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02848241",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07345693E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90273704E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07345693E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90273704E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03372372",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.065807",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06449276",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.953785",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.385315",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "29.905869",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.08905",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.067612",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "4.87873102E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03388352",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.94518",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.20547",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.66045",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.96631",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.68791",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "330.02917",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03786167",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "97.287643",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8530.7656",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-790.28857",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.3438",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.09033",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.74707",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1421.4189",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2225.7253",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.1562",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.09033",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.536133",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-90.931427",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007843018",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.87671",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.532227",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1326551",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4378614",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1536942",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4449205",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.49667",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.8299",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.42809",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "342.13226",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10327426E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-656.47339",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04727224E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.491211",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48214.629",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112317.35",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.90667093E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48890956E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.80700392E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29714806E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-430105.06",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "436007.94",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "956.03125",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-235.94325",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "82.075119",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03086038",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258392",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-679.69556",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "816.79736",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1205.4666",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "223.13477",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.82032306E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.92253524E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1585.3386",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2137.6799",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-264945.31",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "641653.88",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "962.98438",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-235.94325",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.348602",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.1848",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.21265",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.21817",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "312.31586",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005474087",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02996165",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.193384",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.50482",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.62098095E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78219161E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.62098095E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78219161E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005474087",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02996165",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97522195E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94389122E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97522195E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94389122E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0275285",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.806828",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06128158",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.495686",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.304184",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "29.862473",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.741913",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.277878",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "7.21244078E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03650028",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.42236",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.349",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.34512",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "328.67679",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.35735",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.51392",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04556333",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "95.86647",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8529.5508",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-785.75024",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.4688",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.72192",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.494385",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1342.8621",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2273.0322",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1170.75",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.72192",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.494385",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-92.479797",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007583618",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.86353",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.5354",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6326027",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.553997",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.4827881",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1418705",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.09326",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.03436",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.04968",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.41058",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27862438E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-672.26172",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05387880E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "14.861084",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48014.5",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112210.28",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.75296747E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "2.26006773E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.17455236E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26880389E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-475545.06",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "443754.75",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "951.5",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-257.34106",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "68.834854",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02941597",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25844",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.72021",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "901.37036",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1306.8853",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "228.04565",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.22586788E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.11913958E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2049.4016",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2231.2192",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-311947.69",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "667745.0",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "951.95312",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-257.34106",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.758163",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.3501",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89352",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.52635",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.14706",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004094619",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02982617",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.936815",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68439",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55037869E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76840695E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55037869E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76840695E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004094619",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02982617",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05910283E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06992672E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.05910283E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06992672E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03211577",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.583099",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05846403",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.984417",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.520782",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.549469",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.984283",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.81427",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.03090940E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03796224",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.07095",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.36133",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.95821",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.3772",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "186.97447",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.10886",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03946501",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.244057",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.3984",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-798.59424",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.375",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-390.84619",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.28125",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1417.6899",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2010.2136",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.1562",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-390.84619",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.175781",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-93.151627",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007461548",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-721.42065",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.406494",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0120573",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2581549",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.8625288",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.0697708",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.47551",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "337.65045",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.17026",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.99701",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48172546E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-675.35474",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23167410E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.03125",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47771.461",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112381.05",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.37708797E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.61575656E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33984372E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-449009.62",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "486040.94",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "956.92188",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-257.95166",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "63.92482",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03169377",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258411",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-835.37451",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1454.0613",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1973.7498",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "203.56201",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.89247338E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.13997758E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1539.1055",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2196.8743",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-284963.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "625483.5",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.26562",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-257.95166",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.545792",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.17929",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06061",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.35159",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.16663",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005022191",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02848013",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.660582",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "411.09247",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56522365E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84024411E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.56522365E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84024411E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005022191",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02848013",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97502004E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10091252E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97502004E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10091252E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03075261",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.957668",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04640088",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.862194",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.459305",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "30.08522",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.931458",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.619568",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "6.11228188E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03508683",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.95264",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "337.54022",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.93518",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "325.53171",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.97057",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "330.57944",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.02790486",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "93.454247",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8541.2773",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-798.08691",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1168.4688",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-390.34521",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.569824",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1530.4475",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2221.5051",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.2188",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-390.34521",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.351074",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-101.36821",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008010864",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.96826",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.054443",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.5659208",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3817139",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.7984362",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9789743",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.49701",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.96753",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.43521",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "344.33905",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32296202E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-670.58154",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05888466E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "13.835938",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48076.695",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112283.86",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.81518202E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.86819807E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15187879E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-425731.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "419854.5",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "956.14062",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-272.87329",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "75.50737",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02998104",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-889.17603",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1210.2905",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1684.4824",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "230.21509",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.73577404E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.20594232E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1768.2485",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2030.8669",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-257374.56",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "612761.0",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "956.14062",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-272.87329",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.273178",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.9133",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59103",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "208.94388",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.16547",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004389994",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02942115",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.595963",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.74515",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53767196E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82277727E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.53767196E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82277727E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004389994",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02942115",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.08532742E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84237956E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.08532742E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84237956E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.024478",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.736923",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03718889",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.81982",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.357208",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "30.228836",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.767227",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.893677",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "6.30323598E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03339818",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "185.29434",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "334.099",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.98732",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "324.21036",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "185.10107",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "332.32501",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04735892",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "96.826797",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8457.4062",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.05688",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.4375",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.7644",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-82.271484",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1418.4175",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2268.6533",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.35425",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.037109",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.507538",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008331299",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.33057",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.012207",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.6545467",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1512632",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5396423",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.3088713",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "188.92543",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "337.45038",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "188.96207",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.51578",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24964072E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-673.51343",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24980579E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "13.029785",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47960.867",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112617.78",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82326093E-28",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36270408E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.94208747E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18581636E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-404985.31",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "425012.44",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "960.32812",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-244.75447",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "76.238235",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02943688",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-689.59595",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1018.3806",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1317.4307",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "214.00928",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.26803660E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.55787334E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1966.5977",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2132.5442",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-288054.94",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "634379.19",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "966.39062",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-244.75447",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.026367",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28357",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06317",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.59711",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.71899",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005288836",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02923275",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.834442",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.7883",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.58221246E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85299468E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.58221246E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85299468E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005288836",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02923275",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98134171E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78337268E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98134171E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78337268E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03379675",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.231201",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05188012",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.30534",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.498413",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "27.942978",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.470337",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.90799",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.23142513E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03779818",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "192.36551",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.03732",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "192.13",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "326.70844",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "192.20209",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.03806",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03037759",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "93.989586",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8478.2812",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-798.30054",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.25",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.58057",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.218506",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1632.0957",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1986.1709",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0938",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.58057",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.031006",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.250977",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00718689",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-722.61816",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.326904",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1258144",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1693859",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3634157",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2395935",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.63309",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "337.88077",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.55795",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.30457",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13500789E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-659.59375",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6533661",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13502028E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.736816",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "47817.801",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112307.97",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.42194004E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71189345E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24577275E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-404467.94",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "416558.69",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "954.84375",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-249.50372",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "77.453506",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03065661",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-670.75562",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1042.2231",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1415.5071",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "225.88721",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.66021697E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.03252442E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2008.1008",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1905.9158",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-277944.5",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "644384.56",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "957.4375",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-252.09312",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.080215",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.21352",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.37201",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.51801",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.17645",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004858416",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02794872",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.19174",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.59082",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55749549E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89366419E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.55749549E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89366419E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004858416",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02794872",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98488283E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00111958E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98488283E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00111958E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02233689",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.003311",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06305349",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.244823",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.489975",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "29.662384",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.211105",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.953445",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8.81896085E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03798794",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.80495",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "333.82703",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "186.69354",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "326.5051",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "186.71254",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "329.07892",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04460085",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "94.728592",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8460.1328",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-795.19702",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1170.1562",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.09473",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.698975",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1536.4441",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2085.9365",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.79443",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.617432",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.371857",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007675171",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.49512",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.859863",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2184849",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2196503",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4254036",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3811483",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.80585",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.24445",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "184.82579",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "345.54321",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30763908E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-669.40479",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7183075",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11825648E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "13.671387",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48290.391",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112037.77",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.21416200E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63204152E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.26490257E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47213234E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-418041.06",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "472162.31",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "967.0",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-249.47539",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "67.026917",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03060802",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-773.71729",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1009.9177",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1571.0674",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "221.88428",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.28225848E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "8.87284273E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1632.7871",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2124.6851",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-285869.5",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "650895.19",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.0",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-249.58063",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.402328",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.30602",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.25134",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.54018",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.07196",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004514355",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02897147",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-19.916977",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.65262",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54135669E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78543578E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.54135669E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78543578E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004514355",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02897147",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.77023583E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89567072E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.77023583E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89567072E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02683543",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.855598",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04591892",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "37.411209",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.767365",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "33.678421",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-36.02594",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "36.526001",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "9.62239710E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03847663",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.9809",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "337.12085",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.86089",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.47968",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "187.88721",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "334.44263",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05099776",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "92.78302",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8488.1445",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-794.8584",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1170.0312",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-402.04858",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.779785",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1522.9062",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1965.9751",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.6875",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-402.04858",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.75708",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-87.997391",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006896973",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-725.87524",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.962158",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1109447",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8721189",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3782167",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2655382",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "185.57251",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.39404",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "185.47243",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "339.73727",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26582438E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-666.59302",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "9.80828190E-07",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "14.756348",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48017.098",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112248.42",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.41451770E-33",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.25622556E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49960204E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33994979E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-414255.88",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "443377.38",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "953.07812",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-242.38116",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "73.960724",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02969067",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258461",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.97046",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "919.76587",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1468.3555",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "193.73511",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.87154318E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.74684565E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1680.3191",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2261.3582",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-312832.62",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "620592.19",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.20312",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-242.38116",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "47.018692",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.87376",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "309.9718",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.0172",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "313.8479",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.009553272",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.03130891",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.342131",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.54523",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59529482E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82382864E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.59529482E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82382864E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.009553272",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03130891",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.93287065E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93998335E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.93287065E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93998335E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02568195",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.501205",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05252441",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.294491",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.176346",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "28.469513",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.343338",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "31.816833",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "6.67977815E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03913074",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.877",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "338.68451",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.61578",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "327.33725",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "188.62892",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "331.63998",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.031842",
                                            "PDS_TimeRange": "10",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "90.747383",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "8554.2148",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-798.0957",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "1166.625",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-389.38965",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.401611",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1549.9521",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2268.6179",
                                                    "gribparam": "105",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1171.4375",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-389.38965",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-70.909424",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "PDS_TimeRange": "10",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.832642",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006835938",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.15356",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.682617",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.4762583",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4076471",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0781145",
                                            "PDS_TimeRange": "10",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9482613",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.0865",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "338.99292",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "181.009",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "343.67639",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16906222E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-674.78687",
                                            "PDS_TimeRange": "10",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6894531",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13516580E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "15.42334",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "48144.441",
                                            "PDS_TimeRange": "10",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "112634.56",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.05861028E-27",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "7.54752136E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75525054E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.44560339E-23",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14490899E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-474558.75",
                                            "PDS_TimeRange": "10",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "444099.38",
                                            "gribparam": "108",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "950.71875",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PTVersion": "128",
                                                "gribNumBits": "16",
                                                "scale_min": "-255.80688",
                                                "PDS_TimeRange": "10",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "subcenter": "255",
                                                "gribleveltype": "1",
                                                "scale_max": "74.236847",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "PDS_TimeRange": "10",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03164991",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258427",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.05981",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "919.67578",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1319.0059",
                                            "PDS_TimeRange": "10",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "265.61133",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.27433542E-07",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06216703E-07",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1987.8435",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2027.675",
                                                    "gribparam": "106",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-287134.69",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627187.5",
                                                    "gribparam": "107",
                                                    "process": "50"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "951.64062",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PTVersion": "128",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-258.22363",
                                                    "PDS_TimeRange": "10",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "subcenter": "255",
                                                    "gribleveltype": "1",
                                                    "scale_max": "23.628632",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "210.43903",
                                            "PDS_TimeRange": "10",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06793",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "209.41856",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "subcenter": "255",
                                            "gribleveltype": "111",
                                            "scale_max": "314.0722",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004161038",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02773672",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-20.019855",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "410.46512",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.62246179E-05",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77880902E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.62246179E-05",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77880902E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst aug2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004161038",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02773672",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01595776E-06",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00633121E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.01595776E-06",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00633121E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03241843",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "wind10",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.546986",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05048259",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "35.970886",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.388947",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "32.409546",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.147293",
                                            "PDS_TimeRange": "10",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "34.666443",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "3.32169989E-08",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03639423",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "184.02078",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmx",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "336.38208",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "183.09006",
                                            "PDS_TimeRange": "10",
                                            "grib_name": "t2mmn",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "321.77676",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "16",
                                            "scale_min": "183.20528",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "subcenter": "255",
                                            "gribleveltype": "105",
                                            "scale_max": "332.29727",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PTVersion": "128",
                                            "gribNumBits": "24",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "333.75"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "30.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/aug2001"
                        },
                        "dec2001": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/dec2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "dec2001",
                            "restriction": "Public",
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "mem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem24year0": "200203",
                                    "mem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem24/.griblist.html",
                                    "mem24filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc24_%6d.01",
                                    "mem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem23year0": "200203",
                                    "mem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem23/.griblist.html",
                                    "mem23filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc23_%6d.01",
                                    "mem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem22year0": "200203",
                                    "mem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem22/.griblist.html",
                                    "mem22filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc22_%6d.01",
                                    "mem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem21year0": "200203",
                                    "mem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem21/.griblist.html",
                                    "mem21filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc21_%6d.01",
                                    "mem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem20year0": "200203",
                                    "mem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem20/.griblist.html",
                                    "mem20filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc20_%6d.01",
                                    "mem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem19year0": "200203",
                                    "mem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem19/.griblist.html",
                                    "mem19filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc19_%6d.01",
                                    "mem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem18year0": "200203",
                                    "mem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem18/.griblist.html",
                                    "mem18filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc18_%6d.01",
                                    "mem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem17year0": "200203",
                                    "mem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem17/.griblist.html",
                                    "mem17filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc17_%6d.01",
                                    "mem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem16year0": "200203",
                                    "mem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem16/.griblist.html",
                                    "mem16filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc16_%6d.01",
                                    "mem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem15year0": "200203",
                                    "mem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem15/.griblist.html",
                                    "mem15filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc15_%6d.01",
                                    "mem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem14year0": "200203",
                                    "mem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem14/.griblist.html",
                                    "mem14filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc14_%6d.01",
                                    "mem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem13year0": "200203",
                                    "mem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem13/.griblist.html",
                                    "mem13filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc13_%6d.01",
                                    "mem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem12year0": "200203",
                                    "mem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem12/.griblist.html",
                                    "mem12filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc12_%6d.01",
                                    "mem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem11year0": "200203",
                                    "mem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem11/.griblist.html",
                                    "mem11filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc11_%6d.01",
                                    "mem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem10year0": "200203",
                                    "mem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem10/.griblist.html",
                                    "mem10filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc10_%6d.01",
                                    "mem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem09year0": "200203",
                                    "mem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem09/.griblist.html",
                                    "mem09filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc09_%6d.01",
                                    "mem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem08year0": "200203",
                                    "mem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem08/.griblist.html",
                                    "mem08filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc08_%6d.01",
                                    "mem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem07year0": "200203",
                                    "mem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem07/.griblist.html",
                                    "mem07filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc07_%6d.01",
                                    "mem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem06year0": "200203",
                                    "mem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem06/.griblist.html",
                                    "mem06filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc06_%6d.01",
                                    "mem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem05year0": "200203",
                                    "mem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem05/.griblist.html",
                                    "mem05filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc05_%6d.01",
                                    "mem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem04year0": "200203",
                                    "mem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem04/.griblist.html",
                                    "mem04filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc04_%6d.01",
                                    "mem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem03year0": "200203",
                                    "mem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem03/.griblist.html",
                                    "mem03filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc03_%6d.01",
                                    "mem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem02year0": "200203",
                                    "mem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem02/.griblist.html",
                                    "mem02filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc02_%6d.01",
                                    "mem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                    "mem01year0": "200203",
                                    "mem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.dec2001/.SIX-HOURLY/.mem01/.griblist.html",
                                    "mem01filepattern": "/mstore/iri/forecast/data/echam4/psst/dec01/20004fc01_%6d.01",
                                    "Conventions": "IRIDL"
                                },
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06567878",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "83.696877",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8519.2969",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.86792",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.60229",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.499512",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1647.4707",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2453.8953",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.60229",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.69043",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-76.599457",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1193085",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-745.14404",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-79.763428",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5907736",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8712015",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.6617193",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3971872",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.74966",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.84174",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.73351",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.5163",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16986666E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.01782",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49496394E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.47876",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47343.641",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111899.92",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.69663722E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.88662079E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26429188E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-430912.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "443893.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.20312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-266.56885",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "47.527313",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03091175",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258451",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.79443",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "908.56836",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1064.802",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "254.64087",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.25784464E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01822934E-07",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1883.5479",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1971.9771",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-368644.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "614434.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.20312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-266.56885",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "9.352356",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.13892",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.87164",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.11893",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.39761",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.73351",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "343.00848",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.29054",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.04819",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005691011",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02594875",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.251955",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.32965",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.32589512E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73479475E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.32589512E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73479475E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005691011",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02594875",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.98514135E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05865967E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.98514135E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05865967E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02731489",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.941608",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05600873",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.520817",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.796005",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.068283",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.324585",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.009048",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.44065961E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03552589",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "197.48055",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "326.42322",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.8187",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.3512",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.00522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.35266",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04848596",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "81.824203",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8519.8008",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.59424",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-395.20923",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.148438",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1812.6277",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2035.2205",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-395.20923",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.723633",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.947968",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1188965",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-721.06592",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.456055",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1174145",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2303982",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7316198",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7036724",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.48094",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.83533",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.37372",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.85281",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33126434E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.86768",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.38989911E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.630859",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47105.18",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111940.19",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.88839634E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65708923E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50856579E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-452256.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "467993.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-269.979",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "49.804443",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02991025",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.38379",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "967.53345",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-974.03223",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "163.90088",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.89488235E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.55415988E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2001.5261",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1794.8379",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-313279.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "617884.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.39062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-269.979",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.203918",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.43837",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.12231",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.74052",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.46375",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.37372",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.56375",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.59476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.09341",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006170344",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02688652",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.471905",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.15979",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.06076086E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76626781E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.06076086E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76626781E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006170344",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02688652",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.75886305E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81562405E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.75886305E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81562405E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03303315",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.744637",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05013348",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.223057",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.2789",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.145844",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.314346",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.948868",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.95057861E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03346029",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.8165",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.43286",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.9464",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.14099",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.95018",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.73938",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07574916",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "83.534569",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.4453",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.35034",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.02881",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.081543",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1649.7563",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1861.74",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.02881",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-93.817871",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-74.510757",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1194",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-728.58984",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-82.14624",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.8738461",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "6.572011",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4262781",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6663561",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.1667",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.96921",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.09189",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.57425",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26367502E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-705.33081",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.51214281E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.45459",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47344.055",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111948.04",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.73477893E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59649358E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.53394918E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37147379E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-405831.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "418448.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "973.4375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-289.5083",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "48.728027",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03170276",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.35864",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1027.6135",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1165.8025",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "203.98633",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.66171798E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.15658154E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1492.0798",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2014.5042",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-297918.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "638189.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-289.5083",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2.6978302",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.40498",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.77203",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.38544",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.00146",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.09189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.47736",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.71509",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.61041",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006722998",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02715011",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.770016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.29755",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.10891142E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70983512E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.10891142E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70983512E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006722998",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02715011",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89341574E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16271815E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89341574E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16271815E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02976642",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.811913",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04372048",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.637432",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.873627",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "28.122147",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.731537",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.267395",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.52759831E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03486227",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.56963",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "323.96701",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "197.94551",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "317.59686",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.98074",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.09698",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05535708",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "82.991821",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.4023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.07959",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-395.69287",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-80.970459",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1749.6206",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1609.5879",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.2188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-395.69287",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.142822",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-70.43045",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1193848",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-714.71313",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-80.27417",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0099077",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.945159",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7346087",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4897776",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.98645",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.63721",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.66368",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "344.03531",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63761581E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-691.7063",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.02290742E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.51416",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47147.93",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111690.02",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.77932707E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.13814290E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66574910E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50699395E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-408088.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "541537.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "975.90625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-288.29858",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "51.960556",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0307323",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258387",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-733.15723",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "858.21655",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1081.791",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "224.26392",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.32577963E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.96749555E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1771.0681",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1757.7444",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-338834.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "582662.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.90625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-288.29858",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "0.6347198",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.90964",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29315",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.26495",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.61908",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.66368",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "340.4108",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.98009",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.83887",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003987942",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02645896",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.779913",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.27026",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.17345289E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80809202E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.17345289E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80809202E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003987942",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02645896",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86817249E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89305570E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86817249E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89305570E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03354803",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.499413",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04304955",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.281479",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.633957",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.932388",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.957047",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.386795",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.68961582E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03414906",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "197.40677",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "328.58615",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.69516",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.37515",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.75877",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.75424",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.08144546",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "84.314056",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8532.0469",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-813.85913",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-380.8916",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.527588",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1649.7756",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1879.1406",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.66406",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-94.258789",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-75.508102",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1196289",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.21973",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-76.736816",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9219275",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.215312",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7869091",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0398092",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.9269",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.32422",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.90327",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.2157",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31695890E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-704.66162",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68777682E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.230469",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47414.801",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112059.08",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.75361775E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58764124E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37646862E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-402117.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "439774.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.17188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-278.23193",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "47.782837",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03129779",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25844",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.75562",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "960.00684",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-999.05005",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "167.85425",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.99492166E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.71227554E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1826.7903",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1839.1328",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-308955.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591917.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.17188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-284.50269",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-1.6499176",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.3855",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.98355",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "204.06854",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.34991",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.90327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.13562",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.98683",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.88025",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003725442",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02711187",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.501463",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.2865",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03301545E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87862588E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03301545E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87862588E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003725442",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02711187",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88799174E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.12457576E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88799174E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.12457576E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03054387",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "36.151905",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05504653",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.312412",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.255951",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.483276",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.639694",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.247025",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.76084346E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03523743",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.10417",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.0983",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.87181",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.85071",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.87181",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.27472",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05820398",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "80.92276",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.8008",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.42334",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.94824",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.831299",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1777.9346",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1953.3704",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-387.94824",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.854004",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-73.759033",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1191101",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.29492",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.020508",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2805023",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.63132",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.566925",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3878965",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.87308",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.61664",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.81001",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.62598",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16730860E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.01074",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "6.71265298E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.5979",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47093.922",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111652.36",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.58637350E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64439780E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20236950E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-407093.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "497050.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "970.0625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.50708",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "40.491852",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02976187",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-712.97729",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1319.0945",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1370.4417",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "172.19165",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.48001253E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.88537227E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1724.0498",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2265.0159",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-328715.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "578359.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-261.06323",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1.3429108",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.32436",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.22723",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.67477",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.56549",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.81001",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "343.60059",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.59361",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82495",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004190166",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02667379",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.675856",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.00717",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.07267069E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71652191E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.07267069E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71652191E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004190166",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02667379",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88279159E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88208037E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88279159E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88208037E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03217102",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.787472",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0517914",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.311905",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.20311",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.358704",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.99205",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.187119",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.65790970E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03312947",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.49763",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.66135",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.91971",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.55988",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.94217",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.56946",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06206062",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "79.882858",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.0078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.63013",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-385.16504",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.730225",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2076.9307",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1563.4309",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-385.16504",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.150146",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-75.139175",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1194458",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-717.46606",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-76.355469",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.1158295",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5954151",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0527639",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5226326",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.60065",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.68518",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.63002",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.88727",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21562118E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.90942",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.34784408E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.307617",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47249.934",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111984.56",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.30957311E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59732247E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18285664E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-395491.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "436788.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.5",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-263.89502",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "47.048477",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03068788",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258547",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-840.07935",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1042.9204",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1065.3149",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "169.81738",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.25989612E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.79036134E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1593.2585",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1956.3948",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-302619.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "601824.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.5",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.9082",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-7.7585449",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.21046",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.49371",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.42162",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.24286",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.63002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.36969",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.52245",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.31604",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006017931",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02581721",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.619442",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.41043",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03076372E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71684151E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03076372E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.71684151E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006017931",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02581721",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83261750E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92998846E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83261750E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92998846E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02253414",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.877281",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05427819",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.92112",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.920929",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.474487",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.387283",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.339386",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.10265227E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03610428",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.13255",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.57397",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.84581",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "317.01901",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.02272",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.75562",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06839019",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "80.321785",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.5938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.37451",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-392.50586",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.905518",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1798.7065",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1678.7727",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.50586",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-92.547852",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-72.375076",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1197662",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.86206",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-83.769043",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.5170298",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1002655",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.5405226",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "8.2870636",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.20293",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.03677",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.21939",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.07605",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09997643E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.28271",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.44039426E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.902588",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47276.246",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111915.11",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.56926966E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.88713148E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18518710E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-443789.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "397004.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "975.64062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-292.07739",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "47.333847",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0309066",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-709.63184",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1144.334",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1330.1755",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "181.05542",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.31899957E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.23966878E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1640.5959",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1808.8274",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382744.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "612337.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.64062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-292.07739",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-0.6269836",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.00266",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.63971",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.01048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.14764",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.21939",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.2132",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.1756",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.66095",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00408205",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02828454",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.52396",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.12524",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16338952E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72532600E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16338952E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72532600E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00408205",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02828454",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.05807896E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76783453E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.05807896E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76783453E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02331003",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.339481",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05277607",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.583759",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.468307",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.422882",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.643188",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.804825",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.99712735E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03505042",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.39296",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "324.97806",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "197.41579",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.66229",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.79001",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.1153",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07517099",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "79.479088",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8530.9531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-801.20581",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-381.36963",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.915771",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1859.887",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1705.6323",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-381.36963",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-92.684326",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-77.167755",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1196442",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-715.57422",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.328125",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5000982",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6877327",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.0038328",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7973671",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.93527",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "335.07349",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.83771",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "344.05725",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47073104E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.46948",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.96047971E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.47998",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47368.883",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111838.89",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.50004540E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.78750349E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35043058E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-392167.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "461889.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.95312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-262.85327",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "46.225967",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03023051",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258503",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-751.10962",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "964.50244",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1013.449",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "189.54053",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.05249835E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57904672E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1858.7507",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2349.8169",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-335972.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "639934.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.33911",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "12.090622",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.9265",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.3844",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.28253",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.75836",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.83771",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "340.04358",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.12224",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "312.99054",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005065624",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02618458",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.661837",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.34103",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16983565E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62524266E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16983565E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62524266E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005065624",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02618458",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90654418E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00597492E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90654418E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00597492E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02675005",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "37.286324",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06164193",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "40.807304",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.347702",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.309235",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.575089",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "39.284714",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.66128132E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03821049",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.76033",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "323.59796",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.34312",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "317.62695",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.48953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.19141",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04354754",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "81.713844",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.9102",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.50293",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.55176",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.848389",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1722.7947",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1620.425",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.2188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.55176",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-83.493408",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.678955",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1198273",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.64771",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.79126",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.5529232",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3843536",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.5947409",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "8.8722048",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.44035",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.71429",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.53122",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.12793",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12723660E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.34668",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04148057E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.080078",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47476.051",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112074.95",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.63548280E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62845208E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33091589E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-393021.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "446098.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "970.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-282.48853",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "64.581787",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03063181",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258427",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.46704",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1060.3601",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1111.2292",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "196.50732",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.44349496E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.85791485E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1633.8684",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1880.3647",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-330235.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "595162.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.75",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-282.67432",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "10.485855",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.07607",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.76157",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.57443",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.54492",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.53122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.85449",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.12648",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.70123",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002794672",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02711447",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.346884",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.04135",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.06320722E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68231145E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.06320722E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68231145E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002794672",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02711447",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.19453386E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86365310E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.19453386E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86365310E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02013835",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.670322",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03816917",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.588081",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.067612",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "35.087967",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.288986",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.478439",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.38320740E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03937183",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.33049",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "323.16498",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.97353",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.06961",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.12912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "322.30875",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03557465",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "83.847015",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8547.0703",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-811.70532",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.28345",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.326416",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1756.5884",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2072.6943",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.28345",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.469971",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-77.928238",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1197205",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.80664",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.079102",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3978472",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6390781",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.9531527",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2369442",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.69171",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.84711",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.21538",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.80951",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19547019E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.5896",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.62666639E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.297607",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47417.344",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112297.41",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.44499539E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63973016E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40220118E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-440935.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "431270.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "972.29688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-281.46851",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "53.213776",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03072148",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-705.0",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "942.94043",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-993.0542",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "181.27954",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.97094595E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.24858182E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1960.2214",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2151.1919",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-267654.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615940.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.32812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-281.73438",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2.7176971",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28224",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.62225",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.25751",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.74164",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.21538",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "343.75446",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.56404",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.47601",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005407352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02754068",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.986704",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.23679",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.95317714E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72165146E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.95317714E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72165146E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005407352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02754068",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.80698180E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03343507E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.80698180E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03343507E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0324342",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.436829",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05450123",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.566345",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.689911",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.380325",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.716187",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.068375",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.05908168E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03741221",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.79021",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "327.25781",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.8551",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.51071",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.8551",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.10669",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05610841",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "83.732727",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8530.3672",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-810.19019",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.70264",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.800781",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1633.4292",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1994.0195",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.70264",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.622314",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-73.572769",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1195526",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-728.54883",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-77.676025",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6184111",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3442459",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.681654",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.443325",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.48602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.26917",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.45145",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.14484",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20859670E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-692.78662",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.63772584E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.882324",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46772.32",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111601.38",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.34903495E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59416754E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22361712E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-383410.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "485020.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "972.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.62646",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "50.032593",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02996168",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258469",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-730.20337",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "931.87354",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-972.83398",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "182.01416",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.89009074E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.27811482E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1998.8901",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1870.2095",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-342427.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "563703.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.62646",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "19.363953",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.81615",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.60306",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.65251",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.41711",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.45145",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.98077",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.03796",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.35034",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003306088",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0266685",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.927996",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.19016",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08649847E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76964822E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08649847E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76964822E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003306088",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0266685",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93798451E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96081874E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93798451E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96081874E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02809997",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "38.668488",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06411833",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "39.998291",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.685394",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "35.576279",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-39.316528",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.068756",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.51105267E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03948136",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.01282",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.27271",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.3325",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.50977",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.37956",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "321.36841",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06255227",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "79.252037",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8551.2266",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-800.8103",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-386.27637",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.893799",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1878.9792",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1681.3674",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-386.27637",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-87.651855",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-71.25853",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1191254",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.37549",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-75.796143",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0737152",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4478254",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.9342966",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.6161156",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.17546",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.97964",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.89238",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.22626",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23515633E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.75391",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.34625098E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.751465",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46739.148",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111815.24",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.36165804E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.84232852E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.26804421E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30602973E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-413574.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "470132.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.54688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-286.80884",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "54.102921",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0290327",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-774.96118",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1221.5122",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1251.6296",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "232.98633",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.00491694E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.31643171E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1674.3691",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1898.469",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-316551.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "595603.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "977.875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-286.80884",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "10.811264",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.03743",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.31845",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.63036",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.61493",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.89238",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.61459",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.12932",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.43185",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003523477",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02598206",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.381657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.35831",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20638006E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78194678E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20638006E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78194678E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003523477",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02598206",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.36602568E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09966765E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.36602568E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09966765E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02764728",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.892014",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05224649",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.008244",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.160522",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.724945",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.317245",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.634506",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.17088222E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03397909",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.61411",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.2691",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.01292",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.09045",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.13516",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "322.28448",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04832854",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "79.596535",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.1523",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-799.89697",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-385.50684",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.206787",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1978.5134",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1604.4968",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-385.50684",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.664062",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-74.62442",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1194916",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-756.25635",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-76.654053",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1299791",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.128233",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3981619",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1908712",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.91766",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.76276",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.09308",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "350.49249",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15873718E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.84424",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.44897989E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.364014",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47113.59",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111607.44",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.99380859E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52783844E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17268371E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-439917.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "456561.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "979.54688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-262.82275",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "41.368988",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02875938",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258493",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-743.42627",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1078.5762",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1319.0969",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "168.70557",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.27469979E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.74619400E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1453.1594",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1794.855",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-420790.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "584688.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.98438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-262.87524",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "3.0463104",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.57072",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.86868",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "202.54478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.35901",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.09308",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "346.01025",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.8447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.64893",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006151654",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02652477",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.419189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.26855",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.13041133E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76593549E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.13041133E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.76593549E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006151654",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02652477",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89904938E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98411385E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89904938E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98411385E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03095812",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.437065",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0576563",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.43605",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.359634",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.683487",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.267899",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.284378",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.57232340E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0407531",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.56154",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "330.79932",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.1039",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.36176",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.10098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "325.95905",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.08098119",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "81.1203",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.8828",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.34399",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-392.32788",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.525635",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1744.3752",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1906.2798",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.32788",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-99.38623",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-74.670731",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1197662",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-739.72461",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-82.40918",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2596693",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2608213",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.3893309",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1436272",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.39844",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.98834",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.30258",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.18329",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11549775E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.33276",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60846888E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.166504",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46958.734",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111635.26",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57965665E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67248004E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.35274736E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25399276E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-463723.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "448869.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "968.48438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-267.67285",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "48.486954",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02959259",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258539",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-903.37134",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "984.97852",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-993.46948",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "198.05151",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.75244298E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.91976333E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1623.1101",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1868.7432",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271636.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "583412.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.48438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-267.67285",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "6.4957428",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.29167",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.20758",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "206.93835",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.85828",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.30258",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "343.10162",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.66847",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.67462",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007234965",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02790737",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-22.018982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.77298",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.13701517E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62583710E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.13701517E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.62583710E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007234965",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02790737",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.11471365E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92032462E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.11471365E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92032462E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0277233",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "32.705048",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04740088",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "34.225979",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.198822",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.911942",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.708496",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.165848",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.32096670E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03632745",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.38591",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.79724",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.04883",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.20435",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.07397",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.46185",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05539581",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "84.794456",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8504.3516",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-814.6604",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-407.38525",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.716797",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1611.1384",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1871.4939",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-408.37305",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.202148",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-78.401215",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1188965",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-743.61865",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.740967",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.883728",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9141817",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2610817",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0894175",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.00941",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "340.70599",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.47498",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "349.80249",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39205952E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.60449",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "6.06378308E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.630615",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47446.816",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111691.12",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.67919289E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.78691380E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45211607E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-406914.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "452624.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "977.40625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-288.69165",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "35.864502",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03201964",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258446",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.0647",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1213.0825",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1291.2688",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "161.53027",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.16342254E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.45912905E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1532.2927",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1764.6619",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-295299.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "596487.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "977.40625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-288.71533",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-2.8978119",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.16409",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.49561",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.59271",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "319.67255",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.47498",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "345.47827",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.22108",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.32269",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002642032",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02657205",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.936071",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.27408",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.19983797E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68979695E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.19983797E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.68979695E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002642032",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02657205",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87880948E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08358074E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87880948E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08358074E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03128627",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.964989",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06039276",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.443504",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-27.32872",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.46312",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.799179",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.783218",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.83114503E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03424845",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.69614",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.86572",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.08612",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "320.13037",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.92986",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.80109",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05020135",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "81.869797",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.625",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.4021",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-381.42847",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-79.457764",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1965.7754",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1815.7422",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-381.42847",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.321777",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-71.072769",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1191559",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-741.08447",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-80.432617",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4352064",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2339973",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8819361",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0566006",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.17079",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.10718",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.73886",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "348.2373",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04670607E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.48901",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.98841938E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.942627",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47341.047",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112079.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.32340084E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72975695E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39685994E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-438231.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "431538.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "973.57812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-273.38477",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "48.336502",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03103697",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-737.96509",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1041.6252",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1125.5049",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "175.77222",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.50057883E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.02881380E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1805.5947",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2457.2051",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-296135.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "577642.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.57812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-273.52344",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "10.623398",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.26599",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.09372",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.13902",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.56726",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.73886",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "344.00098",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.36327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.24713",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003346147",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02667793",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-22.133425",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.18292",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.07227752E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.69489540E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.07227752E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.69489540E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003346147",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02667793",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93824962E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82496569E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93824962E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82496569E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03272222",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.751701",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06426382",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.285614",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.87706",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.500687",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.100235",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "38.249176",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.49083962E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03465282",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.60709",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.63528",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.97099",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.84631",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.23203",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.53119",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04705194",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "84.325012",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8532.6797",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.29932",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-375.86475",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.235107",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1798.5952",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2007.2388",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-375.86475",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.717285",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-74.158798",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1194458",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.41895",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.385986",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.5983839",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8462772",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.3316908",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3929825",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.26134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.82788",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.58879",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.62372",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09597590E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.09814",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.20233254E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.094238",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46999.855",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111733.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49914477E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "2.07052426E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21911967E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-404882.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "428887.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "975.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-247.8895",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "42.199463",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02825488",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258389",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-715.63184",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1271.717",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1320.3171",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "208.99194",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.27957809E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.35680396E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1391.7834",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1761.167",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-385869.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "582394.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-251.158",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "5.4955139",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.2549",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.04468",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "203.90005",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.15875",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.58879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.46753",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.92303",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005360827",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02617344",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.463587",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.44705",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03091115E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75062360E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.03091115E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75062360E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005360827",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02617344",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86478587E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81173925E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86478587E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81173925E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0320017",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.881279",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0574524",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.623367",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.05098",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.933258",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.401611",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.419937",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.21861364E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03441547",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.98497",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "327.57495",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.90889",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.21283",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.27084",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.45166",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06078886",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "85.504791",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8528.5586",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.78979",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-385.36719",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.256104",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1852.334",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1679.7417",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.07007",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.877686",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-72.539948",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1189423",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-721.68408",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-77.630127",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7023087",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7271643",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2447262",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7433434",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.41205",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.17136",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.04456",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.52823",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15006515E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.7583",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.32952389E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.002686",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47070.426",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111564.36",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.07780771E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49711889E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19534559E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-438143.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "432033.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.6875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-271.54077",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "39.327744",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0303711",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258413",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-733.7356",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "969.19629",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1255.1243",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "173.33276",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.01889076E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.93086690E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1741.7109",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2062.187",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-314483.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "618525.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.0625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271.54077",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "12.4151",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.93961",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.7048",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.42577",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.8465",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.04456",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "341.15128",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.08003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.57584",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00440276",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02687903",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.789476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.23712",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.09401090E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78243990E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.09401090E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78243990E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00440276",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02687903",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99206374E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95355847E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99206374E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95355847E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02097803",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.794708",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05950401",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.392586",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.457321",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.591858",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.975418",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.294769",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.42710325E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03508818",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.80458",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.50818",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.77664",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.46198",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.82906",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.14551",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04390636",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "80.10582",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.4453",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-810.19824",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-365.89722",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.250488",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1693.9717",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1738.9387",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-366.2832",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-81.27832",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.490036",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1196136",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.00098",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.043213",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7303572",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9267368",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.6807442",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5698452",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.26215",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.52539",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.34218",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.11548",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20777236E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.25806",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.58620445E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "12.940674",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47525.875",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111603.11",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.80419214E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51214567E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25964937E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-488946.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "482518.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-247.50597",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "42.390213",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02994512",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258484",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-817.33203",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1097.9119",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1137.1624",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "192.01807",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.43404588E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.67841186E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1547.4331",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1765.855",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-385242.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "587538.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.51562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-247.50597",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-2.0504608",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.2135",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05273",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.8111",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.44812",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.34218",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "339.45923",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.45262",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.81842",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004384689",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02629707",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.673233",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.07553",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25075612E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73106964E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25075612E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73106964E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004384689",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02629707",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92387597E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89710988E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92387597E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89710988E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03037965",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.186653",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06252682",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "34.548992",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.479156",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.959244",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.875153",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.61409",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.28429587E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03494899",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.04832",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "323.83075",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.36272",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "317.91052",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.36272",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "321.47736",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05436542",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "82.55925",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.0742",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.92456",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-384.76392",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.077637",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1747.6179",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2315.1367",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.76392",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.916504",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-77.550537",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1195068",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.27295",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-77.820557",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6853533",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8225365",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.155098",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1551552",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.48315",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.72864",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.98146",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.41589",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33044853E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.49536",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.20656021E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.62915",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47070.438",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111630.97",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.78990261E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58673527E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21227720E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-399124.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "470382.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-278.87891",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "49.542282",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0290796",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258467",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-706.2749",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "954.87671",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1038.4495",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "184.52393",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.15246831E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.37852304E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2081.2212",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2289.6626",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-312918.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "652948.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.84375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-278.87891",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "11.387909",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.11923",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.36337",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.59",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "317.25293",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.98146",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "343.15411",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.28598",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.97394",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005913869",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02600497",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.712442",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "407.96298",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.96485869E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72700820E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.96485869E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.72700820E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005913869",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02600497",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.78848086E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96672613E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.78848086E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96672613E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03318304",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.203205",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06907964",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.483727",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.55365",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.675705",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.495972",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.296097",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "4.12458917E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03525951",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.41534",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "327.39584",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.33905",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.41345",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "194.90762",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "322.65067",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07271361",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "81.225609",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.1719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.53149",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-392.99487",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.416504",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1937.0164",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2415.3279",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.99487",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-93.345947",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-74.421768",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1190186",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-746.75635",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-83.743408",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.9338837",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9800091",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.9630861",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6336708",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.34692",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.83649",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.53461",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "349.54492",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14602085E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-691.1001",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.43893906E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "13.80542",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47260.73",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111658.06",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.19169884E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.60160084E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19526442E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-424603.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "497829.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.29688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-287.1145",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "37.442322",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02988149",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-717.43018",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1185.2224",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1219.3723",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "219.3374",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.87592843E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.77046773E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2008.9448",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2157.7327",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-284358.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "593961.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.29688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-287.1145",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-2.1639709",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28954",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.27106",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "203.01001",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "318.17889",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.53461",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "345.25391",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.58839",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.11963",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003903663",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02796803",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.229698",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.19293",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.09102757E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74566176E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.09102757E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74566176E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003903663",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02796803",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.96852716E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08847223E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.96852716E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.08847223E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.01757254",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "36.745487",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04438286",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.300522",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.383102",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.313248",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.077805",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.183502",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.52988683E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03490747",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "201.29007",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "327.06903",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "198.49786",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "319.65372",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.95061",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "324.6297",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0584791",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "78.656715",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.5898",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.93579",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-378.25513",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.96582",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1583.3416",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1802.6089",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-378.25513",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.775146",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-72.753754",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1190186",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.00098",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-75.480957",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.8471041",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2396498",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0438204",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1114063",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.97749",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.76721",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.54303",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.91754",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28789463E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.72412",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.51810148E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.64209",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47272.938",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111792.69",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.77292996E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47955302E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12176656E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-409823.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "480280.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "976.07812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-268.80151",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "48.836838",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03056095",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258444",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-783.24536",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1126.0732",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1163.55",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "171.05225",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.65271057E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.83966448E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1622.4702",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1894.6172",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-318332.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "586162.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-268.80151",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "6.1827393",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.8118",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.93835",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.59674",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.29742",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.54303",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.7652",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.90558",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.50848",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.008365043",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02747688",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.761114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "408.17047",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.81948142E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70953663E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.81948142E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.70953663E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.008365043",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02747688",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.48600418E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21103437E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.48600418E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21103437E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03461502",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.663372",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05859202",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.259457",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.285751",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.874557",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.50206",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.799164",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.32999810E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03286062",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.90906",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "325.35712",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.53165",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "317.24207",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.6582",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "322.87546",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07887727",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "85.517365",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.0078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.50171",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-386.1792",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.249756",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1621.7319",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1770.9702",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-386.1792",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.730957",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-73.301117",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.1190643",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.32983",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-77.570557",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8255844",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "7.562603",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6323423",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.151824",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.48265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.45618",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.51434",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.24005",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "9.35739138E-07",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.04663",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "7.20305252E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.605225",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47176.52",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111562.08",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.10154779E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42384829E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30407204E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-471467.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "471988.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.20312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "subcenter": "255",
                                                "gribNumBits": "16",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "PTVersion": "128",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-272.44922",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "45.098206",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0295519",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.71484",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1557.7366",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1566.4011",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "185.46777",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "24",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.52619838E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.41611927E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1544.9395",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1917.0508",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-291078.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "597905.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.96875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "subcenter": "255",
                                                    "gribNumBits": "16",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "PTVersion": "128",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-272.46606",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "7.4033508",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "8",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.50772",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05707",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.85968",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "scale_max": "316.57462",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.51434",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "scale_max": "342.79083",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.66765",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.91928",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009891991",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.025862",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.359402",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "407.83591",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.95450318E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.67411108E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.95450318E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.67411108E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst dec2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009891991",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.025862",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86158695E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.32882508E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86158695E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.32882508E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03076342",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.427803",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04699028",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.025158",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.552307",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.454498",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.302521",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.859589",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.49461004E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03740445",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.11285",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "327.42404",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "195.40033",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "318.11926",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.45956",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "323.00803",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "Z_10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "Z_09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "Z_06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "cm_down",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Depth"
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "pressure"
                                },
                                "sp_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "C": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "C",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "2",
                                    "long_name": "complex"
                                },
                                "Z_05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "Y_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "Z_03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Height"
                                },
                                "sp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "Z_02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "0.0"
                                },
                                "Z_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m_above_gnd",
                                    "gridtype": "0",
                                    "pointwidth": "0",
                                    "long_name": "Height"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 2001-01-01 00:00:00",
                                    "gridtype": "0",
                                    "pointwidth": "0.25",
                                    "calendar": "standard",
                                    "defaultvalue": "454.75"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "modulus": "360.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/dec2001/SIX-HOURLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "SIXHOURLY"
                            ]
                        },
                        "ensemble": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble",
                            "restriction": "requires dlauth tokens"
                        },
                        "ensemble12": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble12",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble12",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PressureLevelSFlong_name": "Pressure Level: Smoothed and Filled",
                                    "Conventions": "IRIDL",
                                    "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.ensemble12/.MONTHLY/.griblist.html"
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "178",
                                            "long_name": "net shortwave at top",
                                            "units": "W/m2"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "179",
                                            "long_name": "net longwave at top",
                                            "units": "W/m2"
                                        }
                                    }
                                },
                                "FT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "calendar": "360",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "pointwidth": "1.0"
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "zg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "zg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "129",
                                        "long_name": "surface geopotential",
                                        "units": "unitless"
                                    },
                                    "tcld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tcld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "164",
                                        "long_name": "total cloud cover",
                                        "units": "unitless"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "181",
                                        "long_name": "surface meridional wind stress",
                                        "units": "Pa"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "180",
                                        "long_name": "surface zonal wind stress",
                                        "units": "Pa"
                                    },
                                    "stemp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stemp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "169",
                                        "long_name": "surface Temperature",
                                        "units": "Kelvin_scale"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "151",
                                        "long_name": "sea level pressure",
                                        "units": "Pa"
                                    },
                                    "prl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "142",
                                        "long_name": "large scale precipitation",
                                        "units": "m/s"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Total Precipitation",
                                        "units": "m/s",
                                        "gribparam": "143"
                                    },
                                    "prc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "143",
                                        "long_name": "convective precipitation",
                                        "units": "m/s"
                                    },
                                    "net": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "net",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "swflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "swflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "176",
                                            "long_name": "net shortwave at ground",
                                            "units": "W/m2"
                                        },
                                        "lwflx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwflx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "177",
                                            "long_name": "net longwave at ground",
                                            "units": "W/m2"
                                        }
                                    },
                                    "hfss": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfss",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "146",
                                        "long_name": "surface sensible heat flux",
                                        "units": "W/m2"
                                    },
                                    "hfls": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hfls",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "147",
                                        "long_name": "surface latent heat flux",
                                        "units": "W/m2"
                                    },
                                    "evs": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evs",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "182",
                                        "long_name": "evaporation",
                                        "units": "m/s"
                                    }
                                },
                                "PressureLevelSF": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel-SF",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "va": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "va",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "132",
                                        "long_name": "meridional velocity",
                                        "units": "m/s"
                                    },
                                    "ua": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ua",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "131",
                                        "long_name": "zonal velocity",
                                        "units": "m/s"
                                    },
                                    "ta": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ta",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "130",
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale"
                                    },
                                    "phi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "phi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "156",
                                        "long_name": "geopotential height",
                                        "units": "gpm"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "135",
                                        "long_name": "vertical pressure velocity",
                                        "units": "unitless"
                                    },
                                    "hus": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hus",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_min": "0.0",
                                        "gribparam": "133",
                                        "long_name": "specific humidity",
                                        "units": "unitless"
                                    }
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "167",
                                        "long_name": "temperature at 2m",
                                        "units": "Kelvin_scale"
                                    }
                                },
                                "P": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "bounds": "Z"
                                },
                                "L": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "L",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "standard_name": "longitude",
                                    "pointwidth": "2.8125"
                                },
                                "S": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "S",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "calendar": "360",
                                    "long_name": "Forecast Started",
                                    "pointwidth": "0.0"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0"
                                },
                                "M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "ids",
                                    "gridtype": "0",
                                    "long_name": "member",
                                    "pointwidth": "1.0"
                                },
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble12/MONTHLY"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble12/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY",
                                "SIXHOURLY"
                            ]
                        },
                        "ensemble12_mean": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble12_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble12_mean",
                            "restriction": "requires dlauth tokens"
                        },
                        "ensemble1324_mean": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble13-24_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble13-24_mean",
                            "restriction": "requires dlauth tokens"
                        },
                        "ensemble24": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble24",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble24",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble24/MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "MONTHLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble24/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY",
                                "SIXHOURLY"
                            ]
                        },
                        "ensemble24_mean": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/ensemble24_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble24_mean",
                            "restriction": "requires dlauth tokens"
                        },
                        "feb2002": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "feb2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200205",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200205",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200205",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200205",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200205",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200205",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200205",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200205",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200205",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200205",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200205",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200205",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200205",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200205",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200205",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200205",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200205",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200205",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200205",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200205",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200205",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200205",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200205",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.feb2002/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/feb02/20006fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200205",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06512219",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "83.173409",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.8438",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.37305",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-375.15259",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.735352",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1662.5273",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1358.7542",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-375.15259",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.315918",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-82.415558",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01832581",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-704.45752",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.267822",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5586615",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.7752676",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0019808",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.4437799",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.71834",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "335.89532",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.59866",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "344.36969",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.10622852E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-707.19849",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.10728433E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.430176",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46944.242",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111929.23",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.09474705E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.58300600E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.25884640E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-452230.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "481113.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "966.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-242.78328",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "46.853455",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02940073",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258503",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-685.45703",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1586.1001",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1661.2761",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "176.44751",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.64297772E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.05561831E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1322.7129",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "2089.2336",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-275080.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "604750.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "971.5625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-243.35358",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "6.8074341",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.13968",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.87695",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "200.14511",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.1814",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.59866",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "340.35388",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.73093",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.06882",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.001999494",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02678742",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.693859",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.91971",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.10206975E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.13866035E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.10206975E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.13866035E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.001999494",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02678742",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94727500E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98586849E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94727500E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98586849E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.01865",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.722454",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0415806",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.324894",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.396118",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.513901",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.677399",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.791519",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.28210729E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03574505",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.70477",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "326.68274",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.43379",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "322.46408",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.48758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "325.75952",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04599914",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "89.894363",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.793",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-811.10034",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-378.27441",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-79.998535",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1853.8052",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1352.0586",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-378.27441",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.179443",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-82.507965",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01881409",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-727.06274",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-69.082764",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3353157",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.7137384",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4700699",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.9891205",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.00177",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "337.06061",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.99594",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "345.68323",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.27383566E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-699.92603",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.08854418E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.578125",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47275.375",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111791.11",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.82327826E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.44884687E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.66310087E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.34537402E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-410723.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "449158.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "973.64062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-251.39499",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "53.897644",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0311002",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258415",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-724.16626",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1044.7366",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1324.2332",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "195.80469",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.29523788E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.82958693E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1398.3508",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1841.6177",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-288663.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "570478.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "974.23438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-251.39499",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "15.077225",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.43504",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.11169",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.35823",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.08783",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.99594",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "341.6507",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.11852",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.11462",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003235378",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02692391",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.696911",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.06369",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.21479561E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.48184808E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.21479561E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.48184808E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003235378",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02692391",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97708823E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.95636039E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97708823E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.95636039E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02936021",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.233536",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04670583",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.93597",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.63562",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.463684",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.353821",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.846619",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.13905912E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03564405",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.21715",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "335.95087",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.94974",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "325.20294",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.95947",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.41388",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.060309",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "86.670166",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8519.1289",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.36768",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-388.62891",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-76.995605",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1861.8899",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1513.8752",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-388.62891",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-80.073486",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-82.023895",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01881409",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.27954",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-67.391357",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5751429",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.2843781",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.5266314",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.7870111",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.80397",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "337.96869",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.77368",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "346.79651",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.04312733E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-693.11865",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.68866516E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.480469",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46758.566",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111977.12",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.86993780E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.61622540E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.21752282E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-414226.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "445059.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "970.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.56958",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "45.943863",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02816396",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258453",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-739.74097",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "858.48462",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1128.8877",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "175.79346",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.51410529E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.02924012E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1541.8213",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1642.4329",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-409798.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "593686.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "976.17188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266.56958",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "11.134338",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.40489",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.78448",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.59004",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.09979",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.77368",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.73688",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.11671",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.90576",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005328145",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02734295",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.858587",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.16208",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.13800979E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.45413460E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.13800979E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.45413460E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005328145",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02734295",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07195603E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.95695634E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07195603E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.95695634E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03245082",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.709393",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04887522",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "39.824055",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.95961",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.42955",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.60347",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "39.444321",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.38375526E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03634196",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.16742",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "333.63959",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.86838",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "325.74921",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.94463",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.80853",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05952236",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "79.74865",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8531.3789",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.5271",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-383.46362",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.782959",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1673.0442",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1401.6707",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-383.46362",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.342041",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.64418",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01853943",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-713.94946",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-68.278809",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8167477",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.857543",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.429368",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.0171442",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.40472",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "336.88379",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.37608",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "343.00363",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.07171809E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-708.91406",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.59291356E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.459961",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47065.777",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111575.88",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.58169449E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.39914209E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.26455052E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-404129.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "453626.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "970.21875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-246.25217",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "48.158615",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02893379",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258497",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-877.20044",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1249.5479",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1335.835",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "170.15967",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.34163007E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.80426808E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1583.2659",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1736.7415",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266554.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "578273.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "975.71875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-246.25217",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "16.896622",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.9111",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.29297",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.29312",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.07242",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.37608",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "339.25754",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.48497",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.026",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003489986",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02600789",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.37188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.24979",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.18288290E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.26392761E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.18288290E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.26392761E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003489986",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02600789",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83628447E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.03001014E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.83628447E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.03001014E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03219388",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.407494",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05831588",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.283028",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.682358",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "29.944565",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.916275",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.921768",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.14467582E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03534197",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.08725",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "331.16083",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.77362",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "323.89111",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.88562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.58417",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06526119",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.444923",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8512.9492",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.5708",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-383.41016",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.592041",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2265.9478",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1664.2827",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.1875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-383.41016",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-85.442871",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.986511",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0191803",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-706.24194",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.234863",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.7345867",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.8081493",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0106602",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.2636404",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.72865",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "335.56653",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.78571",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "343.60297",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.37552502E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.36621",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.01089245E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.442383",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46811.09",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111929.95",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.91302773E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.55371174E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.16979902E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-414590.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "458000.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "976.45312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.09766",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "48.444427",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02850692",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25861",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-711.3728",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "995.27881",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1112.908",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "220.3667",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.45020731E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.81215385E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1574.6013",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1925.7007",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-321203.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "590231.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "977.73438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-266.09766",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "11.463669",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.38564",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.96997",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.38828",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.24893",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.78571",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "339.63031",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.35205",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.49854",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003935032",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02596861",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.273867",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.2919",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.23308628E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.22126612E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.23308628E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.22126612E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003935032",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02596861",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.95099346E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86417981E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.95099346E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86417981E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03276511",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.811928",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06960207",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "36.293194",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.60083",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.588272",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-35.11441",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.854538",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "2.01999910E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03730988",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.35452",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.44724",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.16739",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "323.66309",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.35452",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "326.52441",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05959206",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "84.28553",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8524.6562",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.29004",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-396.31885",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-76.748779",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1814.6494",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1531.1172",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.1875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.31885",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.981201",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-90.174973",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01907349",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-742.27856",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.237549",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8796654",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.5904789",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6737146",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.895793",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.73177",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.24271",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.73701",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "348.33459",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.19547462E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.57471",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.04401261E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.687256",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47041.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111413.44",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.63306048E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.65552706E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.30930061E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-405556.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "432383.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.1875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-274.94287",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "62.726913",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02977458",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-697.42847",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1065.0496",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1380.729",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "189.86621",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.52114898E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.59190755E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1680.3882",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1727.2112",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-270934.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "598007.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "971.1875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-277.4231",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "7.9709167",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.3241",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.21655",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.94514",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.63208",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.73701",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.72717",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.96951",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.66998",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007186741",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02737963",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.324186",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.02673",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.09324037E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.18579765E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.09324037E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.18579765E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007186741",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02737963",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06200957E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.04444882E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.06200957E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.04444882E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03190911",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.201324",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05560002",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.32373",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.078751",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.874466",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.85849",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.296234",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.94247150E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03505723",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.40913",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.32303",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.37708",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.36603",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.38281",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "331.88837",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04531902",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.201622",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.25",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.3042",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1180.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.32471",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-81.983887",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1702.53",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1490.6748",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-386.32471",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.889648",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.20108",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01881409",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-735.2019",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-67.830566",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0149307",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.4372473",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.0756922",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.0246067",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.14149",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.08838",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.17564",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.51178",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.30931903E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-698.59668",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.09890243E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.379395",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46956.656",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111618.48",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.12831331E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.63578306E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.33879303E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-404827.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "431964.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.78125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-265.46606",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "52.042145",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02919927",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258587",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-718.96875",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "963.06616",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1547.6982",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "190.56616",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.18881188E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.61996262E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1634.8284",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1706.7332",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-292406.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "590033.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "972.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-265.50049",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "11.095322",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.21176",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.49942",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "200.25378",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.85107",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.17564",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.32233",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.86389",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.26328",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.002590341",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02796172",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.819136",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.92249",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.18572498E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33009771E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.18572498E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33009771E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.002590341",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02796172",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99523561E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.03027480E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.99523561E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.03027480E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03190365",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.584641",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04982528",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.195808",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.785248",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.102219",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-27.884613",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.521744",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.34884999E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03596323",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.88429",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "333.69476",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.63507",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.41302",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.65601",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.79675",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.067518",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "83.620163",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8512.7969",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-815.17896",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.9375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-389.5918",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-77.717041",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1519.604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1667.9084",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-390.79346",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-84.28833",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-80.546173",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01895142",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-748.12402",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.833252",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.841712",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.8755541",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.8443069",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.2416096",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.19376",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "339.11646",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.2058",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "348.03735",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.38755934E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-703.2793",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.02588092E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "14.973633",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47449.488",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111736.3",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.01254739E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.57925683E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31948673E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-416515.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "451308.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.48438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-273.79761",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "47.012054",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02855632",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258493",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-740.83057",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1039.5168",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1321.9717",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "169.98389",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.28619466E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.79733034E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1808.7004",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1529.4243",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-360609.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "619246.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "972.75",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-273.79761",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "24.486359",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.00525",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.62451",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "202.60512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.66058",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.2058",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.84506",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.64717",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.57932",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004805099",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02729072",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.55954",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.78403",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46271250E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33977319E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.46271250E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33977319E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004805099",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02729072",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.15222894E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97249346E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.15222894E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97249346E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03534627",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.66663",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0480883",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "36.862526",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.566422",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "29.84166",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.932785",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.654556",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.70298335E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03659926",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.69456",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "331.37708",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.46405",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.95511",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.4861",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.51126",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06108603",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.983307",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8555.75",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-803.55664",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.0",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-378.94922",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.553467",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1860.928",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1459.6116",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-378.94922",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-87.030273",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.373535",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01913452",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-719.66748",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-73.237061",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6865978",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.6347408",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.1307364",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.4476709",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.71538",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.15668",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.65503",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "344.84869",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.39931433E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-701.08643",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.45481588E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.599609",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47049.492",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111794.12",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.94118478E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.62474555E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.49853292E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-416683.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "428391.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "967.5",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-268.6377",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "61.041412",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02927945",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258537",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-842.69263",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1048.083",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1085.196",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "281.35327",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.33939505E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.12508246E-07",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1381.4246",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1827.269",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-283253.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "660290.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "968.54688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-268.6377",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "8.4751587",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.92268",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.37616",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "201.68777",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.08795",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.65503",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "340.84955",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.62602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.94983",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006981775",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02744959",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.203049",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.84479",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.15684134E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.28357506E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.15684134E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.28357506E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.006981775",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02744959",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07379662E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98183625E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.07379662E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98183625E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03421637",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.626724",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04998441",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.306137",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.807297",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.32576",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.392776",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.409012",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.96157146E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.0407541",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "192.31833",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "330.11749",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "192.16193",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.00266",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "192.19255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "326.95801",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.07141215",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "78.9804",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8506.5117",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.5791",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-378.93726",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.997803",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1812.8198",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1426.353",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-378.93726",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-86.530029",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-81.959106",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01878357",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.38062",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-71.224854",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.1809111",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.2958126",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.3276329",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.4971895",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.39407",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.87048",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.40906",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.82715",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.38038070E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.91748",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.15783769E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.209473",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47186.625",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111865.09",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.25932943E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.47980461E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.22024096E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-407605.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "447505.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "979.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.88989",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "60.907455",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02952188",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258436",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-780.84302",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "870.98022",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1132.562",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "188.4624",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.52879874E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.53599352E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1403.4463",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1589.2737",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-310628.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "562421.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "979.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.88989",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "13.775604",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.07243",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.76514",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.98015",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.92432",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.40906",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.63184",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.49835",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.08844",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.01137783",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02697913",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.193289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.04126",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.06559319E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33399790E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.06559319E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33399790E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.01137783",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02697913",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97278064E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91934919E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.97278064E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91934919E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0267345",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.180611",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.03395388",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.619278",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.805191",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.586792",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.822311",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.87323",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.28025192E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03397906",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.3119",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "334.59363",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.2341",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "323.50412",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "191.28848",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.26636",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0609222",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "82.622849",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.9883",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-811.50391",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.8291",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.163574",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2254.7795",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1506.8826",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.71265",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-80.274414",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-89.406113",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01823425",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.11621",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-66.84082",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2258139",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.4267931",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2958126",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.9725285",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.42502",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "337.78311",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.46211",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.1358",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31555475E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-696.73145",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.07268259E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.389893",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47099.336",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "112325.24",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.00484147E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.72960779E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.26885527E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-412895.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "446362.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "965.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-254.31844",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "46.010193",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0294786",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-717.70117",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1006.229",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1069.2627",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "188.46387",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.27568239E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.53609868E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1520.9697",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1803.7449",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391967.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "550044.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "969.67188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-254.339",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "11.914154",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28348",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.59766",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.23935",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.41388",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.46211",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.89752",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.94011",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.53778",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004194312",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02686595",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.192799",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.13586",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.21877492E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.30563958E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.21877492E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.30563958E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004194312",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02686595",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04025969E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88401577E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.04025969E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88401577E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02557251",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.393822",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04809018",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.338737",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.389572",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.251846",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.737839",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.681824",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "7.54625376E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03501328",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.59895",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.03473",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.43797",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "323.92477",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.44598",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.85663",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0728789",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "82.325737",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.3242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.40454",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-392.2981",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-77.945801",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1857.3745",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1589.8333",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-392.2981",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-84.006104",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-81.974411",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01875305",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-728.24072",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-72.956543",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.986536",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.4977617",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.6350937",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.112978",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.5424",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "337.14178",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.49138",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "346.84174",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.20600066E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-706.78223",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.87580279E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "17.012695",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47199.688",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111755.22",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.78854314E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.40239081E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31674096E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-422308.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "425852.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "974.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-262.76855",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "55.307968",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02973445",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258396",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-781.26025",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "938.67114",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1091.8286",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "203.46655",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.36591733E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.13631971E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1606.2166",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1748.5432",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-294371.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "594887.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "974.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.76855",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "19.079926",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.82065",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.59686",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.6797",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.71924",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.49138",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.67963",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.37395",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.43414",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.008074448",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.0271998",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.220617",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.23495",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.24392136E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37341776E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.24392136E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37341776E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.008074448",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.0271998",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90850051E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07075504E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90850051E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07075504E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02942744",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.186214",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05973487",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.731323",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.555038",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.363846",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.314545",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.199234",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.74015156E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03487565",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "192.29991",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.90543",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.84267",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.7652",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "191.88974",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.52151",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05903839",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.777481",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.6953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-807.46167",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-395.71387",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.543945",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1679.8416",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1580.167",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-395.71387",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-84.194336",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-82.697174",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01872253",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.96729",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.272705",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0749035",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.369689",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.5522242",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.7540684",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.76169",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.96375",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.78568",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.65686",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.12907412E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-699.12891",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.10524707E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.784668",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47263.348",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111693.33",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.65286416E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.50116352E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31565594E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-422154.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "429850.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "970.95312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-267.20166",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "50.219864",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02826654",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258429",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-734.54565",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1224.7354",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1827.2275",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "199.625",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.30657177E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.98243889E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1562.4348",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "2087.9119",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-301266.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "589947.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "970.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-267.20166",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "12.726822",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.04556",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.29547",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.51376",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.96967",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.78568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.44202",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.64536",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.1355",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003512601",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.0280758",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.908791",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.13965",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.17554246E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.34934744E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.17554246E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.34934744E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003512601",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.0280758",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.85503245E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.14186048E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.85503245E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.14186048E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02158625",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "36.188732",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04351287",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.266144",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.597244",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.200317",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.324036",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.485596",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.35408982E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03465421",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.36266",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "337.21838",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.18689",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.63141",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "191.24997",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.9599",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05055725",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "82.932587",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8530.957",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.4856",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-381.67651",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.762207",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2131.8911",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1246.8401",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-381.67651",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.490723",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.574936",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01831055",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.07495",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-68.210938",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4516935",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.6612825",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-6.2171583",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.9285164",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.36925",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "339.44397",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.32608",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.32684",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.16850686E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-695.5188",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.07008964E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "14.530273",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46959.277",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "112049.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.80888172E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.85961949E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31911213E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-403131.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "435216.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "968.64062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-260.323",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "59.37767",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02966478",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-870.92725",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "861.1731",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1062.168",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "211.19702",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.24731269E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.44496810E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1629.3525",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1876.7834",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-301285.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "607424.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "977.09375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-260.323",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "24.15062",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.57622",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.89426",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.98282",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "318.64191",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.32608",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.54337",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.2524",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.26724",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007090513",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02671823",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.8822",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.98428",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.11684030E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.21628718E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.11684030E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.21628718E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007090513",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02671823",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90034075E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.11396878E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90034075E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.11396878E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03010621",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "36.905354",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06095653",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.460896",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.475876",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.883316",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.887665",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.997467",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.21180221E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03344002",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.30772",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.46768",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.18771",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.89062",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.22522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.04651",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05652468",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "86.12751",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.9258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.32446",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1177.8125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-380.12842",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.802002",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1674.6755",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1372.2524",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-380.12842",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.499023",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.263779",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01861572",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-728.02466",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-67.86377",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8993607",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.1723328",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2959938",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.2275352",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.12793",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.09521",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.08214",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.18597",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.43446050E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-715.18384",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.52786650E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.15625",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47265.875",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111981.48",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.98711255E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.61951027E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.25734982E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-411840.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "468214.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "974.51562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-261.08447",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "48.329803",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03029118",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258528",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-730.69653",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "893.43481",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1225.8853",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "185.24512",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.90197181E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.40756718E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1555.2368",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1774.6621",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-284369.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "553637.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "976.59375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-265.7312",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "9.0247498",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.28976",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.21326",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.57555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "318.27704",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "186.08214",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.9632",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.30289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.43103",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004635327",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02763804",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.614258",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.16693",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.19485749E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.27224921E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.19485749E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.27224921E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004635327",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02763804",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94782024E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98134057E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.94782024E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98134057E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02909825",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.867439",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06204646",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "36.273426",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.859741",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "29.936661",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.142319",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.625046",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.04925221E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03415892",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.67882",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.96387",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.52522",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.47607",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.52991",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.63373",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05511154",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "83.771088",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8520.8086",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.12915",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.0938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-391.0769",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-77.707275",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1634.4495",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1477.147",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.0769",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-79.630127",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-88.388687",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01904297",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-730.15479",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-66.824951",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0346804",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.3161144",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4755507",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.2656212",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.40198",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "337.32953",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.23692",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.01349",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.06838456E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-693.6814",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.97853931E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.674316",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47459.336",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111565.06",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.52763583E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.50261576E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.28464683E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-415340.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "426776.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.8125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-270.22852",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "58.172501",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03029444",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258495",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-714.17676",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1339.4138",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1418.8467",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "222.2251",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.67357063E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.88620946E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1459.436",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1693.2166",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-336280.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "588863.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "972.17188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-270.22852",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "13.622986",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.17307",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.48621",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.34555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.95032",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.23692",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.77124",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.65222",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.38776",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003086306",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02687195",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.62598",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.16452",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.16867095E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.47977134E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.16867095E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.47977134E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003086306",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02687195",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.11035217E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.21983646E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-2.11035217E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.21983646E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.0326745",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.690899",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06019247",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.016529",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-28.989746",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.081436",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.876266",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.574265",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.13572469E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03416157",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.37576",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.76578",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.99083",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "322.94031",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.05299",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.47845",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06153205",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "82.335075",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.625",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.27759",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-378.49463",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.102539",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2091.0322",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1588.0874",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-378.49463",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.945557",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.290054",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01896667",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-703.72461",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-69.602539",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.3405294",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.6966553",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.7487669",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.0240507",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.28839",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "335.81689",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.15843",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "343.79663",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.27751298E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-692.3877",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.01592741E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "14.944092",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47411.168",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111890.32",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.85897521E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.45145657E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.20776747E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-412339.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "432316.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "980.29688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-246.39772",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "45.631485",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02919014",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258516",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-752.60205",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "890.93286",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1177.447",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "261.13867",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.70828127E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.04421161E-07",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1834.356",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1832.5",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-269966.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "600657.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "980.29688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-253.0564",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "10.000916",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.26604",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.10614",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "199.53242",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "315.50391",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.15843",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "339.89429",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.79948",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.23114",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004753061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02572314",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.993393",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.85721",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.05464787E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.26427758E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.05464787E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.26427758E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004753061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02572314",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.95389248E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98293583E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.95389248E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98293583E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03127584",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.973099",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05313417",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "38.298798",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.671463",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "29.647919",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.767609",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.41452",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.39643419E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03692573",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.6174",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.59479",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "189.30148",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "322.07788",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "189.6174",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.59479",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05929587",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "79.659294",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8506.418",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.50952",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-396.43213",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-74.752441",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1568.4373",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1460.7112",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-396.43213",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-78.693604",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.83902",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01835632",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-733.21851",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-66.02124",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.8586245",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.5616608",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5680628",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.5713291",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.84857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "339.05157",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.83022",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "346.55331",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31616844E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.01807",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.89995897E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.129883",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46834.367",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "112141.12",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.07337710E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.69547000E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.35333119E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.49176117E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-403688.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "443792.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "969.64062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-264.67236",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "50.853012",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.03004488",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258474",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-824.34399",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "983.4729",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1378.9812",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "191.48022",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.51416008E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.65650441E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1419.6775",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1633.7285",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-300879.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "577847.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "974.09375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-264.67236",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "15.511185",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.25484",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.05597",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.63718",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.96552",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "184.83022",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "342.80661",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.96483",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.4986",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004390053",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02710578",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.613823",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.9342",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12641192E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.50166761E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12641192E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.50166761E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004390053",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02710578",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.81198652E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.92350944E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.81198652E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.92350944E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02946179",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.38448",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04169048",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.807312",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-34.024567",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.334045",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.483948",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "31.78891",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.26738882E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03361153",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.41034",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "335.76654",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.28966",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "325.89264",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.39275",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.92047",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06307095",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "77.886826",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8522.543",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-809.4646",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-381.85791",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-78.805908",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1892.8606",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1620.3491",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-382.48193",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.372314",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-84.00679",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01856995",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-711.36108",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.227783",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.5366793",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.8918266",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.531146",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.0219622",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.75308",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.46301",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.83449",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "348.09131",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.31280433E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-731.53955",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.16727004E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "14.007812",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47164.184",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111726.91",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.85386385E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.74817637E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.36728568E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-431938.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "427824.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "978.0625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-266.64014",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "50.544022",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02798918",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258545",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-714.1499",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1199.2646",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1351.1316",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "206.01904",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-5.40279643E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.23798416E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1541.6267",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1672.6226",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-293166.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "615094.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "978.0625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-269.84839",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "13.559631",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.94679",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.67847",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "201.38466",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.36511",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.83449",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.86017",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.63042",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.93619",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007790446",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02818193",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.70038",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.91971",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12125044E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37183633E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12125044E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37183633E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.007790446",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02818193",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98339194E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.01486955E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98339194E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.01486955E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.02825961",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.331764",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06766474",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.247654",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-30.326294",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.781418",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.926102",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.38385",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.02171896E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03416644",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.57375",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "327.79944",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.2859",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "322.20026",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.52747",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.71588",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06000873",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "84.174019",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8513.1602",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-808.94556",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-380.86621",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-77.207275",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1869.3494",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1370.8083",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-380.86621",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-83.926758",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.778244",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01856995",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.58398",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-70.255127",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5278912",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.2970839",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4263554",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.0140924",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.7571",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "336.7337",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.72089",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "344.72614",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.33507569E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-690.88599",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.00108446E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "12.985596",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47188.285",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "112277.71",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.19562536E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.88695344E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.25481859E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-430082.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "445304.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.67188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-257.22534",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "57.689651",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02898357",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-707.2644",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "997.00488",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1068.0713",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "185.01074",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.27091749E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.39803170E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1442.177",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1859.49",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-236534.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "557551.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "972.78125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-258.05029",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "17.078812",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.21242",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.05676",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "200.79816",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.31183",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.72089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "340.83365",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.83183",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.05829",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004691739",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02801024",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.252399",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.2605",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.14123195E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.21955818E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.14123195E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.21955818E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004691739",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02801024",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.87976389E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85955616E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.87976389E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85955616E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03161885",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.250175",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.05753528",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.885941",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.82782",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.721619",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-32.448395",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.663589",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "7.12433348E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03232436",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "191.53574",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.20551",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.75475",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "326.42932",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.84172",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.20551",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.04541952",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.052353",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8532.1484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-806.47925",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-398.36865",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-75.109131",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1655.9526",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1885.8657",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-401.73267",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.607178",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-80.939941",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01882935",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-745.47998",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-71.351562",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.0695601",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.5689974",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.2372351",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.8506784",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.46114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "339.09",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.48462",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "348.89621",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.24618828E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-736.93677",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.85368388E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.670166",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46797.832",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111643.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.41346207E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.73549961E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-1.03902716E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.32773380E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-415900.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "432913.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "967.90625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-289.31958",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "48.506454",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02974162",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-721.54248",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1061.6863",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1563.4993",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "181.64966",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-6.25199618E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.26353448E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1386.9336",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1793.4373",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-281330.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "574668.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "972.76562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-289.31958",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "9.1688385",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.11488",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.35019",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "200.82892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.97437",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.48462",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "344.6019",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.68233",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.58832",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004618004",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02716447",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-22.038288",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.28778",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.13348297E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37067354E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.13348297E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37067354E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004618004",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02716447",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90231253E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.13252156E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.90231253E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.13252156E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03314286",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.176552",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0701775",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.432526",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.675949",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.173157",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-33.24762",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "32.154999",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "2.45143269E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.04033428",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.86023",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "334.28766",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.77316",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.64359",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.86023",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "329.93927",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0646221",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "82.061653",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8540.8203",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-804.80054",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1179.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.81885",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-71.51123",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-2009.6687",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1574.761",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-387.87524",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.379883",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-83.244217",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01869202",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-723.68018",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-67.38623",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.5612984",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.9120493",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-3.8393564",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.3373556",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.81805",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "336.8996",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.74484",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "345.15839",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.27160888E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-707.69067",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.00035686E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "13.775635",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46984.633",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "112033.54",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.28690077E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.40864324E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.21691244E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-435151.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "465973.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "969.26562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-256.40381",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "44.757278",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02856492",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258369",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-783.09888",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1007.6604",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1121.947",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "187.07837",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.48635149E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.48054561E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1507.7996",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1559.019",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-318746.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "581164.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "973.51562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-256.42188",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "12.197403",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.29163",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.26587",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.64122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "317.4519",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.74484",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "341.15839",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.09277",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.56085",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004843231",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02643305",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.403906",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.04642",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12467997E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33773183E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.12467997E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.33773183E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.004843231",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02643305",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.78153141E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.00161594E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.78153141E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.00161594E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.03087894",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.659973",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.047905",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "37.070259",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.102463",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.802399",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.437134",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.467438",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.73776300E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03478739",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.57179",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "332.61053",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "188.55824",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "324.90686",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "188.56758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.87567",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.07122862",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "83.574577",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8521.6016",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-805.43066",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-386.8938",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-76.570801",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1930.2063",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1451.9285",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.4375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-391.10205",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.966309",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-77.769165",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.01885986",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-732.05371",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-69.716309",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.6343431",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "4.2201309",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-5.9920988",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.2958317",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.39149",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.57852",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.33153",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "347.45258",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.13538670E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-704.42505",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "9.64384526E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "14.637939",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "47620.414",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111668.3",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.11298207E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.77585662E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.18701621E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-419298.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "438193.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "970.14062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-261.75146",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "52.124466",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.0289549",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258532",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-720.07251",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1002.05",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1076.7388",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "171.55273",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.30557662E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "6.85973021E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1290.5366",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1876.842",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-272486.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "585950.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "976.0",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-262.46777",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "15.02327",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.81793",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "309.94876",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "200.91827",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.44638",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.33153",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "343.08929",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "209.35464",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "311.03043",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005945288",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02822993",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.590122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.3392",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.17308464E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37166253E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.17308464E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.37166253E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.005945288",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02822993",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.78848859E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.08642859E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.78848859E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.08642859E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.04019177",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.047363",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.06106773",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "35.446041",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.044983",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.072922",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.909271",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.395279",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8.62423235E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03541247",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.89763",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "336.78198",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "190.82787",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "326.40125",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "190.83141",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "330.78406",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0546842",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "81.798363",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "8519.2148",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-802.95996",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-378.24463",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "-78.061035",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1651.8721",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1405.8669",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-378.34888",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "-78.343506",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-86.903351",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0189209",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-716.80908",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "-66.504395",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.5965891",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "3.678215",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-4.4564505",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "5.9239254",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.25687",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "338.52063",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.23457",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "344.97821",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.36977042E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-724.12109",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.06368680E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "15.554932",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "46765.137",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "111843.25",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "7.63360845E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.53357723E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.27939791E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-408484.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "407567.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "971.46875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "process": "50",
                                                "gribNumBits": "16",
                                                "scale_min": "-254.89418",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "subcenter": "255",
                                                "scale_max": "58.744751",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.02942466",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-756.97974",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "922.14722",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1133.3193",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "202.97949",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "scale_min": "-4.53182622E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "8.11666041E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-1385.5342",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "1561.6611",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-300245.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "571308.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "971.46875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "process": "50",
                                                    "gribNumBits": "16",
                                                    "scale_min": "-255.40681",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "subcenter": "255",
                                                    "scale_max": "28.88147",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "8",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.50764",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "310.06464",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "198.78688",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "316.79767",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "185.23457",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "341.25555",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "210.14047",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "subcenter": "255",
                                            "scale_max": "312.01349",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "subcenter": "255",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "subcenter": "255",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003536943",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "subcenter": "255",
                                            "scale_max": "0.02646687",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "subcenter": "255",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-21.788008",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "408.9256",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.07869027E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.23014597E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.07869027E-05",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.23014597E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst feb2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-0.003536943",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "0.02646687",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98447492E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07777407E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-1.98447492E-06",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07777407E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "0.04309406",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.368389",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "0.07241148",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "34.996376",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-29.357574",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "30.182205",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "-31.272324",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "33.405167",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "1.43571469E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "0.03586736",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.68712",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "328.04041",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "units": "unitless",
                                            "scale_min": "187.04173",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "322.61584",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_min": "187.14845",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "subcenter": "255",
                                            "scale_max": "325.75586",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "515.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/feb2002"
                        },
                        "jan2002": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "jan2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200204",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200204",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200204",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200204",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200204",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200204",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200204",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200204",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200204",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200204",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200204",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200204",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200204",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200204",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200204",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200204",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200204",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200204",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200204",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200204",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200204",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200204",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200204",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jan2002/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/jan02/20005fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200204",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.08863497",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "78.790146",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8546.5312",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-804.31665",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-391.22925",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.313477",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1527.0908",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1577.9519",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.4688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-392.91211",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-93.489746",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-77.398315",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07272339",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-729.83203",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.738281",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.0943336",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5235043",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.0255165",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9800425",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.1898",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.8504",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.1144",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.83765",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00436489E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-695.20972",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.72708222E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.424805",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47033.043",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111675.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.06893411E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36344408E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.28448359E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18325477E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-438272.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "498223.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "973.0625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-281.32471",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "47.71521",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02970763",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258419",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-725.33789",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "851.42017",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1078.4763",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "205.64209",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.31252488E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.22365962E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1501.5115",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1804.9653",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-308149.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "585631.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.0",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-281.32471",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "10.485779",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.14008",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.87869",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.85269",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.28247",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.1144",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.85913",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.35413",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.1217",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003158709",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02694465",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.663422",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.82764",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.05536301E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37718625E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.05536301E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37718625E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003158709",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02694465",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.03175387E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87358489E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.03175387E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87358489E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03283593",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.224972",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0598011",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.448578",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.802383",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.226456",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.852234",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.863434",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.48499441E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03483288",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "195.39905",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.86102",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "195.19731",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.19989",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.20944",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.36237",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.08159852",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.205399",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8518.707",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-802.23584",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-386.4021",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.490723",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2212.1458",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1881.8127",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-386.4021",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-89.891602",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-77.742157",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07249451",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-714.07446",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-73.312256",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8135738",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9163294",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.0129528",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7896891",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.76363",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.24884",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.75607",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.64984",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12451039E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.33179",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.63481546E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.553223",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46941.281",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111639.02",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60610135E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74755974E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23651864E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-422452.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "471231.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "966.95312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-261.90186",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "49.06189",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02886837",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258408",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-763.92041",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1247.1392",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1288.9866",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.63232",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.15429633E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.38300230E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1533.7637",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1771.5142",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-287021.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "565604.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.3125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-261.90186",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "3.6437225",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.43509",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.11182",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.36539",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "315.30502",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.75607",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "340.77679",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.72362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.28027",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006198265",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02601864",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.989038",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.8342",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.02084723E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41538540E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.02084723E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41538540E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006198265",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02601864",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.05940501E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79968754E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.05940501E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79968754E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0252226",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.768612",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04675357",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.851433",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.791245",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.658829",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.181854",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.246017",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.96481551E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03373118",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.06259",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "332.99371",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.99986",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.59946",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.05313",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.79559",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07135242",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "81.979973",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8520.8242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.20483",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-393.08154",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.516113",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1902.7502",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1696.0122",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-393.08154",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-85.724854",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-86.345047",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07261658",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-722.78784",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.105469",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.4013233",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9394646",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8116369",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4169388",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.62093",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.19818",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.57861",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.32877",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20019035E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-693.59326",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.84960173E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.436523",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47353.07",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111857.21",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.06554056E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68355734E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25315114E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-453559.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "544784.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.76562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-280.3606",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "42.238678",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02920849",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.95264",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "934.48804",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1032.6865",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "178.79639",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.12942427E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.14942416E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1587.7065",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1978.8889",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-333512.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "599436.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.42188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280.3606",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-1.5118103",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.4046",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.78421",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "200.26634",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.35052",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.57861",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.41141",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.78809",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.96973",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002713242",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02683125",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.501242",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.86768",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.07304913E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41882792E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.07304913E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41882792E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002713242",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02683125",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99680471E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04506205E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99680471E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.04506205E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0276368",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.031742",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04521976",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.695332",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.895691",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.08905",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.455292",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.709381",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.65885808E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03786822",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.12914",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.24841",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "190.95403",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.42145",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.96959",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.13116",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.08346063",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "82.792542",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8531.4023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-804.03979",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-392.42456",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.016846",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2209.8638",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1447.2239",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-392.42456",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.117676",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-77.492111",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07188416",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-747.58325",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.786621",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.4782829",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7106428",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3357716",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4273624",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.106",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.72958",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.13101",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.14459",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68765985E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-699.23096",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.33199772E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.507812",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47228.387",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111543.67",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57033490E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62038054E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23307132E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-395834.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "421836.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "973.35938",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-271.93433",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "58.867676",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02871597",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258463",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-737.86621",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1138.9348",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1450.259",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "195.40942",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.79917980E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.81389247E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1627.5989",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2128.6934",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-286031.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "613147.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.57812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-272.36938",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "10.427948",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.91154",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29401",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "203.00102",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.35992",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.13101",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.08795",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.04863",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.82599",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006195955",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0264501",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.509912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.1629",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08344775E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41968958E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08344775E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41968958E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006195955",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0264501",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.94381641E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92612742E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.94381641E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92612742E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.028108",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.361088",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06699288",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.198128",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.906693",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.154144",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.011261",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.601974",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.76964363E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03746422",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.4333",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "331.00284",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "190.68228",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.72937",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.68228",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.27637",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06514055",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "79.685387",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8513.4258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-808.25342",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-395.70093",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.930664",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1927.4688",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1676.4255",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-395.70093",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-87.209961",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-79.845016",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07258606",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.32056",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.496338",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.4029398",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1781483",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.6627359",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3459024",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.58226",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.36743",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.53023",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.17047",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17336640E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-700.68408",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.42599547E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.322754",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46582.891",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111693.03",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.24617507E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.77647269E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31231161E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-456165.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "435317.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "978.84375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-281.13159",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "48.782425",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.0299079",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258427",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-762.1626",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "954.04297",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1150.8213",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "210.05005",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.60181184E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.39928589E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1825.7559",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1592.0627",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-339436.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "604517.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "978.84375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-281.13159",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2.7609711",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.38564",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.96759",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "201.63911",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.48267",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.53023",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.11969",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.03781",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.41086",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002155717",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0257889",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.483788",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.90222",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10013470E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.47625806E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10013470E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.47625806E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002155717",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0257889",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99080068E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10620533E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99080068E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10620533E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03290768",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.541016",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05327624",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.38031",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.737534",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.084259",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.888885",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.440186",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.47660068E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03694062",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.76929",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.60153",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.42642",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.5636",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.47794",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.6554",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.076913",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "78.438332",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8520.9492",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-806.64624",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-381.09692",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.948975",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1686.0493",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1758.7886",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-381.09692",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-92.750488",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-76.346878",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07196045",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-736.79858",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-76.129883",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.6575813",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5186739",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.306942",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6470404",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.54721",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "341.17999",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.56439",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "349.2106",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24944074E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-698.09888",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.23188054E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.656006",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47089.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111510.2",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91402890E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.20994160E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55960504E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20600816E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-421470.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "472170.0",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "971.59375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-279.18579",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "50.344696",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02894654",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258411",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-737.98657",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1060.0986",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1122.2888",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "197.38354",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.48771914E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.89298156E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1582.5027",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1807.6426",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-252174.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "594759.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.59375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-279.18579",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "8.3146362",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.32361",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.21667",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "203.54875",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.92474",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.56439",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "344.94888",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.63492",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.1564",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00241454",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02716777",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.697725",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.10904",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.95959817E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.44540654E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.95959817E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.44540654E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.00241454",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02716777",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93631763E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02385900E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93631763E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02385900E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02841977",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.146168",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05619862",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.770874",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.027481",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "29.263107",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.295517",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.409409",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.01689659E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03683738",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "194.12103",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.31226",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.86497",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.10782",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.88359",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.28497",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07113761",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "81.858292",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8540.2812",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.4541",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-395.49756",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.698486",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1851.9724",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1641.6665",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-396.69556",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-89.196533",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-79.438293",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0725708",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-738.39404",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.775879",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2854185",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.383234",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8563423",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6906614",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.72971",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.34027",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.67572",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.4881",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22633162E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-700.73193",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01429760E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.505859",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47101.594",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111586.94",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88085742E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.90395406E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23018776E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-427296.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "469593.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "969.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-289.09937",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "47.751053",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02999133",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258389",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-724.86621",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "973.82812",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1115.4094",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "219.72729",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.46021033E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.78632136E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1913.7119",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1751.6096",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-298157.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "587668.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-289.21826",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "14.428986",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.21205",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.49536",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.9958",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.35559",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.67572",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.46857",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.53528",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.38098",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004413251",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02706424",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.847956",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.59424",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.05157978E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.43743382E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.05157978E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.43743382E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004413251",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02706424",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92747484E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85954991E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92747484E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85954991E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02384229",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.100494",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0457606",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.043453",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.644623",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.766388",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.627808",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.191971",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.25251767E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03532648",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.29427",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.71063",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.49083",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.23038",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.65712",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.8844",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06787294",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.943642",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8521.5234",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.16626",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-395.68066",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.868896",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1759.8972",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1827.3037",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.2812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-395.68066",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.165283",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-79.347687",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07223511",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.01685",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-75.509277",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1911783",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2105513",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.913579",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.469739",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.21527",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.24805",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.31361",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.45547",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18501498E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-705.87329",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.20757123E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.911621",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47416.426",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111430.62",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01607361E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53058068E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36763163E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-435431.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "445289.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "973.64062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-271.47217",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "40.937485",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02915859",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258497",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-725.95874",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "949.72339",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1001.1628",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "207.33276",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.00337001E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.29108728E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2022.1917",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2013.8237",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-301496.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "560232.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.64062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-271.47217",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "7.3872986",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.00533",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.62311",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "204.59225",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.45172",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.31361",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.25821",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.25827",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.04733",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002680055",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02714986",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.925404",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.62634",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10738720E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.30628687E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10738720E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.30628687E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002680055",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02714986",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93372080E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02853312E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93372080E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02853312E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03123133",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.54797",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05585377",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.084698",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-27.926819",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.518311",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.171204",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.30278",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.15787020E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03985489",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.22382",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "329.23325",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.07733",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.48886",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.09688",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.77908",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06327736",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "86.158173",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8511.957",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.01733",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-382.83838",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.304443",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1764.2073",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1645.8909",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-382.83838",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-94.208984",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-74.923004",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07261658",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-725.45752",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.773438",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.86444",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.884716",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8833761",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9647741",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.12993",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.98926",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.89484",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.38031",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20011578E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-700.98804",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.79590516E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.642578",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47118.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111607.45",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.70181759E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.78655750E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37799634E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-424980.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "470670.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "970.40625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-272.77295",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "44.73204",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02888972",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258429",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-710.06519",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "855.35718",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-962.22485",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "198.4458",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.84766736E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.93527875E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1708.7188",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1785.6848",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-299680.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "574348.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.40625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-272.77295",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "15.654266",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.9227",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.37683",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "204.93535",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.1817",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.89484",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.26898",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.20789",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "311.88171",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003222116",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02624288",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.383305",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.6412",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.13576498E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41136043E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.13576498E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41136043E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003222116",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02624288",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.13979115E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83530710E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.13979115E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83530710E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02542069",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.296368",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05044972",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.382175",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.978607",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.441437",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.495819",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.46875",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.80243932E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03350567",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "197.19569",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.81808",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "196.68367",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "318.01758",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "196.68367",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.3634",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05089009",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "84.284454",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8521.0039",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-804.59961",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.2812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-387.74805",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.404053",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1779.7383",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1516.498",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.2812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-387.74805",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-88.788086",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-86.620575",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07244873",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-726.76807",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-73.754395",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.643796",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4967651",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9076681",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "7.1597595",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.03889",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "339.61993",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.01814",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.41406",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13122110E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-696.90771",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.45146894E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.163086",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46820.176",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111590.98",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.62090212E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72522778E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34745017E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-442532.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "485795.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "969.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-275.7168",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "48.104324",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02995696",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-705.90674",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1306.1624",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1385.2249",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "189.22144",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.53912628E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.56634506E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1473.3171",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1817.4719",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-282127.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "547422.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.35938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-275.7168",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.377762",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.07272",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.76437",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.35504",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "317.10846",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.01814",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.22488",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.14102",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.73282",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003773673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02687748",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.739754",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.77963",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.23676509E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.33446702E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.23676509E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.33446702E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003773673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02687748",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91522872E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97367194E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91522872E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97367194E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0201621",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.467384",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03541747",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.757454",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.894867",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.807037",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.023911",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.477951",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.06668005E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03548557",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.27264",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.14926",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.77805",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "321.43588",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.77805",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.35226",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06646073",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "85.014",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8512.5469",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.43066",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-388.66162",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.780029",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1652.7549",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1854.1665",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-392.96167",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-87.016357",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-79.353607",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07270813",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-731.3855",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.980713",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7574482",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9897308",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.9245405",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8778248",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.58597",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.53677",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.57718",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.3302",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36308563E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-697.29419",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.13525582E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.322266",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47108.867",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111636.28",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.23525665E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.98657197E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.83871020E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38721998E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-412565.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "483465.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "968.4375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-269.71265",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "47.06015",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02894589",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.65015",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1090.522",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1177.8604",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "220.28662",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.70993371E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.80851871E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1894.9229",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1793.5815",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-299181.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "603179.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.79688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-269.86255",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "16.282806",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.28374",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.5976",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "205.38965",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "315.84961",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.57718",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.13684",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.58946",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.84143",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002704571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02719582",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.212059",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.90015",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.29132850E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48435247E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.29132850E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.48435247E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002704571",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02719582",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92735661E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98303201E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92735661E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98303201E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02190127",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.174183",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04919917",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.940697",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.489502",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "30.742096",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.836487",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.585388",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.62628646E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03758482",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.20995",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.46423",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.1671",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.34277",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.20601",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.46454",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07916874",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "77.354454",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8512.4336",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.18799",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.5127",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.095947",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1646.5938",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1855.5569",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.5127",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-91.043457",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-76.596954",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07249451",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-739.66699",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-73.295166",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.4685249",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0001163",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.6994953",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6876259",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.75748",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.74683",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.71426",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.883",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32358957E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-700.30396",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.77436833E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.876465",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46650.379",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111506.66",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.34399145E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44039097E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.34095262E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32716195E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-425128.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "509122.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "967.98438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-264.61523",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "49.055405",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02994091",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258471",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-721.62207",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "902.479",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1160.8591",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "204.55371",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.64195068E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.17973671E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1912.5901",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1670.8003",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-324772.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "556309.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.17188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-264.61523",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "0.9284058",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.82198",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59726",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "203.0378",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.79697",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.71426",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.66718",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.05002",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.4758",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002045426",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02656992",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.672165",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.8335",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.13637652E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.42970794E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.13637652E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.42970794E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002045426",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02656992",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17203660E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05096489E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.17203660E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05096489E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03185421",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.894035",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06714308",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.932541",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.363449",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.188721",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.157776",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.796234",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.65928179E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03642208",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.84726",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "328.73642",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.7879",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.18268",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.80019",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.51572",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07214123",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "79.265884",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8518.4023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.16479",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-376.57666",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.742676",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2129.241",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1445.1851",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-376.57666",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-94.164795",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-77.020889",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07240295",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-738.69922",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-77.283691",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.3166685",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2920036",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.8708315",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7188978",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.27927",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.32275",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.27808",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.63843",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40625707E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-696.64087",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.90766387E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.722168",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46994.996",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111624.52",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46217324E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49921345E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32360481E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-418057.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "454292.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "968.25",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-255.02086",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "49.650146",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02878015",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-756.79785",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1296.1072",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1294.8396",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "187.27637",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.09552308E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.48844968E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1446.6426",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1782.8013",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-357191.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "587235.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.67188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-255.02086",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "16.138031",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.04517",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29691",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "205.0979",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "318.40887",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "192.27808",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.60327",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.17505",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.39185",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.001297545",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02618027",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.323158",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.19223",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.19732113E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31690995E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.19732113E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31690995E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.001297545",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02618027",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99154670E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13365502E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.99154670E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13365502E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02943742",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.563663",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06090225",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.784153",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.107208",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.620468",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.549759",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.196716",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.50700907E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0353168",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "194.76027",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.37109",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "194.5563",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "321.19513",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "194.57907",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.82208",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.08043951",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.604797",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8522.5547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.26123",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-379.22632",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.234619",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1787.4897",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1860.9124",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-379.22632",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-87.042969",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-78.58786",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07263184",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-728.11768",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.019775",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2927036",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9892807",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.7821445",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1040478",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.23804",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.6806",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.20973",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.9429",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15672424E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-696.13843",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.75967851E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.497803",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47236.574",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111845.55",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46567707E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66976258E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29595435E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-405484.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "426933.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.85938",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-253.9879",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "46.947006",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02950557",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25841",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-798.68994",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1067.4155",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1066.3972",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "182.03516",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.26422389E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.27915506E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1706.2415",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1666.7512",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-348933.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "615753.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.85938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-254.47914",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "13.3638",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.5766",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89441",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "200.89629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.5192",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.20973",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.15579",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.88618",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.98578",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007022448",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02522637",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.586929",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.61115",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.18760190E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.32407786E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.18760190E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.32407786E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.007022448",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02522637",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93005121E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89396690E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.93005121E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89396690E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0341382",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.992882",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07152718",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.59576",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.107697",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.061951",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.587906",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.935303",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.14605655E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03633545",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.42377",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.51532",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.38766",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "318.70282",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.41048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "322.34021",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0792895",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "81.028435",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8533.3711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-806.29663",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-385.66479",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.458984",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1889.8901",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1488.3486",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-385.66479",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.549561",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-75.295456",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07202148",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-733.09814",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-75.692871",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.0550852",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.466423",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.4816666",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8096027",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.26617",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.384",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.24026",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.76675",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01165597E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-698.85913",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.12229700E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.141602",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47278.973",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111911.56",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.57512043E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.12876239E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19247295E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-410503.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "437389.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "981.71875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-278.22095",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "42.119125",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02817865",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-720.52515",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1100.6426",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1458.4829",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "200.99707",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.83206429E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.03725584E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1509.2791",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1612.4421",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-355403.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "591954.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "981.71875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-278.22095",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2.6461487",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.28973",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.2135",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.27379",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.60095",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.24026",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.7276",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.95753",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.77588",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004102387",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02604836",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.817511",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.86252",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.22052179E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35470282E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.22052179E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35470282E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004102387",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02604836",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92628249E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97477880E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.92628249E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97477880E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0312342",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.186039",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04983494",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.604404",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.303024",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.568878",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.320709",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.2453",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.55400926E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03886515",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.91881",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.21344",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.7726",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.14038",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.8622",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.06018",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06574619",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "85.456635",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8506.3477",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-801.20947",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-383.36108",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.062988",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2013.8018",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1277.4324",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-383.36108",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-94.638672",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-79.187332",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07249451",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-723.36987",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-78.60376",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3665276",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.9778156",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.6678314",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1560297",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.07021",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.78784",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.03307",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.46915",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50218625E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-697.40112",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.63568857E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.654541",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46470.082",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111692.81",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.18935746E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.86155785E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18571040E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-432461.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "491219.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "973.57812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-267.6272",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "51.900818",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02982578",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-746.19727",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "826.84326",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1046.3506",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "182.94312",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.18406302E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.31555474E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1556.5796",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1975.5303",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-331920.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "551816.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.57812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-270.90698",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "15.670349",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.17262",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.48572",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "205.32413",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.21524",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.03307",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.36145",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.24294",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.79565",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003841179",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02713555",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.768373",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.00543",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.02341573E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37437573E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.02341573E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37437573E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003841179",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02713555",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.94399763E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90326602E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.94399763E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90326602E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02984808",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.836033",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06319427",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.207394",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.577271",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.176727",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.939682",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.960342",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.30929857E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03514299",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "196.24281",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.77692",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "195.88577",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.96213",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "195.88577",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.73792",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06701356",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "79.831734",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8556.0625",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-808.59985",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-394.95532",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.698242",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1572.8096",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1977.2305",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-394.95532",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.046631",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-82.895432",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0723114",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-719.60034",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.154785",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1666307",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3876791",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9536152",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5523806",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.30258",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.79321",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.36037",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.13037",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15296064E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-699.4978",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.86823579E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.914795",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46952.336",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111644.7",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.19925936E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74474894E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45486126E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-434196.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "484719.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-279.99219",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "45.009415",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03045795",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258347",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-735.98975",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "958.17896",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-998.45679",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "201.4314",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.99254901E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.05481477E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1779.356",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1858.467",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-320216.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "605495.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.5625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-279.99219",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "9.8577118",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.26683",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.10638",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "204.13396",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.3609",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.36037",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.86401",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.39912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.35809",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006491017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0276714",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.639675",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.81451",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10668898E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.39837930E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.10668898E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.39837930E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.006491017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0276714",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.38375742E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.20701941E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.38375742E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.20701941E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03079716",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.114346",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04729972",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.987503",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.300522",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.204544",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.472092",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.55825",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "3.00708507E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03819112",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.6671",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.69562",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.27531",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.29584",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.3291",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.56079",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.08752769",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.95031",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8524.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-807.43994",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-361.9856",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.279053",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2039.2627",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1416.4526",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-362.71094",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-90.386719",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-77.69928",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07247925",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-711.021",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-74.973389",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.5611629",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8368988",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.0160913",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.22258",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.81998",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.44836",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.76004",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "345.43332",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14252748E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-690.74585",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05553772E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.077637",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47236.762",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111649.4",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.75488729E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.01140779E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22891424E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-451143.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "460532.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "974.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-236.88541",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "52.21875",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02950875",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25839",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-755.54102",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1166.0149",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1495.8433",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "188.32251",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.98145846E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.53057350E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1732.6868",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1968.3713",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-275767.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "574420.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.70312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-236.88541",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.105652",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.25467",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05597",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.66753",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.99329",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.76004",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "341.32199",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.63701",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.25226",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003715722",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02619914",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.439497",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.91327",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.03646144E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.43045227E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.03646144E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.43045227E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.003715722",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02619914",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88139995E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.18557830E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88139995E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.18557830E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.0291393",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.846298",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06025466",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "40.754135",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.744537",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "38.438934",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.426865",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.683075",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.18285413E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03501917",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.53943",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.32611",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "193.44102",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "319.12305",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "193.52956",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.62045",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0792411",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "78.553818",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8520.5312",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-809.41406",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-390.95288",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.623535",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1844.6089",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2017.9797",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-390.95288",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-89.915283",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-83.831924",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07244873",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-704.72363",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-72.86792",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.8570118",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0978174",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1921129",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2686243",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.49567",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.55618",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.46304",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "344.3873",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23486882E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.12524",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.95088306E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.955322",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46666.109",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111635.09",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "8.43839132E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72525927E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-6.32451324E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21713799E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-408624.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "504015.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "972.53125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-280.80713",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "56.597031",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.02915601",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-777.18579",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1064.6951",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1254.8677",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.9231",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.01786474E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.39442783E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1513.2449",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2284.9915",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-320644.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "557562.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.48438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-280.80713",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "12.834518",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.94659",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.68155",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "203.10197",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "314.78378",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.46304",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "340.32285",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.14098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.82458",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.001947387",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02619046",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.907236",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.15942",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.09404409E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27832445E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.09404409E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27832445E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.001947387",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02619046",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91612912E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95193320E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.91612912E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95193320E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02583911",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.636295",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.03953605",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "37.219196",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.893082",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.347916",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-35.359024",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.557617",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.43979628E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03392826",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.04329",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.09259",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.74371",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "318.53821",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.74973",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "323.08273",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.09325933",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "87.449677",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8541.3672",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-803.45117",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.3438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-383.48853",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.375977",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1787.9937",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1572.6152",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-383.48853",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.831055",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-84.150101",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07247925",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.58105",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.604248",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.9073677",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3349552",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.6820345",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5218525",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.66803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "336.42883",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.66026",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "343.88669",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11949123E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-699.10522",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.63641617E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.048584",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47446.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111506.55",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00163902E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "2.01336820E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32790649E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-422355.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "427108.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "979.42188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-266.38794",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "53.86673",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03030113",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258432",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-709.1499",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1059.5808",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1088.1555",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "194.36206",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.03533392E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.77171749E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1524.2573",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1622.0535",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-286650.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "563106.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.42188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-266.38794",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "11.836807",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.21214",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.05762",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "203.45934",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.466",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.66026",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "339.56638",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.48595",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.78284",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002264449",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0273666",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.863129",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.59457",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.91697289E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.42445933E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.91697289E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.42445933E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002264449",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0273666",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.25232634E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05289552E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-2.25232634E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05289552E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03194875",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.784836",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06405747",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.8083",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.124603",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.280426",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.617493",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.835114",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.68441147E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03436437",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "192.01508",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "330.70258",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.96486",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.16617",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.9742",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.54117",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06604862",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.293999",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8524.1406",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-808.16309",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-380.02588",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.095703",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1604.3306",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1904.4141",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-380.02588",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.922607",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-83.445999",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07261658",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-730.21411",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.446533",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.9926596",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0330667",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.3423796",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4377337",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.2211",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.71072",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.23528",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "346.58234",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "9.90011472E-07",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.84326",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "9.61532351E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.564697",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47170.309",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111361.65",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.95850951E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50513608E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14059685E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-420243.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "474700.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "977.45312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-265.47632",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "44.144089",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03026856",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258394",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-714.4834",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1004.769",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1157.0659",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "179.23291",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.62678315E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.16681541E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1936.8181",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1530.4492",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-323229.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "559745.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "978.32812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-265.47632",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "5.6477661",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.11459",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.35162",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "201.98787",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.88055",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "187.23528",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "342.45148",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.31364",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.24921",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002597189",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02598796",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-22.022333",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.03757",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.97397456E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34688635E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.97397456E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34688635E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002597189",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02598796",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88326499E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99396595E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.88326499E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99396595E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02257473",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.349915",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04463705",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.792629",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-30.931976",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.255646",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-34.267044",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.962952",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.85508497E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03559026",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "189.17281",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.85742",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "189.02597",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.52356",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "189.05995",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.92786",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07533187",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.189735",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8531.9609",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-804.53809",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-382.69556",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.993408",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1670.5967",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1446.4949",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-382.69556",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.226074",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-84.99614",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07232666",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-731.62134",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.064941",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.5146856",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9183359",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.306654",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "7.4628172",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.29594",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "338.85919",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.30688",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "348.17929",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31342915E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-696.6748",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.43574526E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "13.814941",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47412.68",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111476.8",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.64833032E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41202452E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28049180E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-401200.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "445409.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "965.3125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-273.88086",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "45.373474",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03025798",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258408",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-829.37671",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "934.71387",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1089.364",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "165.53931",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.35606211E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "6.61970034E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1808.3521",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1791.5139",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-327091.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "589392.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.5625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-273.88086",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "5.3374329",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.29166",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.26578",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "201.26614",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.58725",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.30688",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.67734",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.73802",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.22046",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002105663",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02571083",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.622656",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "408.10696",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.78113167E-06",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35105856E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-9.78113167E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35105856E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002105663",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02571083",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.89539276E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88855302E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.89539276E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88855302E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.03329809",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "33.760426",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.05344814",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.255314",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-32.391739",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.962646",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.444748",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.260101",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.69679049E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03213238",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.56508",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "326.2677",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.31511",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.50162",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.3969",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "324.61386",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.07143551",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "80.262711",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8533.7773",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-802.62427",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-384.09912",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.634277",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1658.582",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1454.0793",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-384.38525",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.228271",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-83.022476",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07246399",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-740.80078",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.086182",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.1104069",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3174629",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.2713947",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3909369",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.39613",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "341.7485",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.29282",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "350.25449",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28756517E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.63794",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22567872E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "14.678711",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "47116.801",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111698.98",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57770238E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63185132E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37380016E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-411028.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "456645.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "979.96875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-261.55542",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "44.516998",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03006941",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258427",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-766.20044",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1053.0063",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1185.3076",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "184.23926",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.73971340E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.36723393E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1531.6736",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1925.1445",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-266021.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "585887.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "979.96875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-261.63477",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "12.505432",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.8177",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "309.94812",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "202.14413",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "316.96057",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.29282",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "346.05508",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "208.92708",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "312.96613",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004142601",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0255136",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.547842",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.68988",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.19360766E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27974827E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.19360766E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27974827E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.004142601",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0255136",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96562542E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99599162E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.96562542E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99599162E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.020519",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.671364",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04830165",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "36.074627",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-28.62442",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "35.253052",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-31.915146",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.853409",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "2.41872783E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03531877",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.19864",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.73486",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "190.1792",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "318.64896",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "190.51141",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.73486",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06635427",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "79.345108",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "8537.6953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-805.48633",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-383.34351",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.310059",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-2238.6836",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1468.0029",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-383.34351",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-86.224365",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-84.641708",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.07211304",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-728.4397",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.229004",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-4.2315912",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5460033",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.1717863",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4586759",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.44",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "337.66525",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.48189",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "347.57983",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17511684E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-701.20264",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "8.73784302E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "15.560547",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "46730.879",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "111593.98",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.42751467E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.54012901E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39902579E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-440610.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "442576.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "976.34375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PTVersion": "128",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "process": "50",
                                                "scale_min": "-251.55209",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PDS_TimeRange": "10",
                                                "gribNumBits": "16",
                                                "gribleveltype": "1",
                                                "scale_max": "54.327866",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.03153343",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-715.96826",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "1259.425",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1324.0605",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1",
                                            "scale_max": "200.45386",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-5.29454724E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "24",
                                            "gribleveltype": "1",
                                            "scale_max": "7.76785782E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-1507.386",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1917.4878",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-315950.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "633704.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.34375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PTVersion": "128",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "process": "50",
                                                    "scale_min": "-251.55209",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PDS_TimeRange": "10",
                                                    "gribNumBits": "16",
                                                    "gribleveltype": "1",
                                                    "scale_max": "8.3148193",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "8",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "210.5074",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06073",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "201.86697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "315.9989",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "188.48189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "343.42749",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "209.74632",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "111",
                                            "scale_max": "313.34009",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002068474",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02608679",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-21.662127",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "407.80209",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.07146989E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31756187E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.07146989E-05",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31756187E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jan2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-0.002068474",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02608679",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.78165101E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77896027E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-1.78165101E-06",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77896027E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "0.02184174",
                                            "grib_name": "wind10",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.915237",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "0.04017266",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "34.676228",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-29.397003",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "31.028488",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "-33.891647",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "32.20253",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "1.45010574E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03794711",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.31723",
                                            "grib_name": "t2mmx",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "327.78668",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "process": "50",
                                            "units": "unitless",
                                            "scale_min": "191.10309",
                                            "grib_name": "t2mmn",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "320.86459",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PTVersion": "128",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "process": "50",
                                            "scale_min": "191.11307",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PDS_TimeRange": "10",
                                            "gribNumBits": "16",
                                            "gribleveltype": "105",
                                            "scale_max": "325.98163",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "484.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/jan2002"
                        },
                        "jul2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "jul2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24year0": "200110",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong24.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23year0": "200110",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong23.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22year0": "200110",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong22.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21year0": "200110",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong21.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20year0": "200110",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong20.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19year0": "200110",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong19.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18year0": "200110",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong18.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17year0": "200110",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong17.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16year0": "200110",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong16.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15year0": "200110",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong15.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14year0": "200110",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong14.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13year0": "200110",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong13.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12year0": "200110",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong12.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11year0": "200110",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong11.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10year0": "200110",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong10.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09year0": "200110",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri_1/forecast_usr/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong9.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08year0": "200110",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong8.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07year0": "200110",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong7.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06year0": "200110",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong6.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05year0": "200110",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04year0": "200110",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03year0": "200110",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong3.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02year0": "200110",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong2.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01year0": "200110",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jul2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri_1/modelling/daved/Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong1.D/PerSSTFcst1sea.D/Yr2001.D/July.D/00001test_%6d.01",
                                "description": "forecast starting jul2001",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04841085",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.952095",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8485.2383",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-780.10132",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.0312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.96729",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.383789",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1148.8816",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2138.6558",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.2812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.96729",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.937256",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.796555",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009216309",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-747.14771",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.558594",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0134907",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.3534842",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8614225",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4375143",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.29417",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.918",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.37245",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.66968",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10258145E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.21729",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7160492",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01921614E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.333496",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48662.617",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112407.65",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.56962698E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63030211E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43178772E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-392033.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "440410.62",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "927.59375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-251.41679",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.931946",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02976833",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258493",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-669.22388",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1032.772",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1409.9768",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "191.40845",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.63810261E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.65419088E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1574.3513",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2238.1631",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-280703.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "624392.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "928.14062",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-251.41679",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "50.84581",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.34619",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.53955",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.67812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.89728",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01136118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02792187",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.267338",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.76379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.56847236E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88974882E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56847236E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88974882E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01136118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02792187",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.10409985E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91257664E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.10409985E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91257664E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02591996",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.279404",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05611027",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.509064",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.696716",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.80603",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.418106",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.046478",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.04186427E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03667531",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "190.38939",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.32382",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "190.04964",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.52441",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "190.22501",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.32281",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0408787",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.48571",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.9766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-775.20264",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.5625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-398.47949",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.205811",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1238.7136",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1996.751",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-398.47949",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.005615",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.917847",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008499146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-737.26245",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.19873",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5711365",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7172089",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9198427",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3191233",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.99496",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.47284",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.9008",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.90149",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27621081E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-687.76074",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6806335",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27623207E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.541992",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48587.098",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112227.22",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.37863482E-29",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.61663250E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.72601892E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66053542E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-437388.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "409644.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "939.98438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-249.05804",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "67.859726",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03194284",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258463",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-876.11694",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1039.1482",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1490.6074",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "185.01562",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.96052132E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.39846655E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1942.0132",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2364.6077",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-240633.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640179.88",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "941.04688",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250.23669",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.438339",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.47919",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.9538",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.67003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.47232",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003346701",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0300095",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.534725",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.94022",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57008399E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87785954E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57008399E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87785954E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003346701",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0300095",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.03398940E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02062120E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.03398940E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02062120E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02374493",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.95343",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03683168",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.528385",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.978546",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "28.010056",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.836639",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.187241",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.84229507E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04275441",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.23944",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.27066",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.19841",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.6423",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.23279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.42554",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04191047",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "101.37698",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8537.2305",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-770.16016",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.2188",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-406.89917",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.581055",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1393.4587",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2019.0798",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.2188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-406.89917",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.276367",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.944427",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008712769",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-740.93896",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.588867",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1576595",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0516644",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.3568439",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5708022",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.33459",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.25909",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.31044",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.33716",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19836216E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-701.02368",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.82254278E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.478271",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48382.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112119.61",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.74828186E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65567030E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26413181E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-410708.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "390798.25",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "926.17188",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-256.62354",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "81.919968",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03086724",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258499",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.59644",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1090.8506",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1659.9202",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "180.10449",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.63755600E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.20208959E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1823.5715",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2307.6624",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-297694.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640789.38",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "927.39062",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256.89966",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.893204",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.55618",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.56985",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.02513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.56482",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004714988",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03176913",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.270735",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.88635",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.52444272E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88570666E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.52444272E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88570666E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004714988",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03176913",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.02274509E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99569331E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.02274509E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99569331E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02868999",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.670757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04781121",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.488438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.087616",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.575455",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-36.093018",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.519241",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.82603786E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03943696",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.07173",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "341.17844",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.78822",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.78006",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.79039",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.56833",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04450023",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "91.915459",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8502.0078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-775.74072",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.0625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-399.06567",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.387207",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1484.2971",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2297.4873",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-399.06567",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.504395",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.972504",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008895874",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.88916",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.395508",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.0783377",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0786829",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.2386856",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5203724",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.42061",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.07404",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.38008",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.55798",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16695446E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-684.38159",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10658584E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.353516",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48519.934",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "111954.22",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.33241756E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "2.31695162E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42755914E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-390559.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "422214.19",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "921.6875",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-248.94061",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "73.201324",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03046005",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258457",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-670.74707",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "949.14111",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1243.0356",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "202.90991",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.97055112E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.11401151E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1881.5173",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1990.4465",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-288629.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "610558.81",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "928.07812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.94061",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "41.560425",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.00807",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.21118",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.20233",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.39325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007814683",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03030431",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.493683",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.91501",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.58334478E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87500737E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58334478E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87500737E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007814683",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03030431",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.01769944E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96009114E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.01769944E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96009114E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.0228261",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.80611",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04748452",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.634663",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.762939",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.112061",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.53125",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.804321",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.19561023E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03764847",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.56183",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.84549",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.48514",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.73645",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.52739",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.2027",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04480016",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.138573",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8529.9375",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-778.96875",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-397.23779",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.827637",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1423.7795",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2260.5022",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-397.23779",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.327637",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.331558",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008514404",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.26489",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.08667",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7280178",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.1453543",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9430256",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.894537",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.92545",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.3114",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.92566",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.93365",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18518551E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.75952",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7235718",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00425677E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.275879",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48380.793",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112647.43",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.89884303E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49747245E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.40042879E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24413680E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-431837.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "425815.75",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "923.0625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-256.30591",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "72.656921",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03050959",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258368",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-815.83325",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "901.47461",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1321.2415",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "224.35205",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.28327462E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.97140069E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1803.6011",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2395.8499",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244786.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "609800.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256.30591",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.029694",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.43034",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.65106",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.91556",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.92181",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008838981",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03013644",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.519909",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.84595",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.58094299E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97484987E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58094299E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97484987E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.008838981",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03013644",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.81757252E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94477775E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.81757252E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94477775E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02528217",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.346115",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06030263",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.293625",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.271667",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.139114",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.820877",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.246063",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.99931854E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03550168",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.629",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.67548",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.44565",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "323.50592",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.5155",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.51678",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04726705",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "97.906624",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8531.0547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-780.10938",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-396.1875",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.368896",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1292.8506",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2304.519",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.3125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-396.1875",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.970459",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.658875",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008682251",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-731.05615",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.706787",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2794733",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.370903",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2412338",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4452085",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.65762",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.00372",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.63562",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.17221",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37481163E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-646.60889",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05871004E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.608398",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48541.773",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112859.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.20725885E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.52107155E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56511101E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41442990E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-436129.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "409526.94",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "920.60938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-252.01825",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "82.879532",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02972694",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258446",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-717.5",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "843.30786",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1326.4553",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "266.1687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.30412365E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06435806E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1854.7988",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2333.7346",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-274364.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "654580.25",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "920.60938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-252.01825",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.775253",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.43042",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.07495",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.52864",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.47638",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006100878",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02823432",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.616758",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.92813",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57949707E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81384130E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57949707E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81384130E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006100878",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02823432",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.26121938E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93773644E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.26121938E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93773644E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03303268",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.597385",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06366444",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "40.132313",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.065414",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.301697",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-39.50499",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.972519",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.53634595E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03615223",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.27203",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.83893",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.01881",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.77441",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.01881",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.7677",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04017646",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.131248",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.4102",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-776.19336",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.0312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-383.70581",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-70.39502",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1353.8601",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1958.5125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.3125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-383.70581",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-70.505615",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.89476",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00881958",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.89453",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-59.765625",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.4509821",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4788933",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1887703",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.9673271",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.36832",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.06543",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.30725",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.13092",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12920907E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-640.09692",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6918182",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03111961E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.321289",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48600.441",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112211.35",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.99105260E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.76121546E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.79270329E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37680877E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-394473.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "435827.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "919.60938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-266.08716",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "68.057373",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02962728",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-701.9248",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1504.6343",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2001.8586",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "176.69214",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.00487271E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.06545507E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1464.6079",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2183.252",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-281298.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627331.94",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-266.11084",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.736176",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.18707",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.13043",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.12102",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90778",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00809129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02923661",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.382994",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.55594371E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91159397E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55594371E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91159397E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00809129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02923661",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.03061563E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96900805E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.03061563E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96900805E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02248749",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.947159",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0609365",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "39.489094",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.963196",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.588821",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-38.8414",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.537201",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.58260558E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03627151",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "184.17397",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.23743",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "183.99272",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.45572",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.10408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.83408",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04672921",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.248749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8479.3242",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-767.69751",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.9375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-396.31299",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.506592",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1542.4355",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2432.3",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.3125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-396.31299",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.475342",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.131424",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008590698",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-722.52075",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.530518",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6199675",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5376244",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8240051",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4968348",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.86426",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.93445",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.86063",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "344.33691",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16172168E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.77148",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7085266",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16182491E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.911133",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48628.992",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112140.86",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.67917754E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71401973E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.35525294E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45652984E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-390387.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "440179.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "922.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-261.21387",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.459946",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03086368",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258373",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-766.46338",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1023.739",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1144.0845",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "228.36914",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.57487317E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.13189524E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1649.7627",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2137.5735",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-275970.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "596141.06",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "933.8125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-261.21387",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.401505",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.18874",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.24731",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.42705",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.1004",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003269118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02963572",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.618971",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.64328",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.54275112E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80025472E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.54275112E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80025472E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003269118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02963572",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.90784976E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22406447E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.90784976E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.22406447E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02449528",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.016857",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05075592",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.312317",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.957565",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.201202",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.375504",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.267303",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.06352887E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03846481",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.92935",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.5087",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.67233",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.74066",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.7084",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.77985",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04649346",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.248955",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8480.9688",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-780.84888",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.4375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-406.08105",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.873047",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1377.6245",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2279.1772",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-406.08105",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.430908",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.05545",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009231567",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-751.64624",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.221191",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0257692",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4118919",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1311779",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.9197617",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.71117",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.20868",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.69147",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.41364",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31998343E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-702.10132",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16942101E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.500488",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48485.691",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112525.77",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.78378001E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.70348312E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53595383E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21250650E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-419639.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "420385.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "924.82812",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-267.68384",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "71.852417",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03108256",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25852",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-658.88037",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "959.84277",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1298.9092",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "199.32886",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.19397418E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.97072346E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1838.2407",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2294.7344",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-259309.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "638081.81",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.82812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-267.70532",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.877228",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.13361",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.31329",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.47873",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.42542",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005120184",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03090502",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.060238",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "411.05795",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.53367564E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88598151E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53367564E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88598151E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005120184",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03090502",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.95598273E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10331496E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.95598273E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10331496E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03662806",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.498623",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05939101",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.26685",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.522781",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.956879",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.431976",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.240021",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.08764539E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03842342",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.01878",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.29889",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.6338",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.74054",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.65785",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.21161",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03997175",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "92.898384",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8477.4766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-777.80444",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.4062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-385.48242",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.535889",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1465.5168",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2032.4902",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.75",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.48242",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.246826",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.998077",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009094238",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-738.104",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.955322",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.4384079",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9221735",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.471734",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7392607",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.39265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.53113",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.38461",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.17749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39542806E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-669.60254",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.006835938",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22020720E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.93042",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48302.504",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112088.95",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49481785E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.77509048E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37957693E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-423497.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "429581.81",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "923.95312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-238.22247",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.011612",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03042956",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258518",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-761.0188",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "958.98438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1380.4905",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "186.64453",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.52019515E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.46355511E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1996.6973",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2441.0239",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-253850.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "607310.19",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.5",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-239.12207",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.307022",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.25571",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.62094",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.32478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.0412",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007055517",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02922263",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.5772",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.67642",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.50787928E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85564295E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.50787928E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85564295E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007055517",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02922263",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.95994676E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85042529E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.95994676E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85042529E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03492163",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.69146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999356",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.844501",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.419998",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.217697",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.043625",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.290981",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.20806304E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03803496",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.91098",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.64612",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.67073",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.40759",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.68694",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.64612",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.01948404",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.277382",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8488.5859",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-779.09302",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.5312",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.60645",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-72.462402",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1590.7803",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2044.6345",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.0938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.60645",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.243652",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-93.730087",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009368896",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-740.77881",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.159424",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7670803",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9184732",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9839334",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4306402",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.74579",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.21417",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.56845",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.86111",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62469109E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.05298",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7126617",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09686516E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.396973",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48654.406",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112359.37",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.13339375E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66245229E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28915701E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-399311.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "405192.75",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "917.17188",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-257.54248",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "72.98262",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03047132",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258373",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-932.17749",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1081.3821",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1311.0935",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "198.74634",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.24269581E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.94735797E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1872.4963",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2261.0571",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-235797.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "627070.44",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "922.0625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-257.54248",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.683655",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.35565",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.35175",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.40874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.46793",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004271358",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03164204",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.840345",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70786",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.61344997E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80232546E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61344997E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80232546E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004271358",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03164204",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.93590608E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13764815E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.93590608E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13764815E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03094406",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.83596",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05811464",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.442425",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.400803",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "27.391785",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.557892",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.095505",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.58955707E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03798636",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.9023",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.07397",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.95406",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.14835",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.07362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.73047",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04407495",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.134377",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8459.25",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-772.21826",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.25",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-398.20435",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.010742",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1366.864",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1812.4375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1143.8125",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-398.20435",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.296143",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.064346",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008010864",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.38574",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.626709",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.932066",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0293322",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9578733",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1326036",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.16",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.92169",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.07524",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.80151",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66310349E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-651.07861",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7140961",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15184230E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.890137",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48386.727",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "111998.11",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.26357450E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.93844403E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10678976E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30152000E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-433819.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "412455.44",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "924.29688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-250.33278",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "78.548279",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03157329",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258429",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-726.11401",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "992.86987",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1374.1775",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "180.68213",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.49495098E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.22521918E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1603.73",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2045.6055",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-260648.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "665274.12",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "925.51562",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-250.33278",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.91156",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.03946",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.32852",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.08723",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.04352",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004060101",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03110993",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.971632",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.62604",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.53645997E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81852865E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53645997E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81852865E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004060101",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03110993",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.97974418E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91023537E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.97974418E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91023537E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02661591",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.092163",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04086019",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.071529",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.74762",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.220139",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.844604",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.374786",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.77838113E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03763219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.95839",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.40686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.42467",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.99579",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.58356",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.36972",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04214353",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "99.38974",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8484.875",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-764.51855",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1144.8438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-401.61255",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.772949",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1308.8367",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2735.499",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.8438",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-401.61255",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.772949",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.440384",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009140015",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.79761",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.427734",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2109289",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8759508",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2148819",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5658655",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.51074",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.0451",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.37706",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.01941",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59126751E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-614.12549",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03205093E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.688477",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48662.617",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112422.67",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.18315903E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.83873669E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36494521E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-394166.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "462490.88",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "915.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-242.04468",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "69.758057",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03030907",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25848",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-671.17944",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "937.72754",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1419.5657",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "269.30737",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.67644577E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.07689345E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1853.7639",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2092.0005",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256973.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "658416.12",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "919.1875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-242.04468",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.198547",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.22699",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.99847",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.41672",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.75714",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005199336",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03023264",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.488222",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.96198",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.45274225E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87968089E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.45274225E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87968089E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005199336",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03023264",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.05420997E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92223706E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05420997E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92223706E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03278191",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.065731",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06401944",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.832783",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.157898",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.563156",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.147003",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.812119",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.47659215E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03793689",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.15047",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.06757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.72565",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.72495",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.79536",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.71228",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0464203",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.462769",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8545.0508",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-762.57861",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.83228",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.108887",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1392.5374",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2541.4636",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.83228",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.812012",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.201202",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008621216",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-725.40137",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.841553",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.728096",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.3779812",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1966228",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5479097",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.76088",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.13086",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.70326",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.78604",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.96948963E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-722.96387",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04994979E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.256348",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48522.27",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "111969.38",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.76424634E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "2.28440467E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51488587E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-386268.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "408749.12",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "915.53125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-263.10254",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "68.477783",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03024151",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258352",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.87939",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "966.42188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1340.7935",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "212.82031",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.36145706E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.51001118E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1869.1865",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2098.0498",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-268230.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640463.81",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "919.23438",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-263.12744",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.571991",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.59273",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.64154",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.5125",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.36627",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007441636",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02806293",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-20.309845",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.82767",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.55706530E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86530724E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55706530E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86530724E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007441636",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02806293",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.99693204E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83584950E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99693204E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83584950E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02795134",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.328365",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04609264",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.762306",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.590027",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.374374",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.043625",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.957184",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.94244102E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03976219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.67534",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.00757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.38182",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.85553",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.41205",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.86835",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05071706",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100.98164",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8515.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-769.42188",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.8125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-394.96118",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.951416",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1352.3604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1954.6631",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.1875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.96118",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.874512",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.706802",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009277344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-731.74121",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.97583",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0668468",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4067593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5245333",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6361341",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.19379",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.15717",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.09625",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.81165",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32670687E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.31519",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7285461",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09270331E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.14209",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48012.43",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112153.02",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.81961455E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67330620E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.25643225E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34023810E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-410119.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "463635.56",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "916.59375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-245.0661",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "72.004684",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03104591",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258425",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-764.01782",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "984.06177",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1349.3127",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "166.36987",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.39552332E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.65236257E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1583.4849",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1994.1067",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244135.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "629952.44",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "922.35938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-245.0661",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "51.673126",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.39832",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "308.81238",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.81369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "312.85876",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003636141",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0287878",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.65206",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.89188",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.56096175E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86848283E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56096175E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86848283E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003636141",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0287878",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.07127050E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02117963E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.07127050E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02117963E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02633329",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.911438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05523029",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.974724",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.861267",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.42482",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.723114",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.86058",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.20311277E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03941672",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.54944",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "339.35004",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.45705",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.59863",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.48967",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.39941",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03777998",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "99.329536",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.918",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-775.29346",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.125",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-410.11377",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.991455",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1441.1106",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2331.2207",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.9688",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-410.11377",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.752197",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-91.096283",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008499146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-724.80908",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.713867",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.1678686",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1485853",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8397913",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4791775",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.68034",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.93689",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.66293",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.67621",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22276754E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-682.97363",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.730484",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.76957381E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.502686",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48126.828",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112235.3",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.74355761E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.82304473E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31187903E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-414318.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "447788.06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "921.73438",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-258.09497",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.382401",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02990348",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258415",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-676.96851",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "904.27759",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1181.0903",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "242.31177",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.72284910E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.68955192E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1751.4719",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2497.8333",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-226444.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "616460.31",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "923.26562",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258.12061",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.879669",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.30997",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.37833",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.27934",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.57431",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005361613",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03440683",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.93919",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.88531",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.60988584E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88990325E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60988584E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88990325E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005361613",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03440683",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.88228228E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89641617E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.88228228E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89641617E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.0276829",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.536282",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04794061",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.798176",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.289932",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.332092",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-36.224045",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.679474",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.43782004E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03439093",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.34906",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.97394",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.17065",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.70593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.1707",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.5416",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03696631",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.179482",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.1211",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5324707",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-770.66504",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1140.1875",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-404.04688",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.544678",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.7188",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-404.04688",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.505615",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-14.866614",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "37.761902",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6593456",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "365.49292",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-18.940338",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "19.561243",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.90307393E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.04795122E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "303.04688",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.845032",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009277344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-735.67163",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.755859",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.47833",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.84024",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9800644",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3611841",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5769949",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2065706",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.71715",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.70422",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.4749",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.42123",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.58064",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.10138",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.47888",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.34875",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42351507E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.31929388E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-649.80151",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7084656",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27826934E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.901123",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48594.809",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112799.46",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.29299961E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.54959253E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28271995E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "932.75",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-262.27637",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "73.893127",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03002507",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258493",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1049.5791",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1313.9565",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1403.6399",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "184.46948",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.61276295E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.33384411E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.28859745E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.23891253E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "932.75",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-266.19458",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.06958",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.19362041E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "230.25194",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.37917",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.86157",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.49438",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.8129",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.98532",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.48041",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.47888",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.18079",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.3414",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.1174",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005308017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02887106",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.510513",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.53763",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.62140441E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89943967E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62140441E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89943967E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-4.33680869E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.00334543",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005308017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02887106",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.95634925E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80438496E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.95634925E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80438496E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02210074",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.301544",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03153383",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.883656",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.00592",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.2397",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.697128",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.663254",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.84991274E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03862129",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.98793",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "338.0202",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.7952",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.4024",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.84601",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.4436",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05034413",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.177315",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8460.4531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.756073",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-782.69043",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.1562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-395.51758",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.427979",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.51758",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.708008",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-15.990088",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "42.002884",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6867371",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "324.35205",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-18.635483",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.59293",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.68015986E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.83572483E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "303.01562",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-92.134079",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009246826",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-720.16602",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.327881",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.2679",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.77954",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8491182",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5191317",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9990788",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.126647",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.57494",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.30914",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.20016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "333.43268",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.34691",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.69464",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.20016",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.04611",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.52823452E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.39952197E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-650.23584",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.692749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15184230E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.010742",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48657.945",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112151.7",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.22314553E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74427839E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23122481E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "922.0625",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-248.96684",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "65.191467",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03046585",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258455",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-861.1897",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1077.1257",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1394.1626",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "237.21655",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.57486601E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.48547267E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.15543469E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.87436852E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "923.85938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.96684",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.828857",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.41182167E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "189.75865",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.27342",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.89844",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.22537",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.80084",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.50462",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.86166",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.20016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "336.68018",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.44322",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.24847",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0049689",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03017703",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.376488",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.98752",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.62443885E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85907029E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.62443885E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85907029E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.43945489E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003494143",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0049689",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03017703",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.26428688E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84885130E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.26428688E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84885130E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02443334",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.800739",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06744623",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.441269",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.687576",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.066757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.78804",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.607132",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.20052277E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03840603",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.09694",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.49103",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.73024",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.28888",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.9415",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "340.48999",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03311469",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "97.924789",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.3164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5623474",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-780.7832",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.6875",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-396.85474",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-69.371826",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.5625",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-396.85474",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-69.371826",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-15.060859",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "35.281609",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.7712936",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "289.85938",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-24.401459",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "19.103655",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.04029117E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.99356198E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.98438",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.013916",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008132935",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-743.81982",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-59.601074",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.12517",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.54675",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9318085",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3168859",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.7190208",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.9500046",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.2688",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.77124",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.23563",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.00757",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.24825",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.44446",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.24529",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.93481",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33946162E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.17322019E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-665.15894",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7055511",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24223880E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.836182",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48443.086",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112400.41",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.72346902E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "2.11170391E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30897445E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "924.14062",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-255.6349",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "63.69426",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03022504",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258415",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-662.88843",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1262.2397",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1632.4016",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "256.98022",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.52751737E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02759316E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.24952339E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.96793017E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "924.84375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-255.6349",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.509247",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.72888384E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "278.08661",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.13751",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.45782",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.5164",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.23434",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.76717",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.83228",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "180.24529",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "336.36841",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.16206",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.70804",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004943583",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03332553",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.964241",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.7959",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57053910E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78734954E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57053910E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78734954E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003179908",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004943583",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03332553",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.10206895E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92600010E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.10206895E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92600010E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02223193",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.914509",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0520682",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.374207",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.420624",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.599213",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.493561",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.875946",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.31540695E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03629909",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "183.41037",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "339.12756",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "183.3558",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.30249",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.39972",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "338.37918",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05335968",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.609344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8516.0938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.616394",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-771.38745",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.9688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.5144",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.917236",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.7812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.90479",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.631836",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.270279",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "36.899277",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.6788969",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "389.33282",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.345215",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "18.620018",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.69001530E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.63731587E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.088455",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008056641",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.85547",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.900146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.41216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.91104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3391647",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8843222",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5879078",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8241749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.60164",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.47379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "332.12903",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.48784",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.73026",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.47379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21451785E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92318943E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.92969",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05629442E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.049072",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48590.266",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112052.2",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.87176282E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59023534E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.60282832E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "917.5",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-265.27954",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "69.389526",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03064082",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.55347",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1285.3765",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1766.5281",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "176.77026",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.06385208E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.06839671E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.05856680E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.57518399E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "918.45312",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.27954",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.927002",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.32712875E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "185.8326",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.35515",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.97235",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.37939",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.6618",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.1183",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.14172",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.52261",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.44012",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.19791",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005941264",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02935665",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.316423",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.93091",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.48751942E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85859117E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.48751942E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85859117E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-3.04931861E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003569305",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005941264",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02935665",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.31127774E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93007145E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.31127774E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93007145E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.0194447",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.52866",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04667433",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.997086",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.389664",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.804413",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.367752",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.45961",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.36919946E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0410027",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.71045",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.91324",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.4519",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.56671",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.47513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.66443",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05335968",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.609344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8516.0938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.616394",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-771.38745",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.9688",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.5144",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.917236",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.7812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-390.90479",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.631836",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.270279",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "36.899277",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.6788969",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "389.33282",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.345215",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "18.620018",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.69001530E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.63731587E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.088455",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008056641",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.85547",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.900146",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.41216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.91104",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3391647",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8843222",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5879078",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8241749",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.60164",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.47379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "332.12903",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.48784",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.73026",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.47379",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21451785E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92318943E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.92969",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05629442E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.049072",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48590.266",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112052.2",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.87176282E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.59023534E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.60282832E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "917.5",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-265.27954",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "69.389526",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03064082",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.55347",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1285.3765",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1766.5281",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "176.77026",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.06385208E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.06839671E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.05856680E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.57518399E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "918.45312",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.27954",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.927002",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.32712875E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "185.8326",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.35515",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.97235",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.37939",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.6618",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.1183",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.14172",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.3661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.52261",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.44012",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.19791",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005941264",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02935665",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.316423",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.93091",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.48751942E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85859117E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.48751942E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.85859117E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-3.04931861E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003569305",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005941264",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02935665",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.31127774E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93007145E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.31127774E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.93007145E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.0194447",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.52866",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04667433",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.997086",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.389664",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.804413",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.367752",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.45961",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.36919946E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0410027",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.71045",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.91324",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.4519",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.56671",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.47513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.66443",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03403548",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.151962",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.1328",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5658264",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-787.67285",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1141.0",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-391.32935",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.724121",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.1875",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-391.32935",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.356934",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-17.639084",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "36.648872",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6924744",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "235.16986",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-20.439072",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.046127",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.98237041E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.07073307E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.90625",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.762207",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008758545",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-728.37744",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.227295",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.78841",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.77643",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1811943",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9428196",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8218155",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0352283",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.98322",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.1275",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.8326",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "333.16071",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.88748",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.74414",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.97238",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "342.48486",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36446215E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.93495346E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-686.00439",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007324219",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6802826",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.36037395E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.674316",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47879.23",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112257.25",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.51769369E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.93322808E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.39434769E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "917.26562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-263.90796",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "78.770737",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03085741",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-737.9187",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "953.53491",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1445.6426",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "223.65625",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.78071990E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.94348489E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.48636909E-07",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.65709513E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "920.10938",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-263.95996",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.447159",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.07278164E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "186.07854",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.36678",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.02106",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "194.38501",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.59357",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.07983",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "326.02136",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.97238",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.40479",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.27568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.2081",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01006534",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02748195",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.547709",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.86874",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.55819907E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88859267E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55819907E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88859267E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003299236",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.01006534",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02748195",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.20858601E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98607881E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.20858601E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98607881E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03115616",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.254341",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05071262",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.372139",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.24324",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.857407",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.392609",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.461182",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.60110199E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03676247",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.67842",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.02252",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.50911",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.14154",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.64851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.84729",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04450122",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.089119",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8489.9219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.525177",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-775.3064",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1143.75",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-413.82983",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.98999",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1145.0",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-413.82983",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.685303",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-20.243484",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "40.253807",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.9020338",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "259.08173",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-17.685867",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.843128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.59595366E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.70312142E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.88281",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-92.254333",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008728027",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-735.61011",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.473633",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.67474",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.78488",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3052988",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1496878",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2939377",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4231958",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.90274",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.23877",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.71034",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.71344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.76617",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.93326",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.72023",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.15674",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13511624E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.24023962E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-701.36157",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.6777344",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.78878234E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.775635",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48242.414",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112157.48",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.80937000E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58532532E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.53595383E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.40416000E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "921.09375",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-248.11716",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "76.518921",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03189293",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258465",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-661.13916",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1201.2961",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1280.2114",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "236.30664",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.11920689E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.44908152E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.93064759E-07",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.96464269E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "921.09375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.11716",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "25.360855",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.22151900E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "212.14461",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.92989",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.93573",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.0385",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.22867",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.37573",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.43439",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.72023",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "339.31299",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.1161",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.33087",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006066062",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.0285325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.457426",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.95956",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.60148174E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92278821E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.60148174E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92278821E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.57498016E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003417134",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006066062",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0285325",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.04573644E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07604285E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.04573644E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07604285E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.031106",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.050541",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04907893",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.020805",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.882401",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.828812",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.834015",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.144699",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.89346962E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03834767",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.526",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "336.45322",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.32214",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.69446",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.38248",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.23361",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04169669",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "92.431831",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8464.5156",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "164"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated liquid water content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.4952393",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "231"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-779.79785",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1142.0938",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-399.55542",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.036377",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1144.9375",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-399.55542",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.803467",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "129"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "meridonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-14.379056",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "38.14299",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "196"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "gravity wave dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8758688",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "285.59241",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "197"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "zonal gravity wave stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-26.117996",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "19.341057",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "195"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "u*^3",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.23389176E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.40345907E-04",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "159"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.85938",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "206"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.279999",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008758545",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.68335",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.368164",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "205"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "effective sea-ice skin temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.00871",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.84143",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "213"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "total cloud cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "163"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9968395",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4318266",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.9645653",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.3073168",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "180"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.21938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.12137",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "214"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "minimum air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.02956",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "331.43744",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "215"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.09616",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.5769",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.1864",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.12137",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23322718E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "160"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "skin reservoir content (t-1)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.00345694E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "194"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-675.27588",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.72995",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.99163603E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.365967",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48585.273",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112387.55",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.20978778E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50885091E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28067734E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "143"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "921.76562",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-260.46802",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "75.085632",
                                                "PDS_TimeRange": "10",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03166922",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-655.34985",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "995.573",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1279.9473",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "189.7478",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "147"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.11815074E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.58729186E-08",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "182"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow depth change",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.00167847E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.21546996E-07",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "221"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "929.82812",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-260.46802",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.361389",
                                                    "PDS_TimeRange": "10",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Boundary Layer Dissipation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.22302871E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "203.22055",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "145"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.62511",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.8634",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.3829",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.04517",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "209"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.84912",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.21848",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "208"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.1864",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.88504",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.71211",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.15283",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004732523",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03061776",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "PDS_TimeRange": "10"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-19.313688",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69922",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57420982E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81298801E-05",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57420982E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81298801E-05",
                                            "PDS_TimeRange": "10"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jul2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "PDS_TimeRange": "10"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Liquid Water Content",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-4.33680869E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.00319314",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "153"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004732523",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03061776",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.92719585E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99298051E-06",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92719585E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99298051E-06",
                                            "PDS_TimeRange": "10"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03214817",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.610825",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05516426",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.40646",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.279144",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.492203",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.097046",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.99025",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.15985301E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0414033",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.03195",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "339.13715",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "188.91408",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "325.89276",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.9142",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.78241",
                                            "PDS_TimeRange": "10",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                }
                            },
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "PDS_TimeRange": "10"
                                        }
                                    }
                                }
                            },
                            "Z_11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "303.75"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "30.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/jul2001"
                        },
                        "jun2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "jun2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong8.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem08year0": "200109",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong7.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem07year0": "200109",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong6.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem06year0": "200109",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem05year0": "200109",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong5.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem04year0": "200109",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong3.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem03year0": "200109",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong2.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem02year0": "200109",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.jun2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri_1/modelling/daved//Makos.D/ForcastDiv.D/ECHAM4_3.23.D/EXP.D/LongRun1.D/IriLong1.D/PerSSTFcst1sea.D/Yr2001.D/June.D/00001test_%6d.01",
                                "SIXHOURLYmem01year0": "200109",
                                "description": "forecast starting jun2001",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03945732",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.744576",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8460.4336",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.4791565",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-761.32861",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.1562",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-406.34009",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-80.341553",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1122.8438",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-406.34009",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.138428",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-15.4705",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "41.053024",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.2007236",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "310.21945",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-20.454651",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.721185",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.61268796E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.29572368E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "303.04688",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.943848",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.00831604",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.82275",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.427979",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.10596",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.89975",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.5679951",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.7554865",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0039778",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7157068",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.3506",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.18283",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.14156",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "332.86914",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.21452",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.75244",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.2045",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.96771",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16829438E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.25530048E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-643.69263",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7062225",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16831507E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.852051",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48348.227",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112741.75",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.91118566E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48142726E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32573814E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "913.57812",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-245.69696",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.019592",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02999841",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258495",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-779.16235",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "941.55737",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1415.3833",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "227.85132",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.65972130E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.11105928E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.17084221E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57548889E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "918.35938",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-245.69696",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.624359",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.82870998E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "213.60181",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.6579",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.39813",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.02853",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "317.72638",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "191.10869",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.37473",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.2045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "335.3974",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.00339",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.02682",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006168544",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03030651",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-21.022957",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.77139",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.55584221E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77909915E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55584221E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.77909915E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.40557357E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003385961",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006168544",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03030651",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.92101675E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02444744E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92101675E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02444744E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03286216",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "38.929691",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05430986",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "39.201241",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.684967",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.814835",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-37.290527",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.561478",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.03837010E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.036694",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.76906",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.94003",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "189.53894",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.45981",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.5632",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "331.612",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03661076",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "102.63074",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8516.1992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5858459",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-759.64062",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1120.875",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-389.91577",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.825928",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1123.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-389.91577",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.919678",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-15.996517",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "40.426147",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8824244",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "303.10699",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-17.996445",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "17.831234",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.99011632E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.42124903E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "303.01562",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.140594",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008972168",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-734.40186",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.266846",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.82425",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.47986",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5771189",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9656677",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7384348",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8147645",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.03635",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.56122",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.87758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.14151",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.94124",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.54105",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.87758",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.84045",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.37624977E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.53131452E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-682.0647",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7134552",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23851351E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.008301",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48150.516",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112054.83",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.63379126E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56501062E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44135799E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "919.78125",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-249.68831",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.418839",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03046697",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-804.43555",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1003.5232",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1401.1211",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "202.73267",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.60269086E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.10669860E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.24102723E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.34068329E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "920.59375",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-249.68831",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.246048",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.65037626E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "142.82828",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.31795",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.60895",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.49487",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.53314",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.40018",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.8692",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.87758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "336.13733",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.30147",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.17255",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005266599",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03076908",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-20.888111",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68921",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.55487432E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82146032E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.55487432E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82146032E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003279448",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005266599",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03076908",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.80608913E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07697917E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.80608913E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07697917E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02525562",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.828049",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05137027",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.155819",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.684235",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "29.523132",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.344666",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.472305",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.76442317E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03522627",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.22809",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.15222",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.00133",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "328.41898",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.00133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "332.42679",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04086367",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.50647",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8481.5703",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5797424",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-755.85742",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.0312",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-385.86328",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.713135",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1122.8125",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.17529",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.931885",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.252563",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "35.838947",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.2672167",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "305.70972",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.436539",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.144573",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.79459063E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.15388155E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.98438",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.039932",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008773804",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-734.16406",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.009521",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.91156",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.42566",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.4719076",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "2.9903994",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8359137",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8616438",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.01572",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.23398",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.96048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "331.04095",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.00899",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.3754",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.96048",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "341.21426",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32961793E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.27698256E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-658.43506",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12253474E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.856201",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48285.156",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112698.42",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.31808598E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.95548273E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27345891E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "916.21875",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-246.00389",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.617371",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03062351",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25835",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-711.1189",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1096.2397",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1460.2383",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "225.85132",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.83908445E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "9.03085891E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.13734586E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.43971680E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "921.15625",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-246.00389",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.321304",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "5.27519151E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "206.84396",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.23457",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "310.1662",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "195.09692",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.75079",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.58191",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.52527",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "181.96048",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.38614",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "208.99062",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.42419",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00405892",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02981668",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-21.117056",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68851",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.61487515E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83261873E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.61487515E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83261873E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-4.33680869E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003427267",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00405892",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02981668",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.72535579E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89418495E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.72535579E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.89418495E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02856446",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.651356",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.07415134",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.821377",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.464859",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "31.741425",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.441879",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.126343",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.04246190E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.05988204",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "185.03024",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "338.70068",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "184.96025",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "324.4671",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.9677",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.89679",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03958098",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.311317",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8522.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5846558",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-754.49683",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.8125",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.32007",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.281494",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1123.0312",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.32007",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.179932",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.702209",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "37.240341",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7620573",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "315.09375",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.383163",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "17.284752",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.17237684E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.39731574E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.502075",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007980347",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.34546",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.497803",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.70279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.09277",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.3605957",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9715328",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5578594",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6358585",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.81485",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.00439",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.79803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "333.10629",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80437",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.83533",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80081",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.56625",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47442495E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.42184328E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-687.2959",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12983980E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.032227",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48202.211",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112031.46",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.86000931E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75105708E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25808162E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "915.9375",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-241.31444",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "72.236862",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03079011",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258419",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-840.59424",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "924.23755",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1378.5061",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "254.26733",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.51225980E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01674885E-07",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.12998202E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.13805469E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "919.125",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244.13628",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.476181",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.86857316E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "129.28563",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.41861",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.63345",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.68668",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.97644",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.85562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.53235",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80081",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "335.00375",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.45482",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.91391",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004988946",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02867297",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-21.064684",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70441",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57270006E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81029791E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57270006E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81029791E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003046215",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004988946",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02867297",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.94428844E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83047587E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94428844E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83047587E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03546632",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.743092",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06858867",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.237526",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.756866",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "28.604446",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.866196",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.049789",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.62885372E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.05026117",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.49324",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.776",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.32053",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.026",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.42555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.80212",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03958098",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "93.311317",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8522.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5846558",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-754.49683",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.8125",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.32007",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.281494",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1123.0312",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.32007",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.179932",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.702209",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "37.240341",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7620573",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "315.09375",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.383163",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "17.284752",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.17237684E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.39731574E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.96094",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.502075",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007980347",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.34546",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.497803",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.70279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.09277",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.3605957",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.9715328",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5578594",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6358585",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.81485",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.00439",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.79803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "333.10629",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80437",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.83533",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80081",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "337.56625",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47442495E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.42184328E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-687.2959",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12983980E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.032227",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48202.211",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112031.46",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.86000931E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.75105708E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25808162E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "915.9375",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-241.31444",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "72.236862",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03079011",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258419",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-840.59424",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "924.23755",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1378.5061",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "254.26733",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.51225980E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01674885E-07",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.12998202E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.13805469E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "919.125",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244.13628",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.476181",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.86857316E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "129.28563",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.41861",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.63345",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.68668",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.97644",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.85562",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.53235",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80081",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "335.00375",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.45482",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.91391",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004988946",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02867297",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-21.064684",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70441",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.57270006E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81029791E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.57270006E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81029791E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.16840434E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003046215",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004988946",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02867297",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.94428844E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83047587E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94428844E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83047587E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.03546632",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.743092",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06858867",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "36.237526",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.756866",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "28.604446",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.866196",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.049789",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.62885372E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.05026117",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.49324",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "337.776",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "186.32053",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "327.026",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.42555",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "330.80212",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04967966",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "94.624062",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8489.3945",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5526123",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-757.57593",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.4375",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-401.40649",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.547607",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1122.5312",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-401.40649",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.387207",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-15.666717",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "32.747246",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.3634567",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "350.06348",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-24.054993",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "17.737057",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.32990093E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.20154834E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.90625",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-88.415909",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008285522",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-743.86523",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.849854",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.94269",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.37924",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.4510479",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1341791",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.3210859",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0474548",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.0614",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.53674",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.9953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.37109",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.01639",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.1391",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.01651",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.68439",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32461298E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.02462048E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-699.11279",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09724351E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "13.668701",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47680.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "111980.48",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.00644512E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68175291E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31261595E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "914.4375",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-236.1767",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "67.08017",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03039389",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258354",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-733.54077",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1020.5647",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1254.7512",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "175.19312",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.01739862E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "7.00532041E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.10336828E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.66744347E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "915.67188",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-236.1767",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "33.994232",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.16284311E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "206.34773",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.37325",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.57831",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.13309",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.39362",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.09489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "326.06299",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.01651",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.15479",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.28812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.63721",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005144376",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.02929922",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-20.555742",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.71716",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.58023813E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79471463E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.58023813E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79471463E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-6.09883729E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003402948",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005144376",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02929922",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.84107182E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99102965E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.84107182E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99102965E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.0306885",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.54969",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05053375",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.308891",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.018478",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.847488",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.958099",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.159744",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.39414235E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03334115",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.16425",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "341.06366",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.12035",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.4856",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.15784",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "333.54291",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.035232",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "95.592354",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8458.4297",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5759277",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-754.99219",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1121.7188",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-392.04443",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.399658",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1123.1562",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.04443",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.791748",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-16.210068",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "37.097519",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.4915724",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "290.38104",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.025711",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "24.139563",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.00003920E-15",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.15474176E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.88281",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-97.351685",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008804321",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-733.56006",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.184082",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.23151",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.33417",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5119143",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.3433065",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.9198103",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5086746",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.63589",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "343.43521",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.22035",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "332.92419",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.3774",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "339.25989",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.22685",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.93744",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33848096E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.89087249E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-691.97949",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7319946",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.08222594E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "14.79248",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48433.938",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "112588.38",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.64697809E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.97768314E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.65820620E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20164168E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "912.45312",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-248.31871",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "70.644714",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03133485",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258574",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.84937",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1310.8984",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1764.4165",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "281.54175",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.05540742E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12583223E-07",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08844563E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.01702289E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "914.51562",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.31871",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.35498",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.67523787E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "179.6488",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.13402",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.64185",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "319.66614",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.28513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "325.13068",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.22685",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "338.17572",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.14",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "314.27692",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00581798",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03170232",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-20.396858",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.6412",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.56740061E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78348819E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.56740061E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78348819E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-3.04931861E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003387511",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00581798",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03170232",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-2.11131942E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94288259E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.11131942E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.94288259E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.02836154",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.088707",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05655383",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "35.528664",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.628693",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "30.943192",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.108353",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "33.981888",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.21690479E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03541872",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.47301",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "334.89865",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.01326",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.95215",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.19731",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.98877",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04436549",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "96.437263",
                                            "gribparam": "230",
                                            "process": "50"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8516.0234",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "process": "50"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "process": "50"
                                        },
                                        "ALWCVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALWCVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated liquid water content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "kg/m2",
                                            "grib_name": "ALWCVI",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.561554",
                                            "gribparam": "231",
                                            "process": "50"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-760.99365",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "1122.2812",
                                                "gribparam": "178",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-391.83179",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.32666",
                                                "gribparam": "179",
                                                "process": "50"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1123.0625",
                                                    "gribparam": "187",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.45312",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.975098",
                                                    "gribparam": "188",
                                                    "process": "50"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "process": "50"
                                        },
                                        "VSTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VSTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "meridonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-18.150833",
                                            "units": "Pa",
                                            "grib_name": "VSTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "31.167446",
                                            "gribparam": "196",
                                            "process": "50"
                                        },
                                        "VDISGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VDISGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "gravity wave dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.5409565",
                                            "units": "W/m2",
                                            "grib_name": "VDISGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "400.077",
                                            "gribparam": "197",
                                            "process": "50"
                                        },
                                        "USTRGW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "USTRGW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "zonal gravity wave stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-20.63179",
                                            "units": "Pa",
                                            "grib_name": "USTRGW",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "18.801558",
                                            "gribparam": "195",
                                            "process": "50"
                                        },
                                        "u3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u*3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "u*^3",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.29112588E-14",
                                            "units": "unitless",
                                            "grib_name": "u*3",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "4.06675041E-04",
                                            "gribparam": "159",
                                            "process": "50"
                                        },
                                        "TSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TSN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "302.85938",
                                            "gribparam": "206",
                                            "process": "50"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.755661",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.009155273",
                                            "gribparam": "220",
                                            "process": "50"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.54102",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.627197",
                                            "gribparam": "205",
                                            "process": "50"
                                        },
                                        "TEFF": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TEFF",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "effective sea-ice skin temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.82167",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TEFF",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "335.82104",
                                            "gribparam": "213",
                                            "process": "50"
                                        },
                                        "tcld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tcld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "total cloud cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "tcld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "163",
                                            "process": "50"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6194954",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "3.4021931",
                                            "gribparam": "181",
                                            "process": "50"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7414532",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3703976",
                                            "gribparam": "180",
                                            "process": "50"
                                        },
                                        "Tasmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Tasmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.98837",
                                            "units": "Kelvin_scale",
                                            "grib_name": "Tasmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "340.17938",
                                            "gribparam": "214",
                                            "process": "50"
                                        },
                                        "tasmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tasmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "minimum air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.78848",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tasmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "332.70319",
                                            "gribparam": "215",
                                            "process": "50"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.9055",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "336.68826",
                                            "gribparam": "169",
                                            "process": "50"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80197",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "338.51392",
                                            "gribparam": "139",
                                            "process": "50"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14054967E-06",
                                            "gribparam": "160",
                                            "process": "50"
                                        },
                                        "srct1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srct1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "skin reservoir content (t-1)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.31640486E-20",
                                            "units": "unitless",
                                            "grib_name": "srct1",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.001793593",
                                            "gribparam": "194",
                                            "process": "50"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.99316",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "process": "50"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "process": "50"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06805237E-06",
                                            "gribparam": "218",
                                            "process": "50"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "15.305664",
                                            "gribparam": "141",
                                            "process": "50"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_11",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "process": "50"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "process": "50"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "process": "50"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "48057.711",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "111998.05",
                                            "gribparam": "134",
                                            "process": "50"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.27055215E-07",
                                            "gribparam": "144",
                                            "process": "50"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49789230E-06",
                                            "gribparam": "142",
                                            "process": "50"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24861253E-06",
                                            "gribparam": "143",
                                            "process": "50"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "914.65625",
                                                "gribparam": "176",
                                                "process": "50"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "PDS_TimeRange": "10",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-246.54723",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "PTVersion": "128",
                                                "gribleveltype": "1",
                                                "scale_max": "71.664581",
                                                "gribparam": "177",
                                                "process": "50"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "process": "50"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02986586",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258421",
                                            "gribparam": "152",
                                            "process": "50"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-854.31909",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "1052.7336",
                                            "gribparam": "146",
                                            "process": "50"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1545.5627",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "222.73779",
                                            "gribparam": "147",
                                            "process": "50"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.18027229E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "8.90661340E-08",
                                            "gribparam": "182",
                                            "process": "50"
                                        },
                                        "DSNAC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DSNAC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow depth change",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.07252470E-06",
                                            "units": "m/s",
                                            "grib_name": "DSNAC",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "6.77971968E-07",
                                            "gribparam": "221",
                                            "process": "50"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "915.5",
                                                    "gribparam": "185",
                                                    "process": "50"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "PDS_TimeRange": "10",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-248.03178",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "PTVersion": "128",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.481903",
                                                    "gribparam": "186",
                                                    "process": "50"
                                                }
                                            }
                                        },
                                        "bld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Boundary Layer Dissipation",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.76954010E-05",
                                            "units": "Wm-2",
                                            "grib_name": "bld",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "149.53529",
                                            "gribparam": "145",
                                            "process": "50"
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "process": "50"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.72708",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "309.31693",
                                            "gribparam": "183",
                                            "process": "50"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.06384",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "318.48267",
                                            "gribparam": "209",
                                            "process": "50"
                                        },
                                        "TD4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.48132",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD4",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "324.8721",
                                            "gribparam": "208",
                                            "process": "50"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.80197",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "335.88501",
                                            "gribparam": "207",
                                            "process": "50"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.54926",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "PTVersion": "128",
                                            "gribleveltype": "111",
                                            "scale_max": "313.31592",
                                            "gribparam": "170",
                                            "process": "50"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00824061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "scale_max": "0.03149816",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "scale_min": "-20.892014",
                                            "grib_name": "ta",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "410.38812",
                                            "gribparam": "130",
                                            "process": "50"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.54046211E-05",
                                            "grib_name": "rvort",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81150608E-05",
                                            "gribparam": "138",
                                            "process": "50"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.54046211E-05",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81150608E-05",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst jun2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "process": "50"
                                        },
                                        "lwc153": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lwc153",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Liquid Water Content",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "-2.49027686E-19",
                                            "grib_name": "lwc153",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.003499925",
                                            "gribparam": "153",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00824061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03149816",
                                            "gribparam": "133",
                                            "process": "50"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "scale_min": "-1.96830842E-06",
                                            "grib_name": "div",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09030122E-06",
                                            "gribparam": "155",
                                            "process": "50"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96830842E-06",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09030122E-06",
                                            "process": "50"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "0.01567795",
                                            "grib_name": "wind10",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.367477",
                                            "gribparam": "171",
                                            "process": "50"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03757096",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "37.745445",
                                            "gribparam": "216",
                                            "process": "50"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.03891",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "32.585342",
                                            "gribparam": "166",
                                            "process": "50"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.616165",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "34.703644",
                                            "gribparam": "165",
                                            "process": "50"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.65307899E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03383318",
                                            "gribparam": "168",
                                            "process": "50"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.57602",
                                            "grib_name": "t2mmx",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "335.47198",
                                            "gribparam": "201",
                                            "process": "50"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "unitless",
                                            "scale_min": "187.3685",
                                            "grib_name": "t2mmn",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "326.41855",
                                            "gribparam": "202",
                                            "process": "50"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.39381",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "PTVersion": "128",
                                            "gribleveltype": "105",
                                            "scale_max": "329.79355",
                                            "gribparam": "167",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "500.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "500",
                                            "units": "mm/(30 days)",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "12800",
                                            "scale_max": "20.0",
                                            "maxncolor": "13",
                                            "ncolor": "13",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "20",
                                            "units": "mm/day",
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PDS_TimeRange": "10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "process": "50"
                                        }
                                    }
                                }
                            },
                            "Z_11": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_11",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "272.75"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "30.0"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01",
                                "gridtype": "0",
                                "calendar": "standard",
                                "pointwidth": "1.0"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/jun2001"
                        },
                        "mar2002": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "mar2002",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200206",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200206",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200206",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200206",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200206",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200206",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200206",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200206",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200206",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200206",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200206",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200206",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200206",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200206",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200206",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200206",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200206",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200206",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200206",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200206",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200206",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200206",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200206",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.mar2002/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/mar02/20007fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200206",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04762395",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.280769",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8525.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.4751",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.75",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-379.1377",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.111572",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1681.7629",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1592.5845",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.1875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-379.76758",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.752197",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.23613",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01895142",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.27124",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.260498",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0699635",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1989756",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0428314",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.6515484",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.13606",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.37912",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.98857",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.96716",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22857011E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-689.7644",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03999628E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.520264",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47163.48",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111985.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.06168009E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42019792E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22652034E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-447896.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "442241.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "968.03125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-243.26703",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "51.567398",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03023294",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258482",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-732.76001",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "844.2334",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1258.0525",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "195.28247",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.03059994E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.80897551E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1488.9778",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1750.2095",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-282851.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "558420.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.03125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-243.28212",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "19.869873",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.14821",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.84546",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.49854",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.87207",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.98857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.03357",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.47273",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.22366",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005917497",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02780054",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.517342",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.89612",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.46945504E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.26442665E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.46945504E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.26442665E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005917497",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02780054",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.91380491E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00059276E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.91380491E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00059276E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01951129",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.481178",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04092383",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.887466",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.155106",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.432022",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.6996",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.167587",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.87041223E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03282221",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.29309",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.60248",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.25835",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.86295",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "190.29309",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.18762",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06462717",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.528175",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.8125",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-796.12012",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-384.65137",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.442871",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1843.2749",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1517.6873",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.5938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-384.65137",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.023682",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-83.324173",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01889038",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.51245",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.27417",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1921835",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3373528",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3482742",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.5459757",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.70038",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.42389",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.67738",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.71765",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27167232E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-698.51294",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15227886E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.558105",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47490.648",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111802.67",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.70442625E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.89597006E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.17455236E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27140925E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-413003.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "418235.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "961.375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-255.65192",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "62.470505",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.0289751",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258514",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.65576",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1001.0684",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1265.7422",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "180.80566",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.06134882E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.22988034E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1634.1755",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1893.2788",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-299103.38",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "593172.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-255.65192",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.125946",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.44894",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.06808",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.80884",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.99548",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.67738",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.77234",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.64098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.09509",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00540496",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02784553",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.795803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.98557",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49063571E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.38779651E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49063571E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.38779651E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00540496",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02784553",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.17862862E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01564717E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.17862862E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01564717E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03483798",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.339275",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05991498",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.885727",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.695343",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.239624",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.84697",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.772308",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.02917056E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03570805",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.09837",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "338.68793",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.9324",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.14154",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.96332",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.8364",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0511191",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.519951",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8489.6602",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.24902",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.7439",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.051758",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1830.3445",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1426.6421",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.0312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.05884",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.751953",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.68959",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01939392",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.76416",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.805664",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8893442",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0657701",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3858414",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4699383",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.41942",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.54568",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.35013",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.98297",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18962396E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-675.50317",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09584653E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.530762",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47145.871",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111902.52",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.05856473E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.53998690E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24213750E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-435048.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "518819.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "969.73438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-265.33447",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "61.012024",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02922535",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258533",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-705.40991",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1040.9771",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1111.6868",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "189.62329",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.44532446E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.58223564E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1569.6011",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1672.8506",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-295343.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "605328.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.0",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-265.34814",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.596619",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.41811",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.74622",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.22076",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.03094",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.35013",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.74225",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.655",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.18781",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00786357",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0263203",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.679365",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.16821",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49670423E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27659769E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49670423E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27659769E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00786357",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0263203",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05818560E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19199524E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.05818560E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.19199524E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02783179",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.44183",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06009063",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.636261",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.200287",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.930161",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.885452",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.172714",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.04094283E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03284477",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.47122",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.95172",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.34703",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.1087",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.44255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.43451",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0556576",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "87.779564",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8513.2109",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-800.41431",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.46143",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.360107",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1903.3289",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1534.7078",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-391.31079",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.262939",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.913635",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01858521",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-726.52734",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.457275",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.737586",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4581318",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8200865",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.444725",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.84349",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.38049",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.8591",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.45331",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06361290E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-681.87891",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06368680E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.559082",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47065.852",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111935.6",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.77699063E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66978816E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34082541E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-411822.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "408008.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "967.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-249.10281",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "72.513901",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02902524",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258471",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-732.31763",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1053.8",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1452.1047",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "164.61279",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.80656035E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.58232295E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1515.2776",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1679.719",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-338243.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "583474.0",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.92188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-251.22289",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "25.823532",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.92168",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.22638",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "198.82788",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.42767",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.8591",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.58563",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.23111",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.4856",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004715145",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02690188",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.575169",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.09982",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.47563105E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55838552E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.47563105E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.55838552E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004715145",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02690188",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96907263E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05010838E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.96907263E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.05010838E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.019868",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.655663",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03723314",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.592773",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.873779",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.704453",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.4888",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.055817",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.07084304E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03417541",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.91158",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "337.14093",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.68761",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.48907",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.73288",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.58142",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05255646",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "84.095787",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8488.5312",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.4021",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.03638",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.887207",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2260.0479",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1444.8186",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.03638",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.396729",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.763",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01869202",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.34619",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.052979",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8843107",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8514109",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.2104788",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2879219",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.25635",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.75427",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.30241",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "347.17065",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46252000E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-692.81445",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.78732714E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.380371",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46515.105",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111789.09",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.34591788E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58303919E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.69871771E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-419850.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "503507.81",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "963.01562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-250.41635",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "55.457657",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02922259",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258369",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-679.07715",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "978.08057",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1499.5525",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "209.46655",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.99629118E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.37630125E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1325.9629",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1752.8442",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-277258.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "595089.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.0",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258.47754",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.005249",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.42003",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.93762",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.32968",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.26593",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.30241",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.672",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.58095",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.52301",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00318878",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0268442",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.5891",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.28595",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.46786961E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37924044E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.46786961E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37924044E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00318878",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0268442",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.04748312E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86072498E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.04748312E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86072498E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01356976",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.463665",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.026906",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.934952",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.044281",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.01088",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.4823",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.291809",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.23333166E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03278318",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.17224",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.33835",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.00137",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.32877",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.03531",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.89078",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06090919",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.115746",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8545.2656",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-798.57251",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.6562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-390.38477",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.505127",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1759.5818",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1266.376",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.09009",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-81.296631",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.108994",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01856995",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.71021",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.202881",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0613174",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8749533",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.084569",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.0257902",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.69148",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.50314",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.68726",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.49054",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25748295E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-691.00537",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.50356480E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.761475",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47040.027",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111916.87",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.79577704E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42355918E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33733590E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-440540.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "448025.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "963.20312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-234.26866",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "58.435242",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03100288",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-729.12134",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1206.5601",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1643.7097",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "202.90454",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.57273517E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.11329528E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1274.1338",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1709.1296",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-309516.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "609476.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "966.10938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-234.26866",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.699203",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.33318",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.15936",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.91602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "318.013",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.68726",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "337.1088",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.54329",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.99048",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00345726",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0285337",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.802189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.1492",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42999143E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.32252699E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42999143E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.32252699E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00345726",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0285337",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.29028910E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16605190E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.29028910E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16605190E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02168757",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.540279",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04411562",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.75872",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.492294",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.793457",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.120941",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.11113",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.17972036E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03374275",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.88702",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.08844",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.78683",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.0907",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.79836",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.69617",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05800875",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "88.617928",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8523.1719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.59277",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.1562",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-403.94409",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.319824",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1590.8396",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1299.2097",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-403.94409",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-84.143066",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.353882",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01875305",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.71851",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-71.897705",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8184385",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.22225",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.2905903",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6460352",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.89096",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.40118",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.84294",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.40631",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20017137E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.14893",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.09066605E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.540039",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46969.703",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112098.75",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49148853E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57052307E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25909787E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-425134.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "469589.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "964.95312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-278.42163",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.714218",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02997177",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25845",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.53613",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "954.06445",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1114.6538",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "219.90137",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.45718825E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.79345237E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1366.9202",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1922.8091",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-302862.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "577663.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "964.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-278.42163",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.631897",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.22313",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.4751",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.71994",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.40503",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.84294",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.47272",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.53078",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.88062",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004284412",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02636645",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.727758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.19583",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42847166E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36593026E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42847166E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36593026E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004284412",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02636645",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99123406E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00422255E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99123406E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00422255E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03135122",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.086342",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04868858",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.920143",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.793106",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.675842",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.487442",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.001221",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.63352354E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03689282",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.78705",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.4826",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.50798",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.05243",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "191.5172",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.55933",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0643791",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.188026",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.3086",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-798.65894",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-395.18262",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.89209",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2170.5513",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1508.5234",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-395.18262",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-83.542969",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.209229",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01855469",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.78906",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.857178",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6589956",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2384911",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.0137968",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0581303",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.18402",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.46664",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.45312",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43135958E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-707.74414",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.48770321E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.981445",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47308.32",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112099.66",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.26221685E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67637177E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34027721E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-412626.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "395220.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "965.5",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-258.66187",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "55.36174",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02896226",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258455",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-693.92651",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "860.76807",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1152.0125",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "189.39893",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.60657475E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57306395E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1630.4946",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1751.7258",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-321712.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "578898.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258.66187",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.887802",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.01906",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.57764",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "201.42094",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.54749",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.46664",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.30078",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.39914",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.67218",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004289933",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0275299",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.701794",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.36224",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43458883E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31407796E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43458883E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.31407796E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004289933",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0275299",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.07220546E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02040178E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.07220546E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02040178E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02552947",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.026939",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05952737",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.550968",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.89212",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "28.136841",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.027359",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.174393",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.44904334E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0324688",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.79066",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.88715",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.70059",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.57828",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.70302",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.59747",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06193829",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "92.201958",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8522.2188",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-801.88135",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.0",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.0708",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.019775",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2165.6365",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1364.4316",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.0708",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-82.260498",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.44725",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01889038",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-713.0293",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.343994",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.3772354",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9613857",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.6359043",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5521574",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.80176",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.34564",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.74709",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.16003",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13944668E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-697.59521",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.80566256E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.702148",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46964.18",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111723.89",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.88716534E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.06930281E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26188900E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-433140.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "478062.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "965.90625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-262.76562",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "66.249451",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02971865",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258471",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-752.50928",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "902.94946",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1323.6914",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "196.09863",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.29307158E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.84130805E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1433.0935",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2015.2395",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-307356.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "555823.19",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "965.90625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.76562",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.781876",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.9388",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.25128",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.74173",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.74506",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.74709",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.21082",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.37463",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.69226",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006885771",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02719104",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.303123",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.02939",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42599374E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50029909E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.42599374E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50029909E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006885771",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02719104",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94854056E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99111059E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94854056E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.99111059E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03267983",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.208363",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06411201",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.579082",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.379196",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.530365",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.782181",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.352585",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.34869140E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03760381",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.68649",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "336.9324",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.51886",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.38391",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "191.51886",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.69641",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0550837",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "85.751526",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8524.9453",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.65283",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.98828",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.748535",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2283.2585",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1458.1807",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.75",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.98828",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-81.910156",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-90.750397",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01869202",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.58594",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.141602",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.8859921",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5211697",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.317296",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3910398",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.31735",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.95291",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.32445",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.93591",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25773909E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.87329",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06773223E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.175781",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47354.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112005.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.10299639E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.10211329E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.67976602E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30202818E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-389730.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "467604.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "961.29688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-256.10815",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "65.903931",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03028608",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258512",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-694.91333",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1242.5964",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1424.3689",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "175.83765",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.69565259E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.03153376E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1459.3569",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1758.1157",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-291942.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "555044.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256.12622",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.894638",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.07544",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.72192",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.77446",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.43317",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.32445",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.72968",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.26961",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.3407",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007625692",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02783979",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.641922",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.82431",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44923115E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.45516187E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44923115E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.45516187E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007625692",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02783979",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.03731815E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06414256E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.03731815E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.06414256E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03305063",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.156776",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05755774",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.323772",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.051071",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.107864",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.862137",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.282242",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.61740056E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03475508",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.99222",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "338.36731",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.72958",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.64273",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.73454",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.01382",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0570926",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.798889",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8523.332",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.41821",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-392.32227",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.864746",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1959.6882",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1371.3296",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-392.71997",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.401855",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-81.783905",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0191803",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-741.67822",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.557373",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.3640909",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.770546",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.0452366",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7360449",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.20377",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.48999",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.26279",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.65887",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57667262E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-689.1333",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16281444E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.346436",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46961.703",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112181.86",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.68542202E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.60906529E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15451053E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-412219.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "436740.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "968.76562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-267.38037",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "53.858536",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02915478",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258461",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.56738",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "992.51221",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1075.9387",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "259.80542",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.30237748E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03891153E-07",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1434.0845",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1653.748",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256395.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "555738.31",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.76562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-267.53223",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "24.951752",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.29468",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.55481",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "196.97325",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.7522",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.26279",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.73804",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.10884",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.5014",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006296307",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02803767",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.970139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.95172",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44833939E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36305243E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44833939E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36305243E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006296307",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02803767",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.09973177E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00435306E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.09973177E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00435306E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02731653",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.273941",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04573407",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.423786",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.60318",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.468613",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.129959",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.238907",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "4.57650700E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03300226",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.8008",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.0593",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.59232",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.63037",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.64639",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.8952",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0510614",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.49543",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.4531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-798.70166",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1176.5",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-378.67798",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.836182",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1680.5349",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1531.2727",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-378.67798",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.398682",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-84.133759",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01922607",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-710.62109",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.179932",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.8049927",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.6908092",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.3683338",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.7259684",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.2408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.36563",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.17973",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "340.33032",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28864951E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-695.00098",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18650496E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "17.073242",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47030.672",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111694.27",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.90223680E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.54063287E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45163199E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-418470.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "439315.44",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "967.07812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-231.45021",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.02121",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02951541",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25835",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-678.25513",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "906.92456",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1112.8357",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "184.3855",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.44991826E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.37291259E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1319.6011",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1928.407",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-278087.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "561940.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.07812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-231.45021",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "37.509491",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.82561",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.52094",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.01712",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.05829",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.17973",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.27963",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.7383",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.43945",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004913401",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02671843",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.676043",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.40677",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44721998E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.29125565E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44721998E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.29125565E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004913401",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02671843",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.87760941E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87689864E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.87760941E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87689864E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03218022",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.882778",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05637121",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.058681",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.928009",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.320465",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.134109",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.201553",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "9.78000685E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03647622",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.46631",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.43246",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.3074",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.41156",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.33794",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "331.56802",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05778518",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.046089",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8524.2656",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.984",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.46216",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.37378",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.234131",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1563.9009",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1501.9709",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.37378",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-84.682861",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-83.199799",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01934814",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-717.98535",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.250977",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0247555",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8602962",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.282506",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7889643",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.11444",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.96155",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.0034",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.63226",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16757622E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-705.62549",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02823833E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.832031",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47277.5",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111883.16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.76465045E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.60006856E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36890424E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46420689E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-425944.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "440220.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "984.1875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-264.83301",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.220764",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02978806",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258493",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-707.74658",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "932.98486",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1107.3618",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "187.47363",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.42803014E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.49680851E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1475.5222",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1905.1099",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-288028.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "575635.88",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "984.1875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-264.83301",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "18.693558",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.0578",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.24335",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "200.4637",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.32861",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.0034",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.79437",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.32063",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.40939",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006875988",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.0269556",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.2666",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.35394",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.39125204E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27936719E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.39125204E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.27936719E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006875988",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0269556",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.93267124E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09109953E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.93267124E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09109953E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03751457",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.539158",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06455803",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.296623",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-28.785294",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.198013",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.653275",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.001755",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.07269203E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03347278",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.01721",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.84155",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.8989",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.608",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.9016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.04205",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05877543",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.372665",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.6484",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-801.07251",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-381.0957",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.722656",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1746.4124",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1673.5369",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-385.71533",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-81.254395",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.992371",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01908875",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-725.9458",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-68.330811",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.6138258",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8808613",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.2608566",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4463358",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.44585",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.28537",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.46637",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "347.69504",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41180442E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-690.80493",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10160909E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.565918",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47044.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112415.25",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.61410092E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "2.07655694E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29904015E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-436538.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "442808.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "964.73438",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-243.10561",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.907333",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02936309",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258444",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.74951",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "994.90527",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1156.27",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "196.35889",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.62359992E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.85204008E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1705.5349",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1752.9143",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-300673.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "596448.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "964.73438",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-244.13966",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.444733",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.58786",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.84763",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.19106",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.70523",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.46637",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "343.31613",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.83511",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.41422",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007345848",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02719342",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.316946",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.14749",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44028045E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34817556E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44028045E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34817556E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.007345848",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02719342",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.83538032E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15848081E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.83538032E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.15848081E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02961318",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.900436",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04453076",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.546711",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.242935",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.045868",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.601852",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.259048",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.08876179E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03551123",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.96524",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.19086",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.81725",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.15784",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "189.84039",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.99963",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04262917",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "84.333916",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8478.1602",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.41284",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.5938",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.72583",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.477539",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1539.3662",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1593.8113",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-386.72583",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.477539",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-87.385376",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01864624",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-716.0415",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.168701",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.875638",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7143288",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.6424551",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7631617",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.22453",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.60004",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.92192",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.75909",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15072498E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-679.88672",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06877997E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.344727",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46731.477",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111965.88",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.49514947E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.56345823E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17701438E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-423228.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "411364.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "974.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-249.60091",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "61.467407",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02978644",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.25836",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-808.4502",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1073.897",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1191.679",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "186.46533",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.76519062E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.45636441E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1520.2927",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2011.0532",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-266473.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "604454.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.9375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-249.60091",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "24.860336",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.32738",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.17505",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.89317",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.10321",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.92192",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.92395",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.28789",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.82452",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004515439",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02629217",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.286615",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.10675",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.45048225E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37632005E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.45048225E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.37632005E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004515439",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02629217",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92744778E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01884973E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92744778E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01884973E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03277068",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.681141",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04855837",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.115704",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.235367",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.413269",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.44986",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.764038",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "7.03721525E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03238038",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.68001",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.01996",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.24275",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "323.28369",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.24275",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.04932",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04699285",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "88.862061",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8504.7852",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-806.9668",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.83203",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.994873",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1642.5098",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1217.7637",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-387.83203",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.196777",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.884949",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01919556",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-727.45825",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-67.575195",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8639059",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0178337",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.3523474",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.1027031",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.95363",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.35114",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.93657",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "344.66687",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38719281E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-686.26587",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03478669E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.75293",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47162.801",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111888.38",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.56158784E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71446209E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.36670360E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-401610.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "437977.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "961.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-257.68823",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.816376",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03106987",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258392",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-691.71191",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1212.0566",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1725.1414",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "230.87183",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.89835815E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.22064692E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1351.7131",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1609.2087",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-346718.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "593642.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-257.75073",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.970551",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.17847",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.34839",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.2036",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.5632",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.93657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "340.73914",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.30331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.85211",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003178244",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02817464",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.821238",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.08499",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49069001E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50404076E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49069001E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.50404076E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.003178244",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02817464",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92635594E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81408950E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92635594E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81408950E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03486685",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.819878",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06085271",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.475407",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.340027",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.82135",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.119354",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.939941",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.19281708E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03492568",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.48602",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "339.258",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "190.4028",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.22406",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "190.44548",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.95319",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04025863",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "88.912575",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8530.2578",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-808.03345",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.3438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-388.26221",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.341309",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2004.8669",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1375.5847",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.25",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-391.81519",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.036621",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.327026",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01927185",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.74805",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.511475",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.9516783",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2604446",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.3435001",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9172363",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.84633",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.77979",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.85513",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "341.6673",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22164715E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-677.2915",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22169149E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.05127",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47020.117",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112322.79",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.68727318E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49369544E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31570641E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-444224.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "441826.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "967.28125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-238.79108",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "58.787704",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03083726",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.60645",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1079.9329",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1165.3394",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "175.95361",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.65986602E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.03612386E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1555.0566",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1681.823",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-282841.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "596292.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.89062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-242.13998",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "26.615631",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.27252",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.0658",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.3782",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.99338",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "183.85513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.13019",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.42346",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.56598",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005719129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02696813",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.998476",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.10846",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43156103E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.28917973E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43156103E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.28917973E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005719129",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02696813",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86447198E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95552457E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86447198E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95552457E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03975114",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.907001",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06800842",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.818302",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.506882",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.184708",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.543182",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.36644",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8.22917059E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03606181",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "185.7489",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.12506",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "184.62885",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.35522",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.63171",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.80688",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05383456",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "94.563362",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.4023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-808.40405",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-398.67114",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.474365",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2057.6567",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1742.8357",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.7812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-398.67114",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.191406",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-86.707062",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01928711",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-728.57007",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.925293",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.645196",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4194107",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8688784",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6205225",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.09602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "338.56519",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.11423",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.06702",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27129761E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.14185",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.99309123E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.199219",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46648.512",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111555.93",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.97704240E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.50634298E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28949591E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-435836.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "447368.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "971.53125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-270.28638",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "66.05304",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02993838",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258402",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-839.1792",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "848.74707",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1472.2568",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "206.30957",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.88714329E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.24990423E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1606.5356",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1954.1672",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-284637.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "592331.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.53125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-270.28638",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.25502",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.26985",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.01007",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "195.75774",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.35858",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.11423",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.09436",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.50208",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.43127",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006936543",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02729723",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.044514",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68713",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.41003356E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.38740488E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.41003356E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.38740488E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.006936543",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02729723",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.08400525E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96088604E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.08400525E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96088604E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02404384",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.445274",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03766833",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.475681",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.680328",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "30.313217",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-34.777466",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.501282",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "6.35849915E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03759604",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.90338",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.47052",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.7937",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.37134",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.79434",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "329.79321",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0596066",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.682365",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8521.5469",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-809.71289",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-381.19604",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.521484",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1892.3337",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1550.4727",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.0",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-383.66724",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.025635",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-89.318161",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01870728",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-711.05273",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.75293",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.5274734",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8008928",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1417723",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.434351",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.43771",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.69073",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.28525",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "339.31003",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31661852E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-673.16626",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31814159E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.033691",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47139.57",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112219.77",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.01508213E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58952184E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.36918674E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21049857E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-407022.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "420458.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "967.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-245.99329",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "75.209213",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.03192077",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258392",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.98267",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "936.19897",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1135.8345",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "164.72119",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.54188353E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.58697843E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1724.7681",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1728.3899",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-319837.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "569839.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.39062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-247.29054",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "22.670425",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.96751",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.6062",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.41812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.97577",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.28525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "336.26508",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.2686",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.96729",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004013594",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02705633",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-22.093594",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.35327",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49622201E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35928676E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49622201E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35928676E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.004013594",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02705633",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.98348198E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97501367E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.98348198E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.97501367E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02260777",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.957718",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04969711",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.469105",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.173569",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.262939",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-35.672424",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.152527",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.27999783E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03486317",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.65471",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.4827",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.19728",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.64301",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.23997",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.02319",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06965584",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.787346",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8546.9727",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-802.94067",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-386.74219",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.226318",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2017.6892",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1355.2454",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-394.21997",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.977051",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.832657",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01882935",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-708.58936",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.599365",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.7171373",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.401803",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.0604544",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3394489",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.29953",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "335.979",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.32112",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "342.99957",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26008933E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-719.87207",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24523649E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.159668",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47241.762",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112239.05",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.53786196E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.85294778E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.44560339E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31685545E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-408826.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "449264.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "958.46875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-255.73079",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.217041",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02955906",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258415",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-810.38696",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1013.1672",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1291.6694",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "179.84326",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.16502439E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.19172135E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1476.0706",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2134.5928",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-258365.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "577750.44",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-255.73079",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "22.681625",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.22319",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.98688",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.16879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.99191",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.32112",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "338.75665",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.46864",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.76941",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00462516",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02992407",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.599756",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.10226",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.45305830E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36270437E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.45305830E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36270437E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.00462516",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02992407",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99061151E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16214562E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.99061151E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.16214562E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03957801",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "38.594917",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05778928",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "40.923443",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-29.568527",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.089859",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-39.121613",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.241989",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.09678751E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03431872",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.28134",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.5722",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.51204",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.29651",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.81879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "327.42197",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05076472",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "86.705742",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8518.5508",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-805.93701",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.2188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.68848",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.601807",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1874.2095",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1464.7173",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.1562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.52856",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-79.428711",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-82.759308",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01852417",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-715.40771",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.022705",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.4115992",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2654514",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.1178675",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5263958",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.84154",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.48587",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.80334",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "346.01617",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03972161E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-689.05298",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03973434E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.675537",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47158.965",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "112518.74",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "9.22658160E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.61950788E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24737596E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-426375.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "421466.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "961.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-280.74048",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "63.943146",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02977264",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258474",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-708.63501",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "885.69873",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1204.9346",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "205.4939",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.81819654E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.21730453E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1786.2104",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1947.8015",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-332911.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "567655.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "961.65625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-280.76099",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.715622",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.12349",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.26605",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "197.3317",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.04077",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "184.80334",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.92242",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.20763",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.38861",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005522054",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02887475",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.786451",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.25381",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49694706E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36857770E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.49694706E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.36857770E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005522054",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02887475",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86589966E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03930654E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.86589966E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03930654E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.02404362",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.915718",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04470007",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.867947",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.295013",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.325424",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-33.078461",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.140213",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.44761373E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03229252",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.13493",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "333.03693",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "187.97632",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "322.11707",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.98553",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "328.75208",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05412762",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "89.00528",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8531.0586",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-801.99634",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.64502",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.847168",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1857.7866",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1558.8533",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1179.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.64502",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-83.624268",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.237656",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01924133",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-712.61279",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-70.130615",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7601194",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4248314",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.8192739",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.48069",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.7117",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.78247",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.7556",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "347.04187",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.43975217E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-730.40015",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29223918E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "13.914062",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "47230.668",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111759.06",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.53657708E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.71875422E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26406530E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-413983.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "421108.69",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "963.32812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-255.23407",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.028076",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02928887",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258472",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-707.8186",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1124.813",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1337.1379",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "216.81396",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-5.34684034E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "8.66964456E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1720.9631",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1906.5408",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-240573.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "601535.56",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "966.125",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-256.21704",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "21.438217",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.31509",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.22916",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.84831",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.45013",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "187.7556",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "342.4989",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.59369",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.23608",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005308591",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02965068",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.400759",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.19272",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.47666642E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35278769E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.47666642E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.35278769E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005308591",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02965068",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.32273146E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00555701E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-2.32273146E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "2.00555701E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.03044969",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "36.55901",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04853215",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "37.813145",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.701599",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.243164",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.966965",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.408524",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.76094716E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04173303",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.69193",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "334.59686",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "191.22517",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "324.74518",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "191.54935",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.10065",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.04634168",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "90.397865",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8519.8359",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-808.61377",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.4062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-387.13013",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.047607",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-2363.5962",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1420.1516",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-388.22095",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.050781",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-81.030685",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01863098",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-721.52295",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.298828",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.1658506",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4588442",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.7576542",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.9183159",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.92757",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "336.80963",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.89119",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.83685",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15172077E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-680.42505",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.15172588E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "14.716797",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46957.207",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111866.56",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-6.73161534E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.72402871E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63617040E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.51751829E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-406233.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "433850.31",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "968.40625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-231.5619",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "59.895355",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02980427",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-688.01172",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "925.56567",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1102.8496",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "250.99854",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.40998747E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00369533E-07",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1428.2532",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2235.7981",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-264785.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "640566.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-231.59785",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "25.668839",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "209.82527",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "309.92096",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "195.83855",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "316.66943",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "182.89119",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "335.18896",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.1153",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.79376",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005077999",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02897024",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.505795",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "410.23413",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.48375439E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41230375E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.48375439E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.41230375E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005077999",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02897024",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92942616E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96417591E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.92942616E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96417591E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.0308799",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.895329",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.05543466",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "34.729225",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.59848",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "29.284286",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-31.535263",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "33.476196",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "3.60467887E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03469222",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.38113",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.52814",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "186.31619",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "326.811",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "186.3631",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "332.29077",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06251824",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "82.238197",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "8524.9766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-803.47656",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "1178.8438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-382.1875",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.348633",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1906.5049",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1473.6592",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.0938",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-382.1875",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.849365",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-85.668701",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.01948547",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-718.35571",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.486572",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.869441",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "5.0445642",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.5832682",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8627672",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.23952",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "337.3298",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.21214",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "345.25287",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.33153787E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-694.93066",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.06572406E-06",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "15.617188",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "46824.52",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "111609.95",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.18883986E-06",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.62736524E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63055745E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-392734.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "453051.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "958.89062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "PDS_TimeRange": "10",
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "gribNumBits": "16",
                                                "PTVersion": "128",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "subcenter": "255",
                                                "scale_min": "-262.25366",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "scale_max": "56.571411",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.02902416",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-686.70703",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "859.55981",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1205.6895",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "175.47681",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "24",
                                            "PTVersion": "128",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-4.82121493E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "7.01661804E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-1434.4304",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1702.3682",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-275859.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "583155.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "958.89062",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "PDS_TimeRange": "10",
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "gribNumBits": "16",
                                                    "PTVersion": "128",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "subcenter": "255",
                                                    "scale_min": "-262.25366",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.548767",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "8",
                                            "PTVersion": "128",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.51846",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "310.03604",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "199.05698",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "317.42523",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "185.21214",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "341.23334",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "210.52824",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "scale_max": "311.91644",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005571146",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "scale_max": "0.02692905",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-21.981489",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "409.95276",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43897805E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34403108E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.43897805E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.34403108E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "1"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst mar2002 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "process": "50",
                                            "gribleveltype": "109"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-0.005571146",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02692905",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94146241E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96545443E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-1.94146241E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96545443E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "0.01630237",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.367664",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "0.03734837",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "35.877995",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-32.005569",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "31.105606",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "-30.360382",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "32.600403",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "1.09611108E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03844184",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "189.11349",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "335.1886",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "units": "unitless",
                                            "subcenter": "255",
                                            "scale_min": "188.9012",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "325.0383",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "PDS_TimeRange": "10",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "gribNumBits": "16",
                                            "PTVersion": "128",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "subcenter": "255",
                                            "scale_min": "188.96361",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "scale_max": "330.21017",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2002-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "180.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/mar2002"
                        },
                        "nov2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "nov2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200202",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200202",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200202",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200202",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200202",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200202",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200202",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200202",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200202",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200202",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200202",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200202",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200202",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200202",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200202",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200202",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200202",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200202",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200202",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200202",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200202",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200202",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200202",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.nov2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/nov01/20003fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200202",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03962162",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "85.368813",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8530.9844",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.0105",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.4375",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-374.19263",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.188232",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1714.3657",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1809.1541",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.6875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-374.19263",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-75.440674",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.691589",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1217957",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.87573",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-65.9104",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.443759",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.6379089",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.864398",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.0536232",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.83188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.45367",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.82512",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.08405",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.26407394E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.7417",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.55491021E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.304688",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47296.348",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111853.36",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.89469084E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.45625654E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.37295888E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-411376.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "426047.19",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "967.96875",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-236.34059",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "51.517715",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03025912",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258425",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.81396",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "982.20972",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1272.2039",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "167.34888",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.08718699E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.69189433E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1442.9502",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1861.9978",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-350404.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "615019.25",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "968.71875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-236.34059",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "3.2423401",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.14941",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.85547",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.43719",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.82544",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.82512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.75006",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.30074",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.10126",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006635837",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02689834",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.50548",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.54395",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20503828E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85550452E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20503828E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85550452E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006635837",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02689834",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.06764321E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97262329E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.06764321E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97262329E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.027197",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.670624",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06101385",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.439053",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.044159",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.31694",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.407547",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.770493",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.42675416E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03517486",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.95523",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.75488",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.59596",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.93042",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.67505",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.45654",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05030314",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "85.225899",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.9258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.42603",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.1875",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-391.59351",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-77.102539",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1659.8733",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1928.7412",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.1875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.59351",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.486816",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.159058",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1215668",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-714.32422",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-70.98584",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6262951",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.6285219",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.409338",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.8533316",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.24493",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "336.2923",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.38168",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.72873",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.47009109E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.01074",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.66142262E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.486816",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47265.246",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111990.91",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.62711443E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.52225584E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.33075162E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-413441.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "457961.31",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "988.57812",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-281.73706",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "51.269836",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03106722",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258429",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.84692",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "894.8186",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1099.0984",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "188.40234",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.39498621E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.53366578E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1957.4922",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2176.0547",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-306958.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "610946.31",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "988.57812",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-281.73706",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "27.106979",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.44257",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.06403",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.13419",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.18292",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.38168",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.72092",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.56203",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.15918",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003531433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02670686",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.370375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "410.25348",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23146037E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86874386E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23146037E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86874386E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003531433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02670686",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.06603931E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86962973E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.06603931E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86962973E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03197556",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.095192",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0549152",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.908447",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.702591",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.783478",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.820602",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.863541",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.48014806E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03470725",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.77126",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "333.20868",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.40842",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "320.63077",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.47939",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.08603",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04491321",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "88.172165",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8530.2656",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.07593",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1180.25",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.42456",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.479248",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2002.0081",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2062.3081",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.5938",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.42456",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-77.575195",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-94.194183",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1218109",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-711.19824",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-67.393799",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.6356659",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.3850164",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.5089884",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.809103",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.82501",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "336.06317",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.74971",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "343.677",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.39676001E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.96118",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.03119440E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.401611",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46877.902",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112148.14",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.26271935E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "2.10204689E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.27501619E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-458233.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "424308.5",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "970.96875",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-273.80713",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "50.527908",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02982759",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258509",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.60889",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1030.6716",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1115.6833",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "188.23413",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.46130542E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.52681899E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1824.7568",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2196.9722",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-368597.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "636970.62",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "972.23438",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-275.18066",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "8.0924377",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.39345",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.78021",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.5773",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.4472",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.74971",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "339.69861",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.71878",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.59442",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004815027",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02676692",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.853754",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.38409",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.28618467E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.74136421E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.28618467E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.74136421E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004815027",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02676692",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94755285E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.10438679E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94755285E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.10438679E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03153286",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.978863",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07077003",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.145561",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.06163",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.354385",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.089233",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.994904",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.28506315E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03325401",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.13731",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.39288",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.99394",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.83875",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.00111",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.08499",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05471559",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "87.392326",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.7578",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.95703",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.6562",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.2478",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.222168",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1774.2251",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1856.8452",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.5625",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.2478",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.36792",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.627289",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1220245",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-711.63135",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-72.826172",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1086521",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.4594488",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7898998",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.5799255",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.30966",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "335.83069",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.25848",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.83069",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.04516630E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-694.77319",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.39833922E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.498535",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47434.055",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111835.86",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.66901451E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.71743864E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.50339417E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-429762.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "447169.56",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "968.73438",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-276.43115",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "43.196182",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03004971",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258429",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-739.87427",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "895.20947",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1055.6553",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "171.37695",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.22126988E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.85282657E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1593.5571",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2079.4492",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-332364.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "659158.12",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "969.21875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-276.43115",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "8.4565125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.9395",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.35858",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.22716",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.90704",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.25848",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.53772",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.01411",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.88098",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.001755477",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02890755",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.273602",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.79944",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20526183E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.79992967E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20526183E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.79992967E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.001755477",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02890755",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99188617E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88592355E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99188617E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88592355E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02963223",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.907536",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06027605",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.082199",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.851501",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "29.983932",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.704422",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.780458",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.69947896E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03792507",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.98256",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "333.01251",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.08818",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.69739",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.21725",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.49237",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05230347",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "87.604362",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8506.8164",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.19214",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.9688",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.61597",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-79.494385",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1562.4529",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2081.7502",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9062",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.61597",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-79.494385",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-79.827606",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1218567",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-748.66064",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-70.699951",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1085463",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.2905893",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3962851",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.424181",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.15611",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "339.63318",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.01343",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "348.70526",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.11405609E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.13989",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.03627996E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.168945",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46670.445",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112176.58",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.78788910E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.56491751E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.31200215E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-458086.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "470938.0",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "976.10938",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-281.02271",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "50.632996",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03039625",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25843",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-750.18091",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "940.19287",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1083.9358",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "215.98828",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.33435616E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.63659295E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2050.521",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1828.1301",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-313390.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "607626.94",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "980.59375",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-281.02271",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "17.537903",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.37526",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.90137",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "202.23416",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.98792",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.01343",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.52557",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.94286",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.86737",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.001698297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02720114",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.479029",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "410.05496",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.21318726E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91621493E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.21318726E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91621493E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.001698297",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02720114",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.78361768E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88003503E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.78361768E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.88003503E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.04029983",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.880611",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06372124",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.7384",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.605209",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "30.512482",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-37.727036",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.817886",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.16769684E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03758406",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.18001",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "333.04138",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.61662",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "321.90277",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.74376",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.93481",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04487296",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.977745",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.1914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.80884",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1180.0",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.77563",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-75.610107",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1749.5776",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2300.6279",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0625",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.77563",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-75.235107",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.936417",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1213684",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.34937",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-67.007568",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.2695913",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.1615534",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6425915",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.3413391",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.6964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "336.39658",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.48457",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.3205",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.26759071E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.40796",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.64468792E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.505615",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47076.469",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111881.08",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.58507838E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.64002688E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.20718244E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-411816.31",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "497440.06",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "974.53125",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-276.01245",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "43.972946",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0305268",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258457",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-742.18408",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "992.19116",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1041.0845",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "170.21338",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.16300509E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.80620929E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1671.3669",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1749.7585",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-298814.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "635629.69",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "975.53125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-276.01245",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "15.244019",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.3486",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.14896",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.07472",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.72568",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.48457",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.23944",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.61058",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.83588",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004094105",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02736162",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.89537",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.72556",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22598840E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.82096410E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22598840E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.82096410E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004094105",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02736162",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.80708992E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.94620520E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.80708992E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.94620520E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02662187",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.655613",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06090605",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.24572",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.560425",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "29.467072",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.639175",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.514664",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "9.02742840E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03855826",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.55852",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "330.5144",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.09212",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.11514",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.4025",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.34827",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05998594",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "90.025902",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8517.9453",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.44531",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.3125",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.55591",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-75.44751",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2082.031",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2204.3662",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-387.55591",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-83.225342",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-81.902924",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1217194",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-731.28516",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-73.243652",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7025642",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.6913433",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5750093",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.3822384",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.7439",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.25302",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.7701",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.69641",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.13652709E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.48926",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.27667760E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.198242",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47514.266",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111849.12",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.31851992E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.79147389E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.41048395E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-443459.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "456753.12",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "970.28125",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.40015",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "45.259201",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02955444",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258516",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-719.85107",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "891.9248",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1133.7371",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "197.03467",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.53349713E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.87857743E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1982.7346",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1853.1404",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-358001.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "628072.69",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "972.8125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.40015",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "23.163177",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.21542",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.49771",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.68982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.84637",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.7701",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "342.80188",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.52109",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.35101",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006829716",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0277974",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.388706",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.75388",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22552647E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83636712E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22552647E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83636712E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006829716",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0277974",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83738416E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.06597383E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83738416E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.06597383E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0172307",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.088776",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03471962",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.780708",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.191589",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "29.136902",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.811874",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.517975",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.29864384E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03593269",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.20007",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "330.45441",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.65378",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "320.48325",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.78426",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.16153",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04443215",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.549454",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8519.918",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.55176",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.6562",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-384.14087",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.862305",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1476.0278",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1640.8882",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.1875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.14087",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.914307",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-82.005066",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1217041",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.48584",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-72.229004",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6230898",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "3.8939514",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8575773",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.3042421",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.01448",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.69568",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.2549",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.8201",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.51222321E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.60376",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.98200131E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "14.864502",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47292.266",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112096.75",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.33752972E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.77119978E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.18013509E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-427786.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "454960.81",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "966.32812",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-271.21094",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "43.268448",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02904879",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258436",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-753.31226",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "906.896",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1096.8813",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "188.45874",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.38612119E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.53588836E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1813.6636",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1792.0835",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-312688.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "599735.06",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "966.32812",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271.21094",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "12.627869",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.9967",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.60187",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.67885",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.37103",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.2549",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "342.46121",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.17372",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.65875",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003819981",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02732079",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.161251",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.9234",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.38407277E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78545961E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.38407277E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78545961E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003819981",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02732079",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.77967024E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.99952524E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.77967024E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.99952524E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0236739",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.495556",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05817139",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.797604",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.204712",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.856506",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.410599",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.449356",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.01413400E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03521667",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.86061",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "331.20648",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.12451",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.39948",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.38753",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.28766",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04805781",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "90.609077",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8511.5547",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.28027",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.9688",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-378.55298",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-76.334473",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1693.3135",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1848.8484",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.625",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-78.436768",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.075638",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1212006",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-711.13306",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-68.881592",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.8177109",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.1103859",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2670622",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.7215872",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.86398",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "336.68896",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.6678",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.23212",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.43446550E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-692.71777",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.10642019E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.478027",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47349.699",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111911.86",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.09476467E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.53407086E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.28215822E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-440848.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "429979.81",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "972.79688",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-265.75317",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "56.866379",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02913117",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258608",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-732.27368",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1389.5564",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1469.2402",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "168.30908",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.87508055E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.73047111E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1823.7595",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1920.7083",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-318945.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "616824.38",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "972.79688",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-269.9043",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1.1956177",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.91312",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.33643",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.54649",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "316.77258",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.6678",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.3161",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.10262",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.05261",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003868712",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02694692",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.381872",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.82605",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.37418574E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.80655097E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.37418574E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.80655097E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003868712",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02694692",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.30498040E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.23253710E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.30498040E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.23253710E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.01714108",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.96983",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03773161",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.756859",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.203979",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "30.492371",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.601974",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.056503",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.04139553E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.04038134",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.45235",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "331.4928",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.73479",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "321.91052",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.75996",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.72308",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.02897478",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "84.235825",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.3477",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.71338",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.9062",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-376.18896",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-77.225586",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1506.22",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2171.209",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.9375",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-376.18896",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-77.942627",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-93.712524",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1215668",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-727.10986",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-67.308594",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.3895359",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.8982248",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1309471",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.4187965",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.78374",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.43039",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.8096",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.00763",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.13907697E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-701.95459",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.56204827E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.974854",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47282.609",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111912.55",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.72336807E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.84103931E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.77626390E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.34220215E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-459192.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "446808.31",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "979.53125",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-256.98291",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "53.479324",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03091273",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258539",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.83228",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "904.3728",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1129.209",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "163.80347",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.51539051E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.87961040E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1888.4102",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2250.6633",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-283851.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "630855.81",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "979.53125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256.98291",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "23.429214",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.05597",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.82507",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.81363",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.10504",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.8096",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "342.12677",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.07986",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.65884",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004063651",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02597344",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.074982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.66721",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25488032E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.73419958E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25488032E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.73419958E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004063651",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02597344",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86543275E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97450322E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86543275E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.97450322E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02254185",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.779705",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04009176",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.744228",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.05368",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.090393",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.378632",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.14006",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.06343009E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03859269",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.15282",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "327.6485",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.78952",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "322.36029",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.95097",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.10138",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04489268",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.626099",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.7617",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.43481",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.4375",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.57886",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-76.79248",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1378.4641",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1762.3552",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.5625",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.57886",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.0271",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-81.86293",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1213074",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-727.76074",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-71.093506",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1393099",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.4462929",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.005249",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.5232",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.37456",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.26166",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.55025",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.5108",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.10413566E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-705.98486",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.53205609E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.216064",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47070.172",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112247.64",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.88821319E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.46111904E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.17338527E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-399896.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "503977.12",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "970.48438",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-268.04053",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "37.643158",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03103579",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258438",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-729.49121",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "778.5437",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1129.6833",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "171.17847",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.51728766E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.84488555E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1791.2397",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1721.7256",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-321300.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "592207.62",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "974.75",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-268.04053",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1.5050049",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.2733",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.5423",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.71883",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.37595",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.55025",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.75885",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.564",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.4762",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003439725",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02901437",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.4373",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.70175",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.18458274E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85129738E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.18458274E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85129738E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003439725",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02901437",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89031471E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.75699336E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89031471E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.75699336E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02720777",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.90881",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04967429",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.208164",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.458328",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.672592",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.759003",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.018341",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.41030569E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03445723",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.33147",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "329.65283",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.03108",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.38324",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.1689",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.31027",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05598744",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "85.683495",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8531.75",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.22632",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.5312",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.13818",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-75.990967",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2072.9988",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1804.6064",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.13818",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.291504",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-82.723404",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1213837",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.42847",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-72.476318",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0825558",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.7557583",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.0730581",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.2769761",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.40982",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.15765",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.93869",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.03345",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.40335101E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.91357",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.70508598E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.788574",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47281.094",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112241.55",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.13892563E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.70969201E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.29761816E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-416090.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "429215.88",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "975.35938",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-259.72144",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "47.457016",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0296964",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.25853",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-709.53882",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "989.73047",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1223.0774",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "202.11938",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.89074353E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.08200014E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1577.3145",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2011.1956",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-299096.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "648039.31",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "975.51562",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-259.72144",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1.9089813",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.85983",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.61115",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.54308",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.49628",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.93869",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.89282",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.0571",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.34",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003512534",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02643578",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.705441",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.79532",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.17310738E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85012395E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.17310738E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85012395E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003512534",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02643578",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90690434E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91791651E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90690434E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91791651E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03315635",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.368176",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05186795",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.673168",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.484268",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "29.457031",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.084015",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.430954",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.04885794E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03659149",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.67807",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "329.43994",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.04419",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.97009",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.33434",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.30548",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03809334",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "88.686806",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8517.9258",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-809.89258",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.4062",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.95947",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-76.762207",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1624.8352",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1795.3594",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.0",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.14893",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-76.48877",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-95.060181",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.12117",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.5791",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-67.576172",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9169674",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.0586023",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7967081",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.3686686",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.92871",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.92007",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.7507",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.58667",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.05326683E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.90356",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.35073923E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.668945",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47274.805",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111934.83",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.61577939E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.72023101E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.24436372E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-409871.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "455579.62",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "972.01562",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-264.87988",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "62.073273",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03032464",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258471",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.17358",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "981.27881",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1057.271",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "169.854",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.22773013E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.79210643E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1382.6931",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1746.5913",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-322873.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "656078.19",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "973.25",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-264.96387",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "7.2911987",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.02419",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.32367",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.16054",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "320.0416",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.7507",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.99487",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.11267",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.45279",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005338736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02637599",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.974974",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.79083",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.27661233E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86506950E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.27661233E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86506950E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005338736",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02637599",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89231218E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07393668E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89231218E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.07393668E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0325004",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.806572",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05830161",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.304607",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.60881",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "29.729904",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.84256",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.82576",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8.72887540E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03480053",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.02638",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.16962",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.24182",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.65344",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.24182",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.72748",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03924308",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "85.888443",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.5742",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.17603",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.9062",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-380.9458",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.782227",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1963.5159",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1753.5195",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.3438",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-380.95581",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.592529",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-81.117477",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1214142",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-734.55298",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-73.587158",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2515755",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.4221354",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2227707",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.5856524",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.15652",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.16449",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.60188",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "350.34375",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.38845485E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-689.20605",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.82876964E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "14.385254",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47690.676",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112082.51",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.14914949E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.47287494E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.55036389E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-397169.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "453544.19",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "976.53125",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.66284",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "40.597137",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02994568",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258471",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-686.23535",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "857.4563",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1137.1404",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "175.56226",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.54710630E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.02013665E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1898.7234",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1892.4954",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256566.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "622798.44",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "976.53125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-260.66284",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "3.1015015",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.58395",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.94031",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.84396",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.87402",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.60188",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.77344",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.81003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.69287",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00382855",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02743105",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.206522",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.93237",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16272631E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.89867933E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.16272631E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.89867933E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00382855",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02743105",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87180467E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91115737E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87180467E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91115737E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03660752",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.603287",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05692108",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.881889",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.872253",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.878098",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.568619",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.337265",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "3.00827480E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03740037",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.58551",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.33157",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.82913",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.27173",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.46666",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.2757",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.08577907",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "89.825432",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.5039",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.91895",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.1562",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.62061",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-72.629395",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1511.2356",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2220.0149",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.0625",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.62061",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-90.351318",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-73.619461",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1220398",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-719.16772",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-77.369385",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8978939",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.1056671",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.9732046",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.0546703",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.25929",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.84161",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.16272",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.54214",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.31893853E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.70483",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.62184141E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "16.020996",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47385.277",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112175.16",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.73033889E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.62286005E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.40897725E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-495777.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "481698.38",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "969.51562",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-280.7146",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "47.692581",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0275771",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258642",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-726.57812",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1118.5908",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1216.4265",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "185.32324",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.86414876E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.41039514E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2061.6406",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2133.9041",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-301022.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "630693.06",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "969.51562",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-280.7146",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "4.0759277",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28389",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.10779",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.21671",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.63766",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.16272",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "342.48853",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.57686",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.66949",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003938809",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02656893",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.843208",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "410.09778",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25755068E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.79182425E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.25755068E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.79182425E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003938809",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02656893",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87748469E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91337153E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87748469E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91337153E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03212528",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.332462",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05500382",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.730507",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.656235",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "30.055908",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.50116",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.70932",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.80601352E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03931992",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.75365",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.19376",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "196.59373",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "321.03223",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.65143",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.27649",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03273069",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "83.331619",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8546.1289",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.9165",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.7188",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-396.57568",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-75.085693",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1674.2297",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2148.9399",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.7188",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-396.57568",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-75.388916",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.6371",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1212769",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-708.98218",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-64.706055",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7908497",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.7038565",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.3061361",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.8652382",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.91609",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "335.78088",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.75851",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.04214",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.42244630E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.18994",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.59186446E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.487549",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47025.16",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111808.86",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.66067808E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "2.22824360E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.50626136E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-452829.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "484574.81",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "968.45312",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-285.18848",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "44.750107",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0301014",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258415",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-718.28369",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "938.62549",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1177.9172",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "220.38867",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.71016165E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.81279902E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1890.4219",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2209.6089",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-289189.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "577607.44",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "968.8125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-285.18848",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "7.0055084",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.17197",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.54474",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.41655",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.4632",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.75851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.08307",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.24713",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.34259",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004560724",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02924465",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.483109",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.66101",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22688016E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78894843E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.22688016E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78894843E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004560724",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02924465",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92387733E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98902239E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.92387733E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.98902239E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02751035",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.180367",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04818871",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.864178",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.833115",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.516357",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.432831",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.366745",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "9.24612777E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03547608",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.54524",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "328.03882",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.06303",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.28854",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.24815",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "325.03821",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0575906",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "89.497993",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8524.5078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.57959",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.875",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.24316",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.330566",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1464.9094",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2175.3645",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.4062",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-387.24316",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-82.684326",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.847443",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1218109",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-713.82153",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-72.124023",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5645323",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.9064274",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2910728",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.6291656",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.95184",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "336.8299",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.93918",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "344.84247",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.11522127E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.01978",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.51939593E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "14.811279",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46909.5",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111880.03",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.09577614E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.44530020E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.26926591E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-438634.12",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "459954.06",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "972.5",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.46875",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "49.371628",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02968026",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258427",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.93604",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "907.30933",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1021.3657",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "231.9043",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.08415559E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "9.27279586E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1506.4739",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1990.1836",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-324264.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "645574.12",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "975.21875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-260.46875",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "29.449753",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.27722",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.13721",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.6331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.5209",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.93918",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.71234",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.37392",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.24121",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002793198",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0274215",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.670778",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.6907",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.24126100E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.77423281E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.24126100E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.77423281E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002793198",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0274215",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.96078804E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.82326926E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.96078804E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.82326926E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0306731",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.304718",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04545197",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.803574",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.307175",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.057373",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.59758",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.251785",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.15527712E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03354265",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.40123",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "329.70508",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.02979",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.13281",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.94214",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.84909",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05399295",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.647263",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.9688",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.22437",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.375",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-379.56689",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-73.679199",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1338.7014",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1588.543",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.6562",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.8186",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-85.984375",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-79.250229",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1219788",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.07788",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-74.493896",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6774511",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.4669886",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.8441858",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.141809",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.60612",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "335.14587",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.54964",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "343.57104",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.09910911E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.51245",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.41796908E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.981201",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47115.805",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112125.34",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.71492091E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.46921798E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.30061539E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-461007.38",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "463624.94",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "972.39062",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-270.80664",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "42.85611",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0295378",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258484",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.55688",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "963.0",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-978.21143",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "169.89453",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.87938229E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.79334136E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1425.3145",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1728.4663",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256092.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "600408.81",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "972.39062",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271.00562",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "17.039307",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.25803",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.06531",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "201.0269",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.41342",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.54964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "339.8894",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.63835",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.91919",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005161017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02915158",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.290966",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.69934",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20336053E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83788798E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.20336053E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83788798E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005161017",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02915158",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03256036E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.15068735E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03256036E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.15068735E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02220129",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.344208",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03692427",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.484581",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.490189",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.456055",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.438324",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.930481",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.69916882E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03448027",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.7449",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "330.15894",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.77534",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.60754",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.99904",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "329.52448",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05122538",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.683784",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8551.4766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.69409",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1180.2812",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-392.12524",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-73.253662",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1681.2466",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2100.2195",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.8438",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.12524",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-81.94751",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.739731",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1217499",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-742.63232",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-73.456787",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.8812084",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.5137653",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.4481955",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.6412106",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.14931",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.75732",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.7372",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "348.98019",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.32207333E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.24316",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.75368938E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "13.823242",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47234.59",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112788.16",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.23125276E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.68623490E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.25297015E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-417024.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "450809.62",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "971.79688",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-279.09229",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "46.684113",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03052",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258434",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-718.82593",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1211.9382",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1242.7874",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "193.29272",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.96955920E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.72948283E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2046.5569",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1938.9294",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-301666.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "683574.56",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "971.79688",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-279.09229",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "12.591248",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.93733",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.66711",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.30219",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.75626",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.7372",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.13644",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.07857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.55429",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003834673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02593776",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.428226",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.59818",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23827604E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.84435739E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23827604E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.84435739E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003834673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02593776",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03854120E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.99028045E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03854120E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.99028045E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02651513",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.488258",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05324702",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "39.699341",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.52063",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.771347",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.441254",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.195724",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.32710795E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.04161635",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.66628",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "330.4491",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.47952",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.28113",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.51216",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.64172",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04717844",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "86.021484",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.582",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.35815",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.0625",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-379.8894",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-73.205322",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1992.2336",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2343.5667",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.6875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-379.8894",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-78.375",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-85.218674",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1216583",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-716.37695",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-68.010742",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7692871",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.4691114",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2172499",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.3570042",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.26276",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.17188",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.21375",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "343.93115",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.31334912E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.98999",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.81479981E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "12.956787",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47292.91",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112130.36",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.54730843E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.56710769E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.30764442E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-426526.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "488434.75",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "969.57812",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-256.32812",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "37.874496",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03037264",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258448",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.10254",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "920.82031",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-991.6106",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "224.49072",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.96517294E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.97712482E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1602.8625",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2204.7542",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-317586.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "615275.75",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "969.57812",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256.37061",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "7.2515411",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.20532",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.01816",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.187",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.37152",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.21375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.11475",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.43768",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.83649",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005709007",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02834049",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-22.157986",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.83432",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.21903186E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.84792407E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.21903186E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.84792407E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005709007",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02834049",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.20959441E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91298273E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.20959441E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.91298273E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03262201",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.084614",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05663408",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.670494",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.243637",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "30.849136",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.95549",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "31.769852",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.94266534E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03459571",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.66345",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "327.67529",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.57001",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.67386",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.57275",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.80096",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05514316",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "89.335487",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8532.4688",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.96167",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.9375",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-384.93677",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-77.012451",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1623.2014",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1856.4521",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.125",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.93677",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-84.371582",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.552261",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1211853",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-733.90479",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-73.350342",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7088156",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.896019",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1247082",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.4413586",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.8008",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.74329",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.70999",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "346.16644",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.48539971E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.6543",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.44708052E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.621582",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47346.82",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111749.64",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.32460444E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.53596136E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.24856467E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-434352.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "488791.81",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "973.6875",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-267.67114",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "42.153412",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02968542",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258562",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.27539",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "895.97925",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-945.51587",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "169.29468",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.78085332E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.76933212E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1928.5471",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "2019.3196",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-309477.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "605616.06",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "973.6875",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-267.72778",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "0.4866333",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.14931",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.34064",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.66771",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.98959",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.70999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "342.09027",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.33284",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.99475",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003628514",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02781068",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-22.277485",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.98175",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.31084507E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78706759E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.31084507E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.78706759E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003628514",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02781068",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94508448E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85075044E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.94508448E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85075044E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03084241",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.50346",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06551111",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "36.23185",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.619629",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "32.567307",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.741653",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.936016",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.61524611E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03522773",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.3755",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "329.41895",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.30315",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "321.91272",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.32515",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "324.69873",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04926793",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "83.49942",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.082",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.91064",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.1875",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-386.67944",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-74.843018",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1819.011",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1752.5042",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1180.75",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-386.67944",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-80.534912",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-81.860229",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1215973",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-712.25684",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-70.755127",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7714815",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.5894661",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7459202",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.2925797",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.10016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.21985",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.16193",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.60059",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.08937456E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.60449",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.83415385E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "13.712402",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47244.598",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111829.61",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.02622403E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.61503613E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.27065709E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-416122.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "450605.0",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "972.01562",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.10132",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "43.234955",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02906969",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258451",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-742.01172",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1145.1133",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1231.1482",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "156.90723",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.92301695E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.27400993E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1633.6501",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1818.4302",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-282483.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "618443.38",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "974.82812",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-260.10132",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "0.4871521",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.28941",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.26334",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.74512",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.35059",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.16193",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.4209",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.57289",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "314.19815",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00493367",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02635074",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.930599",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.66064",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.18164207E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85510999E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.18164207E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.85510999E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00493367",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02635074",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00419140E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86751095E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00419140E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86751095E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02335205",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.02338",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05807418",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "41.149761",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.381897",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "40.883301",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.084015",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.2612",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "9.21028231E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03457734",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.92531",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "332.09192",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.63591",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "320.08588",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.75255",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "323.70834",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05106081",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "84.595108",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.7383",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.7207",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1178.8125",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-377.01562",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-75.149414",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1543.9841",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1964.519",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.1562",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-377.01562",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-77.970215",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.626129",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1220703",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-718.28613",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-67.171143",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2970467",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.6032944",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.773201",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "6.4905453",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.65039",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "338.15643",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.62109",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.57672",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.41500061E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.55933",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "5.23694325E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "14.587891",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47375.648",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "111797.62",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "8.13094914E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.76086519E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.24235896E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-431496.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "460356.38",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "968.64062",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-254.01337",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "41.530121",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0308817",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258451",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-871.84424",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1043.2",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1028.8284",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "185.00659",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.05900494E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.39774180E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1598.1929",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1895.1318",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-249445.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "593017.25",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "968.64062",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-254.01337",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1.4072113",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.81664",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "309.91779",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.1992",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "317.92258",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.62109",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "341.7193",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.89868",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.51636",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005191118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02755642",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.514347",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.53394",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23517975E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83533612E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.23517975E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.83533612E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005191118",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02755642",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87564149E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.06568643E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87564149E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "2.06568643E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03385956",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.564156",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05869738",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "37.765705",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.979004",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.333664",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.538956",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "35.0354",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.02585716E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03746738",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.66644",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "333.74219",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.45741",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.77661",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.64343",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.99991",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0491235",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "91.119492",
                                            "gribNumBits": "16",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8519.1328",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "100000.0",
                                            "gribNumBits": "16",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-814.46289",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "1179.5312",
                                                "gribNumBits": "16",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.11597",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "-76.273193",
                                                "gribNumBits": "16",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1593.9736",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1564.2271",
                                                    "gribNumBits": "16",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1181.2812",
                                                    "gribNumBits": "16",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-382.78784",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "-83.316162",
                                                    "gribNumBits": "16",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "58762.242",
                                            "gribNumBits": "16",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.819336",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.1215515",
                                            "gribNumBits": "16",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-717.17139",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "-71.736328",
                                            "gribNumBits": "16",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7541275",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "4.6466103",
                                            "gribNumBits": "16",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.6443615",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.311492",
                                            "gribNumBits": "16",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.73874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "337.44482",
                                            "gribNumBits": "16",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.79808",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "345.06329",
                                            "gribNumBits": "16",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.28823808E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.23828",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.0078125",
                                            "gribNumBits": "16",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.7324371",
                                            "gribNumBits": "16",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.14993803E-07",
                                            "gribNumBits": "16",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "15.431641",
                                            "gribNumBits": "16",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.5",
                                            "gribNumBits": "16",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "20.00148",
                                            "gribNumBits": "16",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47151.18",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "112128.95",
                                            "gribNumBits": "16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.35871708E-07",
                                            "gribNumBits": "24",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.56300280E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42101112E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.23177551E-06",
                                            "gribNumBits": "24",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-421519.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "443987.0",
                                            "gribNumBits": "16",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "966.23438",
                                                "gribNumBits": "16",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-275.18701",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "scale_max": "38.677704",
                                                "gribNumBits": "16",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "1.0",
                                            "gribNumBits": "8",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Log Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02971696",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255",
                                            "scale_max": "16.258417",
                                            "gribNumBits": "16",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-718.64136",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "906.83521",
                                            "gribNumBits": "16",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1018.624",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "197.25317",
                                            "gribNumBits": "16",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.9492188",
                                            "gribNumBits": "8",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.07319249E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "7.88784860E-08",
                                            "gribNumBits": "24",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1951.0552",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "1932.7605",
                                                    "gribNumBits": "16",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-325806.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "630162.5",
                                                    "gribNumBits": "16",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "967.54688",
                                                    "gribNumBits": "16",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-275.33545",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "scale_max": "4.3799744",
                                                    "gribNumBits": "16",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.8004687",
                                            "gribNumBits": "8",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.50768",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "310.03625",
                                            "gribNumBits": "16",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.43172",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "318.40701",
                                            "gribNumBits": "16",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.79808",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "340.76056",
                                            "gribNumBits": "16",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.66655",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "313.96329",
                                            "gribNumBits": "16",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009461354",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02616844",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.704597",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "409.49457",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.24305861E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.74620582E-05",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.24305861E-05",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.74620582E-05",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst nov2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.009461354",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.02616844",
                                            "gribNumBits": "16",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.84297926E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86335342E-06",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.84297926E-06",
                                            "process": "50",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255",
                                            "scale_max": "1.86335342E-06",
                                            "gribNumBits": "16"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03415591",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.281216",
                                            "gribNumBits": "16",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06591314",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "38.03981",
                                            "gribNumBits": "16",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.452194",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "33.370544",
                                            "gribNumBits": "16",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.043106",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "34.424484",
                                            "gribNumBits": "16",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.98248949E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "0.03515056",
                                            "gribNumBits": "16",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.27628",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "331.36887",
                                            "gribNumBits": "16",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.8871",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "319.69519",
                                            "gribNumBits": "16",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.8938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "scale_max": "326.22797",
                                            "gribNumBits": "16",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "423.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/nov2001"
                        },
                        "oct2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "oct2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200201",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200201",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200201",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200201",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200201",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200201",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200201",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200201",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200201",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200201",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200201",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200201",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200201",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200201",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200201",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200201",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200201",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200201",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200201",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200201",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200201",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200201",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200201",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.oct2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/oct01/20002fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200201",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0404233",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "91.561562",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.2734",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-811.97852",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.0625",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-73.866455",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1511.7336",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1811.9321",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.0625",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-73.858643",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-93.340576",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.140686",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-738.16431",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-63.449951",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.9431276",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.1867218",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.1174212",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.1101799",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.06638",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "339.12445",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.10759",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "347.99872",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.10354074E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-689.69458",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.15503120E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.304199",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47283.934",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112290.2",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.41163143E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.47438889E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.58102239E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.27247313E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-402795.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "439920.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "974.6875",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-277.63281",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "60.39325",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03001987",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258488",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.98169",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "851.35303",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1074.7341",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "226.84937",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.29756085E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "9.07111826E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1629.4224",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2160.8171",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-412809.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "629672.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "974.875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-277.63281",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "19.001358",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.14459",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.94168",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.08676",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.11838",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.10759",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "343.69403",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.26355",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.21484",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00501645",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02814297",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.03462",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.58286",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.47803357E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85140070E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.47803357E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85140070E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00501645",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02814297",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04216190E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85995725E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.04216190E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85995725E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03294361",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "39.66766",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05026391",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "41.704437",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.99408",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "29.959335",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-41.294098",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.056503",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "9.95619871E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.05297118",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.13356",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "332.90341",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.02251",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "320.38974",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.09818",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.08044",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04509993",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "92.169914",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8543.2109",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-812.85449",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.30664",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-74.426025",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1616.248",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1774.5752",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.34473",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-77.983154",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.014786",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.141098",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-727.10449",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-68.729492",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5107031",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.2382574",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.9256706",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.2830429",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.73608",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.59674",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.72331",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.13406",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.06175980E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.17041",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "8.78804713E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.491211",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47330.633",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112305.36",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.80571042E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.37892835E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.15186128E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-396026.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "437957.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "971.78125",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-264.53125",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "62.961502",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02840996",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258541",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-721.06543",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "909.13721",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1071.5979",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "182.8042",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.28502005E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.31002672E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1859.46",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2005.9634",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-290385.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "637517.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "974.35938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-265.65088",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "22.744293",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.4796",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.99249",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.17209",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.57663",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.72331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.1366",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.63837",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.69385",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00549433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02967164",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.651957",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.54593",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54970385E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.87398055E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54970385E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.87398055E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00549433",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02967164",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89346213E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.96447945E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89346213E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.96447945E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03583745",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.324009",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05637093",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.563179",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.279984",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.130112",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.848755",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.2836",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.17128195E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03533986",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.06639",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "332.91583",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.81461",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.5257",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.83922",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.77618",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04332361",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "93.914032",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.1328",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.38452",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-396.90063",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-73.940918",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1883.8494",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1839.0928",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.2812",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-397.99463",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-73.943848",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.25885",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1408539",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-735.58545",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-62.725098",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.814353",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.8255606",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4827023",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.7811089",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.55647",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.28662",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.48947",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.47925",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.28479383E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.50415",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.71148121E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.349365",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47542.316",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112042.09",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.27738120E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.41568864E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.07996707E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20277889E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-387276.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "450751.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "968.625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-262.86499",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "57.219131",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02967521",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258444",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.02124",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1097.4719",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1170.9102",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "169.40405",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.68214239E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.77372043E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2107.9561",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1724.6714",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-297779.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "616775.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "969.32812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.19287",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "21.496704",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.36479",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.7807",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.06793",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.41553",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.48947",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.4223",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.57375",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.6571",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005271651",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03203419",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.628122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.5853",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56389397E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.83623870E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56389397E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.83623870E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005271651",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03203419",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93322558E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06740833E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93322558E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06740833E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03589255",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.813862",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05800484",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.665768",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.214188",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.457138",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.926804",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.885452",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.95075152E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03787952",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.03683",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "331.57324",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "185.94559",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.84814",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.96127",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.39801",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04702938",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "94.084106",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8524.1445",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.8584",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.25",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-394.26782",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-73.872314",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1461.2134",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1951.8032",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-401.7605",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-73.833252",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-89.660965",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1407928",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-725.58203",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-63.457031",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.0915604",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.2634315",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.3014631",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.8269424",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.05238",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.25748",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.97816",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.71472",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.06930406E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.57227",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.44038664E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.428711",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47384.449",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "111877.42",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.34839454E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "2.00112640E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.17086256E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-475950.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "463793.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "971.17188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-276.89648",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "55.815201",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03111",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258518",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-790.79248",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "804.34985",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1164.3193",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "218.08228",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.65578751E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.72096848E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2008.0254",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2213.1731",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-281801.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "630738.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-276.96436",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "14.676285",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.86966",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.43073",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.56186",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.74579",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.97816",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.50769",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.98157",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.21484",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002119117",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03017602",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.23542",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.61877",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52140219E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.79286435E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52140219E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.79286435E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002119117",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03017602",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.13381804E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.99814463E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.13381804E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.99814463E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02652412",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.127121",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06439048",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.732216",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.593704",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.380859",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.485901",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.437698",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.17892021E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03941472",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.27577",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "332.63315",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.12994",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.70648",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.14204",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "326.67883",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04806907",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "93.229782",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8483.2578",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.52075",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-391.7229",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-75.97998",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1468.948",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2174.302",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.5",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.7229",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-83.579102",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-81.891251",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1412354",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-723.95532",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-74.747803",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.5641689",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.3225794",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.0218477",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.9384289",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.75134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.04037",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.74016",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.99817",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.28597389E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.15845",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.60918886E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.208984",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47317.242",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112231.17",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.95767335E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.95177654E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.34095262E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.24188659E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-428899.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "515550.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "971.85938",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-263.54614",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "54.28688",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03108695",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.25844",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-755.35645",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1140.9377",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1192.3252",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "213.36768",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.76777529E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.53188737E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1660.321",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2451.3916",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-321027.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "659035.25",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "973.75",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.83496",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "17.417648",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.35989",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.90527",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "202.10332",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.05664",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.74016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.75012",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.92145",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.84467",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002197682",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0307528",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.829624",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.57043",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50368314E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.94022377E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50368314E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.94022377E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002197682",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0307528",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.18449895E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.00608906E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.18449895E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.00608906E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02908164",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.531994",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04471447",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.280621",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.48204",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.73111",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.412369",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.262558",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "2.36707933E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03822327",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "194.5018",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.37222",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.78288",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "323.10809",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "193.93622",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.88828",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03917768",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "89.583618",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.2344",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-804.05078",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.47974",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-75.869141",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1555.3135",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2111.1404",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.47974",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-75.541016",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.908188",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1409454",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-737.32202",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-65.847412",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1711893",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.2197495",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.2292929",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.9727974",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.75525",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.67871",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.6739",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "347.58234",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.21414530E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-696.58936",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.58008503E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.464355",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47305.242",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112482.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.05619073E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.79459505E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.29200987E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-462965.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "510427.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "969.0",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-271.94873",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "66.125488",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0307214",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258457",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-715.86938",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "790.65747",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1096.9358",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "165.97705",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.38633890E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.63711432E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1973.5876",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1958.5811",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-268506.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "627745.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.4375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271.94873",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "31.185806",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.29466",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.25217",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.21675",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.11612",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.6739",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "343.40601",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.50572",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.93912",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006152112",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02719126",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.425098",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.77036",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57983141E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81263931E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57983141E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81263931E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006152112",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02719126",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.91571621E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.05533183E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.91571621E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.05533183E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03504849",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.301903",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05903333",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.470284",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.821198",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.668198",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.117279",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.288651",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.39249323E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03959822",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.60095",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "337.99075",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.35896",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "323.00864",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.39432",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.27246",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06065033",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "92.966263",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8520.9531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.59033",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-391.5332",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-77.961182",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1830.425",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2055.9666",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-391.5332",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-82.421631",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.419861",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1408691",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.80664",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-72.341553",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6801643",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.056922",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.5193024",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.1781092",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.09998",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.30981",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.98622",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.3009",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.15973023E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.10864",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.68922439E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.310059",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47027.238",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "111733.54",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.69362657E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.76701360E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.26078464E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-444998.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "439546.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "968.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-259.00757",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "56.106903",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03025244",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258528",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.46216",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "880.21704",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1075.541",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "166.823",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.30078700E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.67101006E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1722.2566",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2169.3127",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-308129.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "697046.69",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "968.9375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-259.00757",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "38.007263",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.21989",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.51205",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "200.85863",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.07562",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.98622",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.30664",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.52615",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.21765",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006178077",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02750367",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.045547",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.61981",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54765312E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82003369E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54765312E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82003369E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006178077",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02750367",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00685008E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.93593200E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00685008E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.93593200E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02404224",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.314049",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04869335",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.956444",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.155304",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.65239",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.324951",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.451202",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.77424511E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03583305",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.48172",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.91516",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.23999",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.55548",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.30516",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.48383",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04256865",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "97.0998",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8511.9023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-801.18164",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.7188",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.43701",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.276855",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1537.9021",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2069.6707",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.09912",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-82.996582",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.88829",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1411743",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-733.73926",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-72.726074",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1203232",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "3.7156324",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.2452898",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.4970531",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.31697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "339.48111",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.38838",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "347.9743",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.03415857E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.9751",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "8.05928721E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "14.838135",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47483.277",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112466.03",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.32423814E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "2.06687014E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.37026541E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-441856.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "475070.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "969.67188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-260.62964",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "64.113266",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02966807",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258471",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-716.68286",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "864.19629",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1314.4111",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "175.81836",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.25596249E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.03021499E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1721.3333",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2121.4363",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-329503.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "630710.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.96875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-260.62964",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "23.132111",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.02293",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.64227",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.85559",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.66806",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.38838",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "343.5603",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.19492",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.80859",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004050922",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02806904",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.834179",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.7106",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.48870467E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80176394E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.48870467E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80176394E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004050922",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02806904",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99209580E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.14428928E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99209580E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.14428928E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.04524821",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.656414",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06500381",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.059246",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.392761",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.821793",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.984909",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.366348",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.44767057E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03327904",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.83519",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.11398",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.78287",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "324.33856",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.82874",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.61639",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03153373",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "90.45945",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8482.9023",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-801.97168",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-394.74316",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.205322",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1456.3142",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1826.4202",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.1875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-395.58179",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-78.970947",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-92.12883",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1412201",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.8252",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-69.943115",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.078043",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.450738",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7485542",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.7316246",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.58922",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.63708",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.65102",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.66937",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20301445E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.60449",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.15559805E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.473145",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47258.832",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112406.83",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.41172175E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.54987411E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.46047523E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.42301546E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20328946E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-440953.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "438629.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "968.92188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-273.45923",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "51.35701",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02963252",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258438",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-905.55591",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "949.39014",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1125.3167",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "192.42944",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.49982622E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.69470603E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2014.8604",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1955.7563",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-326595.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "676525.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "969.54688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-273.50488",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "19.173523",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.93584",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.4967",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.74423",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.77322",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.65102",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.74994",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.21629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.27698",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0048475",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02827307",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.775892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.51553",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56288897E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84236978E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56288897E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84236978E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0048475",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02827307",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93843994E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.98274120E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.93843994E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.98274120E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02238405",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.974323",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04067428",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.962673",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.067444",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.069672",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.278854",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.083008",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.05925835E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.04045576",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.37154",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "335.19788",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.92871",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.60553",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.94803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.50378",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03553081",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "94.886925",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8561.293",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.65381",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.32178",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.156738",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1564.3787",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1933.5422",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.90552",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-76.122559",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-83.542343",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1405945",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-719.02686",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-64.68042",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.8516846",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.5056944",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6437111",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.6554689",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.92674",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.44254",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.9149",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "345.05106",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.13027454E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.94727",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.67021891E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.998779",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47261.531",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112048.44",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.44795443E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.74253307E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.19691879E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-408999.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "478586.19",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "970.15625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-274.65308",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "62.970322",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03034052",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258373",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-725.58423",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1180.0105",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1383.0127",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "193.95093",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.53028087E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.75534659E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1762.6426",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2305.0632",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-256475.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "636838.81",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "972.45312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-277.39209",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "18.352112",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.13907",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.79602",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.13976",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.29681",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.9149",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "341.05692",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.31447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.62073",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002014325",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02844471",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.976265",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.56213",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54871959E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77526308E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54871959E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77526308E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002014325",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02844471",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.81640462E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84130351E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.81640462E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84130351E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03040254",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.146503",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.07675505",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.097904",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.011841",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.19574",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.877441",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.093979",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.03215712E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03632068",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.29088",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "331.81696",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.23009",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.04968",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.26575",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.73492",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03681768",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "91.125366",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8517.0625",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.33545",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.1875",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-384.56592",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-73.12793",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1558.2935",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2226.1125",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.7188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-384.56592",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-73.12793",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-92.198502",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1404572",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.25415",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-63.520996",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.968749",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.4158459",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.17554",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.2797403",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.14803",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.40363",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.94882",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "341.91794",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.34508605E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.24316",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.33706043E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.260254",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47355.785",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112068.84",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.66791175E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.63230072E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.14795607E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.44568605E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-419416.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "434877.75",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "973.45312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-249.3463",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "64.297455",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02945766",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258465",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-866.83276",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "836.27051",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1132.1848",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "170.8374",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.52729012E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.83126871E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1839.115",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2072.0598",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-288823.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "610941.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "973.45312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-249.3463",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "29.325638",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.30931",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.57446",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.56697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.11151",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "182.94882",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "337.83591",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.4622",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.53168",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007046245",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02986223",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.765518",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.58597",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54590234E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.88520116E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54590234E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.88520116E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.007046245",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02986223",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.02996989E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.96948167E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.02996989E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.96948167E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.026367",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.853065",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05570356",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "38.631607",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.681473",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "29.303192",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.474365",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.3172",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "5.68374681E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03793754",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.96072",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "331.66858",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.17505",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.00772",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.24165",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "330.81363",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0447759",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "92.574989",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8544.668",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-811.27637",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.9062",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.82568",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-74.611084",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1469.8162",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1889.2324",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.9062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-392.97583",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-74.478271",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-94.052689",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1410065",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-755.38843",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-65.468018",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9326305",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.8556232",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.9408331",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.8315058",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.58084",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "343.21497",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.46509",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "350.35269",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.21118399E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.39966",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.61384547E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.731934",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47501.914",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "111965.67",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.04871003E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "9.02557133E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.59089677E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.29001296E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-411478.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "509858.38",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "970.82812",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-265.44019",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "59.800781",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03069475",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258417",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-761.52393",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1074.7708",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1204.6536",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "243.98193",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.81707275E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "9.75652767E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2080.4724",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1953.572",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-319290.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "657807.06",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "970.82812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-265.44019",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "18.653793",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.80864",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.67767",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.02666",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.81418",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "184.46509",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "346.26202",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "208.98431",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.59659",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00353857",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02779661",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.435976",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.46616",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50394990E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82048680E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.50394990E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82048680E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00353857",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02779661",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90677065E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81307337E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.90677065E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81307337E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0349563",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.859249",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06010152",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.823139",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.123703",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "29.605103",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-37.684433",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.565079",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.52840016E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03374197",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.3168",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "334.06836",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.27005",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.0105",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.44989",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.21973",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03747261",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "93.096062",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8524.75",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.70386",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-387.70459",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-70.438721",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1541.3696",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1864.0225",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.67554",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-70.219971",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.285172",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1407013",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-730.6958",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-60.047119",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2900791",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.7644958",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7225456",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.5689259",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.58177",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "338.94528",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.69095",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.05438",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.24764290E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.99878",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.13567715E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.59082",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47134.254",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112213.45",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.40687426E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.48677805E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.25770373E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-389572.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "434637.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "975.5625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-274.19189",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "58.933075",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0294508",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-716.84155",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1093.2424",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1307.1438",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "227.71606",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.22690186E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "9.10547442E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1680.2705",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1994.5681",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-266341.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "674304.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.5625",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-274.29175",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "19.060013",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.02707",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.34021",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.11006",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "320.00723",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.69095",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "341.9411",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.13499",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.4801",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003639404",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02686213",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.656851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.61014",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53027358E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.92210500E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.53027358E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.92210500E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003639404",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02686213",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87214425E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85929491E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.87214425E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85929491E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02877969",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.345638",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06200147",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.300617",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.313812",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.083893",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.249557",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.83638",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.67104780E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03649859",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "183.74878",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.30652",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "183.2149",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "323.42712",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.30243",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.19028",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04254697",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "90.357079",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8531.0898",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-806.17285",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.3438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-389.0354",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.22168",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1853.6345",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2319.2236",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.9375",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-389.0354",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-78.101074",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.962585",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1406708",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-733.38306",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-67.474365",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.9726191",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.1040421",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.4152327",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.8697596",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.88042",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "339.99615",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.79231",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "348.78986",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.36680819E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-704.17896",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.68281393E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "14.23584",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47348.211",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112016.89",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.66684082E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.77183881E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.36983283E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-451310.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "433402.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "970.54688",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-257.11523",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "65.194534",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03059915",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258526",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-705.83838",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "783.23804",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1205.1414",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "222.1936",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.81902248E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.88498448E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1699.8625",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1851.8005",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-323788.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "637609.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.95312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-257.11523",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "34.083328",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.57822",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.91843",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.71053",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.42465",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.79231",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "344.5188",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.82631",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.51501",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006019317",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02723618",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.861315",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.56973",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52289776E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81554278E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52289776E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.81554278E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006019317",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02723618",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.81549399E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84111161E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.81549399E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84111161E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0343336",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.082817",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04994747",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.177338",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-28.39827",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "29.347855",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.364731",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.91098",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.69992063E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03430228",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.10236",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.23376",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "187.86423",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.46545",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.90134",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.03925",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04448763",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "93.099411",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.5156",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.36499",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.3438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-398.38818",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-74.155762",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1523.1697",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2087.5059",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.1562",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-398.38818",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-80.438232",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.398788",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1404114",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-740.33594",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-69.087646",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.7348633",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.8439741",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8097897",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.9823017",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.98045",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "339.7439",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.95398",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "349.01373",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.11511292E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-697.85327",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.21323886E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.036621",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47721.191",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112367.13",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.05879123E-26",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.03358091E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.62616550E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.32393166E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-414770.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "423370.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "968.65625",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-287.13306",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "66.75415",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0299568",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.25835",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-765.28271",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1166.8555",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1202.771",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "202.85107",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.80954498E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.11134839E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1788.5596",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2158.4092",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-305809.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "648819.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.07812",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-287.13306",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "18.580154",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.20158",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.17816",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.00357",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.30054",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.95398",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "344.68951",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.50909",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.28992",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003027647",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02918842",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.68133",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.50482",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57580362E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80413153E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.57580362E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80413153E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.003027647",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02918842",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88157867E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.91912659E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.88157867E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.91912659E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03199405",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.14072",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05783179",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "38.548615",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.804535",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.36673",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.353882",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.05722",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.35220830E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03727993",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.90305",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.30966",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.75505",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.74811",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.76123",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.95599",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03513751",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "91.403687",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8489.5859",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.80957",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.0625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-381.83521",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-75.76001",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1586.3108",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1879.5808",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.3438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-385.41016",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-79.025879",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-85.592575",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.141098",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.01855",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-67.179443",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7075157",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.1164379",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.7547426",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.510705",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.67168",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.95276",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.55807",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.49976",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.09384689E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-695.44946",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.96279278E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.469482",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47590.801",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112450.81",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.12203018E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.49720961E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.33706305E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-418070.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "432630.25",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "967.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-271.42017",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "69.166092",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0304253",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258503",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-712.54956",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "897.00073",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1328.5859",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "173.69019",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.31264277E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.94535061E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1927.2253",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2027.6997",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-305889.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "632466.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "969.09375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-271.61743",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "15.942596",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.19812",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.56366",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.29791",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.03723",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.55807",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.45795",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.24294",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.58325",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002100222",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02900478",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.492832",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.59253",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55577436E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80047082E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55577436E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.80047082E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002100222",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02900478",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00516638E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06020627E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.00516638E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06020627E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03559218",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.515163",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04686935",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.251595",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.897705",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.813553",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.907013",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.862911",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.93480694E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03553523",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.67877",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "331.48438",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.50984",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.47693",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.55028",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "325.83997",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03757494",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "94.281471",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8512.7617",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-805.56104",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1178.7812",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.84497",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-74.860107",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1745.7927",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1840.6353",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.84497",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-76.711182",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.694305",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1409607",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.89819",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-66.985596",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8073902",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.3442917",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.1868963",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.5243893",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.48228",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.99866",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.31059",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.64819",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.09375287E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-700.5791",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.87651516E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "14.730225",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47755.605",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112057.34",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.00974201E-32",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.87068893E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.42010981E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.18651178E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-404134.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "445543.12",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "971.39062",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-252.37361",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "68.313599",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02998414",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258404",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-728.19238",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1016.8533",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1597.8557",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "188.4126",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.38937763E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.53433085E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1562.6226",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1817.0649",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-293045.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "603591.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "975.46875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-252.37361",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "14.370987",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.24969",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.0979",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.14645",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.20605",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.31059",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.80835",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.28151",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.07208",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006314352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02881729",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.305241",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.61774",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55748858E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77721449E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55748858E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77721449E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006314352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02881729",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.84867201E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.03856985E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.84867201E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.03856985E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02729005",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.424828",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05693302",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "38.365757",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.986008",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "32.162109",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.53183",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.814423",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "6.64944650E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03714996",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.56828",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "340.33936",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.15283",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.20306",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.17712",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "332.17661",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04953362",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "88.979362",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8521.3086",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-802.28174",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.9688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-390.4585",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-79.611084",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1392.5566",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2119.4961",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.4062",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-390.4585",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-78.618896",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.143448",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1406708",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-720.10327",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-68.457031",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.959012",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.5684366",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0431547",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.7422934",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.61478",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "336.84003",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.53331",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.56427",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.48697211E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.18848",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.66841515E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.968506",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47493.246",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112022.55",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.62008369E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.99999204E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-8.18798571E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.22852293E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-424086.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "457581.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "970.4375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-245.03409",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "55.89006",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03045917",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258467",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-827.29102",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1189.5776",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1356.9309",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "211.58838",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.42598627E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.46111732E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1607.3884",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1814.811",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-280654.5",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "649304.75",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "973.6875",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-245.03409",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "19.337769",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.23323",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.06012",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "199.53456",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.48022",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.53331",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.78168",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.54425",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.00623",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004213274",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02831351",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.95261",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.87601",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52596167E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85369663E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.52596167E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85369663E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004213274",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02831351",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89163950E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85780550E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.89163950E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.85780550E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.0234901",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.271976",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03484546",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.976662",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.08754",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.208847",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.531845",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.712509",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.53851317E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03873791",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.10335",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "335.68658",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.86403",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "324.02411",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.88756",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.53583",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04539018",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "91.532455",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8548.1406",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "99999.992",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.57715",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.4688",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-393.53345",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-74.602295",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1536.0251",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1844.3936",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-393.53345",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-78.039307",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-88.897644",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1407166",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-739.54126",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-67.684326",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4808407",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.713933",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6498823",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.3000078",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.02661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.52667",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.95114",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "347.03049",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.49791038E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-694.94873",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.87009708E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "13.727539",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47453.734",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112033.39",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.20581514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.48801824E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.79445647E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.35211678E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-460764.06",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "450423.06",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "985.20312",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-285.59814",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "70.311279",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02941271",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258413",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-736.26733",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "852.85498",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1157.1001",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "204.58301",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.62691958E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.18074852E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-2027.583",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1855.5959",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-291628.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "672458.38",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "985.20312",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-285.59814",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "35.040298",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.96033",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.60168",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "196.36812",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.46152",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.95114",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.84186",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.15593",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.56641",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0091842",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02791023",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.100613",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.5939",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56048245E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82536096E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56048245E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82536096E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.0091842",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02791023",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83224188E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.97030568E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.83224188E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.97030568E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02425292",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.37711",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0455946",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.347752",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.097565",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "30.524918",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-36.296982",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.843918",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.16192325E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.05472569",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.31142",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "334.29669",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "189.13336",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "323.52216",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "189.23824",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.58997",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05684322",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "92.435707",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8485.3516",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-808.01416",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.3438",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.80542",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.409424",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1981.8438",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1825.0061",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.1875",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.80542",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-80.775635",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-87.634842",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1407623",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-721.10156",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-70.007568",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4515305",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "3.9902897",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.7452793",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.6484127",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.70567",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "336.05423",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.54407",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.88696",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.06458754E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-702.47656",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "7.57223461E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "12.891113",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47288.062",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112785.89",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.90454806E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.49382799E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.32957098E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-433193.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "432727.62",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "971.67188",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-259.45581",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "52.270462",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03178613",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258356",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-722.97144",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1568.7869",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1633.4429",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "173.85938",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-6.53168058E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "6.95229119E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1784.3293",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1869.8425",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-286439.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "640078.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "971.67188",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-259.45581",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "28.560547",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.18671",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.11624",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.81717",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.46588",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "187.54407",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "341.06274",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.3676",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.84695",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006113529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03025027",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.774258",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.70752",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54960417E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.83831598E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54960417E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.83831598E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.006113529",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03025027",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86055934E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.88208548E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.86055934E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.88208548E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02211624",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.241371",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.03629822",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.885773",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-30.456558",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.594025",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-35.778091",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.431122",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.16923331E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03624797",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "191.17285",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.26678",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "190.98515",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.01999",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "191.03169",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "326.41998",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05803329",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "93.753548",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8522.1523",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-807.38452",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.3125",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-383.32788",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-75.470947",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1439.5427",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1900.6177",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1180.5312",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-388.52295",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-83.815918",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-84.111435",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1412659",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-719.37817",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-74.352295",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.4140148",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.3846102",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1839552",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.8380384",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.3943",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "337.72229",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.35434",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "346.36804",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "9.68845939E-07",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.39136",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "8.33737431E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.561768",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47013.91",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112265.59",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.06085700E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.85037936E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.29550961E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-389455.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "446842.56",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "967.75",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-263.94775",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "61.221527",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02880409",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258526",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-727.99609",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1097.7737",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1243.9058",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "191.65112",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.97403050E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.66368657E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1606.9116",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1858.7925",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-300943.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "644280.62",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "969.79688",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-263.9624",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "23.245483",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.14424",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.33365",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "197.24629",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "318.68323",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "190.35434",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "342.37698",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.38174",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.25296",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004857957",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02836066",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.474113",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.79004",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56125752E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77266211E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.56125752E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.77266211E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.004857957",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02836066",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.98085945E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.03143645E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.98085945E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.03143645E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02908726",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.947666",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04755842",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.166866",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.151367",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.8815",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-34.315155",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "34.576706",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.53876329E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03873864",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "193.52179",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "333.67267",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "192.89514",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.97305",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "192.93822",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.10129",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.02809351",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "90.860626",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8511.9766",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-803.94336",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.375",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-382.34839",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-75.150635",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1465.0491",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1816.9055",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.0625",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-383.99414",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-74.669678",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-92.952057",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1403809",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-745.7207",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-66.159424",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.1645279",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.3725548",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.2983551",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.4931116",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.03575",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "340.26633",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.00859",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "348.90588",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.21392941E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-699.60938",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.44198735E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "13.757324",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "46381.449",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112080.48",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.32348904E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "8.09297489E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.57871443E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20147877E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-418642.44",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "440718.88",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "973.51562",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-280.32373",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "56.667358",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.02984328",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258442",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-842.69214",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1322.9316",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1380.1045",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "178.2124",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.51865128E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.12616952E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1653.8684",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2285.7693",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-294528.44",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "645405.94",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "976.26562",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-280.55005",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "27.978745",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.17307",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "310.31598",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.38568",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "319.96912",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "185.00859",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "344.77502",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.30727",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "314.25543",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005744804",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02721583",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-21.169962",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.53592",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54776462E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84507062E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.54776462E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.84507062E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.005744804",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02721583",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76663309E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82700148E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.76663309E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.82700148E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02841237",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "38.444649",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05355577",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "39.840843",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.662369",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.758987",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.633957",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.802551",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.14667216E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03896837",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.53578",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.89081",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "186.41461",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "322.48199",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.43358",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "327.67084",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.02532358",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "94.490601",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8518.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-800.41064",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.5625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-386.70728",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-70.321045",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1886.9421",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2272.4089",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.2188",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-386.70728",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-70.289795",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-94.963409",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1410828",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-717.60645",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-59.62207",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.6201897",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.469636",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.0529127",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "6.7050581",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.23595",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "335.58301",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.23483",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "344.35144",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20820539E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-693.55371",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "4.94925189E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "14.594238",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47326.562",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "111988.22",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.18311412E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.48745755E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.20433037E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-434558.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "466504.5",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "974.60938",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-257.68091",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "69.416046",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03175008",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258406",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-766.48315",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1007.5278",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1170.8875",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "187.41064",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.68205144E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.49367643E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1718.4521",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "2110.3171",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-294940.75",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "619016.5",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "974.60938",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-258.38843",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "17.35994",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.84438",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.8707",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "195.25513",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "317.98505",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "180.23483",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.28113",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.03447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.42841",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002214836",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02873542",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.967314",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.539",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55233338E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.89707152E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.55233338E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.89707152E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.002214836",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02873542",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03486275E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.05792321E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-2.03486275E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.05792321E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.03163227",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "33.50391",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0533142",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.128342",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-31.228119",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.169495",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-32.773895",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "36.126022",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "7.18026172E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03848707",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "183.45302",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "331.43832",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "183.26031",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.49591",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "183.27003",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.29791",
                                            "gribparam": "167"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vertically integrated specific humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.04401235",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "90.297485",
                                            "gribparam": "230"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum height of convective cloud tops",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "8517.1836",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "100000.0",
                                            "gribparam": "217"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "164"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (top)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-810.39868",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "1179.625",
                                                "gribparam": "178"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-395.79614",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "-76.883789",
                                                "gribparam": "179"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1642.207",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1696.0862",
                                                    "gribparam": "105"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1181.8438",
                                                    "gribparam": "187"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-396.36523",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "-78.457764",
                                                    "gribparam": "188"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Geopotential",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "58762.242",
                                            "gribparam": "129"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "TSLIN heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-86.556915",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.1409302",
                                            "gribparam": "220"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "longwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-710.77148",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "-67.732178",
                                            "gribparam": "205"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.6794968",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.6229763",
                                            "gribparam": "181"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-4.8057022",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.637249",
                                            "gribparam": "180"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "air temperature (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.09532",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "335.67505",
                                            "gribparam": "169"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.0705",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "345.0163",
                                            "gribparam": "139"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "surface runoff",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.13251474E-06",
                                            "gribparam": "160"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-698.32349",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil wetness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "snow melt",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "5.87882823E-07",
                                            "gribparam": "218"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "15.410889",
                                            "gribparam": "141"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_10",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice depth",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1.5",
                                            "gribparam": "211"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sfc roughness",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "20.00148",
                                            "gribparam": "173"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "sea ice cover",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "210"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Pressure",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "47371.609",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "112206.16",
                                            "gribparam": "134"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Snow Fall",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.88002353E-07",
                                            "gribparam": "144"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Large Scale Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.37592485E-06",
                                            "gribparam": "142"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Convective Precipitation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "1.32734692E-06",
                                            "gribparam": "143"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Primary wave mean period",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-433964.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "443469.94",
                                            "gribparam": "108"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "970.9375",
                                                "gribparam": "176"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "PTVersion": "128",
                                                "subcenter": "255",
                                                "long_name": "longwave flux",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "scale_min": "-281.34253",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "process": "50",
                                                "gribleveltype": "1",
                                                "gribNumBits": "16",
                                                "scale_max": "69.6884",
                                                "gribparam": "177"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "land-sea mask",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "1.0",
                                            "gribparam": "172"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "long_name": "Log Surface Pressure",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.03006823",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "16.258478",
                                            "gribparam": "152"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-740.39038",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "1204.1985",
                                            "gribparam": "146"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1288.1697",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16",
                                            "scale_max": "185.28369",
                                            "gribparam": "147"
                                        },
                                        "FOREST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FOREST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vegetation type",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "FOREST",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.9492188",
                                            "gribparam": "212"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Evaporation",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-5.15103011E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "24",
                                            "scale_max": "7.40913038E-08",
                                            "gribparam": "182"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-1738.7017",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "1873.5415",
                                                    "gribparam": "106"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-287871.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "664006.12",
                                                    "gribparam": "107"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "solar flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "970.9375",
                                                    "gribparam": "185"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "PTVersion": "128",
                                                    "subcenter": "255",
                                                    "long_name": "longwave flux",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "scale_min": "-281.34253",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "process": "50",
                                                    "gribleveltype": "1",
                                                    "gribNumBits": "16",
                                                    "scale_max": "23.353348",
                                                    "gribparam": "186"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Albedo (surface)",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "8",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temp level CL",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "210.4939",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "309.95978",
                                            "gribparam": "183"
                                        },
                                        "TD5": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD5",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "198.72887",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD5",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "317.90533",
                                            "gribparam": "209"
                                        },
                                        "TD3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TD3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "186.0705",
                                            "units": "Kelvin_scale",
                                            "grib_name": "TD3",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "340.69403",
                                            "gribparam": "207"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "deep soil temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "209.60661",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "process": "50",
                                            "gribleveltype": "111",
                                            "gribNumBits": "16",
                                            "scale_max": "313.83972",
                                            "gribparam": "170"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "138"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00288848",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02960173",
                                            "gribparam": "133"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribNumBits": "16"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-20.702139",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "410.47031",
                                            "gribparam": "130"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "vorticity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58565126E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.70962430E-05",
                                            "gribparam": "138"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.58565126E-05",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "1.70962430E-05"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "1",
                                            "gribNumBits": "16"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst oct2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Specific Humidity",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-0.00288848",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "0.02960173",
                                            "gribparam": "133"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Divergence",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99819897E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06636491E-06",
                                            "gribparam": "155"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-1.99819897E-06",
                                            "process": "50",
                                            "gribleveltype": "109",
                                            "gribNumBits": "16",
                                            "scale_max": "2.06636491E-06"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "10m windspeed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "0.02402355",
                                            "grib_name": "wind10",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "37.925102",
                                            "gribparam": "171"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "maximum 10m wind speed",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "0.05047724",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "38.637524",
                                            "gribparam": "216"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "V-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-29.628128",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "31.098572",
                                            "gribparam": "166"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "U-wind at 10",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "-33.269287",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "35.323608",
                                            "gribparam": "165"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Dewpoint at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "1.39907229E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "0.03470604",
                                            "gribparam": "168"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "max 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.81299",
                                            "grib_name": "t2mmx",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "329.94571",
                                            "gribparam": "201"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "min 2m temp",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "units": "unitless",
                                            "scale_min": "188.68121",
                                            "grib_name": "t2mmn",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "321.00891",
                                            "gribparam": "202"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "PTVersion": "128",
                                            "subcenter": "255",
                                            "long_name": "Temperature at 2 m",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "scale_min": "188.73938",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "process": "50",
                                            "gribleveltype": "105",
                                            "gribNumBits": "16",
                                            "scale_max": "328.58444",
                                            "gribparam": "167"
                                        }
                                    }
                                }
                            },
                            "Z_10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "395.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/oct2001"
                        },
                        "sep2001": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sep2001",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SIXHOURLYmem24PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem24griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem24/.griblist.html",
                                "SIXHOURLYmem24filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc24_%6d.01",
                                "SIXHOURLYmem24year0": "200112",
                                "SIXHOURLYmem23PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem23griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem23/.griblist.html",
                                "SIXHOURLYmem23filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc23_%6d.01",
                                "SIXHOURLYmem23year0": "200112",
                                "SIXHOURLYmem22PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem22griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem22/.griblist.html",
                                "SIXHOURLYmem22filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc22_%6d.01",
                                "SIXHOURLYmem22year0": "200112",
                                "SIXHOURLYmem21PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem21griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem21/.griblist.html",
                                "SIXHOURLYmem21filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc21_%6d.01",
                                "SIXHOURLYmem21year0": "200112",
                                "SIXHOURLYmem20PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem20griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem20/.griblist.html",
                                "SIXHOURLYmem20filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc20_%6d.01",
                                "SIXHOURLYmem20year0": "200112",
                                "SIXHOURLYmem19PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem19griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem19/.griblist.html",
                                "SIXHOURLYmem19filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc19_%6d.01",
                                "SIXHOURLYmem19year0": "200112",
                                "SIXHOURLYmem18PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem18griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem18/.griblist.html",
                                "SIXHOURLYmem18filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc18_%6d.01",
                                "SIXHOURLYmem18year0": "200112",
                                "SIXHOURLYmem17PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem17griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem17/.griblist.html",
                                "SIXHOURLYmem17filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc17_%6d.01",
                                "SIXHOURLYmem17year0": "200112",
                                "SIXHOURLYmem16PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem16griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem16/.griblist.html",
                                "SIXHOURLYmem16filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc16_%6d.01",
                                "SIXHOURLYmem16year0": "200112",
                                "SIXHOURLYmem15PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem15griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem15/.griblist.html",
                                "SIXHOURLYmem15filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc15_%6d.01",
                                "SIXHOURLYmem15year0": "200112",
                                "SIXHOURLYmem14PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem14griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem14/.griblist.html",
                                "SIXHOURLYmem14filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc14_%6d.01",
                                "SIXHOURLYmem14year0": "200112",
                                "SIXHOURLYmem13PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem13griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem13/.griblist.html",
                                "SIXHOURLYmem13filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc13_%6d.01",
                                "SIXHOURLYmem13year0": "200112",
                                "SIXHOURLYmem12PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem12griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem12/.griblist.html",
                                "SIXHOURLYmem12filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc12_%6d.01",
                                "SIXHOURLYmem12year0": "200112",
                                "SIXHOURLYmem11PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem11griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem11/.griblist.html",
                                "SIXHOURLYmem11filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc11_%6d.01",
                                "SIXHOURLYmem11year0": "200112",
                                "SIXHOURLYmem10PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem10griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem10/.griblist.html",
                                "SIXHOURLYmem10filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc10_%6d.01",
                                "SIXHOURLYmem10year0": "200112",
                                "SIXHOURLYmem09PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem09griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem09/.griblist.html",
                                "SIXHOURLYmem09filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc09_%6d.01",
                                "SIXHOURLYmem09year0": "200112",
                                "SIXHOURLYmem08PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem08griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem08/.griblist.html",
                                "SIXHOURLYmem08filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc08_%6d.01",
                                "SIXHOURLYmem08year0": "200112",
                                "SIXHOURLYmem07PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem07griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem07/.griblist.html",
                                "SIXHOURLYmem07filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc07_%6d.01",
                                "SIXHOURLYmem07year0": "200112",
                                "SIXHOURLYmem06PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem06griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem06/.griblist.html",
                                "SIXHOURLYmem06filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc06_%6d.01",
                                "SIXHOURLYmem06year0": "200112",
                                "SIXHOURLYmem05PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem05griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem05/.griblist.html",
                                "SIXHOURLYmem05filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc05_%6d.01",
                                "SIXHOURLYmem05year0": "200112",
                                "SIXHOURLYmem04PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem04griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem04/.griblist.html",
                                "SIXHOURLYmem04filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc04_%6d.01",
                                "SIXHOURLYmem04year0": "200112",
                                "SIXHOURLYmem03PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem03griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem03/.griblist.html",
                                "SIXHOURLYmem03filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc03_%6d.01",
                                "SIXHOURLYmem03year0": "200112",
                                "SIXHOURLYmem02PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem02griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem02/.griblist.html",
                                "SIXHOURLYmem02filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc02_%6d.01",
                                "SIXHOURLYmem02year0": "200112",
                                "SIXHOURLYmem01PressureLeveldescription": "gaussian grid at standard Pressure Levels -- below surface values marked as missing",
                                "SIXHOURLYmem01griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.Forecast/.psst/.sep2001/.SIX-HOURLY/.mem01/.griblist.html",
                                "SIXHOURLYmem01filepattern": "/mstore/iri/forecast/data/echam4/psst/sep01/20001fc01_%6d.01",
                                "SIXHOURLYmem01year0": "200112",
                                "Conventions": "IRIDL"
                            },
                            "SIXHOURLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem24": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem24",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04331307",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "91.956276",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8485.6367",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-802.6687",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.9375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-387.22266",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.30127",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1487.843",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1887.0093",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.25",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-387.22266",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.39502",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-87.98349",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007629395",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-741.56226",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.053467",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6343613",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.606163",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.0545397",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7474127",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.74899",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "340.28433",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.70522",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "344.83533",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23765278E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-697.81177",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.05833169E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.330566",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "48008.16",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112297.27",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00763850E-06",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48168499E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.12937729E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47805099E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-424798.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "472380.81",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "968.45312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-256.56201",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "61.340057",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03094702",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-732.73389",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "974.00879",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1437.2717",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "205.12329",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.74724766E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.20201649E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1829.1648",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2051.9143",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-258617.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "607369.5",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.73438",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-256.56201",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "20.815247",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.13048",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.95331",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.29178",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.32257",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006655734",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02852578",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.229973",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68335",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52168232E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80927855E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52168232E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80927855E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem24 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006655734",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02852578",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.84415103E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01851049E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.84415103E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.01851049E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03059001",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "37.078815",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05260183",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.645851",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.160538",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "28.862579",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-36.479218",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.862274",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.01937758E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03660711",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.6855",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.02209",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.3141",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "325.1098",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.32907",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "336.02054",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem23": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem23",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04216444",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "91.912918",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8502.1953",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-799.90308",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-387.9353",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.313477",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1445.6909",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2394.239",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.8125",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-387.9353",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.989746",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-88.552917",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007797241",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-729.13672",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.194336",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.682579",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7887011",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.6212873",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.4488926",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.01447",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.53406",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.08159",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.38812",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27720330E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-696.90552",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7307892",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.43822670E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.566895",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47367.383",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112535.88",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.77499088E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.95142502E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.06325292E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.24924588E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-387335.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "406944.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "980.95312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-252.94928",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "69.903198",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02987128",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258448",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-746.27344",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1548.4207",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2217.2468",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "201.8584",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.86614998E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.07153810E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1726.7681",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2082.9619",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-305520.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "662492.0",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "980.95312",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-256.5249",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.275574",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.41049",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.0849",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.59006",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.974",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005891673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02872263",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.116018",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.76791",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57156828E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82801450E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57156828E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82801450E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem23 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005891673",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02872263",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00674322E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92077368E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.00674322E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.92077368E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02212631",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "39.516331",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04976841",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "41.043995",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-29.667908",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.667725",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-40.969223",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.345367",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "7.35861931E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03736457",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.23048",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.3804",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.08484",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.69415",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.10649",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "333.03284",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem22": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem22",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03940221",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.007843",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8489.1719",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-804.72363",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-384.9646",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.655273",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1510.8228",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2158.281",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.25",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-386.54272",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.232666",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-88.07103",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007965088",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-731.26343",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.604248",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1745205",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4312983",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3594227",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.718255",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.56648",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.09796",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.50064",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.82574",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04992444E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-703.98242",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.03408820E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.424805",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47259.504",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112018.64",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.58457134E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.83672387E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.27540977E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-419435.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "430973.12",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "970.39062",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-252.92062",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "73.897385",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02943996",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258432",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-794.30859",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1118.9688",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1598.7571",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "226.14136",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.39298207E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.04260276E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1904.4919",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2006.8662",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-290361.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "608949.62",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.39062",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254.14824",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "34.823288",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.51285",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.7464",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.59399",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.49097",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005416792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02816162",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.11488",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.88773",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58549337E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81334017E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58549337E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81334017E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem22 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005416792",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02816162",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.88877766E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88245076E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.88877766E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88245076E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03076365",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.310398",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06105046",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.092503",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.397873",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.300217",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.136292",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.048447",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.06119444E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03672759",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.4039",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "334.1644",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.11003",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "324.11249",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.12625",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.32153",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem21": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem21",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04388804",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.094131",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8535.1523",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-801.90918",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-386.0791",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.981689",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1642.3042",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2307.9949",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9688",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-386.0791",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.472412",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-90.939651",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007873535",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-719.45581",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.886963",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7330828",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2628098",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7848082",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3695602",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.35992",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.23462",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.30919",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "344.5582",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21562675E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-700.01025",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.04753417E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.368164",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47398.484",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112051.28",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.47367039E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.79827714E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.23701682E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-443797.75",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "476222.06",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "966.07812",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-262.96924",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "71.393829",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02984257",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258371",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-804.80591",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "865.87012",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1115.4043",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "181.60767",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.46018930E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.26215603E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1534.939",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2210.4128",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254705.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "642597.12",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "972.6875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-263.00317",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.718475",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.87216",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29004",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.04681",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90582",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.002372098",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03077561",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.603239",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.84735",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58434686E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88363520E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58434686E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88363520E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem21 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.002372098",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03077561",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.16365311E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82336703E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.16365311E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82336703E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03909914",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.286373",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06313014",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "34.188263",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-28.378433",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "28.744492",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.310623",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.803177",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "4.62610537E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03788733",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.27049",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.76672",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.23138",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.86465",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.27049",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "328.76953",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem20": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem20",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03643",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.651917",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8478.793",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-803.81592",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.1875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-394.04248",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.167969",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1384.616",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1821.0491",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-394.04248",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.167969",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-84.769958",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007675171",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-719.09155",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.784912",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.478076",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0995817",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2410746",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1907978",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.79189",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.72253",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.58519",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "342.91382",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42821716E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-700.02368",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19348988E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.257812",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47532.699",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111990.3",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.25683378E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.64790083E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31684544E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-401703.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "447928.88",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "965.75",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-244.36691",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "67.093887",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03010138",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258553",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-671.81274",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "971.55078",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1272.5017",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "199.3606",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.08837843E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.97170969E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1788.5105",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1797.8982",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-289736.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "631403.62",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "967.4375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-244.36691",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.147934",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.22966",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.91553",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "208.51408",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.87659",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003035678",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02902868",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.030657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.85803",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52554921E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87756268E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52554921E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87756268E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem20 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003035678",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02902868",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.05718766E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95017219E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.05718766E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.95017219E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03302147",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.545227",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04939521",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "34.862312",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-29.096756",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.107147",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.350281",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.411072",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "6.37585913E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03597314",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.51195",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.09778",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.42523",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.54102",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.44128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "328.68112",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem19": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem19",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04219699",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.941353",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8516.5938",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-799.57642",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5312",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-386.91333",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.689453",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1252.1614",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1676.6074",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3438",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-386.91333",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.667236",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-89.306442",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007614136",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-728.87134",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.843018",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.132494",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.5888023",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.951993",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2644072",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.48657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.40149",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.4868",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.38385",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21820187E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-699.41724",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.70583642E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.582275",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47750.816",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112238.38",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.34757009E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.55589123E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.26490257E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17730951E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-443100.88",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "431507.5",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.17188",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-262.20581",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "70.890305",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03032706",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258411",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-691.03271",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "819.40112",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1320.1775",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "188.60498",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.27902046E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.54198766E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1719.8047",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1946.4084",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-293887.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "638783.25",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.89062",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-262.20581",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "30.554901",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.25114",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.34479",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.36043",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.50693",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005390849",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03046459",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-19.841864",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.95264",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.61291591E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82424810E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.61291591E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.82424810E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem19 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005390849",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03046459",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.75090395E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86679620E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.75090395E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86679620E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02290783",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "38.025963",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05409757",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.8517",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.054123",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.663132",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-37.06456",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.901123",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8.18897661E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04390924",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.2356",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.99597",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.034",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.21472",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "189.15654",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "329.6861",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem18": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem18",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05327725",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.103531",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8489.7617",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-799.75269",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0938",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-384.16504",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.498291",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1455.2234",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2006.9719",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.16504",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-80.844238",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-84.666946",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008026123",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-727.51123",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-69.167236",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.8940086",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8821993",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7239552",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.0520792",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.0006",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.61017",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.99014",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.02942",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.57212764E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-697.13062",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7307892",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.49614332E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.370117",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47773.461",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111947.16",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.93823858E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.66684333E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.93852012E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.10347889E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-424782.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "438943.69",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "966.29688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-249.64218",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "78.039795",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02973013",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258469",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-684.26196",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "934.35889",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1125.0889",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "178.22241",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.49891559E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.12667827E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1684.0811",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2047.1064",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-355499.69",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "612003.75",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.25",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-249.64218",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "40.744965",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.1922",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.38446",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.42528",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.64355",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004013069",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02954319",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.250706",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.73444",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.60750551E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83610719E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.60750551E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83610719E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem18 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004013069",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02954319",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94200015E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98975181E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.94200015E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98975181E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03030156",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.18211",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06916672",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.016495",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-32.111877",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.538803",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.963196",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.51622",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.32595744E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03738553",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "191.1916",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "333.79413",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "191.02606",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.4635",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "191.09758",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "329.62201",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem17": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem17",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03630475",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "96.44104",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8536.6562",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.984",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-803.32642",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-388.53027",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.091797",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1423.5813",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1912.8306",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.1875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-388.53027",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.216553",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-96.768417",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007949829",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-730.21704",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.070068",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9081717",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.0689917",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.8520536",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.7217627",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.1851",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.52023",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.12497",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "342.15045",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.00931481E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-699.8689",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.48172931E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.870605",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47635.984",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112256.12",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.35421758E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.44298065E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14002717E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-463782.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "490841.0",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "966.75",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-251.42044",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "65.322006",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03175079",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258507",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-741.27368",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1354.1333",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1883.6277",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "193.00537",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.53210031E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.71805730E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1877.4788",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2007.0591",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-292984.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "622283.25",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "969.76562",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-251.42044",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "35.788559",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.0423",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.62369",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.31232",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.88159",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003778959",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02759963",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.471813",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.70578",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.51785353E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81828891E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.51785353E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.81828891E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem17 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003778959",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02759963",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.95103712E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02019260E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.95103712E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02019260E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02879457",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.774082",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0544799",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.93084",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.62941",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.265396",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-32.396454",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.377258",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.18799278E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03854727",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.34995",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "337.89093",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.72581",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "325.40918",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "189.01291",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.95605",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem16": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem16",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04547069",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "93.302177",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8535.3711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-803.75317",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-394.55273",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.067627",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1291.2307",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1911.3315",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.3438",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-395.40063",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.498047",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-87.306503",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008010864",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-734.5",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.511719",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9264154",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "3.5537691",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4680014",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.0332956",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.24908",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.40808",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.18907",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.76663",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.97186046E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-697.48462",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.20481398E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.512207",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47588.934",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112648.2",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.79442985E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.87166836E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.06161469E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.26012230E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-426590.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "434651.38",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "970.70312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-245.92894",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "68.277954",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02868003",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258417",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-755.60815",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1065.9563",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1374.2822",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "160.92627",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.49536935E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.43529461E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1619.5125",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1829.8232",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-310160.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "601524.44",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.70312",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-245.92894",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "28.618439",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.91455",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.65515",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.13936",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.68463",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003801976",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03116794",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.167122",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69992",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.60809232E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88406066E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.60809232E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88406066E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem16 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003801976",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03116794",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83953864E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90228877E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.83953864E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90228877E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02655067",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.608509",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04644993",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.507504",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.265732",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.016006",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.860352",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "35.65155",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.09877590E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.06269276",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.12869",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "339.06683",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.87738",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "324.36032",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.93802",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "339.06738",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem15": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem15",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03397455",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.825302",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8522.6992",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-804.26025",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5938",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-386.71265",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.75",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1259.1067",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1797.054",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6562",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.16919",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.210938",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-90.850632",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007385254",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-732.68628",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-63.785156",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.2314825",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "3.8019829",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.4495306",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.5310755",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.35732",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.97473",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.17487",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.95276",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.31300874E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-700.55811",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7319794",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.01185287E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.923096",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47873.68",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112298.98",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.87288445E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.49048992E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34717129E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-391567.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "500450.38",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "975.20312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-255.95274",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "66.790634",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03027176",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258436",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-723.19751",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1208.7102",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1667.5928",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "192.9978",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.66823667E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.71751729E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1648.2122",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2101.4922",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-253170.25",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "654427.75",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "976.84375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-255.95274",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.448334",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.10315",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.85162",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.15587",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.81927",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003952738",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03143527",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.237583",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.53143",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56638744E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73507087E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56638744E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.73507087E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem15 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003952738",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03143527",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.82508927E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80109271E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.82508927E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80109271E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03959651",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "38.122726",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05979041",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.896423",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.021103",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.520523",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.989014",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.000946",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "4.95749823E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04087765",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.64139",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.7522",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.50951",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.89374",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.51411",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "332.11151",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem14": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem14",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04193793",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "98.027283",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8454.8711",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-799.84961",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1177.75",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-386.0105",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-75.176025",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1187.9978",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1915.9355",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.6875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-386.0105",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.609863",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-91.553268",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008544922",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-723.92896",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.482666",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.4341288",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4854889",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5616417",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4089785",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.74825",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.28726",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.73517",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "346.84583",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.25409042E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-701.03931",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16592855E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.384277",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "48056.473",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112268.08",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.10290750E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.91446587E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42268493E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28531110E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-457669.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "441844.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.64062",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-247.20563",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "66.549713",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0322413",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258406",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-781.04443",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1040.7629",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1455.9463",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "225.82446",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.82192172E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.02991815E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1804.4238",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2127.051",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-270523.94",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "632146.81",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.8125",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-247.25676",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.538544",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.2003",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.59366",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.2932",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.42633",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005997401",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0285903",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.5406",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.7731",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58893308E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78252376E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58893308E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78252376E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem14 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005997401",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0285903",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.02298452E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96566634E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.02298452E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.96566634E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02952462",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.974026",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0549784",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.519089",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.563507",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.371979",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-37.166245",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.221939",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.08519998E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03724689",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.80797",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "334.36633",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.43359",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.96866",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.46173",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "331.91962",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem13": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem13",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0370653",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "93.483147",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8515.8633",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "99999.992",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-806.28101",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-389.90967",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-71.422119",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1284.7361",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1797.9209",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5625",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-393.146",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-71.148682",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-92.240402",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008132935",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-715.54272",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-60.77124",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9545078",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4626141",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.812026",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.4002724",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "181.07883",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.89557",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "181.0106",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "342.81326",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.28240004E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-700.90015",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.96936399E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.901367",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47809.863",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112239.42",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.05861028E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.64806793E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45069248E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.34261870E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-421751.69",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "442419.69",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.625",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-259.02368",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "73.443466",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03030397",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258404",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-789.81445",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "843.21484",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1312.458",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "205.75684",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.24815164E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.22752781E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1737.2212",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2108.3369",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-279220.06",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "663619.69",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.78125",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-259.16406",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "44.574326",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.87242",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.63077",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "208.9901",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.32449",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006074332",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02903795",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.206392",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.52692",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52345792E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87510304E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.52345792E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87510304E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem13 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.006074332",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02903795",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.98781663E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13797375E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.98781663E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.13797375E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03016748",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "37.330513",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06806713",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.878201",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.94368",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "27.59659",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-38.653809",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.330734",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "4.24723048E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03797544",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "184.18021",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.95825",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "183.11377",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.63043",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.14806",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "331.13684",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem12": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem12",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03776748",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "91.26815",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8531.2539",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-801.20068",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4688",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-390.39014",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.234375",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1418.3562",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2081.1204",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4375",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-390.39014",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-75.810547",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-88.782196",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007385254",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-737.20801",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.690186",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1893482",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "3.1832533",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4621363",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.6815004",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.69292",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.63287",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.53049",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.89948",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20090760E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-678.85059",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.28280463E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.635742",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "48047.863",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112638.12",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.36580767E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.48997172E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47158812E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.45389068E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22582492E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-444083.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "424092.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "975.04688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-282.97998",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "61.902863",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03095624",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258581",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-714.94019",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1377.7505",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1876.1394",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "196.66846",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.50215634E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.86420173E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1804.3958",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2177.0383",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-306309.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "608723.12",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "981.15625",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-282.97998",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.857971",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.13785",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.2807",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.45547",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.26691",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007027369",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03034777",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-19.983223",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.72372",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55354555E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78811497E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55354555E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.78811497E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem12 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007027369",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03034777",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.15415434E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10761687E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.15415434E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.10761687E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03156503",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.720795",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05646517",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "34.957874",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.066406",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.563583",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.07489",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.547607",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.11524741E-07",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03529675",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.80014",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "337.42297",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.44327",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.84335",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.44327",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "333.09729",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem11": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem11",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04444515",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "94.011429",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8544.7852",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-802.55298",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-386.85571",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.546631",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1326.5706",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1907.2468",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.4375",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-387.67236",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.421631",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-85.455719",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007827759",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-721.88037",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.656738",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.5797396",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1610241",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.4624481",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.3404379",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.36137",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.7735",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.37631",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.44583",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16241119E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-701.00806",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.00341547E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.283447",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47593.91",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112296.41",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.20581571E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.42969383E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.38577013E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.08420222E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.29801720E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-423678.81",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "424321.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "973.04688",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-247.42162",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "75.214294",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03075274",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258419",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-799.97217",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1115.3555",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1358.9419",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "196.16895",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.43402791E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.84422127E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1380.3594",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2219.2957",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-311337.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "667672.88",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.04688",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-248.73309",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.91832",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.54352",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.86533",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.78857",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.28189",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005512062",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02970918",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.11274",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68265",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55962098E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86742673E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.55962098E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.86742673E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem11 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005512062",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02970918",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.89121636E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98813177E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.89121636E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.98813177E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03039053",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "37.582611",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05135004",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.468487",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.536148",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "27.919846",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-37.440033",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "35.766022",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "7.97532493E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03909738",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.9855",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "333.97601",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.85918",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "321.29468",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.86362",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.47263",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem10": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem10",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.02675952",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "89.245697",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8536.5234",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-804.5957",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4062",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-388.29492",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.697998",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1297.46",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2028.2502",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-388.29492",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.697998",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-88.763184",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008773804",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-734.63599",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.74707",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6241245",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.1708727",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.1666508",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.4165211",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.54964",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.51965",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.5305",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.62891",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.45753268E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-702.19019",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.33345291E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.129395",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47952.07",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112270.12",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.02897034E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.84017631E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.35330004E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-426139.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "408144.81",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.20312",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-283.09961",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "58.270401",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03145235",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258387",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-703.15039",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1278.2498",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1327.6826",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "180.12378",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.30903094E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.20264097E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1730.4382",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1800.8264",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-308148.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "628206.88",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.84375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-283.13843",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "27.584854",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.22708",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.17645",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.59683",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.40924",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.01011254",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02842912",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.095324",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.49826",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62785127E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88571230E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62785127E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88571230E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem10 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.01011254",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02842912",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.12765576E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07675635E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.12765576E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.07675635E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03174085",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.767433",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04265293",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.527515",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-29.429749",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.866135",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.061905",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.733826",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "7.77979494E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03687815",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.52367",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.58142",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.44588",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.09677",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.48212",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "329.41852",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem09": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem09",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04647465",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "93.492081",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8536.5078",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-803.24731",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.125",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-384.44849",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-78.608154",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1496.9387",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2217.5715",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.2812",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.44849",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-78.725342",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-89.018509",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007598877",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-733.46777",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.914551",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.4210529",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.3462534",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.4453163",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.1835442",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.46094",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.32343",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.45912",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.58081",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.47623416E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-703.68164",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.86387022E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.473633",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47571.68",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112401.43",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.73161534E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.75875378E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.89049581E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.13151668E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.32123535E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-442102.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "428586.44",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "968.96875",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-254.87474",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "65.626801",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03007397",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258394",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-847.39209",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "959.97998",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1180.5667",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "282.2207",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.72075556E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12849904E-07",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1704.5493",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2658.1777",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-244859.88",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "654637.31",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "968.96875",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-254.87474",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.296646",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.29648",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.56262",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.60892",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.49118",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003067703",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02833105",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.404657",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.73581",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56839233E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84430810E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56839233E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.84430810E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem09 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003067703",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02833105",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.81827863E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02769843E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.81827863E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02769843E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03887829",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.528866",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06184828",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.034504",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.162842",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.66481",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.211884",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.93428",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8.94013397E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0384657",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.93283",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.05164",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.69438",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.8609",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.70233",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "329.23279",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem08": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem08",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0448707",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "96.605049",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8485.7031",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-800.78223",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.0312",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-387.86157",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.004395",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1465.458",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2242.6228",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5938",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.73975",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.098145",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-88.066254",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007965088",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-733.18896",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-65.520996",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7166204",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.1819563",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.0932751",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7724514",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.48999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.88165",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.45445",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.4939",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.11875602E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-705.15063",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7137146",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.51971742E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.848633",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47771.207",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112122.12",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.68290328E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.61317188E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.63691391E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.17596410E-23",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.42656779E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-412619.94",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "430409.25",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "973.21875",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-258.177",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "63.489471",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03138088",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258387",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-761.49707",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1007.6201",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1473.7444",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "176.91528",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.89309082E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.07437096E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1835.551",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2269.6926",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-231977.19",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "628038.88",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "978.07812",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-258.24072",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "29.352432",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.25041",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.99127",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.32033",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.90204",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003824874",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02809509",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.321087",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.64777",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62484575E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87651749E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62484575E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.87651749E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem08 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003824874",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02809509",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03575269E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91940057E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.03575269E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.91940057E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03868401",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "37.588764",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05796998",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.089874",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.922195",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.147491",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-37.669556",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.362976",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "9.21436367E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03991163",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.40335",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "339.20789",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.18405",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "325.81357",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.19055",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.27451",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem07": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem07",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0371078",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "92.190262",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8536.4648",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-802.08179",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-389.0542",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.355225",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1444.9651",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2276.2659",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.875",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.0542",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.355225",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-87.791931",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007781982",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-714.38257",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.093018",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5903711",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "6.5130663",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.3462076",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.3618793",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.93999",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "336.80463",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.94153",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.41446",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20013181E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-701.13159",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.713501",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.27117071E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "16.029297",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47692.449",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112175.72",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "9.02595389E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.74518891E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.17574655E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-378734.0",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "401585.81",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "980.10938",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-259.04248",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "72.270477",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03069654",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258404",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-703.87646",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1375.9622",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1624.5659",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "205.32837",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.49618414E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.21028436E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1878.5317",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2052.3291",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-273034.62",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "632896.75",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "982.17188",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-259.04248",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "39.813705",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.16911",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.07831",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.3765",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.92529",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003798352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02775688",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.103275",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69748",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56955666E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88464273E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.56955666E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88464273E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem07 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003798352",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02775688",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.87926094E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09793302E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.87926094E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.09793302E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.03179173",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.115486",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05168912",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.034813",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-29.953598",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.732376",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-35.70874",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.356476",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "9.08718789E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03761458",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.53864",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "342.56317",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.43683",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.67453",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.47137",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "334.74237",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem06": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem06",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04304668",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "96.822235",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8535.1797",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-807.78491",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.4375",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-384.86011",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-74.896729",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1199.4727",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2149.4993",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.9062",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.86011",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-74.655762",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-90.120728",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007965088",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-733.97461",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.206055",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7972126",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "5.8616867",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.1606903",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "7.6216545",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.63089",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.85376",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.63933",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "345.83936",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.13406384E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-697.44873",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007568359",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7204285",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.71660484E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "13.82251",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47521.582",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112301.45",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.00974201E-32",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.99549582E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.80155428E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.58326734E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.22098857E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-438614.56",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "460161.88",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.85938",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-275.75659",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "71.245544",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03152038",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258413",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-775.99902",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1144.4668",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1285.6145",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "223.88965",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.14081250E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.95301184E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1512.0349",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2070.9985",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-312031.56",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "612905.69",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "970.23438",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-275.75659",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "43.16861",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.91414",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.60434",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.08092",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.27496",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00506869",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02962615",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.273697",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.57043",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57153318E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80299994E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57153318E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.80299994E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem06 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.00506869",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02962615",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85635975E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90072012E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85635975E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90072012E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02738174",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "33.804024",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05552047",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "35.041042",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-30.845078",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "28.548462",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.151169",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "33.034378",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "3.92708515E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03697312",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.6552",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.56915",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.10884",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "323.47687",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.1918",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "336.56976",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem05": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem05",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.02994867",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "95.001457",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8535.9336",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-802.9502",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.5625",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-385.87158",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.848877",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1363.3967",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2184.7004",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.125",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-387.88135",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-73.536377",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-83.177963",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007797241",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-742.55737",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.863281",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.7180033",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.8173141",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.5886326",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.2694893",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.20708",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "339.57928",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.97394",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.65399",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30770150E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-703.44971",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "9.49890818E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "13.005371",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47289.938",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112674.24",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.52930514E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "6.56695534E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.41497060E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.48595677E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-418507.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "428615.19",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "972.98438",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-273.93042",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "75.811035",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02968862",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258408",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-709.979",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1000.6086",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1286.7271",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "222.17163",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.14526164E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.88389309E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1578.2705",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2103.4888",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-307335.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "605695.06",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "973.70312",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-273.93042",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "38.255142",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.16144",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.07721",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.28787",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.69995",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005293936",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.03105163",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-19.874573",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.89188",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.59007523E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90296505E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.59007523E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.90296505E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem05 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005293936",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.03105163",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.91369941E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21710843E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.91369941E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.21710843E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.0290852",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "36.562405",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04894662",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "38.198151",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-32.419083",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.403015",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-37.991638",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.710724",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "6.04379693E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03567424",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.209",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.78906",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "186.5802",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "322.76538",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "186.58994",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.51306",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem04": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem04",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04381614",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "93.284721",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8480.6914",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-801.42603",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.6875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-383.38696",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.117188",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1508.4666",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2136.0891",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.1562",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-383.38696",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.175781",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-86.444458",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008071899",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-729.93652",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.827881",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.9905882",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.201685",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.9946728",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.2600021",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.43723",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "338.79681",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.42111",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "344.51086",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.12848466E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-701.21436",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.02154445E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.724609",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47361.219",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111813.44",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "8.71018926E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.82891620E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20532707E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-400967.62",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "448462.69",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "970.5625",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-248.07834",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "64.722183",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02956281",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258434",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-718.1897",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1063.2686",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1182.3008",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "187.76074",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.72768932E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.50821698E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1891.9297",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2260.428",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-326754.0",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "598863.56",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.89062",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-248.07834",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "31.555008",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.14226",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.29791",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.3611",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.72803",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003336061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0287378",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.289736",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.68161",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.61224161E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75462592E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.61224161E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.75462592E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem04 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.003336061",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0287378",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.77873130E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.29792022E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.77873130E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.29792022E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02857561",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.728176",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.05972537",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.449478",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.047043",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "30.773819",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-33.830734",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "32.771942",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "3.16980469E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.04020736",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "189.22249",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "336.21237",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.71429",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "325.64478",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "189.02316",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "329.35083",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem03": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem03",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.02757525",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "92.593552",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8535.9531",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-805.07178",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1180.2812",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-392.38867",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-73.088379",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1477.4417",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1906.7068",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.5",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-392.38867",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-72.893066",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-90.385666",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007400513",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-736.62598",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-62.217773",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-3.6538925",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.2044811",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.7469578",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "6.8673296",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.20636",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.98468",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "182.02176",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "347.25119",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.21467713E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-698.66797",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.83082976E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "13.641846",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47301.621",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112561.57",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.76465199E-27",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.11187170E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.58404077E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.20011134E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-421437.25",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "459921.5",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "971.48438",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-262.6189",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "82.91745",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.03082948",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258421",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-725.87476",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1143.3086",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1448.2615",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "191.42334",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.79119273E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.65450636E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1585.1519",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1859.0862",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-267380.31",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "643453.94",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "971.48438",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-262.6189",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "32.671356",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.1427",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "310.27365",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.20299",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "314.15314",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004995659",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02909932",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.762323",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.69266",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57442191E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83387074E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.57442191E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.83387074E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem03 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.004995659",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02909932",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85276610E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02565070E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.85276610E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.02565070E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02462243",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.898476",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06086915",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.513371",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.840683",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "29.69191",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-35.200577",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.702438",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "5.58800153E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.0351259",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.58093",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "335.72473",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "185.32648",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "326.31696",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "185.32997",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "331.11633",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem02": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem02",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04648022",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "93.252121",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8489.4219",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-800.24146",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.1875",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-389.78784",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-76.527832",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1519.5259",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2063.0911",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1181.25",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-389.78784",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-76.144043",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-89.317001",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.008453369",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-724.79004",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-64.720215",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.04599",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4183884",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-6.3352833",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "4.9220581",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.93016",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.73419",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "183.96576",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "343.8056",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.68089264E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-693.42188",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7324371",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "1.16316369E-06",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "14.693359",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47934.645",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "112346.98",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-2.52435502E-33",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.43080250E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.67088979E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7.22801456E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.14559316E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-467034.19",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "454017.56",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "974.0",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-260.93018",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "67.057587",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.02972193",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258488",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-704.77783",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1036.2151",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1412.9343",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "189.3208",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.64992945E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.57052021E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1687.7217",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "2022.5203",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-353293.12",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "639012.06",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "974.0",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-260.93018",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "36.484894",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.89163",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.91122",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.12183",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.58414",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005788513",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.02979098",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.416382",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.62808",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58421353E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79433227E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.58421353E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.79433227E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem02 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.005788513",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.02979098",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.93510982E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88912759E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.93510982E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "1.88912759E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.02088281",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "35.125141",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03099272",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "37.071621",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-29.722168",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "28.097488",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.565323",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.131042",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "6.98407234E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03904513",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.30013",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "333.30954",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "187.18816",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "327.08813",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "187.2043",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "330.57642",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                },
                                "mem01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mem01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "QVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vertically integrated specific humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.03783375",
                                            "units": "kg/m2",
                                            "grib_name": "QVI",
                                            "gribleveltype": "1",
                                            "scale_max": "92.802032",
                                            "gribparam": "230",
                                            "subcenter": "255"
                                        },
                                        "CLTOPMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CLTOPMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum height of convective cloud tops",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "8541.7578",
                                            "units": "Pa",
                                            "grib_name": "CLTOPMAX",
                                            "gribleveltype": "1",
                                            "scale_max": "100000.0",
                                            "gribparam": "217",
                                            "subcenter": "255"
                                        },
                                        "cltm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cltm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "cloud cover total mean[0-1]",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "cltm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "164",
                                            "subcenter": "255"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SRAD0U": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRAD0U",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (top)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-801.51636",
                                            "units": "W/m2",
                                            "grib_name": "SRAD0U",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "203",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (top)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rst",
                                                "gribleveltype": "1",
                                                "scale_max": "1179.0312",
                                                "gribparam": "178",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-384.62866",
                                                "units": "Wm-2",
                                                "grib_name": "rlt",
                                                "gribleveltype": "1",
                                                "scale_max": "-77.490723",
                                                "gribparam": "179",
                                                "subcenter": "255"
                                            }
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1492.2117",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0U",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1904.3247",
                                                    "gribparam": "105",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1180.25",
                                                    "gribparam": "187",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-384.64941",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAF0",
                                                    "gribleveltype": "1",
                                                    "scale_max": "-77.533691",
                                                    "gribparam": "188",
                                                    "subcenter": "255"
                                                }
                                            }
                                        }
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "zg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "zg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Geopotential",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-7517.7578",
                                            "units": "m2 s-2",
                                            "grib_name": "zg",
                                            "gribleveltype": "1",
                                            "scale_max": "58762.242",
                                            "gribparam": "129",
                                            "subcenter": "255"
                                        },
                                        "TSLIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSLIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "TSLIN heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-93.164856",
                                            "units": "W/m2",
                                            "grib_name": "TSLIN",
                                            "gribleveltype": "1",
                                            "scale_max": "0.007385254",
                                            "gribparam": "220",
                                            "subcenter": "255"
                                        },
                                        "TRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "longwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-719.84351",
                                            "units": "W/m2",
                                            "grib_name": "TRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "-66.158203",
                                            "gribparam": "205",
                                            "subcenter": "255"
                                        },
                                        "tauv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-4.2044525",
                                            "units": "Nm-2",
                                            "grib_name": "tauv",
                                            "gribleveltype": "1",
                                            "scale_max": "4.4429274",
                                            "gribparam": "181",
                                            "subcenter": "255"
                                        },
                                        "tauu": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauu",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-component of Surface Wind Stress",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.2171717",
                                            "units": "Nm-2",
                                            "grib_name": "tauu",
                                            "gribleveltype": "1",
                                            "scale_max": "5.7086821",
                                            "gribparam": "180",
                                            "subcenter": "255"
                                        },
                                        "tas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "air temperature (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.94879",
                                            "units": "Kelvin_scale",
                                            "grib_name": "tas",
                                            "gribleveltype": "1",
                                            "scale_max": "337.43665",
                                            "gribparam": "169",
                                            "subcenter": "255"
                                        },
                                        "stemp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stemp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "184.91077",
                                            "units": "unitless",
                                            "grib_name": "stemp",
                                            "gribleveltype": "1",
                                            "scale_max": "342.44617",
                                            "gribparam": "139",
                                            "subcenter": "255"
                                        },
                                        "srun": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "srun",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "surface runoff",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "srun",
                                            "gribleveltype": "1",
                                            "scale_max": "1.30786179E-06",
                                            "gribparam": "160",
                                            "subcenter": "255"
                                        },
                                        "SRADSU": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SRADSU",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "shortwave radiation upward (surface)",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-699.81592",
                                            "units": "W/m2",
                                            "grib_name": "SRADSU",
                                            "gribleveltype": "1",
                                            "scale_max": "0.0078125",
                                            "gribparam": "204",
                                            "subcenter": "255"
                                        },
                                        "soilm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "soilm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil wetness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "soilm",
                                            "gribleveltype": "1",
                                            "scale_max": "0.7168884",
                                            "gribparam": "140",
                                            "subcenter": "255"
                                        },
                                        "SNMEL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNMEL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "snow melt",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "SNMEL",
                                            "gribleveltype": "1",
                                            "scale_max": "8.78528226E-07",
                                            "gribparam": "218",
                                            "subcenter": "255"
                                        },
                                        "snd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "snd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "snd",
                                            "gribleveltype": "1",
                                            "scale_max": "15.405029",
                                            "gribparam": "141",
                                            "subcenter": "255"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "151",
                                            "long_name": "mean sea level pressure",
                                            "gribleveltype": "102",
                                            "Z": "Z_08",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "SICED": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SICED",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice depth",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m",
                                            "grib_name": "SICED",
                                            "gribleveltype": "1",
                                            "scale_max": "1.5",
                                            "gribparam": "211",
                                            "subcenter": "255"
                                        },
                                        "sfr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sfr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sfc roughness",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "1.49999996E-05",
                                            "units": "m",
                                            "grib_name": "sfr",
                                            "gribleveltype": "1",
                                            "scale_max": "20.00148",
                                            "gribparam": "173",
                                            "subcenter": "255"
                                        },
                                        "SEAICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SEAICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "sea ice cover",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "unitless",
                                            "grib_name": "SEAICE",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "210",
                                            "subcenter": "255"
                                        },
                                        "pss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "47894.957",
                                            "units": "Pa",
                                            "grib_name": "pss",
                                            "gribleveltype": "1",
                                            "scale_max": "111930.44",
                                            "gribparam": "134",
                                            "subcenter": "255"
                                        },
                                        "prs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Snow Fall",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-8.82326093E-28",
                                            "units": "unitless",
                                            "grib_name": "prs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.47801266E-07",
                                            "gribparam": "144",
                                            "subcenter": "255"
                                        },
                                        "prl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Large Scale Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "m/s",
                                            "grib_name": "prl",
                                            "gribleveltype": "1",
                                            "scale_max": "1.46125240E-06",
                                            "gribparam": "142",
                                            "subcenter": "255"
                                        },
                                        "prcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "260",
                                            "long_name": "Total Precipitation",
                                            "grib_name": "totprcp",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "prc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Convective Precipitation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-9.03501880E-24",
                                            "units": "m/s",
                                            "grib_name": "prc",
                                            "gribleveltype": "1",
                                            "scale_max": "1.19430001E-06",
                                            "gribparam": "143",
                                            "subcenter": "255"
                                        },
                                        "PERPW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PERPW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Primary wave mean period",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-426392.5",
                                            "units": "s",
                                            "grib_name": "PERPW",
                                            "gribleveltype": "1",
                                            "scale_max": "428427.5",
                                            "gribparam": "108",
                                            "subcenter": "255"
                                        },
                                        "net": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "net",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "swflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "swflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "Net Shortwave Radiation (surface)",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "0.0",
                                                "units": "Wm-2",
                                                "grib_name": "rss",
                                                "gribleveltype": "1",
                                                "scale_max": "969.8125",
                                                "gribparam": "176",
                                                "subcenter": "255"
                                            },
                                            "lwflx": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lwflx",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                "process": "50",
                                                "long_name": "longwave flux",
                                                "gribNumBits": "16",
                                                "calendar": "standard",
                                                "PDS_TimeRange": "10",
                                                "PTVersion": "128",
                                                "scale_min": "-271.31665",
                                                "units": "Wm-2",
                                                "grib_name": "rls",
                                                "gribleveltype": "1",
                                                "scale_max": "61.07431",
                                                "gribparam": "177",
                                                "subcenter": "255"
                                            }
                                        },
                                        "lsm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lsm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "land-sea mask",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.0",
                                            "units": "(0,1)",
                                            "grib_name": "lsm",
                                            "gribleveltype": "1",
                                            "scale_max": "1.0",
                                            "gribparam": "172",
                                            "subcenter": "255"
                                        },
                                        "logpsl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "logpsl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Log Surface Pressure",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.0308093",
                                            "units": "unitless",
                                            "grib_name": "logpsl",
                                            "gribleveltype": "1",
                                            "scale_max": "16.258501",
                                            "gribparam": "152",
                                            "subcenter": "255"
                                        },
                                        "hfss": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfss",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Sensible Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-693.68311",
                                            "units": "Wm-2",
                                            "grib_name": "hfss",
                                            "gribleveltype": "1",
                                            "scale_max": "1274.4636",
                                            "gribparam": "146",
                                            "subcenter": "255"
                                        },
                                        "hfls": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hfls",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Surface Flux of Latent Heat",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1344.0342",
                                            "units": "Wm-2",
                                            "grib_name": "hfls",
                                            "gribleveltype": "1",
                                            "scale_max": "184.49829",
                                            "gribparam": "147",
                                            "subcenter": "255"
                                        },
                                        "evs": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evs",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Evaporation",
                                            "gribNumBits": "24",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-5.37441622E-07",
                                            "units": "m (H2O)",
                                            "grib_name": "evs",
                                            "gribleveltype": "1",
                                            "scale_max": "7.37780113E-08",
                                            "gribparam": "182",
                                            "subcenter": "255"
                                        },
                                        "dpsdy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "274",
                                            "long_name": "Meridional Deriv. of Surface Pres.",
                                            "grib_name": "dpsdy",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "dpsdx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "dpsdx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "273",
                                            "long_name": "Zonal Deriv. of Surface Pres.",
                                            "grib_name": "dpsdx",
                                            "units": "kilogram meter-2 second-2",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "clear_sky": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "clear_sky",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "upward": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "upward",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-1868.803",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "1964.2161",
                                                    "gribparam": "106",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-290316.81",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFSU",
                                                    "gribleveltype": "1",
                                                    "scale_max": "624605.56",
                                                    "gribparam": "107",
                                                    "subcenter": "255"
                                                }
                                            },
                                            "net": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "net",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "solar flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "0.0",
                                                    "units": "W/m2",
                                                    "grib_name": "SRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "975.9375",
                                                    "gribparam": "185",
                                                    "subcenter": "255"
                                                },
                                                "lwflx": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "lwflx",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                                    "process": "50",
                                                    "long_name": "longwave flux",
                                                    "gribNumBits": "16",
                                                    "calendar": "standard",
                                                    "PDS_TimeRange": "10",
                                                    "PTVersion": "128",
                                                    "scale_min": "-271.35181",
                                                    "units": "W/m2",
                                                    "grib_name": "TRAFS",
                                                    "gribleveltype": "1",
                                                    "scale_max": "23.915634",
                                                    "gribparam": "186",
                                                    "subcenter": "255"
                                                }
                                            }
                                        },
                                        "ALBEDO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBEDO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Albedo (surface)",
                                            "gribNumBits": "8",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.06999999",
                                            "units": "unitless",
                                            "grib_name": "ALBEDO",
                                            "gribleveltype": "1",
                                            "scale_max": "0.8004687",
                                            "gribparam": "175",
                                            "subcenter": "255"
                                        }
                                    },
                                    "soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TDCL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TDCL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "soil temp level CL",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "210.53656",
                                            "units": "m (H2O)",
                                            "grib_name": "TDCL",
                                            "gribleveltype": "111",
                                            "scale_max": "309.93329",
                                            "gribparam": "183",
                                            "subcenter": "255"
                                        },
                                        "td": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "deep soil temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "209.79451",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td",
                                            "gribleveltype": "111",
                                            "scale_max": "313.55344",
                                            "gribparam": "170",
                                            "subcenter": "255"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007935233",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "scale_max": "0.0302815",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribleveltype": "100",
                                            "history": "toS: regridded Z to IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev P",
                                            "missing_value": "NaN",
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "subcenter": "255"
                                        }
                                    },
                                    "hybrid_lev": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybrid_lev",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "132",
                                            "long_name": "meridional velocity",
                                            "grib_name": "va",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "131",
                                            "long_name": "zonal velocity",
                                            "grib_name": "ua",
                                            "units": "m/s",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "ta": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ta",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-20.036913",
                                            "units": "Kelvin_scale",
                                            "grib_name": "ta",
                                            "gribleveltype": "109",
                                            "scale_max": "410.39676",
                                            "gribparam": "130",
                                            "subcenter": "255"
                                        },
                                        "rvort": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rvort",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "vorticity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62926281E-05",
                                            "units": "s-1",
                                            "grib_name": "rvort",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74410143E-05",
                                            "gribparam": "138",
                                            "subcenter": "255"
                                        },
                                        "Rv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for moist air"
                                        },
                                        "Rd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Rd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "J/kg/K",
                                            "long_name": "gas constant for dry air"
                                        },
                                        "psi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "psi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "148",
                                            "long_name": "streamfunction",
                                            "grib_name": "strm",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.62926281E-05",
                                            "gribleveltype": "109",
                                            "scale_max": "1.74410143E-05",
                                            "subcenter": "255"
                                        },
                                        "phi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "phi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "156",
                                            "long_name": "geopotential height",
                                            "grib_name": "zg",
                                            "units": "m",
                                            "fnname": "max",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "pressure",
                                            "units": "Pa",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "1",
                                            "subcenter": "255"
                                        },
                                        "omega": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omega",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "135",
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "history": "Z regridded on IRI FD ECHAM4p5 Forecast psst sep2001 SIX-HOURLY mem01 hybrid_lev omegahalf",
                                            "grib_name": "ua",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "gribleveltype": "109",
                                            "subcenter": "255"
                                        },
                                        "hus": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hus",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Specific Humidity",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-0.007935233",
                                            "units": "unitless",
                                            "grib_name": "hus",
                                            "gribleveltype": "109",
                                            "scale_max": "0.0302815",
                                            "gribparam": "133",
                                            "subcenter": "255"
                                        },
                                        "gravity": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gravity",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m/s2",
                                            "long_name": "earth\\'s gravity"
                                        },
                                        "Div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Divergence",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.99463489E-06",
                                            "units": "s-1",
                                            "grib_name": "Div",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03325544E-06",
                                            "gribparam": "155",
                                            "subcenter": "255"
                                        },
                                        "chi": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "chi",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "gribparam": "149",
                                            "long_name": "velocity potential",
                                            "grib_name": "vpot",
                                            "units": "meter2 second-1",
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-1.99463489E-06",
                                            "gribleveltype": "109",
                                            "scale_max": "2.03325544E-06",
                                            "subcenter": "255"
                                        },
                                        "BC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless"
                                        },
                                        "AC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "AC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "10m windspeed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "0.0198893",
                                            "grib_name": "wind10",
                                            "gribleveltype": "105",
                                            "scale_max": "34.902489",
                                            "gribparam": "171",
                                            "subcenter": "255"
                                        },
                                        "WIMAX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIMAX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "maximum 10m wind speed",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "0.04501817",
                                            "units": "m/s",
                                            "grib_name": "WIMAX",
                                            "gribleveltype": "105",
                                            "scale_max": "36.02454",
                                            "gribparam": "216",
                                            "subcenter": "255"
                                        },
                                        "vas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "V-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-31.062195",
                                            "units": "m/s",
                                            "grib_name": "vas",
                                            "gribleveltype": "105",
                                            "scale_max": "31.769257",
                                            "gribparam": "166",
                                            "subcenter": "255"
                                        },
                                        "uas": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uas",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "U-wind at 10",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "-34.758377",
                                            "units": "m/s",
                                            "grib_name": "uas",
                                            "gribleveltype": "105",
                                            "scale_max": "34.453491",
                                            "gribparam": "165",
                                            "subcenter": "255"
                                        },
                                        "td2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "td2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Dewpoint at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "7.11302164E-08",
                                            "units": "Kelvin_scale",
                                            "grib_name": "td2m",
                                            "gribleveltype": "105",
                                            "scale_max": "0.03353035",
                                            "gribparam": "168",
                                            "subcenter": "255"
                                        },
                                        "t2mmx": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmx",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "max 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.52625",
                                            "grib_name": "t2mmx",
                                            "gribleveltype": "105",
                                            "scale_max": "334.81689",
                                            "gribparam": "201",
                                            "subcenter": "255"
                                        },
                                        "t2mmn": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmn",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "min 2m temp",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "units": "unitless",
                                            "scale_min": "188.13959",
                                            "grib_name": "t2mmn",
                                            "gribleveltype": "105",
                                            "scale_max": "321.203",
                                            "gribparam": "202",
                                            "subcenter": "255"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "center": "European Center for Medium-Range Weather Forecasts - Reading",
                                            "process": "50",
                                            "long_name": "Temperature at 2 m",
                                            "gribNumBits": "16",
                                            "calendar": "standard",
                                            "PDS_TimeRange": "10",
                                            "PTVersion": "128",
                                            "scale_min": "188.2412",
                                            "units": "Kelvin_scale",
                                            "grib_name": "t2m",
                                            "gribleveltype": "105",
                                            "scale_max": "332.5368",
                                            "gribparam": "167",
                                            "subcenter": "255"
                                        }
                                    }
                                }
                            },
                            "Z_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "Z_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "Z_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "cm_down",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Depth"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "sp_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "C": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "C",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "ids",
                                "gridtype": "2",
                                "long_name": "complex"
                            },
                            "Z_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "Z_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Height"
                            },
                            "sp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "Z_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "0.0"
                            },
                            "Z_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Z": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Z",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m_above_gnd",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Height"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2001-01-01 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0.25",
                                "calendar": "standard",
                                "defaultvalue": "364.75"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "modulus": "360.0"
                            },
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/psst/sep2001"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "SIXHOURLY",
                            "apr2002",
                            "aug2001",
                            "dec2001",
                            "ensemble",
                            "ensemble12",
                            "ensemble12_mean",
                            "ensemble1324_mean",
                            "ensemble24",
                            "ensemble24_mean",
                            "feb2002",
                            "jan2002",
                            "jul2001",
                            "jun2001",
                            "mar2002",
                            "nov2001",
                            "oct2001",
                            "sep2001"
                        ]
                    },
                    "ssst": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ssst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ssst",
                        "restriction": "Public",
                        "ensemble": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ssst/ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ensemble",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ssst/ensemble/MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "MONTHLY",
                                "restriction": "Public",
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "SIXHOURLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/FD/ECHAM4p5/Forecast/ssst/ensemble/SIX-HOURLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "SIX-HOURLY",
                                "restriction": "requires dlauth tokens"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY",
                                "SIXHOURLY"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "ensemble"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "ECMWFSST",
                        "asst",
                        "ca_sst",
                        "psst",
                        "ssst"
                    ]
                },
                "History": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/ECHAM4p5/History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "History",
                    "restriction": "Public",
                    "DAILY": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/DAILY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "DAILY",
                        "restriction": "requires dlauth tokens"
                    },
                    "MONTHLY": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "MONTHLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "topnetexpires": "1492214400",
                            "topexpires": "1492214400",
                            "surfacenetexpires": "1492214400",
                            "surfaceexpires": "1492214400",
                            "PressureLevelSFlong_name": "Pressure Level: Smoothed and Filled",
                            "PressureLevelSFexpires": "1492214400",
                            "above_groundexpires": "1492214400",
                            "griblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.History/.MONTHLY/.griblist.html",
                            "note": "Jul-Sep 2007 reread 20080623 to correct winds",
                            "expires": "1492214400",
                            "Conventions": "IRIDL"
                        },
                        "top": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "top",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "net": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "net",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "swflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "swflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "178",
                                    "long_name": "net shortwave at top",
                                    "units": "W/m2",
                                    "expires": "1492214400"
                                }
                            }
                        },
                        "surface": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "surface",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "129",
                                "long_name": "surface geopotential",
                                "units": "unitless",
                                "expires": "1492214400"
                            },
                            "tcld": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tcld",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "164",
                                "long_name": "total cloud cover",
                                "units": "unitless",
                                "expires": "1492214400"
                            },
                            "tauy": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tauy",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "181",
                                "long_name": "surface meridional wind stress",
                                "units": "Pa",
                                "expires": "1492214400"
                            },
                            "taux": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "taux",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "180",
                                "long_name": "surface zonal wind stress",
                                "units": "Pa",
                                "expires": "1492214400"
                            },
                            "stemp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "stemp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "169",
                                "long_name": "surface Temperature",
                                "units": "Kelvin_scale",
                                "expires": "1492214400"
                            },
                            "slp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "slp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "151",
                                "long_name": "sea level pressure",
                                "units": "Pa",
                                "expires": "1492214400"
                            },
                            "prl": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prl",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "142",
                                "long_name": "large scale precipitation",
                                "units": "m/s",
                                "expires": "1492214400"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Total Precipitation",
                                "units": "m/s",
                                "expires": "1492214400",
                                "gribparam": "143"
                            },
                            "prc": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prc",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "143",
                                "long_name": "convective precipitation",
                                "units": "m/s",
                                "expires": "1492214400"
                            },
                            "olr": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "olr",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "179",
                                "long_name": "outgoing longwave radiation",
                                "units": "W/m2",
                                "expires": "1492214400"
                            },
                            "net": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "net",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "swflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "swflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "176",
                                    "long_name": "net shortwave at ground",
                                    "units": "W/m2",
                                    "expires": "1492214400"
                                },
                                "lwflx": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lwflx",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "177",
                                    "long_name": "net longwave at ground",
                                    "units": "W/m2",
                                    "expires": "1492214400"
                                }
                            },
                            "hfss": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfss",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "146",
                                "long_name": "surface sensible heat flux",
                                "units": "W/m2",
                                "expires": "1492214400"
                            },
                            "hfls": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hfls",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "147",
                                "long_name": "surface latent heat flux",
                                "units": "W/m2",
                                "expires": "1492214400"
                            },
                            "evs": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "evs",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "182",
                                "long_name": "evaporation",
                                "units": "m/s",
                                "expires": "1492214400"
                            }
                        },
                        "PressureLevelSF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "PressureLevel-SF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "va": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "va",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "132",
                                "long_name": "meridional velocity",
                                "units": "m/s",
                                "expires": "1492214400"
                            },
                            "ua": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ua",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "131",
                                "long_name": "zonal velocity",
                                "units": "m/s",
                                "expires": "1492214400"
                            },
                            "ta": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ta",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "130",
                                "long_name": "temperature",
                                "units": "Kelvin_scale",
                                "expires": "1492214400"
                            },
                            "phi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "phi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "156",
                                "long_name": "geopotential height",
                                "units": "gpm",
                                "expires": "1492214400"
                            },
                            "omega": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "omega",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "135",
                                "long_name": "vertical pressure velocity",
                                "units": "Pa/s",
                                "expires": "1492214400"
                            },
                            "hus": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hus",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "133",
                                "long_name": "specific humidity",
                                "units": "unitless",
                                "scale_min": "0.0",
                                "expires": "1492214400"
                            }
                        },
                        "above_ground": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "above_ground",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "gribparam": "167",
                                "long_name": "temperature at 2m",
                                "units": "Kelvin_scale",
                                "expires": "1492214400"
                            }
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "bounds": "Z"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "expires": "1492214400",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "member"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.8125",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/MONTHLY"
                    },
                    "SIXHOURLY": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/SIX-HOURLY",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "SIX-HOURLY",
                        "restriction": "requires dlauth tokens"
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "c7100long_name": "1971-2000",
                            "c7100iridlhasSemantics": "iridl:climatology",
                            "c6998long_name": "1969-1998",
                            "c6998iridlhasSemantics": "iridl:climatology",
                            "Conventions": "IRIDL"
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "gribparam": "156",
                                "long_name": "geopotential height",
                                "units": "m",
                                "expires": "1492214400"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "P_01": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P_01",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0",
                            "bounds": "Z"
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "2",
                            "pointwidth": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "1",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time",
                            "modulo": "12.0",
                            "modulus": "12.0"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.8125",
                            "standard_name": "longitude"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/climatology"
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "member"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.8125",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/ensemble"
                    },
                    "ensemble24": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/ensemble24",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "ensemble24",
                        "restriction": "requires dlauth tokens"
                    },
                    "ensemble85": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble85",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLYPressureLevelSFlong_name": "Pressure Level: Smoothed and Filled",
                            "MONTHLYgriblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM4p5/.History/.ensemble85/.MONTHLY/.griblist.html",
                            "MONTHLYnote": "When using the data, please include the acknowledgement: The computing for this project was provided (or partially provided) by a grant from the NCAR CSL program to the IRI",
                            "iridlhasSemantics": "iridl:Goddard_L",
                            "Conventions": "IRIDL",
                            "note": "When using the data, please include the acknowledgement: The computing for this project was provided (or partially provided) by a grant from the NCAR CSL program to the IRI"
                        },
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "top": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "top",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "178",
                                        "long_name": "net shortwave at top",
                                        "units": "W/m2"
                                    }
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "tauy": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tauy",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "181",
                                    "long_name": "surface meridional wind stress",
                                    "units": "Newton/m2"
                                },
                                "taux": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "taux",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "180",
                                    "long_name": "surface zonal wind stress",
                                    "units": "Newton/m2"
                                },
                                "stemp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "stemp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "169",
                                    "long_name": "surface Temperature",
                                    "units": "Kelvin_scale"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "151",
                                    "long_name": "sea level pressure",
                                    "units": "Pa"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Total Precipitation",
                                    "units": "m/s"
                                },
                                "olr": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "olr",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "179",
                                    "long_name": "outgoing longwave radiation",
                                    "units": "W/m2"
                                },
                                "net": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "net",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "swflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "swflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "176",
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2"
                                    },
                                    "lwflx": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lwflx",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "gribparam": "177",
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2"
                                    }
                                },
                                "hfss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "146",
                                    "long_name": "surface sensible heat flux",
                                    "units": "W/m2"
                                },
                                "hfls": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hfls",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "147",
                                    "long_name": "surface latent heat flux",
                                    "units": "W/m2"
                                },
                                "evs": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "evs",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "182",
                                    "long_name": "evaporation",
                                    "units": "m/s"
                                },
                                "cld": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "cld",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "164",
                                    "long_name": "total cloud cover"
                                }
                            },
                            "PressureLevelSF": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel-SF",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "va": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "va",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "132",
                                    "long_name": "meridional velocity",
                                    "units": "m/s"
                                },
                                "ua": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ua",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "131",
                                    "long_name": "zonal velocity",
                                    "units": "m/s"
                                },
                                "ta": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ta",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "130",
                                    "long_name": "temperature",
                                    "units": "Kelvin_scale"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "156",
                                    "long_name": "geopotential height",
                                    "units": "gpm"
                                },
                                "omega": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "omega",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "135",
                                    "long_name": "vertical pressure velocity",
                                    "units": "Pa/s"
                                },
                                "hus": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hus",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_min": "0.0",
                                    "long_name": "specific humidity",
                                    "units": "kg/kg",
                                    "gribparam": "133"
                                }
                            },
                            "above_ground": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "above_ground",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "gribparam": "167",
                                    "long_name": "temperature at 2m",
                                    "units": "Kelvin_scale"
                                }
                            }
                        },
                        "P": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "P",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mb",
                            "gridtype": "0"
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "M": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "M",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "ids",
                            "gridtype": "0",
                            "pointwidth": "1.0",
                            "long_name": "member"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.8125",
                            "standard_name": "longitude"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/ensemble85"
                    },
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "NC_GLOBAL": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "NC_GLOBAL",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "Conventions": "IRIDL"
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "months since 1960-01-01",
                            "gridtype": "0",
                            "calendar": "360",
                            "pointwidth": "1.0",
                            "standard_name": "time"
                        },
                        "X": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "X",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_east",
                            "gridtype": "1",
                            "pointwidth": "2.8125",
                            "standard_name": "longitude"
                        },
                        "Y": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Y",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "degree_north",
                            "gridtype": "0"
                        },
                        "dir": "SOURCES/IRI/FD/ECHAM4p5/History/ensemble_mean"
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "DAILY",
                        "MONTHLY",
                        "SIXHOURLY",
                        "climatology",
                        "ensemble",
                        "ensemble24",
                        "ensemble85",
                        "ensemble_mean"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "Forecast",
                    "History"
                ]
            },
            "ECHAM5": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ECHAM5",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "T85HistoryensembleMONTHLYhistory": "CSL ECHAM5 run output",
                    "T85HistoryensembleMONTHLYiridlhasSemantics": "iriref:DeWitt_DG",
                    "T42Historyensemble24MONTHLYtotal_air_columniridlhasSemantics": "iridl:Atmosphere",
                    "T42Historyensemble24MONTHLYtopiridlhasSemantics": "iridl:Atmosphere",
                    "T42Historyensemble24MONTHLYPressureLeveliridlhasSemantics": "iridl:Atmosphere",
                    "T42Historyensemble24MONTHLYabove_groundiridlhasSemantics": "iridl:Atmosphere",
                    "T42Historyensemble24MONTHLYiridlhasSemantics": "iridl:monthly",
                    "T42Forecastca_sstensemble24MONTHLYtotal_air_columniridlhasSemantics": "iridl:Atmosphere",
                    "T42Forecastca_sstensemble24MONTHLYtopiridlhasSemantics": "iridl:Atmosphere",
                    "T42Forecastca_sstensemble24MONTHLYPressureLeveliridlhasSemantics": "iridl:Atmosphere",
                    "T42Forecastca_sstensemble24MONTHLYabove_groundiridlhasSemantics": "iridl:Atmosphere",
                    "T42Forecastca_sstensemble24MONTHLYnote": "When using the data, please include the acknowledgement: The computing for this project was provided (or partially provided) by a grant from the NCAR CSL program to the IRI",
                    "T42Forecastca_sstensemble24MONTHLYreferences": "Roeckner_etal2006 vandenDool1994 vandenDool2007",
                    "T42Forecastca_sstensemble24MONTHLYiridlhasSemantics": "iridl:monthly",
                    "references": "Roeckner_etal2006",
                    "Roeckner_etal2006": "http://ams.allenpress.com/perlserv/?request=get-abstract&doi=10.1175%2FJCLI3824.1",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECHAM5/.dataset_documentation.html",
                    "iridlhasSemantics": "iridl:ECHAM5",
                    "Conventions": "IRIDL"
                },
                "T85": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T85",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2/s2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radation",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "1/s",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2/s",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "meters/second",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "meters/second",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "units": "m2/s",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "1/s",
                                        "cNZ": "17"
                                    }
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    }
                                }
                            }
                        }
                    }
                },
                "T42": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T42",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble24": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble24",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    }
                                },
                                "top": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "top",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2/s2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radation",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W/m2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg/m2/s",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "1/s",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2/s",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "meters/second",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "meters/second",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "units": "m2/s",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "unitless",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "1/s",
                                        "cNZ": "17"
                                    }
                                },
                                "above_ground": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "above_ground",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    }
                                }
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ca_sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ca_sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble24": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble24",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "MONTHLY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "total_air_column": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "total_air_column",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cwat": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cwat",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertically integrated cloud water",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        }
                                    },
                                    "top": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "top",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "nswt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "nswt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "net shortwave at top",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        }
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Forecast Time",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "calendar": "360",
                                        "pointwidth": "1.0"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "uswg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "uswg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "upward short wave at ground",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "ulwg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ulwg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "upward long wave at ground",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "tauy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tauy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional wind stress",
                                            "units": "Pa",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "taux": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "taux",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal wind stress",
                                            "units": "Pa",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sw": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sw",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil wetness",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "stl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface temperature of land",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "st": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "st",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface temperature",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "src": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "src",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "skin reservoir content",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sni": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sni",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "water equivalent snow depth",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "slp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mean sea level pressure",
                                            "units": "Pa",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "slm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "slm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land sea mask",
                                            "units": "unitless",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sice": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sice",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sea ice fraction",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat flux",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sf": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sf",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snowfall",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "sd": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sd",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow depth",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "runoff": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "runoff",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface runoff",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "pwat": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "pwat",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "precipitable water",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "precl": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precl",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "large scale precipitation",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "precc": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "precc",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "convective precipitation",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "prec": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "prec",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "total precipitation",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "oro": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "oro",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "orography",
                                            "units": "m2/s2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "olr": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "olr",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "outgoing longwave radation",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "nswg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "nswg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "net shortwave at ground",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "nlwg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "nlwg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "net longwave at ground",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "lh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "lh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "latent heat flux",
                                            "units": "W/m2",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "icedep": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "icedep",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sea ice depth",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "glac": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "glac",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "glacier depth",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "evap": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "evap",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "evaporation",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "drain": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "drain",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "drainage",
                                            "units": "kg/m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "cld": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cld",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud cover",
                                            "units": "unitless",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "alb": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "alb",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "albedo",
                                            "units": "unitless",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        }
                                    },
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "vrt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vrt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vorticity",
                                            "units": "1/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "velpot": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "velpot",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "velocity potential",
                                            "units": "m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "units": "m/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "units": "m/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "tmp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tmp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "temperature",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "stream": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stream",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "stream function",
                                            "units": "m2/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "rh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "rh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "relative humidity",
                                            "units": "unitless",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "q": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "q",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "specific humidity",
                                            "units": "kg/kg",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "omg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "omg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical pressure velocity",
                                            "units": "Pa/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "gz": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gz",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "units": "m",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "div": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "div",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "divergence",
                                            "units": "1/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        }
                                    },
                                    "above_ground": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "above_ground",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "wind10": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "wind10",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "wind speed at 10 meters",
                                            "units": "",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "v10m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v10m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional wind at 10 meters",
                                            "units": "m/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "u10m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u10m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal wind at 10 meters",
                                            "units": "m/s",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "t2mmin": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmin",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "two meter minimum temperature",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "t2mmax": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2mmax",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "two meter maximum temperature",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "t2md": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2md",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "dew point temperature at 2 meters",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        },
                                        "t2m": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "t2m",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "temperature at 2 meters",
                                            "units": "Kelvin_scale",
                                            "cNZ": "17",
                                            "missing_value": "-999.0"
                                        }
                                    }
                                }
                            }
                        }
                    }
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.40625",
                    "standard_name": "longitude"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Member"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead Time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.8125",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "ensemble member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Start Time",
                    "defaultvalue": "539.0",
                    "calendar": "360"
                },
                "dir": "SOURCES/IRI/FD/ECHAM5"
            },
            "ECPC": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "ECPC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "HistoryensembleMONTHLYgriblisthtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.ECPC/.History/.ensemble/.MONTHLY/.griblist.html",
                    "Historyclimatologyc7100long_name": "1971-2000",
                    "Historyclimatologyc6998long_name": "1969-1998",
                    "HistoryclimatologyiridlhasSemantics": "iridl:climatology",
                    "Forecastssstensemblemonthlyrunoffset": "533.0",
                    "Forecastssstensemblemonthlyexpires": "1407801600",
                    "Forecastpsstensemblemonthlyrunoffset": "521.0",
                    "Forecastpsstensemblemonthlyexpires": "1407801600",
                    "ForecastiridlhasSemantics": "iridl:forecast",
                    "references": "Kanamitsu_Mo2003 Kanamitsu_etal2002",
                    "description": "UC Scripps ECPC ensemble forecasts of precipitation and 2m temperature",
                    "iridlhasSemantics": "iridl:SIO",
                    "Conventions": "IRIDL"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "MONTHLY": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "MONTHLY",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "total_air_column": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "total_air_column",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "PWAT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PWAT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Precipitable water",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "0.113",
                                    "units": "kg/m^2",
                                    "grib_name": "PWAT",
                                    "process": "0",
                                    "gribleveltype": "200",
                                    "scale_max": "70.989998",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "54"
                                }
                            },
                            "surface": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "surface",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Pressure",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "50508.301",
                                    "units": "Pa",
                                    "grib_name": "PRES",
                                    "process": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "105309.1",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "1"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Geopotential height",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-296.29999",
                                    "units": "gpm",
                                    "grib_name": "HGT",
                                    "process": "0",
                                    "gribleveltype": "1",
                                    "scale_max": "5495.54",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "7"
                                }
                            },
                            "PressureLevel": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "PressureLevel",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vvel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vvel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Pressure vertical velocity",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-0.44263",
                                    "units": "Pa/s",
                                    "grib_name": "VVEL",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "0.56874",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "39"
                                },
                                "v": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "v",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "meridional wind",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-86.407997",
                                    "units": "m/s",
                                    "grib_name": "VGRD",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "87.956001",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "15",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "34"
                                },
                                "u": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "u",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "zonal wind",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-78.693001",
                                    "units": "m/s",
                                    "grib_name": "UGRD",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "126.13",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "15",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "33"
                                },
                                "temp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Temperature",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "145.64999",
                                    "units": "Kelvin_scale",
                                    "grib_name": "TMP",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "313.134",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "11"
                                },
                                "rhum": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "rhum",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Relative humidity",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "0.0",
                                    "units": "percent",
                                    "grib_name": "RH",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "99.93",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "14",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "52"
                                },
                                "qa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "qa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Specific humidity",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-4.08299995E-04",
                                    "units": "unitless",
                                    "grib_name": "SPFH",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "0.0211329",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "51"
                                },
                                "phi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Geopotential height",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-267.42999",
                                    "units": "gpm",
                                    "grib_name": "HGT",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "31582.74",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "7"
                                },
                                "ABSV": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ABSV",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Absolute vorticity",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "-2.09480000E-04",
                                    "units": "1/s",
                                    "grib_name": "ABSV",
                                    "process": "0",
                                    "gribleveltype": "100",
                                    "scale_max": "2.94010009E-04",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "41"
                                }
                            },
                            "MSL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MSL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pressure": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pressure",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "center": "US Weather Service - National Met. Center",
                                    "long_name": "Pressure",
                                    "subcenter": "NCEP Ensemble Products",
                                    "calendar": "standard",
                                    "PTVersion": "2",
                                    "scale_min": "96750.297",
                                    "units": "Pa",
                                    "grib_name": "PRES",
                                    "process": "0",
                                    "gribleveltype": "102",
                                    "scale_max": "107597.4",
                                    "GRIBgridcode": "2",
                                    "gribNumBits": "16",
                                    "PDS_TimeRange": "3",
                                    "gribparam": "1"
                                }
                            },
                            "filepattern": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "filepattern",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless"
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "Forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1407801600",
                                    "calendar": "360",
                                    "bounds": "L"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "psst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "psst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1407801600",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "asst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "asst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "missing_value": "NaN"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "missing_value": "NaN"
                                }
                            }
                        }
                    }
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "M_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "member"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "modulus": "360.0",
                    "pointwidth": "2.5"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "pointwidth": "1.0",
                    "modulo": "12.0",
                    "calendar": "360"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "calendar": "standard",
                    "pointwidth": "1.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "member"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1407801600",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1407801600",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.875",
                    "standard_name": "longitude"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "member"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "dir": "SOURCES/IRI/FD/ECPC"
            },
            "Flexible_Forecast": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/FD/Flexible_Forecast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "Flexible_Forecast",
                "restriction": "Public",
                "precip_CPC": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/precip_CPC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "precip_CPC",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "precip_obs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "precip_obs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "prcp_est_sqrt": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp_est_sqrt",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CMAP estimated precipitation",
                        "fnname": "sqrt",
                        "units": "unitless",
                        "history": "Boxes with less than 0.0% dropped",
                        "missing_value": "NaN",
                        "file_missing_value": "-999.0",
                        "maxncolor": "254",
                        "standard_name": "lwe_precipitation_rate",
                        "colormap": "1989150",
                        "ncolor": "254"
                    },
                    "prcp_est": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prcp_est",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "CMAP estimated precipitation",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 0.0% dropped",
                        "units": "mm/day",
                        "file_missing_value": "-999.0",
                        "maxncolor": "254",
                        "standard_name": "lwe_precipitation_rate",
                        "colormap": "1989150",
                        "ncolor": "254"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "pointwidth": "2.5"
                    },
                    "T2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "12.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "2.5"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "standard_name": "time",
                        "calendar": "360",
                        "pointwidth": "3.0"
                    },
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/precip_obs"
                },
                "precipitation": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/precipitation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "precipitation",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "temp_CPC": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/temp_CPC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "temp_CPC",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "temp_obs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_obs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Conventions": "IRIDL"
                    },
                    "temp_s8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp_s8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "long_name": "Air Temperature",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "file_missing_value": "9.99900026E20",
                        "expires": "1617235200",
                        "standard_name": "air_temperature",
                        "gribfield": "1"
                    },
                    "temp_c8110": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp_c8110",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "history": "Averaged over T2[1981, 2010] minimum 0.0% data present",
                        "long_name": "Air Temperature",
                        "missing_value": "NaN",
                        "units": "Celsius_scale",
                        "file_missing_value": "9.99900026E20",
                        "expires": "1617235200",
                        "standard_name": "air_temperature",
                        "gribfield": "1"
                    },
                    "temp": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "temp",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Air Temperature",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 0.0% dropped",
                        "units": "Celsius_scale",
                        "file_missing_value": "9.99900026E20",
                        "expires": "1617235200",
                        "standard_name": "air_temperature",
                        "gribfield": "1"
                    },
                    "anomaly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "anomaly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "temperature anomaly",
                        "missing_value": "NaN",
                        "history": "Boxes with less than 0.0% dropped",
                        "units": "degree_Celsius",
                        "file_missing_value": "-9999.0",
                        "expires": "1617260400"
                    },
                    "T2_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T2_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "12.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "standard_name": "longitude",
                        "pointwidth": "2.0"
                    },
                    "T2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "pointwidth": "12.0",
                        "standard_name": "time",
                        "calendar": "360"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "standard_name": "latitude",
                        "pointwidth": "2.0"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulo": "12.0",
                        "modulus": "12.0",
                        "standard_name": "time",
                        "calendar": "360",
                        "pointwidth": "3.0"
                    },
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/temp_obs"
                },
                "temperature": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/FD/Flexible_Forecast/temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "temperature",
                    "restriction": "Public",
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ]
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "precip_CPC",
                    "precip_obs",
                    "precipitation",
                    "temp_CPC",
                    "temp_obs",
                    "temperature"
                ]
            },
            "GCM": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GCM",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NSIPP1Historyc7100long_name": "1971-2000",
                    "NSIPP1Historyc7100iridlhasSemantics": "iridl:climatology",
                    "NSIPP1Historyc6998long_name": "1969-1998",
                    "NSIPP1Historyc6998iridlhasSemantics": "iridl:climatology",
                    "NSIPP1Forecastssstmonthlyrunoffset": "533.0",
                    "NSIPP1references": "Bacmeister_etal2000 Pegion_etal2000",
                    "NSIPP1description": "NASA GSFC NSIPP-1 ensemble forecasts and simulations of precipitation rate, 2m temperature, and 500mb heights",
                    "NSIPP1iridlhasSemantics": "iridl:NASA",
                    "NCEPHistoryc7100long_name": "1971-2000",
                    "NCEPHistoryc6998long_name": "1969-1998",
                    "NCEPlong_name": "NCEP MRF9",
                    "NCEPreferences": "Kumar_etal1996 Livezey_etal1996 Saha_etal2006",
                    "NCEPdescription": "NCEP MRF9 ensemble forecasts and simulations of precipitation rate, 2m temperature, and 500mb heights",
                    "NCEPiridlhasSemantics": "iridl:NCEP",
                    "GFDLHistoryc7100long_name": "1971-2000",
                    "GFDLHistoryc6998long_name": "1968-1998",
                    "GFDLForecastssstmonthlyrunoffset": "537.0",
                    "GFDLForecastssstmonthlyexpires": "1491868800",
                    "GFDLForecastpsstmonthlyrunoffset": "537.0",
                    "GFDLForecastpsstmonthlyexpires": "1491868800",
                    "GFDLdescription": "Princeton GFDL ensemble forecasts of precipitation and 2m temperature",
                    "GFDLiridlhasSemantics": "iridl:GFDL",
                    "ECPCHistoryc7100long_name": "1971-2000",
                    "ECPCHistoryc6998long_name": "1969-1998",
                    "ECPCForecastssstmonthlyrunoffset": "533.0",
                    "ECPCForecastssstmonthlyexpires": "1407801600",
                    "ECPCForecastpsstmonthlyrunoffset": "521.0",
                    "ECPCForecastpsstmonthlyexpires": "1407801600",
                    "ECPCreferences": "Kanamitsu_Mo2003 Kanamitsu_etal2002",
                    "ECPCdescription": "UC Scripps ECPC ensemble forecasts of precipitation and 2m temperature",
                    "ECPCiridlhasSemantics": "iridl:SIO",
                    "ECHAM4p5MOM3DC2long_name": "ECHAM4.5 MOM3 DC2",
                    "ECHAM4p5MOM3DC2description": "ECHAM4.5 ensemble forecasts and simulations",
                    "ECHAM4p5MOM3AC1long_name": "ECHAM4.5 MOM3 AC1",
                    "ECHAM4p5MOM3AC1description": "ECHAM4.5 ensemble forecasts and simulations",
                    "ECHAM4p5GMLcfsSSTlong_name": "ECHAM4.5 GML cfsSST",
                    "ECHAM4p5GMLcfsSSTdescription": "ECHAM4.5 ensemble forecasts and simulations",
                    "ECHAM4p5Historyc7100long_name": "1971-2000",
                    "ECHAM4p5Historyc7100iridlhasSemantics": "iridl:climatology",
                    "ECHAM4p5Historyc6998long_name": "1969-1998",
                    "ECHAM4p5Historyc6998iridlhasSemantics": "iridl:climatology",
                    "ECHAM4p5Forecastssstmonthlyrunoffset": "533.0",
                    "ECHAM4p5Forecastssstmonthlyexpires": "1491868800",
                    "ECHAM4p5Forecastpsstmonthlyrunoffset": "504.0",
                    "ECHAM4p5Forecastpsstmonthlyexpires": "1491868800",
                    "ECHAM4p5long_name": "ECHAM4.5",
                    "ECHAM4p5references": "Roeckner_etal1996",
                    "ECHAM4p5description": "ECHAM4.5 ensemble forecasts and simulations",
                    "ECHAM4p5iridlhasSemantics": "iridl:MPI_Met",
                    "COLAHistoryc7100long_name": "1971-2000",
                    "COLAHistoryc6998long_name": "1969-1998",
                    "COLAForecastssstmonthlyrunoffset": "533.0",
                    "COLAForecastssstmonthlyexpires": "1491868800",
                    "COLAabout_COLA": "http://www.iges.org/cola.html",
                    "COLAlong_name": "COLA",
                    "COLAreferences": "Kinter_etal1988 Dewitt1996 Schneider2002",
                    "COLAdescription": "COLA C2.2 ensemble forecasts and simulations of precipitation rate and temperature at canapy air space",
                    "COLAiridlhasSemantics": "iridl:COLA",
                    "CCM3v6Historyc7100long_name": "1971-2000",
                    "CCM3v6Historyc6998long_name": "1969-1998",
                    "CCM3v6Historyc6998iridlhasSemantics": "iridl:climatology",
                    "CCM3v6Forecastssstmonthlyexpires": "1491307200",
                    "CCM3v6Forecastpsstmonthlyexpires": "1491307200",
                    "CCM3v6references": "Hack_etal1998 Hurrell_etal1998 Kiehl_etal1998",
                    "CCM3v6description": "CCM3.6 ensemble forecasts and simulations",
                    "CCM3v6iridlhasSemantics": "iridl:NCAR",
                    "CCM3v6CCM3v6guide": "http://www.cgd.ucar.edu/cms/ccm3/ccm3lsm_doc/ccm3_doc/cover.html",
                    "description": "Global Circulation Models",
                    "Conventions": "IRIDL"
                },
                "NSIPP1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NSIPP-1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2000 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2000 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2000]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "fnname": "masklt",
                                "long_name": "500 mb height",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m",
                                "missing_value": "-9999.0"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "geopotential height",
                                "missing_value": "-662.31567"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "long_name": "temperature at 2m",
                                "missing_value": "-9999.0"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-102.095",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999000.0",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "bounds": "L"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0",
                                    "long_name": "sea level pressure",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12]",
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 9] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-102.095",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 9] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999000.0",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 9] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0",
                                    "long_name": "sea level pressure",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 9]",
                                    "long_name": "precipitation rate",
                                    "units": "mm/day",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "NCEP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NCEP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2004 0% min data present",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2004 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2004 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2004]",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2004]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2004]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30]",
                                    "long_name": "geopotential hieght",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30]",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30]",
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10]",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10]",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10]",
                                    "long_name": "precipitation rate",
                                    "units": "mm/day",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "GFDL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "GFDL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2000]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2000]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1491868800",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491868800",
                                    "calendar": "360",
                                    "bounds": "L"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30] minimum 0.0% data present",
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1491868800",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "psst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1491868800",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491868800",
                                    "calendar": "360",
                                    "bounds": "L"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1491868800",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "ECPC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECPC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2001 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2001 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2001]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2001]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1407801600",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 12] minimum 0.0% data present",
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "psst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1407801600",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1407801600",
                                    "missing_value": "NaN",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "missing_value": "NaN"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "mm/s",
                                    "long_name": "precipitation rate",
                                    "missing_value": "NaN"
                                }
                            }
                        }
                    }
                },
                "ECHAM4p5MOM3DC2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5-MOM3-DC2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "coupled": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "coupled",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "standard_name": "geopotential",
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "9"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "standard_name": "air_temperature",
                                    "long_name": "temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "cNZ": "9"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "standard_name": "lwe_thickness_of_precipitation_amount",
                                    "long_name": "total precipitation",
                                    "units": "m s-1",
                                    "cNZ": "9"
                                }
                            }
                        }
                    }
                },
                "ECHAM4p5MOM3AC1": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5-MOM3-AC1",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "coupled": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "coupled",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "temperature at 2m",
                                    "units": "K",
                                    "cNZ": "17"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "total precipitation",
                                    "units": "m s-1",
                                    "cNZ": "17"
                                }
                            }
                        }
                    }
                },
                "ECHAM4p5GMLcfsSST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5-GML-cfsSST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "coupled": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "coupled",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "geopotential height",
                                    "units": "gpm",
                                    "cNZ": "17"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "temperature at 2m",
                                    "units": "K",
                                    "cNZ": "17"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 12.5]",
                                    "long_name": "total precipitation",
                                    "units": "m s-1",
                                    "cNZ": "17"
                                }
                            }
                        }
                    }
                },
                "ECHAM4p5": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ECHAM4p5",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2003 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2003 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2003]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2003]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "gribparam": "156",
                                "long_name": "geopotential height",
                                "units": "m",
                                "expires": "1492214400"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "expires": "1491868800",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491868800",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "units": "m/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "psst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "expires": "1491868800",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491868800",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "units": "m/s",
                                    "long_name": "precipitation rate",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 24]",
                                    "long_name": "precipitation rate",
                                    "units": "m/s",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "COLA": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "COLA",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2003 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2003 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2003] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2003]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space",
                                "missing_value": "-9999.0"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space",
                                "missing_value": "-9999.0"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "file_missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at canopy air space"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30]",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491868800",
                                    "calendar": "360",
                                    "bounds": "L"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 30] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0",
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "expires": "1491868800",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "asst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "asst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "missing_value": "NaN"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[1, 10] minimum 0.0% data present",
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "missing_value": "NaN"
                                }
                            }
                        }
                    }
                },
                "CCM3v6": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CCM3v6",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "m8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2002 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1981-2002 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1971-2000 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1969-1998 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "m6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "m6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "percentiles computed over T2:1961-1990 0% min data present",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c8110": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c8110",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2002]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1981, 2002]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "units": "m",
                                "missing_value": "NaN",
                                "file_missing_value": "9.99999962E35",
                                "long_name": "Geopotential Height (above sea level)",
                                "time_op": "average",
                                "pointwidth": "1.0"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6190": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6190",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1961, 1990]",
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "units": "m",
                                    "long_name": "geopotential height",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999962E35",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999962E35",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491307200",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "units": "m/s",
                                    "long_name": "precipitation rate",
                                    "missing_value": "NaN",
                                    "expires": "1491307200",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                }
                            }
                        },
                        "psst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "units": "m",
                                    "long_name": "geopotential height",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999962E35",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "9.99999962E35",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "expires": "1491307200",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "pointwidth": "1",
                                    "long_name": "Forecast Time",
                                    "standard_name": "time",
                                    "units": "months since 1960-01-01",
                                    "expires": "1491307200",
                                    "calendar": "360"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "history": "Averaged over M[0.5, 24.5] minimum 0.0% data present",
                                    "units": "m/s",
                                    "long_name": "precipitation rate",
                                    "missing_value": "NaN",
                                    "expires": "1491307200",
                                    "file_missing_value": "9.99999962E35",
                                    "time_op": "average",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "X_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "S_14": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_14",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "X_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "S_13": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_13",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "S_12": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_12",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "P_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "S_11": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_11",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "Y_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.0",
                    "standard_name": "latitude"
                },
                "Y_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.0",
                    "standard_name": "latitude"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "S_10": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_10",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1491868800",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "Y_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "S_09": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_09",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1407801600",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "S_08": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_08",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1407801600",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "Y_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "S_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "P_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure level"
                },
                "S_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Start time",
                    "calendar": "360"
                },
                "P_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure level"
                },
                "Y_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "L_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period",
                    "long_name": "Lead time"
                },
                "S_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "long_name": "Start time",
                    "calendar": "360"
                },
                "P_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "bounds": "Z"
                },
                "P_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2",
                    "pointwidth": "0"
                },
                "L_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1491868800",
                    "pointwidth": "0",
                    "long_name": "Forecast Started"
                },
                "P_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1491868800",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "forecast_period"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.875",
                    "standard_name": "longitude"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "calendar": "360"
                },
                "percentile": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percentile",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "calendar": "360",
                    "modulo": "12.0",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.8125",
                    "standard_name": "longitude"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0",
                    "long_name": "lead time"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "long_name": "Pressure"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0",
                    "long_name": "lead time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.8125",
                    "standard_name": "longitude"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1491307200",
                    "pointwidth": "0",
                    "standard_name": "forecast_reference_time",
                    "long_name": "start time"
                },
                "dir": "SOURCES/IRI/FD/GCM"
            },
            "GFDL": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "GFDL",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "AM2p14references": "Delworth_etal2006",
                    "AM2p12bHistoryclimatologyc7100long_name": "1971-2000",
                    "AM2p12bHistoryclimatologyc6998long_name": "1968-1998",
                    "AM2p12bHistoryclimatologyiridlhasSemantics": "iridl:climatology",
                    "AM2p12bForecastssstensemblemonthlyexpires": "1491868800",
                    "AM2p12bForecastssstensemblemonthlyrunoffset": "537.0",
                    "AM2p12bForecastpsstensemblemonthlyexpires": "1491868800",
                    "AM2p12bForecastpsstensemblemonthlyrunoffset": "537.0",
                    "AM2p12bForecastiridlhasSemantics": "iridl:forecast",
                    "AM2p12breferences": "Anderson_etal2005",
                    "description": "Princeton GFDL ensemble forecasts of precipitation and 2m temperature",
                    "iridlhasSemantics": "iridl:GFDL",
                    "Conventions": "IRIDL"
                },
                "AM2p14": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AM2p14",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "vcomp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "vcomp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-1.00000000E10",
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 19:19:46 2007",
                                    "long_name": "meridional wind",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "ucomp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ucomp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-1.00000000E10",
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 18:33:02 2007",
                                    "long_name": "zonal wind",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "m/s",
                                    "pointwidth": "1.0"
                                },
                                "t_surf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t_surf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 17:30:54 2007",
                                    "long_name": "surface temperature",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "degree_Celsius",
                                    "pointwidth": "1.0"
                                },
                                "t_ref": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t_ref",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 17:26:29 2007",
                                    "long_name": "temperature at 2m",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "degree_Celsius",
                                    "pointwidth": "1.0"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 17:29:31 2007",
                                    "long_name": "sea level pressure",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "hPa",
                                    "pointwidth": "1.0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "created": "Wed May  2 17:28:08 2007",
                                    "author": "Shuhua Li",
                                    "long_name": "total precipitation rate",
                                    "units": "kg/m2/s",
                                    "standard_name": "precipitation flux",
                                    "pointwidth": "1.0"
                                },
                                "hght": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hght",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-1000.0",
                                    "author": "Shuhua Li",
                                    "created": "Wed May  2 17:36:11 2007",
                                    "long_name": "height",
                                    "title": "AM2.1_1870-2004-HGlob-SST-ICE-AllForc_B1",
                                    "units": "m",
                                    "pointwidth": "1.0"
                                }
                            }
                        }
                    }
                },
                "AM2p12b": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "AM2p12b",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "History": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "History",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble_mean": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble_mean",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature at 2m"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        },
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature at 2m"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        },
                        "climatology": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "climatology",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "c7100": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c7100",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature at 2m"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            },
                            "c6998": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "c6998",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature at 2m"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate"
                                }
                            }
                        }
                    },
                    "Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ssst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ssst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "Kelvin_scale",
                                        "long_name": "Temperature at 2m",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast Time",
                                        "pointwidth": "1",
                                        "expires": "1491868800",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "bounds": "L"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "mm/s",
                                        "long_name": "precipitation rate",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        },
                        "psst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "psst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "ensemble": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "Kelvin_scale",
                                        "long_name": "Temperature at 2m",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "time",
                                        "long_name": "Forecast Time",
                                        "pointwidth": "1",
                                        "expires": "1491868800",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "bounds": "L"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "expires": "1491868800",
                                        "units": "mm/s",
                                        "long_name": "precipitation rate",
                                        "missing_value": "NaN",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    }
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "hPa",
                    "gridtype": "0"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.5"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1491868800",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/IRI/FD/GFDL"
            },
            "NCEP": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NCEP",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Historyclimatologyc7100long_name": "1971-2000",
                    "Historyclimatologyc6998long_name": "1969-1998",
                    "HistoryclimatologyiridlhasSemantics": "iridl:climatology",
                    "ForecastiridlhasSemantics": "iridl:forecast",
                    "description": "NCEP MRF9 ensemble forecasts and simulations of precipitation rate, 2m temperature, and 500mb heights",
                    "iridlhasSemantics": "iridl:NCEP",
                    "Conventions": "IRIDL",
                    "long_name": "NCEP MRF9",
                    "references": "Kumar_etal1996 Livezey_etal1996 Saha_etal2006"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over M[0.5, 10.5]",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000]",
                                "units": "gpm",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "Forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "geopotential hieght",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_factor": "4000.0",
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "asst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "asst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "scale_factor": "4000.0",
                                    "long_name": "precipitation rate",
                                    "units": "mm/day",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2",
                    "pointwidth": "0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/IRI/FD/NCEP"
            },
            "NMME_India_Forecast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NMME_India_Forecast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "Temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "defaultvalue": "691.5"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "tercileclassesscale",
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "100",
                        "CS": "0",
                        "long_name": "Tercile Probability",
                        "units": "percent",
                        "defaultvalue": "691.5",
                        "pointwidth": "1"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "100.0",
                        "scale_min": "-100.0",
                        "maxncolor": "254",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "1250198",
                        "ncolor": "254",
                        "CE": "99.601593",
                        "CS": "-99.601593",
                        "missing_value": "NaN",
                        "units": "percent",
                        "pointwidth": "1",
                        "fnname": "masklt",
                        "colorscalename": "tercileclassesscale",
                        "defaultvalue": "691.5"
                    }
                },
                "Precipitation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Precipitation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "calendar": "360",
                        "units": "months since 1960-01-01",
                        "defaultvalue": "702.5"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "maxncolor": "254",
                        "colorscalename": "tercileclassesscale",
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CE": "100",
                        "CS": "0",
                        "long_name": "Tercile Probability",
                        "units": "percent",
                        "defaultvalue": "702.5",
                        "pointwidth": "1"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "100.0",
                        "scale_min": "-100.0",
                        "maxncolor": "254",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "16724736",
                        "ncolor": "254",
                        "CE": "99.601593",
                        "CS": "-99.601593",
                        "missing_value": "NaN",
                        "units": "percent",
                        "pointwidth": "1",
                        "fnname": "masklt",
                        "colorscalename": "tercileclassesscale",
                        "defaultvalue": "702.5"
                    }
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "1.0"
                },
                "F_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "defaultvalue": "691.5",
                    "pointwidth": "1"
                },
                "C": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "C",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "1.0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "standard_name": "longitude",
                    "pointwidth": "1.0"
                },
                "F": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "defaultvalue": "702.5",
                    "pointwidth": "1"
                },
                "dir": "SOURCES/IRI/FD/NMME_India_Forecast"
            },
            "NMME_Seasonal_Forecast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NMME_Seasonal_Forecast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Temperature_ELR_datesexpires": "1614582000",
                    "Temperature_ELRMethodology": "http://iri.columbia.edu/our-expertise/climate/forecasts/seasonal-climate-forecasts/methodology/",
                    "Temperature_ELRexpires": "1614582000",
                    "Precipitation_ELR_datesexpires": "1614582000",
                    "Precipitation_ELRMethodology": "http://iri.columbia.edu/our-expertise/climate/forecasts/seasonal-climate-forecasts/methodology/",
                    "Precipitation_ELRexpires": "1614582000",
                    "PiClong_name": "Predictions in Context",
                    "PiCdescription": "Predictions in Context",
                    "PiCexpires": "1614582000",
                    "PiCiridlhasSemantics": "iridl:verification",
                    "Full_Distributionexpires": "1494288000",
                    "ELR_coeffs_IMDparamfcst2description": "ELR forecast coefficients",
                    "ELR_coeffs_IMDparamfcst2expires": "1515456000",
                    "ELR_coeffs_IMDparamclimdescription": "ELR climatological coefficients",
                    "ELR_coeffs_IMDparamclimexpires": "1515456000",
                    "ELR_coeffs_IMDfcstmeandescription": "Forecast Ensemble Mean",
                    "ELR_coeffs_IMDfcstmeanexpires": "1515456000",
                    "ELR_coeffs_IMDdescription": "India Met. Dept. Extended Logistic Regression Forecast",
                    "ELR_coeffs_IMDexpires": "1515456000",
                    "ELR_coeffsparamfcst2description": "ELR forecast coefficients",
                    "ELR_coeffsparamfcst2expires": "1515456000",
                    "ELR_coeffsparamclimdescription": "ELR climatological coefficients",
                    "ELR_coeffsparamclimexpires": "1515456000",
                    "ELR_coeffsfcstmeandescription": "Forecast Ensemble Mean",
                    "ELR_coeffsfcstmeanexpires": "1515456000",
                    "ELR_coeffsdescription": "Global Extended Logistic Regression Forecast",
                    "ELR_coeffsexpires": "1515456000",
                    "expires": "1515456000",
                    "Conventions": "IRIDL"
                },
                "Temperature_ELR_dates": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Temperature_ELR_dates",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "expires": "1614582000",
                        "calendar": "360",
                        "defaultvalue": "733.5"
                    }
                },
                "Temperature_ELR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Temperature_ELR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "expires": "1515456000"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "expires": "1614582000",
                        "calendar": "360",
                        "defaultvalue": "733.5"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "100",
                        "colorscalename": "tercileclassesscale",
                        "long_name": "Tercile Probability",
                        "missing_value": "NaN",
                        "expires": "1614582000",
                        "units": "percent",
                        "defaultvalue": "733.5",
                        "pointwidth": "1"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "1250198",
                        "units": "percent",
                        "pointwidth": "1",
                        "missing_value": "NaN",
                        "expires": "1614582000",
                        "fnname": "masklt",
                        "colorscalename": "tercileclassesscale",
                        "defaultvalue": "733.5"
                    }
                },
                "target_date": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "target_date",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pointwidth": "3",
                    "long_name": "forecast time",
                    "units": "months since 1960-01-01",
                    "expires": "1515456000",
                    "calendar": "360",
                    "bounds": "S"
                },
                "Precipitation_ELR_dates": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Precipitation_ELR_dates",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "expires": "1614582000",
                        "calendar": "360",
                        "defaultvalue": "733.5"
                    }
                },
                "Precipitation_ELR": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Precipitation_ELR",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "expires": "1515456000"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "expires": "1614582000",
                        "calendar": "360",
                        "defaultvalue": "733.5"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "100",
                        "colorscalename": "tercileclassesscale",
                        "long_name": "Tercile Probability",
                        "missing_value": "NaN",
                        "expires": "1614582000",
                        "units": "percent",
                        "defaultvalue": "733.5",
                        "pointwidth": "1"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "16724736",
                        "units": "percent",
                        "pointwidth": "1",
                        "missing_value": "NaN",
                        "expires": "1614582000",
                        "fnname": "masklt",
                        "colorscalename": "tercileclassesscale",
                        "defaultvalue": "733.5"
                    }
                },
                "PiC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PiC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pic3mo_same": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic3mo_same",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "4.0",
                        "maxncolor": "8",
                        "ncolor": "7",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "4",
                        "long_name": "Same Tendency in Forecast and 3-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "4",
                        "missing_value": "0.0",
                        "CLIST": "Past Wet/Possible Future Wet, Greatly Enhanced",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1",
                        "expires": "1614582000",
                        "file_missing_value": "-999.0",
                        "standard_name": "lwe_precipitation_rate"
                    },
                    "pic3mo_reversed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic3mo_reversed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "2.0",
                        "maxncolor": "6",
                        "ncolor": "5",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "2",
                        "long_name": "Reversed Tendency in Forecast and 3-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "2",
                        "missing_value": "0.0",
                        "CLIST": "Past Dry/Possible Future Wet",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1",
                        "expires": "1614582000",
                        "file_missing_value": "-999.0",
                        "standard_name": "lwe_precipitation_rate"
                    },
                    "pic12mo_same": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic12mo_same",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "4.0",
                        "maxncolor": "8",
                        "ncolor": "7",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "4",
                        "long_name": "Same Tendency in Forecast and 12-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "4",
                        "missing_value": "0.0",
                        "CLIST": "Past Wet/Possible Future Wet, Greatly Enhanced",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1",
                        "expires": "1614582000",
                        "file_missing_value": "-999.0",
                        "standard_name": "lwe_precipitation_rate"
                    },
                    "pic12mo_reversed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic12mo_reversed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "2.0",
                        "maxncolor": "6",
                        "ncolor": "5",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "2",
                        "long_name": "Reversed Tendency in Forecast and 12-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "2",
                        "missing_value": "0.0",
                        "CLIST": "Past Dry/Possible Future Wet",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1",
                        "expires": "1614582000",
                        "file_missing_value": "-999.0",
                        "standard_name": "lwe_precipitation_rate"
                    }
                },
                "Full_Distribution": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Full_Distribution",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "tref": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "tref",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "1",
                        "long_name": "Temperature Probability",
                        "missing_value": "NaN",
                        "expires": "1494288000",
                        "units": "unitless",
                        "pointwidth": "0.0"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "long_name": "forecast time",
                        "units": "months since 1960-01-01",
                        "expires": "1494288000",
                        "calendar": "360",
                        "bounds": "S"
                    },
                    "precip": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "precip",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "1.0",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "1",
                        "long_name": "Precipitation Probability",
                        "missing_value": "NaN",
                        "expires": "1494288000",
                        "units": "unitless",
                        "pointwidth": "0.0"
                    }
                },
                "ELR_coeffs_IMD": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ELR_coeffs_IMD",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_length": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_length",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Length of forecast time",
                        "units": "days",
                        "history": "Averaged in T with overlapping interval 3",
                        "missing_value": "NaN",
                        "pointwidth": "1.0",
                        "calendar": "360"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "long_name": "forecast time",
                        "units": "months since 1960-01-01",
                        "expires": "1518134400",
                        "calendar": "360",
                        "bounds": "S"
                    },
                    "paramfcst2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paramfcst2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "expires": "1518134400",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Precipitation Forecast Coefficients",
                            "missing_value": "NaN",
                            "expires": "1518134400",
                            "units": "unitless",
                            "pointwidth": "0.0"
                        }
                    },
                    "paramclim": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paramclim",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "calendar": "360"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Precipitation Climatological Coefficients",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "pointwidth": "0"
                        }
                    },
                    "fcstmean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fcstmean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "expires": "1518134400",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "colormap": "290304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "colorscalename": "precip_colors",
                            "units": "mm/day",
                            "long_name": "Ensemble Mean Precipitation",
                            "missing_value": "NaN",
                            "expires": "1518134400",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "ELR_coeffs": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ELR_coeffs",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "long_name": "forecast time",
                        "units": "months since 1960-01-01",
                        "expires": "1552089600",
                        "calendar": "360",
                        "bounds": "S"
                    },
                    "smooth2a_Gaussian_9_9_75": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "smooth2a_Gaussian_9_9_75",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless",
                        "long_name": "Gaussian Weights"
                    },
                    "paramfcst2": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paramfcst2",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "missing_value": "NaN",
                            "long_name": "Temperature Forecast Coefficients",
                            "expires": "1552089600",
                            "units": "unitless",
                            "pointwidth": "0.0"
                        },
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "expires": "1552089600",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Precipitation Forecast Coefficients",
                            "missing_value": "NaN",
                            "expires": "1552089600",
                            "units": "unitless",
                            "pointwidth": "0.0"
                        }
                    },
                    "paramclim": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "paramclim",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Temperature Climatological Coefficients",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "pointwidth": "0",
                            "modulo": "12.0",
                            "modulus": "12.0"
                        },
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "modulo": "12.0",
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "modulus": "12.0"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Precipitation Climatological Coefficients",
                            "missing_value": "NaN",
                            "units": "unitless",
                            "pointwidth": "0",
                            "modulo": "12.0",
                            "modulus": "12.0"
                        }
                    },
                    "fcstmean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "fcstmean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "tref": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "tref",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "maxncolor": "254",
                            "colormap": "255",
                            "ncolor": "254",
                            "colorscalename": "temp_colors",
                            "missing_value": "NaN",
                            "long_name": "Ensemble Mean Temperature",
                            "units": "Kelvin_scale",
                            "expires": "1552089600",
                            "pointwidth": "0.0"
                        },
                        "target_date": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "target_date",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "long_name": "forecast time",
                            "units": "months since 1960-01-01",
                            "expires": "1552089600",
                            "calendar": "360",
                            "bounds": "S"
                        },
                        "precip": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "precip",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "0.0",
                            "CS": "0",
                            "colormap": "290304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "colorscalename": "precip_colors",
                            "units": "mm/month",
                            "long_name": "Ensemble Mean Precipitation",
                            "missing_value": "NaN",
                            "expires": "1552089600",
                            "pointwidth": "0.0"
                        }
                    }
                },
                "C": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "C",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "F": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "defaultvalue": "733.5",
                    "expires": "1614582000",
                    "pointwidth": "1"
                },
                "percentile": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percentile",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "percent",
                    "gridtype": "0",
                    "pointwidth": "5.0",
                    "long_name": "Percentile"
                },
                "S_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1494288000",
                    "long_name": "Start Time",
                    "pointwidth": "0.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "Latitude"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "Longitude"
                },
                "S_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1518134400",
                    "long_name": "Start Time",
                    "pointwidth": "0.0"
                },
                "Y_lag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_lag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Latitude"
                },
                "X_lag": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_lag",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Longitude"
                },
                "ind_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ind_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Coefficients Index"
                },
                "ind": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ind",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "2.0",
                    "long_name": "Coefficients Index"
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "pointwidth": "0",
                    "long_name": "Start Time",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1552089600",
                    "long_name": "Start Time",
                    "pointwidth": "0.0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude",
                    "long_name": "Latitude"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Lead Time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude",
                    "long_name": "Longitude"
                },
                "modl": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "modl",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "long_name": "Models"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "expires": "1552089600",
                    "long_name": "Start Time",
                    "pointwidth": "0.0"
                },
                "dir": "SOURCES/IRI/FD/NMME_Seasonal_Forecast"
            },
            "NOAA": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NOAA",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NCEPCPCForecastUnitesStatesstandard_deviationexpires": "1552608000",
                    "NCEPCPCForecastUnitesStatesmeanexpires": "1492214400",
                    "description": "NOAA\\'s CPC seasonal probabilistic forecast",
                    "iridlhasSemantics": "iridl:forecast",
                    "Conventions": "IRIDL",
                    "long_name": "National Oceanic and Atmospheric Administration"
                },
                "NCEP": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NCEP",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CPC": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "CPC",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Forecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Forecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "UnitesStates": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Unites-States",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_deviation": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "standard_deviation",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Tsd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Tsd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature standard deviation skill",
                                        "missing_value": "-99.989998",
                                        "expires": "1552608000",
                                        "units": "unitless",
                                        "file_last_modified": "1489620157",
                                        "pointwidth": "0"
                                    },
                                    "Psd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Psd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitation standard deviation skill",
                                        "missing_value": "-99.989998",
                                        "expires": "1552608000",
                                        "units": "unitless",
                                        "file_last_modified": "1489620157",
                                        "pointwidth": "0"
                                    }
                                },
                                "mean": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mean",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Txb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Txb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "standardized mean temperature",
                                        "missing_value": "-99.989998",
                                        "expires": "1492214400",
                                        "units": "unitless",
                                        "file_last_modified": "1489620157",
                                        "pointwidth": "0"
                                    },
                                    "target_date": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "target_date",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "forecast time",
                                        "pointwidth": "3",
                                        "expires": "1492214400",
                                        "calendar": "360",
                                        "units": "months since 1960-01-01",
                                        "file_last_modified": "1489620157"
                                    },
                                    "Pxb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Pxb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "standardized mean precipitation",
                                        "missing_value": "-99.989998",
                                        "expires": "1492214400",
                                        "units": "unitless",
                                        "file_last_modified": "1489620157",
                                        "pointwidth": "0"
                                    }
                                }
                            }
                        }
                    }
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "3"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1492214400",
                    "calendar": "360",
                    "file_last_modified": "1489620157",
                    "long_name": "Forecast Start Time",
                    "pointwidth": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.0"
                },
                "dir": "SOURCES/IRI/FD/NOAA"
            },
            "NSIPP1": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "NSIPP-1",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Historyclimatologyc7100iridlhasSemantics": "iridl:climatology",
                    "Historyclimatologyc7100long_name": "1971-2000",
                    "Historyclimatologyc6998iridlhasSemantics": "iridl:climatology",
                    "Historyclimatologyc6998long_name": "1969-1998",
                    "HistoryclimatologyiridlhasSemantics": "iridl:climatology",
                    "Forecastssstensemblemonthlyrunoffset": "533.0",
                    "ForecastiridlhasSemantics": "iridl:forecast",
                    "description": "NASA GSFC NSIPP-1 ensemble forecasts and simulations of precipitation rate, 2m temperature, and 500mb heights",
                    "iridlhasSemantics": "iridl:NASA",
                    "Conventions": "IRIDL",
                    "references": "Bacmeister_etal2000 Pegion_etal2000"
                },
                "History": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "History",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ensemble_mean": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble_mean",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "missing_value": "-9999.0",
                                "long_name": "500mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "missing_value": "-9999.0",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "ensemble": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ensemble",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "z500": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "z500",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "units": "m",
                                "long_name": "500 mb height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "missing_value": "-9999.0",
                                "units": "Kelvin_scale",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    },
                    "climatology": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "climatology",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "c7100": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c7100",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                "missing_value": "NaN",
                                "fnname": "masklt",
                                "long_name": "500 mb height",
                                "file_missing_value": "-9999.0",
                                "units": "m"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Kelvin_scale",
                                "missing_value": "-9999.0",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        },
                        "c6998": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "c6998",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "zg": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "zg",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "missing_value": "-662.31567",
                                "long_name": "geopotential height"
                            },
                            "t2m": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "t2m",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_Celsius",
                                "missing_value": "-9999.0",
                                "long_name": "temperature at 2m"
                            },
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "long_name": "precipitation rate"
                            }
                        }
                    }
                },
                "Forecast": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Forecast",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "geopotential height",
                                    "missing_value": "-102.095",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Temperature at 2m",
                                    "missing_value": "-999000.0",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01",
                                    "bounds": "L"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "sea level pressure",
                                    "missing_value": "-999.0",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mm/day",
                                    "long_name": "precipitation rate",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    },
                    "asst": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "asst",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "ensemble": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ensemble",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "monthly": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "monthly",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "zg": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "zg",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-102.095",
                                    "long_name": "geopotential height",
                                    "units": "m",
                                    "pointwidth": "0"
                                },
                                "t2m": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "t2m",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999000.0",
                                    "long_name": "Temperature at 2m",
                                    "units": "Kelvin_scale",
                                    "pointwidth": "0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "standard_name": "time",
                                    "long_name": "Forecast Time",
                                    "pointwidth": "1",
                                    "calendar": "360",
                                    "units": "months since 1960-01-01"
                                },
                                "slp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "slp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "sea level pressure",
                                    "units": "unitless",
                                    "pointwidth": "0"
                                },
                                "prcp": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "precipitation rate",
                                    "units": "mm/day",
                                    "pointwidth": "0"
                                }
                            }
                        }
                    }
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "P_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2",
                    "unts": "mb",
                    "pointwidth": "0"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.5"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulo": "12.0",
                    "modulus": "12.0",
                    "calendar": "360",
                    "standard_name": "time",
                    "pointwidth": "1.0"
                },
                "M_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "P": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "P",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "mb",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "standard_name": "forecast_period",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.5"
                },
                "M": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "M",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "0",
                    "long_name": "member",
                    "pointwidth": "1.0"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "standard_name": "forecast_reference_time",
                    "long_name": "Forecast Started",
                    "pointwidth": "0"
                },
                "dir": "SOURCES/IRI/FD/NSIPP-1"
            },
            "SSTA_FCST": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SSTA_FCST",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "PSSTexpires": "1499299200",
                    "ASSTversion02expires": "1496707200",
                    "iridlhasSemantics": "iridl:forecast",
                    "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.SSTA_FCST/.dataset_documentation.html",
                    "Conventions": "IRIDL",
                    "long_name": "Monthly SST Forecast",
                    "description": "Real-Time IRI SST predictions (forcing for IRI climate prediction)"
                },
                "SSST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "SSST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "version02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Plus": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Plus",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1",
                                "expires": "1496707200",
                                "bounds": "S"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1496707200",
                                "long_name": "sea surface temperature anomaly",
                                "units": "degreeC",
                                "pointwidth": "0"
                            }
                        },
                        "Minu": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Minu",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1",
                                "expires": "1496707200",
                                "bounds": "S"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "expires": "1496707200",
                                "long_name": "sea surface temperature anomaly",
                                "units": "degreeC",
                                "pointwidth": "0"
                            }
                        }
                    },
                    "version01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "VanD": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VanD",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "sea surface temperature anomaly",
                                "units": "degreeC",
                                "pointwidth": "0"
                            }
                        },
                        "Ncep": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Ncep",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "sea surface temperature anomaly",
                                "units": "degreeC",
                                "pointwidth": "0"
                            }
                        },
                        "Ldeo": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Ldeo",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "standard_name": "time",
                                "long_name": "Forecast time",
                                "units": "months since 1960-01-01",
                                "calendar": "360",
                                "pointwidth": "1"
                            },
                            "sst": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "sst",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "sea surface temperature anomaly",
                                "units": "degreeC",
                                "pointwidth": "0"
                            }
                        }
                    }
                },
                "PSST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PSST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "ssta": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "ssta",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "expires": "1499299200",
                        "long_name": "observed SST_Anomaly",
                        "units": "degreeC",
                        "pointwidth": "0"
                    }
                },
                "ASST": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "ASST",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "version02": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version02",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Forecast time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "pointwidth": "1",
                            "expires": "1496707200",
                            "bounds": "S"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "expires": "1496707200",
                            "long_name": "sea surface temperature anomaly",
                            "units": "degreeC",
                            "pointwidth": "0"
                        }
                    },
                    "version01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "version01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "T": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "T",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "standard_name": "time",
                            "long_name": "Forecast time",
                            "units": "months since 1960-01-01",
                            "calendar": "360",
                            "pointwidth": "1"
                        },
                        "sst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "sst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "sea surface temperature anomaly",
                            "units": "degreeC",
                            "pointwidth": "0"
                        }
                    }
                },
                "S_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "pointwidth": "0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.7893267"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "expires": "1499299200",
                    "long_name": "Observation time",
                    "standard_name": "time",
                    "calendar": "360",
                    "pointwidth": "0"
                },
                "S_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "pointwidth": "0"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "long_name": "Lead time",
                    "standard_time": "forecast_period",
                    "pointwidth": "1.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "standard_name": "longitude",
                    "pointwidth": "2.8125"
                },
                "S": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "S",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "long_name": "Start time",
                    "pointwidth": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "standard_name": "latitude",
                    "pointwidth": "2.7893267"
                },
                "dir": "SOURCES/IRI/FD/SSTA_FCST"
            },
            "Seasonal_Forecast": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Seasonal_Forecast",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "TemperatureTemperature_ELR": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.NMME_Seasonal_Forecast/.Temperature_ELR/",
                    "PrecipitationPrecipitation_ELR": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.NMME_Seasonal_Forecast/.Precipitation_ELR/",
                    "PiClong_name": "Predictions in Context",
                    "PiCdescription": "Predictions in Context",
                    "PiCexpires": "1617235200",
                    "PiCdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.FD/.Seasonal_Forecast/.PiC.dataset_documentation.html",
                    "PiCiridlhasSemantics": "iridl:verification",
                    "Extreme_Temperatureexpires": "1491696000",
                    "Climatologiesc7100seasonalUEA_TS2p1description": "Seasonal Temperature and Precipitation Climatologies Based Upon UEA TS2p1 Data Set",
                    "Climatologiesc6998seasonalUEA_TS2p1description": "Seasonal Temperature and Precipitation Climatologies Based Upon UEA TS2p1 Data Set",
                    "Conventions": "IRIDL"
                },
                "Temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "100",
                        "colorscalename": "tercileclassesscale",
                        "long_name": "Tercile Probability",
                        "missing_value": "-9.0",
                        "units": "percent"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "1250198",
                        "units": "percent",
                        "missing_value": "NaN",
                        "fnname": "masklt",
                        "file_missing_value": "-9.0",
                        "colorscalename": "tercileclassesscale"
                    }
                },
                "Precipitation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Precipitation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "standard_name": "time",
                        "long_name": "forecast time",
                        "pointwidth": "3",
                        "units": "months since 1960-01-01",
                        "calendar": "360"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "6303920",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0",
                        "CE": "100",
                        "colorscalename": "tercileclassesscale",
                        "long_name": "Tercile Probability",
                        "missing_value": "-9.0",
                        "units": "percent"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "long_name": "Dominant Tercile Probability",
                        "colormap": "16724736",
                        "units": "percent",
                        "missing_value": "NaN",
                        "fnname": "masklt",
                        "file_missing_value": "-9.0",
                        "colorscalename": "tercileclassesscale"
                    }
                },
                "PiC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "PiC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "pic3mo_same": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic3mo_same",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "4.0",
                        "maxncolor": "8",
                        "ncolor": "7",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "4",
                        "long_name": "Same Tendency in Forecast and 3-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "4",
                        "missing_value": "0.0",
                        "CLIST": "Past Wet/Possible Future Wet, Greatly Enhanced",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1.0",
                        "expires": "1617235200",
                        "file_missing_value": "-999.0",
                        "standard_name": "time",
                        "shiftlag": "0.0",
                        "bounds": "T"
                    },
                    "pic3mo_reversed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic3mo_reversed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "2.0",
                        "maxncolor": "6",
                        "ncolor": "5",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "2",
                        "long_name": "Reversed Tendency in Forecast and 3-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "2",
                        "missing_value": "0.0",
                        "CLIST": "Past Dry/Possible Future Wet",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1.0",
                        "expires": "1617235200",
                        "file_missing_value": "-999.0",
                        "standard_name": "time",
                        "shiftlag": "0.0",
                        "bounds": "T"
                    },
                    "pic12mo_same": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic12mo_same",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "4.0",
                        "maxncolor": "8",
                        "ncolor": "7",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "4",
                        "long_name": "Same Tendency in Forecast and 12-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "4",
                        "missing_value": "0.0",
                        "CLIST": "Past Wet/Possible Future Wet, Greatly Enhanced",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1.0",
                        "expires": "1617235200",
                        "file_missing_value": "-999.0",
                        "standard_name": "time",
                        "shiftlag": "0.0",
                        "bounds": "T"
                    },
                    "pic12mo_reversed": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "pic12mo_reversed",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "2.0",
                        "maxncolor": "6",
                        "ncolor": "5",
                        "scale_min": "1.0",
                        "CS": "1",
                        "CE": "2",
                        "long_name": "Reversed Tendency in Forecast and 12-Month Precipitation Observation",
                        "units": "ids",
                        "plotlast": "2",
                        "missing_value": "0.0",
                        "CLIST": "Past Dry/Possible Future Wet",
                        "plotfirst": "1",
                        "fnname": "maskrange",
                        "history": "Boxes with less than 0.0% dropped",
                        "pointwidth": "1.0",
                        "expires": "1617235200",
                        "file_missing_value": "-999.0",
                        "standard_name": "time",
                        "shiftlag": "0.0",
                        "bounds": "T"
                    }
                },
                "Observations": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Observations",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "monthly": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "monthly",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "units": "mm/day",
                            "missing_value": "-9999.0",
                            "long_name": "precipitation"
                        }
                    }
                },
                "Extreme_Temperature": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Extreme_Temperature",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "long_name": "forecast time",
                        "units": "months since 1960-01-01",
                        "expires": "1491696000",
                        "calendar": "360",
                        "file_last_modified": "1489612556",
                        "bounds": "F"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Tercile Probability",
                        "missing_value": "-9.0",
                        "expires": "1491696000"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9.0",
                        "long_name": "Extreme Temperature Risk",
                        "file_missing_value": "0",
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "colormap": "7920",
                        "units": "unitless",
                        "expires": "1491696000"
                    }
                },
                "Extreme_Precipitation": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Extreme_Precipitation",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "target_season": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_season",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "unitless"
                    },
                    "target_date": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "target_date",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "pointwidth": "3",
                        "long_name": "forecast time",
                        "units": "months since 1960-01-01",
                        "calendar": "360",
                        "file_last_modified": "1489612569",
                        "bounds": "F"
                    },
                    "prob": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "prob",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "long_name": "Tercile Probability",
                        "missing_value": "-9.0"
                    },
                    "dominant": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "dominant",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "missing_value": "-9.0",
                        "long_name": "Extreme Precipitation Risk",
                        "file_missing_value": "0",
                        "scale_max": "99.601593",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "-99.601593",
                        "CS": "-99.601593",
                        "CE": "99.601593",
                        "colormap": "16777215",
                        "units": "unitless"
                    }
                },
                "Climatologies": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Climatologies",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "c7100": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c7100",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "seasonal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "seasonal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "UEA_TS2p1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UEA_TS2p1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "deg2p5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "deg2p5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "40.0",
                                        "scale_min": "-50.0",
                                        "CS": "-50",
                                        "CE": "40",
                                        "long_name": "Seasonal Temperature Climatology, 1971-2000 Base Period",
                                        "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                        "units": "Celsius_scale",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Seasonal Precipitation Climatology, 1971-2000 Base Period",
                                        "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                        "units": "mm/month",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    }
                                },
                                "deg0p5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "deg0p5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "40.0",
                                        "scale_min": "-50.0",
                                        "CS": "-50",
                                        "CE": "40",
                                        "long_name": "Seasonal Temperature Climatology, 1971-2000 Base Period",
                                        "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                        "units": "Celsius_scale",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Seasonal Precipitation Climatology, 1971-2000 Base Period",
                                        "history": "Averaged over T2[1971, 2000] minimum 0.0% data present",
                                        "units": "mm/month",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    }
                                }
                            }
                        }
                    },
                    "c6998": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "c6998",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "seasonal": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "seasonal",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "UEA_TS2p1": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "UEA_TS2p1",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "deg2p5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "deg2p5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "40.0",
                                        "scale_min": "-50.0",
                                        "CS": "-50",
                                        "CE": "40",
                                        "long_name": "Seasonal Temperature Climatology, 1969-98 Base Period",
                                        "history": "Averaged over T2[1969, 1998] minimum 0.0% data present",
                                        "units": "Celsius_scale",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Seasonal Precipitation Climatology, 1969-98 Base Period",
                                        "history": "Averaged over T2[1969, 1998] minimum 0.0% data present",
                                        "units": "mm/month",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    }
                                },
                                "deg0p5": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "deg0p5",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "scale_max": "40.0",
                                        "scale_min": "-50.0",
                                        "CS": "-50",
                                        "CE": "40",
                                        "long_name": "Seasonal Temperature Climatology, 1969-98 Base Period",
                                        "history": "Averaged over T2[1969, 1998] minimum 0.0% data present",
                                        "units": "Celsius_scale",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    },
                                    "prcp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prcp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Seasonal Precipitation Climatology, 1969-98 Base Period",
                                        "history": "Averaged over T2[1969, 1998] minimum 0.0% data present",
                                        "units": "mm/month",
                                        "missing_value": "NaN",
                                        "file_missing_value": "-99.900002"
                                    }
                                }
                            }
                        },
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "prcp": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "prcp",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mm/day",
                                "missing_value": "-9999.0",
                                "long_name": "precipitation"
                            }
                        }
                    }
                },
                "F_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1",
                    "calendar": "360"
                },
                "F_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1",
                    "calendar": "360"
                },
                "L_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "F_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.0",
                    "standard_name": "latitude"
                },
                "F_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "file_last_modified": "1489612556",
                    "expires": "1491696000",
                    "pointwidth": "1"
                },
                "X_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.0",
                    "standard_name": "longitude"
                },
                "C": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "C",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "ids",
                    "gridtype": "2"
                },
                "F": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "file_last_modified": "1489612569",
                    "pointwidth": "1"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "0"
                },
                "X_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "period": "360.0",
                    "modulus": "360.0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "X_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "period": "360.0",
                    "modulus": "360.0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "period": "360.0",
                    "modulus": "360.0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "period": "360.0",
                    "modulus": "360.0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/IRI/FD/Seasonal_Forecast"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "AgMIP",
                "CCM3",
                "CCM3v6",
                "COLA",
                "COLA2p2p6",
                "CPT",
                "ECHAM3",
                "ECHAM4p5",
                "ECHAM5",
                "ECPC",
                "Flexible_Forecast",
                "GCM",
                "GFDL",
                "NCEP",
                "NMME_India_Forecast",
                "NMME_Seasonal_Forecast",
                "NOAA",
                "NSIPP1",
                "SSTA_FCST",
                "Seasonal_Forecast"
            ]
        },
        "MD": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/IRI/MD",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "MD",
            "restriction": "Public",
            "CID": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "CID",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Climate Information Digest",
                    "description": "Analyses from the IRI Climate Information Digest",
                    "expires": "1617235200",
                    "Conventions": "IRIDL",
                    "iridlhasSemantics": "iriref:Grover-Kopec_E"
                },
                "temp_persist": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_persist",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "3289855",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "temp_persistence",
                    "CE": "3.5",
                    "long_name": "Temperature Persistence",
                    "units": "months",
                    "history": "1 pass of 121 smoothing.",
                    "missing_value": "NaN",
                    "fnname": "masklt",
                    "file_missing_value": "-9999.0",
                    "expires": "1617260400"
                },
                "temp_fcst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_fcst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Dominant Tercile Probability:  Temperature",
                    "scale_max": "99.601593",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-99.601593",
                    "CS": "-99.601593",
                    "CE": "99.601593",
                    "colormap": "1250198",
                    "units": "percent",
                    "missing_value": "NaN",
                    "fnname": "masklt",
                    "file_missing_value": "-9.0",
                    "colorscalename": "tercileclassesscale"
                },
                "temp_climo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_climo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Climatological Temperature",
                    "maxncolor": "254",
                    "colormap": "255",
                    "scale_max": "40.0",
                    "ncolor": "254",
                    "scale_min": "-40.0",
                    "CS": "-40",
                    "colorscalename": "temp_colors",
                    "CE": "40",
                    "CLIST": "40",
                    "history": "1 pass of 121 smoothing.",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.90002",
                    "units": "Celsius_scale"
                },
                "temp_anomaly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "temp_anomaly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Temperature Anomaly",
                    "scale_max": "10.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-10.0",
                    "CS": "-10.0",
                    "CE": "10.0",
                    "colormap": "2237106",
                    "CI": "1.0",
                    "units": "degree_Celsius",
                    "missing_value": "-9999.0",
                    "expires": "1617260400"
                },
                "sst_anomaly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sst_anomaly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "CI": "0.5",
                    "scale_max": "5.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-5.0",
                    "CS": "-5.0",
                    "CE": "5.0",
                    "colormap": "2237106",
                    "standard_name": "sea_surface_temperature",
                    "long_name": "Sea Surface Temperature Anomaly",
                    "colorscalename": "sstacolorscale",
                    "units": "degree_Celsius",
                    "missing_value": "NaN",
                    "expires": "1615161600",
                    "pointwidth": "1.0"
                },
                "sensitivity": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "sensitivity",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "description": "Sensitivity Map -- Generated from 9-Month WASP Index",
                    "maxncolor": "254",
                    "colormap": "360960",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "std_wasp_colors",
                    "CE": "3.5",
                    "long_name": "9-Month WASP Index",
                    "units": "unitless",
                    "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "shiftlag": "0.0",
                    "bounds": "T",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "prcp_persist": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp_persist",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "maxncolor": "254",
                    "colormap": "25600",
                    "scale_max": "3.5",
                    "ncolor": "254",
                    "scale_min": "-3.5",
                    "CS": "-3.5",
                    "colorscalename": "prcp_persistence_colors",
                    "CE": "3.5",
                    "long_name": "Precipitation Persistence",
                    "units": "months",
                    "history": "1 pass of 121 smoothing.",
                    "missing_value": "NaN",
                    "fnname": "masklt",
                    "file_missing_value": "-999.0",
                    "expires": "1617235200",
                    "pointwidth": "1.0",
                    "shiftlag": "0.0",
                    "bounds": "T",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "prcp_fcst": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp_fcst",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Dominant Tercile Probability:  Precipitation",
                    "scale_max": "99.601593",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "-99.601593",
                    "CS": "-99.601593",
                    "CE": "99.601593",
                    "colormap": "16724736",
                    "units": "percent",
                    "missing_value": "NaN",
                    "fnname": "masklt",
                    "file_missing_value": "-9.0",
                    "colorscalename": "tercileclassesscale"
                },
                "prcp_climo_3month": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp_climo_3month",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Climatological 3-Month Precipitation",
                    "units": "cm",
                    "history": "1 pass of 121 smoothing.",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.0",
                    "colormap": "1973790",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "expires": "1617235200",
                    "pointwidth": "1.0",
                    "shiftlag": "0.0",
                    "bounds": "T",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "prcp_climo": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp_climo",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "long_name": "Climatological Precipitation",
                    "colormap": "290304",
                    "scale_max": "16.0",
                    "maxncolor": "254",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "16",
                    "colorscalename": "precip_colors",
                    "missing_value": "NaN",
                    "file_missing_value": "-999.90002",
                    "units": "mm/day"
                },
                "prcp_anomaly": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "prcp_anomaly",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "scale_max": "500.0",
                    "scale_min": "-500.0",
                    "CS": "-500",
                    "CE": "500",
                    "CLIST": "500",
                    "long_name": "Precipitation Anomaly",
                    "units": "mm/month",
                    "maxncolor": "254",
                    "colormap": "23040",
                    "ncolor": "254",
                    "colorscalename": "prcp_anomaly_max500_colors2",
                    "missing_value": "NaN",
                    "expires": "1617235200",
                    "file_missing_value": "-999.0",
                    "pointwidth": "1.0",
                    "shiftlag": "0.0",
                    "bounds": "T",
                    "standard_name": "time",
                    "calendar": "360"
                },
                "T_07": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_07",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "calendar": "360",
                    "standard_name": "time"
                },
                "F_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1",
                    "calendar": "360"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.0",
                    "standard_name": "longitude"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.0",
                    "standard_name": "latitude"
                },
                "T_06": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_06",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "shiftlag": "0",
                    "standard_name": "time",
                    "expires": "1617260400",
                    "defaultvalue": "733.5",
                    "calendar": "360"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "1.0",
                    "standard_name": "longitude"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "standard_name": "latitude"
                },
                "T_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "T_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "9.0",
                    "calendar": "360",
                    "standard_name": "time"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "3",
                    "calendar": "360",
                    "standard_name": "time"
                },
                "L": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "L",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months",
                    "gridtype": "0",
                    "pointwidth": "1.0"
                },
                "F": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "F",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1",
                    "calendar": "360"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "calendar": "360",
                    "pointwidth": "3",
                    "standard_name": "time",
                    "modulo": "12.0"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "2.5",
                    "standard_name": "longitude"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "2.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "0",
                    "pointwidth": "1.0",
                    "shiftlag": "0.0",
                    "standard_name": "time",
                    "expires": "1617235200",
                    "calendar": "360"
                },
                "dir": "SOURCES/IRI/MD/CID"
            },
            "IFRC": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/MD/IFRC",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "IFRC",
                "restriction": "Public",
                "CIESIN": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MD/IFRC/CIESIN",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "CIESIN",
                    "restriction": "requires dlauth tokens"
                },
                "CPC": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CPC",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Merged_Analysismonthlylong_name": "CPC Merged Analysis of Precipitation",
                        "Merged_Analysismonthlydescription": "U.S. Climate Prediction Center Merged Analysis of Precipitation",
                        "long_name": "CPC Products",
                        "description": "U.S. Climate Prediction Center Products for the Precipitation Forecast in Context Map Tool",
                        "Conventions": "IRIDL"
                    },
                    "Merged_Analysis": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Merged_Analysis",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "monthly": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "monthly",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "v1201": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v1201",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "5189423",
                                    "scale_max": "500.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "500",
                                    "long_name": "CMAP Monthly Precipitation Climatology (1985-2010 Base Period)",
                                    "units": "mm/month",
                                    "history": "Averaged over T2[1985, 2010] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0",
                                    "standard_name": "lwe_precipitation_rate"
                                }
                            },
                            "v0703": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "v0703",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "prcp_est": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "prcp_est",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "colormap": "5189423",
                                    "scale_max": "500.0",
                                    "maxncolor": "254",
                                    "ncolor": "254",
                                    "scale_min": "0.0",
                                    "CS": "0",
                                    "CE": "500",
                                    "long_name": "CMAP Monthly Precipitation Climatology (1979-2004 Base Period)",
                                    "units": "mm/month",
                                    "history": "Averaged over T2[1979, 2004] minimum 0.0% data present",
                                    "missing_value": "NaN",
                                    "file_missing_value": "-999.0"
                                }
                            }
                        }
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "T": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "T",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "1",
                        "modulus": "12.0",
                        "calendar": "360",
                        "modulo": "12.0",
                        "pointwidth": "1",
                        "standard_name": "time"
                    },
                    "dir": "SOURCES/IRI/MD/IFRC/CPC"
                },
                "ESRL": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MD/IFRC/ESRL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "ESRL",
                    "restriction": "Public",
                    "PSD": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "PSD",
                        "restriction": "Public",
                        "reforecast": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "reforecast",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ensemble_meanpentadpercentilec7904tot6daysfcstlong_name": "Six-Day Total Forecast",
                                "ensemble_meanpentadpercentilec7904day6fcstlong_name": "Day 6 Forecast",
                                "ensemble_meanpentadpercentilec7904day5fcstlong_name": "Day 5 Forecast",
                                "ensemble_meanpentadpercentilec7904day4fcstlong_name": "Day 4 Forecast",
                                "ensemble_meanpentadpercentilec7904day3fcstlong_name": "Day 3 Forecast",
                                "ensemble_meanpentadpercentilec7904day2fcstlong_name": "Day 2 Forecast",
                                "ensemble_meanpentadpercentilec7904day1fcstlong_name": "Day 1 Forecast",
                                "ensemble_meanpentadclimatologyc7904tot6daysfcstlong_name": "Six-Day Total Forecast",
                                "ensemble_meanpentadclimatologyc7904day6fcstlong_name": "Day 6 Forecast",
                                "ensemble_meanpentadclimatologyc7904day5fcstlong_name": "Day 5 Forecast",
                                "ensemble_meanpentadclimatologyc7904day4fcstlong_name": "Day 4 Forecast",
                                "ensemble_meanpentadclimatologyc7904day3fcstlong_name": "Day 3 Forecast",
                                "ensemble_meanpentadclimatologyc7904day2fcstlong_name": "Day 2 Forecast",
                                "ensemble_meanpentadclimatologyc7904day1fcstlong_name": "Day 1 Forecast",
                                "ensemble_meannoseasonalpercentilec7904tot6daysfcstlong_name": "Six-Day Total Forecast",
                                "ensemble_meannoseasonalpercentilec7904day6fcstlong_name": "Day 6 Forecast",
                                "ensemble_meannoseasonalpercentilec7904day5fcstlong_name": "Day 5 Forecast",
                                "ensemble_meannoseasonalpercentilec7904day4fcstlong_name": "Day 4 Forecast",
                                "ensemble_meannoseasonalpercentilec7904day3fcstlong_name": "Day 3 Forecast",
                                "ensemble_meannoseasonalpercentilec7904day2fcstlong_name": "Day 2 Forecast",
                                "ensemble_meannoseasonalpercentilec7904day1fcstlong_name": "Day 1 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904tot6daysfcstlong_name": "Six-Day Total Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day6fcstlong_name": "Day 6 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day5fcstlong_name": "Day 5 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day4fcstlong_name": "Day 4 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day3fcstlong_name": "Day 3 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day2fcstlong_name": "Day 2 Forecast",
                                "ensemble_meanmonthlyclimatologyc7904day1fcstlong_name": "Day 1 Forecast",
                                "Conventions": "IRIDL"
                            },
                            "ensemble_mean": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "ensemble_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "pentad": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pentad",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "percentile": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "percentile",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c7904": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "c7904",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tot6daysfcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tot6daysfcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day6fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day6fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day5fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day5fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day4fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day4fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day3fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day3fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day2fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day2fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            },
                                            "day1fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day1fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "long_name": "Accumulated Precipitation"
                                                }
                                            }
                                        }
                                    },
                                    "climatology": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "climatology",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c7904": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "c7904",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tot6daysfcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tot6daysfcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Six-Day Total Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day6fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day6fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 6 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day5fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day5fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 5 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day4fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day4fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 4 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day3fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day3fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 3 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day2fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day2fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 2 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day1fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day1fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Day 1 Pentad Mean 1979-2004 Mean Precipitation",
                                                    "history": "Averaged over S2[1200 2 Jul 1978 - 1200 2 Jul 1979, 2400 31 Dec 2004] minimum 0.0% data present",
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    }
                                },
                                "noseasonal": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "noseasonal",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "percentile": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "percentile",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c7904": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "c7904",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tot6daysfcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tot6daysfcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day6fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day6fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day5fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day5fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day4fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day4fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day3fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day3fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day2fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day2fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "day1fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day1fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "history": "percentiles computed over S:1200 1 Jan 1979 - 1200 31 Dec 2004 0% min data present",
                                                    "missing_value": "NaN",
                                                    "statistic": "Mean",
                                                    "units": "mm",
                                                    "long_name": "Accumulated precipitation",
                                                    "data_download_level": "Nonemb",
                                                    "var_desc": "Accumulated precipitation",
                                                    "data_download_type": "ensemble mean",
                                                    "Dataset": "MRF Reforecasting experiment",
                                                    "parent_stat": "Mean",
                                                    "actual_range": "68.57",
                                                    "valid_range": "9.9692100E36",
                                                    "precision": "-999.0",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    }
                                },
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "climatology": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "climatology",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c7904": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "c7904",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tot6daysfcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tot6daysfcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day6fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day6fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day5fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day5fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day4fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day4fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day3fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day3fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day2fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day2fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            },
                                            "day1fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day1fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/month",
                                                    "long_name": "1979-2004 Mean Monthly Precipitation"
                                                }
                                            }
                                        }
                                    }
                                },
                                "analyses": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "analyses",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "tot6day": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tot6day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "6",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Six-Day Total Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 tot6daysfcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Six-Day Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Six-Day Total Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "120.0",
                                            "scale_min": "-120.0",
                                            "CS": "-120",
                                            "CE": "120",
                                            "CLIST": "120",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Six-Day Total Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Six-Day Total Precipitation Forecast",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day6": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day6",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 6 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day6fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 6 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 6 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 6 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 6 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day5": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 5 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day5fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 5 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 5 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 5 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 5 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day4": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 4 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day4fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 4 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 4 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 4 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 4 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 3 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day3fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 3 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 3 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 3 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 3 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day2": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 2 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day2fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 2 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 2 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 2 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 2 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "day1": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "day1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "forecasttime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "forecasttime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "pointwidth": "1",
                                            "standard_name": "time",
                                            "long_name": "Forecast Time",
                                            "units": "days since 2007-08-24 00:00:00",
                                            "calendar": "standard"
                                        },
                                        "apcppctmonthlyclim": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctmonthlyclim",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "300.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "300",
                                            "long_name": "Day 1 Precipitation as Percent of 1979-2004 Mean Monthly Total",
                                            "units": "percent",
                                            "history": "S regridded on IRI MD IFRC ESRL PSD reforecast ensemble_mean monthly climatology c7904 day1fcst apcp",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctlenoseasonal": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctlenoseasonal",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 1 Total Precipitation Percentile from 1979-2004 Base Period - No Seasonality",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcppctle": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcppctle",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "13434880",
                                            "scale_max": "1.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.85",
                                            "CS": "0.85",
                                            "CE": "1.0",
                                            "long_name": "Day 1 Precipitation Percentile from 1979-2004 Base Period",
                                            "units": "unitless",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcpanom": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcpanom",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "scale_max": "50.0",
                                            "scale_min": "-50.0",
                                            "CS": "-50",
                                            "CE": "50",
                                            "CLIST": "50",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "colormap": "5189423",
                                            "long_name": "Day 1 Precipitation Anomaly from 1979-2004 Mean",
                                            "units": "mm",
                                            "history": "Boxes with less than 0.0% dropped",
                                            "missing_value": "NaN",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        },
                                        "apcp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "apcp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "colormap": "9445584",
                                            "scale_max": "150.0",
                                            "maxncolor": "254",
                                            "ncolor": "254",
                                            "scale_min": "0.0",
                                            "CS": "0",
                                            "CE": "150",
                                            "long_name": "Day 1 Forecast Total Precipitation",
                                            "history": "Averaged over members[0.5, 15.5] minimum 0.0% data present",
                                            "missing_value": "NaN",
                                            "units": "mm",
                                            "statistic": "Mean",
                                            "var_desc": "Accumulated precipitation",
                                            "parent_stat": "Mean",
                                            "Dataset": "NCEP/CDC MRF Reforecast",
                                            "actual_range": "133.221",
                                            "valid_range": "9.9692100E36",
                                            "precision": "-999.0",
                                            "pointwidth": "0"
                                        }
                                    }
                                }
                            },
                            "percentile_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "percentile_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "S_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pentads since 1960-01-01",
                                "gridtype": "1",
                                "modulus": "73.0",
                                "calendar": "365",
                                "pointwidth": "1.0",
                                "modulo": "73.0"
                            },
                            "S_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "pentads since 1961-01-01",
                                "gridtype": "1",
                                "modulus": "73.0",
                                "calendar": "365",
                                "pointwidth": "1.0",
                                "modulo": "73.0"
                            },
                            "percentile": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "percentile",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0"
                            },
                            "S_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "1",
                                "modulus": "12.0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "modulo": "12.0"
                            },
                            "X_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude"
                            },
                            "Y_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.5",
                                "standard_name": "latitude"
                            },
                            "L_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "forecast_period",
                                "long_name": "Lead Time"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "pointwidth": "2.5",
                                "standard_name": "latitude"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.5",
                                "standard_name": "longitude"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 2007-08-24 00:00:00",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Forecast Start Time",
                                "calendar": "standard",
                                "standard_name": "forecast_reference_time"
                            },
                            "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast"
                        },
                        "reforecast2": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "reforecast2",
                            "restriction": "Public",
                            "ensemble_mean": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "ensemble_mean",
                                "restriction": "Public",
                                "analyses": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "analyses",
                                    "restriction": "Public",
                                    "day1": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day1",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day1",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "day2": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day2",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day2",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "day3": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day3",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "day4": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day4",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day4",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "day5": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day5",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day5",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "day6": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/day6",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "day6",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "tot6day": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/analyses/tot6day",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "tot6day",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "day1",
                                        "day2",
                                        "day3",
                                        "day4",
                                        "day5",
                                        "day6",
                                        "tot6day"
                                    ]
                                },
                                "monthly": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "monthly",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c8512tot6daysfcstlong_name": "Six-Day Total Forecast",
                                        "c8512day6fcstlong_name": "Day 6 Forecast",
                                        "c8512day5fcstlong_name": "Day 5 Forecast",
                                        "c8512day4fcstlong_name": "Day 4 Forecast",
                                        "c8512day3fcstlong_name": "Day 3 Forecast",
                                        "c8512day2fcstlong_name": "Day 2 Forecast",
                                        "c8512day1fcstlong_name": "Day 1 Forecast",
                                        "Conventions": "IRIDL"
                                    },
                                    "c8512": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "c8512",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "tot6daysfcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "tot6daysfcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day6fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day6fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day5fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day5fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day4fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day4fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day3fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day3fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day2fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day2fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        },
                                        "day1fcst": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "day1fcst",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "apcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "apcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "mm/month",
                                                "long_name": "1985-2012 Mean Monthly Precipitation"
                                            }
                                        }
                                    },
                                    "S": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "S",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "1",
                                        "modulus": "12.0",
                                        "calendar": "360",
                                        "pointwidth": "1.0",
                                        "modulo": "12.0"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "1.0",
                                        "standard_name": "longitude"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "standard_name": "latitude"
                                    },
                                    "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/monthly"
                                },
                                "noseasonal": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "noseasonal",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "percentilec8512tot6daysfcstlong_name": "Six-Day Total Forecast",
                                        "percentilec8512day6fcstlong_name": "Day 6 Forecast",
                                        "percentilec8512day5fcstlong_name": "Day 5 Forecast",
                                        "percentilec8512day4fcstlong_name": "Day 4 Forecast",
                                        "percentilec8512day3fcstlong_name": "Day 3 Forecast",
                                        "percentilec8512day2fcstlong_name": "Day 2 Forecast",
                                        "percentilec8512day1fcstlong_name": "Day 1 Forecast",
                                        "Conventions": "IRIDL"
                                    },
                                    "percentile": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "percentile",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "1.0",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/noseasonal"
                                },
                                "pentad": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "pentad",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "climatologyc8512tot6daysfcstlong_name": "Six-Day Total",
                                        "climatologyc8512day6fcstlong_name": "Day 6 Forecast",
                                        "climatologyc8512day5fcstlong_name": "Day 5 Forecast",
                                        "climatologyc8512day4fcstlong_name": "Day 4 Forecast",
                                        "climatologyc8512day3fcstlong_name": "Day 3 Forecast",
                                        "climatologyc8512day2fcstlong_name": "Day 2 Forecast",
                                        "climatologyc8512day1fcstlong_name": "Day 1 Forecast",
                                        "Conventions": "IRIDL"
                                    },
                                    "climatology": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "climatology",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "c8512": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "c8512",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "tot6daysfcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tot6daysfcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "long_name": "Six-Day Total Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day6fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day6fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 6 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day5fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day5fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 5 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day4fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day4fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 4 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day3fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day3fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 3 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day2fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day2fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 2 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            },
                                            "day1fcst": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "day1fcst",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "apcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "apcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "long_name": "Day 1 Pentad Mean 1985-2012 Mean Precipitation"
                                                }
                                            }
                                        }
                                    },
                                    "S": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "S",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "pentads since 1960-01-01",
                                        "gridtype": "1",
                                        "modulus": "73.0",
                                        "calendar": "365",
                                        "pointwidth": "1.0",
                                        "modulo": "73.0"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "1.0",
                                        "standard_name": "longitude"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "standard_name": "latitude"
                                    },
                                    "dir": "SOURCES/IRI/MD/IFRC/ESRL/PSD/reforecast2/ensemble_mean/pentad"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "analyses",
                                    "monthly",
                                    "noseasonal",
                                    "pentad"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "ensemble_mean"
                            ]
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "reforecast",
                            "reforecast2"
                        ]
                    },
                    "banned_long": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type",
                        "PSD"
                    ]
                },
                "IRI": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "IRI",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NC_GLOBAL": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NC_GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "Seasonal_Forecastlong_name": "IRI Forecast Products",
                        "Seasonal_Forecastdescription": "IRI Forecast Products for the Precipitation Forecast in Context Map Tool",
                        "Seasonal_Forecastexpires": "1614582000",
                        "long_name": "IRI Products",
                        "description": "IRI Products for the Precipitation Forecast in Context Map Tool",
                        "Conventions": "IRIDL"
                    },
                    "Seasonal_Forecast": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Seasonal_Forecast",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "prcp_fcst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "prcp_fcst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "99.601593",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-99.601593",
                            "CS": "-99.601593",
                            "CE": "99.601593",
                            "colormap": "13434880",
                            "long_name": "Dominant Tercile Probability:  Precipitation",
                            "units": "percent",
                            "pointwidth": "1",
                            "missing_value": "NaN",
                            "expires": "1614582000",
                            "fnname": "masklt",
                            "colorscalename": "tercileclassesscale",
                            "defaultvalue": "733.5"
                        },
                        "pic3mo_same": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pic3mo_same",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Same Tendency in Forecast and 3-Month Precipitation Observation",
                            "colormap": "16777215",
                            "scale_max": "4.0",
                            "maxncolor": "8",
                            "ncolor": "7",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "4",
                            "units": "ids",
                            "plotlast": "4",
                            "missing_value": "0.0",
                            "CLIST": "Past Wet/Possible Future Wet, Greatly Enhanced",
                            "plotfirst": "1",
                            "fnname": "maskrange",
                            "history": "Boxes with less than 0.0% dropped",
                            "pointwidth": "1",
                            "expires": "1614582000",
                            "file_missing_value": "-999.0",
                            "standard_name": "lwe_precipitation_rate"
                        },
                        "pic3mo_reversed": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "pic3mo_reversed",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "long_name": "Reversed Tendency Between Forecast and 3-Month Precipitation Observation",
                            "colormap": "16777215",
                            "scale_max": "2.0",
                            "maxncolor": "6",
                            "ncolor": "5",
                            "scale_min": "1.0",
                            "CS": "1",
                            "CE": "2",
                            "units": "ids",
                            "plotlast": "2",
                            "missing_value": "0.0",
                            "CLIST": "Past Dry/Possible Future Wet",
                            "plotfirst": "1",
                            "fnname": "maskrange",
                            "history": "Boxes with less than 0.0% dropped",
                            "pointwidth": "1",
                            "expires": "1614582000",
                            "file_missing_value": "-999.0",
                            "standard_name": "lwe_precipitation_rate"
                        },
                        "observationtime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "observationtime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Observation Time",
                            "units": "months since 1960-01-01",
                            "expires": "1614582000",
                            "calendar": "360",
                            "defaultvalue": "733.5",
                            "bounds": "F"
                        },
                        "forecasttime": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "forecasttime",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "pointwidth": "3",
                            "standard_name": "time",
                            "long_name": "Forecast Time",
                            "units": "months since 1960-01-01",
                            "expires": "1614582000",
                            "calendar": "360",
                            "defaultvalue": "733.5"
                        },
                        "extreme_prcp_fcst": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "extreme_prcp_fcst",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "99.601593",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "scale_min": "-99.601593",
                            "CS": "-99.601593",
                            "CE": "99.601593",
                            "colormap": "16777215",
                            "long_name": "Probability of Extreme Precipitation",
                            "missing_value": "-9.0",
                            "file_missing_value": "0",
                            "units": "unitless"
                        }
                    },
                    "Y_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "latitude"
                    },
                    "X_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "0",
                        "pointwidth": "1.0",
                        "standard_name": "longitude"
                    },
                    "LG": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "LG",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "0",
                        "long_name": "Lag Time"
                    },
                    "F_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "F_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "calendar": "360",
                        "defaultvalue": "733.5",
                        "expires": "1614582000",
                        "pointwidth": "1"
                    },
                    "L_01": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L_01",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "1.0"
                    },
                    "Y": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Y",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_north",
                        "gridtype": "0",
                        "pointwidth": "2.5",
                        "standard_name": "latitude"
                    },
                    "F": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "F",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months since 1960-01-01",
                        "gridtype": "0",
                        "file_last_modified": "1489612569",
                        "calendar": "360",
                        "pointwidth": "1"
                    },
                    "L": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "L",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "months",
                        "gridtype": "0",
                        "pointwidth": "0"
                    },
                    "X": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "X",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "units": "degree_east",
                        "gridtype": "1",
                        "pointwidth": "2.5",
                        "standard_name": "longitude"
                    },
                    "dir": "SOURCES/IRI/MD/IFRC/IRI"
                },
                "banned_long": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type",
                    "CIESIN",
                    "CPC",
                    "ESRL",
                    "IRI"
                ]
            },
            "SERVIR": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "SERVIR",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "MODISNDVIexpires": "1615420800",
                    "MODISEVIexpires": "1615420800",
                    "MODISexpires": "1615420800",
                    "CSMTreferences": "Grover-Kopec_etal2006",
                    "CSMTdescription": "Climatic Suitability for Malaria Transmission",
                    "CSMTdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MD/.SERVIR/.CSMT.dataset_documentation.html",
                    "CSMTiridlhasSemantics": "iridl:Malaria",
                    "expires": "1615420800",
                    "Conventions": "IRIDL"
                },
                "MODIS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MODIS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "NDVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "NDVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WAF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WAF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "SWAS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SWAS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EAF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EAF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridlhasSemantics": "iridl:NDVI",
                            "scale_max": "10000",
                            "units": "unitless",
                            "scale_min": "-2000",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    },
                    "EVI": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "EVI",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "WAF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "WAF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "SWAS": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "SWAS",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        },
                        "EAF": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "EAF",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_min": "-2000",
                            "scale_max": "10000",
                            "units": "unitless",
                            "colormap": "2304",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "CS": "-0.2",
                            "CE": "1.0",
                            "colorscalename": "ndvi_colorsMODIS",
                            "missing_value": "-3000",
                            "scale_factor": "9.99999975E-05",
                            "valid_max": "10000",
                            "valid_min": "-2000",
                            "pointwidth": "0"
                        }
                    }
                },
                "MEWS": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "MEWS",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "missing_value": "-999.0",
                    "expires": "1615420800",
                    "maxncolor": "254",
                    "units": "mm",
                    "colormap": "14053594",
                    "scale_max": "1200.0",
                    "ncolor": "254",
                    "scale_min": "0.0",
                    "CS": "0",
                    "CE": "1200",
                    "long_name": "Estimated Precipitation",
                    "standard_name": "lwe_precipitation_rate",
                    "description": "CPC/Famine Early Warning System Dekadal Estimates"
                },
                "CSMT": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "CSMT",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "TempCondProb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "TempCondProb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "100.0",
                        "CI": "25.0",
                        "long_name": "Percent Occurrence of Temperature Condition in Historical Record",
                        "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "fnname": "flagge",
                        "file_missing_value": "-99.900002"
                    },
                    "RHCondProb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "RHCondProb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "13882323",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "100.0",
                        "CI": "25.0",
                        "long_name": "Percent Occurrence of Relative Humidity Condition in Historical Record",
                        "history": "Averaged over T2[1951, 2000]",
                        "units": "unitless",
                        "fnname": "flagge",
                        "process": " run",
                        "PDS_TimeRange": "113",
                        "GRIBgridcode": "2",
                        "subcenter": "NCEP Ensemble Products",
                        "gribvariable": "51",
                        "gribleveltype": "100",
                        "gribparam": "51",
                        "PTVersion": "2",
                        "gribNumBits": "15",
                        "gribfield": "1",
                        "center": "US Weather Service - National Met. Center",
                        "grib_name": "SPFH",
                        "calendar": "standard",
                        "pointwidth": "1.0"
                    },
                    "PcpnCondProb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "PcpnCondProb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "16777215",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "100.0",
                        "CI": "25.0",
                        "long_name": "Percent Occurrence of Precipitation Condition in Historical Record",
                        "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                        "units": "unitless",
                        "fnname": "flagge",
                        "missing_value": "NaN",
                        "file_missing_value": "-99.900002"
                    },
                    "Annual_Sum": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "Annual_Sum",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "0",
                        "scale_max": "12.5",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "12.5",
                        "long_name": "Number of Months Suitable for Malaria Transmission",
                        "history": "Averaged over T[Jan, Dec] minimum 0.0% data present",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "fnname": "flagge",
                        "file_missing_value": "-99.900002"
                    },
                    "AllCondProb": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "AllCondProb",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "colormap": "13882323",
                        "scale_max": "100.0",
                        "maxncolor": "254",
                        "ncolor": "254",
                        "scale_min": "0.0",
                        "CS": "0.0",
                        "CE": "100.0",
                        "CI": "25.0",
                        "long_name": "Percent Occurrence of All Three Climate Conditions in Historical Record",
                        "history": "Averaged over T2[1951, 2000] minimum 0.0% data present",
                        "units": "unitless",
                        "missing_value": "NaN",
                        "fnname": "flagge",
                        "file_missing_value": "-99.900002"
                    }
                },
                "X_05": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_05",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.002217041",
                    "standard_name": "longitude"
                },
                "T_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2003-01-01",
                    "gridtype": "0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "X_04": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_04",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.002217041",
                    "standard_name": "longitude"
                },
                "Y_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.00221704",
                    "standard_name": "latitude"
                },
                "T_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 2003-01-01",
                    "gridtype": "0",
                    "standard_name": "time",
                    "calendar": "standard"
                },
                "X_03": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_03",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.002217041",
                    "standard_name": "longitude"
                },
                "Y_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "latitude"
                },
                "T_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "days since 1960-01-01",
                    "gridtype": "0",
                    "calendar": "standard",
                    "expires": "1615420800"
                },
                "X_02": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_02",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.1",
                    "standard_name": "longitude"
                },
                "Y_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "X_01": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X_01",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "calendar": "360",
                    "long_name": "Month",
                    "modulo": "12.0",
                    "expires": "1617408000",
                    "pointwidth": "1.0",
                    "standard_name": "time"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/IRI/MD/SERVIR"
            },
            "Tools": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "Tools",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "UnaveragingM2Pentadlong_name": "Monthly to Pentad",
                    "UnaveragingM2Pentaddataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MD/.Tools/.Unaveraging.M2Pentad.dataset_documentation.html",
                    "UnaveragingM2PentadiridlhasSemantics": "iriref:Blumenthal_MB",
                    "Conventions": "IRIDL"
                },
                "Unaveraging": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Unaveraging",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "M2Pentad": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "M2Pentad",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "avginv": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "avginv",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "scale_max": "1.2",
                            "scale_min": "-1.2",
                            "CS": "-1.2",
                            "CE": "1.2",
                            "units": "unitless",
                            "maxncolor": "254",
                            "ncolor": "254",
                            "colorscalename": "correlationcolorscale",
                            "colormap": "2763429"
                        }
                    }
                },
                "T2": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T2",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "pentads since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "73.0",
                    "calendar": "365",
                    "pointwidth": "1.0",
                    "modulo": "73.0"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "calendar": "360",
                    "pointwidth": "1.0",
                    "standard_name": "time",
                    "modulo": "12.0",
                    "modulus": "12.0"
                },
                "dir": "SOURCES/IRI/MD/Tools"
            },
            "maproom": {
                "iridl_type": "DataSet",
                "iridl_ds_name": "maproom",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "NC_GLOBAL": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "NC_GLOBAL",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "Conventions": "IRIDL"
                },
                "Analyses": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Analyses",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "GHCN_CAMS": {
                        "iridl_type": "DataSet",
                        "iridl_ds_name": "GHCN_CAMS",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "gridded": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "gridded",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "deg0p5": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "deg0p5",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "temperature": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "temperature",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "c8110": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "c8110",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "bypercentile": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bypercentile",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "history": "percentiles computed over T2:1981-2010 100% min data present",
                                            "missing_value": "NaN",
                                            "file_missing_value": "9.99900026E20",
                                            "long_name": "Air Temperature",
                                            "standard_name": "air_temperature",
                                            "expires": "1617235200",
                                            "units": "Celsius_scale",
                                            "gribfield": "1"
                                        }
                                    }
                                }
                            }
                        }
                    }
                },
                "percentile": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "percentile",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "unitless",
                    "gridtype": "0"
                },
                "Y": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "Y",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_north",
                    "gridtype": "0",
                    "pointwidth": "0.5",
                    "standard_name": "latitude"
                },
                "T": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "T",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "months since 1960-01-01",
                    "gridtype": "1",
                    "modulus": "12.0",
                    "calendar": "360",
                    "modulo": "12.0",
                    "standard_name": "time",
                    "pointwidth": "1.0",
                    "expires": "1617235200"
                },
                "X": {
                    "iridl_type": "DataSet",
                    "iridl_ds_name": "X",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "units": "degree_east",
                    "gridtype": "1",
                    "pointwidth": "0.5",
                    "standard_name": "longitude"
                },
                "dir": "SOURCES/IRI/MD/maproom"
            },
            "banned_long": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type",
                "CID",
                "IFRC",
                "SERVIR",
                "Tools",
                "maproom"
            ]
        },
        "MP": {
            "iridl_type": "Source",
            "invalid": [],
            "dir": "SOURCES/IRI/MP",
            "banned": [
                "dir",
                "invalid",
                "parent",
                "name",
                "banned",
                "banned_long",
                "iridl_ds_name",
                "iridl_type"
            ],
            "iridl_ds_name": "MP",
            "restriction": "Public",
            "RESEARCH": {
                "iridl_type": "Source",
                "invalid": [],
                "dir": "SOURCES/IRI/MP/RESEARCH",
                "banned": [
                    "dir",
                    "invalid",
                    "parent",
                    "name",
                    "banned",
                    "banned_long",
                    "iridl_ds_name",
                    "iridl_type"
                ],
                "iridl_ds_name": "RESEARCH",
                "restriction": "Public",
                "ASSIMILATION": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MP/RESEARCH/ASSIMILATION",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "ASSIMILATION",
                    "restriction": "requires dlauth tokens"
                },
                "ATMOSPHERE": {
                    "iridl_type": "Source",
                    "invalid": [],
                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE",
                    "banned": [
                        "dir",
                        "invalid",
                        "parent",
                        "name",
                        "banned",
                        "banned_long",
                        "iridl_ds_name",
                        "iridl_type"
                    ],
                    "iridl_ds_name": "ATMOSPHERE",
                    "restriction": "Public",
                    "GLOBAL": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "GLOBAL",
                        "restriction": "Public",
                        "CAM3_CA_SST_GHG": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_CA_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "CAM3_CA_SST_GHG",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TotalAirColumnTotalAirColumn": "T",
                                    "tomtom": "T",
                                    "tomlong_name": "TopOfModel",
                                    "SurfaceSurface": "T",
                                    "PrecipPrecip": "S",
                                    "lsmsource": "Community Land Model: CLM2",
                                    "lsmdescription": "land surface model",
                                    "LanduseLanduse": "T",
                                    "HybridLevHybridLev": "T",
                                    "Conventions": "CF-1.0"
                                },
                                "TotalAirColumn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TotalAirColumn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "co2vmr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "co2vmr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "co2 volume mixing ratio",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "CLDMED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDMED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Vertically-integrated mid-level cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "CLDLOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDLOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Vertically-integrated low cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "CLDHGH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDHGH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Vertically-integrated high cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "tom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Net solar flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLUTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Clearsky upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLUT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Clearsky net longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Net longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TSMX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Maximum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TSMN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Minimum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface temperature (radiative)",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TMQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TMQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Total (vertically integrated) precipitatable water",
                                        "units": "kg/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Meridional surface stress",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Zonal surface stress",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Shortwave cloud forcing",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SNOWHLND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHLND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SNOWHICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Sea level pressure",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface pressure",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PHIS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PHIS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface geopotential",
                                        "units": "m2/s2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Longwave cloud forcing",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FSNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Clearsky net solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FSDSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Clearsky downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Clearsky net longwave flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Sampling_Sequence": "rad_lwsw",
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "Precip": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Precip",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PRECT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Total (convective and large-scale) precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Shallow Convection precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Convective snow rate (water equivalent)",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "ModelParameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ModelParameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnummax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnummax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cutoff Fourier wavenumber",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Forecast time",
                                        "pointwidth": "1",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "calendar": "360"
                                    },
                                    "P0": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P0",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference pressure",
                                        "units": "kg/m/s^2"
                                    },
                                    "hybm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer midpoints",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hybi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer interfaces",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hyam": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyam",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer midpoints",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hyai": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyai",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer interfaces",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "gw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "gauss weights",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "lsm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lsm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Forecast time",
                                        "pointwidth": "1",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "calendar": "360"
                                    },
                                    "Surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TG": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TG",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "QRGWL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QRGWL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface runoff at glaciers, wetlands, lakes",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QOVER": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QOVER",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface runoff",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FGEV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FGEV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground evaporation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TLAKE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TLAKE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "lake temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SUCSAT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SUCSAT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "saturated soil matric potential",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "SOILLIQ": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SOILLIQ",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil liquid water",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SOILICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SOILICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil ice",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "SnowIce": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SnowIce",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TSNOW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSNOW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SNOWLIQ": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWLIQ",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow liquid water",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow ice",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWDP": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWDP",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow height",
                                            "units": "m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWAGE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWAGE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow age",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric snow",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Radiation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Radiation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SABV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SABV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar rad absorbed by veg",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SABG": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SABG",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar rad absorbed by ground",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse vis reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis reflected solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVD": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVD",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRNI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRNI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse nir reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRNDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRNDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir reflected solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse vis incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis incident solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVD": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVD",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSNI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSNI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse nir incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSNDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSNDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir incident solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "absorbed solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FLDS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLDS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric longwave radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FIRE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FIRE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "emitted infrared (longwave) radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FIRA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FIRA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "net infrared (longwave) radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Moisture": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Moisture",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "QSOIL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QSOIL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground evaporation",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QMELT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QMELT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow melt",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QDRIP": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QDRIP",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "throughfall",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QDRAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QDRAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sub-surface drainage",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric specific humidity",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "Q2M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q2M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2m specific humidity",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "volumetric soil water",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OSNO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OSNO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow depth (liquid water)",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OCAN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OCAN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "intercepted water",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Leaf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Leaf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "RSSUN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RSSUN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sunlit leaf stomatal resistance",
                                            "units": "s/m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: minimum",
                                            "pointwidth": "0"
                                        },
                                        "RSSHA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RSSHA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "shaded leaf stomatal resistance",
                                            "units": "s/m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: minimum",
                                            "pointwidth": "0"
                                        },
                                        "QVEGT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVEGT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy transpiration",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QVEGE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVEGE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy evaporation",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QINTR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QINTR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "interception",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QINFL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QINFL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "infiltration",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FPSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FPSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "photosynthesis",
                                            "units": "umol/m2s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FCTR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FCTR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy transpiration",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FCEV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FCEV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy evaporation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ESAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ESAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "exposed one-sided stem area index",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ELAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ELAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "exposed one-sided leaf area index",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "BTRAN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BTRAN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "transpiration beta factor",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Landuse": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Landuse",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "landmask": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "landmask",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land/ocean mask (0.=ocean and 1.=land)",
                                            "units": "unitless"
                                        },
                                        "landfrac": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "landfrac",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land fraction",
                                            "units": "unitless"
                                        },
                                        "FSNO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "fraction of ground covered by snow",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "HeatFlux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "HeatFlux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "FSM": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSM",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow melt heat flux",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH_V": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH_V",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat from veg",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH_G": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH_G",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat from ground",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FGR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FGR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "heat flux into soil",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Errors": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Errors",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ERRSOL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSOL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar radiation conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil/lake energy conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRSEB": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSEB",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface energy conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRH2O": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRH2O",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "total water conservation error",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Constants": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Constants",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ZSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil depth",
                                            "units": "m",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "WATSAT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WATSAT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "saturated soil water content (porosity)",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "longxy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "longxy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "longitude",
                                            "units": "degree_east"
                                        },
                                        "latixy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "latixy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "latitude",
                                            "units": "degree_north"
                                        },
                                        "DZSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DZSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil thickness",
                                            "units": "m",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "BSW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BSW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "slope of soil water retention curve",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "area": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "area",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "grid cell areas",
                                            "units": "km^2"
                                        }
                                    },
                                    "Atmosphere": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Atmosphere",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ZBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric reference height",
                                            "units": "m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "WIND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric wind velocity magnitude",
                                            "units": "m/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TSA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2m air temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TREFMXAV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TREFMXAV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "daily maximum of average 2-m temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TREFMNAV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TREFMNAV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "daily minimum of average 2-m temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "THBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "THBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric air potential temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric air temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TAUY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TAUY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional surface stress",
                                            "units": "kg/m/s^2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TAUX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TAUX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal surface stress",
                                            "units": "kg/m/s^2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "RAIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RAIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric rain",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "Landuse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Landuse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "OCNFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OCNFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by ocean",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LANDMCOS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDMCOS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Land ocean transition mask: ocean (0), continent (1), transition (0-1)",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LANDFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by land",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "ICEFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ICEFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by sea-ice",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "HybridLev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HybridLev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Meridional wind",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Zonal wind",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Relative humidity",
                                        "units": "percent",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Specific humidity",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PBLH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PBLH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "PBL height",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "ilev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ilev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "level",
                                    "gridtype": "0"
                                },
                                "levsoi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "levsoi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "gridtype": "0"
                                },
                                "L": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "L",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Lead time"
                                },
                                "lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "level",
                                    "gridtype": "0"
                                },
                                "M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "lon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "standard_name": "longitude"
                                },
                                "S": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "S",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "long_name": "Start time",
                                    "pointwidth": "0",
                                    "standard_name": "forecast_reference_time",
                                    "calendar": "360"
                                },
                                "lat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0",
                                    "standard_name": "latitude"
                                },
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_CA_SST_GHG/MONTHLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY"
                            ]
                        },
                        "CAM3_CFS_SST_GHG": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_CFS_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "CAM3_CFS_SST_GHG",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TotalAirColumnTotalAirColumn": "T",
                                    "tomlong_name": "TopOfModel",
                                    "tomtom": "T",
                                    "SurfaceSurface": "T",
                                    "PrecipPrecip": "S",
                                    "lsmsource": "Community Land Model: CLM2",
                                    "lsmdescription": "land surface model",
                                    "LanduseLanduse": "T",
                                    "HybridLevHybridLev": "T",
                                    "Conventions": "CF-1.0"
                                },
                                "TotalAirColumn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TotalAirColumn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "co2vmr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "co2vmr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "co2 volume mixing ratio",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "CLDMED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDMED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertically-integrated mid-level cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "CLDLOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDLOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertically-integrated low cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "CLDHGH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDHGH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertically-integrated high cloud",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    }
                                },
                                "tom": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tom",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Net solar flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLUTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Clearsky upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLUT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Clearsky net longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Net longwave flux at top of model",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    }
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TSMX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Maximum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TSMN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Minimum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface temperature (radiative)",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TMQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TMQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Total (vertically integrated) precipitatable water",
                                        "units": "kg/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Meridional surface stress",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Zonal surface stress",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Shortwave cloud forcing",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "SNOWHLND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHLND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SNOWHICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Sea level pressure",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface pressure",
                                        "units": "kg/m/s^2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PHIS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PHIS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface geopotential",
                                        "units": "m2/s2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Longwave cloud forcing",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "FSNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Clearsky net solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FSDSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Clearsky downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Clearsky net longwave flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "cell_method": "time: mean",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "0"
                                    }
                                },
                                "Precip": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Precip",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "PRECT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Total (convective and large-scale) precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Shallow Convection precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Convective snow rate (water equivalent)",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "ModelParameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ModelParameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnummax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnummax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cutoff Fourier wavenumber",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Forecast time",
                                        "pointwidth": "1",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "calendar": "360"
                                    },
                                    "P0": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P0",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reference pressure",
                                        "units": "kg/m/s^2"
                                    },
                                    "hybm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer midpoints",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hybi": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hybi",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid B coefficient at layer interfaces",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hyam": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyam",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer midpoints",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "hyai": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hyai",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "hybrid A coefficient at layer interfaces",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    },
                                    "gw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "gauss weights",
                                        "units": "unitless",
                                        "pointwidth": "0"
                                    }
                                },
                                "lsm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lsm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Forecast time",
                                        "pointwidth": "1",
                                        "units": "months since 1960-01-01",
                                        "standard_name": "time",
                                        "calendar": "360"
                                    },
                                    "Surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TG": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TG",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "QRGWL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QRGWL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface runoff at glaciers, wetlands, lakes",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QOVER": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QOVER",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface runoff",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FGEV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FGEV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground evaporation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Soil": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Soil",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TLAKE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TLAKE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "lake temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SUCSAT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SUCSAT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "saturated soil matric potential",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "SOILLIQ": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SOILLIQ",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil liquid water",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SOILICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SOILICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil ice",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "SnowIce": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SnowIce",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TSNOW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSNOW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SNOWLIQ": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWLIQ",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow liquid water",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWICE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWICE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow ice",
                                            "units": "kg/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWDP": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWDP",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow height",
                                            "units": "m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOWAGE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOWAGE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow age",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SNOW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SNOW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric snow",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Radiation": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Radiation",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "SABV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SABV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar rad absorbed by veg",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "SABG": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SABG",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar rad absorbed by ground",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse vis reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis reflected solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRVD": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRVD",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRNI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRNI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse nir reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRNDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRNDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir reflected solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSRND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSRND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "reflected solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse vis incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis incident solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSVD": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSVD",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct vis incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSNI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSNI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "diffuse nir incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSNDLN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSNDLN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir incident solar radiation at local noon",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDSND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDSND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "direct nir incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSDS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSDS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric incident solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "absorbed solar radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FLDS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLDS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric longwave radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FIRE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FIRE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "emitted infrared (longwave) radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FIRA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FIRA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "net infrared (longwave) radiation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Moisture": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Moisture",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "QSOIL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QSOIL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "ground evaporation",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QMELT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QMELT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow melt",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QDRIP": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QDRIP",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "throughfall",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QDRAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QDRAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sub-surface drainage",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric specific humidity",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "Q2M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q2M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2m specific humidity",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "volumetric soil water",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OSNO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OSNO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow depth (liquid water)",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "H2OCAN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "H2OCAN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "intercepted water",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Leaf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Leaf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "TV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "RSSUN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RSSUN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sunlit leaf stomatal resistance",
                                            "units": "s/m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: minimum",
                                            "pointwidth": "0"
                                        },
                                        "RSSHA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RSSHA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "shaded leaf stomatal resistance",
                                            "units": "s/m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: minimum",
                                            "pointwidth": "0"
                                        },
                                        "QVEGT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVEGT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy transpiration",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QVEGE": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QVEGE",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy evaporation",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QINTR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QINTR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "interception",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "QINFL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QINFL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "infiltration",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FPSN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FPSN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "photosynthesis",
                                            "units": "umol/m2s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FCTR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FCTR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy transpiration",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FCEV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FCEV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "canopy evaporation",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ESAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ESAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "exposed one-sided stem area index",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ELAI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ELAI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "exposed one-sided leaf area index",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "BTRAN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BTRAN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "transpiration beta factor",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Landuse": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Landuse",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "landmask": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "landmask",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land/ocean mask (0.=ocean and 1.=land)",
                                            "units": "unitless"
                                        },
                                        "landfrac": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "landfrac",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land fraction",
                                            "units": "unitless"
                                        },
                                        "FSNO": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNO",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "fraction of ground covered by snow",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "HeatFlux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "HeatFlux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "FSM": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSM",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow melt heat flux",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH_V": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH_V",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat from veg",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH_G": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH_G",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat from ground",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FSH": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSH",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sensible heat",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "FGR": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FGR",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "heat flux into soil",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Errors": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Errors",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ERRSOL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSOL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "solar radiation conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil/lake energy conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRSEB": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRSEB",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface energy conservation error",
                                            "units": "W/m2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "ERRH2O": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERRH2O",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "total water conservation error",
                                            "units": "mm",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "Constants": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Constants",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ZSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil depth",
                                            "units": "m",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "WATSAT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WATSAT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "saturated soil water content (porosity)",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "longxy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "longxy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "longitude",
                                            "units": "degree_east"
                                        },
                                        "latixy": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "latixy",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "latitude",
                                            "units": "degree_north"
                                        },
                                        "DZSOI": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "DZSOI",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil thickness",
                                            "units": "m",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "BSW": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "BSW",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "slope of soil water retention curve",
                                            "units": "unitless",
                                            "missing_value": "9.99999962E35"
                                        },
                                        "area": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "area",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "grid cell areas",
                                            "units": "km^2"
                                        }
                                    },
                                    "Atmosphere": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Atmosphere",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "ZBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric reference height",
                                            "units": "m",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "WIND": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "WIND",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric wind velocity magnitude",
                                            "units": "m/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TSA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "2m air temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TREFMXAV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TREFMXAV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "daily maximum of average 2-m temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TREFMNAV": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TREFMNAV",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "daily minimum of average 2-m temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "THBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "THBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric air potential temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric air temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TAUY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TAUY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional surface stress",
                                            "units": "kg/m/s^2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "TAUX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TAUX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal surface stress",
                                            "units": "kg/m/s^2",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "Forecast time",
                                            "pointwidth": "1",
                                            "units": "months since 1960-01-01",
                                            "standard_name": "time",
                                            "calendar": "360"
                                        },
                                        "RAIN": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RAIN",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "atmospheric rain",
                                            "units": "mm/s",
                                            "missing_value": "9.99999962E35",
                                            "cell_method": "time: mean",
                                            "pointwidth": "0"
                                        }
                                    }
                                },
                                "Landuse": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Landuse",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "OCNFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OCNFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by ocean",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LANDMCOS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDMCOS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Land ocean transition mask: ocean (0), continent (1), transition (0-1)",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "LANDFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by land",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "ICEFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ICEFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Fraction of sfc area covered by sea-ice",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "HybridLev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "HybridLev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Meridional wind",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Zonal wind",
                                        "units": "m/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Temperature",
                                        "units": "Kelvin_scale",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Relative humidity",
                                        "units": "percent",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Specific humidity",
                                        "units": "unitless",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "PBLH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PBLH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "PBL height",
                                        "units": "m",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "cell_method": "time: mean",
                                        "pointwidth": "0"
                                    }
                                },
                                "ilev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ilev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "level",
                                    "gridtype": "0"
                                },
                                "levsoi": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "levsoi",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "gridtype": "0"
                                },
                                "L": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "L",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months",
                                    "gridtype": "0",
                                    "pointwidth": "1.0",
                                    "long_name": "Lead time"
                                },
                                "lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "level",
                                    "gridtype": "0"
                                },
                                "M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0",
                                    "pointwidth": "1.0"
                                },
                                "lon": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lon",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "1",
                                    "pointwidth": "2.8125",
                                    "standard_name": "longitude"
                                },
                                "S": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "S",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "months since 1960-01-01",
                                    "gridtype": "0",
                                    "long_name": "Start time",
                                    "pointwidth": "0",
                                    "standard_name": "forecast_reference_time",
                                    "calendar": "360"
                                },
                                "lat": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lat",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0",
                                    "standard_name": "latitude"
                                },
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_CFS_SST_GHG/MONTHLY"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY"
                            ]
                        },
                        "CAM3_EC3_SST_GHG": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_EC3_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "CAM3_EC3_SST_GHG",
                            "restriction": "Public",
                            "MONTHLY": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_EC3_SST_GHG/MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "MONTHLY",
                                "restriction": "requires dlauth tokens",
                                "indextex": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_EC3_SST_GHG/MONTHLY/index.tex",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "index.tex",
                                    "restriction": "Public",
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ]
                                },
                                "indextexbak": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_EC3_SST_GHG/MONTHLY/index.tex-bak",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "index.tex-bak",
                                    "restriction": "requires dlauth tokens"
                                },
                                "lsm": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_EC3_SST_GHG/MONTHLY/lsm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "lsm",
                                    "restriction": "requires dlauth tokens"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "indextex",
                                    "indextexbak",
                                    "lsm"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "MONTHLY"
                            ]
                        },
                        "CAM3_OBS_SST_GHG": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CAM3_OBS_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYtoalong_name": "top of atmosphere",
                                "MONTHLYlsmdescription": "land surface model",
                                "MONTHLYlsmsource": "Community Land Model: CLM2",
                                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.CAM3_OBS_SST_GHG/.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "total_air_column": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "total_air_column",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TMQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TMQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Total (vertically integrated) precipitatable water",
                                        "units": "kg/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "CLDTOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDTOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Vertically-integrated total cloud",
                                        "units": "unitless",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "CLDMED": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDMED",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Vertically-integrated mid-level cloud",
                                        "units": "unitless",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "CLDLOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDLOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Vertically-integrated low cloud",
                                        "units": "unitless",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "CLDHGH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "CLDHGH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Vertically-integrated high cloud",
                                        "units": "unitless",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "toa": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "toa",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "FSNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Net solar flux at top of model",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLUTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Clearsky upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLUT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLUT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Upwelling longwave flux at top of model",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNTC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNTC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Clearsky net longwave flux at top of model",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Net longwave flux at top of model",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "TSMX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Maximum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "TSMN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSMN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Minimum surface temperature over output period",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "TS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Surface temperature (radiative)",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "TREFHT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFHT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Reference height temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Meridional surface stress",
                                        "units": "kg/m/s^2",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Zonal surface stress",
                                        "units": "kg/m/s^2",
                                        "pointwidth": "1.0"
                                    },
                                    "SWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Shortwave cloud forcing",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWHLND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHLND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWHICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWHICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Water equivalent snow depth",
                                        "units": "m",
                                        "pointwidth": "1.0"
                                    },
                                    "SHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Surface sensible heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "PSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Sea level pressure",
                                        "units": "kg/m/s^2",
                                        "pointwidth": "1.0"
                                    },
                                    "PS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Surface pressure",
                                        "units": "kg/m/s^2",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Total (convective and large-scale) precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECSL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Shallow Convection precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Convective snow rate (water equivalent)",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Large-scale (stable) precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PRECC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PRECC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Convective precipitation rate",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "PHIS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PHIS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Surface geopotential",
                                        "units": "m2/s2",
                                        "pointwidth": "1.0"
                                    },
                                    "PBLH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PBLH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "PBL height",
                                        "units": "m",
                                        "pointwidth": "1.0"
                                    },
                                    "OCNFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OCNFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Fraction of sfc area covered by ocean",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "LWCF": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LWCF",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Longwave cloud forcing",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "LHFLX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LHFLX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Surface latent heat flux",
                                        "units": "W/m2",
                                        "pointwidth": "1.0"
                                    },
                                    "LANDMCOS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDMCOS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Land ocean transition mask: ocean (0), continent (1), transition (0-1)",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "LANDFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "LANDFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Fraction of sfc area covered by land",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "ICEFRAC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ICEFRAC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Fraction of sfc area covered by sea-ice",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "FSNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Clearsky net solar flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FSNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Net solar flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Clearsky downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Downwelling solar flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNSC": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNSC",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Clearsky net longwave flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    },
                                    "FLNS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLNS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Net longwave flux at surface",
                                        "units": "W/m2",
                                        "Sampling_Sequence": "rad_lwsw",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "parameters": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "parameters",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "time_bnds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bnds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "time interval endpoints",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "lsm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "lsm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "ZSOI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ZSOI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil depth",
                                        "units": "m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ZBOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ZBOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric reference height",
                                        "cell_method": "time: mean",
                                        "units": "m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "WIND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WIND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric wind velocity magnitude",
                                        "cell_method": "time: mean",
                                        "units": "m/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "WATSAT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "WATSAT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "saturated soil water content (porosity)",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vegetation temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TSOI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSOI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TSNOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSNOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TSA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TSA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "2m air temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TREFMXAV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFMXAV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "daily maximum of average 2-m temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TREFMNAV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TREFMNAV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "daily minimum of average 2-m temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TLAKE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TLAKE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "lake temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "time_written": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_written",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "time_bounds": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "time_bounds",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "logname": "history time interval endpoints",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "THBOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "THBOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric air potential temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TG": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TG",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "ground temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TBOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TBOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric air temperature",
                                        "cell_method": "time: mean",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUY": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUY",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional surface stress",
                                        "cell_method": "time: mean",
                                        "units": "kg/m/s^2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "TAUX": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "TAUX",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal surface stress",
                                        "cell_method": "time: mean",
                                        "units": "kg/m/s^2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SUCSAT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SUCSAT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "saturated soil matric potential",
                                        "units": "mm",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SOILLIQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOILLIQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil liquid water",
                                        "cell_method": "time: mean",
                                        "units": "kg/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SOILICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SOILICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil ice",
                                        "cell_method": "time: mean",
                                        "units": "kg/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWLIQ": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWLIQ",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow liquid water",
                                        "cell_method": "time: mean",
                                        "units": "kg/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWICE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWICE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow ice",
                                        "cell_method": "time: mean",
                                        "units": "kg/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWDP": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWDP",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow height",
                                        "cell_method": "time: mean",
                                        "units": "m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOWAGE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOWAGE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow age",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SNOW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SNOW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric snow",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SABV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SABV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar rad absorbed by veg",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "SABG": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "SABG",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar rad absorbed by ground",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "RSSUN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RSSUN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sunlit leaf stomatal resistance",
                                        "cell_method": "time: minimum",
                                        "units": "s/m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "RSSHA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RSSHA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "shaded leaf stomatal resistance",
                                        "cell_method": "time: minimum",
                                        "units": "s/m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "RAIN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RAIN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric rain",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QVEGT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVEGT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "canopy transpiration",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QVEGE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QVEGE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "canopy evaporation",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QSOIL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QSOIL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "ground evaporation",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QRGWL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QRGWL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff at glaciers, wetlands, lakes",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QOVER": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QOVER",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QMELT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QMELT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow melt",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QINTR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QINTR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "interception",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QINFL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QINFL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "infiltration",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QDRIP": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QDRIP",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "throughfall",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QDRAI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QDRAI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sub-surface drainage",
                                        "cell_method": "time: mean",
                                        "units": "mm/s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "QBOT": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "QBOT",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric specific humidity",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "Q2M": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q2M",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "2m specific humidity",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "longxy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "longxy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "longitude",
                                        "units": "degree_east",
                                        "pointwidth": "1.0"
                                    },
                                    "latixy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "latixy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latitude",
                                        "units": "degree_north",
                                        "pointwidth": "1.0"
                                    },
                                    "landmask": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "landmask",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land/ocean mask (0.=ocean and 1.=land)",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "landfrac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "landfrac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land fraction",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "H2OSOI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "H2OSOI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "volumetric soil water",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "H2OSNO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "H2OSNO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth (liquid water)",
                                        "cell_method": "time: mean",
                                        "units": "mm",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "H2OCAN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "H2OCAN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "intercepted water",
                                        "cell_method": "time: mean",
                                        "units": "mm",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "diffuse vis reflected solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRVDLN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRVDLN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct vis reflected solar radiation at local noon",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRVD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRVD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct vis reflected solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRNI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRNI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "diffuse nir reflected solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRNDLN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRNDLN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct nir reflected solar radiation at local noon",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSRND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSRND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct nir reflected solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "reflected solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSNO": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSNO",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "fraction of ground covered by snow",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow melt heat flux",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSH_V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSH_V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat from veg",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSH_G": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSH_G",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat from ground",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSH": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSH",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSVI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSVI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "diffuse vis incident solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSVDLN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSVDLN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct vis incident solar radiation at local noon",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSVD": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSVD",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct vis incident solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSNI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSNI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "diffuse nir incident solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSNDLN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSNDLN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct nir incident solar radiation at local noon",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDSND": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDSND",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "direct nir incident solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric incident solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FSA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FSA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "absorbed solar radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FPSN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FPSN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "photosynthesis",
                                        "cell_method": "time: mean",
                                        "units": "umol/m2s",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FLDS": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FLDS",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "atmospheric longwave radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FIRE": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FIRE",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "emitted infrared (longwave) radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FIRA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FIRA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net infrared (longwave) radiation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FGR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FGR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "heat flux into soil",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FGEV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FGEV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "ground evaporation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FCTR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FCTR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "canopy transpiration",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "FCEV": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "FCEV",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "canopy evaporation",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ESAI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ESAI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "exposed one-sided stem area index",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ERRSOL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERRSOL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "solar radiation conservation error",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ERRSOI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERRSOI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil/lake energy conservation error",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ERRSEB": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERRSEB",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface energy conservation error",
                                        "cell_method": "time: mean",
                                        "units": "W/m2",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ERRH2O": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ERRH2O",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total water conservation error",
                                        "cell_method": "time: mean",
                                        "units": "mm",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "ELAI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ELAI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "exposed one-sided leaf area index",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "DZSOI": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "DZSOI",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil thickness",
                                        "units": "m",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "BTRAN": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BTRAN",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "transpiration beta factor",
                                        "cell_method": "time: mean",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    },
                                    "BSW": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "BSW",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "slope of soil water retention curve",
                                        "units": "unitless",
                                        "missing_value": "9.99999962E35",
                                        "pointwidth": "1.0"
                                    }
                                },
                                "hybrid_lev": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "hybrid_lev",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Z3": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Z3",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Geopotential Height (above sea level)",
                                        "units": "m",
                                        "pointwidth": "1.0"
                                    },
                                    "V": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "V",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Meridional wind",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "U": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "U",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Zonal wind",
                                        "units": "m/s",
                                        "pointwidth": "1.0"
                                    },
                                    "T": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "T",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Temperature",
                                        "units": "Kelvin_scale",
                                        "pointwidth": "1.0"
                                    },
                                    "RELHUM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "RELHUM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Relative humidity",
                                        "units": "percent",
                                        "pointwidth": "1.0"
                                    },
                                    "Q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Specific humidity",
                                        "units": "unitless",
                                        "pointwidth": "1.0"
                                    },
                                    "OMEGA": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "OMEGA",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "cell_method": "time: mean",
                                        "long_name": "Vertical velocity (pressure)",
                                        "units": "Pa/s",
                                        "pointwidth": "1.0"
                                    }
                                }
                            },
                            "tbnd": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "tbnd",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "hist_interval": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "hist_interval",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "levsoi": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "levsoi",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "m",
                                "gridtype": "0"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "calendar": "360"
                            },
                            "lev": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lev",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "level",
                                "gridtype": "0"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CAM3_OBS_SST_GHG"
                        },
                        "CCM": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "CCM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "mem10hybrid_sigma_pressure": "",
                                "mem10source": "Data converted from CCM History Tape Format",
                                "mem10missing_value": "-999.0",
                                "mem10Conventions": "NCAR-CSM",
                                "mem10history": "Fri Dec 17 09:31:05 1999> /c2/suzana/ccm/ccm2nc/ccm2nc 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long10.nc",
                                "mem10title": "long10",
                                "mem10case": "long10",
                                "mem09hybrid_sigma_pressure": "",
                                "mem09source": "Data converted from CCM History Tape Format",
                                "mem09missing_value": "-999.0",
                                "mem09Conventions": "NCAR-CSM",
                                "mem09history": "Thu Dec  9 16:05:07 1999> /c2/suzana/ccm/ccm2nc/ccm2nc 1978-10 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long9.nc",
                                "mem09title": "long9",
                                "mem09case": "long9",
                                "mem08hybrid_sigma_pressure": "",
                                "mem08source": "Data converted from CCM History Tape Format",
                                "mem08missing_value": "-999.0",
                                "mem08Conventions": "NCAR-CSM",
                                "mem08history": "Thu Nov 18 10:13:17 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long8.nc",
                                "mem08title": "long8",
                                "mem08case": "long8",
                                "mem07hybrid_sigma_pressure": "",
                                "mem07source": "Data converted from CCM History Tape Format",
                                "mem07missing_value": "-999.0",
                                "mem07Conventions": "NCAR-CSM",
                                "mem07history": "Tue Nov  2 09:51:12 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc/ 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long7.nc",
                                "mem07title": "long7",
                                "mem07case": "long7",
                                "mem06hybrid_sigma_pressure": "",
                                "mem06source": "Data converted from CCM History Tape Format",
                                "mem06missing_value": "-999.0",
                                "mem06Conventions": "NCAR-CSM",
                                "mem06history": "Tue Nov  2 09:44:20 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1978-10 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long6.nc",
                                "mem06title": "long6",
                                "mem06case": "long6",
                                "mem05hybrid_sigma_pressure": "",
                                "mem05source": "Data converted from CCM History Tape Format",
                                "mem05missing_value": "-999.0",
                                "mem05Conventions": "NCAR-CSM",
                                "mem05history": "Fri Oct 15 10:32:58 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1978-10 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long5.nc",
                                "mem05title": "long5",
                                "mem05case": "long5",
                                "mem04hybrid_sigma_pressure": "",
                                "mem04source": "Data converted from CCM History Tape Format",
                                "mem04missing_value": "-999.0",
                                "mem04Conventions": "NCAR-CSM",
                                "mem04history": "Mon Sep 27 15:56:52 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1978-11 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 long4.nc",
                                "mem04title": "long4",
                                "mem04case": "long4",
                                "mem03hybrid_sigma_pressure": "",
                                "mem03source": "Data converted from CCM History Tape Format",
                                "mem03missing_value": "-999.0",
                                "mem03Conventions": "NCAR-CSM",
                                "mem03history": "Tue Sep 14 16:28:19 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1978-12 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 1996-01 1996-02 ccmlong3.nc",
                                "mem03title": "long3",
                                "mem03case": "long3",
                                "mem02hybrid_sigma_pressure": "",
                                "mem02source": "Data converted from CCM History Tape Format",
                                "mem02Conventions": "NCAR-CSM",
                                "mem02history": "Tue Aug 31 09:53:41 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc binaryfiles/1978-09 binaryfiles/1978-10 binaryfiles/1978-11 binaryfiles/1978-12 binaryfiles/1979-01 binaryfiles/1979-02 binaryfiles/1979-03 binaryfiles/1979-04 binaryfiles/1979-05 binaryfiles/1979-06 binaryfiles/1979-07 binaryfiles/1979-08 binaryfiles/1979-09 binaryfiles/1979-10 binaryfiles/1979-11 binaryfiles/1979-12 binaryfiles/1980-01 binaryfiles/1980-02 binaryfiles/1980-03 binaryfiles/1980-04 binaryfiles/1980-05 binaryfiles/1980-06 binaryfiles/1980-07 binaryfiles/1980-08 binaryfiles/1980-09 binaryfiles/1980-10 binaryfiles/1980-11 binaryfiles/1980-12 binaryfiles/1981-01 binaryfiles/1981-02 binaryfiles/1981-03 binaryfiles/1981-04 binaryfiles/1981-05 binaryfiles/1981-06 binaryfiles/1981-07 binaryfiles/1981-08 binaryfiles/1981-09 binaryfiles/1981-10 binaryfiles/1981-11 binaryfiles/1981-12 binaryfiles/1982-01 binaryfiles/1982-02 binaryfiles/1982-03 binaryfiles/1982-04 binaryfiles/1982-05 binaryfiles/1982-06 binaryfiles/1982-07 binaryfiles/1982-08 binaryfiles/1982-09 binaryfiles/1982-10 binaryfiles/1982-11 binaryfiles/1982-12 binaryfiles/1983-01 binaryfiles/1983-02 binaryfiles/1983-03 binaryfiles/1983-04 binaryfiles/1983-05 binaryfiles/1983-06 binaryfiles/1983-07 binaryfiles/1983-08 binaryfiles/1983-09 binaryfiles/1983-10 binaryfiles/1983-11 binaryfiles/1983-12 binaryfiles/1984-01 binaryfiles/1984-02 binaryfiles/1984-03 binaryfiles/1984-04 binaryfiles/1984-05 binaryfiles/1984-06 binaryfiles/1984-07 binaryfiles/1984-08 binaryfiles/1984-09 binaryfiles/1984-10 binaryfiles/1984-11 binaryfiles/1984-12 binaryfiles/1985-01 binaryfiles/1985-02 binaryfiles/1985-03 binaryfiles/1985-04 binaryfiles/1985-05 binaryfiles/1985-06 binaryfiles/1985-07 binaryfiles/1985-08 binaryfiles/1985-09 binaryfiles/1985-10 binaryfiles/1985-11 binaryfiles/1985-12 binaryfiles/1986-01 binaryfiles/1986-02 binaryfiles/1986-03 binaryfiles/1986-04 binaryfiles/1986-05 binaryfiles/1986-06 binaryfiles/1986-07 binaryfiles/1986-08 binaryfiles/1986-09 binaryfiles/1986-10 binaryfiles/1986-11 binaryfiles/1986-12 binaryfiles/1987-01 binaryfiles/1987-02 binaryfiles/1987-03 binaryfiles/1987-04 binaryfiles/1987-05 binaryfiles/1987-06 binaryfiles/1987-07 binaryfiles/1987-08 binaryfiles/1987-09 binaryfiles/1987-10 binaryfiles/1987-11 binaryfiles/1987-12 binaryfiles/1988-01 binaryfiles/1988-02 binaryfiles/1988-03 binaryfiles/1988-04 binaryfiles/1988-05 binaryfiles/1988-06 binaryfiles/1988-07 binaryfiles/1988-08 binaryfiles/1988-09 binaryfiles/1988-10 binaryfiles/1988-11 binaryfiles/1988-12 binaryfiles/1989-01 binaryfiles/1989-02 binaryfiles/1989-03 binaryfiles/1989-04 binaryfiles/1989-05 binaryfiles/1989-06 binaryfiles/1989-07 binaryfiles/1989-08 binaryfiles/1989-09 binaryfiles/1989-10 binaryfiles/1989-11 binaryfiles/1989-12 binaryfiles/1990-01 binaryfiles/1990-02 binaryfiles/1990-03 binaryfiles/1990-04 binaryfiles/1990-05 binaryfiles/1990-06 binaryfiles/1990-07 binaryfiles/1990-08 binaryfiles/1990-09 binaryfiles/1990-10 binaryfiles/1990-11 binaryfiles/1990-12 binaryfiles/1991-01 binaryfiles/1991-02 binaryfiles/1991-03 binaryfiles/1991-04 binaryfiles/1991-05 binaryfiles/1991-06 binaryfiles/1991-07 binaryfiles/1991-08 binaryfiles/1991-09 binaryfiles/1991-10 binaryfiles/1991-11 binaryfiles/1991-12 binaryfiles/1992-01 binaryfiles/1992-02 binaryfiles/1992-03 binaryfiles/1992-04 binaryfiles/1992-05 binaryfiles/1992-06 binaryfiles/1992-07 binaryfiles/1992-08 binaryfiles/1992-09 binaryfiles/1992-10 binaryfiles/1992-11 binaryfiles/1992-12 binaryfiles/1993-01 binaryfiles/1993-02 binaryfiles/1993-03 binaryfiles/1993-04 binaryfiles/1993-05 binaryfiles/1993-06 binaryfiles/1993-07 binaryfiles/1993-08 binaryfiles/1993-09 binaryfiles/1993-10 binaryfiles/1993-11 binaryfiles/1993-12 binaryfiles/1994-01 binaryfiles/1994-02 binaryfiles/1994-03 binaryfiles/1994-04 binaryfiles/1994-05 binaryfiles/1994-06 binaryfiles/1994-07 binaryfiles/1994-08 binaryfiles/1994-09 binaryfiles/1994-10 binaryfiles/1994-11 binaryfiles/1994-12 binaryfiles/1995-01 binaryfiles/1995-02 binaryfiles/1995-03 binaryfiles/1995-04 binaryfiles/1995-05 binaryfiles/1995-06 binaryfiles/1995-07 binaryfiles/1995-08 binaryfiles/1995-09 binaryfiles/1995-10 binaryfiles/1995-11 binaryfiles/1995-12 binaryfiles/1996-01 binaryfiles/1996-02 newccm.nc",
                                "mem02title": "years",
                                "mem02case": "longrun",
                                "mem01hybrid_sigma_pressure": "",
                                "mem01source": "Data converted from CCM History Tape Format",
                                "mem01missing_value": "-999.0",
                                "mem01Conventions": "NCAR-CSM",
                                "mem01history": "Fri Sep 10 15:31:33 1999> /crunch/c2/suzana/ccm/ccm2nc/ccm2nc 1979-01 1979-02 1979-03 1979-04 1979-05 1979-06 1979-07 1979-08 1979-09 1979-10 1979-11 1979-12 1980-01 1980-02 1980-03 1980-04 1980-05 1980-06 1980-07 1980-08 1980-09 1980-10 1980-11 1980-12 1981-01 1981-02 1981-03 1981-04 1981-05 1981-06 1981-07 1981-08 1981-09 1981-10 1981-11 1981-12 1982-01 1982-02 1982-03 1982-04 1982-05 1982-06 1982-07 1982-08 1982-09 1982-10 1982-11 1982-12 1983-01 1983-02 1983-03 1983-04 1983-05 1983-06 1983-07 1983-08 1983-09 1983-10 1983-11 1983-12 1984-01 1984-02 1984-03 1984-04 1984-05 1984-06 1984-07 1984-08 1984-09 1984-10 1984-11 1984-12 1985-01 1985-02 1985-03 1985-04 1985-05 1985-06 1985-07 1985-08 1985-09 1985-10 1985-11 1985-12 1986-01 1986-02 1986-03 1986-04 1986-05 1986-06 1986-07 1986-08 1986-09 1986-10 1986-11 1986-12 1987-01 1987-02 1987-03 1987-04 1987-05 1987-06 1987-07 1987-08 1987-09 1987-10 1987-11 1987-12 1988-01 1988-02 1988-03 1988-04 1988-05 1988-06 1988-07 1988-08 1988-09 1988-10 1988-11 1988-12 1989-01 1989-02 1989-03 1989-04 1989-05 1989-06 1989-07 1989-08 1989-09 1989-10 1989-11 1989-12 1990-01 1990-02 1990-03 1990-04 1990-05 1990-06 1990-07 1990-08 1990-09 1990-10 1990-11 1990-12 1991-01 1991-02 1991-03 1991-04 1991-05 1991-06 1991-07 1991-08 1991-09 1991-10 1991-11 1991-12 1992-01 1992-02 1992-03 1992-04 1992-05 1992-06 1992-07 1992-08 1992-09 1992-10 1992-11 1992-12 1993-01 1993-02 1993-03 1993-04 1993-05 1993-06 1993-07 1993-08 1993-09 1993-10 1993-11 1993-12 1994-01 1994-02 1994-03 1994-04 1994-05 1994-06 1994-07 1994-08 1994-09 1994-10 1994-11 1994-12 1995-01 1995-02 1995-03 1995-04 1995-05 1995-06 1995-07 1995-08 1995-09 1995-10 1995-11 1995-12 ccm.nc",
                                "mem01title": "years",
                                "mem01case": "longrun",
                                "Conventions": "IRIDL"
                            },
                            "mem10": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem10",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "16:07:41",
                                    "date": "11/29/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "16:10:10",
                                    "date": "12/09/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "16:48:29",
                                    "date": "12/09/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "14:58:47",
                                    "date": "11/29/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "09:23:40",
                                    "date": "11/30/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "10:00:59",
                                    "date": "11/30/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "17:50:31",
                                    "date": "10/18/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "10:16:05",
                                    "date": "11/02/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "10:53:53",
                                    "date": "11/02/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "16:28:10",
                                    "date": "10/18/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "10:24:15",
                                    "date": "10/27/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "11:00:31",
                                    "date": "10/27/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "15:09:31",
                                    "date": "10/18/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "16:23:13",
                                    "date": "10/19/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "17:01:22",
                                    "date": "10/19/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "16:56:48",
                                    "date": "08/31/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "12:51:16",
                                    "date": "09/28/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "13:28:46",
                                    "date": "09/28/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "12:37:37",
                                    "date": "09/01/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "15:54:45",
                                    "date": "09/14/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "16:33:08",
                                    "date": "09/14/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "13:43:51",
                                    "date": "09/01/99"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "15:26:27",
                                    "date": "09/01/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "16:03:53",
                                    "date": "09/01/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "mem02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "time": "06:26:35",
                                    "date": "02/06/98"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "time": "12:01:36",
                                    "date": "08/25/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "time": "12:39:03",
                                    "date": "08/25/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average"
                                }
                            },
                            "mem01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "mem01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "ZMDT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ZMDT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "K/S",
                                    "long_name": "ZMDT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Z3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "Z3",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "V": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "V",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "meridional wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "USTAR": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "USTAR",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Surface friction velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "U": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "U",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "zonal wind component",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS4": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS4",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 4)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS3": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS3",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 3)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS2": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS2",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Subsurface temperature (level 2)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS1": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS1",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature (level 1)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Surface temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TREFHT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TREFHT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "Reference height temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "tibnd_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "tibnd_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of time-invariant boundary data",
                                    "units": "unitless"
                                },
                                "TAUY": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUY",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Y-component (north-south) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "TAUX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "TAUX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "X-component (east-west) of surface stress",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Kelvin_scale",
                                    "long_name": "temperature",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "sst_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sst_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of SST boundary data",
                                    "units": "unitless"
                                },
                                "SRFRAD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SRFRAD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net radiative flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLSD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLSD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLLD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLLD",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLLD",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "SOLL",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SOLIN": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SOLIN",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Solar insolation",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SNOWH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SNOWH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Water equivalent snow depth",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SICTHK": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SICTHK",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SICTHK",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface sensible heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "SGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "M",
                                    "long_name": "SGH",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "RELHUM": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "RELHUM",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Relative humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "QFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "QFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "kg/m2/s",
                                    "long_name": "Surface water flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "Q": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Q",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "specific humidity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "Sea level pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa",
                                    "long_name": "surface pressure",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective snow rate (water equivalent)",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Large-scale (stable) precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PRECC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PRECC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m/s",
                                    "long_name": "Convective precipitation rate",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "PHIS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PHIS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "surface geopotential",
                                    "units": "m2/s2",
                                    "missing_value": "-999.0"
                                },
                                "PBLH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PBLH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "PBL height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "P0": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "P0",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "reference pressure",
                                    "units": "Pa"
                                },
                                "ozone_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ozone_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "MSS pathname of ozone boundary data",
                                    "units": "unitless"
                                },
                                "ORO": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ORO",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "ocean (0), land (1), sea ice (2) flag",
                                    "units": "unitless",
                                    "missing_value": "-999.0"
                                },
                                "OMEGA": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "OMEGA",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "Pa/s",
                                    "long_name": "Vertical pressure velocity",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "ntrn": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrn",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter N",
                                    "units": "unitless"
                                },
                                "ntrm": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrm",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter M",
                                    "units": "unitless"
                                },
                                "ntrk": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ntrk",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "spectral truncation parameter K",
                                    "units": "unitless"
                                },
                                "nsbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nsbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base day",
                                    "units": "s"
                                },
                                "nlons": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nlons",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "number of longitudes at each latitude",
                                    "units": "unitless"
                                },
                                "ndbase": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "ndbase",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base day for this case",
                                    "units": "unitless"
                                },
                                "nbsec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbsec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "seconds to complete base date",
                                    "units": "s"
                                },
                                "nbdate": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "nbdate",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "base date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless"
                                },
                                "mhisf": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mhisf",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "frequency of model writes (timesteps)",
                                    "units": "unitless"
                                },
                                "mdt": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "mdt",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999",
                                    "long_name": "model timestep",
                                    "units": "s"
                                },
                                "LWSH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LWSH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "m",
                                    "long_name": "Liquid water scale height",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "LHFLX": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "LHFLX",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Surface latent heat flux",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "init_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "init_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of initial data",
                                    "missing_value": "-999.0",
                                    "time": "07:27:58",
                                    "date": "02/06/98"
                                },
                                "gw": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "gw",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "missing_value": "-999.0",
                                    "long_name": "gauss weights",
                                    "units": "unitless"
                                },
                                "FSNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net solar flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNRTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNRTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNRTC",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRTSQ": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRTSQ",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRTSQ",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSNIRT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSNIRT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSNIRT",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FSDS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FSDS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/M2",
                                    "long_name": "FSDS",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNTC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNTC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at top",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNSC": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNSC",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Clearsky net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "FLNS": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "FLNS",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "W/m2",
                                    "long_name": "Net longwave flux at surface",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "first_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "first_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of first file for this case",
                                    "missing_value": "-999.0",
                                    "time": "08:52:49",
                                    "date": "07/23/99"
                                },
                                "datesec": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "datesec",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "seconds to complete current date",
                                    "units": "s",
                                    "missing_value": "-999"
                                },
                                "date": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "date",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "current date as 8 digit integer (YYYYMMDD)",
                                    "units": "unitless",
                                    "missing_value": "-999"
                                },
                                "current_mss": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "current_mss",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "MSS pathname of this file",
                                    "missing_value": "-999.0",
                                    "time": "11:48:34",
                                    "date": "07/23/99"
                                },
                                "CLDTOT": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDTOT",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, total cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDMED": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDMED",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, mid-level cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDLOW": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDLOW",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, low cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                },
                                "CLDHGH": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "CLDHGH",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "long_name": "Vertically-integrated, random overlap, high cloud amount",
                                    "time_op": "average",
                                    "missing_value": "-999.0"
                                }
                            },
                            "time_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "layer": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "layer",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "Pa",
                                "gridtype": "0",
                                "long_name": "pressure"
                            },
                            "nchar": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "nchar",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "nchar"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "calendar": "360",
                                "pointwidth": "1.0",
                                "standard_name": "time"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "long_name": "latitude"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "modulus": "360.0",
                                "pointwidth": "2.8125",
                                "long_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/CCM"
                        },
                        "COLA": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/COLA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "COLA",
                            "restriction": "requires dlauth tokens"
                        },
                        "ECHAM": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "ECHAM",
                            "restriction": "requires dlauth tokens"
                        },
                        "ECHAM4p5CliSST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5CliSST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnd10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnd10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter meridional wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter zonal wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "9"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "9"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter dewpoint",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "snowf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow fall",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "snowd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": " pascals",
                                        "cNZ": "9"
                                    },
                                    "sicef": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sicef",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "9"
                                    },
                                    "siced": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "siced",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "runoff",
                                        "cNZ": "9"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "9"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "out long wave radiation",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at toa",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": " watts/sq meter",
                                        "cNZ": "9"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "cNZ": "9"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "cNZ": "9"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "9"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "9"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "9"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "9"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "9"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "9"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    }
                                }
                            },
                            "DAILY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "DAILY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "K",
                                        "cNZ": "0"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "0"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": " pascals",
                                        "cNZ": "0"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "0"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "0"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "cNZ": "0"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity at 850 mb",
                                        "units": "s-1",
                                        "cNZ": "0"
                                    },
                                    "v925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 925 mb",
                                        "units": "m/s",
                                        "cNZ": "0"
                                    },
                                    "v300": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v300",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 300 mb",
                                        "units": "m/s",
                                        "cNZ": "0"
                                    },
                                    "u925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 925 mb",
                                        "units": "m/s",
                                        "cNZ": "0"
                                    },
                                    "u300": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u300",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 300 mb",
                                        "units": "m/s",
                                        "cNZ": "0"
                                    },
                                    "t850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 850 mb",
                                        "units": "K",
                                        "cNZ": "0"
                                    },
                                    "q925": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q925",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity at 925 mb ",
                                        "units": "kg/kg",
                                        "cNZ": "0"
                                    },
                                    "omega500": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega500",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity at 500 mb",
                                        "units": "pascals/s",
                                        "cNZ": "0"
                                    },
                                    "gz850": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz850",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 850 mb ",
                                        "units": "gpm",
                                        "cNZ": "0"
                                    },
                                    "gz300": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz300",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height at 300 mb ",
                                        "units": "gpm",
                                        "cNZ": "0"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1981-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "standard"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM4p5CliSST"
                        },
                        "ECHAM4p5_CFS_SST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5_CFS_SST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Saha_etal2006",
                                "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM4p5_CFS_SST/.MONTHLY.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnd10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnd10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter meridional wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter zonal wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter dewpoint",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "snowf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow fall",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "snowd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": " pascals",
                                        "cNZ": "17"
                                    },
                                    "sicef": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sicef",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "17"
                                    },
                                    "siced": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "siced",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "runoff",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "out long wave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": " watts/sq meter",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Lead time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Start time",
                                "calendar": "360"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM4p5_CFS_SST"
                        },
                        "ECHAM4p5_EC3_SST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM4p5_EC3_SST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM4p5_EC3_SST/.MONTHLY.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wnd10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wnd10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter meridional wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter zonal wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface meridional wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface zonal wind stress",
                                        "units": " newton m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter dewpoint",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2m",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "snowf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow fall",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "snowd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "snowd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea level pressure",
                                        "units": " pascals",
                                        "cNZ": "17"
                                    },
                                    "sicef": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sicef",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "17"
                                    },
                                    "siced": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "siced",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface sensible heat flux",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "runoff",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "mm",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "out long wave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface latent heat flux",
                                        "units": " watts/sq meter",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cloud cover",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "K",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Lead time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Start time",
                                "calendar": "360"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM4p5_EC3_SST"
                        },
                        "ECHAM5_CA_SST_GHG": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM5_CA_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_CA_SST_GHG/.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 m",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter v wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "uswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "ulwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ulwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "u10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter u wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "dew point temperature at 2 m",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "2 meter temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radation",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at top",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "laten heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evapration",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "cloud_area_fraction",
                                        "long_name": "cloud cover",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_mname": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Lead time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Start time",
                                "calendar": "360"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM5_CA_SST_GHG"
                        },
                        "ECHAM5_CFS_SST_GHG": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM5_CFS_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_CFS_SST_GHG/.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 m",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "v10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter v wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "uswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "ulwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ulwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "u10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter u wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "dew point temperature at 2 m",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "2 meter temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "9"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "9"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radation",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at top",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "laten heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evapration",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "cloud_area_fraction",
                                        "long_name": "cloud cover",
                                        "cNZ": "9"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "9"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "9"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_mname": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "9"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "9"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Lead time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Start time",
                                "calendar": "360"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM5_CFS_SST_GHG"
                        },
                        "ECHAM5_EC3_SST_GHG": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM5_EC3_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Roeckner_etal2006 Anderson_etal2006",
                                "dataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_EC3_SST_GHG/.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "long_name": "Forecast time",
                                    "pointwidth": "1.0",
                                    "units": "months since 1960-01-01",
                                    "standard_name": "time",
                                    "calendar": "360",
                                    "bounds": "S"
                                },
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 m",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "v10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter v wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "uswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "ulwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ulwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "u10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter u wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "dew point temperature at 2 m",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "2 meter temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "9"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "9"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radation",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at top",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "laten heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evapration",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "cloud_area_fraction",
                                        "long_name": "cloud cover",
                                        "cNZ": "9"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "9"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "9"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_mname": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "9"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "9"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "L": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "L",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Lead time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "S": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "S",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "0",
                                "long_name": "Start time",
                                "calendar": "360"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM5_EC3_SST_GHG"
                        },
                        "ECHAM5_OBS_SST_GHG": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM5_OBS_SST_GHG",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Roeckner_etal2006",
                                "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_OBS_SST_GHG/.MONTHLY.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter v wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "uswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "ulwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ulwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "u10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter u wind",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter minimum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "2 meter dew point temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "2 meter temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_longwave_flux",
                                        "long_name": "outgoing longwave radation",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at top",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "laten heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evapration",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM5_OBS_SST_GHG"
                        },
                        "ECHAM5_OBS_SST_GHG_REAL_TIME": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "ECHAM5_OBS_SST_GHG_REAL_TIME",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYECHAM5_OBS_SST_GHG": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_OBS_SST_GHG/.MONTHLY",
                                "MONTHLYreferences": "Roeckner_etal2006",
                                "MONTHLYdataset_documentationhtml": "http://iridl.ldeo.columbia.edu/SOURCES/.IRI/.MP/.RESEARCH/.ATMOSPHERE/.GLOBAL/.ECHAM5_OBS_SST_GHG_REAL_TIME/.MONTHLY.dataset_documentation.html",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "10 meter wind speed",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "v10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "10 meter v wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "uswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "uswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "ulwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ulwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "upward longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "u10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "10 meter u wind",
                                        "units": "m s-1",
                                        "cNZ": "9"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter minimum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "two meter maximum temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "dew_point_temperature",
                                        "long_name": "2 meter dew point temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "2 meter temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_temperature",
                                        "long_name": "surface temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_surface_snow_amount",
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_pressure_at_sea_level",
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "9"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "9"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "cNZ": "9"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_sensible_heat_flux",
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "lwe_thickness_of_precipitation_amount",
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_longwave_flux",
                                        "long_name": "outgoing longwave radation",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "toa_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at top",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_shortwave_flux",
                                        "long_name": "net shortwave at ground",
                                        "units": " W m-2",
                                        "cNZ": "9"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_net_downward_longwave_flux",
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "surface_downward_latent_heat_flux",
                                        "long_name": "laten heat flux",
                                        "units": "W m-2",
                                        "cNZ": "9"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "9"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evapration",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "9"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "cNZ": "9"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "9"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "9"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "northward_wind",
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "eastward_wind",
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "cNZ": "9"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "air_temperature",
                                        "long_name": "temperature",
                                        "units": "kelvin_scale",
                                        "cNZ": "9"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "9"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "cNZ": "9"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "specific_humidity",
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "9"
                                    },
                                    "omega": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omega",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "pascals/s",
                                        "cNZ": "9"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "standard_name": "geopotential",
                                        "long_name": "geopotential height",
                                        "units": "m2 s-2",
                                        "cNZ": "9"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "9"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/ECHAM5_OBS_SST_GHG_REAL_TIME"
                        },
                        "Lyon_ECHAM5_EAfrica_ClimoSST": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Lyon_ECHAM5_EAfrica_ClimoSST",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa s-1",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/Lyon_ECHAM5_EAfrica_ClimoSST"
                        },
                        "Lyon_ECHAM5_EAfrica_GlobalTropics": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Lyon_ECHAM5_EAfrica_GlobalTropics",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa s-1",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/Lyon_ECHAM5_EAfrica_GlobalTropics"
                        },
                        "Lyon_ECHAM5_EAfrica_TropAtlantic": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Lyon_ECHAM5_EAfrica_TropAtlantic",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa s-1",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/Lyon_ECHAM5_EAfrica_TropAtlantic"
                        },
                        "Lyon_ECHAM5_EAfrica_TropIndian": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Lyon_ECHAM5_EAfrica_TropIndian",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa s-1",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/Lyon_ECHAM5_EAfrica_TropIndian"
                        },
                        "Lyon_ECHAM5_EAfrica_TropPacific": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Lyon_ECHAM5_EAfrica_TropPacific",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "MONTHLYreferences": "Anderson_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "MONTHLY": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "MONTHLY",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Surface": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Surface",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "wind10": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "wind10",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "wind speed at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "v10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "u10m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u10m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind at 10 meters",
                                        "units": "m s-1",
                                        "cNZ": "17"
                                    },
                                    "tauy": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tauy",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "taux": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "taux",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind stress",
                                        "units": "N m-2",
                                        "cNZ": "17"
                                    },
                                    "t2mmin": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmin",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter minimum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2mmax": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2mmax",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "two meter maximum temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2md": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2md",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "dew point temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "t2m": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "t2m",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature at 2 meters",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "sw": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sw",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "soil wetness",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "stl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature of land",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "st": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "st",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "src": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "src",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "skin reservoir content",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "sni": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sni",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "water equivalent snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "slp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "mean sea level pressure",
                                        "units": "Pa",
                                        "cNZ": "17"
                                    },
                                    "slm": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "slm",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "land sea mask",
                                        "cNZ": "17"
                                    },
                                    "sice": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sice",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice fraction",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "sh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sensible heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "sf": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sf",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snowfall",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "sd": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "sd",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "snow depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "runoff": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "runoff",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface runoff",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "pwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "pwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitable water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precl": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precl",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "large scale precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "precc": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "precc",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "prec": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "prec",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total precipitation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "oro": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "oro",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "orography",
                                        "units": "m2 s-2",
                                        "cNZ": "17"
                                    },
                                    "olr": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "olr",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "outgoing longwave radiation",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at top",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nswg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nswg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net shortwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "nlwg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "nlwg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "net longwave at ground",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "lh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "lh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "latent heat flux",
                                        "units": "W m-2",
                                        "cNZ": "17"
                                    },
                                    "icedep": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "icedep",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "sea ice depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "glac": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "glac",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "glacier depth",
                                        "units": "m",
                                        "cNZ": "17"
                                    },
                                    "evap": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "evap",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "evaporation",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "drain": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "drain",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "drainage",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cwat": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cwat",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertically integrated cloud water",
                                        "units": "kg m-2 s-1",
                                        "cNZ": "17"
                                    },
                                    "cld": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "cld",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "cloud cover",
                                        "units": "fraction",
                                        "cNZ": "17"
                                    },
                                    "alb": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "alb",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "albedo",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    }
                                },
                                "PressureLevel": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "PressureLevel",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "vrt": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "vrt",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vorticity",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    },
                                    "velpot": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "velpot",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "velocity potential",
                                        "units": "m2 s-1",
                                        "cNZ": "17"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal velocity",
                                        "units": "m/s",
                                        "cNZ": "17"
                                    },
                                    "tmp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tmp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "temperature",
                                        "units": "Kelvin_scale",
                                        "cNZ": "17"
                                    },
                                    "stream": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "stream",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "stream function",
                                        "cNZ": "17"
                                    },
                                    "rh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "rh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "relative humidity",
                                        "units": "percentage",
                                        "cNZ": "17"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "specific humidity",
                                        "units": "kg/kg",
                                        "cNZ": "17"
                                    },
                                    "omg": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "omg",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "vertical pressure velocity",
                                        "units": "Pa s-1",
                                        "cNZ": "17"
                                    },
                                    "gz": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "gz",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "geopotential height",
                                        "units": "gpm",
                                        "cNZ": "17"
                                    },
                                    "div": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "div",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "divergence",
                                        "units": "s-1",
                                        "cNZ": "17"
                                    }
                                }
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "360"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/Lyon_ECHAM5_EAfrica_TropPacific"
                        },
                        "NUDGING": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/NUDGING",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "NUDGING",
                            "restriction": "requires dlauth tokens"
                        },
                        "VIGAUD_CAM5": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "VIGAUD_CAM5",
                            "restriction": "Public",
                            "amvSST": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "amvSST",
                                "restriction": "Public",
                                "amv_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_climo.D"
                                },
                                "amv_extrop_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_extrop_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "percent",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2 s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "J/m2",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "FieldType": "104",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_extrop_climo.D"
                                },
                                "amv_extrop_negD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_extrop_neg.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "FieldType": "104",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_extrop_neg.D"
                                },
                                "amv_extrop_posD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_extrop_pos.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "FieldType": "104",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_extrop_pos.D"
                                },
                                "amv_hist_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_hist_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "perturbed": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "perturbed",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "control": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "control",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "control": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "control",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "control": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "control",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "FieldType": "104",
                                                    "description": "Geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Meridional heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Meridional momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Zonal heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Zonal momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 850 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "M": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "M",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "gridtype": "0",
                                        "pointwidth": "1.0",
                                        "long_name": "Ensemble member"
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_climo.D"
                                },
                                "amv_hist_gogaD": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_goga.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "amv_hist_goga.D",
                                    "restriction": "Public",
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "D": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "01.D",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 850 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Z500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 500 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Z200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 200 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Lowest model level temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "850 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "200 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Lowest model level water vapor mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "850 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "200 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1930-01-01 12:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "pointwidth": "1",
                                            "long_name": "Time"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_goga.D/Daily"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "10m wind speed",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Maximum surface temperature over output period",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Minimum surface temperature over output period",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Surface temperature (radiative)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Reference height temperature",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Turbulent kinetic energy",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T equivalent of energy correction",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Meridional surface stress",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Zonal surface stress",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Shortwave cloud forcing",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Solar insolation",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface sensible heat flux",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "description": "Relative humidity",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "description": "Surface water flux",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Sea level pressure",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Surface pressure",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Shallow convection precipitation rate",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Surface geopotential",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection top pressure",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "description": "Convection base pressure",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "description": "PBL height",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Orography",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Longwave cloud forcing",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Surface latent heat flux",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling solar flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at top of the model",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated total cloud",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated low cloud",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Vertically integrated high cloud",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "FieldType": "104",
                                                    "missing_value": "9.96920997E36",
                                                    "MemoryOrder": "XY ",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional velocity squared",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional wind",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal velocity squared",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal wind",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Temperature",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Relative humidity",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Total water mixing ratio",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Specific humidity",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical heat flux",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical water transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical velocity (pressure)",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Convective cloud fraction",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Cloud fraction",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Geopotential",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional velocity squared",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional heat transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional water transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional momentum flux",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Meridional wind",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal velocity squared",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal heat transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal water transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal momentum flux",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Zonal wind",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Temperature",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Relative humidity",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Total water mixing ratio",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Specific humidity",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical heat flux",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical water transport",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Vertical velocity (pressure)",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Convective cloud fraction",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "description": "Cloud fraction",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "P_01": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P_01",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Sigma level"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure level"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "months since 1960-01-01",
                                            "gridtype": "0",
                                            "pointwidth": "1",
                                            "long_name": "Time",
                                            "calendar": "360"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_goga.D/Monthly"
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "Daily",
                                        "Monthly"
                                    ]
                                },
                                "amv_hist_negD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_hist_neg.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 850 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_neg.D"
                                },
                                "amv_hist_posD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_hist_pos.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 850 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_hist_pos.D"
                                },
                                "amv_neg_tnaD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_neg_tna.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_neg_tna.D"
                                },
                                "amv_pos_tnaD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_pos_tna.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_02": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_02",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_pos_tna.D"
                                },
                                "amv_trop_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_trop_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "FieldType": "104",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K.m/s",
                                                "FieldType": "104",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "FieldType": "104",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m2/s2",
                                                "FieldType": "104",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "FieldType": "104",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K s-1",
                                                "FieldType": "104",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "FieldType": "104",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "FieldType": "104",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "K Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "kg Pa s-1",
                                                "FieldType": "104",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa/s",
                                                "FieldType": "104",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "cloud_fraction",
                                                "FieldType": "104",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_trop_climo.D"
                                },
                                "amv_trop_negD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_trop_neg.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_trop_neg.D"
                                },
                                "amv_trop_posD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amv_trop_pos.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "U10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "10m wind speed",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Maximum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TSMN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TSMN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Minimum surface temperature over output period",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Surface temperature (radiative)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMXAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMXAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily maximum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFMNAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFMNAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Average of TREFHT daily minimum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TREFHT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TREFHT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Kelvin_scale",
                                                "description": "Reference height temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TMQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TMQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2",
                                                "description": "Total (vertically integrated) precipitable water",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Turbulent kinetic energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TFIX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TFIX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "K s-1",
                                                "description": "T equivalent of energy correction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Meridional surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TAUX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TAUX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Zonal surface stress",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Shortwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SOLIN": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SOLIN",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Solar insolation",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "percent",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "kg m-2 s-1",
                                                "description": "Surface water flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Surface pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Shallow convection precipitation rate",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convection snow rate (water equivalent)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECCZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECCZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate from ZM deep",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq+ice)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PHIS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PHIS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m2/s2",
                                                "description": "Surface geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection top pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PCONVB": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PCONVB",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "Pa",
                                                "description": "Convection base pressure",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "PBLH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PBLH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "m",
                                                "description": "PBL height",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ORO": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ORO",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Orography",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LWCF": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LWCF",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Longwave cloud forcing",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOAC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOAC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNTOA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNTOA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at top of atmosphere",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FSDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQZM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQZM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of ZM convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FREQSH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FREQSH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Fractional occurence of shallow convection",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLUT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLUT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Upwelling longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNTC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNTC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of the model",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNSC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNSC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Clearsky net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "FLDS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLDS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "W/m2",
                                                "description": "Downwelling longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDTOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDTOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated total cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDMED": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDMED",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated mid-level cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDLOW": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDLOW",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated low cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLDHGH": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLDHGH",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "unitless",
                                                "description": "Vertically integrated high cloud",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "ATMEINT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "ATMEINT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "MemoryOrder": "XY ",
                                                "units": "J/m2",
                                                "description": "Vertically integrated total atmospheric energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z3": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z3",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Meridional flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Meridional heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "VFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Meridional momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "V": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Meridional wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Zonal velocity squared",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K.m/s",
                                                "description": "Zonal heat transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "UFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Zonal momentum flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "U": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "TKE": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TKE",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m2/s2",
                                                "description": "Turbulence Kinetic Energy",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "T": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Temperature",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "SHDLFT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHDLFT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K s-1",
                                                "description": "T-tendency due to shallow convective detrainment",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "RELHUM": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "RELHUM",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Relative humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "QT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Total water mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "Q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAV": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAV",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of meridional momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAU": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAU",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Vertical flux of zonal momentum",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "K Pa s-1",
                                                "description": "Vertical heat flux",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGAQ": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGAQ",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "kg Pa s-1",
                                                "description": "Vertical water transport",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "OMEGA": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "OMEGA",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa/s",
                                                "description": "Vertical velocity (pressure)",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CONCLD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CONCLD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Convective cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            },
                                            "CLOUD": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "CLOUD",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "cloud_fraction",
                                                "description": "Cloud fraction",
                                                "missing_value": "9.96920997E36",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Z500": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z500",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 500 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Z200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m",
                                            "description": "Geopotential Z at 200 mbar pressure surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "VBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "VBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "V200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "V200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "UBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "UBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Lowest model level zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "850 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "U200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "U200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "200 mb zonal wind",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "TBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "Lowest model level temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "850 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "T200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Kelvin_scale",
                                            "description": "200 mb temperature",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "SHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Surface sensible heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "QBOT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "QBOT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "Lowest model level water vapor mixing ratio",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q850": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q850",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "850 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "Q200": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Q200",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "unitless",
                                            "description": "200 mb specific humidity",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PSL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PSL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "Pa",
                                            "description": "Sea level pressure",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "PRECC": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PRECC",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "m s-1",
                                            "description": "Convective precipitation rate (liq + ice)",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "LHFLX": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "LHFLX",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Surface latent heat flux",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FSNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FSNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net solar flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNT": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNT",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at top of model",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        },
                                        "FLNS": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "FLNS",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "FieldType": "104",
                                            "MemoryOrder": "XY ",
                                            "units": "W/m2",
                                            "description": "Net longwave flux at surface",
                                            "missing_value": "9.96920997E36",
                                            "pointwidth": "0"
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/amvSST/amv_trop_pos.D"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "amv_climoD",
                                    "amv_extrop_climoD",
                                    "amv_extrop_negD",
                                    "amv_extrop_posD",
                                    "amv_hist_climoD",
                                    "amv_hist_gogaD",
                                    "amv_hist_negD",
                                    "amv_hist_posD",
                                    "amv_neg_tnaD",
                                    "amv_pos_tnaD",
                                    "amv_trop_climoD",
                                    "amv_trop_negD",
                                    "amv_trop_posD"
                                ]
                            },
                            "biasSST": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "biasSST",
                                "restriction": "Public",
                                "GOGA_histD": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/GOGA_hist.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "GOGA_hist.D",
                                    "restriction": "Public",
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "D": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "01.D",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 850 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Z500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 500 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Z200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 200 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "VBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "V850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "V200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "UBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "U850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "U200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Lowest model level temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "T850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "850 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "T200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "200 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Lowest model level water vapor mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "850 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "200 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of model",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1930-01-01 12:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "pointwidth": "1",
                                            "long_name": "Time"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/GOGA_hist.D/Daily"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "MemoryOrder": "XY ",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "description": "Geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "description": "Meridional heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Meridional momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "description": "Zonal heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Zonal momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "P_01": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P_01",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Sigma level"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure level"
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "months since 1960-01-01",
                                            "gridtype": "0",
                                            "pointwidth": "1",
                                            "long_name": "Time",
                                            "calendar": "360"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/GOGA_hist.D/Monthly"
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "Daily",
                                        "Monthly"
                                    ]
                                },
                                "SST_forcings": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/SST_forcings",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "SST_forcings",
                                    "restriction": "Public",
                                    "Hist_19792005": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/SST_forcings/Hist_1979-2005",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "Hist_1979-2005",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "Proj_20402059": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/SST_forcings/Proj_2040-2059",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "Proj_2040-2059",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "Proj_20802099": {
                                        "iridl_type": "Source",
                                        "invalid": [],
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/SST_forcings/Proj_2080-2099",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "iridl_ds_name": "Proj_2080-2099",
                                        "restriction": "Public",
                                        "banned_long": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ]
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "Hist_19792005",
                                        "Proj_20402059",
                                        "Proj_20802099"
                                    ]
                                },
                                "biasSST_histD": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/biasSST_hist.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "biasSST_hist.D",
                                    "restriction": "Public",
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "D": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "01.D",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 850 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Z500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 500 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Z200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m",
                                                "description": "Geopotential Z at 200 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "VBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "V850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "V200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "UBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "U850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "U200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "TBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "Lowest model level temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "T850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "850 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "T200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Kelvin_scale",
                                                "description": "200 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "QBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "Lowest model level water vapor mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "850 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "Q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "unitless",
                                                "description": "200 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "Pa",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "m s-1",
                                                "description": "Convective precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at top of model",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "FieldType": "104",
                                                "units": "W/m2",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "MemoryOrder": "XY ",
                                                "pointwidth": "0"
                                            }
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1930-01-01 12:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "pointwidth": "1",
                                            "long_name": "Time"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/biasSST_hist.D/Daily"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Kelvin_scale",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "kg m-2",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m2/s2",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "K s-1",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "percent",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "kg m-2 s-1",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m/s",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m2/s2",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "Pa",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "m",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "W/m2",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "unitless",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "MemoryOrder": "XY ",
                                                    "units": "J/m2",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "description": "Geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "description": "Meridional heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Meridional momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "description": "Zonal heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Zonal momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m/s",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "P_01": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P_01",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Sigma level"
                                        },
                                        "P": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "P",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure level"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "Time": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Time",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "months since 1960-01-01",
                                            "gridtype": "0",
                                            "pointwidth": "1",
                                            "long_name": "Time",
                                            "calendar": "360"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "1",
                                            "pointwidth": "2.8125",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/biasSST_hist.D/Monthly"
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "Daily",
                                        "Monthly"
                                    ]
                                },
                                "biasSST_proj_4059D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_4059.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "MemoryOrder": "XY ",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "FieldType": "104",
                                                    "description": "Geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Meridional heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Meridional momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Zonal heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Zonal momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "D": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "01.D",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 850 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Z500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 500 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Z200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 200 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level water vapor mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "MemoryOrder": "XY ",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Convective precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at top of model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/biasSST_proj_4059.D"
                                },
                                "biasSST_proj_8099D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_8099.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NC_GLOBAL": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NC_GLOBAL",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Conventions": "IRIDL"
                                    },
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "U10": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U10",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "10m wind speed",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Maximum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TSMN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TSMN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Minimum surface temperature over output period",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface temperature (radiative)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMXAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMXAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily maximum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFMNAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFMNAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Average of TREFHT daily minimum",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TREFHT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TREFHT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Reference height temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TMQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TMQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (vertically integrated) precipitable water",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Turbulent kinetic energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TFIX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TFIX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "T equivalent of energy correction",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUY": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUY",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Meridional surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "TAUX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TAUX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Zonal surface stress",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shortwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SOLIN": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SOLIN",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Solar insolation",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "SHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface sensible heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "percent",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "QFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg m-2 s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface water flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Sea level pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Total (convective and large-scale) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Shallow convection precipitation rate",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection snow rate (water equivalent)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECL": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECL",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Large-scale (stable) precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECCZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECCZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate from ZM deep",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PRECC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PRECC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convective precipitation rate (liq+ice)",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PHIS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PHIS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection top pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PCONVB": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PCONVB",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Convection base pressure",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "PBLH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "PBLH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "MemoryOrder": "XY ",
                                                    "description": "PBL height",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ORO": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ORO",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Orography",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LWCF": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LWCF",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Longwave cloud forcing",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "LHFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "LHFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Surface latent heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOAC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOAC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNTOA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNTOA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at top of atmosphere",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FSDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FSDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling solar flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQZM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQZM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of ZM convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FREQSH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FREQSH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Fractional occurence of shallow convection",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLUT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLUT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Upwelling longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNTC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNTC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at top of the model",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNSC": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNSC",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Clearsky net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLNS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLNS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Net longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "FLDS": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "FLDS",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Downwelling longwave flux at surface",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDTOT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDTOT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDMED": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDMED",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated mid-level cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDLOW": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDLOW",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated low cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "CLDHGH": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLDHGH",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated high cloud",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                },
                                                "ATMEINT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ATMEINT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "J/m2",
                                                    "MemoryOrder": "XY ",
                                                    "description": "Vertically integrated total atmospheric energy",
                                                    "missing_value": "9.96920997E36",
                                                    "FieldType": "104",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Sigmalevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Sigmalevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "D": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "01.D",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Z3": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Z3",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m",
                                                    "FieldType": "104",
                                                    "description": "Geopotential",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Meridional flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Meridional heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "VFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "VFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Meridional momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "V": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "V",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Meridional wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Zonal velocity squared",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K.m/s",
                                                    "FieldType": "104",
                                                    "description": "Zonal heat transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "UFLX": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "UFLX",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Zonal momentum flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "U": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "U",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m s-1",
                                                    "FieldType": "104",
                                                    "description": "Zonal wind",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "TKE": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "TKE",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "m2/s2",
                                                    "FieldType": "104",
                                                    "description": "Turbulence Kinetic Energy",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "FieldType": "104",
                                                    "description": "Temperature",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "SHDLFT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "SHDLFT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K s-1",
                                                    "FieldType": "104",
                                                    "description": "T-tendency due to shallow convective detrainment",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "RELHUM": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "RELHUM",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Relative humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "QT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "QT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Total water mixing ratio",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "Q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "unitless",
                                                    "FieldType": "104",
                                                    "description": "Specific humidity",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAV": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAV",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of meridional momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAU": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAU",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "W/m2",
                                                    "FieldType": "104",
                                                    "description": "Vertical flux of zonal momentum",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAT": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAT",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "K Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical heat flux",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGAQ": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGAQ",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "kg Pa s-1",
                                                    "FieldType": "104",
                                                    "description": "Vertical water transport",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "OMEGA": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "OMEGA",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Pa/s",
                                                    "FieldType": "104",
                                                    "description": "Vertical velocity (pressure)",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CONCLD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CONCLD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Convective cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                },
                                                "CLOUD": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "CLOUD",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "cloud_fraction",
                                                    "FieldType": "104",
                                                    "description": "Cloud fraction",
                                                    "missing_value": "9.96920997E36",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "D": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "01.D",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Z850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 850 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Z500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 500 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Z200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Z200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m",
                                                "MemoryOrder": "XY ",
                                                "description": "Geopotential Z at 200 mbar pressure surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "VBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "VBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "V200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "V200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "UBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "UBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "U200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "U200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb zonal wind",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "TBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "TBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "T200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "T200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Kelvin_scale",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb temperature",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "SHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface sensible heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "QBOT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "QBOT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "Lowest model level water vapor mixing ratio",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "850 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "Q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "Q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "MemoryOrder": "XY ",
                                                "description": "200 mb specific humidity",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PSL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PSL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "Pa",
                                                "MemoryOrder": "XY ",
                                                "description": "Sea level pressure",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECL": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECL",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Large-scale (stable) precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "PRECC": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "PRECC",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "m s-1",
                                                "MemoryOrder": "XY ",
                                                "description": "Convective precipitation rate (liq + ice)",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "LHFLX": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "LHFLX",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Surface latent heat flux",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FSNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FSNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net solar flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNT": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNT",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at top of model",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            },
                                            "FLNS": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "FLNS",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "W/m2",
                                                "MemoryOrder": "XY ",
                                                "description": "Net longwave flux at surface",
                                                "missing_value": "9.96920997E36",
                                                "FieldType": "104",
                                                "pointwidth": "0"
                                            }
                                        }
                                    },
                                    "P_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Sigma level"
                                    },
                                    "P": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "P",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "mb",
                                        "gridtype": "0",
                                        "long_name": "Pressure level"
                                    },
                                    "Time_01": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time_01",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "months since 1960-01-01",
                                        "gridtype": "0",
                                        "pointwidth": "1",
                                        "long_name": "Time",
                                        "calendar": "360"
                                    },
                                    "Y": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Y",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_north",
                                        "gridtype": "0",
                                        "standard_name": "latitude"
                                    },
                                    "Time": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Time",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "days since 1930-01-01 12:00:00",
                                        "gridtype": "0",
                                        "calendar": "standard",
                                        "pointwidth": "1",
                                        "long_name": "Time"
                                    },
                                    "X": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "X",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "degree_east",
                                        "gridtype": "1",
                                        "pointwidth": "2.8125",
                                        "standard_name": "longitude"
                                    },
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_CAM5/biasSST/biasSST_proj_8099.D"
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "GOGA_histD",
                                    "SST_forcings",
                                    "biasSST_histD",
                                    "biasSST_proj_4059D",
                                    "biasSST_proj_8099D"
                                ]
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "amvSST",
                                "biasSST"
                            ]
                        },
                        "VIGAUD_ECHAM5": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "VIGAUD_ECHAM5",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "EAfrSSTEAfr_rgogaDMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_rgogaDDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_rgogaDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_PWP4DMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_PWP4DDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_PWP4DDailyPressurelevelreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_OBSDMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_OBSDDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_OBSDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_IWP4DMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_IWP4DDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_hist_IWP4DDailyPressurelevelreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_gogaDMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_gogaDDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_gogaDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_climoDMonthlyreferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_climoDDailySurfacereferences": "Roeckner_etal2006",
                                "EAfrSSTEAfr_climoDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTGOGA_histDMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTGOGA_histDDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTGOGA_histDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099_SST_changeDMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099_SST_changeDDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099_SST_changeDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099DMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099DDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_8099DDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059_SST_changeDMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059_SST_changeDDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059_SST_changeDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059DMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059DDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_proj_4059DDailyPressurelevelreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_histDMonthlyreferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_histDDailySurfacereferences": "Roeckner_etal2006",
                                "biasSSTbiasSST_histDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_pos_tna_dlsanDMonthlyreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_pos_tna_dlsanDDailySurfacereferences": "Roeckner_etal2006",
                                "amvSSTamvSST_pos_tna_dlsanDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_posDMonthlyreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_posDDailySurfacereferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_posDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_negDMonthlyreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_negDDailySurfacereferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_negDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_gogaDMonthlyreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_gogaDDailySurfacereferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_gogaDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_climoDMonthlyreferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_climoDDailySurfacereferences": "Roeckner_etal2006",
                                "amvSSTamvSST_hist_climoDDailyPressurelevelreferences": "Roeckner_etal2006",
                                "Conventions": "IRIDL"
                            },
                            "EAfrSST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "EAfrSST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "EAfr_rgogaD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_rgoga.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "EAfr_hist_PWP4D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_hist_PWP4.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "EAfr_hist_OBSD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_hist_OBS.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "EAfr_hist_IWP4D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_hist_IWP4.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "EAfr_gogaD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_goga.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "EAfr_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "EAfr_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                }
                            },
                            "biasSST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "biasSST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SST_forcings": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "SST_forcings",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Proj_20802099": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Proj_2080-2099",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SST_proj_change": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_proj_change",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "grid_type": "gaussian",
                                                "long_name": "BCS Pseudo SST"
                                            }
                                        },
                                        "SST_proj": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_proj",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "grid_type": "gaussian",
                                                "long_name": "BCS Pseudo SST"
                                            }
                                        },
                                        "SST_change_20802099": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_change_2080-2099",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "delta_SST": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "delta_SST",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ACCESS1-3_rcp85_r0i0p0.nc areacella: areacella_fx_ACCESS1-3_rcp85_r0i0p0.nc",
                                                "comment": " temperature (i.e., SST for open ocean)",
                                                "pointwidth": "1.0",
                                                "expires": "1554163200",
                                                "long_name": "Surface Temperature",
                                                "dodsname": "ts",
                                                "standard_name": "surface_temperature",
                                                "file_missing_value": "1.00000002E20",
                                                "grid_type": "gaussian",
                                                "units": "degree_Celsius",
                                                "cell_methods": "time: mean",
                                                "missing_value": "NaN"
                                            }
                                        },
                                        "ERSST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERSST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "long_name": "BCS Pseudo SST",
                                                "grid_type": "gaussian"
                                            }
                                        },
                                        "CMIP5_Bias_20802099": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CMIP5_Bias_2080-2099",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "bias": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "bias",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "grid_type": "gaussian",
                                                "history": "[[(mean [ ( { [ Tproj_climo_2080-2099.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * (   mean   mean { [ ( { [ Tproj_climo_2080-2099.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * cosd ] / 0.843 }     /   mean { [ ( { [ Tproj_climo_2080-2099.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * cosd ] / 0.843 }   ) ]) [[(mean   mean [ ( { [ ( Tproj_climo_2080-2099.nc T_proj ) - ( Tcmip_1979-2005.nc T_hist ) ] *   masklt [   flaglt ( { WORLDBATH bath } , 0 )   , 1 ]   } * cosd ) / 0.843 ]  ) [(Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present) (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(mean [ ( { [ ( Tproj_climo_2080-2099.nc T_proj ) - ( Tcmip_1979-2005.nc T_hist ) ] *   masklt [   flaglt ( { WORLDBATH bath } , 0 )   , 1 ]   } * cosd ) / 0.843 ]) (Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present)] (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(/beluga/data/Web/blyon/iri_html/NSF_SST_BIAS SST_Bias_Forcing MMM_Adj_SST_Bias.nc MMM_Adj_SST_Bias) ([[(mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(mean [ (   mean { [ Tcmip_1979-2005.nc T_hist ] - [ NOAA NCDC ERSST version4 sst 0.0 meters ( climatology + 273.15 ) ] }   * cosd ) / 0.85339 ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(Averaged over Model[0.5, 31.5] minimum 0.0% data present)] (Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present)]]])]]",
                                                "missing_value": "NaN",
                                                "expires": "1538438400"
                                            }
                                        }
                                    },
                                    "Proj_20402059": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Proj_2040-2059",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SST_proj_change": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_proj_change",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "grid_type": "gaussian",
                                                "long_name": "BCS Pseudo SST"
                                            }
                                        },
                                        "SST_proj": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_proj",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "grid_type": "gaussian",
                                                "long_name": "BCS Pseudo SST"
                                            }
                                        },
                                        "SST_change_20402059": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_change_2040-2059",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "delta_SST": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "delta_SST",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "associated_files": "baseURL: http://cmip-pcmdi.llnl.gov/CMIP5/dataLocation gridspecFile: gridspec_atmos_fx_ACCESS1-3_rcp85_r0i0p0.nc areacella: areacella_fx_ACCESS1-3_rcp85_r0i0p0.nc",
                                                "comment": " temperature (i.e., SST for open ocean)",
                                                "pointwidth": "1.0",
                                                "expires": "1554163200",
                                                "long_name": "Surface Temperature",
                                                "dodsname": "ts",
                                                "standard_name": "surface_temperature",
                                                "file_missing_value": "1.00000002E20",
                                                "grid_type": "gaussian",
                                                "units": "degree_Celsius",
                                                "cell_methods": "time: mean",
                                                "missing_value": "NaN"
                                            }
                                        },
                                        "ERSST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERSST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "long_name": "BCS Pseudo SST",
                                                "grid_type": "gaussian"
                                            }
                                        },
                                        "CMIP5_Bias_20402059": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CMIP5_Bias_2040-2059",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "bias": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "bias",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless",
                                                "grid_type": "gaussian",
                                                "history": "[[(mean [ ( { [ Tproj_climo_2040-2059.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * (   mean   mean { [ ( { [ Tproj_climo_2040-2059.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * cosd ] / 0.843 }     /   mean { [ ( { [ Tproj_climo_2040-2059.nc T_proj ] - [ Tcmip_1979-2005.nc T_hist ] } *   masklt {   flaglt [ ( WORLDBATH bath ) , 0 ]   , 1 }   ) * cosd ] / 0.843 }   ) ]) [[(mean   mean [ ( { [ ( Tproj_climo_2040-2059.nc T_proj ) - ( Tcmip_1979-2005.nc T_hist ) ] *   masklt [   flaglt ( { WORLDBATH bath } , 0 )   , 1 ]   } * cosd ) / 0.843 ]  ) [(Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present) (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(mean [ ( { [ ( Tproj_climo_2040-2059.nc T_proj ) - ( Tcmip_1979-2005.nc T_hist ) ] *   masklt [   flaglt ( { WORLDBATH bath } , 0 )   , 1 ]   } * cosd ) / 0.843 ]) (Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present)] (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(/beluga/data/Web/blyon/iri_html/NSF_SST_BIAS SST_Bias_Forcing MMM_Adj_SST_Bias.nc MMM_Adj_SST_Bias) ([[(mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(mean [ (   mean { [ Tcmip_1979-2005.nc T_hist ] - [ NOAA NCDC ERSST version4 sst 0.0 meters ( climatology + 273.15 ) ] }   * cosd ) / 0.85339 ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(Averaged over Model[0.5, 31.5] minimum 0.0% data present)] (Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present)]]])]]",
                                                "missing_value": "NaN",
                                                "expires": "1538438400"
                                            }
                                        }
                                    },
                                    "Hist_19792005": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Hist_1979-2005",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "SST_hist": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SST_hist",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "grid_type": "gaussian",
                                                "long_name": "BCS Pseudo SST"
                                            }
                                        },
                                        "ERSST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ERSST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SST_cpl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SST_cpl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "degree_Celsius",
                                                "long_name": "BCS Pseudo SST",
                                                "grid_type": "gaussian"
                                            }
                                        },
                                        "CMIP5_Bias_19792005": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CMIP5_Bias_1979-2005",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MMM_Adj_SST_Bias": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "MMM_Adj_SST_Bias",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "colormap": "[None 12632256 8388608 [16711680 66] [16760576 43] [15453831 16] 13959039 [13959039 7] 64636 [65535 4] [36095 24] [255 31] [128 60] [128 7] 2763429]",
                                                "long_name": "MMM_Adj_SST_Bias",
                                                "missing_value": "NaN",
                                                "grid_type": "gaussian",
                                                "colorscalename": "sstacolorscale",
                                                "expires": "1538438400",
                                                "scale_min": "-4.1999998",
                                                "units": "unitless",
                                                "CE": "4.1999998",
                                                "maxncolor": "254",
                                                "ncolor": "254",
                                                "scale_max": "4.1999998",
                                                "history": "[[(mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (Averaged over Model[0.5, 31.5] minimum 0.0% data present)]] [(mean [ (   mean { [ Tcmip_1979-2005.nc T_hist ] - [ NOAA NCDC ERSST version4 sst 0.0 meters ( climatology + 273.15 ) ] }   * cosd ) / 0.85339 ]) [(NOAA NCDC ERSST version4 sst 0.0 meters [ climatology + 273.15 ]) [(Boxes with less than 0.0% dropped) (Averaged over T2[1979, 2005] minimum 0.0% data present)] (mean [ ( Tcmip_1979-2005.nc T_hist ) - ( NOAA NCDC ERSST version4 sst 0.0 meters { climatology + 273.15 } ) ]) [(Averaged over Model[0.5, 31.5] minimum 0.0% data present)] (Averaged over X[1W, 1W] Y[55S, 55N] minimum 0.0% data present)]]]",
                                                "CS": "-4.1999998"
                                            }
                                        }
                                    }
                                },
                                "GOGA_histD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "GOGA_hist.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "biasSST_proj_8099_SST_changeD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_8099_SST_change.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "biasSST_proj_8099D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_8099.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "biasSST_proj_4059_SST_changeD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_4059_SST_change.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "biasSST_proj_4059D": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_proj_4059.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "biasSST_histD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "biasSST_hist.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                }
                            },
                            "amvSST": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "amvSST",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "amvSST_pos_tna_dlsanD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amvSST_pos_tna_dlsan.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "amvSST_hist_posD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amvSST_hist_pos.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "amvSST_hist_negD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amvSST_hist_neg.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "amvSST_hist_gogaD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amvSST_hist_goga.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                },
                                "amvSST_hist_climoD": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "amvSST_hist_climo.D",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Monthly": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Monthly",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "wind10": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "wind10",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "10 meter wind speed",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "17"
                                            },
                                            "tauy": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tauy",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "meridional wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "taux": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "taux",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "zonal wind stress",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "src": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "src",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "skin reservoir content",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "sni": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sni",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_surface_snow_amount",
                                                "long_name": "water equivalent snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "17"
                                            },
                                            "slm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land sea mask",
                                                "cNZ": "17"
                                            },
                                            "sice": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sice",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "17"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "sf": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sf",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "pwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "precipitable water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "large scale precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "precc": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "precc",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "convective precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "oro": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "oro",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "orography",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at top",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "17"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "17"
                                            },
                                            "icedep": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "icedep",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "glac": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "glac",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "glacier depth",
                                                "units": "m",
                                                "cNZ": "17"
                                            },
                                            "evap": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "evap",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "evapration",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "drain": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "drain",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "drainage",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cwat": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cwat",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertically integrated cloud water",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "17"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "17"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "17"
                                            }
                                        },
                                        "PressureLevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "PressureLevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vorticity",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            },
                                            "velpot": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "velpot",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "velocity potential",
                                                "units": "m2 s-1",
                                                "cNZ": "17"
                                            },
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind",
                                                "units": "m/s",
                                                "cNZ": "17"
                                            },
                                            "tmp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "tmp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "17"
                                            },
                                            "stream": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stream",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "stream function",
                                                "cNZ": "17"
                                            },
                                            "rh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "relative humidity",
                                                "cNZ": "17"
                                            },
                                            "q": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity",
                                                "units": "kg/kg",
                                                "cNZ": "17"
                                            },
                                            "omg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascals/s",
                                                "cNZ": "17"
                                            },
                                            "gz": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height",
                                                "units": "m2 s-2",
                                                "cNZ": "17"
                                            },
                                            "div": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "div",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "divergence",
                                                "units": "s-1",
                                                "cNZ": "17"
                                            }
                                        }
                                    },
                                    "Daily": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "Daily",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "Surface": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Surface",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "10 meter v wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "u10m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u10m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "10 meter u wind",
                                                "units": "m s-1",
                                                "cNZ": "0"
                                            },
                                            "t2mmin": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmin",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter minimum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2mmax": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2mmax",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "two meter maximum temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2md": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2md",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "dew_point_temperature",
                                                "long_name": "2 meter dew point temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t2m": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t2m",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "2 meter temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "sw": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sw",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "soil wetness",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "stl": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "stl",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "land surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "st": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "st",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_temperature",
                                                "long_name": "surface temperature",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "slp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "slp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_pressure_at_sea_level",
                                                "long_name": "mean sea level pressure",
                                                "units": "Pa",
                                                "cNZ": "0"
                                            },
                                            "sh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_sensible_heat_flux",
                                                "long_name": "sensible heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "sfall": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sfall",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snowfall",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "seaicef": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaicef",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice fraction",
                                                "cNZ": "0"
                                            },
                                            "seaiced": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "seaiced",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "sea ice depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "sd": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "sd",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "snow depth",
                                                "units": "m",
                                                "cNZ": "0"
                                            },
                                            "runoff": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "runoff",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "surface runoff",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "prec": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "prec",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "lwe_thickness_of_precipitation_amount",
                                                "long_name": "total precipitation",
                                                "units": "kg m-2 s-1",
                                                "cNZ": "0"
                                            },
                                            "olr": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "olr",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "toa_net_downward_longwave_flux",
                                                "long_name": "outgoing longwave radation",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nswg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nswg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_shortwave_flux",
                                                "long_name": "net shortwave at ground",
                                                "units": " W m-2",
                                                "cNZ": "0"
                                            },
                                            "nlwg": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "nlwg",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_net_downward_longwave_flux",
                                                "long_name": "net longwave at ground",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "lh": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "lh",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "surface_downward_latent_heat_flux",
                                                "long_name": "laten heat flux",
                                                "units": "W m-2",
                                                "cNZ": "0"
                                            },
                                            "cld": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "cld",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "cloud cover",
                                                "cNZ": "0"
                                            },
                                            "alb": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "alb",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "albedo",
                                                "units": "percentage",
                                                "cNZ": "0"
                                            }
                                        },
                                        "Pressurelevel": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Pressurelevel",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "vrt850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "vrt850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "vorticity",
                                                "long_name": "vorticity at 850 mb",
                                                "units": "s-2",
                                                "cNZ": "0"
                                            },
                                            "v925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "v1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "northward_wind",
                                                "long_name": "meridional wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 925 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 850 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 700 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 600 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 500 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 400 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 300 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 200 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "u1000": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u1000",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "eastward_wind",
                                                "long_name": "zonal wind at 1000 mb",
                                                "units": "m/s",
                                                "cNZ": "0"
                                            },
                                            "t850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 850 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 700 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 500 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "t300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "t300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "air_temperature",
                                                "long_name": "temperature at 300 mb",
                                                "units": "kelvin_scale",
                                                "cNZ": "0"
                                            },
                                            "q925": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q925",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 925 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 850 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 700 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q600": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q600",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 600 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 500 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q400": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q400",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 400 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "q200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "q200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "specific_humidity",
                                                "long_name": "specific humidity at 200 mb",
                                                "units": "kg/kg",
                                                "cNZ": "0"
                                            },
                                            "omg500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "omg500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "long_name": "vertical pressure velocity",
                                                "units": "pascal/s",
                                                "cNZ": "0"
                                            },
                                            "gz850": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz850",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 850 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz700": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz700",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 700 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz500": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz500",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 500 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz300": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz300",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 300 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            },
                                            "gz200": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "gz200",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "standard_name": "geopotential",
                                                "long_name": "geopotential height at 200 mb",
                                                "units": "m2 s-2",
                                                "cNZ": "0"
                                            }
                                        }
                                    }
                                }
                            },
                            "T_09": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_09",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "T_08": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_08",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1971-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "standard"
                            },
                            "time_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1870-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "365_day",
                                "standard_name": "time"
                            },
                            "time": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "time",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1870-01-01 00:00:00",
                                "gridtype": "0",
                                "calendar": "365_day",
                                "standard_name": "time"
                            },
                            "T_07": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_07",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "calendar": "360_day",
                                "standard_name": "time"
                            },
                            "lat": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lat",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "axis": "Y",
                                "long_name": "latitude",
                                "standard_name": "latitude"
                            },
                            "lon": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "lon",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "axis": "X",
                                "long_name": "longitude",
                                "standard_name": "longitude",
                                "modulus": "360.0",
                                "pointwidth": "2.8125"
                            },
                            "T_06": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_06",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "T_05": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_05",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "T_04": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_04",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1949-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "standard"
                            },
                            "T_03": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_03",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "T_02": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_02",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1949-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "standard"
                            },
                            "P": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "P",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "mb",
                                "gridtype": "0",
                                "long_name": "Pressure level"
                            },
                            "T_01": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T_01",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "months since 1960-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "calendar": "360",
                                "long_name": "Time"
                            },
                            "T": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "T",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "days since 1949-01-01",
                                "gridtype": "0",
                                "pointwidth": "1",
                                "standard_name": "time",
                                "long_name": "Time",
                                "calendar": "standard"
                            },
                            "Y": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "Y",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_north",
                                "gridtype": "0",
                                "standard_name": "latitude"
                            },
                            "M": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "M",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "unitless",
                                "gridtype": "0",
                                "pointwidth": "1.0",
                                "long_name": "Ensemble member"
                            },
                            "X": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "X",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "units": "degree_east",
                                "gridtype": "1",
                                "pointwidth": "2.8125",
                                "standard_name": "longitude"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/GLOBAL/VIGAUD_ECHAM5"
                        },
                        "banned_long": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type",
                            "CAM3_CA_SST_GHG",
                            "CAM3_CFS_SST_GHG",
                            "CAM3_EC3_SST_GHG",
                            "CAM3_OBS_SST_GHG",
                            "CCM",
                            "COLA",
                            "ECHAM",
                            "ECHAM4p5CliSST",
                            "ECHAM4p5_CFS_SST",
                            "ECHAM4p5_EC3_SST",
                            "ECHAM5_CA_SST_GHG",
                            "ECHAM5_CFS_SST_GHG",
                            "ECHAM5_EC3_SST_GHG",
                            "ECHAM5_OBS_SST_GHG",
                            "ECHAM5_OBS_SST_GHG_REAL_TIME",
                            "Lyon_ECHAM5_EAfrica_ClimoSST",
                            "Lyon_ECHAM5_EAfrica_GlobalTropics",
                            "Lyon_ECHAM5_EAfrica_TropAtlantic",
                            "Lyon_ECHAM5_EAfrica_TropIndian",
                            "Lyon_ECHAM5_EAfrica_TropPacific",
                            "NUDGING",
                            "VIGAUD_CAM5",
                            "VIGAUD_ECHAM5"
                        ]
                    },
                    "REGIONAL": {
                        "iridl_type": "Source",
                        "invalid": [],
                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL",
                        "banned": [
                            "dir",
                            "invalid",
                            "parent",
                            "name",
                            "banned",
                            "banned_long",
                            "iridl_ds_name",
                            "iridl_type"
                        ],
                        "iridl_ds_name": "REGIONAL",
                        "restriction": "Public",
                        "Brazil": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "Brazil",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "Conventions": "IRIDL"
                            },
                            "RSM": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "RegCM2": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RegCM2",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ]
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/Brazil"
                        },
                        "East_Africa": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/East_Africa",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "East_Africa",
                            "restriction": "requires dlauth tokens"
                        },
                        "GHA": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "GHA",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "long_name": "Greater Horn of Africa",
                                "description": "Greater Horn of Africa",
                                "Conventions": "IRIDL"
                            },
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/GHA"
                        },
                        "NorthWest_Pacific": {
                            "iridl_type": "Source",
                            "invalid": [],
                            "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "iridl_ds_name": "NorthWest_Pacific",
                            "restriction": "Public",
                            "RSM": {
                                "iridl_type": "Source",
                                "invalid": [],
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "iridl_ds_name": "RSM",
                                "restriction": "Public",
                                "y1994": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1994",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "y1994",
                                    "restriction": "Public",
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "w": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "w",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "temp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "spres": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "spres",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface pressure",
                                            "units": "mb",
                                            "missing_value": "NaN"
                                        },
                                        "q": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "q",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "humidity",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "gh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "units": "gpm",
                                            "missing_value": "NaN"
                                        },
                                        "geshem": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geshem",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "preciptation",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "bengsh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bengsh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "convective precipitation",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "Z_01": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z_01",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure"
                                        },
                                        "Z": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1994-06-01 00:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "pointwidth": "0.25",
                                            "standard_name": "time"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "gridtype": "0",
                                            "pointwidth": "1.0"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "0",
                                            "pointwidth": "0.487",
                                            "standard_name": "longitude"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1994/PressureLevel"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "ZORL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZORL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface roughness [* over ocean] ",
                                            "units": "mm",
                                            "missing_value": "NaN"
                                        },
                                        "vtype": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vtype",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation type",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "vfrac": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vfrac",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation cover",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ustar": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ustar",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface friction velocity",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "TSEA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSEA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land and sea surface temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "TG3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TG3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "deep soil temperature,-2000mm--4000mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "stype": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stype",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil type",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "STC2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "STC2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature from -100- -2000mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "STC1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "STC1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature mean from 0--100mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "SMC2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SMC2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil moisture contents (0.47 - 0.1)",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "SMC1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SMC1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil moisture contents (0.47 - 0.1)",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "SLMSK": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SLMSK",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sea land mask",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "sheleg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sheleg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow depth",
                                            "units": "mm",
                                            "missing_value": "NaN"
                                        },
                                        "hprime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hprime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mountain variance",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "fm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "fm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "integrated profile function for momentum, heat, and moisture in the surface layer",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "fh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "fh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "integrated profile function for momentum, heat, and moisture in the surface layer",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "facalf2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "facalf2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zeneith angle dependent vegetation fraction",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "facalf1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "facalf1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zeneith angle dependent vegetation fraction",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "F10M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "F10M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "10 M height factor for wind",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cvt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cvt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud top height",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cvb": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cvb",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud base height",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud cover",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "CANOPY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CANOPY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface canopy water content",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo IV",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo III",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo II",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo I",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "0",
                                            "standard_name": "longitude",
                                            "pointwidth": "0.487"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1994-06-01 00:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "standard_name": "time",
                                            "pointwidth": "0.25"
                                        },
                                        "M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "gridtype": "0",
                                            "pointwidth": "1.0"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1994/surface"
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "PressureLevel",
                                        "surface"
                                    ]
                                },
                                "y1998": {
                                    "iridl_type": "Source",
                                    "invalid": [],
                                    "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1998",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "iridl_ds_name": "y1998",
                                    "restriction": "Public",
                                    "PressureLevel": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "PressureLevel",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "w": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "w",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vertical velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "v": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "v",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "meridional velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "u": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "u",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zonal velocity",
                                            "units": "m/s",
                                            "missing_value": "NaN"
                                        },
                                        "temp": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "temp",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "spres": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "spres",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface pressure",
                                            "units": "mb",
                                            "missing_value": "NaN"
                                        },
                                        "q": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "q",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "humidity",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "gh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "gh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "geopotential height",
                                            "units": "gpm",
                                            "missing_value": "NaN"
                                        },
                                        "geshem": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "geshem",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "preciptation",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "bengsh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "bengsh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "convective precipitation",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "Z_01": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z_01",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure"
                                        },
                                        "Z": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Z",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "mb",
                                            "gridtype": "0",
                                            "long_name": "Pressure"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "0",
                                            "standard_name": "longitude",
                                            "pointwidth": "0.487"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1998-06-01 00:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "standard_name": "time",
                                            "pointwidth": "0.25"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "gridtype": "0",
                                            "pointwidth": "1.0"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1998/PressureLevel"
                                    },
                                    "surface": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "surface",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "NC_GLOBAL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "NC_GLOBAL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "Conventions": "IRIDL"
                                        },
                                        "ZORL": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ZORL",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface roughness [* over ocean] ",
                                            "units": "mm",
                                            "missing_value": "NaN"
                                        },
                                        "vtype": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vtype",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation type",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "vfrac": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "vfrac",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "vegetation cover",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ustar": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ustar",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface friction velocity",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "TSEA": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TSEA",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "land and sea surface temperature",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "TG3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "TG3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "deep soil temperature,-2000mm--4000mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "stype": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "stype",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil type",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "STC2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "STC2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature from -100- -2000mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "STC1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "STC1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil temperature mean from 0--100mm ",
                                            "units": "Kelvin_scale",
                                            "missing_value": "NaN"
                                        },
                                        "SMC2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SMC2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil moisture contents (0.47 - 0.1)",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "SMC1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SMC1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "soil moisture contents (0.47 - 0.1)",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "SLMSK": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "SLMSK",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "sea land mask",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "sheleg": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "sheleg",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "snow depth",
                                            "units": "mm",
                                            "missing_value": "NaN"
                                        },
                                        "hprime": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "hprime",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "mountain variance",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "fm": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "fm",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "integrated profile function for momentum, heat, and moisture in the surface layer",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "fh": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "fh",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "integrated profile function for momentum, heat, and moisture in the surface layer",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "facalf2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "facalf2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zeneith angle dependent vegetation fraction",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "facalf1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "facalf1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "zeneith angle dependent vegetation fraction",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "F10M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "F10M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "10 M height factor for wind",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cvt": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cvt",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud top height",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cvb": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cvb",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud base height",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "cv": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "cv",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "cloud cover",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "CANOPY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "CANOPY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface canopy water content",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED4": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED4",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo IV",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED3": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED3",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo III",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED2": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED2",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo II",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "ALBED1": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "ALBED1",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "long_name": "surface albedo I",
                                            "units": "unitless",
                                            "missing_value": "NaN"
                                        },
                                        "X": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "X",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_east",
                                            "gridtype": "0",
                                            "standard_name": "longitude",
                                            "pointwidth": "0.487"
                                        },
                                        "Y": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "Y",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "degree_north",
                                            "gridtype": "0",
                                            "standard_name": "latitude"
                                        },
                                        "T": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "T",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "days since 1998-06-01 00:00:00",
                                            "gridtype": "0",
                                            "calendar": "standard",
                                            "standard_name": "time",
                                            "pointwidth": "0.25"
                                        },
                                        "M": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "M",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "units": "unitless",
                                            "gridtype": "0",
                                            "pointwidth": "1.0"
                                        },
                                        "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM/y1998/surface"
                                    },
                                    "banned_long": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type",
                                        "PressureLevel",
                                        "surface"
                                    ]
                                },
                                "banned_long": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type",
                                    "y1994",
                                    "y1998"
                                ]
                            },
                            "RSMLD": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "RSM-LD",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "NC_GLOBAL": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "NC_GLOBAL",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "Conventions": "IRIDL"
                                },
                                "y1998": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "y1998",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "w": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "w",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "tseas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tseas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "ps": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ps",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface pressure",
                                        "units": "mb",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "hcv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hcv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cover for high cloud",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "h": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "h",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "gpm",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "geshem": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "geshem",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitation",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "bengsh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "bengsh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    }
                                },
                                "y1994": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "y1994",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "w": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "w",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "v": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "v",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "meridional wind",
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "u": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "u",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "zonal wind",
                                        "units": "m/s",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "tseas": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "tseas",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface temperature",
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "temp": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "temp",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "Kelvin_scale",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "q": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "q",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "ps": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ps",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "surface pressure",
                                        "units": "mb",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "hcv": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "hcv",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "total cover for high cloud",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "h": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "h",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "units": "gpm",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "geshem": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "geshem",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "precipitation",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    },
                                    "bengsh": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "bengsh",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "long_name": "convective precipitation",
                                        "units": "unitless",
                                        "missing_value": "9.99999987E14"
                                    }
                                },
                                "T_01": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T_01",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 1998-06-01 00:00:00",
                                    "gridtype": "0",
                                    "calendar": "standard",
                                    "pointwidth": "0.25",
                                    "standard_name": "time"
                                },
                                "Z": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Z",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "mb",
                                    "gridtype": "0",
                                    "long_name": "Pressure"
                                },
                                "Y": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "Y",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_north",
                                    "gridtype": "0",
                                    "standard_name": "latitude"
                                },
                                "T": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "T",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "days since 1994-06-01 00:00:00",
                                    "gridtype": "0",
                                    "calendar": "standard",
                                    "pointwidth": "0.25",
                                    "standard_name": "time"
                                },
                                "X": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "X",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "degree_east",
                                    "gridtype": "0",
                                    "pointwidth": "0.487",
                                    "standard_name": "longitude"
                                },
                                "M": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "M",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "units": "unitless",
                                    "gridtype": "0"
                                },
                                "dir": "SOURCES/IRI/MP/RESEARCH/ATMOSPHERE/REGIONAL/NorthWest_Pacific/RSM-LD"
                            },
                            "banned_long": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type",
                                "RSM",
                                "RSMLD"
                            ]
                        },
                        "RegCM3": {
                            "iridl_type": "DataSet",
                            "iridl_ds_name": "RegCM3",
                            "banned": [
                                "dir",
                                "invalid",
                                "parent",
                                "name",
                                "banned",
                                "banned_long",
                                "iridl_ds_name",
                                "iridl_type"
                            ],
                            "NC_GLOBAL": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "NC_GLOBAL",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "SEAsiasriNRHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiasriNRHOURLYiridlhasSemantics": "irigaz:Sri_Lanka_136_1",
                                "SEAsiasriNRdescription": "forced by NCEP-Reanalysis",
                                "SEAsiaphilNRHINDCASTHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiaphilNRHINDCASTdescription": "forced by NCEP-Reanalysis",
                                "SEAsiaphilECHAMHINDCASTHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiaphilECHAMHINDCASTdescription": "forced by ten-member ECHAM ensemble",
                                "SEAsiaphilECHAMHINDCASTiridlhasSemantics": "irigaz:Philippines_119_1",
                                "SEAsialargedNRHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsialargedNRdescription": "forced by NCEP-Reanalysis",
                                "SEAsialargedECHAMHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsialargedECHAMdescription": "forced by ten-member ECHAM ensemble",
                                "SEAsiajavaNRHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiajavaNRdescription": "forced by NCEP-Reanalysis",
                                "SEAsiajavaECHAMHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiajavaECHAMdescription": "forced by three-member ECHAM ensemble",
                                "SEAsiaindoNRHOURLYdescription": "three-hourly and six-hourly data",
                                "SEAsiaindoNRHOURLYiridlhasSemantics": "irigaz:Indonesia_69_1",
                                "SEAsiaindoNRdescription": "forced by NCEP-Reanalysis",
                                "SEAsiaindoNRiridlhasSemantics": "irigaz:Indonesia_69_1",
                                "SEAsiareferences": "Qian2008",
                                "Conventions": "IRIDL"
                            },
                            "SEAsia": {
                                "iridl_type": "DataSet",
                                "iridl_ds_name": "SEAsia",
                                "banned": [
                                    "dir",
                                    "invalid",
                                    "parent",
                                    "name",
                                    "banned",
                                    "banned_long",
                                    "iridl_ds_name",
                                    "iridl_type"
                                ],
                                "sri": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "sri",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temoerature of lower soil layer",
                                                    "pointwidth": "0.0"
                                                },
                                                "t": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "qv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water mixing ratio",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temoerature of lower soil layer",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "qv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water mixing ratio",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        }
                                    }
                                },
                                "phil": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "phil",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MOVAVG3MON": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MOVAVG3MON",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "v": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "v",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ]
                                            },
                                            "u": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "u",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ]
                                            },
                                            "season": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "season",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "units": "unitless"
                                            },
                                            "pcp": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "pcp",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ]
                                            }
                                        },
                                        "HINDCAST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HINDCAST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MONTHLY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "MONTHLY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "surface": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "surface",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "zpbl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "zpbl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "PBL layer height",
                                                        "units": "m",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "v10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "southerly wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "uvdrag": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "uvdrag",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface drag stress",
                                                        "units": "kg/(s m2)",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "u10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "westerly  wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tlef": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tlef",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of foliage",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "ground temperature",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "t2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "t2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "air temperature at 2m",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "ssw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ssw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "upper layer soil water",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sina": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sina",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "incident solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sena": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sena",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "sensible heat flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "scv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "scv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "total snow amount",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "runoff": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "runoff",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm/day",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "surface runoff",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "rsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "root zone soil water",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "q2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "humidity at 2m",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "psb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "prcv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "prcv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "convective precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "fsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "fsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net absorbed solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "flwd": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flwd",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "downward infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "flw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "evp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "evp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "evapotranspiration",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    }
                                                },
                                                "rad": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rad",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "solin": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "solin",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "instantaneous incident solar",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sabtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sabtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total column absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qrs": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrs",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "solar heating rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qrl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "frsa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frsa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "frla": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frla",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling of surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "firtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "firtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clwp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clwp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud liquid water path",
                                                        "units": "unitless",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrst": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrst",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky total column abs solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrss": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrss",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrlt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrlt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrls": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrls",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky LW cooling at surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "cld": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "cld",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud fractional cover",
                                                        "units": "unitless",
                                                        "pointwidth": "0.0"
                                                    }
                                                },
                                                "atm": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "atm",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "v": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "meridional wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "u": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "zonal wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of lower soil layer",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "temp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "temp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "swt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "swt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "total soil water",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "rno": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rno",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm/day",
                                                        "missing_value": "NaN",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "accumulated surface runoff",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qc": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qc",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud water",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "q": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "specific humidity",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "ptop": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ptop",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "hPa"
                                                    },
                                                    "psa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "P": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "P",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "Pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    }
                                                }
                                            },
                                            "HOURLY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "HOURLY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "surface": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "surface",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "zpbl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "zpbl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "PBL layer height",
                                                        "units": "m",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "v10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "southerly wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "uvdrag": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "uvdrag",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface drag stress",
                                                        "units": "kg/(s m2)",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "u10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "westerly  wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tlef": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tlef",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of foliage",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "ground temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "t2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "t2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "air temperature at 2m",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "ssw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ssw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "upper layer soil water",
                                                        "units": "mm",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sina": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sina",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "incident solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sena": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sena",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "sensible heat flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "scv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "scv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "total snow amount",
                                                        "units": "mm",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "runoff": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "runoff",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "surface runoff",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "rsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "root zone soil water",
                                                        "units": "mm",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "q2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "humidity at 2m",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "psb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "prcv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "prcv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "convective precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "fsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "fsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net absorbed solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "flwd": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flwd",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "downward infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "flw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "evp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "evp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "evapotranspiration",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    }
                                                },
                                                "rad": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rad",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "solin": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "solin",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "instantaneous incident solar",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "sabtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sabtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total column absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qrs": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrs",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "solar heating rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qrl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "frsa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frsa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "frla": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frla",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling of surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "firtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "firtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clwp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clwp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud liquid water path",
                                                        "units": "unitless",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrst": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrst",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky total column abs solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrss": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrss",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrlt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrlt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "clrls": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrls",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky LW cooling at surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "cld": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "cld",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud fractional cover",
                                                        "units": "unitless",
                                                        "pointwidth": "0.0"
                                                    }
                                                },
                                                "atm": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "atm",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "v": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "meridional wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "u": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "zonal wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of lower soil layer",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "temp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "temp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "swt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "swt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "total soil water",
                                                        "units": "mm",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "rno": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rno",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "accumulated surface runoff",
                                                        "units": "mm/day",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "qc": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qc",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud water",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "q": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "specific humidity",
                                                        "units": "kg/kg",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "ptop": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ptop",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "hPa"
                                                    },
                                                    "psa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    },
                                                    "P": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "P",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "Pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "0.0"
                                                    }
                                                }
                                            }
                                        }
                                    },
                                    "ECHAM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ECHAM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "RETROFCST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "RETROFCST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "SEP": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "SEP",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "Tl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "Tl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Forecast Time",
                                                    "pointwidth": "1.0",
                                                    "units": "months since 1960-01-01",
                                                    "calendar": "360"
                                                },
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Forecast Time",
                                                    "pointwidth": "1.0",
                                                    "units": "months since 1960-01-01",
                                                    "calendar": "360"
                                                },
                                                "pcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "pcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0"
                                                }
                                            },
                                            "MAR": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "MAR",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "T": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "T",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Forecast Time",
                                                    "pointwidth": "1.0",
                                                    "units": "months since 1960-01-01",
                                                    "calendar": "360"
                                                },
                                                "pcp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "pcp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0"
                                                }
                                            }
                                        },
                                        "HINDCAST": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HINDCAST",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "MONTHLY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "MONTHLY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "surface": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "surface",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "zpbl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "zpbl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "PBL layer height",
                                                        "units": "m",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "v10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "southerly wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "uvdrag": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "uvdrag",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface drag stress",
                                                        "units": "kg/(s m2)",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "u10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "westerly  wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tlef": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tlef",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of foliage",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "ground temperature",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "t2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "t2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "air temperature at 2m",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "ssw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ssw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "upper layer soil water",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sina": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sina",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "incident solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sena": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sena",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "sensible heat flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "scv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "scv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "total snow amount",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "runoff": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "runoff",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm/day",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "surface runoff",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "rsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "root zone soil water",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "q2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "humidity at 2m",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "psb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "prcv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "prcv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "convective precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "fsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "fsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net absorbed solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "flwd": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flwd",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "downward infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "flw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "evp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "evp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "evapotranspiration",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    }
                                                },
                                                "rad": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rad",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "solin": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "solin",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "instantaneous incident solar",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sabtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sabtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total column absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qrs": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrs",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "solar heating rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qrl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "frsa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frsa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "frla": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frla",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling of surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "firtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "firtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clwp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clwp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud liquid water path",
                                                        "units": "unitless",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrst": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrst",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky total column abs solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrss": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrss",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrlt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrlt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrls": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrls",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky LW cooling at surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "cld": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "cld",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud fractional cover",
                                                        "units": "unitless",
                                                        "pointwidth": "1.0"
                                                    }
                                                },
                                                "atm": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "atm",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "v": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "meridional wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "u": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "zonal wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "Kelvin_scale",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of lower soil layer",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "temp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "temp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "swt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "swt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "total soil water",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "rno": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rno",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "mm/day",
                                                        "history": "Boxes with less than 0.0% dropped",
                                                        "missing_value": "NaN",
                                                        "file_missing_value": "-9.99999979E33",
                                                        "long_name": "accumulated surface runoff",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qc": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qc",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud water",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "q": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "specific humidity",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "ptop": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ptop",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "hPa"
                                                    },
                                                    "psa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "P": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "P",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "Pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    }
                                                }
                                            },
                                            "HOURLY": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "HOURLY",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "surface": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "surface",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "zpbl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "zpbl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "PBL layer height",
                                                        "units": "m",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "v10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "southerly wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "uvdrag": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "uvdrag",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface drag stress",
                                                        "units": "kg/(s m2)",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "u10m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u10m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "westerly  wind at 10m",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tlef": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tlef",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of foliage",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "ground temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "t2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "t2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "air temperature at 2m",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "ssw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ssw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "upper layer soil water",
                                                        "units": "mm",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sina": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sina",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "incident solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sena": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sena",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "sensible heat flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "scv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "scv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "total snow amount",
                                                        "units": "mm",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "runoff": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "runoff",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "surface runoff",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "rsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "root zone soil water",
                                                        "units": "mm",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "q2m": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q2m",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "humidity at 2m",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "psb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "prcv": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "prcv",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "convective precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "fsw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "fsw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net absorbed solar energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "flwd": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flwd",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "downward infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "flw": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "flw",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net infrared energy flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "evp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "evp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "evapotranspiration",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    }
                                                },
                                                "rad": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rad",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "solin": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "solin",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "instantaneous incident solar",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "sabtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "sabtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total column absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qrs": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrs",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "solar heating rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qrl": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qrl",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling rate",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "frsa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frsa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "frla": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "frla",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "longwave cooling of surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "firtp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "firtp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clwp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clwp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud liquid water path",
                                                        "units": "unitless",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrst": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrst",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky total column abs solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrss": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrss",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky surface absorbed solar flux",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrlt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrlt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky net upward LW flux at TOA",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "clrls": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "clrls",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "clearsky LW cooling at surface",
                                                        "units": "W/m2",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "cld": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "cld",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud fractional cover",
                                                        "units": "unitless",
                                                        "pointwidth": "1.0"
                                                    }
                                                },
                                                "atm": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "atm",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "v": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "v",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "meridional wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "u": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "u",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "zonal wind component",
                                                        "units": "m/s",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tpr": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tpr",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "total precipitation",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "tgb": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "tgb",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "temperature of lower soil layer",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "temp": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "temp",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "temperature",
                                                        "units": "Kelvin_scale",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "swt": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "swt",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "total soil water",
                                                        "units": "mm",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "rno": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "rno",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "missing_value": "-9.99999979E33",
                                                        "long_name": "accumulated surface runoff",
                                                        "units": "mm/day",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "qc": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "qc",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "cloud water",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "q": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "q",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "specific humidity",
                                                        "units": "kg/kg",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "ptop": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "ptop",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "units": "hPa"
                                                    },
                                                    "psa": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "psa",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "surface pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    },
                                                    "P": {
                                                        "iridl_type": "DataSet",
                                                        "iridl_ds_name": "P",
                                                        "banned": [
                                                            "dir",
                                                            "invalid",
                                                            "parent",
                                                            "name",
                                                            "banned",
                                                            "banned_long",
                                                            "iridl_ds_name",
                                                            "iridl_type"
                                                        ],
                                                        "long_name": "Pressure",
                                                        "units": "hPa",
                                                        "pointwidth": "1.0"
                                                    }
                                                }
                                            }
                                        }
                                    }
                                },
                                "larged": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "larged",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "pointwidth": "0.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        }
                                    },
                                    "ECHAM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ECHAM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "1.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "1.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "pointwidth": "1.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "pointwidth": "1.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "pointwidth": "1.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "pointwidth": "1.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "pointwidth": "1.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "pointwidth": "1.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "pointwidth": "1.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "pointwidth": "1.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "pointwidth": "1.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "1.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "1.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm",
                                                    "pointwidth": "1.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm",
                                                    "pointwidth": "1.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm",
                                                    "pointwidth": "1.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "1.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "1.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "1.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "1.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm",
                                                    "pointwidth": "1.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "1.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "1.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "1.0"
                                                }
                                            }
                                        }
                                    }
                                },
                                "java": {
                                    "iridl_type": "DataSet",
                                    "iridl_ds_name": "java",
                                    "banned": [
                                        "dir",
                                        "invalid",
                                        "parent",
                                        "name",
                                        "banned",
                                        "banned_long",
                                        "iridl_ds_name",
                                        "iridl_type"
                                    ],
                                    "NR": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "NR",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "pointwidth": "0.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "missing_value": "NaN",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m",
                                                    "pointwidth": "0.0"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)",
                                                    "pointwidth": "0.0"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2",
                                                    "pointwidth": "0.0"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless",
                                                    "pointwidth": "0.0"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s",
                                                    "pointwidth": "0.0"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale",
                                                    "pointwidth": "0.0"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water",
                                                    "units": "mm",
                                                    "pointwidth": "0.0"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff",
                                                    "units": "mm/day",
                                                    "pointwidth": "0.0"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg",
                                                    "pointwidth": "0.0"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa",
                                                    "pointwidth": "0.0"
                                                }
                                            }
                                        }
                                    },
                                    "ECHAM": {
                                        "iridl_type": "DataSet",
                                        "iridl_ds_name": "ECHAM",
                                        "banned": [
                                            "dir",
                                            "invalid",
                                            "parent",
                                            "name",
                                            "banned",
                                            "banned_long",
                                            "iridl_ds_name",
                                            "iridl_type"
                                        ],
                                        "MONTHLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "MONTHLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day"
                                                }
                                            },
                                            "rad": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "rad",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "solin": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "solin",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "instantaneous incident solar",
                                                    "units": "W/m2"
                                                },
                                                "sabtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sabtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total column absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "qrs": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrs",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "solar heating rate",
                                                    "units": "W/m2"
                                                },
                                                "qrl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qrl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling rate",
                                                    "units": "W/m2"
                                                },
                                                "frsa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frsa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "frla": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "frla",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "longwave cooling of surface",
                                                    "units": "W/m2"
                                                },
                                                "firtp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "firtp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net upward LW flux at TOA",
                                                    "units": "W/m2"
                                                },
                                                "clwp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clwp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud liquid water path",
                                                    "units": "unitless"
                                                },
                                                "clrst": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrst",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky total column abs solar flux",
                                                    "units": "W/m2"
                                                },
                                                "clrss": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrss",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky surface absorbed solar flux",
                                                    "units": "W/m2"
                                                },
                                                "clrlt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrlt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky net upward LW flux at TOA",
                                                    "units": "W/m2"
                                                },
                                                "clrls": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "clrls",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "clearsky LW cooling at surface",
                                                    "units": "W/m2"
                                                },
                                                "cld": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "cld",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud fractional cover",
                                                    "units": "unitless"
                                                }
                                            },
                                            "atm": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "atm",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "v": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "meridional wind component",
                                                    "units": "m/s"
                                                },
                                                "u": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "zonal wind component",
                                                    "units": "m/s"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "Kelvin_scale",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of lower soil layer"
                                                },
                                                "temp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "temp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "temperature",
                                                    "units": "Kelvin_scale"
                                                },
                                                "swt": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "swt",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "total soil water"
                                                },
                                                "rno": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rno",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "mm/day",
                                                    "history": "Boxes with less than 0.0% dropped",
                                                    "missing_value": "NaN",
                                                    "file_missing_value": "-9.99999979E33",
                                                    "long_name": "accumulated surface runoff"
                                                },
                                                "qc": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "qc",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "cloud water",
                                                    "units": "kg/kg"
                                                },
                                                "q": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "specific humidity",
                                                    "units": "kg/kg"
                                                },
                                                "ptop": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ptop",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "units": "hPa"
                                                },
                                                "psa": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psa",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa"
                                                },
                                                "P": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "P",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "Pressure",
                                                    "units": "hPa"
                                                }
                                            }
                                        },
                                        "HOURLY": {
                                            "iridl_type": "DataSet",
                                            "iridl_ds_name": "HOURLY",
                                            "banned": [
                                                "dir",
                                                "invalid",
                                                "parent",
                                                "name",
                                                "banned",
                                                "banned_long",
                                                "iridl_ds_name",
                                                "iridl_type"
                                            ],
                                            "surface": {
                                                "iridl_type": "DataSet",
                                                "iridl_ds_name": "surface",
                                                "banned": [
                                                    "dir",
                                                    "invalid",
                                                    "parent",
                                                    "name",
                                                    "banned",
                                                    "banned_long",
                                                    "iridl_ds_name",
                                                    "iridl_type"
                                                ],
                                                "zpbl": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "zpbl",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "PBL layer height",
                                                    "units": "m"
                                                },
                                                "v10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "v10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "southerly wind at 10m",
                                                    "units": "m/s"
                                                },
                                                "uvdrag": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "uvdrag",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface drag stress",
                                                    "units": "kg/(s m2)"
                                                },
                                                "u10m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "u10m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "westerly  wind at 10m",
                                                    "units": "m/s"
                                                },
                                                "tpr": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tpr",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "total precipitation",
                                                    "units": "mm/day"
                                                },
                                                "tlef": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tlef",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "temperature of foliage",
                                                    "units": "Kelvin_scale"
                                                },
                                                "tgb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "tgb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "ground temperature",
                                                    "units": "Kelvin_scale"
                                                },
                                                "t2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "t2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "air temperature at 2m",
                                                    "units": "Kelvin_scale"
                                                },
                                                "ssw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "ssw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "upper layer soil water",
                                                    "units": "mm"
                                                },
                                                "sina": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sina",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "incident solar energy flux",
                                                    "units": "W/m2"
                                                },
                                                "sena": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "sena",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "sensible heat flux",
                                                    "units": "W/m2"
                                                },
                                                "scv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "scv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "total snow amount",
                                                    "units": "mm"
                                                },
                                                "runoff": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "runoff",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "surface runoff",
                                                    "units": "mm/day"
                                                },
                                                "rsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "rsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "missing_value": "-9.99999979E33",
                                                    "long_name": "root zone soil water",
                                                    "units": "mm"
                                                },
                                                "q2m": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "q2m",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "humidity at 2m",
                                                    "units": "kg/kg"
                                                },
                                                "psb": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "psb",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "surface pressure",
                                                    "units": "hPa"
                                                },
                                                "prcv": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "prcv",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "convective precipitation",
                                                    "units": "mm/day"
                                                },
                                                "fsw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "fsw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net absorbed solar energy flux",
                                                    "units": "W/m2"
                                                },
                                                "flwd": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flwd",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "downward infrared energy flux",
                                                    "units": "W/m2"
                                                },
                                                "flw": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "flw",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "net infrared energy flux",
                                                    "units": "W/m2"
                                                },
                                                "evp": {
                                                    "iridl_type": "DataSet",
                                                    "iridl_ds_name": "evp",
                                                    "banned": [
                                                        "dir",
                                                        "invalid",
                                                        "parent",
                                                        "name",
                                                        "banned",
                                                        "banned_long",
                                                        "iridl_ds_name",
                                                        "iridl_type"
                                                    ],
                                                    "long_name": "evapotranspiration",
                                                    "units": "mm/day"
                                                }
         